/*v0291*/
#-- actualizao do relatrio de fecho de caixa para conter as vendas por famlia
UPDATE `reports` SET `Variables`='101,109,111' WHERE `UID`='1';

DELETE FROM `reportsections` WHERE `UID`=999;

INSERT INTO `reportsections`
(`UID`,
`RecordDeleted`,
`SyncCounter`,
`ReportUID`,
`HeaderText`,
`HeaderFormat`,
`DetailQuery`,
`DetailFormat`,
`FooterQuery`,
`FooterFormat`,
`Columns`,
`OrderField`)
VALUES
(
'999', '0', '1', '1', NULL, '\n\n        -- TOTAL POR FAMILIA  --           \n
Fam/Subfam              Qnt        Valor
----------------------------------------
', "SELECT
    Q.F,
    Q.T,
    Q.V/*,
    Q.C,
    Q.K*/
FROM(
(
    #query das familias
    SELECT
        qry.fam AS F,
        qry.qnt as T,
        qry.value as V,
        qry.code as C,
        qry.fam2 as K
    FROM(
        SELECT 
            families.shortdescription as fam,
            SUM(IF(properties.ReadQuantityFromScale,1,details.Quantity)) as qnt,
            replace(round(sum(details.salevalue)/100,2),'.',',') as value, 
            families.code AS code,
            families.uid AS fam2            
        FROM transactionsdetails details
            INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID  #needed for the dates
            INNER JOIN plus on details.PluUID = plus.uid
            INNER JOIN families on plus.familyid = families.uid
            RIGHT JOIN properties on properties.UID =plus.PropertyUID
        WHERE DATE(headers.CreateDate) >= '(101)' 
            and DATE(headers.CreateDate) <= '(111)' 
            and headers.TransactionStatus = 'N'            
        GROUP BY families.uid
        ORDER by families.code
    )
    AS qry
)
UNION
(
    #query das subfamilias
    SELECT
        qry2.subfam AS F,
        qry2.qnt as T,
        qry2.value as V,
        qry2.code as C,
        qry2.fam as K
    FROM(
        SELECT 
            concat(\"    \",subfamilies.shortdescription) as subfam,
            SUM(IF(properties.ReadQuantityFromScale,1,details.Quantity)) as qnt,
            replace(round(sum(details.salevalue)/100,2),'.',',') as value,
            (subfamilies.code+10000) AS code,
            plus.familyid AS fam           
        FROM transactionsdetails details
            INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID  #needed for the dates
            INNER JOIN plus on details.PluUID = plus.uid
            INNER JOIN subfamilies on plus.subfamilyid = subfamilies.uid
            RIGHT JOIN properties on properties.UID =plus.PropertyUID
        WHERE DATE(headers.CreateDate) >= '(101)' 
            and DATE(headers.CreateDate) <= '(111)' 
            and headers.TransactionStatus = 'N' 
        GROUP BY subfamilies.uid
        ORDER by subfamilies.code
    )
    AS qry2
)
UNION
(
    SELECT
        @label :=\"Total\" AS F,
        SUM(IF(props.ReadQuantityFromScale,1,details.Quantity)) as T,
        replace(round(sum(details.salevalue)/100,2),'.',',') as V,
        999999 AS C,
        999999 AS K
    FROM transactionsdetails details
        INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID
        RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID
        RIGHT JOIN properties props on props.UID =mainplus.PropertyUID
    WHERE DATE(headers.CreateDate) BETWEEN  '(101)'  AND '(111)' 
        AND headers.TransactionStatus = 'N'
)
ORDER BY K,C) AS Q;", '%-20.20s %6.6s %12.12s\n', NULL, NULL, '3', '0'
);



