/*v0309*/
#-- Actualizao do relatrio de apuramento de caixa
DELETE FROM reportsections WHERE ReportUID=19;

INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
(
'0', '1', '19', NULL, '', 
"SELECT  
    cd.description,
    `date`,
    salesman.SalesmanName,
    sales.description
     
FROM cashdrawer_movements mov
    INNER JOIN cashdrawers cd on cd.UID = mov.CashDrawerUID
    INNER JOIN salesterminal sales on sales.UID = mov.SalesTerminalUID
    INNER JOIN salesmans salesman on salesman.UID = mov.SalesmanUID
WHERE mov.UID = (110)", 
'Caixa:      %-20.20s\nData:       %-20.20s\nUtilizador: %-20.20s\nTerminal:   %-20.20s', NULL, NULL, '4', '1'
);

INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
(
'0', '1', '19', NULL, '\n\n----------------------------------------\nENTRADAS\n----------------------------------------\n    Movimentos Caixa\n    -----------------\n',
"SELECT mType.description, replace(round(value/100,2),'.',',') as 'value'
FROM cashdrawer_movements mov
inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
WHERE 
    (
    mov.CashDrawerMovementUID = '(121)'
    and mType.MovementFlow = 1
     )
   || 
    mov.uid = '(121)'"
, '    %-20.20s%16.16s\n', 
"SELECT replace(round(sum(value)/100,2),'.',',') as 'value'
FROM cashdrawer_movements mov
inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
WHERE 
    (
    mov.CashDrawerMovementUID = '(121)'
    and mType.MovementFlow = 1
     )
   || 
    mov.uid =  '(121)'"
, '                                   -----\n    Total: %29.29s\n', '2', '2'
);

INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
(
'0', '1', '19', NULL, '\n    Vendas Dinheiro\n    -----------------\n', 
"SELECT 
    'Dinheiro',
    replace(round(sum(tenders.value)/100,2),'.',',') as 'value'
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN PaymentTypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.type = 1
    AND tenders.MovementUID =  '(121)'
    AND headers.TransactionStatus = 'N'
Group by pTypes.type;"
, '    %-20.20s%16.16s\n', NULL, NULL, '2', '3'
);

INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
(
'0', '1', '19', NULL, '\n    Vendas Outros\n    -----------------\n', 
"SELECT
    pTypes.LongDescription as 'description',
    replace(round(sum(tenders.value)/100,2),'.',',') as 'value'
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN PaymentTypes pTypes on pTypes.uid = tenders.PaymentTypeUID

WHERE pTypes.type NOT IN (1,2,3) /* diferente dinheiro, facturação externa e conta corrente*/
    AND tenders.MovementUID =  '(121)'
    AND headers.TransactionStatus = 'N'  
Group by tenders.PaymentTypeUID"
, '    %-20.20s%16.16s\n', 
"SELECT 
    replace(round( IFNULL(sum(tenders.value),0)/100,2),'.',',') as 'value'
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN PaymentTypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.type NOT IN (1,2,3) /* diferente dinheiro, facturação externa e conta corrente*/
    AND tenders.MovementUID =  '(121)'
    AND headers.TransactionStatus = 'N'", 
'                                   -----\n    Total: %29.29s\n', '2', '4'
);

INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
(
'0', '1', '19', NULL, '\n----------------------------------------\nSAIDAS\n----------------------------------------\n    Movimentos Caixa\n    -----------------\n', 
"SELECT mType.description, replace(round(value/100,2),'.',',') as 'value'
FROM cashdrawer_movements mov
inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
WHERE 
    mov.CashDrawerMovementUID =  '(121)'
    and mov.MovementTypeID != 2 /*exclui fecho caixa*/
    and mType.MovementFlow = 0
;",
'    %-20.20s%16.16s\n', NULL, NULL, '2', '6'
);
INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
(
'0', '1', '19', NULL, '', NULL, '%s', 
"SELECT replace(round((
(
/*Movimentos Caixa Entrada Footer*/
SELECT IFNULL( sum(value),0) 
FROM cashdrawer_movements mov
    inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
WHERE 
    (
    mov.CashDrawerMovementUID = '(121)'
    and mType.MovementFlow = 1
     )
   || 
    mov.uid =  '(121)'
)
+
(
/*VENDAS DINHEIRO*/
SELECT IFNULL( sum(value),0) 
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN PaymentTypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.type = 1
    AND  tenders.MovementUID = '(121)'
    AND headers.TransactionStatus = 'N'
)
+
(
/*VENDAS OUTROS*/
SELECT IFNULL( sum(value),0) 
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN PaymentTypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.type NOT IN (1,2,3) /* diferente dinheiro, facturação externa e conta corrente*/
    AND  tenders.MovementUID = '(121)'
    AND headers.TransactionStatus = 'N'
)
)/100,2),'.',',') as 'value'",
 '\n                                   -----\n    Total Entradas: %20.20s\n', '2', '5'
);

INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
(
'0', '1', '19', NULL, '', NULL, NULL, 
"SELECT replace(round((
(
/*Movimentos Caixa Entrada Footer*/
SELECT IFNULL( sum(value),0) 
FROM cashdrawer_movements mov
    inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
WHERE 
    (
    mov.CashDrawerMovementUID = '(121)'
    and mType.MovementFlow = 1
     )
   || 
    mov.uid =  '(121)'
)
+
(
/*VENDAS DINHEIRO*/
SELECT IFNULL( sum(value),0) 
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN PaymentTypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.type = 1
    AND  tenders.MovementUID = '(121)'
    AND headers.TransactionStatus = 'N'
)
+
(
/*VENDAS OUTROS*/
SELECT IFNULL( sum(value),0) 
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN PaymentTypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.type NOT IN (1,2,3) /* diferente dinheiro, facturação externa e conta corrente*/
    AND  tenders.MovementUID = '(121)'
    AND headers.TransactionStatus = 'N'
)
-
(
/*TOTAL DE SAIDAS*/
(
SELECT IFNULL(sum(tenders.value),0) 
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN PaymentTypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.code = 9998
    AND  tenders.MovementUID = '(121)'
    AND headers.TransactionStatus = 'N'
)
+
(
SELECT IFNULL(sum(value),0)
FROM cashdrawer_movements mov
inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
WHERE 
    mov.CashDrawerMovementUID = '(121)'
    and mov.MovementTypeID != 2 /*exclui fecho caixa*/
    and mType.MovementFlow = 0
)
)
)/100,2),'.',',') as 'value'",
 '\nENTRADAS - SAIDAS: %-20.20s\n----------------------------------------\n', '2', '9'
);
INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
(
'0', '1', '19', NULL, NULL, NULL, NULL, 
"SELECT replace(round((
(
SELECT IFNULL(sum(tenders.value),0) 
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN PaymentTypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.code = 9998
    and tenders.MovementUID = '(121)'
    AND headers.TransactionStatus = 'N'
)
+
(
SELECT IFNULL(sum(value),0)
FROM cashdrawer_movements mov
inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
WHERE 
    mov.CashDrawerMovementUID = '(121)'
    and mov.MovementTypeID != 2 /*exclui fecho caixa*/
    and mType.MovementFlow = 0
)
)/100,2),'.',',') as 'value'"
, '\n                                   -----\n    Total Saidas: %22.22s\n', '2', '8'
);

INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
(
'0', '1', '19', NULL, '
----------------------------------------
RECIBOS CC
----------------------------------------
    Movimentos Caixa
    -----------------
',
"SELECT mType.description, replace(round(value/100,2),'.',',') as 'value'
FROM cashdrawer_movements mov
inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
WHERE 
    mov.CashDrawerMovementUID =  '(121)'
    and mov.MovementTypeID != 2
    and mType.MovementFlow = 2;",
 '    %-20.20s%16.16s\n', NULL, NULL, '2', '10'

);
INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
(
'0', '1', '19', NULL, NULL, NULL, NULL, 
"SELECT replace(round((
(
SELECT IFNULL(sum(tenders.value),0) 
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN PaymentTypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.code = 9998
    and tenders.MovementUID = '(121)'
    AND headers.TransactionStatus = 'N'
)
+
(
SELECT IFNULL(sum(value),0)
FROM cashdrawer_movements mov
inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
WHERE 
    mov.CashDrawerMovementUID = '(121)'
    and mov.MovementTypeID != 2 
    and mType.MovementFlow = 2
)
)/100,2),'.',',') a",
 '
                                   -----
    Total Recibos: %22.22s
', '2', '11'
);