/*v0335*/
# -- relatrio de fecho mensal
DELETE FROM `reports` WHERE `UID`=27;
INSERT INTO `reports` (`UID`,`RecordDeleted`, `SyncCounter`, `Code`, `Description`, `HeaderText`, `HeaderFormat`, `FooterText`, `FooterFormat`, `Hints`, `Variables`, `ReportType`) VALUES 
(27,0, 1, 27, 'Fecho Mensal', '\\nFecho Mensal\\n--------------------------------------\\nData inicio: (109)\\nData fim: (112)', '%s\\n', '', '%s\\n', 'Seleccione o intervalo de Datas', '101,111,109,112', 19);

DELETE FROM `reportsections` WHERE ReportUID=27;

INSERT INTO `reportsections`
(`UID`,`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
('60', '0', '1', '27', '', '
           -- TOTAL POR IVAS --         
Tx    Incidencia       Valor       Total
----------------------------------------
', 
"SELECT 
    Taxes.TaxRate as 'rate',
    replace(round((   sum(SaleValue) / ((100+Taxes.TaxRate)/100)                             )/100,2),'.',',') as 'valueTaxOff',
    replace(round((   sum(SaleValue)    -    (sum(SaleValue) / ((100+Taxes.TaxRate)/100))    )/100,2),'.',',') as 'taxValue',
    replace(round(    sum(SaleValue)                                                         /100,2),'.',',') as 'totalValue'
FROM transactionsdetails details
INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
WHERE       
DATE(headers.CreateDate) between '(101)' and '(111)'
and  headers.TransactionStatus = 'N' 
Group by SaleTaxUID;", 
'%4.4s%12.12s%12.12s%12.12s
', 
"SELECT 
    replace(round(  sum(    SaleValue / ((100+Taxes.TaxRate)/100))                  /100,2),'.',',')  as 'valueTaxOff',
    replace(round(  sum(    SaleValue - (SaleValue / ((100+Taxes.TaxRate)/100)))    /100,2),'.',',')  as 'taxValue',
    replace(round(  sum(    SaleValue)                                              /100,2),'.',',')  as 'totalValue'
FROM transactionsdetails details
INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
WHERE DATE(headers.CreateDate) between '(101)' and '(111)'
and headers.TransactionStatus = 'N'", 
'        --------------------------------
%16.16s%12.12s%12.12s
', '4', '0'
),
('61', '0', '1', '27', '', '

         -- TOTAL POR POSTOS --         
Terminal                           Valor
----------------------------------------
', 
"SELECT 
    salesterminal.description as 'description', 
    replace(round(sum(details.salevalue)/100,2),'.',',') as 'value'
FROM transactionsheaders headers
INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID
INNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid
WHERE DATE(headers.CreateDate) between '(101)' and '(111)'
and headers.TransactionStatus = 'N' 
Group by headers.TransactionStartTerminalUID;", 
'%-20.20s%20.20s
', 
"SELECT 
replace(round(IFNULL(sum(details.salevalue),0)/100,2),'.',',') as 'value'
FROM transactionsheaders headers
INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID
INNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid
WHERE DATE(headers.CreateDate) between '(101)' and '(111)'
and headers.TransactionStatus = 'N' ", 
'        --------------------------------
%40.40s
', '2', '0'
),
('62', '0', '1', '27', '', '

        -- FORMAS PAGAMENTO--           
Forma Pagamento                    Valor
----------------------------------------
', 
"SELECT 
    pTypes.LongDescription as 'description',
    replace(round(sum(tenders.value)/100,2),'.',',') as 'value'
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.Type in (0,3)
    AND DATE(headers.CreateDate) between '(101)' and '(111)'
    and  headers.TransactionStatus = 'N'
Group by tenders.PaymentTypeUID
union
SELECT 
    'Dinheiro',
    replace(round(sum(tenders.value)/100,2),'.',',') as 'value'
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.type = 1
    AND DATE(headers.CreateDate) between '(101)' and '(111)'
    and  headers.TransactionStatus = 'N'
Group by pTypes.type;", 
'%-20.20s%20.20s
', 
"SELECT 
    replace(round(IFNULL(sum(tenders.value),0)/100,2),'.',',') as 'value'
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.Type in (0,1,3)
    AND DATE(headers.CreateDate) between '(101)' and '(111)'
    and headers.TransactionStatus = 'N'", 
'        --------------------------------
%40.40s
', '2', '0'
),
('63', '0', '1', '27', NULL, '

        -- TOTAL POR FAMILIA  --           

Fam/Subfam              Qnt        Valor
----------------------------------------
', 
"SELECT
    Q.F,
    Q.T,
    Q.V/*,
    Q.C,
    Q.K*/
FROM(
(
    #query das familias
    SELECT
        qry.fam AS F,
        qry.qnt as T,
        qry.value as V,
        qry.code as C,
        qry.fam2 as K
    FROM(
        SELECT 
            families.shortdescription as fam,
            SUM(IF(properties.ReadQuantityFromScale,1,details.Quantity)) as qnt,
            replace(round(sum(details.salevalue)/100,2),'.',',') as value, 
            families.code AS code,
            families.uid AS fam2            
        FROM transactionsdetails details
            INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID  #needed for the dates
            INNER JOIN plus on details.PluUID = plus.uid
            INNER JOIN families on plus.familyid = families.uid
            RIGHT JOIN properties on properties.UID =plus.PropertyUID
        WHERE DATE(headers.CreateDate) >= '(101)' 
            and DATE(headers.CreateDate) <= '(111)' 
            and headers.TransactionStatus = 'N'            
        GROUP BY families.uid
        ORDER by families.code
    )
    AS qry
)
UNION
(
    #query das subfamilias
    SELECT
        qry2.subfam AS F,
        qry2.qnt as T,
        qry2.value as V,
        qry2.code as C,
        qry2.fam as K
    FROM(
        SELECT 
            concat(\"    \",subfamilies.shortdescription) as subfam,
            SUM(IF(properties.ReadQuantityFromScale,1,details.Quantity)) as qnt,
            replace(round(sum(details.salevalue)/100,2),'.',',') as value,
            (subfamilies.code+10000) AS code,
            plus.familyid AS fam           
        FROM transactionsdetails details
            INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID  #needed for the dates
            INNER JOIN plus on details.PluUID = plus.uid
            INNER JOIN subfamilies on plus.subfamilyid = subfamilies.uid
            RIGHT JOIN properties on properties.UID =plus.PropertyUID
        WHERE DATE(headers.CreateDate) >= '(101)' 
            and DATE(headers.CreateDate) <= '(111)' 
            and headers.TransactionStatus = 'N' 
        GROUP BY subfamilies.uid
        ORDER by subfamilies.code
    )
    AS qry2
)
UNION
(
    SELECT
		@label :=\"Total\" AS F,
        SUM(IF(props.ReadQuantityFromScale,1,details.Quantity)) as T,
        replace(round(sum(details.salevalue)/100,2),'.',',') as V,
        999999 AS C,
        999999 AS K
    FROM transactionsdetails details
        INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID
        RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID
        RIGHT JOIN properties props on props.UID =mainplus.PropertyUID
    WHERE DATE(headers.CreateDate) BETWEEN  '(101)'  AND '(111)' 
        AND headers.TransactionStatus = 'N'
)
ORDER BY K,C) AS Q;", 
'%-20.20s %6.6s %12.12s
', 
NULL, NULL, '3', '0'
);
