/*v0416*/
#-- actualização de relatórios
DELETE FROM `reports` WHERE `UID`=29;
DELETE FROM `reports` WHERE `UID`=30;
DELETE FROM `reports` WHERE `UID`=31;

INSERT INTO `reports`
(`UID`,`RecordDeleted`,`SyncCounter`,`Code`,`Description`,`HeaderText`,`HeaderFormat`,`FooterText`,`FooterFormat`,`Comments`,`Hints`,`Variables`,`ReportType`)
VALUES
('29', '0', '1', '29', 'Resumo CC empregados', 'Resumo CC dos empregados\n----------------------------------------\n', '%s', '\n', '%s', NULL, 'Seleccione o empregado', '102', '19'),
('30', '0', '1', '30', 'Extracto de conta', 'Extracto de conta\n----------------------------------------\n', '%s', '\n', '%s', NULL, '', '125', '19'),
('31', '0', '1', '31', 'Resumo CC clientes', 'Resumo CC clientes\n----------------------------------------\n', '%s', '\n', '%s', NULL, ' ', '125', '19');

#-- secções do relatório Resumo CC empregados
DELETE FROM `reportsections` WHERE `ReportUID`=29 and `UID`>0;
INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
('0', '1', '29', NULL, '\nNome             Visitas Pontos    Valor\n----------------------------------------\n', 
"SELECT 
    ShortName,
    COALESCE(NumberOfVisits,0),
    COALESCE(TotalPoints,0),
    replace(round(COALESCE(Balance,0)/100,2),'.',',')
FROM customers WHERE SalesmanUID>0 AND SalesmanUID LIKE '(102)' AND RecordDeleted=0
ORDER BY ShortName;",
 '%-17.17s %4.4s %6.6s %10.10s\n', NULL, NULL, '4', '1'),
('0', '1', '29', NULL, '\nTotais\n----------------------------------------\n',
"SELECT \"Saldo positivo\",REPLACE(ROUND(SUM(Balance)/100,2),'.',',') FROM customers WHERE Balance>=0 AND SalesmanUID>0 AND SalesmanUID LIKE '(102)' AND RecordDeleted=0
UNION
SELECT \"Saldo negativo\",REPLACE(ROUND(SUM(Balance)/100,2),'.',',') FROM customers WHERE Balance<0 AND SalesmanUID>0 AND SalesmanUID LIKE '(102)' AND RecordDeleted=0
UNION
SELECT \"Diferença\",   REPLACE(ROUND(SUM(Balance)/100,2),'.',',') FROM customers WHERE SalesmanUID>0 AND SalesmanUID LIKE '(102)' AND RecordDeleted=0;"
, '%-30.30s %9.9s\n', NULL, NULL, '2', '2'
);

#-- secções do relatório Extracto de conta
DELETE FROM `reportsections` WHERE `ReportUID`=30 and `UID`>0;
INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
('0', '1', '30', NULL, '', 
"SELECT \"Nome\", ShortName FROM customers WHERE UID='(125)' AND RecordDeleted=0
UNION
SELECT \"Saldo Actual\",REPLACE(ROUND(COALESCE(Balance,0)/100,2),'.',',') FROM customers WHERE UID='(125)' AND RecordDeleted=0
UNION
SELECT \"Total gasto\", REPLACE(ROUND(COALESCE(TotalSpent,0)/100,2),'.',',') FROM customers WHERE UID='(125)' AND RecordDeleted=0
UNION
SELECT \"Visitas\", COALESCE(NumberOfVisits,0) FROM customers WHERE UID='(125)' AND RecordDeleted=0
UNION
SELECT \"Pontos acumulados\", COALESCE(TotalPoints,0) FROM customers WHERE UID='(125)' AND RecordDeleted=0
UNION
SELECT \"Ultima visita\", COALESCE(LastVisit,0) FROM customers WHERE UID='(125)' AND RecordDeleted=0
UNION
SELECT \"Cliente desde\", COALESCE(CreateDate,0) FROM customers WHERE UID='(125)' AND RecordDeleted=0;"
, '%-20.20s %19.19s\n', NULL, NULL, '2', '1'),
('0', '1', '30', NULL, '\n\nDocumentos Pendentes\n----------------------------------------\nData                Documento     Valor\n', 
"SELECT  Q.docdate, 
        Q.docid, 
        REPLACE(ROUND(COALESCE(Q.total,0)/100,2),'.',',')
        /*Q.doctype, 
        Q.docstatus,
        Q.customer,
        Q.receipt*/
        FROM 
(
    (
    SELECT 
        H.TransactionEndTime AS docdate,
        H.DocumentID AS docid, 
        H.TableTotal AS total,
        H.DocumentTypeUID AS doctype,
        H.TransactionStatus AS docstatus,
        H.CustomerUID AS customer,
        T.ReceiptMovementUID AS receipt
    FROM transactionsheaders AS H JOIN transactionstenders AS T 
    ON 
        H.UID=T.TransactionUID
    ) AS Q
)
WHERE Q.doctype=11 AND Q.receipt=0 AND Q.docstatus='N' AND Q.customer= '(125)' ORDER BY  Q.docdate;"
, '%-19.19s %8.8s %10.10s\n', NULL, NULL, '3', '2'
);

#-- secções do relatório Resumo CC clientes
DELETE FROM `reportsections` WHERE `ReportUID`=31 and `UID`>0;
INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
('0', '1', '31', NULL, '\nNome             Visitas Pontos    Valor\n----------------------------------------\n', 
"SELECT 
    ShortName,
    COALESCE(NumberOfVisits,0),
    COALESCE(TotalPoints,0),
    REPLACE(round(COALESCE(Balance,0)/100,2),'.',',')
FROM customers WHERE SalesmanUID=0 AND CustomerID!=9999 AND UID LIKE '%' AND RecordDeleted=0
ORDER BY ShortName;"
, '%-17.17s %4.4s %6.6s %10.10s\n', NULL, NULL, '4', '1'),
('0', '1', '31', NULL, '\nTotais\n----------------------------------------\n', 
"SELECT \"Positivo\",REPLACE(ROUND(SUM(Balance)/100,2),'.',',') FROM customers WHERE Balance>=0 AND SalesmanUID=0 AND UID LIKE '(125)' AND RecordDeleted=0
UNION
SELECT \"Negativo\",REPLACE(ROUND(SUM(Balance)/100,2),'.',',') FROM customers WHERE Balance<0 AND SalesmanUID=0 AND UID LIKE '(125)' AND RecordDeleted=0
UNION
SELECT \"Total\",   REPLACE(ROUND(SUM(Balance)/100,2),'.',',') FROM customers WHERE SalesmanUID=0 AND UID LIKE '(125)' AND RecordDeleted=0;"
, '%-30.30s %9.9s\n', NULL, NULL, '2', '2');

#-- Actualização do relatório de fecho de sessão
DELETE FROM `reportsections` WHERE `ReportUID`=5 and `UID`>0;
INSERT INTO `reportsections`
(`RecordDeleted`,`SyncCounter`,`ReportUID`,`HeaderText`,`HeaderFormat`,`DetailQuery`,`DetailFormat`,`FooterQuery`,`FooterFormat`,`Columns`,`OrderField`)
VALUES
('0', '1', '5', NULL, '

         -- TOTAL FACTURADO--         
Terminal                           Valor
----------------------------------------
', 
"SELECT 
    salesterminal.description as 'description', 
    replace(round(sum(tenders.value)/100,2),'.',',') as 'value'
FROM transactionsheaders headers
INNER JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID
INNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid
WHERE 
    headers.SalesmanSessionID = '(122)' 
    and headers.TransactionStatus = 'N' 
Group by headers.TransactionStartTerminalUID;"
, '%-20.20s%20.20s
', 
"SELECT 
    replace(round(sum(tenders.value)/100,2),'.',',') as 'value'
FROM transactionsheaders headers
INNER JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID
INNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid
WHERE 
	headers.SalesmanSessionID = '(122)' 
    and headers.TransactionStatus = 'N';"
, '        --------------------------------
%40.40s
', '2', '1'
),
('0', '1', '5', NULL, '

             -- COMMISSOES--              
                                   Valor
----------------------------------------
', "SELECT 
    replace(round(`Commission` /100,2),'.',',') as 'value'
FROM 
    `salesmansessions` 
WHERE 
    `SessionID`='(122)';", '%40.40s
', NULL, NULL, '1', '2'
),
('0', '1', '5', NULL, '

         -- CONSUMO PROPRIO --      
Artigo                   Qt         Valor
----------------------------------------
', "SELECT 
    details.PluName AS 'Name',
    details.Quantity AS 'qt',
    replace(round(details.SaleValue/100,2),'.',',') as 'value'
FROM transactionsdetails details    
INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID
WHERE 
    headers.SalesmanSessionID =  '(122)'
    AND headers.TableID= '(124)'
    AND headers.TransactionStatus = 'N';", '%-20.20s %6.6s %12.12s
', "SELECT 
    replace(round(sum(tenders.value)/100,2),'.',',') as 'value'
FROM transactionsheaders headers
INNER JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID
WHERE 
    headers.SalesmanSessionID =  '(122)'
    AND headers.TableID= '(124)'
    AND headers.TransactionStatus = 'N';", '        --------------------------------
%40.40s
', '3', '3'
),
('0', '1', '5', NULL, '

         -- SALDO ACTUAL--                
----------------------------------------
', "SELECT  replace(round(COALESCE(customers.Balance,0)/100,2),'.',',') as 'value' FROM customers WHERE UID='(125)';", '%40.40s
', NULL, NULL, '1', '4'
);