/*v0511*/

-- DOCUMENT BODIES
DELETE FROM `documentparts` WHERE UID = 5; 					-- corpo pedido
INSERT INTO `documentparts` 
(`UID`, `RecordDeleted`, `SyncCounter`, `Code`, `Description`, `PartType`, `Contents`) 
VALUES ('5', '0', '7', '5', 'Corpo Pedido', '3', "\\FD\\-3BQ \\-16B1\\FN
\\FN    \\-4BQ \\-30B1
");

DELETE FROM `documentparts` WHERE UID = 3; 					-- corpo subtotal
INSERT INTO `documentparts` 
(`UID`, `RecordDeleted`, `SyncCounter`, `Code`, `Description`, `PartType`, `Contents`) 
VALUES ('3', '0', '107', '3', 'Corpo SubTotal', '3', "\\FN\\-6BQ \\-15BN \\17BV
\\FN    \\-20BN\\16BV
");

DELETE FROM `documentparts` WHERE UID = 8; 					-- corpo facturaVD
INSERT INTO `documentparts` 
(`UID`, `RecordDeleted`, `SyncCounter`, `Code`, `Description`, `PartType`, `Contents`) 
VALUES ('8', '0', '107', '8', 'Corpo FacturaVD', '3', "\\FN\\-6BQ \\-15BN \\3BT \\6BU \\6BV
\\FN    \\-20BN\\16BV
");

UPDATE `documenttypes` SET `BodyUID`= 8;			   						-- all documents default
UPDATE `documenttypes` SET `BodyUID`= 5 WHERE UID = 3;						-- Pedido Body Pedido
UPDATE `documenttypes` SET `BodyUID`= 3 WHERE UID = 1;						-- Pedido Body SubTotal

-- NOVO FOOTER/HEADER PARA REPORTS
DELETE FROM `documentparts` WHERE UID in (997,998);
INSERT INTO `documentparts` (`UID`, `RecordDeleted`, `SyncCounter`, `Code`, `Description`, `PartType`, `Contents`) 
VALUES ('997', '0', '100', '30', 'Cab. Relatorio', '1', "\\FD  \\FN
\\LE
\\LM 
\\LC 
NIF: \\LF
---------------------------------------
Data: \\DD, \\DH
---------------------------------------
");
INSERT INTO `documentparts` (`UID`, `RecordDeleted`, `SyncCounter`, `Code`, `Description`, `PartType`, `Contents`) 
VALUES ('998', '0', '100', '31', 'Rod. Relatorio', '2', "\\FN----------------------------------------");

UPDATE `DocumentTypes` SET `HeaderUID`='997', `FooterUID`='998' WHERE `UID`='9';

-- DOCUMENT HEADER/FOOTER
UPDATE documentparts set contents = concat(contents,'\n---------------------------------------\n') 
WHERE PartType = 1
AND `UID` not in (SELECT HeaderUID FROM documenttypes WHERE DocumentType = 21)
AND NOT EXISTS (SELECT * FROM database_upgrades WHERE VersionTo = 511)
AND `Code` not in (12,30); -- default ID on most databases

UPDATE documentparts set contents = concat('----------------------------------------\n \\FD    Total:\\10MT\\FN\n',contents) 
WHERE PartType = 2
AND `UID` not in (SELECT FooterUID FROM documenttypes WHERE DocumentType = 21)
AND NOT EXISTS (SELECT * FROM database_upgrades WHERE VersionTo = 511)
AND `Code` not in (13,31); -- 13 default ID on most databases

-- DOCUMENT HINTS
DELETE FROM `languagedictionaries` WHERE StringID in (1223);
INSERT INTO `languagedictionaries`
(`RecordDeleted`,`SyncCounter`,`Description`,`StringID`,`Alias`,`LanguageID`,`Context`)
VALUES
('0', '1', 'DOCUMENTO
\\DS - Contador
\\DD - Data
\\DH - Hora
\\DA - Assinatura
\\DO - Sub-totais
\\DT - Natureza
\\DN - Observações

DETALHE DOCUMENTO
\\BQ - Quantidade
\\BN - Nome Artigo
\\B1 - Descrição Curta 1
\\B2 - Descrição Curta 2
\\BD - Desconto
\\BT - Valor Taxa
\\BU - Preço Unidade
\\BV - Total Linha

GUIAS DE TRANSPORTE
\\GC - Hora Carga
\\GD - Hora Descarga
\\GT - Transporte
\\GI - Cód.Transporte

CARTÃO
\\MM - Nome cartão
\\ME - Empregado
\\MT - Total
\\MC - Nome cliente
\\MN - NIF cliente
\\MA - Morada cli (1)
\\MB - Morada cli (2)
\\MD - C.Postal cliente
\\ML - Localidade cliente
\\MV - Iva
\\MO - Destino Ordem
\\MP - Pagamento
\\MI - Pedido
\\MR - Doc Origem

LICENÇA
\\LE - Empresa
\\LM - Morada
\\LC - C.Postal
\\LL - Localidade
\\LF - Contribuinte
\\LN - Nome Real

FORMATAÇÃO
\\FD - Double size
\\FE - Depois bitmap
\\FI - Beep
\\FN - Normal size
\\FP - Preto
\\FS - Antes bitmap
\\FU - Underline
\\FV - Vermelho'
, '1223', 'HintText', '1', 'SCREEN_CONFIG_DOCUMENTPARTS');