/*v0516*/

-- Listagem Vendas
UPDATE `reportsections` SET `DetailQuery`="SELECT
    taxes.TaxRate as 'rate',
    replace(round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2),'.',',') as 'valueTaxOff',
    replace(round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2),'.',',') as 'taxValue',
    replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),'.',',') as 'totalValue'      
FROM transactionsdetails details
INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
WHERE     DATE(headers.TransactionEndTime)  between '(101)'  and '(111)' 
AND  headers.TransactionStatus = 'N' 
and  headers.DocumentTypeUID != 13
Group by SaleTaxUID;", `FooterQuery`="SELECT
    replace(round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2),'.',',') as 'valueTaxOff',
    replace(round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2),'.',',') as 'taxValue',
    replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),'.',',') as 'totalValue'      
FROM transactionsdetails details
INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
WHERE     DATE(headers.TransactionEndTime) between '(101)'  and '(111)' 
AND  headers.TransactionStatus = 'N' 
and  headers.DocumentTypeUID != 13;" WHERE `UID`='15001';

DELETE FROM `reportsections` where `UID` in (25001,25002);
INSERT INTO `reportsections` (`UID`, `RecordDeleted`, `SyncCounter`, `ReportUID`, `HeaderText`, `HeaderFormat`, `DetailQuery`, `DetailFormat`,`FooterQuery`,`FooterFormat`, `Columns`, `OrderField`) 
VALUES ('25001', '0', '1', '25', NULL, '\\n\\n --- Artigos por empregado ---      \\nEmpregado  Artigo      Qnt       Valor\\n----------------------------------------\\n', "SELECT 
     IF(Q._name=     @lastName,'',   @lastName:= Q._name) AS OpSalesman,
     Q._item AS OpItem,
     Q._qnt AS OpQnt,
     Q._value AS OpValue
FROM
(
SELECT 
    @lastName:='',
    CONCAT(salesmans.SalesmanName,'
') AS _name,
    details.PluName AS _item,
    SUM(IF(properties.ReadQuantityFromScale,details.Quantity/1000,details.Quantity)) as _qnt,
    REPLACE(round(sum(details.salevalue-details.salevalue*headers.DiscountPercent/100)/100,2),'.',',') AS _value
FROM transactionsdetails details
    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
    INNER JOIN salesmans on salesmans.uid = headers.CreateSalesmanUID
    INNER JOIN plus on details.PluUID = plus.uid
    RIGHT JOIN properties on properties.UID =plus.PropertyUID
WHERE DATE(headers.TransactionEndTime)>= '(101)' 
    AND DATE(headers.TransactionEndTime)<= '(111)'
    AND DATE(headers.TransactionEndTime)<= '(111)'
    AND headers.TransactionStatus = 'N'     
    AND headers.documentTypeUID  != 13 -- guias
GROUP BY details.pluuid, salesmans.UID
ORDER by _name) 
AS Q", '%s     %-18.18s %5.5s %9.9s\\n', "", NULL, '4', '1'),
('25002', '0', '1', '25', NULL, '\\n\\n ---          Totais            ---\\nEmpregado              Qnt        Valor\\n----------------------------------------\\n', "SELECT 
    salesmans.SalesmanName AS 'Name',
    SUM(IF(properties.ReadQuantityFromScale,details.Quantity/1000,details.Quantity)) as 'Qnt',
    REPLACE(round(sum(details.salevalue-details.salevalue*headers.DiscountPercent/100)/100,2),'.',',') as 'value'
FROM transactionsdetails details
    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
    INNER JOIN salesmans on salesmans.uid = headers.CreateSalesmanUID
	INNER JOIN plus on details.PluUID = plus.uid
    RIGHT JOIN properties on properties.UID =plus.PropertyUID
WHERE DATE(headers.TransactionEndTime)>= '(101)' 
    AND DATE(headers.TransactionEndTime)<= '(111)'
    AND headers.TransactionStatus = 'N'     
    AND headers.documentTypeUID  != 13 -- guias
GROUP BY salesmans.UID
ORDER by 'Name';", ' %-18.18s  %6.6s     %9.9s\\n', "", NULL, '3', '2');

DELETE FROM `screens` WHERE `ScreenType` = 1 AND `ID` in (156,123,155);
INSERT INTO `screens`
(`RecordDeleted`,`SyncCounter`,`Description`,`ID`,`UserInterfaceDescription`,`SalesTerminalUID`,`ScreenType`)
VALUES
('0', '3202', 'SCREEN_CUSTOMER_ACCOUNT', '156', "{\"objects\":[{\"id\":\"7472\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":156},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1055#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"31637\",\"windowid\":\"7472\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":43},{\"value\":3},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"23024\",\"windowid\":\"7472\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":9},{\"value\":13},{\"value\":3},{\"value\":\"#1056#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24621\",\"windowid\":\"7472\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":34},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1057#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32695\",\"windowid\":\"7472\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#1058#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1992\",\"windowid\":\"7472\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":4},{\"value\":58},{\"value\":26},{\"value\":3},{\"value\":\"#770#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"826\",\"windowid\":\"7472\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":5},{\"value\":13},{\"value\":3},{\"value\":\"#1059#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"16101\",\"windowid\":\"7472\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":5},{\"value\":13},{\"value\":3},{\"value\":\"#1059#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1813\",\"windowid\":\"7472\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":15},{\"value\":5},{\"value\":38},{\"value\":33},{\"value\":[{\"v\":38}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"28000\",\"windowid\":\"7472\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":29},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1574#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1097.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11419\",\"windowid\":\"7472\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19589\",\"windowid\":\"7472\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":1},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1911#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}", '0', '1'),
('0', '3201', 'SCREEN_CONFIG_DAILY_JOURNAL', '123', "{\"objects\":[{\"id\":\"9204\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":123},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#520#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"1259\",\"windowid\":\"9204\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":18},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"2515\",\"windowid\":\"9204\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":18},{\"value\":35},{\"value\":[{\"v\":5},{\"v\":4},{\"v\":5},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"15968\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":35},{\"value\":8},{\"value\":3},{\"value\":\"#759#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"26333\",\"windowid\":\"9204\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11044\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#523#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"13448\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":23},{\"value\":8},{\"value\":3},{\"value\":\"#760#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"10083\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":6},{\"value\":16},{\"value\":11},{\"value\":3},{\"value\":\"#526#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"11440\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":1},{\"value\":29},{\"value\":8},{\"value\":3},{\"value\":\"#761#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"8798\",\"windowid\":\"9204\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":36},{\"value\":10},{\"value\":17},{\"value\":24},{\"value\":[{\"v\":2},{\"v\":5},{\"v\":3},{\"v\":2},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"4867\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":36},{\"value\":7},{\"value\":17},{\"value\":3},{\"value\":\"#529#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25785\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":18},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#530#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31384\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":36},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#531#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30246\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":18},{\"value\":10},{\"value\":9},{\"value\":3},{\"value\":\"#532#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29035\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":18},{\"value\":7},{\"value\":17},{\"value\":3},{\"value\":\"#534#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1405\",\"windowid\":\"9204\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":48},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#535#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2201\",\"windowid\":\"9204\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":38},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3711\",\"windowid\":\"9204\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":15},{\"value\":6},{\"value\":39},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#755#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1063.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10123\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":9},{\"value\":35},{\"value\":8},{\"value\":3},{\"value\":\"#762#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"4829\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":9},{\"value\":29},{\"value\":8},{\"value\":3},{\"value\":\"#763#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"18806\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":9},{\"value\":23},{\"value\":8},{\"value\":3},{\"value\":\"#764#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"10290\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":32},{\"value\":16},{\"value\":3},{\"value\":\"#522#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"32726\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":26},{\"value\":16},{\"value\":3},{\"value\":\"#528#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"27411\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":20},{\"value\":16},{\"value\":3},{\"value\":\"#768#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"10706\",\"windowid\":\"9204\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":17},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#765#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1043.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10085\",\"windowid\":\"9204\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":18},{\"value\":26},{\"value\":17},{\"value\":8},{\"value\":[{\"v\":9},{\"v\":7}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"4008\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":4},{\"value\":58},{\"value\":26},{\"value\":3},{\"value\":\"#770#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"18583\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":26},{\"value\":18},{\"value\":0},{\"value\":35},{\"value\":3},{\"value\":\"#771#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"19093\",\"windowid\":\"9204\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":10},{\"value\":16},{\"value\":3},{\"value\":\"#525#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"30831\",\"windowid\":\"9204\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":13},{\"value\":16},{\"value\":3},{\"value\":\"#527#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"25807\",\"windowid\":\"9204\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":25},{\"value\":1},{\"value\":16},{\"value\":5},{\"value\":3},{\"value\":\"#865#\"},{\"value\":[{\"v\":5}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"18834\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":27},{\"value\":10},{\"value\":8},{\"value\":3},{\"value\":\"#822#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14993\",\"windowid\":\"9204\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":29},{\"value\":43},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1438#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29419\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":30},{\"value\":18},{\"value\":13},{\"value\":17},{\"value\":3},{\"value\":\"#1465#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11338\",\"windowid\":\"9204\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":33},{\"value\":33},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1793#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2966\",\"windowid\":\"9204\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":37},{\"value\":1},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#1800#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"29542\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":35},{\"value\":1},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#1800#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"29451\",\"windowid\":\"9204\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":28},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1853#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13904\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":40},{\"value\":18},{\"value\":22},{\"value\":17},{\"value\":3},{\"value\":\"#1854#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12173\",\"windowid\":\"9204\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":42},{\"value\":18},{\"value\":19},{\"value\":17},{\"value\":3},{\"value\":\"#1857#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7586\",\"windowid\":\"9204\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":39},{\"value\":18},{\"value\":16},{\"value\":17},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1902#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}", '0', '1'),
('0', '3205', 'SCREEN_MOVEMENTS_PRINT', '155', "{\"objects\":[{\"id\":\"9998\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":155},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1022#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"1258\",\"windowid\":\"9998\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":16},{\"value\":4},{\"value\":22},{\"value\":29},{\"value\":[{\"v\":8},{\"v\":10},{\"v\":5}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13737\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":1},{\"value\":28},{\"value\":6},{\"value\":3},{\"value\":\"#1023#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24612\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":16},{\"value\":6},{\"value\":3},{\"value\":\"#1024#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6015\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":22},{\"value\":6},{\"value\":3},{\"value\":\"#1025#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17977\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":39},{\"value\":7},{\"value\":14},{\"value\":3},{\"value\":\"#1026#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4122\",\"windowid\":\"9998\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":15},{\"value\":6},{\"value\":34},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1027#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1063.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29428\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":8},{\"value\":28},{\"value\":6},{\"value\":3},{\"value\":\"#1028#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"223\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":8},{\"value\":22},{\"value\":6},{\"value\":3},{\"value\":\"#1029#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3046\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":8},{\"value\":16},{\"value\":6},{\"value\":3},{\"value\":\"#1030#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1005\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":25},{\"value\":13},{\"value\":3},{\"value\":\"#1031#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27190\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#1032#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16172\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#1033#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4106\",\"windowid\":\"9998\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":14},{\"value\":1},{\"value\":34},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1034#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1043.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14496\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":4},{\"value\":58},{\"value\":26},{\"value\":3},{\"value\":\"#770#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"3582\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":15},{\"value\":0},{\"value\":38},{\"value\":3},{\"value\":\"#1035#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"32374\",\"windowid\":\"9998\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":13},{\"value\":39},{\"value\":34},{\"value\":14},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1036#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1097.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"387\",\"windowid\":\"9998\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#1037#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"18543\",\"windowid\":\"9998\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#1038#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"23332\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":0},{\"value\":15},{\"value\":3},{\"value\":\"#1039#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"9609\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":39},{\"value\":10},{\"value\":14},{\"value\":3},{\"value\":\"#1040#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21503\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":39},{\"value\":16},{\"value\":14},{\"value\":3},{\"value\":\"#1041#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8221\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":39},{\"value\":13},{\"value\":14},{\"value\":3},{\"value\":\"#1042#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29684\",\"windowid\":\"9998\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":17},{\"value\":1},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#1043#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"21452\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":39},{\"value\":19},{\"value\":14},{\"value\":14},{\"value\":\"#1044#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22103\",\"windowid\":\"9998\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":39},{\"value\":4},{\"value\":14},{\"value\":3},{\"value\":\"#1045#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3056\",\"windowid\":\"9998\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":19},{\"value\":16},{\"value\":34},{\"value\":22},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1710#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2343\",\"windowid\":\"9998\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}", '0', '1');


DELETE FROM `languagedictionaries` WHERE StringID in (1911,1856);
INSERT INTO `languagedictionaries`
(`RecordDeleted`,`SyncCounter`,`Description`,`StringID`,`Alias`,`LanguageID`,`Context`)
VALUES
('0', '1', 'Faturas Pagas', '1911', 'CustomerAccountPaidInvoices', '1', 'SCREEN_CUSTOMER_ACCOUNT'),
('0', '1', 'Esta guia de transporte já foi processada. O código de transporte não pode ser indicado manualmente.', '1856', 'MSG_BOX_TEXT', '1', 'SCREEN_CONFIG_DAILY_JOURNAL'),
('0', '1', 'DOCUMENTO
\\DS - Contador
\\DD - Data
\\DH - Hora
\\DA - Assinatura
\\DO - Sub-totais
\\DT - Natureza
\\DN - Observacoes

DETALHE DOCUMENTO
\\BQ - Quantidade
\\BN - Nome Artigo
\\B1 - Descricao Curta 1
\\B2 - Descricao Curta 2
\\BD - Desconto
\\BT - Valor Taxa
\\BU - Preco Unidade
\\BV - Total Linha

GUIAS DE TRANSPORTE
\\GC - Hora Carga
\\GD - Hora Descarga
\\GT - Transporte
\\GI - Cod. Transporte

CARTÃO
\\MM - Nome cartão
\\ME - Empregado
\\MT - Total
\\MC - Nome cliente
\\MN - NIF cliente
\\MA - Morada cli (1)
\\MB - Morada cli (2)
\\MD - C.Postal cliente
\\ML - Localidade cliente
\\MV - Iva
\\MO - Destino Ordem
\\MP - Pagamento
\\MQ - Saldo Cliente
\\MI - Pedido
\\MR - Doc Origem

LICENÇA
\\LE - Empresa
\\LM - Morada
\\LC - C.Postal
\\LL - Localidade
\\LF - Contribuinte
\\LN - Nome Real

FORMATAÇÃO
\\FD - Double size
\\FE - Depois bitmap
\\FI - Beep
\\FN - Normal size
\\FP - Preto
\\FS - Antes bitmap
\\FU - Underline
\\FV - Vermelho'
, '1223', 'HintText', '1', 'SCREEN_CONFIG_DOCUMENTPARTS');

-- update DOCTYPE   abertura/movimentos    caixa abertura/fecho sessão
UPDATE `DocumentTypes` SET `HeaderUID`='997', `FooterUID`='998' WHERE `UID` IN  (6,7,8,15);

UPDATE `reportsections` SET `DetailQuery`="SELECT col FROM(
SELECT UID,2 AS col_order,'data', CONCAT('  ','Data: ',TransactionEndTime,'
') as col FROM TransactionsHeaders WHERE DocumentTypeUID=13 AND TransactionStatus = 'N' AND DATE(TransactionEndTime) BETWEEN '(101)' AND '(111)'
UNION
SELECT UID,1 AS col_order,'documento',CONCAT('Guia: ',DocumentID,'
') as col FROM TransactionsHeaders WHERE DocumentTypeUID=13 AND TransactionStatus = 'N' AND DATE(TransactionEndTime) BETWEEN '(101)' AND '(111)' 
UNION
SELECT UID,3 AS col_order,'cliente',CONCAT('  ','Cliente: ',(SELECT ShortName FROM customers WHERE UID=CustomerUID),'
') as col FROM TransactionsHeaders WHERE DocumentTypeUID=13 AND TransactionStatus = 'N' AND DATE(TransactionEndTime) BETWEEN '(101)' AND '(111)' 
UNION
(SELECT 
    headers.UID, 5 AS col_order, 'total',CONCAT('  ','Total: ',replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),'.',','),'
' )AS col
FROM transactionsheaders headers
INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID
WHERE DATE(headers.TransactionEndTime) BETWEEN '(101)' AND '(111)'
AND headers.TransactionStatus = 'N' 
AND headers.DocumentTypeUID=13
Group by headers.UID)
UNION
(
SELECT 
    headers.UID, 4 AS col_order, details.PluName, CONCAT('    ',details.PluName,'	 ',replace(round(SaleValue/100,2),'.',','),'
') AS col
FROM transactionsheaders headers
INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID
WHERE DATE(headers.TransactionEndTime) BETWEEN '(101)' AND '(111)'
AND headers.TransactionStatus = 'N' 
AND headers.DocumentTypeUID=13
ORDER by headers.UID
)
ORDER BY UID, col_order) AS Q;" WHERE `UID`='35001';

UPDATE `reportsections` SET `DetailQuery`="SELECT 
    salesterminal.Description AS 'Name',
    SUM(IF(properties.ReadQuantityFromScale,details.Quantity/1000,details.Quantity)) as 'Qty',
    REPLACE(round(sum(details.NetValue-details.NetValue*headers.DiscountPercent/100)/100,2),'.',',') as 'net_value',
    REPLACE(round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2),'.',',') as 'value'
FROM transactionsdetails details
    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
    INNER JOIN salesterminal on salesterminal.uid = details.OrderSalesTerminalUID
   INNER JOIN plus on details.PluUID = plus.uid
   RIGHT JOIN properties on properties.UID =plus.PropertyUID
WHERE DATE(headers.TransactionEndTime) >= '(101)' 
    AND DATE(headers.TransactionEndTime) <= '(111)'
    AND headers.TransactionStatus = 'N'     
    AND headers.DocumentTypeUID !=13
GROUP BY salesterminal.UID
ORDER by 'Name'" WHERE `UID`='28001';
UPDATE `reportsections` SET `DetailQuery`="SELECT 
     IF(Q._name=     @lastName,'',   @lastName:= Q._name) AS OpSalesman,
     Q._item AS OpItem,
     Q._qnt AS OpQnt,
     Q.net_value AS OpNetValue,
     Q._value AS OpValue
FROM
(
SELECT 
    @lastName:='',
    CONCAT(salesterminal.Description,'
') AS _name,
    details.PluName AS _item,
    SUM(IF(properties.ReadQuantityFromScale,details.Quantity/1000,details.Quantity)) as _qnt,
    REPLACE(round(sum(details.NetValue-details.NetValue*headers.DiscountPercent/100)/100,2),'.',',') AS net_value,
    REPLACE(round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2),'.',',') AS _value
FROM transactionsdetails details
    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
    INNER JOIN salesterminal on salesterminal.uid = details.OrderSalesTerminalUID
    INNER JOIN plus on details.PluUID = plus.uid
    RIGHT JOIN properties on properties.UID =plus.PropertyUID
WHERE DATE(headers.TransactionEndTime) >= '(101)' 
    AND DATE(headers.TransactionEndTime) <= '(111)'
    AND headers.TransactionStatus = 'N'     
   AND headers.DocumentTypeUID !=13
GROUP BY details.pluuid,salesterminal.UID
ORDER by _name) 
AS Q" WHERE `UID`='28002';


UPDATE `reportsections` SET `DetailQuery`="SELECT Date(headers.CreateDate),headers.DocumentID,C.FederalTaxID,
replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),'.',',') as value
FROM transactionsdetails details
INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
JOIN Customers AS C on headers.CustomerUID=C.UID
WHERE C.FederalTaxID not like '999999990'
AND headers.TransactionStatus = 'N'
AND DATE(headers.TransactionEndTime) >=  '(101)'
AND DATE(headers.TransactionEndTime) <=  '(111)'
AND headers.DocumentTypeUID !=13
GROUP BY Date(headers.CreateDate),headers.DocumentID,C.FederalTaxID
ORDER by headers.Createdate", `FooterQuery`="SELECT count(DISTINCT(headers.DocumentID)), 
replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),'.',',') as value
FROM transactionsdetails details
INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
JOIN Customers AS C on headers.CustomerUID=C.UID
WHERE C.FederalTaxID not like '999999990'
AND headers.TransactionStatus = 'N'
AND DATE(headers.TransactionEndTime) >=  '(101)'
AND DATE(headers.TransactionEndTime) <=  '(111)'
AND headers.DocumentTypeUID !=13
ORDER by headers.Createdate" WHERE `UID`='34001';
UPDATE `reportsections` SET `DetailQuery`="SELECT count(DISTINCT(headers.DocumentID)), replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),'.',',') as value
FROM transactionsdetails details
INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
JOIN Customers AS C on headers.CustomerUID=C.UID
WHERE C.FederalTaxID = '999999990'
AND headers.TransactionStatus = 'N'
AND DATE(headers.TransactionEndTime) >=  '(101)'
AND DATE(headers.TransactionEndTime) <=  '(111)'
AND headers.DocumentTypeUID !=13
ORDER by headers.Createdate;", `FooterQuery`="SELECT replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),'.',',') as value
FROM transactionsdetails details
INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
JOIN Customers AS C on headers.CustomerUID=C.UID
WHERE headers.TransactionStatus = 'N'
AND DATE(headers.TransactionEndTime) >=  '(101)'
AND DATE(headers.TransactionEndTime) <=  '(111)'
AND headers.DocumentTypeUID !=13" WHERE `UID`='34002';

UPDATE `reportsections` SET `DetailQuery`="SELECT
    qry.plu,
    IF(qry.ispeso>0,concat(format(qry.qt/1000,3),\"Kg\"),concat(qry.qt,\" Un\")) as qt,
    round(qry.value/100,2) as lineValue,
    truncate(qry.value*100/(
        SELECT sum(details.SaleValue) FROM transactionsdetails details INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID WHERE DATE(headers.TransactionEndTime)BETWEEN  '(101)'  AND '(111)' AND headers.TransactionStatus = 'N' 
 AND headers.documentTypeUID  != 13
        ),2) as perc
FROM(
    SELECT 
        PluName as plu,
        Sum(details.Quantity) as qt,
        props.ReadQuantityFromScale as ispeso,
        sum(details.SaleValue-details.salevalue*headers.DiscountPercent/100) as value
    FROM transactionsdetails details
        INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID
        RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID
        RIGHT JOIN properties props on props.UID =mainplus.PropertyUID
    WHERE DATE(headers.TransactionEndTime)BETWEEN  '(101)'  AND '(111)' 
        AND headers.TransactionStatus = 'N'
        AND headers.documentTypeUID  != 13 -- guias
    GROUP BY PluName
    HAVING QT > 0
    ORDER BY plu
) as qry;" WHERE `UID`='20001';