/*v0531*/



UPDATE `reportsections` SET `DetailQuery`="SELECT
    Q.F,
    Q.T,
    Q.NV,
    Q.V/*,
    Q.C,
    Q.K*/
FROM(
(
    #query das familias
    SELECT
        qry.fam AS F,
        qry.qnt as T,
        qry.net_value AS NV,
        qry.value as V,
        qry.code as C,
        qry.fam2 as K
    FROM(
        SELECT 
            families.shortdescription as fam,
            SUM(
            IF(properties.ReadQuantityFromScale,
            IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000),
            IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)
            )) as qnt,
            replace(round(sum(details.NetValue-NetValue*headers.DiscountPercent/100)/100,2),'.',',') as net_value, 
            replace(round(sum(details.SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),'.',',') as value, 
            families.code AS code,
            families.uid AS fam2            
        FROM transactionsdetails details
            INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID  #needed for the dates
            INNER JOIN plus on details.PluUID = plus.uid
            INNER JOIN families on plus.familyid = families.uid
            RIGHT JOIN properties on properties.UID =plus.PropertyUID
			WHERE DATE(headers.TransactionEndTime) >= '(101)' AND DATE(headers.TransactionEndTime) <= '(111)'
	            and headers.TransactionStatus = 'N'
            and  headers.DocumentTypeUID != 13             
        GROUP BY families.uid
        ORDER by families.code
    )
    AS qry
)
UNION
(
    #query das subfamilias
    SELECT
        qry2.subfam AS F,
        qry2.qnt as T,
        qry2.net_value AS NV,
        qry2.value as V,
        qry2.code as C,
        qry2.fam as K
    FROM(
        SELECT 
            concat(\"    \",subfamilies.shortdescription) as subfam,
            SUM(
            IF(properties.ReadQuantityFromScale,
            IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000),
            IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)
            )) as qnt,
            replace(round(sum(details.NetValue-NetValue*headers.DiscountPercent/100)/100,2),'.',',') as net_value,
            replace(round(sum(details.SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),'.',',') as value,
            (subfamilies.code+10000) AS code,
            plus.familyid AS fam           
        FROM transactionsdetails details
            INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID  #needed for the dates
            INNER JOIN plus on details.PluUID = plus.uid
            INNER JOIN subfamilies on plus.subfamilyid = subfamilies.uid
            RIGHT JOIN properties on properties.UID =plus.PropertyUID
        WHERE DATE(headers.TransactionEndTime) >= '(101)' AND DATE(headers.TransactionEndTime) <= '(111)'
            and headers.TransactionStatus = 'N' 
            and  headers.DocumentTypeUID != 13 
        GROUP BY subfamilies.uid
        ORDER by subfamilies.code
    )
    AS qry2
)
UNION
(
    SELECT
        @label :=\"Total\" AS F,
		SUM(
        IF(props.ReadQuantityFromScale,
        IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000),
        IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)
        )) as T,
        replace(round(sum(details.NetValue-NetValue*headers.DiscountPercent/100)/100,2),'.',',') as NV,
        replace(round(sum(details.SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),'.',',') as V,
        999999 AS C,
        999999 AS K
    FROM transactionsdetails details
        INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID
        RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID
        RIGHT JOIN properties props on props.UID =mainplus.PropertyUID
    WHERE DATE(headers.TransactionEndTime) >= '(101)' AND DATE(headers.TransactionEndTime) <= '(111)'
        AND headers.TransactionStatus = 'N'
        and  headers.DocumentTypeUID != 13 
)
ORDER BY K,C) AS Q;" WHERE `UID`='26001';

UPDATE `reportsections` SET `DetailQuery`="SELECT 
     IF(Q._name=     @lastName,'',   @lastName:= Q._name) AS OpSalesman,
     Q._item AS OpItem,
     Q._qnt AS OpQnt,
     Q.net_value AS OpNetValue,
     Q._value AS OpValue
FROM
(
SELECT 
    @lastName:='',
    CONCAT(salesterminal.Description,'
') AS _name,
    details.PluName AS _item,
SUM(
IF(properties.ReadQuantityFromScale,
IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000),
IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)
)) as _qnt,
    REPLACE(round(sum(details.NetValue-details.NetValue*headers.DiscountPercent/100)/100,2),'.',',') AS net_value,
    REPLACE(round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2),'.',',') AS _value
FROM transactionsdetails details
    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
    INNER JOIN salesterminal on salesterminal.uid = details.OrderSalesTerminalUID
    INNER JOIN plus on details.PluUID = plus.uid
    RIGHT JOIN properties on properties.UID =plus.PropertyUID
WHERE DATE(headers.TransactionEndTime) >= '(101)' 
    AND DATE(headers.TransactionEndTime) <= '(111)'
    AND headers.TransactionStatus = 'N'     
   AND headers.DocumentTypeUID !=13
GROUP BY details.pluuid,salesterminal.UID
ORDER by _name) 
AS Q" WHERE `UID`='28002';

UPDATE `reportsections` SET `DetailQuery`="SELECT 
    salesterminal.Description AS 'Name',
SUM(
IF(properties.ReadQuantityFromScale,
IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000),
IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)
)) as 'Qty',
    REPLACE(round(sum(details.NetValue-details.NetValue*headers.DiscountPercent/100)/100,2),'.',',') as 'net_value',
    REPLACE(round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2),'.',',') as 'value'
FROM transactionsdetails details
    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
    INNER JOIN salesterminal on salesterminal.uid = details.OrderSalesTerminalUID
   INNER JOIN plus on details.PluUID = plus.uid
   RIGHT JOIN properties on properties.UID =plus.PropertyUID
WHERE DATE(headers.TransactionEndTime) >= '(101)' 
    AND DATE(headers.TransactionEndTime) <= '(111)'
    AND headers.TransactionStatus = 'N'     
    AND headers.DocumentTypeUID !=13
GROUP BY salesterminal.UID
ORDER by 'Name'" WHERE `UID`='28001';

UPDATE `reportsections` SET `DetailQuery`="SELECT 
     IF(Q._name=     @lastName,'',   @lastName:= Q._name) AS OpSalesman,
     Q._item AS OpItem,
     Q._qnt AS OpQnt,
     Q._value AS OpValue
FROM
(
SELECT 
    @lastName:='',
    CONCAT(salesmans.SalesmanName,'
') AS _name,
    details.PluName AS _item,
  SUM(
IF(properties.ReadQuantityFromScale,
IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000),
IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)
)) as _qnt,
    REPLACE(round(sum(details.salevalue-details.salevalue*headers.DiscountPercent/100)/100,2),'.',',') AS _value
FROM transactionsdetails details
    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
    INNER JOIN salesmans on salesmans.uid = headers.CreateSalesmanUID
    INNER JOIN plus on details.PluUID = plus.uid
    RIGHT JOIN properties on properties.UID =plus.PropertyUID
WHERE DATE(headers.TransactionEndTime)>= '(101)' 
    AND DATE(headers.TransactionEndTime)<= '(111)'
    AND DATE(headers.TransactionEndTime)<= '(111)'
    AND headers.TransactionStatus = 'N'     
    AND headers.documentTypeUID  != 13 -- guias
GROUP BY details.pluuid, salesmans.UID
ORDER by _name) 
AS Q" WHERE `UID`='25001';

UPDATE `reportsections` SET `DetailQuery`="SELECT 
   salesmans.SalesmanName AS 'Name',
   SUM(
IF(properties.ReadQuantityFromScale,
IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000),
IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)
)) as _qnt,
    REPLACE(round(sum(details.salevalue-details.salevalue*headers.DiscountPercent/100)/100,2),'.',',') as 'value'
FROM transactionsdetails details
    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
    INNER JOIN salesmans on salesmans.uid = headers.CreateSalesmanUID
	INNER JOIN plus on details.PluUID = plus.uid
    RIGHT JOIN properties on properties.UID =plus.PropertyUID
WHERE DATE(headers.TransactionEndTime)>= '(101)' 
    AND DATE(headers.TransactionEndTime)<= '(111)'
    AND headers.TransactionStatus = 'N'     
    AND headers.documentTypeUID  != 13 -- guias
GROUP BY salesmans.UID
ORDER by 'Name';" WHERE `UID`='25002';

UPDATE `reportsections` SET `DetailQuery`= "SELECT
    IF(qry.pDate =  @lastDate,'',   @lastDate:=   qry.pDate) AS Data,
    IF(qry.pExtra =@lastExtra,'',@lastExtra:=qry.pExtra) AS Extra,
    qry.pCount,
    qry.pParent,
    replace(round(qry.pPrice/100,2),'.',',') as pPrice
FROM(
    SELECT 
        @lastDate :='',
        @lastExtra :='',
        CONCAT(DATE_FORMAT(H.TransactionEndTime,\"%d-%m-%y\"),\"\\n\") as pDate,
        CONCAT(D.PluName,\"\\n\") pExtra,
        D.PluName as pParent,
        Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,
        sum(D.SaleValue) as pPrice

    FROM transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 
    AND DATE(H.TransactionEndTime) BETWEEN  '(101)' AND '(111)' 
    GROUP BY pDate, pExtra, pParent
) AS qry;" WHERE `UID`='18001';

UPDATE `reportsections` SET `DetailQuery`="SELECT
    IF(qry.pDate =  @lastDate2,'', @lastDate2:= qry.pDate) AS Data,
    IF(qry.pExtra = @lastExtra2,'', @lastExtra2:=qry.pExtra) AS Extra,
    qry.pCount,
    round(qry.pPrice/100,2) as pPrice    
FROM(
    SELECT 
        @lastDate2 :='',
        @lastExtra2 :='',
        DATE_FORMAT(H.TransactionEndTime,\"%d-%m-%y\") as pDate,
        D.PluName pExtra,
        Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,
        sum(D.SaleValue) as pPrice
    FROM transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 
    AND DATE(H.TransactionEndTime) BETWEEN  '(101)' AND '(111)' 
    GROUP BY pDate, pExtra
) AS qry;" WHERE `UID`='18002';
UPDATE `reportsections` SET `DetailQuery`="SELECT
    qry.pExtra,
    qry.pCount,
    round(qry.pPrice/100,2) as pPrice
FROM(
    SELECT 
        D.PluName pExtra,
                Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,
        sum(D.SaleValue) as pPrice
    FROM 
        transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 
        AND DATE(H.TransactionEndTime) BETWEEN '(101)' AND '(111)' 
    GROUP BY pExtra
) AS qry;", `FooterQuery`="SELECT
    qry.pCount,
    round(qry.pPrice/100,2) as pPrice
    
FROM(
    SELECT 
        D.PluName pExtra,
        Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,
        sum(D.SaleValue) as pPrice
    FROM 
        transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 
        AND DATE(H.TransactionEndTime) BETWEEN '(101)' AND '(111)' 
) AS qry;" WHERE `UID`='18003';


UPDATE `reportsections` SET `DetailQuery`="SELECT
    IF(qry.pDate =  @lastDate2,'', @lastDate2:= qry.pDate) AS Data,
    IF(qry.pExtra = @lastExtra2,'', @lastExtra2:=qry.pExtra) AS Extra,
    qry.pCount,
    round(qry.pPrice/100,2) as pPrice
FROM(
SELECT 
    @lastDate2 :='',
    @lastExtra2 :='',
    DATE_FORMAT(H.TransactionEndTime,\"%d-%m-%y\") as pDate,
    D.PluName pExtra,
    Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,
    sum(D.SaleValue) as pPrice
FROM 
    transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 
    AND DATE(H.TransactionEndTime) BETWEEN  '(101)' AND '(111)' 
    GROUP BY pDate, pExtra
) AS qry" WHERE `UID`='22001';
UPDATE `reportsections` SET `DetailQuery`="SELECT
    qry.pExtra,
    qry.pCount,
    round(qry.pPrice/100,2) as pPrice
    
FROM(
    SELECT 
        D.PluName pExtra,
        Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,
        sum(D.SaleValue) as pPrice
    FROM 
        transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 
        AND DATE(H.TransactionEndTime) BETWEEN '(101)' AND '(111)' 
    GROUP BY pExtra
) AS qry;", `FooterQuery`="SELECT
    qry.pCount,
    round(qry.pPrice/100,2) as pPrice
FROM(
    SELECT 
        D.PluName pExtra,
        Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,
        sum(D.SaleValue) as pPrice
    FROM 
        transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 
        AND DATE(H.TransactionEndTime) BETWEEN '(101)' AND '(111)' 
) AS qry;" WHERE `UID`='22002';

UPDATE `reportsections` SET `DetailQuery`= "SELECT 
    salesterminal.description as 'description', 
    replace(round(sum(tenders.value)/100,2),'.',',') as 'value'
FROM transactionsheaders headers
INNER JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID
INNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid
WHERE 
    headers.SalesmanSessionID = '(122)' 
    and headers.TransactionStatus = 'N' 
    and headers.documentTypeUID not in (13,25) 
Group by headers.TransactionStartTerminalUID;", `FooterQuery`="SELECT 
    replace(round(sum(tenders.value)/100,2),'.',',') as 'value'
FROM transactionsheaders headers
INNER JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID
INNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid
WHERE 
	headers.SalesmanSessionID = '(122)' 
    and headers.TransactionStatus = 'N'
    and headers.documentTypeUID not in (13,25) " WHERE `UID`='5001';
UPDATE `reportsections` SET `OrderField`='5' WHERE `UID`='5003';
UPDATE `reportsections` SET `OrderField`='6' WHERE `UID`='5004';
UPDATE `reportsections` SET `OrderField`='7' WHERE `UID`='5005';
DELETE FROM `reportsections` WHERE `UID` = 5007;
INSERT INTO `reportsections` (`UID`, `RecordDeleted`, `SyncCounter`, `ReportUID`, `HeaderFormat`, `DetailFormat`, `FooterFormat`,`FooterQuery`, `Columns`, `OrderField`) 
VALUES ('5007', '0', '1', '5', '\\n        -- TOTAL APURADO --\\n', NULL, '        --------------------------------  %40.40s', 
"SELECT 
    replace(round(sum(tenders.value)/100,2),'.',',') as 'value'
FROM transactionsheaders headers
INNER JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID
INNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid
WHERE 
	headers.SalesmanSessionID = '(122)' 
    and headers.TransactionStatus = 'N'"
,'3', '4');

UPDATE `reportsections` SET `DetailQuery`="SELECT
    qry.plu,
    IF(qry.ispeso>0,concat(format(qry.qt/1000,3),\"Kg\"),concat(qry.qt,\" Un\")) as qt,
    round(qry.value/100,2) as lineValue,
    truncate(qry.value*100/(
        SELECT sum(details.SaleValue) FROM transactionsdetails details INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID WHERE DATE(headers.TransactionEndTime)BETWEEN  '(101)'  AND '(111)' AND headers.TransactionStatus = 'N' 
 AND headers.documentTypeUID  != 13
        ),2) as perc
FROM(
    SELECT 
        PluName as plu,
        Sum(IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)) as qt,
        props.ReadQuantityFromScale as ispeso,
        sum(details.SaleValue-details.salevalue*headers.DiscountPercent/100) as value
    FROM transactionsdetails details
        INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID
        RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID
        RIGHT JOIN properties props on props.UID =mainplus.PropertyUID
    WHERE DATE(headers.TransactionEndTime)BETWEEN  '(101)'  AND '(111)' 
        AND headers.TransactionStatus = 'N'
        AND headers.documentTypeUID  != 13 -- guias
    GROUP BY PluName
    HAVING QT > 0  
    ORDER BY plu
) as qry;", `FooterQuery`="SELECT SUM(
IF(props.ReadQuantityFromScale,
IF(headers.documentTypeUID != 25,1,-1),
IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)
)) as newqt,
    round(sum(details.SaleValue-details.salevalue*headers.DiscountPercent/100)/100,2) as value

FROM transactionsdetails details
       INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID
       RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID
       RIGHT JOIN properties props on props.UID =mainplus.PropertyUID
    WHERE DATE(headers.TransactionEndTime)BETWEEN  '(101)'  AND '(111)' 
        AND headers.TransactionStatus = 'N'
        AND headers.documentTypeUID  != 13 -- guias" WHERE `UID`='20001';

UPDATE `reportsections` SET `DetailQuery`="SELECT 
 CONCAT_WS(' ',mType.description,mov.DocumentID) as description,
 replace(round(mov.value/100,2),'.',',') as 'value' 
FROM cashdrawer_movements mov
inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
left join cashdrawertenders t on t.CashDrawerMovementUID = mov.UID
WHERE 
    (
    mov.CashDrawerMovementUID = '(121)'
    and mType.MovementFlow>0
and (t.PaymentTypeUID <> 9997 || t.PaymentTypeUID is NULL)
     )
   || 
    mov.uid = '(121)'", `FooterQuery`="SELECT replace(round(sum(mov.value)/100,2),'.',',') as 'value'
FROM cashdrawer_movements mov
inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
left join cashdrawertenders t on t.CashDrawerMovementUID = mov.UID
WHERE 
    ( 
    mov.CashDrawerMovementUID = '(121)'
    and mType.MovementFlow>0
and (t.PaymentTypeUID <> 9997 || t.PaymentTypeUID is NULL)
     )
   || 
    mov.uid =  '(121)'" WHERE `UID`='19002';
UPDATE `reportsections` SET `FooterQuery`="SELECT replace(round((
(
/*Movimentos Caixa Entrada Footer*/
SELECT IFNULL( sum(mov.value),0) 
FROM cashdrawer_movements mov
    inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
left join cashdrawertenders t on t.CashDrawerMovementUID = mov.UID
WHERE 
    (
    mov.CashDrawerMovementUID = '(121)'
    and mType.MovementFlow>0
and (t.PaymentTypeUID <> 9997 || t.PaymentTypeUID is NULL)
     )
   || 
    mov.uid =  '(121)'
)
+
(
/*VENDAS DINHEIRO*/
SELECT IFNULL( sum(value),0) 
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.type = 1
    AND tenders.MovementUID = '(121)'
    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/
)
+
(
/*VENDAS OUTROS*/
SELECT IFNULL( sum(value),0) 
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.type NOT IN (1,2,3) /* diferente dinheiro, facturacaoo externa e conta corrente*/
    AND tenders.MovementUID = '(121)'
    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/
)
)/100,2),'.',',') as 'value'" WHERE `UID`='19004';

UPDATE `reportsections` SET `FooterQuery`="SELECT replace(round((
(
/*Movimentos Caixa Entrada Footer*/
SELECT IFNULL( sum(mov.value),0) 
FROM cashdrawer_movements mov
    inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
	left join cashdrawertenders t on t.CashDrawerMovementUID = mov.UID
WHERE 
    (
    mov.CashDrawerMovementUID = '(121)'
    and mType.MovementFlow>0
	and (t.PaymentTypeUID <> 9997 || t.PaymentTypeUID is NULL)
     )
   || 
    mov.uid =  '(121)'
)
+
(
/*VENDAS DINHEIRO*/
SELECT IFNULL( sum(value),0) 
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.type = 1
    AND  tenders.MovementUID = '(121)'
    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/
)
+
(
/*VENDAS OUTROS*/
SELECT IFNULL( sum(value),0) 
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.type NOT IN (1,2,3) /* diferente dinheiro, factura???§???£o externa e conta corrente*/
    AND  tenders.MovementUID = '(121)'
    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/
)
-
(
/*TOTAL DE SAIDAS*/
(
SELECT IFNULL(sum(tenders.value),0) 
FROM transactionstenders tenders
    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID
    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID
WHERE pTypes.code = 9998
    AND  tenders.MovementUID = '(121)'
    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/   
)
+
(
SELECT IFNULL(sum(value),0)
FROM cashdrawer_movements mov
inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid
WHERE 
    mov.CashDrawerMovementUID = '(121)'
    and mov.MovementTypeID != 2 /*exclui fecho caixa*/
    and mType.MovementFlow = 0
)
)
)/100,2),'.',',') as 'value'" WHERE `UID`='19008';