var boffice = new function() {

    //config
    this.debug = true;
    this.licencaList = [];
    this.waiting = false;

    this.log = function(str) {
        if (((this.debug) || (isAdmin)) && (false)) {
            console.log(str);

            if (typeof(str) != "object") {
                if (str.indexOf("parsererror") > -1) {
                    $("DIV#dialog-confirm").prop("title", "Json ERROR: [ INVALID ]")
                    $("div#sendJSON").html(str);
                    $("#dialog-confirm").dialog({
                        resizable: true,
                        width: 600,

                        modal: true,
                        buttons: {
                            Cancel: function() {
                                //$( this ).dialog( "close" );
                            }
                        }
                    });
                }
            }

        }
    }

    this.processMyJson = function(data) {

        var url = "";

        if (!data) {
            console.log("ATTENTION *********** : JSON IS EMPTY");
            return;
        }


        if (data.objects != undefined) {
            url = boffice_JsonObjects.Process(data);
        } else if (data.windowid != undefined) {
            url = boffice_JsonData.Process(data);
        } else if (data.command != undefined) {
            url = boffice_JsonCommands.Process(data);
        } else {
            boffice.log("ATTENTION *********** : JSON NOT PROCESSED");
        }

        if (url!==undefined)
        {
            boffice.send_url(url);
        }

    }
    this.send_url = function(_url) {

        if (_url == "")
            return;
        
        boffice.log("send_url: '" + _url + "'");

        _url = serverUrl + _url;

        

        var self = this;
        //Handle application exit
        if ((webApp) && (_url == serverUrl + "callback&windowID=1&objectID=451&value=-12")) {
            setTimeout(
                function() {
                    if (ImgCache.helpers.isCordova()) {
                        navigator.app.exitApp();
                    } else { //nw.js
                        var gui = require('nw.gui');
                        var win = gui.Window.get();

                        win.close(true);
                    }
                }, 1000);
        } else if (_url == serverUrl + "callback&windowID=1&objectID=451&value=-12") {
            alert("Aplicação fechada.");
            location.reload();
        }

        if ((cacheMode == 0) && (!this.waiting)) {
            this.waiting = true;
            setTimeout(
                function() {
                    if (this.waiting)
                    {
                    //showWait(1, 2); //if it takes too long
                    if (bofficeGlobals.DEBUG)
                    console.log("PERFORMANCE: '"+url+"' Took more than 1.5secs");
            
                    }
                },
                1500);
        }



        $.ajax({
                    url: _url,
                    dataType: "json",
                    contentType:"application/json; charset=utf-8",
                    async: false,
                    timeout: AJAX_TIMEOUT, //1* 1000 second timeout
                    success: function(data) {

                        self.processMyJson(data);


                    }
                }

            ).done(function() {
                //executes afterwards
                self.waiting = false;
                //showWait(0,2);
            })
            .fail(function(jqxhr, textStatus, error) {
                self.waiting = false;
                //showWait(0,2);
                var err = textStatus + ", " + error;

                var doLog = false;

                try {
                    //check for error message boxes
                    var resJson = JSON.parse(jqxhr.responseText.replace(/\n/g, ""));
                    if (resJson.command != undefined) {
                        self.ProcessJsonCommand(resJson);
                    } else {
                        doLog = true;
                    }
                } catch (e) {
                    doLog = true;
                }

                console.log("send_url URL Fail: " + _url + "\n" + "Request Failed: " + err + "\n" + jqxhr.responseText);
            });

    };

    this.globalClick = function(elem, func) {
        if (forceClicks === undefined)
        {
            forceClicks = false;
        }
        if ( (isTouchDevice) && (forceClicks == false) ) { //not needed when using touch.min.js
            $(elem).on("tap", function(event) { //not compatible with android chrome driver
                //console.log("TAP! "+event.eventPhase);
                event.preventDefault();
                event.stopPropagation();
                func.call($(this));
            });
        } else {
            $(elem).on("click", function(event) {
                //console.log("CLICK!");
                event.preventDefault();
                event.stopPropagation();
                func.call($(this));
            });
        }

    }

}