var ImageCache = new function() {
	this.imagesList = [];
    this.globalCount = 0;


	this.initApp = function()
	{
		if (webApp)
		{
	        initUrl = "/callback&windowID=-4&objectID=-1&value="+bofficeScreen.RESOLUTION;             //INICIO DA APLICACAO
		boffice.send_url(serverUrl+initUrl);
	        //boffice.send_url(initUrl); //windows
	    }
	}

	this.cacheImages = function(skipInit)
	{
		if (skipInit == undefined)
		{
			skipInit = false;
		}

        var dir = imagesPath;
        var fileextension = ".png";
        var self = this;
        $.ajax({
            //This will retrieve the contents of the folder if the folder is configured as 'browsable'
            url: dir,
            contentType:"application/json; charset=utf-8",
            async: true,
            timeout: AJAX_TIMEOUT})
            .done(function (data) {
            	$("#blocker > div").hide();
                //List all png file names in the page
                $(data).each(function () {

                            var filename = $(this).attr("href");
                            if (filename != undefined && (filename.indexOf("png")>-1 || filename.indexOf("jpg")>-1))
                            {
                            	var i = self.imagesList.length;
                                self.imagesList[i] = dir + filename.replace("/","");

                                var fileNameIndex = self.imagesList[i].lastIndexOf("/") ;
						        var filename = self.imagesList[i].substr(fileNameIndex);

						        if (webApp)
						        {
						        	ImgCache.isCached(self.imagesList[i], function(path, success) {
									if (success) {
									    // already cached
									    //ImgCache.useCachedFile(target);
									    ImgCache.getCachedFileURL(path,function(img_src,entry)
									    {

									    	//console.log("CACHE: '"+img_src+"' already cached in '"+entry+"'");
									    	self.globalCount+=1;
									    	if (self.globalCount==self.imagesList.length)
									    	{
									    		console.log("CACHE: All "+self.globalCount+" images cached!");
									    		if (!skipInit)
									    		{
									    			self.initApp();
									    		}
									    	}
									    });
									  } else {
									    // not there, need to cache the image
									    ImgCache.cacheFile(path, function () {
									      //ImgCache.useCachedFile(target);
									    	//console.log("CACHE: caching '"+img_src+"' ...");
									    	self.globalCount+=1;
									    	if (self.globalCount==self.imagesList.length)
									    	{
									    		console.log("CACHE: All "+self.globalCount+" images cached!");
									    		if (!skipInit)
									    		{
										    		self.initApp();
									    		}
									    	}
									    });
									  }
									});
						        }
						        
                            }
                    
                });

	        })
	        .fail(function( jqxhr, textStatus, error ) {
	        	$("#blocker > i").toggleClass("fa-spin");
	        	$("#blocker > div> span").html("Sem ligação ao servidor:<br>"+serverUrl);
	        	$("#blocker > div").show();
	        	
	        	setTimeout(function(){
	        	$("#blocker > i").toggleClass("fa-spin");
	        		//$("#blocker > span").hide();
	        		if (DIALOG_OPEN ==false)
	        		{
	        			self.cacheImages();
	        		}
	        	},2000);
	        }
		);
	}


	this.init= function()
	{

	    // write log to console
	    ImgCache.options.debug = true;

	    // increase allocated space on Chrome to 50MB, default was 10MB
	    ImgCache.options.chromeQuota = 100*1024*1024;

	    ImgCache.init(function () {
	    console.log("ImgCache init: success! cache in: "+ImgCache.getCacheFolderURI()+"/");

	    // from within this function you're now able to call other ImgCache methods
	    // or you can wait for the ImgCacheReady event

	    ImageCache.cacheImages();

	    }, function () {
	        console.log("ImgCache init: error! Check the log for errors");
	    });

	}

	this.cacheImage= function (target)
	{
		var imgpath = target.attr('src').trim();
		
		ImgCache.cacheFile(imgpath, function () {
		  ImgCache.useCachedFileWithSource(target,imgpath,function () {
		  }, function(){
		    ImgCache.cacheFile(imgpath);
		  })
		});
		


	}

	this.cacheImageBackground= function (target)
	{
		/*
		ImgCache.cacheBackground(target, function () {
		  ImgCache.useCachedBackground(target, function () {
		    console.log('now using local background copy');
		  }, function(){
		    console.log('could not load background');
		    ImgCache.cacheBackground(target);
		  })
		});*/

		ImgCache.isBackgroundCached(target, function(path, success) {
		  if (success) {
		    // already cached
		    ImgCache.useCachedBackground(target);
		  } else {
		    // not there, need to cache the image
		    ImgCache.cacheBackground(target, function () {
		      ImgCache.useCachedBackground(target);
		    });
		  }
		});
	}
	this.getCachedImageUrl = function(img)
	{
		if (!webApp)
		{
			return img;//no caching!
		}
		var response = ImgCache.private.getCachedFileName(img.trim());
		if (ImgCache.helpers.isCordovaAndroid()) {
            // This hack is probably only used for older versions of Cordova
            if (response.indexOf('file://') === 0) {
                // issue #4 -- android cordova specific
                response = response.substr(7);
            }
        }
		//todo check if exists? in storage
		return ImgCache.getCacheFolderURI()+"/"+response;
	}

	this.LoadImagePicker = function()
	{

		var self = this;

		this.cacheImages(true);


	    jQuery("select.image-picker").html("");

	    for (var i = 0; i < self.imagesList.length; i++){

	    	var imgP = this.getCachedImageUrl(self.imagesList[i]);
	    	var fileNameIndex = self.imagesList[i].lastIndexOf("/") + 1;
			var filename = self.imagesList[i].substr(fileNameIndex);

      		$("#selectImagePicker").append('<option data-img-src=\"' + imgP + '\" value=\"' + i + '\" class=\"imagePreview\">' + filename + '</option>');  
	    }

	    jQuery("select.image-picker").imagepicker({
	        hide_select:  false,
	    });
	    jQuery("select.image-picker").hide();

	}



}
