var bofficeGlobals = new function() {
    "use strict";

    //disable on production!!!
    this.DEBUG = false;

    this.versionInfo = undefined;
    this.webfeVersion = "beta 6.7";

    this.useCache = 1;

    this.notifWindows = [13, 173, 150, 182, 163, 136, 159, 200, 181, 171];
    this.backgroundDivWindows = [155, 121, 131, 123, 169, 151]; /*force black background in these*/
    this.unscaledWindows = [];
    this.nestedListBoxes = ["102_201"];
    this.labelFields = ["131_83342", "131_123437"]; //;["123_99","155_99"];
    this.forceReadOnlyFields = ["4_15", "138_1", "159_4", "138_10", "153_1",
        "178_14", "178_15", "178_16",
        "4_90" //SPOL!
    ];
    //always chage to first tab on these windows:
    this.alwaysSwitchFirstTab = [138, 123]

    this.screenpy = 53; //default was 53;
    this.TITLE_BARHEIGHT = 2;


    this.colorSelects = ["104_32", "105_6"];

    this.autoFocusFields = {
        //181: "2", //in window 181 autofocus field
    }

    this.DEFAULT_BUTTON_IMAGE = "1100.png"

    this.back2Window1Timer = true;

    this.colorPickerOptions = {
        allowEmpty: true,
        showInitial: true,
        showInput: true,
        preferredFormat: "hex",
        showAlpha: true,

    }

    //pairs input|select
    this.searchBoxes_input = [
        "11_60",
        "123_35",
        "145_13",
        "156_1",
        "13_60",
        "175_1",
        "163_1",
        "109_9",
        "145_13",
        "163_1",
        "171_1"
    ];
    this.searchBoxes_select = [
        "11_10",
        "123_37",
        "145_14",
        "156_4",
        "13_10",
        "175_4",
        "163_2",
        "109_10",
        "145_14",
        "163_2",
        "171_10"
    ];


    this.currencySymbol = "€";

    this.dateField = {
        bootcssVer: 3,
        minView: 2,
        autoclose: true,
        language: 'pt',
        startView: 2,
        todayBtn: true,
        format: 'dd/mm/yyyy'
    };

    this.timeField = {
        bootcssVer: 3,
        format: 'hh:ii',
        minView: 0,
        autoclose: true,
        language: 'pt',
        startView: 0,
    }
    this.KeyboardCaretConfig = {
        // extra class name added to the caret
        // "ui-keyboard-caret" class is always added
        caretClass: 'blinking-cursor',
        // *** for future use ***
        // data-attribute containing the character(s) next to the caret
        charAttr: 'data-character',
        // # character(s) next to the caret (can be negative for RTL)
        charIndex: 1,

        // *** caret adjustments ***
        // adjust horizontal position (pixels)
        offsetX: 0,
        // adjust vertical position (pixels); also adjust margin-top in css
        offsetY: 0,
        // adjust caret height (pixels)
        adjustHt: 0
    }

    this.KeyboardConfig = {
        position: {
            of: null, // null = attach to input/textarea; use $(sel) to attach elsewhere
            my: 'center top',
            at: 'center bottom',
            at2: 'center bottom' // used when "usePreview" is false
        },


        autoAccept: true,
        usePreview: false,
        lockInput: false,
        restrictInput: false,
        caretToEnd: true,

        css: {
            // keyboard wrapper theme
            container: {
                theme: 'b'
            },
            // theme added to all regular buttons
            buttonMarkup: {
                theme: 'b',
                shadow: 'true',
                corners: 'true'
            },
            // theme added to all buttons when they are being hovered
            buttonHover: {
                theme: 'b'
            },
            // theme added to action buttons (e.g. tab, shift, accept, cancel);
            // parameters here will override the settings in the buttonMarkup
            buttonAction: {
                theme: 'c'
            },
            // theme added to button when it is active (e.g. shift is down)
            // All extra parameters will be ignored
            buttonActive: {
                theme: 'c'
            }
        },

        keyBinding: 'mousedown touchend',

        visible: function(e, keyboard, el) {
            //if (windowID.substring(0,3) != "Ask")
            //{

            if ($(el).prop("tagName") != "TEXTAREA") {
                setTimeout(function() {
                    $(el).select();
                }, 100);
            }
            //check overlapping
            var value = windowID.toString();
            if (value.substring(0, 3) != "Ask") {
                if ($("body > Div.ui-keyboard").offset().top < $(el).offset().top) {
                    var hh = $(el).offset().top - $("body > Div.ui-keyboard").height();
                    //if ($("body > Div.ui-keyboard").offset().top+hh >$(el).offset().top )
                    //{
                    //alert("alto!");

                    var otherVar = hh - (2 * (bofficeScreen.ty));
                    $("body > Div.ui-keyboard").css("top", otherVar + "px");
                    //}
                }
            } else {
                $(el).val(""); //clean input on ask windows
            }
            //}
            //block clicks 


            for (var i = windows.length - 1; i >= 0; i--) {
                if (windows[i].substring(0, 3) != "Ask") {
                    $("#w" + windows[i]).append("<div class='kbblocky'></div>");
                    break;
                }
            }



        },
        beforeClose: function(e, keyboard, el) {
            var windowStr = windowID + "";
            setTimeout(function() {
                if (windowStr.substring(0, 3) == "Ask") {
                    keyboard.destroy();
                }
            }, 100);
        },
        accepted: function(e, keyboard, el) {
            e.preventDefault();
            e.stopPropagation();


            for (var i = windows.length - 1; i >= 0; i--) {
                if (windows[i].substring(0, 3) != "Ask") {
                    var takeout = windows[i];
                    setTimeout(
                        function() {
                            $("#w" + takeout + " > .kbblocky").remove();
                        }, 100);
                    break;
                }
            }
            var windowStr = windowID + "";
            if (windowStr.substring(0, 3) == "Ask") {
                bofficeClicks.ProcessClick($("#w" + windowID).find("button.btOK"));


            }

            return false;


        },
        canceled: function(e, keyboard, el) {
            e.preventDefault();
            e.stopPropagation();
            /*
            keyboard.close();
            var windowStr = windowID + "";
            if (windowStr.substring(0, 3) == "Ask") {
                bofficeClicks.ProcessClick($("#w" + windowID).find("button.btCancel"));
                event.preventDefault();
            }

           
            */

            for (var i = windows.length - 1; i >= 0; i--) {
                if (windows[i].substring(0, 3) != "Ask") {
                    var takeout = windows[i];
                    setTimeout(
                        function() {
                            $("#w" + takeout + " > .kbblocky").remove();
                        }, 100);
                    break;
                }
            }
            var windowStr = windowID + "";
            if (windowStr.substring(0, 3) == "Ask") {
                //close window
                bofficeClicks.ProcessClick($("#w" + windowID).find("button.btCancel"));

            }
            return false;


        },


    };
    if (false) {
        this.KeyboardConfig.keyBinding = 'touchend';
    }

    $.keyboard.keyaction.enter = function(base) {
        if (base.el.nodeName === "INPUT") {
            base.close(true); //accept
        } else {
            base.insertText('\r\n'); // textarea
        }
    };

    $.extend(true, this.KeyboardConfig, $.keyboard.language.pt);

    this.DialogKeyboardConfig = {};
    $.extend(true, this.DialogKeyboardConfig, this.KeyboardConfig);
    this.DialogKeyboardConfig.autoAccept = false;


    this.DialogKeyboardConfig.appendLocally = true;
    //this.DialogKeyboardConfig.stayOpen = true;
    //this.DialogKeyboardConfig.alwaysOpen = true;

    /*
        this.DialogKeyboardConfig.css = {
                // keyboard wrapper theme
                container: {
                    theme: 'b'
                },
                // theme added to all regular buttons
                buttonMarkup: {
                    theme: 'b',
                    shadow: 'true',
                    corners: 'true'
                },
                // theme added to all buttons when they are being hovered
                buttonHover: {
                    theme: 'b'
                },
                // theme added to action buttons (e.g. tab, shift, accept, cancel);
                // parameters here will override the settings in the buttonMarkup
                buttonAction: {
                    theme: 'c'
                },
                // theme added to button when it is active (e.g. shift is down)
                // All extra parameters will be ignored
                buttonActive: {
                    theme: 'c'
                }
            },
    */


    this.handleTouchKeyboard = function() {

        //$(this).prop('readonly', false);
        $(this).getkeyboard().reveal();
    }

    var self = this;

    this.Caret = {

    }

    this.quertyKeyboard = {
        layout: 'portuguese-qwerty',
        restrictInput: false,
    };

    this.numericKeyboard = {
        layout: 'custom',
        restrictInput: true,
        customLayout: {
            'default': [
                '7 8 9 {c}',
                '4 5 6 {b}',
                '1 2 3 {empty}',
                '0 {left} {right} {a}'
            ]
        },

    }

    this.decimalKeyboard = {
        layout: 'custom',
        customLayout: {
            'default': [
                '7 8 9 {c}',
                '4 5 6 {b}',
                '1 2 3 .',
                '0 {left} {right} {a}'
            ]
        },

    }

}