"use strict";
var ScreenMigrations = Class.extend(function() {
    var windowRatios = {};
    var windowid;
    var rect;

    //Classes can have constructors
    this.constructor = function(_windowid, xTop, xLeft, xWidth, xHeight, _rect) {

        windowid = _windowid;
        rect = _rect;

        var screenInPX = bofficeScreen.getScreenSizeInTx();

        //exclude dialog windows
        if (!($.inArray(windowid, bofficeGlobals.notifWindows) >= 0)) {
            var ratio_x = 0;
            var ratio_y = 0;
            if ((xTop == bofficeGlobals.TITLE_BARHEIGHT) && (xLeft == 0)) {
                if (xWidth == 53) {
                    ratio_x = xWidth / screenInPX.width;
                    console.log("Window: " + windowid + " is undersize!");
                }

            }
            if (ratio_x != 0 || ratio_y != 0) {
                windowRatios[windowid] = {
                    x: ratio_x,
                    y: ratio_y
                };
            }

            var rootWindow = rect;
            rootWindow.left = 0;
            rootWindow.top = 0;
            rootWindow.width = bofficeScreen.screenWidthPx + "px";
            rootWindow.height = bofficeScreen.screenHeightPx + "px";
            if (usePercUnits) {
                rootWindow.height = "100%";
                rootWindow.width = "100%";
            }
        }
    };
    this.needsResize = function(element) {
        return ((windowRatios[windowid] !== undefined) &&
            ((this.type != "com.sage.components.window.Window"))
        );
    }

    this.resize = function(element, xTop, xLeft, xWidth, xHeight) {
        if (windowRatios[windowid] !== undefined) {
            var ratio = windowRatios[windowid];
            if (element.type != "com.sage.components.window.Window") {
                var resized = false;
                if (bofficeScreen.RESOLUTION == 2) {

                        /**center all elements **/                    
                        xLeft+=5;
                        //xTop+=2;
                    
                }
                rect = bofficeScreen.fromSnatchCoords(
                    xTop,
                    xLeft,
                    xWidth,
                    xHeight
                );
                if (resized) {
                    console.log(element.arguments[0].value + " '" + element.type + "'" + " resizing....");
                }

            }

        }
        return rect;
    }
});
/* STATIC */