var bofficeScreen = new function() {
    "use strict";

    this.RESOLUTION = 1;
    this.tx = 0;
    this.ty = 0;

    //not needed... 
    this.sdlXratio = 1.00;
    this.sdlYratio = 1.00;

    this.screenWidthPx;
    this.screenHeightPx;

    this.gridFactor = 1;


    this.fromTxTyRel = function(rectIn, rel) {
        var rect = {};
        if (usePercUnits) {
            rect.top = ((rectIn.top / rel.height) * 100);
            rect.left = ((rectIn.left / rel.width) * 100);
            rect.width = ((rectIn.width / rel.width) * 100);
            rect.height = ((rectIn.height / rel.height) * 100);

            rect.top += "%";
            rect.left += "%";
            rect.width += "%";
            rect.height += "%";

        } else {
            rect.top = Math.round(rectIn.top) + "px";
            rect.left = Math.round(rectIn.left) + "px";
            rect.width = Math.round(rectIn.width) + "px";
            rect.height = Math.round(rectIn.height) + "px";
        }

        return rect;
    }

    this.fromTxTy = function(rectIn) {
        var rect = {};
        if (usePercUnits) {
            rect.top = ((rectIn.top / this.screenHeightPx) * 100);
            rect.left = ((rectIn.left / this.screenWidthPx) * 100);
            rect.width = ((rectIn.width / this.screenWidthPx) * 100);
            rect.height = ((rectIn.height / this.screenHeightPx) * 100);

            rect.top += "%";
            rect.left += "%";
            rect.width += "%";
            rect.height += "%";

        } else {
            rect.top = Math.round(rectIn.top) + "px";
            rect.left = Math.round(rectIn.left) + "px";
            rect.width = Math.round(rectIn.width) + "px";
            rect.height = Math.round(rectIn.height) + "px";
        }

        return rect;
    }
    this.fromSnatchCoordsToPixels = function(top, left, width, height) {
        var rect = {
            left: Math.round((left * this.tx) / this.sdlXratio),
            top: Math.round((top * this.ty) / this.sdlYratio),
            height: Math.round((height * this.ty) / this.sdlYratio),
            width: Math.round((width * this.tx) / this.sdlXratio)
        }
        return rect;
    }
    this.fromSnatchCoords = function(top, left, width, height) {
        var rect = {
            left: Math.round((left * this.tx) / this.sdlXratio),
            top: Math.round((top * this.ty) / this.sdlYratio),
            height: Math.round((height * this.ty) / this.sdlYratio),
            width: Math.round((width * this.tx) / this.sdlXratio)
        }


        return this.fromTxTy(rect);
    };
    this.fromSnatchCoordsRel = function(top, left, width, height, rel) {
        var rect = {
            left: Math.round((left * this.tx) / this.sdlXratio),
            top: Math.round((top * this.ty) / this.sdlYratio),
            height: Math.round((height * this.ty) / this.sdlYratio),
            width: Math.round((width * this.tx) / this.sdlXratio)
        }


        return this.fromTxTyRel(rect, rel);
    };

    this.fromSnatchCoordsFromRect = function(rect) {
        return this.fromSnatchCoords(rect.top, rect.left, rect.width, rect.height);
    };

    /*main function*/
    /*
        this.toSnatchCoords = function(top, left, width, height) {

            var rect = {
                "top": Math.round((top * this.sdlYratio) / this.ty),
                "left": Math.round((left * this.sdlXratio) / this.tx),
                "width": Math.round((width * this.sdlXratio) / this.tx),
                "height": Math.round((height * this.sdlYratio) / this.ty),
            };

            return rect;
        };
        */

    this.toSnatchCoords = function(top, left, width, height) {

        var rect = {
            "top": Math.round(((top * this.sdlYratio) / this.ty) * 100) / 100,
            "left": Math.round(((left * this.sdlXratio) / this.tx) * 100) / 100,
            "width": Math.round(((width * this.sdlXratio) / this.tx) * 100) / 100,
            "height": Math.round(((height * this.sdlYratio) / this.ty) * 100) / 100,
        };

        return rect;
    };

    this.toSnatchCoordsRel = function(top, left, width, height, rel) {

        var rect = {
            "top": (top - rel.top) * this.sdlYratio,
            "left": (left - rel.left) * this.sdlXratio,
            "width": width * this.sdlXratio,
            "height": height * this.sdlYratio,
        };


        return toSnatchCoords(rect);
    };
    this.toSnatchCoordsFromRect = function(rect) {
        return this.toSnatchCoords(rect.top, rect.left, rect.width, rect.height);
    }
    this.toSnatchCoordsFromRectRel = function(rect, rel) {
        return this.toSnatchCoordsRel(rect.top, rect.left, rect.width, rect.height, rel);
    }

    this.snapToGrid = function(rectin) {
        //var rect1 = this.removePX(rectin);
        //var rect2 = this.fromTxTy(rectin);
        //var rect3 = this.fromSnatchCoordsFromRect(rect2);
        /*
                var rect2 = this.toSnatchCoordsFromRect(this.removePX(rect3));
                var rect3 = this.fromSnatchCoordsFromRect(rect2);
        */
        var rect = {
            "top": ( (Math.floor(rectin.top * 100 / bofficeScreen.ty) / 100) * bofficeScreen.ty) ,
            "left": ( (Math.floor(rectin.left * 100 / bofficeScreen.tx) / 100) * bofficeScreen.tx) ,
            "width": ( (Math.floor(rectin.width * 100 / bofficeScreen.tx) / 100) * bofficeScreen.tx),
            "height": ( (Math.floor(rectin.height * 100 / bofficeScreen.ty) / 100) * bofficeScreen.ty),
        };


        return rect;
    }
    this.snapToGridRound = function(rectin) {
        //var rect1 = this.removePX(rectin);
        //var rect2 = this.fromTxTy(rectin);
        //var rect3 = this.fromSnatchCoordsFromRect(rect2);
        /*
                var rect2 = this.toSnatchCoordsFromRect(this.removePX(rect3));
                var rect3 = this.fromSnatchCoordsFromRect(rect2);
        */
        var rect = {
            "top":  Math.round(rectin.top),
            "left":  Math.round(rectin.left),
            "width":  Math.round(rectin.width),
            "height":  Math.round(rectin.height),
        };


        return rect;
    }
    this.snapToGridFloor = function(rectin) {
        //var rect1 = this.removePX(rectin);
        //var rect2 = this.fromTxTy(rectin);
        //var rect3 = this.fromSnatchCoordsFromRect(rect2);
        /*
                var rect2 = this.toSnatchCoordsFromRect(this.removePX(rect3));
                var rect3 = this.fromSnatchCoordsFromRect(rect2);
        */
        var rect = {
            "top":  Math.floor(rectin.top),
            "left":  Math.floor(rectin.left),
            "width":  Math.floor(rectin.width),
            "height":  Math.floor(rectin.height),
        };


        return rect;
    }
    this.snapToGridCoordsRound = function(top, left, width, height, rel) {

        var rect = {
            "top": top,
            "left": left,
            "width": width,
            "height": height,
        };


        return this.snapToGridRound(rect);
    };
    this.getWindowRect = function(windowID) {
        var j_window = uiData["window_"+windowID].j_procID;
        var isVisible = j_window.is(":visible");
        if (!isVisible)
            j_window.show();
        var windowRect = j_window[0].getBoundingClientRect();
        //if (!isVisible)
            j_window.hide();

        return windowRect;
    }
    this.enableDrag = function() {
        return ({
            cancel: false,
            disabled: false,
            grid: [this.tx / this.gridFactor, this.ty / this.gridFactor],
            drag: function(event, ui) {
                //console.log("drag");
                if ($(this).hasClass("SlideGrid")) {
                    var _id = $(this).attr("id");
                    uiData["slidegrid_" + _id].populateSlideGrid();
                }
                $(this).attr("drag",1);
            },
            stop: function(event, ui) {
                /* enable resize again?!
                $(this).parent().children(".draggable").draggable(bofficeScreen.disableDrag());
                $(this).parent().children(".draggable").resizable(bofficeScreen.enableResize());
                $(this).parent().children(".draggable").draggable(bofficeScreen.enableDrag());
                */
            },
            /*start: function( event, ui ) {
                return false;
            }*/

        });
    }

    this.disableDrag = function() {
        return ({
            cancel: false,
            disabled: true,
            grid: [this.tx, this.ty],
            
        });
    }


    this.enableResize = function() {
        return ({
            grid: [this.tx / this.gridFactor, this.ty / this.gridFactor],
            resize: function(event, ui) {
                //console.log("drag");
                if ($(this).hasClass("SlideGrid")) {
                    var _id = $(this).attr("id");
                    uiData["slidegrid_" + _id].populateSlideGrid();
                }
            },
        });
    }
    this.updatePixelsRatio = function() {
        //Coordenadas de janela/full creen
        this.screenWidthPx = document.documentElement.clientWidth;
        this.screenHeightPx = document.documentElement.clientHeight;
       

        if (this.screenWidthPx / this.screenHeightPx > 1.5) {
            bofficeScreen.RESOLUTION = 2;
        }

        //override
        if (getUrlParameter("res") != undefined) {
            bofficeScreen.RESOLUTION = getUrlParameter("res");
        }
        var cWidth = 53;
        if (this.RESOLUTION == 2) {
            cWidth = 65;
        }

        this.tx = this.screenWidthPx / cWidth;
        this.ty = this.screenHeightPx / bofficeGlobals.screenpy;

        $("button#btFullScreen").css("width", (3 * this.tx));
        $("button#btFullScreen").css("height", (2 * this.ty));

        $("div.window-title").height(2 * this.ty);
        $("span.extra").height(2 * this.ty);

        //$("#blocker").height(2 * this.ty);
    }

    this.getScreenSizeInTx = function() {
        var rect = {
            "top": 0,
            "left": 0,
            "width": this.screenWidthPx / this.tx,
            "height": this.screenHeightPx / this.ty,
        };
        return rect;
    }

};