var bofficeWidgetsForms = new function() {
	"use strict";
	this.showSelectImageForm = function(_destTextBox, _triggerChange) {

		var dialog, form;
		var imageName;

		function save() {

			imageName = $("#selectImagePicker option:selected").text();
			if (imageName == undefined) imageName = "";

			$("#" + _destTextBox).val(imageName);

			if (_triggerChange) {
				$("#" + _destTextBox).trigger('change');
			}

			dialog.dialog("close");

			return true;
		};

		dialog = $("#selectImageForm").dialog({
			autoOpen: false,
			height: 500,
			width: 400,
			modal: true,
			buttons: {
				"Seleccionar Imagem": save,
				"Cancelar": function() {
					dialog.dialog("close");
				}
			},
			open: function() {},

			close: function() {
				form[0].reset();
			}
		});
		form = dialog.find("form").on("submit", function(event) {
			event.preventDefault();
			save();
		});
		ImageCache.LoadImagePicker();
		dialog.dialog("open");
	}
	this.showSelectFolderForm = function(_destTextBox, _triggerChange) {

		var dialog, form;
		var imageName;

		function save() {

			_temp = "./" + _currentFolderPath.replace(window.location.host, "").replace("http:///", "");

			$("#" + _destTextBox).val(_temp);

			if (_triggerChange) {
				$("#" + _destTextBox).trigger('change');
			}

			dialog.dialog("close");

			return true;
		}

		dialog = $("#selectFolderForm").dialog({
			autoOpen: false,
			height: 500,
			width: 400,
			modal: true,
			buttons: {
				"Seleccionar Directoria": save,
				"Cancelar": function() {
					dialog.dialog("close");
				}
			},
			open: function() {
				getFolders(baseUrl2);

			},

			close: function() {
				form[0].reset();
			}
		});
		form = dialog.find("form").on("submit", function(event) {
			event.preventDefault();
			save();
		});
		dialog.dialog("open");
	}
	this.editCheckBoxForm = function(_objID) {

		var dialog, form;
		var _obj = $("#" + _objID);

		function saveTable() {

			var valid = true;
			var _caption = $("#textBoxCaption").val();
			//_fontSize = $("#checkBoxFontSize").val();

			if (valid) {
				bofficeWidgetsBox.setCheckBoxAttributes(_objID, _caption);
				dialog.dialog("close");
			}

			return valid;

		}

		dialog = $("#editTextBoxForm").dialog({
			autoOpen: false,
			height: 500,
			width: 400,
			modal: true,
			title: "Editar Caixa de Seleção",
			buttons: {
				"OK": saveTable,
				"Cancelar": function() {
					dialog.dialog("close");
				}
			},
			open: function() {
				$("#fx").hide();
				$("#textBoxCaption").val(_obj[0].getAttribute("snatch_caption"));
				//$("#checkBoxFontSize").val(_obj[0].getAttribute("snatch_fontsize"));

			},

			close: function() {
				form[0].reset();
			}
		});
		form = dialog.find("form").on("submit", function(event) {
			event.preventDefault();
			//saveTable();
		});
		dialog.dialog("open");
	};
	this.editDropBoxForm = function(_objID) {

		var dialog, form;
		var _obj = $("#" + _objID);

		function saveTable() {

			var valid = true;
			var _caption = $("#textBoxCaption").val();
			//var _fontSize = $("#dropBoxFontSize").val();


			if (valid) {
				bofficeWidgetsBox.setDropBoxAttributes(_objID, _caption);
				dialog.dialog("close");
			}

			return valid;

		}

		dialog = $("#editTextBoxForm").dialog({
			autoOpen: false,
			height: 500,
			width: 400,
			modal: true,
			'title': "Editar DropBox",
			buttons: {
				"OK": saveTable,
				"Cancelar": function() {
					dialog.dialog("close");
				}
			},
			open: function() {
				$("#fx").hide();
				$("#editSlideForm").attr("title", "Edição DropBox");
				$("#textBoxCaption").val(_obj[0].getAttribute("snatch_caption"));
				//$("#dropBoxFontSize").val(_obj[0].getAttribute("snatch_fontsize"));

			},

			close: function() {
				form[0].reset();
			}
		});
		form = dialog.find("form").on("submit", function(event) {
			event.preventDefault();
			//saveTable();
		});
		dialog.dialog("open");
	}
	/*
	this.editSlideForm = function(_objID) {

		var dialog, form;
		var _obj = $("#" + _objID);

		function saveTable() {

			var valid = true;
			var gridX = $("#slideButtonsX").val();

			if (valid) {
				_obj[0].setAttribute("snatch_grid_x", gridX);
				dialog.dialog("close");
				bofficeWidgetsSlide.createSlide(_obj.attr("id"));
			}

			return valid;

		}

		dialog = $("#editSlideForm").dialog({
			autoOpen: false,
			height: 500,
			width: 400,
			modal: true,
			buttons: {
				"OK": saveTable,
				"Cancelar": function() {
					dialog.dialog("close");
				}
			},
			open: function() {
				$("#slideButtonsX").val(_obj[0].getAttribute("snatch_grid_x"));

			},

			close: function() {
				form[0].reset();
			}
		});
		form = dialog.find("form").on("submit", function(event) {
			event.preventDefault();
			saveTable();
		});
		dialog.dialog("open");
	}
	*/
/*
	this.editcSlideGridForm = function(_objID) {

		var dialog, form;
		var _obj = $("#" + _objID);

		function saveTable() {

			valid = true;
			formImage = $("#slideGridImage").val();

			if (valid) {
				bofficeWidgetsSlideGrid.setSlideGridImage(_objID, formImage);
				dialog.dialog("close");
			}

			return valid;

		}

		dialog = $("#editcSlideGridForm").dialog({
			autoOpen: false,
			height: 500,
			width: 400,
			modal: true,
			buttons: {
				"OK": saveTable,
				"Cancelar": function() {
					dialog.dialog("close");
				}
			},
			open: function() {

				$("#slideGridImage").val(_obj[0].getAttribute("snatch_image"));

			},

			close: function() {
				form[0].reset();
			}
		});
		form = dialog.find("form").on("submit", function(event) {
			event.preventDefault();
			saveTable();
		});
		dialog.dialog("open");
	}
	*/
	/*
	this.editSlideGridButtonForm = function(_objID) {

		var dialog, form;
		var _table = $("#" + _objID);
		var table_id = _table[0].getAttribute("snatch_id");

		function saveTable() {

			var slideID = $("#uidata").val();
			var newSnatch = $("#dropButtonSID").val();
			var newLabel = $("#dropButtonSID option:selected").text();
			var newImage = $("#tableIcon").val();
			var imgElement = $("#imgElement").is(":checked")

			var btnID = slideID + "_" + newSnatch;
			var old_btnID = $("#btnID").val();
			var snatch_idx = $("#"+slideID+"_Navigator").attr("snatch_idx");
			var parent = $("#" + slideID + "_" + old_btnID+"_"+snatch_idx);

			if (_table.attr("snatch_id") != -1) { //normal button

				parent.attr("snatch_id", newSnatch);

				parent.attr("snatch_image", "");
				if (newImage != "") {
					parent.css("background-image", "url(" + imagesPath + newImage + ")");
					parent.attr("snatch_image", newImage);
				} else {
					parent.css("background-image", "none");
				}

				parent.find("span").html(newLabel);

				var btn = uiData[slideID + "_initialButtons"][old_btnID];
				delete uiData[slideID + "_initialButtons"][old_btnID];
			} else {
				newLabel = $("#btnlabel").val();
				parent = _table.parent().find("#" + _table.attr("id"));
				parent.children().first().html(newLabel);

				if (newImage != "") {
					parent.css("background-image", "url(" + imagesPath + newImage + ")");
					parent.attr("snatch_image", newImage);

				} else {
					parent.css("background-image", "none");
				}


			}
			if (imgElement) {
				parent.addClass("imgStrech");
				parent.attr("snatch_strech", "1");
			} else {
				parent.removeClass("imgStrech");
				parent.attr("snatch_strech", "0");
			}

			
			//uiData[slideID + "_initialButtons"][newSnatch] = btn;
			//
			//uiData[slideID + "_initialButtons"][newSnatch].label = newLabel;
			//uiData[slideID + "_initialButtons"][newSnatch].bIcon = newImage;
			



			dialog.dialog("close");
			return true;
		}

		dialog = $("#editTableForm").dialog({
			autoOpen: false,
			height: 500,
			width: 450,
			modal: true,
			buttons: {
				"OK": saveTable,
				"Cancelar": function() {
					dialog.dialog("close");
				}
			},
			open: function() {

				var _obj = document.getElementById("w" + windowID);

				var parent = $(_table);
				var snatch_id = parent.attr("snatch_id");
				var slideID = parent.parent().parent().parent().attr("id");
				var snatch_pagegroupid = parent.parent().parent().parent().find(".SlideGrid_Navigator").attr("snatch_pagegroupid");
				var snatch_idx = parent.parent().parent().parent().find(".SlideGrid_Navigator").attr("snatch_idx");

				$("#uidata").val(slideID);
				$("#btnID").val(snatch_id);
				var imgElement = parent.attr("snatch_strech");

				var slideID = $("#uidata").val();

				if (snatch_id != -1) { //a normal button
					$("#staticElement").show();
					$("#btnlbl").hide();
					var _drop = $("#dropButtonSID");

					_drop.html('');

					for (var i = 0; i < uiData[slideID][snatch_idx].d.length; i++) {
						if ((parent.parent().children("[snatch_id=" + uiData[slideID][snatch_idx].d[i].id + "]").length == 0) || (snatch_id == uiData[slideID][snatch_idx].d[i].id)) {
							addOption(_drop[0], uiData[slideID][snatch_idx].d[i].id, uiData[slideID][snatch_idx].d[i].v);
						}
					};

					if ($("#dropButtonSID option").length > 0) {

						$('#dropButtonSID option[value=' + snatch_id + ']').prop('selected', true);


						var skillsSelect = document.getElementById("dropButtonSID");
						var selectedText = skillsSelect.options[skillsSelect.selectedIndex].value;

						$("#dropButtonSID").click(function() {
							var skillsSelect = document.getElementById("dropButtonSID");
							var selectedText = skillsSelect.options[skillsSelect.selectedIndex].value;
							$("#tableName").val(selectedText);

							if (uiData[slideID + "_initialButtons"][selectedText] != undefined) {
								$("#tableIcon").val(uiData[slideID + "_initialButtons"][selectedText].bIcon); //even if no image
							} else {
								$("#tableIcon").val(""); //even if no image
							}

						})

						//$("#tableName").val(_table[0].getAttribute("snatch_id"));
						if (uiData[slideID + "_initialButtons"][selectedText] != undefined) {
							$("#tableIcon").val(uiData[slideID + "_initialButtons"][table_id].bIcon);
						} else {
							$("#tableIcon").val("");
						}

					}
				} else {
					$("#staticElement").hide();
					$("#btnlbl").show();
					$("#btnlabel").val(parent.children().first().text());
					$("#tableIcon").val(parent.attr("snatch_image"));


				}
				if (imgElement == 1) {
					$("#imgElement").prop('checked', true);
				} else {
					$("#imgElement").prop('checked', false);
				}
			},

			close: function() {
				form[0].reset();
			}
		});
		form = dialog.find("form").on("submit", function(event) {
			event.preventDefault();
			saveTable();
		});
		dialog.dialog("open");
	}
	*/
	/*
	this.editButtonForm = function(_objID) {

		var dialog, form;
		var _obj = $("#" + _objID);

		function saveTable() {

			var valid = true;

			var buttonFunction = $("#dropButtonFunction").val();
			var buttonIcon = $("#buttonIcon").val();
			var buttonCaption = $("#buttonCaption").val();
			var buttonTab = $("#dropTab option:selected").val();
			var skin = $("select#skintype").val();

			

			if (buttonFunction == undefined || buttonFunction == null || buttonFunction == "null") buttonFunction = "";
			if (buttonIcon == undefined || buttonIcon == null || buttonIcon == "null") buttonIcon = "";
			if (buttonCaption == undefined || buttonCaption == null || buttonCaption == "null") buttonCaption = "";

			//so se existiu uma alteração
			if ($("#" + _objID).attr("snatch_id") != buttonFunction) {
				if (!validaNewFunction(windowID, buttonFunction)) {
					alert("Esta função já está atribuída.");
					valid = false;
				}
			}

			if (valid) {
				bofficeWidgetsButton.setButtonAttributes(_objID, buttonFunction, buttonIcon, buttonCaption, buttonTab,skin);
				dialog.dialog("close");
			}

			return valid;

		}

		dialog = $("#editButtonForm").dialog({
			autoOpen: false,
			height: 500,
			width: 400,
			modal: true,
			buttons: {
				"OK": saveTable,
				"Cancelar": function() {
					dialog.dialog("close");
				}
			},
			open: function() {

				//get tabs
				$("#editButtonForm").height("90%");
				var cPanel = _obj.parent().parent().find(".Panel");
				var skin = _obj.parent().attr("snatch_skin");
				$("select#skintype").val(skin);
				var tabs = parseInt(cPanel.attr("snatch_pages"))-1;
				var selectedTab = parseInt(cPanel.children().first().attr("snatch_current_page"));
				if (_obj.parent().attr("snatch_tab") != undefined) {
					selectedTab = _obj.parent().attr("snatch_tab");
				}
				var tabSel = $("#dropTab");
				tabSel.html('');

				addOption(tabSel[0], "-1", "Todas");

				for (var i = 0; i <= tabs; i++) {
					addOption(tabSel[0], i, "Tab " + (i + 1), selectedTab);
				};


				var _functions = getButtonFunctions(windowID, 1);
				$("#bfunct").show();
				if (_functions.length == 1)
				{
					$("#bfunct").hide();
				}
				var _drop = $("#dropButtonFunction");
				_drop.html('');

				for (var j = 0; j < _functions.length; j++) {
					addOption(_drop[0], _functions[j].id, _functions[j].v);
				}

				var bFunction = $(_obj).attr("snatch_id");
				var bIcon = $(_obj).parent().attr("snatch_icon");
				var bCaption = $(_obj).parent().attr("snatch_caption");


				if (bFunction == undefined || bFunction == null || bFunction == "null") bFunction = "";
				if (bIcon == undefined || bIcon == null || bIcon == "null") bIcon = "";

				$("#dropButtonFunction").val(bFunction);
				$("#buttonIcon").val(bIcon);
				$("#buttonCaption").val(bCaption);

				$("#dropButtonFunction").change(function() {
					$("#buttonCaption").val($("#dropButtonFunction option:selected").text());
				});

			},

			close: function() {
				form[0].reset();
			}
		});
		form = dialog.find("form").on("submit", function(event) {
			event.preventDefault();
			saveTable();
		});
		dialog.dialog("open");
	}
	*/
}