"use strict";
var SnatchButton = SnatchBase.extend(function() {
    this.constructor = function(windowid, _id, json_id, rect, wtype, _arguments) {

        this.super(rect.left, rect.top, rect.width, rect.height, windowid, _id, json_id, rect, wtype);

        //default values
        this.type = "null";
        this.label = "";
        this.state = 0;
        this.color = "";
        this.icon = "null";
        this.skin = 1;
        this.referral = -1;
        this.tab = -1;

        this.bgtype = "color"; // || image
        this.bgcolor = "";
        this.bgimage = "";

        this.textcolor = "";

        if ( _arguments!==undefined )
        {
            this.setArguments(_arguments);
        }


    }
    var tabArray = [];
    this.getTabArray = function() {
        return tabArray;
    }
    this.putTab = function(val) {
        if (tabArray.indexOf(val) < 0) {
            tabArray.push(val);

        }
    }
    this.setParams = function() {
        this.params = {
            j_parent: this.j_parent.selector,
            j_procID: this.j_procID.selector,
            
        }
        if(this.j_button != undefined)
        {
            this.params.j_button= this.j_button.selector;
        }
    }

    this.setArguments = function(args) {
        if (args[5] !== undefined)
            this.type = args[5].value;
        if (args[6] !== undefined)
            this.label = args[6].value;
        if (args[7] !== undefined)
            this.state = args[7].value;
        if (args[8] !== undefined)
            this.color = args[8].value;
        if (args[9] !== undefined)
            this.icon = args[9].value;
        if (args[10] !== undefined)
            this.skin = args[10].value;
        if (args[11] !== undefined)
            this.referral = args[11].value;
        if (args[12] !== undefined) {
            this.tab = args[12].value;
            tabArray.push(this.tab);
        }

        if (args.length > 13) {
            this.bgtype = args[13].bgtype;
        }
        if (args.length > 14) {
            this.bgcolor = args[14].bgcolor;
        }
        if (args.length > 15) {
            this.bgimage = args[15].bgimage;
        }
        if (args.length > 16) {
            this.textcolor = args[16].bgimage;
        }

        this.j_button = undefined;
    }

    this.createButton = function() {

        var _hidden = 0;
        if (this.tab > 0)
            _hidden = 1;

        if (this.type == "CCheckBox") {
            this.j_parent.append("<div st=\"button_" + this.procID + "\"  id=\"" +
                this.procID + "\" class=\"CheckBox FieldBox draggable skin_" + this.skin + "\"></div>");
            //rect
            this.super.setRect();
            this.j_procID.append("<div class=\"wcont\"></div>");

            $("#" + this.procID + " > div.wcont").append("<div id=\"" + this.procID + "Caption" +
                "\" class=\"caption in_check skin_" + this.skin + "\">" + this.label + "</div>");

            $("#" + this.procID + " > div.wcont").append("<div class=\"field in_check\">" +
                "<input type =\"checkbox\" id=\"" + this.procID + "_Check" + "\" snatch_id=\"" + this.id + "\" class=\"CheckBox_Check\"" + ">" +
                "</div>");


        } else if (this.type == "CButton") {

            this.j_parent.append("<div st=\"button_" + this.procID + "\" id=\"" + this.procID + "\" " +
                "class=\"Button draggable\" snatch_id=\"" + this.id + "\">" +
                "<a id=\"" + this.procID + "_b\" role=\"button\" " +
                " data-toggle='tooltip' title='" + this.label + "' " +
                "></a></div>");
            //rect
            this.super.setRect();
            this.j_button = $("#" + this.procID + "_b");

            this.setButtonSkin();

            if (bofficeGlobals.DEBUG) {
                this.j_procID.append("<span class=\"debugInfo \">" +
                    this.procID + ": " + this.skin + "</span>");
            }


        }


        if (_hidden == 1) {
            this.j_procID.hide();
        }
    }
    this.bindClicks = function() {
        var self = this;
        if (this.type == "CCheckBox") {
            $("#" + this.procID + "_Check").off();

            $("#" + this.procID + "_Check").on("change", function(event) {
                self.processCheckBoxClick(this, self);
                event.stopPropagation();
                return false;
            });

        } else if (this.type == "CButton") {
            //this.j_procID.off();
            boffice.globalClick($("#" + this.procID + " > a"), function(event) {
                self.processButtonClick(this, event, self);
            });
        }
    }

    this.processButtonClick = function(elem, event, parent) {
        if (SnatchBase.displayEditWarning(this.j_procID, event)) {
            return;
        }

        var urlCmd = "callback&windowID=" + windowID + "&objectID=" + parent.id + "&value=0";
        boffice.send_url(urlCmd);
    }
    this.processCheckBoxClick = function(elem, parent) {
        if (SnatchBase.displayEditWarning(this.j_procID)) {
            return;
        }
        var val;

        if ($(elem).is(':checked'))
            val = "1";
        else
            val = "0";

        var urlCmd = "callback&windowID=" + windowID + "&objectID=" + parent.id + "&value=" + val;
        boffice.send_url(urlCmd);
    }

    this.setButtonSkin = function() {

        //skin 1 - imagem centrada s/texto 
        //skin 2 - imagem centrada s/texto. No mousedown desaparece a imagem e fica o texto
        //skin 3 - imagem centrada e texto centrado
        //skin 5 - imagem alinhada à esquerda e texto alinhado à direita
        //
        this.j_button.removeClass();

        var bootCss = "btn btn-lg bs" + this.procID;

        if (this.skin == 1) bootCss += " btn-warning";
        else if (this.skin == 2) bootCss += " btn-warning";
        else if (this.skin == 3) bootCss += " btn-primary";
        else if (this.skin == 4) bootCss += " btn-danger";
        else if (this.skin == 5) bootCss += " btn-success";
        else bootCss += " btn-default";

        this.j_button.addClass(bootCss);
        this.j_button.addClass("skin_" + this.skin);

        if (this.j_button.find("span").length == 0) {
            this.j_button.append("<span>" + this.label + "</span>");
        }

        if ((this.icon.length > 0) && (this.icon != "null")) {
            var cachedImage = ImageCache.getCachedImageUrl(imagesPath + this.icon);

            if (this.j_button.find("div.imgb").length == 0) {
                this.j_button.append("<div class=\"imgb\"></div>");
            }

            $("#" + this.procID + "_b > div").css("background-image", "url(" + cachedImage + ")");
            if (this.skin == 1) {
                this.j_button.addClass("bgcenter notext");
            } else if (this.skin == 2) {
                this.j_button.addClass("bgcenter notext bgtg");
            } else if (this.skin == 3) { //is there a 4 skin?
                this.j_button.addClass("bgcenter centertext");
            } else if (this.skin == 4) { //is there a 4 skin?
                this.j_button.addClass("bgright lefttext");
            } else if (this.skin == 5) {
                this.j_button.addClass("bgleft righttext");
            }

        } else {
            //elimina imagem
            $("#" + this.procID + "_b > div").css("background-image", "none");
            this.j_button.addClass("noimage");


        }

        //caption
        $("#" + this.procID + "_b" + " > span").text(this.label);

        if (this.bgtype == "color") {
            if (this.bgcolor != "") {

                var alternate = darkerColor(this.bgcolor, 0.4);

                // if ($("a#" + procIDChild).hasClass("no_image")) {
                //parent.find("a#" + procIDChild).css("padding", 0);
                this.j_button.css("background-position", 0);
                this.j_button.css("background-size", "cover");



                this.j_button.css("background-image", "linear-gradient(to bottom, " + this.bgcolor + ", " + alternate + ")");

                //}

                //$("a#" + slideBut).css("border", "1px");
                this.j_button.css("border-color", alternate);

                this.j_button.css("background-color", this.bgcolor);
                //linear-gradient(to bottom, #337ab7 0, #265a88 100%)
            } else {
                this.j_button.css("background-image", "");
                this.j_button.css("border-color", "");
                this.j_button.css("background-color", "");

            }
        } else {
            if (this.bgimage != "") {
                this.j_button.css("background", "none");
                this.j_button.css("border", "0");
                this.j_button.css("background-position", 0);
                this.j_button.css("background-size", "100% 100%");
                this.j_button.css("background-image", "url(" + imagesPath + this.bgimage + ")");
            }
        }
        if (this.textcolor != "") {
            this.j_button.css("color", this.textcolor);
        } else {
            this.j_button.css("color", "");
        }

        
    }

    this.updateCheckBox = function(value) {
        var elem2 = $("#" + this.procID + "_Check");
        if (elem2.length > 0) {
            if (value == "1")
                elem2.prop('checked', true);
            else
                elem2.prop('checked', false);
        }
    }

    this.editButtonForm = function(_objID) {

        var dialog, form;
        //var _obj = $("#" + this.procID);
        var self = this;

        function saveTable() {

            var valid = true;

            var buttonFunction = $("#dropButtonFunction").val();
            var buttonIcon = $("#buttonIcon").val();
            var buttonCaption = $("#buttonCaption").val();
            var buttonTab = $("#dropTab option:selected").val();
            var skin = $("select#skintype").val();



            if (buttonFunction == undefined || buttonFunction == null || buttonFunction == "null") buttonFunction = "";
            if (buttonIcon == undefined || buttonIcon == null || buttonIcon == "null") buttonIcon = "";
            if (buttonCaption == undefined || buttonCaption == null || buttonCaption == "null") buttonCaption = "";

            //so se existiu uma alteração
            if (self.id != buttonFunction) {
                if (!validaNewFunction(windowID, buttonFunction)) { //!?
                    alert("Esta função já está atribuída.");
                    valid = false;
                }
            }

            if (valid) {
                self.setButtonAttributes(buttonFunction, buttonIcon, buttonCaption, buttonTab, skin);
                dialog.dialog("close");
            }

            return valid;

        }
        var _functions = this.getButtonFunctions(windowID, 1);
        dialog = $("#editButtonForm").dialog({
            autoOpen: false,
            //height: 500,
            width: 350,
            modal: true,
            buttons: {
                "OK": saveTable,
                "Cancelar": function() {
                    dialog.dialog("close");
                }
            },
            open: function() {
                $("select#skintype").val(self.skin);

                //get tabs
                var cPanel = $("#" + self.parent).find(".Panel");
                var tabs = 0;
                var selectedTab = 0;
                if (cPanel.length > 0) {
                    tabs = parseInt(cPanel.children().first().attr("snatch_page_count"));
                }

                //selectedTab = $("#" + self.procID).attr("snatch_tab");

                //populate drop-down
                var tabSel = $("#dropTab");
                tabSel.html('');
                addOption(tabSel[0], "-1", "Todas");
                for (var i = 0; i < tabs; i++) {
                    addOption(tabSel[0], i, "Tab " + (i + 1), this.tab); //selectedTab);
                };

                //function

                $("#bfunct").show();
                if (_functions.length == 1) {
                    $("#bfunct").hide();
                }
                var _drop = $("#dropButtonFunction");
                _drop.html('');
                for (var j = 0; j < _functions.length; j++) {
                    addOption(_drop[0], _functions[j].id, _functions[j].v);
                }

                var bFunction = self.id;
                var bIcon = self.icon;
                var bCaption = self.label;


                if (bFunction == undefined || bFunction == null || bFunction == "null") bFunction = "";
                if (bIcon == undefined || bIcon == null || bIcon == "null") bIcon = "";

                $("#dropButtonFunction").val(bFunction);
                $("#buttonIcon").val(bIcon);
                $("#buttonCaption").val(bCaption);

                $("#dropButtonFunction").change(function() {
                    $("#buttonCaption").val($("#dropButtonFunction option:selected").text());
                });



            },

            close: function() {
                form[0].reset();
            }
        });
        form = dialog.find("form").on("submit", function(event) {
            event.preventDefault();
            saveTable();
        });
        dialog.dialog("open");
    }

    this.setButtonAttributes = function(_buttonFunction, _buttonIcon, _buttonCaption, _buttonTab, _skin) {
        /*
        $("#" + this.procID).parent().attr("snatch_icon", _buttonIcon);
        $("#" + this.procID).parent().attr("snatch_caption", _buttonCaption);
        $("#" + this.procID).parent().attr("snatch_skin", _skin);

        $("#" + this.procID).parent().attr("snatch_tab", _buttonTab);
*/
        this.icon = _buttonIcon;
        this.label = _buttonCaption;
        this.tab = _buttonTab;
        this.skin = _skin;
        //$("#" + this.procID).attr("snatch_tab", this.tab);
        this.setButtonSkin(this.procID, _skin, _buttonIcon, _buttonCaption);


        //change id
        if (_buttonFunction.length > 0 && _buttonFunction != "-1" && this.j_parent.attr("snatch_id") != _buttonFunction) {

            var newID = windowID + "_" + _buttonFunction;

            if (newID != this.procID)
            {
                uiData[this.uiKey + newID] = uiData[this.uiKey + this.procID];
                delete(uiData[this.uiKey + this.procID]);
                console.log("DELETED: "+this.uiKey + this.procID);
            

                this.j_procID.attr("snatch_id",_buttonFunction);
                this.j_procID.attr("st",this.uiKey+newID);
                this.j_procID.attr("id",newID);

                //this.j_parent.attr("id", newID);
                this.id = _buttonFunction;
                this.procID = this.windowid + "_" + newID;
                //$("#" + newID).attr("snatch_id", _buttonFunction);
                bofficeWidgetsMenu.bindContextMenu("#"+newID, "buttonMenu");
            }

            //change a
            $("#" + newID + " > a").attr("id", newID + "_b");
        }
    }
    this.editTextBoxForm = function() {
        var self = this;
        var _objID = this.procID;
        var dialog, form;
        var _obj = $("#" + _objID);

        function saveTable() {

            var valid = true;
            var _caption = $("#textBoxCaption").val();
            var _fontSize = $("#textBoxFontSize").val();



            if (valid) {
                //uiData["textbox_" + _objID].setTextBoxAttributes(_caption, _function);
                uiData["button_" + _obj.attr("id")].label = _caption;
                _obj.find(".caption").html(_caption);
                dialog.dialog("close");
            }

            return valid;

        }

        dialog = $("#editTextBoxForm").dialog({
            autoOpen: false,
            //height: 400,
            width: 350,
            modal: true,
            title: 'Editar Etiqueta',
            buttons: {
                "OK": saveTable,
                "Cancelar": function() {
                    dialog.dialog("close");
                }
            },
            open: function() {
                $("#fx").hide();

                var snatch_id = $(_obj[0]).attr("id");
                $("#textBoxCaption").val(uiData["button_" + snatch_id].label);
                $("#textBoxFontSize").val(uiData["button_" + snatch_id].fontsize);


            },

            close: function() {
                form[0].reset();
            }
        });
        form = dialog.find("form").on("submit", function(event) {
            event.preventDefault();
            //saveTable();
        });
        dialog.dialog("open");
    }

    this.editColorForm = function() {
        var self = this;

        var _objID = this.procID;
        var _obj = $("#" + _objID);

        var dialog, form;

        function saveTable() {
            var _obj = $("#bgobref").val();
            if ($("#bgtype option:selected").val() == 1) {
                uiData[_obj].bgtype = "color";
                if ($("#colorpck").val() != "") {
                    uiData[_obj].bgcolor = $("#colorpck").spectrum("get").toRgbString();
                } else {
                    uiData[_obj].bgcolor = "";
                }
            } else {
                uiData[_obj].bgtype = "image";
                uiData[_obj].bgimage = $("#btSelectBgImageForm").val();
            }
            if ($("#colorpck2").val() != "") {
                uiData[_obj].textcolor = $("#colorpck2").spectrum("get").toRgbString();
            } else {
                uiData[_obj].textcolor = "";
            }

            //redraw maybe?!
            uiData[_obj].setButtonSkin();

            dialog.dialog("close");

            return

        }
        dialog = $("#editBackgroundForm").dialog({
            autoOpen: false,
            //height: 500,
            width: 350,
            modal: true,
            buttons: {
                "OK": saveTable,
                "Cancelar": function() {
                    dialog.dialog("close");
                }
            },
            open: function() {

                var _obj = $("#bgobref").val();
                $("div#textcolor").show();

                $("#colorpck2").spectrum(bofficeGlobals.colorPickerOptions);
                $("#colorpck2").spectrum("set", uiData[_obj].textcolor);

                $("#bgtype").off();
                $("#bgtype").on('change', function() {
                    if ($("#bgtype option:selected").val() == 1) {
                        $("div#bgcolor").show();
                        $("div#bgimage").hide();

                        $("#colorpck").spectrum(bofficeGlobals.colorPickerOptions);
                        $("#colorpck").spectrum("set", uiData[_obj].bgcolor);



                    } else {
                        $("div#bgcolor").hide();
                        $("div#bgimage").show();

                        $("#btSelectBgImageForm").val(uiData[_obj].bgimage);
                    }
                });

                if (uiData[_obj].bgtype == "color") {
                    $("#bgtype").val(1);
                } else {
                    $("#bgtype").val(2);
                }
                $("#bgtype").change();



            },

            close: function() {
                form[0].reset();
            }
        });
        form = dialog.find("form").on("submit", function(event) {
            event.preventDefault();
            saveTable();
        });
        dialog.dialog("open");

    }

    this.getButtonFunctions = function(_windowID, addEmpty) {

        var ret = [];

        if (addEmpty) {
            ret.push({
                "id": "-1",
                "v": ""
            });
        }

        if (_windowID == 4) {

            ret.push({
                "id": "42",
                "v": "Desconto Directo"
            });
            ret.push({
                "id": "53",
                "v": "Anulação Artigos"
            });
            ret.push({
                "id": "55",
                "v": "Oferta"
            });
            ret.push({
                "id": "57",
                "v": "Linha Preço por Defeito"
            });
            ret.push({
                "id": "58",
                "v": "Linha Preço 1"
            });
            ret.push({
                "id": "59",
                "v": "Linha Preço 2"
            });
            ret.push({
                "id": "60",
                "v": "Linha Preço 3"
            });
            ret.push({
                "id": "61",
                "v": "Linha Preço 4"
            });
            ret.push({
                "id": "62",
                "v": "Linha Preço 5"
            });
            ret.push({
                "id": "63",
                "v": "Novo Artigo"
            });
            ret.push({
                "id": "68",
                "v": "Novo Cliente"
            });
            ret.push({
                "id": "71",
                "v": "Suspender Transação"
            });
            ret.push({
                "id": "80",
                "v": "Tecla 0"
            });
            ret.push({
                "id": "81",
                "v": "Tecla 1"
            });
            ret.push({
                "id": "82",
                "v": "Tecla 2"
            });
            ret.push({
                "id": "83",
                "v": "Tecla 3"
            });
            ret.push({
                "id": "84",
                "v": "Tecla 4"
            });
            ret.push({
                "id": "85",
                "v": "Tecla 5"
            });
            ret.push({
                "id": "86",
                "v": "Tecla 6"
            });
            ret.push({
                "id": "87",
                "v": "Tecla 7"
            });
            ret.push({
                "id": "88",
                "v": "Tecla 8"
            });
            ret.push({
                "id": "89",
                "v": "Tecla 9"
            });
            ret.push({
                "id": "90",
                "v": "Atualizar Descrição"
            });
            ret.push({
                "id": "91",
                "v": "Quantidade"
            });
            ret.push({
                "id": "92",
                "v": "Teclado Artigo"
            });
            ret.push({
                "id": "93",
                "v": "Teclado Preço"
            });
            ret.push({
                "id": "95",
                "v": "Mudar Separador"
            });
            ret.push({
                "id": "97",
                "v": "Reactivar Transação"
            });
            ret.push({
                "id": "601",
                "v": "Logotipo Cliente"
            });
            ret.push({
                "id": "134",
                "v": "Limpar Formas Pagamento"
            });
            ret.push({
                "id": "135",
                "v": "Dinheiro 1"
            });
            ret.push({
                "id": "136",
                "v": "Dinheiro 2"
            });
            ret.push({
                "id": "137",
                "v": "Dinheiro 5"
            });
            ret.push({
                "id": "138",
                "v": "Dinheiro 10"
            });
            ret.push({
                "id": "139",
                "v": "Dinheiro 20"
            });
            ret.push({
                "id": "-11",
                "v": "Pagar"
            });
            ret.push({
                "id": "-12",
                "v": "Fazer Pedidos"
            });
            ret.push({
                "id": "-13",
                "v": "Mapa Mesas"
            });
            ret.push({
                "id": "-14",
                "v": "SubTotais"
            });
            ret.push({
                "id": "-15",
                "v": "Adicionar Quantidade"
            });
            ret.push({
                "id": "-16",
                "v": "Subtrair Quantidade"
            });
            ret.push({
                "id": "-17",
                "v": "Transferir Artigos"
            });
            ret.push({
                "id": "-18",
                "v": "Gaveta"
            });
            ret.push({
                "id": "-19",
                "v": "Descontos"
            });
            ret.push({
                "id": "-20",
                "v": "Pagar Directo"
            });
            ret.push({
                "id": "-21",
                "v": "Pagar Directo CC"
            });
            ret.push({
                "id": "-22",
                "v": "Pagar Directo Desconto"
            });
            ret.push({
                "id": "34",
                "v": "Próxima Página Botões"
            });
            ret.push({
                "id": "35",
                "v": "Anterior Página Botões"
            });
            ret.push({
                "id": "37",
                "v": "Histórico"
            });
        }

        return ret;
    }

    this.handleCache = function(content) {
        if (content.keys["button_" + this.procID] != undefined) {
            this.j_parent = $(content.keys["button_" + this.procID].j_parent);
            this.j_procID = $(content.keys["button_" + this.procID].j_procID);
            if (content.keys["button_" + this.procID].j_button != undefined)
                this.j_button = $(content.keys["button_" + this.procID].j_button);
        } else {
            //manual bind
            this.j_procID = $("#" + this.procID);
            this.j_parent = this.j_procID.parent();
        }
    }
});