"use strict";
var SnatchPanel = SnatchBase.extend(function() {
    this.constructor = function(windowid, _id, json_id, rect, wtype, _arguments) {


        this.super(rect.left, rect.top, rect.width, rect.height, windowid, _id, json_id, rect, wtype);

        this.pages = 1;
        this.skin = -1;
        this.navbuttons = 1;
        this.captions = "";

        if (_arguments !== undefined)
        {
            this.setArguments(_arguments);
        }

        this.j_navigator = undefined;
    };

    //private 
    //var numberOfPages = 1;
    var currentPage = 1;
    this.getCurrentPage = function() {
        return currentPage;
    }
    this.setCurrentPage = function(page) {
        currentPage = page;
    }
    this.setParams = function() {
        this.params = {
            j_parent: this.j_parent.selector,
            j_procID: this.j_procID.selector,
            j_navigator: this.j_navigator.selector,
        }
    }
    this.setArguments = function(args) {
        if (args[5] !== undefined)
            this.pages = args[5].value;
        if (args[6] !== undefined)
            this.skin = args[6].value;
        if (args[7] !== undefined)
            this.navbuttons = args[7].value;
        if (args[8] !== undefined)
            this.captions = args[8].value;
    }
    this.createPanel = function() {

        this.j_parent.prepend("<div st=\"panel_" + this.procID + "\"  id=\"" + this.procID + "\" class=\"Panel draggable\"></div>");

        this.super.setRect();
        if (bofficeGlobals.DEBUG)
            this.j_procID.append("<span class='debugInfo'>" + this.uiKey + "_" + this.procID + "</span>");
        //adiciona 2 filhos: o navegador e o divs de botões container
        this.j_procID.append("<div id=\"" + this.procID + "Navigator" + "\"  class=\"Panel_Navigator\"> " + "</div>");

        this.j_navigator = $("#" + this.procID + "Navigator");

        if (this.navbuttons) {
            var self = this;
            //dentro do navegador, acrescenta os 2 botões de navegação
            this.j_navigator.append("<div id=\"" + this.procID + "NavigatorLeft" +
                //"\" style=\"height:60%;width:10%;top:20%;display:none\" 
                "\" class=\"Panel_NavigatorLeft\"><img class=\"Slide_NavigatorLeft\" src=\"" + imagesPath + "1027.png\"></div>");

            this.j_navigator.append("<div id=\"" + this.procID + "NavigatorRight" +
                //"\" style=\"height:60%;width:10%;top:20%;left:90%;display:none\" 
                "\" class=\"Panel_NavigatorRight\"><img class=\"Slide_NavigatorRight\" src=\"" + imagesPath + "1026.png\"></div>");

            boffice.globalClick($("#" + this.procID + "NavigatorLeft > img"), function(e) {
                self.ProcessPanelNavClick($(this).parent()[0]);
            });
            boffice.globalClick($("#" + this.procID + "NavigatorRight > img"), function(e) {
                self.ProcessPanelNavClick($(this).parent()[0]);
            });

        }
        //hide stuff
        //i'm this window's panel:
        uiData["window_" + this.window_id].setPanel(this.procID);


        this.updatedPanelStatus();

    }
    this.bindClicks = function() {
        if (this.navbuttons) {
            var self = this;

            boffice.globalClick($("#" + this.procID + "NavigatorLeft > img"), function(e) {
                self.ProcessPanelNavClick($(this).parent()[0]);
            });
            boffice.globalClick($("#" + this.procID + "NavigatorRight > img"), function(e) {
                self.ProcessPanelNavClick($(this).parent()[0]);
            });

        }
    }
    this.ProcessPanelNavClick = function(elem) {

        var NavigatorContainer = $(elem).parent();
        var cp = currentPage;
        var pageCount = this.pages;

        //clean active buttons
        //$("button",$(NavigatorContainer).parent()).removeClass("Slide_Button_activated");

        if (cp === undefined) cp = 1;
        if (pageCount === undefined) pageCount = 1;

        if ($(elem).hasClass("Panel_NavigatorLeft")) {
            cp--;
            if (cp < 1) cp = 1;
        } else if ($(elem).hasClass("Panel_NavigatorRight")) {
            cp++;
            if (cp > pageCount) cp = pageCount;

        }

        //NavigatorContainer.attr("snatch_current_page", currentPage);

        if ($(elem).hasClass("Panel_NavigatorLeft") || $(elem).hasClass("Panel_NavigatorRight")) {
            var panel_id = $("#" + NavigatorContainer.attr("id")).parent().attr("id");
            //bofficeWidgets.UpdatedPanelStatus(windowID, "#" + NavigatorContainer.id);
            uiData["panel_" + panel_id].updatedPanelStatus(cp);
            uiData["window_" + this.window_id].SetWindowTabIndex(cp - 1);
        }
    }
    this.updatedPanelStatus = function(page) {

        if (page !== undefined) {
            if (page == currentPage) {
                return;
            }
            if (cacheMode == 0) {
                currentPage = page;
            }
        }



        var _navigator = "#" + this.procID + "Navigator";
        //var currentPage = $(_navigator).attr("snatch_current_page")
        var pageCount = this.pages;

        if ($(_navigator + "Left").length > 0) {
            if (currentPage == 1)
                $(_navigator + "Left").hide()
            else
                $(_navigator + "Left").show()
        }

        if ($(_navigator + "Right").length > 0) {
            if (currentPage == pageCount)
                $(_navigator + "Right").hide();
            else
                $(_navigator + "Right").show()
        }

        //pannnels that show both
        /* 
        if (_navigator == "#123_301Navigator") {
            $(_navigator + "Right").show()
            $(_navigator + "Left").show();
        }
        */

        //bofficeWidgetsWindow.SetWindowTabIndex(this.windowid, currentPage - 1);
        //uiData["window_" + this.window_id].SetWindowTabIndex(currentPage-1);
    }

    this.handleCache = function(content) {
        if (content.keys["panel_" + this.procID] != undefined) {
            this.j_parent = $(content.keys["panel_" + this.procID].j_parent);
            if (content.keys["panel_" + this.procID].j_procID != undefined)
                this.j_procID = $(content.keys["panel_" + this.procID].j_procID);
        }
        if (this.j_procID === undefined) {
            this.j_procID = $("#" + this.procID);
        }
    }
});