"use strict";
var SnatchSlide = SnatchBase.extend(function() {

    this.constructor = function(windowid, _id, json_id, rect, wtype, _arguments) {

        this.super(rect.left, rect.top, rect.width, rect.height, windowid, _id, json_id, rect, wtype);

        //default values
        this.maxButtonX = 0;
        this.skin = -1;
        this.referral = -1;
        this.tab = -1;

        this.color = "";

        this.bgtype = "color"; // || image
        this.bgcolor = "";
        this.bgimage = "";

        this.textcolor = "";

        this.setArguments(_arguments);

        this.j_pages = undefined;
        this.j_navigator = undefined;

        this.j_referralTo = undefined;
        this.j_current_page = undefined;

        this.strechslide;

    }

    //private 
    var numberOfPages = 1;
    var currentPage = 1;

    this.getCurrentPage = function() {
        return currentPage;
    }

    var lastClicked_snatch = {};
    var lastClickedElement = {};

    var activeID = undefined;
    //populated button
    //var slideButtons = {};

    var data = {};
    var data_order = {};

    var tabArray = [];

    var forceRedraw = false;

    var lastData;

    this.setForceRedraw = function() {
        forceRedraw = true;
    }

    this.getTabArray = function() {
        return tabArray;
    }
    this.putTab = function(val) {
        if (tabArray.indexOf(val) < 0) {
            tabArray.push(val);
            if (bofficeGlobals.DEBUG) {
                console.log("INFO: " + this.wtype + ":" +
                    this.procID + " added to tabs: " + JSON.stringify(tabArray));
            }
        }
    }

    this.getActiveId = function() {
        return activeID;
    }

    this.setData = function(_data, _data_order) {
        data = _data;
        data_order = _data_order;
        if ((activeID === undefined) && Object.keys(data).length > 0) {
            activeID = Object.keys(data)[0];
        }
        forceRedraw = true;
    }
    this.getData = function(_data) {
        return (data);
    }

    this.setParams = function() {
        this.params = {
            j_parent: this.j_parent.selector,
            j_procID: this.j_procID.selector,

            j_pages: this.j_pages.selector,
            j_navigator: this.j_navigator.selector,



            currentPage: currentPage,
            activeID: activeID,
            strechslide: this.strechslide,

        }
        if (this.j_referralTo != undefined) {
            this.params.j_referralTo = this.j_referralTo.selector;
        }
        if (this.j_current_page1 = undefined) {
            this.params.j_current_page = this.j_current_page.selector;
        }
    }
    this.setArguments = function(args) {
        if (args[5] !== undefined)
            this.maxButtonX = args[5].value;
        if (args[6] !== undefined)
            this.skin = args[6].value;
        if (args[7] !== undefined) {
            this.referral = args[7].value;
            this.referralTo = this.window_id + "_" + this.referral; // hacky
        }
        if (args[8] !== undefined) {
            this.tab = args[8].value;
            tabArray.push(this.tab);
        }
        if (args[9] !== undefined) {
            this.color = args[9].color;
        }
        if (args.length > 10) {
            this.bgtype = args[10].bgtype;
        }
        if (args.length > 11) {
            this.bgcolor = args[11].bgcolor;
        }
        if (args.length > 12) {
            this.bgimage = args[12].bgimage;
        }
        if (args.length > 13) {
            this.textcolor = args[13].bgimage;
        }
        if (args.length > 14) {
            this.strechslide = args[14].strechslide;
        }
        else
        {
            this.strechslide = 1;
        }
    }
    this.createSlide = function() {

        var cclass = "Slide draggable empty";

        var _html = "<div st=\"slide_" + this.procID + "\"  id=\"" + this.procID + "\" class=\"" + cclass + "\" snatch_id=\"" + this.id + "\"></div>";

        this.j_parent.append(_html);
        //rect
        this.super.setRect();

        this.createSlideNavigator();


        if (this.tab > 0)
            this.j_procID.hide();


    }
    this.setActiveID = function(_activeID) {

        if ((_activeID == undefined) && (activeID !== undefined)) {
            return;
        } else

        if (_activeID !== undefined) {
            $("#" + this.procID + "_" + _activeID + "_page" + (0)).show();
            this.j_current_page = $("#" + this.procID + "_" + _activeID + "_page" + (0));
            //hide active page:
            $("#" + this.procID + "_" + activeID + "_page" + (currentPage - 1)).hide();
            activeID = _activeID;
            currentPage = 1;
            lastClicked_snatch[activeID] = undefined;
        }
    }
    this.drawSlide = function(_activeID, force) { //sets activeID
        var lastActiveID = activeID;

        this.setActiveID(_activeID);

        if (force == undefined) {
            force = false;
        }

        if ((!force) && (lastData == JSON.stringify(data)) && (activeID == lastActiveID) && (this.j_pages.children().length > 0)) {
            if (bofficeGlobals.DEBUG)
                console.log("PERFORMANCE: " + this.uiKey + this.procID + ": using cached values");
            return;
        } else if ((!force) && (lastData != JSON.stringify(data)) && (activeID == lastActiveID) && (this.j_pages.children().length > 0)) {
            //there was an update
            this.j_pages.empty();

        }
        lastData = JSON.stringify(data);


        if ((cacheMode == 1) || (force)) {
            var self = this;
            $.each(data_order["order"], function() {
                {
                    self.populateSlide(this, 1, force);
                }
            });
        } else {
            /*
            if (activeID === undefined) {
                activeID = 1;
            }*/


            this.populateSlide(_activeID);
        }

        this.j_procID.removeClass("empty");

        this.UpdateNavigatorStatus();


        if (bofficeGlobals.DEBUG)
            this.j_procID.append("<span class='debugInfo'>" + this.uiKey + " " + this.procID + "</span>");
        //}
    }
    this.createSlideNavigator = function() {
        //var data = uiData[this.procID + "_Slide"].d[activeID];


        //this.j_procID.empty();
        //adiciona 2 filhos: o navegador e o pages container
        this.j_procID.append(
            "<div id=\"" + this.procID + "_Navigator" + "\" class=\"Slide_Navigator\">" +
            //snatch_current_page=\"1\" snatch_page_count=" + numberOfPages + " " +
            //"snatch_pageGroupID=\"" + data.id + "\">" +
            "<div class=\"Slide_Navigatori NavigatorLeft\"><img class=\"Slide_NavigatorLeft\" src=\"" + imagesPath + "1027.png\"></div>" +
            "<div class=\"Slide_Navigatori NavigatorRight\"><img class=\"Slide_NavigatorRight\" src=\"" + imagesPath + "1026.png\"></div>" +
            "</div>");
        this.j_navigator = $("#" + this.procID + "_Navigator");


        //get available width:
        this.j_navigator.append("<div id=\"" + this.procID + "Pages" + "\" class=\"Slide_Pages noStrech\">" + "</div>");
        //this.j_procID.append("<div id=\"" + this.procID + "Pages" + "\" class=\"Slide_Pages\">" + "</div>");
        //
        this.j_pages = $("#" + this.procID + "Pages");


    }
    this.bindClicks = function() {
        var self = this;
        boffice.globalClick($("#" + this.procID + "_" + "Navigator > .NavigatorLeft > img"), function(e) {
            self.ProcessNavigatorClick(this);
        });
        boffice.globalClick($("#" + this.procID + "_" + "Navigator > .NavigatorRight > img"), function(e) {
            self.ProcessNavigatorClick(this);

        });
    }
    this.ProcessNavigatorClick = function(elem) {
        elem = $(elem).parent();

        //var NavigatorContainer = $("#" + this.procID + "_Navigator");
        /*
        var currentPage = NavigatorContainer.attr("snatch_current_page");
        var pageCount = this.maxButtonX;
*/

        $("#" + this.procID + "_" + activeID + "_page" + (currentPage - 1)).hide();
        //if (currentPage == undefined) currentPage = 1;
        //if (pageCount == undefined) pageCount = 1;

        if (elem.hasClass("NavigatorLeft")) {
            currentPage--;
            if (currentPage < 1) numberOfPages = 1;
        } else if (elem.hasClass("NavigatorRight")) {
            currentPage++;
            if (currentPage > numberOfPages) currentPage = numberOfPages;

        }
        this.j_current_page = $("#" + this.procID + "_" + activeID + "_page" + (currentPage - 1));

        //NavigatorContainer.attr("snatch_current_page", currentPage);

        this.UpdateNavigatorStatus();
    }

    function updateNumberOfPages(maxButtonX) {
        if (data[activeID] != undefined) //has buttons
        {
            numberOfPages = Object.keys(data[activeID]).length / (maxButtonX);
        } else {
            numberOfPages = 1;
        }

        if (!isInteger(numberOfPages)) { //ex: 4,6
            numberOfPages = Math.floor(numberOfPages) + 1; // 5
        }
    }
    this.populateSlide = function(_activeID, _currentPage, force) {

        if (_activeID === undefined) {
            _activeID = activeID;
        }
        if (force == undefined) {
            force = false;
        }

        if (_currentPage === undefined) {
            _currentPage = currentPage;
        }



        if (this.j_current_page == undefined) {
            this.j_current_page = $("#" + this.procID + "_" + activeID + "_page" + (this.getCurrentPage() - 1));
        }
        if (this.j_current_page.length > 0) {
            if ((!force) && (!forceRedraw)) {
                return;
            }
            this.j_pages.empty();

        }


        updateNumberOfPages(this.maxButtonX);



        forceRedraw = false;
        var currentButton = 0;
        var pageIndex = 0;
        var btindex = 0;
        for (var p = 0; p < numberOfPages; p++) {

            this.j_pages.append("<div id=\"" + this.procID + "_" + _activeID + "_page" + p + "\"" +
                " class=\"Slide_Page btn-group btn-group-justified btn-group-lg\"> " +
                "</div>");
            var j_localCurrentPage = $("#" + this.procID + "_" + _activeID + "_page" + pageIndex);

            j_localCurrentPage.hide();



            //$.each( data.d, function(index, value)

            if (data_order[_activeID] !== undefined) {
                var size = 0;
                if ( (this.strechslide==0) && ( data_order[_activeID]["order"].length <= this.maxButtonX )) { 
                    this.j_pages.addClass("noStrech");
                    
                        size = (( (this.j_procID.width()-32) / this.maxButtonX) / this.j_procID.width()) * 100;
                        //j_localCurrentPage.removeClass("btn-group-justified");
                        j_localCurrentPage.css("width", data_order[_activeID]["order"].length * size + "%");
                    
                    
                }
                else
                {
                    this.j_pages.removeClass("noStrech");
                }

                for (var i = btindex; i < data_order[_activeID]["order"].length; i++) {
                    //keep original order
                    var key = data_order[_activeID]["order"][i];
                    //};

                    //for (var key in data_order[activeID]["order"]) {

                    var bId = data[_activeID][key].id;
                    var bText = data[_activeID][key].v;
                    var bColor = GetHtmlColor(data[_activeID][key].color);
                    var slideBut = this.procID + "_" + _activeID + "_" + bId;

                    //slideButtons[slideBut] = i;

                    j_localCurrentPage.append(
                        "<a id=\"" + slideBut +
                        "\" snatch_id=\"" + bId +
                        "\" type=\"button\" class=\"Slide_Button btn btn-primary\">" + bText + "</button>"
                    );
                    var j_slideBut = $("a#" + slideBut);
                    /*
                    if (size > 0) {
                        size-=1;
                        j_slideBut.css("width",size+"%");
                        //j_slideBut.addClass("strechslide");
                    }
                    */

                    if ((bId == lastClicked_snatch[activeID]) || ((this.referral !== -1) && (lastClicked_snatch[activeID] === undefined) && i == 0)) {
                        j_slideBut.addClass("active");
                        lastClickedElement[activeID] = j_slideBut;
                    } else {
                        j_slideBut.removeClass("active");
                    }
                    if (this.bgtype == "color") {
                        if (this.bgcolor != "") {

                            var alternate = darkerColor(this.bgcolor, 0.4);

                            // if ($("a#" + procIDChild).hasClass("no_image")) {
                            //parent.find("a#" + procIDChild).css("padding", 0);
                            j_slideBut.css("background-position", 0);
                            j_slideBut.css("background-size", "cover");



                            j_slideBut.css("background-image", "linear-gradient(to bottom, " + this.bgcolor + ", " + alternate + ")");

                            //}

                            //j_slideBut.css("border", "1px");
                            j_slideBut.css("border-color", alternate);

                            j_slideBut.css("background-color", this.bgcolor);
                            //linear-gradient(to bottom, #337ab7 0, #265a88 100%)
                            j_slideBut.parent().css("box-shadow", "");
                        }
                    } else {
                        if (this.bgimage != "") {
                            j_slideBut.css("background", "none");
                            j_slideBut.css("border", "0");
                            j_slideBut.css("background-position", 0);
                            j_slideBut.css("background-size", "100% 100%");
                            j_slideBut.css("background-image", "url(" + imagesPath + this.bgimage + ")");
                            j_slideBut.parent().css("box-shadow", "none");
                        }
                    }

                    if (this.textcolor != "") {
                        j_slideBut.css("color", this.textcolor);
                    } else {
                        j_slideBut.css("color", "none");
                    }

                    var self = this;
                    $("#" + this.procID + "_" + bId).off();
                    boffice.globalClick(j_slideBut, function() {
                        self.processSlideButtonClick(this, self);
                    });

                    if (bofficeGlobals.DEBUG)
                        $("#" + this.procID + "_" + bId).append("<span class='debugInfo'>" + bId + "</span>");

                    currentButton += 1;
                    btindex += 1;
                    if (currentButton >= this.maxButtonX) {
                        pageIndex += 1;
                        currentButton = 0;
                        break;
                    }

                }
                if (this.referral != "-1") {
                    if (_activeID !== undefined) {
                        if (lastClicked_snatch[activeID] == undefined) {
                            $("#" + this.procID + "_page0 > a[snatch_id=" + data_order[_activeID]["order"][0] + "]").addClass('active'); //select first button
                        } else {
                            $("#" + this.procID + "_page0 > a[snatch_id=" + lastClicked_snatch[activeID] + "]").addClass('active'); //select first button
                        }

                    } else {
                        $("#" + this.procID + "_page0 > a:first").addClass('active');
                        lastClicked_snatch[activeID] = $("#" + this.procID + "_page0 > a:first").attr("snatch_id");
                    }

                }
            } else {
                console.log(this.procID + " Empty grid tab");
            }
        }

    }
    this.processSlideButtonClick = function(objToHandle, parent) {
        if (SnatchBase.displayEditWarning(this.j_procID)) {
            return;
        }

        var snatchID = objToHandle.attr("snatch_id");

        if (lastClicked_snatch[activeID] == snatchID) {
            return;
        }

        if (this.referral != -1) {


            if (lastClickedElement[activeID] != undefined) {
                lastClickedElement[activeID].removeClass('active');
            }

            lastClickedElement[activeID] = objToHandle;
            var activeElement = $("#" + this.procID + "Pages > .Slide_Page > .active").attr("snatch_id");
            if (activeElement == snatchID) {
                return;
            }

            this.updateReferral(objToHandle);

        } else {
            lastClickedElement[activeID] = objToHandle;
            var urlCmd = "callback&windowID=" + windowID + "&objectID=" + parent.id + "&value=" + snatchID;
            boffice.send_url(urlCmd);
        }


    }
    this.updateReferral = function(_lastClicked) {
        lastClicked_snatch[activeID] = _lastClicked.attr("snatch_id");
        _lastClicked.addClass('active');
        if (this.j_referralTo === undefined) {
            this.j_referralTo = $("#" + this.referralTo);
        }
        if ((this.j_referralTo.hasClass("SlideGrid")) || (this.j_referralTo.hasClass("cSlideGrid"))) {

            //FIXME: hash this!
            //var lookID = $(_lastClicked).attr("snatch_id");
            var lookID = $("#" + this.procID + "_" + activeID + "_page" + (this.getCurrentPage() - 1) + " > .active").attr("snatch_id")
                //FIXME: hash this!
                //for (var i = 0; i < uiData[this.referralTo].length; i++) {
                //    if (uiData[this.referralTo][i].id == lookID)
                //        break;
                //};
            if (data_order[activeID] != undefined) {
                if (lookID == undefined) {
                    lookID = data_order[activeID]["order"][0];
                }
                var cp = uiData["slidegrid_" + this.referralTo].getCurrentPage() - 1;
                if (($("#" + this.referralTo + "_" + lookID + "_page" + cp).length == 0) || (uiData["slidegrid_" + this.referralTo].getActiveId() != lookID)) {
                    uiData["slidegrid_" + this.referralTo].drawSlideGrid(lookID);
                }

            } else {
                //draw empty grid
                console.log(this.referralTo + " Empty grid tab");
                uiData["slidegrid_" + this.referralTo].drawEmpty();
            }

        } else //a slide
        {
            if (_lastClicked !== undefined) {


                uiData["slide_" + this.referralTo].drawSlide(lastClicked_snatch[activeID]);

            } else
                uiData["slide_" + this.referralTo].drawSlide();
        }
    }
    this.UpdateNavigatorStatus = function() {

        //var _navigator = $("#" + this.procID + " > .Slide_Navigator");

        updateNumberOfPages(this.maxButtonX);
        //show/hide arrows

        //show/hide arrows
        if (numberOfPages > 1) {
            $("#" + this.procID + "_Navigator > div").show();
            if (currentPage == 1)
                $("#" + this.procID + " > .Slide_Navigator > .NavigatorLeft").hide();
            else
                $("#" + this.procID + " > .Slide_Navigator > .NavigatorLeft").show()
            if (currentPage == numberOfPages)
                $("#" + this.procID + " > .Slide_Navigator > .NavigatorRight").hide();
            else
                $("#" + this.procID + " > .Slide_Navigator > .NavigatorRight").show();


        } else {
            //$("#" + this.procID + "_Navigator").hide();
            $("#" + this.procID + " > .Slide_Navigator > .NavigatorLeft").hide();
            $("#" + this.procID + " > .Slide_Navigator > .NavigatorRight").hide();
        }
        //mostra o div da pagina corrente
        $("#" + this.procID + "_" + activeID + "_page" + (currentPage - 1)).show();

        var width = 0
        this.j_navigator.find(".Slide_Navigatori:visible").each(function() {
            //width+=$(this).width();
            width += $(this)[0].getBoundingClientRect().width;
        });
        if ( (this.strechslide==0) && (  data_order[activeID]["order"].length <= this.maxButtonX  ) ) {
            this.j_pages.css("position","absolute");
            this.j_pages.css("left","0px");
            //this.j_pages.css("width", "100%");
        }
        else
        {
            
            this.j_pages.css("position","relative");
            this.j_pages.css("left","16px");
            this.j_pages.css("width", "calc(100% - " + (width + 26) + "px)");
        }

        if (this.referral != -1) {
            if (activeID == "-1") {
                //activeID = $("#" + this.procID + "_page0 > a:first").attr("snatch_id"); 
            }

            this.updateReferral(this.j_pages.find(".active"));
        }



    }

    this.UpdateSlideGroupStatus = function(_pageGroup, _internalCode) {


        if (_pageGroup.attr("snatch_pagegroupid") != _internalCode) {
            _pageGroup.attr("snatch_pagegroupid", _internalCode);

            var slideId = _pageGroup.parent().parent().attr("id");
            _pageGroup.parent().parent().empty();
            //call the draw function :D

            var data = uiData[slideId + "_Slide"];
            for (var i = 0; i <= data.d.length; i++) {
                if (data.d[i].id == _internalCode) {
                    data = data.d[i];
                    break;
                }
            }


            uiData["slide_" + slideId].createSlideNavigator(data);

            uiData["slide_" + slideId].populateSlide(uiData[slideId + "_Slide"]);
            uiData["slide_" + slideId].UpdateNavigatorStatus();

        }

    }

    this.reset = function() {
        //console.log("reset " + this.procID);
    }
    this.editSlideForm = function() {
        var dialog, form;
        var _obj = this.j_procID;

        $("#slideButtonsX").spinner();
        $("#slideButtonsX").val(this.maxButtonX);

        if (this.strechslide == 1) {
            $("#strechslide").prop('checked', true);
        } else {
            $("#strechslide").prop('checked', false);
        }
        var self = this;

        function saveTable() {

            //TODO: VALIDATION
            var valid = true;
            var gridX = $("#slideButtonsX").val();
            var isStrechslide = $("#strechslide").prop('checked');

            if (valid) {
                self.maxButtonX = gridX;
                self.strechslide = 0;
                if (isStrechslide) {
                    self.strechslide = 1;
                }
                uiData["slide_"+_obj.attr("id")].strechslide = self.strechslide;
                self.drawSlide(self.getActiveId(), true);
                
                dialog.dialog("close")

            }

            return valid;

        }

        dialog = $("#editSlideForm").dialog({
            autoOpen: false,
            //height: 500,
            width: 350,
            modal: true,
            buttons: {
                "OK": saveTable,
                "Cancelar": function() {
                    dialog.dialog("close");
                }
            },
            open: function() {},

            close: function() {
                form[0].reset();
            }
        });
        form = dialog.find("form").on("submit", function(event) {
            event.preventDefault();
            saveTable();
        });
        dialog.dialog("open");
    }

    this.editColorForm = function() {
        var self = this;

        var _objID = this.procID;
        var _obj = $("#" + _objID);

        var dialog, form;

        function saveTable() {
            var _obj = $("#bgobref").val();
            if ($("#bgtype option:selected").val() == 1) {
                uiData[_obj].bgtype = "color";
                if ($("#colorpck").val() != "") {
                    uiData[_obj].bgcolor = $("#colorpck").spectrum("get").toRgbString();
                } else {
                    uiData[_obj].bgcolor = "";
                }
            } else {
                uiData[_obj].bgtype = "image";
                uiData[_obj].bgimage = $("#btSelectBgImageForm").val();
            }
            if ($("#colorpck2").val() != "") {
                uiData[_obj].textcolor = $("#colorpck2").spectrum("get").toRgbString();
            } else {
                uiData[_obj].textcolor = "";
            }

            //redraw maybe?!
            uiData[_obj].drawSlide(uiData[_obj].getActiveId(), true);

            dialog.dialog("close");

            return

        }
        dialog = $("#editBackgroundForm").dialog({
            autoOpen: false,
            //height: 500,
            width: 350,
            modal: true,
            buttons: {
                "OK": saveTable,
                "Cancelar": function() {
                    dialog.dialog("close");
                }
            },
            open: function() {

                var _obj = $("#bgobref").val();
                $("div#textcolor").show();

                $("#colorpck2").spectrum(bofficeGlobals.colorPickerOptions);
                $("#colorpck2").spectrum("set", uiData[_obj].textcolor);

                $("#bgtype").off();
                $("#bgtype").on('change', function() {
                    if ($("#bgtype option:selected").val() == 1) {
                        $("div#bgcolor").show();
                        $("div#bgimage").hide();

                        $("#colorpck").spectrum(bofficeGlobals.colorPickerOptions);
                        $("#colorpck").spectrum("set", uiData[_obj].bgcolor);



                    } else {
                        $("div#bgcolor").hide();
                        $("div#bgimage").show();

                        $("#btSelectBgImageForm").val(uiData[_obj].bgimage);
                    }
                });

                if (uiData[_obj].bgtype == "color") {
                    $("#bgtype").val(1);
                } else {
                    $("#bgtype").val(2);
                }
                $("#bgtype").change();



            },

            close: function() {
                form[0].reset();
            }
        });
        form = dialog.find("form").on("submit", function(event) {
            event.preventDefault();
            saveTable();
        });
        dialog.dialog("open");

    }

    this.handleCache = function(content) {
        if (content.keys["slide_" + this.procID] != undefined) {
            this.j_parent = $(content.keys["slide_" + this.procID].j_parent);
            this.j_procID = $(content.keys["slide_" + this.procID].j_procID);

            this.j_pages = $(content.keys["slide_" + this.procID].j_pages);
            this.j_navigator = $(content.keys["slide_" + this.procID].j_navigator);
            if (content.keys["slide_" + this.procID].j_referralTo != undefined)
                this.j_referralTo = $(content.keys["slide_" + this.procID].j_referralTo);
            if (content.keys["slide_" + this.procID].j_current_page != undefined)
                this.j_current_page = $(content.keys["slide_" + this.procID].j_current_page);
            currentPage = content.keys["slide_" + this.procID].currentPage;
            activeID = content.keys["slide_" + this.procID].activeID;

            this.strechslide = content.keys["slide_" + this.procID].strechslide;

        }
        if (this.j_procID === undefined) {
            this.j_procID = $("#" + this.procID);
            this.j_pages = $("#" + this.procID + "Pages");
            this.j_navigator = $("#" + this.procID + "_Navigator");
            currentPage = 1;


        }
        var i = 0;
    }

});