"use strict";
var SnatchSlideGrid = SnatchBase.extend(function() {

    this.constructor = function(windowid, _id, json_id, rect, wtype, _arguments) {

        this.super(rect.left, rect.top, rect.width, rect.height, windowid, _id, json_id, rect, wtype);

        this.maxButtonX = 0;
        this.maxButtonY = 0;
        this.skin = -1;
        this.referral = -1;
        this.tab = -1;
        this.pageGroupImages = {};

        //new 
        this.default_image = ""; //image when no image from data
        this.last_grid_x = 0;
        this.last_grid_y = 0;


        this.strech = 0;

        //button background
        this.bgtype = "image"; // || color
        this.bgcolor = "";
        this.bgimage = bofficeGlobals.DEFAULT_BUTTON_IMAGE;

        this.setArguments(_arguments);

        this.j_pages = undefined;
        this.j_current_page = undefined;

    }


    //private:
    var numberOfPages = 1;
    var currentPage = 1;
    var slideType = "SlideGrid";
    var isSlideGrid = true;

    var lastClicked_snatch = undefined;
    var activeID = undefined;

    var background = "null"; //optional ?

    var data = {};
    var data_order = {};
    var data_size;

    var initialButtons = {};

    var forceRedraw = false;

    var lastData;
    var lastDataCount = -1;

    var tabArray = [];
    this.getTabArray = function() {
        return tabArray;
    }
    this.putTab = function(val) {
        if (tabArray.indexOf(val) < 0) {
            tabArray.push(val);
            if (bofficeGlobals.DEBUG) {
                console.log("INFO: " + this.wtype + ":" +
                    this.procID + " added to tabs: " + JSON.stringify(tabArray));
            }
        }
    }
    this.setForceRedraw = function() {
        forceRedraw = true;
    }

    this.getCurrentPage = function() {
        return currentPage;
    }

    this.setSlideGrid = function(_bool) {
        var reset = ((!isSlideGrid) && (_bool) || (_bool)); //change from cslidegrid to slidegrid

        if (reset) {
            //can't do this'
            //initialButtons = {};
        } else {
            //aply other changes
            for (var i = 0; i < Object.keys(initialButtons).length; i++) {
                var key = Object.keys(initialButtons)[i];
                initialButtons[key].strech = this.strech;
            };
        }

        isSlideGrid = _bool;

        if (isSlideGrid) {
            this.j_procID.removeClass("cSlideGrid").addClass("SlideGrid");

            //clear all visible objects:
            this.j_procID.find("*[snatch_id=-1]").remove();

        } else {
            this.j_procID.removeClass("SlideGrid").addClass("cSlideGrid");

            //reset attributes
            /*
            for (var i = 0; i < Object.keys(data).length; i++) {
                var key = Object.keys(data)[i];
                for (var i = 0; i < Object.keys(data[key]).length; i++) {
                    var key2 = Object.keys(data)[i];
                    initialButtons[key2]= {};
                        initialButtons[key2].strech = this.strech;
                }
                    
                //initialButtons[button].image = this.default_image;
            };
            */

        }

    }
    this.isSlideGrid = function() {
        return isSlideGrid;
    }
    this.setData = function(_data, _data_order, _dataSize) {
        data = _data;
        data_order = _data_order;
        data_size = _dataSize;
        if ((activeID === undefined) && Object.keys(data).length > 0) {
            activeID = Object.keys(data)[0];
        }
        if (Object.keys(data).indexOf(activeID) < 0) {
            activeID = Object.keys(data)[0];
        }
        forceRedraw = true;
    }
    this.getData = function() {
        return (data);
    }
    this.getDataOrder = function() {
        return (data_order);
    }
    this.getInitialButtons = function() {
        return (initialButtons);
    }
    this.deleteInitialButton = function(delId) {
        delete initialButtons[delId];
    }
    this.setParams = function() {
        this.params = {
            j_parent: this.j_parent.selector,
            j_procID: this.j_procID.selector,

            j_pages: this.j_pages.selector,


        }
        if (this.j_current_page != undefined) {
            this.params.j_current_page = this.j_current_page.selector
        }
    }
    this.setArguments = function(args) {
        if (args[5] !== undefined) {
            this.maxButtonX = args[5].value;
            this.last_grid_x = args[5].value;
        }
        if (args[6] !== undefined) {
            this.maxButtonY = args[6].value;
            this.last_grid_y = args[6].value;
        }
        if (args[7] !== undefined)
            this.skin = args[7].value;
        if (args[8] !== undefined)
            this.ref = args[8].value;
        if (args[9] !== undefined) {
            this.tab = args[9].value;
            tabArray.push(this.tab);
        }

        if (this.last_grid_x == -1) {
            slideType = "cSlideGrid";
            isSlideGrid = false;
            if (args.length > 10) {
                if (args[10].last_grid_x !== undefined)
                    this.last_grid_x = this.maxButtonX = args[10].last_grid_x;
                if (args[11].last_grid_y !== undefined)
                    this.last_grid_y = this.maxButtony = args[11].last_grid_y;
            }
        }
        if (args.length > 12) {
            if (args[12].default_image !== undefined)
                this.default_image = args[12].default_image;
            if (args[13].strech !== undefined)
                this.strech = args[13].strech;
        }
        if (args.length > 14) {
            this.pageGroupImages = args[14].value[0];
            if (this.pageGroupImages == undefined) {
                this.pageGroupImages = {};
            }
            /*
            var kk = {};
            for (var i = 0; i < args[14].value.length; i++) {
                var k = Object.keys(args[14].value[i])
                var kv = args[14].value[i][k]
                kk[k[0]] = kv;
            }


            this.pageGroupImages = kk;
            */
        }
        if (args.length > 15) {
            this.bgtype = args[15].bgtype;
        }
        if (args.length > 16) {
            this.bgcolor = args[16].bgcolor;
        }
        if (args.length > 17) {
            this.bgimage = args[17].bgimage;
            /*
            if (this.bgimage === "") {
                this.bgimage = bofficeGlobals.DEFAULT_BUTTON_IMAGE;
            }
            */
        }



    }
    this.createSlideGrid = function() {
        if (this.maxButtonX < 1) {
            this.maxButtonX = 1;
        }
        if (this.maxButtonY < 1) {
            this.maxButtonY = 1;
        }



        this.j_parent.append("<div st=\"slidegrid_" + this.procID + "\"  id=\"" + this.procID + "\" class=\"" + slideType + " draggable skin_" + this.skin + "\" " +
            " snatch_id=\"" + this.id + "\"></div>");

        this.super.setRect();

        this.createSlideGridNavigator();



        if (this.tab > 0) {
            this.j_procID.hide();
        }
        /*
        if (uiData[this.uiKey + this.procID] === undefined) {
            uiData[this.uiKey + this.procID] = this;
        }
        */


    }
    this.setActiveID = function(_activeID) {
        if ((_activeID == undefined) && (activeID !== undefined)) {
            return;
        } else

        if (_activeID !== undefined) {
            $("#" + this.procID + "_" + _activeID + "_page" + (0)).show();
            this.j_current_page = $("#" + this.procID + "_" + _activeID + "_page" + (0));
            //hide active page:
            $("#" + this.procID + "_" + activeID + "_page" + (currentPage - 1)).hide();
            activeID = _activeID;
            currentPage = 1;

            lastClicked_snatch = undefined;
        }

        if (!$("#" + this.procID + "_" + activeID + "_page" + (0)).is(':visible')) {
            $("#" + this.procID + "_" + activeID + "_page" + (0)).show();
        }

    }
    this.drawSlideGrid = function(_activeID, force) {
        var lastActiveID = activeID;
        this.setActiveID(_activeID);

        if (force == undefined) {
            force = false;
        }

        if ((!force) &&
            ((lastData == JSON.stringify(data)) || (lastDataCount == Object.keys(data).length)) && (activeID == lastActiveID) && (this.j_pages.children().length > 0)) {

            if (!forceRedraw) //datas has not changed?
            {
                if (bofficeGlobals.DEBUG)
                    console.log("PERFORMANCE: " + this.uiKey + this.procID + ": using cached values");
                return;

            } else {
                this.j_pages.empty();
            }
        }
        lastData = JSON.stringify(data);
        lastDataCount = Object.keys(data).length;

        //this.createSlideGridNavigator();
        if (activeID === undefined) {
            activeID = 1;
        }


        this.populateSlideGrid();
        this.UpdateNavigatorStatus();

        //change background image
        var currentBgImage = this.pageGroupImages[activeID];
        if (currentBgImage == undefined) {
            currentBgImage = "none";
        } else if (currentBgImage.length == 0) {
            currentBgImage = "none";
        }

        if (currentBgImage != this.j_procID.css("background-image")) {
            var image = this.pageGroupImages[activeID]
            if (image !== "") {
                this.j_procID.css("background-image", "url(" + imagesPath + image + ")");
            } else {
                this.j_procID.css("background-image", "none");
            }
        }

        if (!isDraggable) {
            SnatchWindow.bindWindow4ButtonsSwipe();
        }



        if (bofficeGlobals.DEBUG)
            this.j_procID.append("<span class='debugInfo'>" + this.uiKey + "_" + this.procID + "</span>");
        //}
    };
    this.drawEmpty = function() {
        //this.createSlideGridNavigator();
        this.UpdateNavigatorStatus();

        if (bofficeGlobals.DEBUG)
            this.j_procID.append("<span class='debugInfo'>" + this.uiKey + "_" + this.procID + "</span>");
    }

    this.getActiveId = function() {
        return activeID;
    }

    this.createSlideGridNavigator = function() {
        //var data = uiData[this.procID][activeID];



        //if ($("#" + this.procID + "_Navigator").length == 0) {

        //var numberOfPages = uiData[this.procID][pageIndex].d.length; //i.e. button number

        this.j_procID.append("<div id=\"" + this.procID + "_Navigator" +
            "\" class=\"SlideGrid_Navigator\">" +
            "<div class=\"SlideGrid_Navigatori NavigatorLeft\"><img class=\"SlideGrid_NavigatorLeft\" src=\"" + imagesPath + "1027.png\"></div>" +
            "<div class=\"SlideGrid_Navigatori NavigatorRight\"><img class=\"SlideGrid_NavigatorRight\" src=\"" + imagesPath + "1026.png\"></div>" +
            "</div>");



        this.j_procID.append("<div id=\"" + this.procID + "Pages" + "\" class=\"SlideGrid_Pages\"></div>");
        this.j_pages = $("#" + this.procID + "Pages");
        //}



        //if (isAdmin) {
        //  bofficeWidgetsMenu.bindContextMenu("#" + this.procID, "SlideGridMenu");
        //}

    };
    this.bindClicks = function() {
        var self = this;
        boffice.globalClick($("#" + this.procID + "_" + "Navigator > .NavigatorLeft > img"), function(e) {
            self.ProcessNavigatorClick(this);
        });
        boffice.globalClick($("#" + this.procID + "_" + "Navigator > .NavigatorRight > img"), function(e) {
            self.ProcessNavigatorClick(this);
        });

        if (this.procID == "4_103") {

            if (!isDraggable) {
                SnatchWindow.bindWindow4Swipe();
            }
        }
        //bind all buttons!!!

        this.j_pages.find("a.btn").each(function() {
            boffice.globalClick($(this), function(elem) {
                self.ProcessSlideGridButtonClick(this, self);
            });
        });
    }

    function updateNumberOfPages(_activeID, maxButtonX, maxButtonY) {
        if (!isSlideGrid) {
            numberOfPages = 1; //cSlideGrid has only one page per group
        } else {
            //numero de DIVS para comportar todos os botões
            numberOfPages = data_order[_activeID]["order"].length / (maxButtonX * maxButtonY);
            if (!isInteger(numberOfPages)) {
                numberOfPages = Math.floor(numberOfPages) + 1;
            }
        }
    }

    this.populateSlideGrid = function(_activeID, _currentPage) {

        if (_activeID === undefined) {
            _activeID = activeID;
        }

        if (_currentPage === undefined) {
            _currentPage = currentPage;
        }


        if (this.j_current_page !== undefined) {
            if (this.j_current_page.length > 0) {
                if (!forceRedraw) {
                    return;
                }
                this.j_pages.empty();

            }
        }

        //var numberOfPages = 0;
        updateNumberOfPages(_activeID, this.maxButtonX, this.maxButtonY);

        //var data = uiData[this.procID][activeID];
        /*
        $("#" + this.procID + " > .SlideGrid_Pages").empty();
        var snatch_pageGroupID = data.id;
*/



        //draw buttons!


        /*
        if (!isSlideGrid) {
            topBt = this.j_pages.parent().offset().top;
        }
        */

        //put buttons in pages
        /* if (newButtons == undefined) {
             newButtons = false;
         }*/


        forceRedraw = false;
        if (!isSlideGrid) {
            for (var i = 0; i < Object.keys(data).length; i++) {
                this.j_pages.append("<div id=\"" + this.procID + "_" + Object.keys(data)[i] + "_page0\" class=\"SlideGrid_Page\"> " +
                    "</div>");
            }

        }

        for (var i = 0; i < numberOfPages; i++) {
            var j_cpage = $("#" + this.procID + "Pages > #" + this.procID + "_" + _activeID + "_page" + i);

            if (isSlideGrid) {
                if ((j_cpage).length == 0) {
                    this.j_pages.append("<div id=\"" + this.procID + "_" + _activeID + "_page" + i +
                        "\" class=\"SlideGrid_Page\"> " +
                        "</div>");
                    $("#" + this.procID + "_" + _activeID + "_page" + i).hide();
                }
            }

            if ((this.pageGroupImages !== undefined) && (this.pageGroupImages[_activeID] != undefined)) {
                //for (var k = 0; k < uiData[this.procID + "_pageGroupImages"].length; k++) {
                //  if (uiData[this.procID + "_pageGroupImages"][k].key == snatch_pageGroupID) {
                var image = this.pageGroupImages[_activeID];
                //j_cpage.css("background-image", "url(" + imagesPath + image + ")");
                $("#" + this.procID + " > .SlideGrid_Navigator").attr("snatch_image", image);
                //break;
                //  }
                //}
                //
            }
        }
        var leftBt = this.j_pages.offset().left;
        var topBt = this.j_pages.offset().top;
        this.createSlideGridButtons(leftBt, topBt, _activeID);


    };
    this.UpdateNavigatorStatus = function() {


        //var _navigator = $("#" + this.procID + " > .SlideGrid_Navigator");
        updateNumberOfPages(activeID, this.maxButtonX, this.maxButtonY);

        //show/hide arrows
        if (numberOfPages > 1) {
            if (!$("#" + this.procID + "_Navigator > div").is(":visible")) $("#" + this.procID + "_Navigator > div").show();
            if ((currentPage == 1) && ($("#" + this.procID + " > .SlideGrid_Navigator > .NavigatorLeft").is(":visible"))) {
                $("#" + this.procID + " > .SlideGrid_Navigator > .NavigatorLeft").hide();
            } else if (!($("#" + this.procID + " > .SlideGrid_Navigator > .NavigatorLeft").is(":visible"))) {
                $("#" + this.procID + " > .SlideGrid_Navigator > .NavigatorLeft").show();
            }
            if ((currentPage == numberOfPages) && ($("#" + this.procID + " > .SlideGrid_Navigator > .NavigatorRight").is(":visible"))) {
                $("#" + this.procID + " > .SlideGrid_Navigator > .NavigatorRight").hide();
            } else if ((!$("#" + this.procID + " > .SlideGrid_Navigator > .NavigatorRight").is(":visible"))) {
                $("#" + this.procID + " > .SlideGrid_Navigator > .NavigatorRight").show();
            }


        } else if ($("#" + this.procID + "_Navigator > div").is(":visible")) {
            $("#" + this.procID + "_Navigator > div").hide();
        }

        //mostra o div da pagina corrente
        //$("#"+this.procID+"Pages > div:visible").css("z-index",-10);
        //$(_navigator).parent().find(".SlideGrid_Pages :nth-child(" + (currentPage) + ")").show();
        $("#" + this.procID + "_" + activeID + "_page" + (currentPage - 1)).show();



    };
    this.createSlideGridButtons = function(_left, _top, _activeID, newButton, onCreate) {
        var divIndex = 0;

        var width = this.j_pages.width() / this.maxButtonX;
        var height = this.j_pages.height() / this.maxButtonY;

        var rect = bofficeScreen.snapToGrid({
            'top': _top,
            'left': _left,
            'width': width,
            'height': height,
        });

        var top = rect.top;
        var left = rect.left;
        var width = rect.width - (bofficeScreen.tx / 2);
        var height = rect.height - (bofficeScreen.ty / 2);

        var orig_left = left;


        var buttonLineX = 0;
        var buttonLineY = 0;

        var totalButtons = data_order["order"].length;
        var buttonCount = 0;

        var valid_keys = [];
        if (isSlideGrid) {
            valid_keys = [activeID];
        } else {
            valid_keys = Object.keys(data);
        }

        for (var w = 0; w < valid_keys.length; w++) {
            var _activeID = valid_keys[w];
            var parent = $("#" + this.procID + " > .SlideGrid_Pages > #" + this.procID + "_" + _activeID + "_page" + divIndex);



            for (var i = 0; i < data_order[_activeID]["order"].length; i++) {
                //var bId = data.d[i].id;
                var key = data_order[_activeID]["order"][i];

                if (true) { //(parent.length > 0) {
                    var strech = this.strech;
                    if (newButton !== undefined) {

                    } else {
                        rect = bofficeScreen.fromTxTy({
                            'top': top,
                            'left': left,
                            'width': width,
                            'height': height
                        });
                    }


                    var classObj = "SlideGrid_Button ";

                    //if ((uiData[this.procID + "_initialButtons"][bId] !== undefined) && (!isSlideGrid) ){
                    if (!isSlideGrid) {
                        classObj = "cSlideGrid_Button draggable ";
                    }

                    var zindex = 0;


                    if (newButton === undefined) {

                        if ((initialButtons[key] !== undefined) && (!isSlideGrid)) {
                            //custom buttons, override coords size:
                            //rect = bofficeScreen.fromTxTy(uiData[this.procID + "_initialButtons"][bId]);
                            if (initialButtons[key].top != undefined) {
                                rect = bofficeScreen.fromSnatchCoordsFromRect(initialButtons[key]);
                            } else {
                                initialButtons[key].top = rect.top;
                                initialButtons[key].left = rect.left;
                                initialButtons[key].width = rect.width;
                                initialButtons[key].height = rect.heigh;
                            }

                            strech = initialButtons[key].strech;


                        } else if (
                            (initialButtons[key] == undefined) && (!isSlideGrid) && (Object.keys(initialButtons).length > 0)) {
                            //cbutton with no position

                            zindex = 1;
                            //get default strech:
                            strech = this.strech;

                        }
                    }

                    if (((zindex == 0) || ((zindex == 1) && AUTO_ADD_NEW_BUTTONS))) {
                        if (newButton !== undefined) {
                            //if (!isSlideGrid) {
                            strech = strech;
                            if (newButton == key) {
                                this.drawButton(parent, rect, zindex, classObj, data, key, newButton, strech, _activeID);
                            }
                            //}
                        } else {
                            this.drawButton(parent, rect, zindex, classObj, data, key, newButton, strech, _activeID);
                        }


                    }
                }


                buttonLineX++;


                if (buttonLineX >= this.maxButtonX) {
                    buttonLineX = 0;
                    left = this.j_procID[0].getBoundingClientRect().left;
                    top = top + height + (bofficeScreen.ty / 2);
                    buttonLineY += 1;
                } else
                    left = left + width + (bofficeScreen.tx / 2);

                if (buttonLineY >= this.maxButtonY) {
                    buttonLineY = buttonLineX = 0;
                    top = $("#" + this.procID + " >  .SlideGrid_Pages")[0].getBoundingClientRect().top;
                    left = this.j_procID[0].getBoundingClientRect().left;

                    if (isSlideGrid) {
                        divIndex++; //cslidegrids only have one page


                    } else {
                        //start at 0,0
                        var rect = bofficeScreen.snapToGrid({
                            'top': _top,
                            'left': _left,
                            'width': width,
                            'height': height,
                        });
                        //if (newButton === undefined) {

                        if ((isDraggable) && (newButton === undefined)) {
                            break; //next activeID
                        }
                        //}
                    }
                }



                parent = $("#" + this.procID + " > .SlideGrid_Pages > #" + this.procID + "_" + _activeID + "_page" + divIndex);


            } //end for #1



            //check for visual elements:
            if (!isSlideGrid) {
                var k = 1;
                for (var j = 0; j < Object.keys(initialButtons).length; j++) {
                    var key = Object.keys(initialButtons)[j];
                    var value = initialButtons[key];
                    var vis_props = key.split("_");
                    if ((vis_props[1] == _activeID) && (value.tab == _activeID)) {
                        SnatchSlideGrid.drawVisualElement(parent.attr("id"), value);
                        k += 1;
                    }

                }
            }
            if (_activeID != activeID) {
                parent.hide();
            }
        } //end for #2

    };
    this.drawButton = function(parent, rect, zindex, classObj, data, key, newButton, strech, _activeID) {
        if (_activeID === undefined) {
            _activeID = activeID;
        }

        var bId = data[_activeID][key].id;
        var bText = data[_activeID][key].v; //always comes from dynamic button
        var bColor = data[_activeID][key].color;
        var bIcon = data[_activeID][key].icon;
        var bColor = GetHtmlColor(bColor);

        var _left = rect.left;
        var _top = rect.top;
        var _width = rect.width;
        var _height = rect.height;

        var currentIDX = _activeID;
        var procIDChild = this.procID + "_" + bId + "_" + currentIDX;

        //sanity
        if (bIcon === undefined) {
            bIcon = "";
        }


        classObj += "btn btn-lg btn-default";
        var j_procidchild = $("a#" + procIDChild);
        if (j_procidchild.length == 0) {
            parent.append("<a role=\"button\" id=\"" + procIDChild + "\"></a>");
            $("#" + procIDChild).append("<span>" + bText + "</span>");
            $("#" + procIDChild).append("<div class='imgb'></div>");
            j_procidchild = $("a#" + procIDChild);
        }
        j_procidchild.attr("snatch_id", bId);
        j_procidchild.attr("snatch_image", bIcon);
        j_procidchild.attr("snatch_color", bColor);
        j_procidchild.css("height", _height);
        j_procidchild.css("width", _width);
        j_procidchild.css("left", _left);
        j_procidchild.css("top", _top);
        bColor = "#" + bColor;
        j_procidchild.css("color", bColor);
        j_procidchild.removeClass();
        j_procidchild.addClass('hover ' + classObj);


        var lastWidth = _width;
        var lastHeight = _height;
        j_procidchild.css("z-index", zindex);

        //image override:
        if (initialButtons[bId] != undefined) {
            if ((initialButtons[bId].bIcon != undefined) && (initialButtons[bId].bIcon != "")) {
                bIcon = initialButtons[bId].bIcon;
            } else if (initialButtons[bId].bIcon == "") {
                j_procidchild.attr("snatch_image", ""); //this is auto-updated....
            }
        }


        if (newButton) {
            if (!isSlideGrid) {
                var default_image = this.default_image;
                if ((default_image != "") && (this.default_image != undefined)) {
                    bIcon = default_image;
                }
            } else {
                //bIcon = uiData[this.procID][0].d[_activeID].icon;
                bIcon = data[_activeID][key].icon;
            }
        } else if (bIcon == "") {
            //last chance of getting a image
            bIcon = uiData["slidegrid_" + this.procID].default_image;
        }

        if (bIcon !== "") {
            $("a#" + procIDChild + " > div.imgb").css("background-image", "url(" + imagesPath + bIcon + ")");
            //parent.find("a#" + procIDChild).attr("snatch_image", bIcon);
        } else {
            j_procidchild.addClass("no_image");
            j_procidchild.addClass("no_image_" + this.procID);
            //parent.find("a#" + procIDChild).attr("snatch_image", "");
        }
        if (strech == 1) {
            j_procidchild.addClass("imgStrech");
            j_procidchild.attr("snatch_strech", "1");
        } else {
            $("a#" + procIDChild + " > div.imgb").css("background-size", "inherit inherit)");
            j_procidchild.removeClass("imgStrech");
        }
        $("#" + procIDChild).off();
        var self = this;


        boffice.globalClick($("#" + procIDChild), function(elem) {
            self.ProcessSlideGridButtonClick(this, self);
        });


        if (this.bgtype == "color") {
            if (this.bgcolor != "") {

                var alternate = darkerColor(this.bgcolor, 0.4);

                // if (j_procidchild.hasClass("no_image")) {
                //parent.find("a#" + procIDChild).css("padding", 0);
                j_procidchild.css("background-position", 0);
                j_procidchild.css("background-size", "cover");



                j_procidchild.css("background-image", "linear-gradient(to bottom, " + this.bgcolor + ", " + alternate + ")");

                //}

                j_procidchild.css("border", "1px");
                j_procidchild.css("border-color", alternate);

                j_procidchild.css("background-color", this.bgcolor);
                //linear-gradient(to bottom, #337ab7 0, #265a88 100%)
            }
        } else {
            //if (this.bgimage != "") {
            j_procidchild.css("background", "none");
            j_procidchild.css("border", "0");
            j_procidchild.css("background-position", 0);
            j_procidchild.css("background-size", "100% 100%");
            j_procidchild.css("background-image", "url(" + imagesPath + this.bgimage + ")");
            //}
        }
        if (isDraggable) {
            bofficeWidgetsMenu.bindContextMenu(j_procidchild);
        }
    }
    this.ProcessSlideGridButtonClick = function(elem, parent) {

        if (SnatchBase.displayEditWarning(this.j_procID)) {
            return;
        }
        //does nothing in case is an graphic element
        //------------
        if ($(elem).attr("id") != -1) {
            //objectParentID = elem[0].parentElement.parentElement.parentElement.parentElement.parentElement.id
            var snatchID = $(elem).attr("snatch_id");
            //snatchIDParent = elem.parent().parent().parent().attr("snatch_id");
            var urlCmd = "callback&windowID=" + windowID + "&objectID=" + parent.id + "&value=" + snatchID;
            boffice.send_url(urlCmd);
        }
    }

    this.UpdateSlideGridGroupStatus = function(_pageGroup, _internalCode) {

        if (cacheMode == 1)
            return;


        if (_pageGroup.attr("snatch_pagegroupid") != _internalCode) {
            _pageGroup.attr("snatch_pagegroupid", _internalCode);

            var slideId = _pageGroup.parent().attr("id");
            _pageGroup.parent().empty();
            //call the draw function :D

            var data = uiData[slideId];
            if (data != undefined) {
                var pageIndex = 0;
                for (var i = 0; i <= data.length; i++) {
                    if (data[i].id == _internalCode) {
                        data = data[i];
                        pageIndex = i;
                        break;
                    }
                }
                activeID = i;

                //this.createSlideGridNavigator(data, i);

                this.populateSlideGrid();
                this.UpdateNavigatorStatus();
            }

        }

    };
    this.ProcessNavigatorClick = function(elemi) {
        var elem = $(elemi);
        var NavigatorContainer = elem.parent().parent();

        if (currentPage == undefined) currentPage = 1;
        if (numberOfPages == undefined) numberOfPages = 1;

        $("#" + this.procID + "_" + activeID + "_page" + (currentPage - 1)).hide();

        if (elem.hasClass("SlideGrid_NavigatorLeft")) {
            currentPage--;
            if (currentPage < 1) currentPage = 1;
        } else if (elem.hasClass("SlideGrid_NavigatorRight")) {
            currentPage++;
            if (currentPage > numberOfPages) currentPage = numberOfPages;

        }

        this.j_current_page = $("#" + this.procID + "_" + activeID + "_page" + (currentPage - 1));


        this.UpdateNavigatorStatus();
    }
    this.editSlideGridImageForm = function() {
        var dialog;
        $("#obref").val(this.procID);

        function saveTable() {
            var objId = $("#obref").val();

            var image = $("#slideGridImage").val();
            var activeID = uiData["slidegrid_" + objId].getActiveId();
            uiData["slidegrid_" + objId].pageGroupImages[activeID] = image;

            if (image == "") {
                $("div[id^=" + objId + "_" + activeID + "_]").parent().parent().css("background-image", "none");
            } else {
                $("div[id^=" + objId + "_" + activeID + "_]").parent().parent().css("background-image", "url(" + imagesPath + image + ")");
            }


            dialog.dialog("close");
        }
        dialog = $("#editSlideGridImageForm").dialog({
            autoOpen: false,
            width: 350,
            modal: true,
            buttons: {
                "OK": saveTable,
                "Cancelar": function() {
                    dialog.dialog("close");
                }
            },
            open: function() {
                var objId = $("#obref").val();
                var activeID = uiData["slidegrid_" + objId].getActiveId();
                $("#slideGridImage").val("");
                if (uiData["slidegrid_" + objId].pageGroupImages[activeID] != undefined) {
                    $("#slideGridImage").val(uiData["slidegrid_" + objId].pageGroupImages[activeID]);
                }

            },

            close: function() {
                form[0].reset();
            }
        });
        var form = dialog.find("form").on("submit", function(event) {
            event.preventDefault();
            saveTable();
        });
        dialog.dialog("open");
    }
    this.editSlideGridForm = function() {
        var self = this;

        var _objID = this.procID;
        var _obj = $("#" + _objID);

        var dialog, form;


        function saveTable() {
            var isSlideGrid = uiData["slidegrid_" + _objID].isSlideGrid();

            var r = confirm("Os botões serão recolocados novamente, tem a certeza?");
            if (r == false) {
                return;
            }

            var gridX = $("#slideGridButtonsY").val();
            var gridY = $("#slideGridButtonsX").val();

            var snatch_pageGroupID = uiData["slidegrid_" + _objID].getActiveId();
            //var _image = $("#slideGridImage").val();
            var checkForcSlideGrid = $("#slideGridButtonsCheck").prop('checked');

            var strech = $("#imgElementi").is(":checked");
            var _strech = 0;
            if (strech) {
                _strech = 1;
            }
            uiData["slidegrid_" + _objID].strech = _strech;

            //set attributes
            //_obj.attr("snatch_image", _image);
            uiData["slidegrid_" + _objID].maxButtonX = gridX;
            uiData["slidegrid_" + _objID].maxButtonY = gridY;
            uiData["slidegrid_" + _objID].last_grid_x = gridX;
            uiData["slidegrid_" + _objID].last_grid_y = gridY;

            //default image for buttons
            uiData["slidegrid_" + _objID].default_image = $("#slideGridImages").val();


            uiData["slidegrid_" + _objID].setSlideGrid(!checkForcSlideGrid);

            if (!isSlideGrid) {
                initialButtons = {};
            }
            uiData["slidegrid_" + _objID].setForceRedraw();
            uiData["slidegrid_" + _objID].drawSlideGrid(uiData["slidegrid_" + _objID].getActiveId(), true); //force update
            var activeID = uiData["slidegrid_" + _objID].getActiveId();
            if (checkForcSlideGrid) {
                $("div[id=" + _objID + "_" + activeID + "_page0] > a").resizable(bofficeScreen.enableResize());
                $("div[id=" + _objID + "_" + activeID + "_page0] > a").draggable(bofficeScreen.enableDrag());

            }

            dialog.dialog("close");

            return

        }
        var own = self;
        dialog = $("#editSlideGridForm").dialog({
            autoOpen: false,
            //height: 600,
            width: 300,
            modal: true,
            buttons: {
                "OK": saveTable,
                "Cancelar": function() {
                    dialog.dialog("close");
                }
            },
            open: function() {

                $("#slideGridButtonsX").spinner();
                $("#slideGridButtonsY").spinner();
                $("#slideGridButtonsX").val(uiData["slidegrid_" + _objID].maxButtonY);
                $("#slideGridButtonsY").val(uiData["slidegrid_" + _objID].maxButtonX);

                $("#slideGridImages").val(uiData["slidegrid_" + _objID].default_image);

                var strech = uiData["slidegrid_" + _objID].strech;

                $("#imgElementi").prop('checked', false);
                if ((strech != undefined) && (strech == true)) {
                    $("#imgElementi").prop('checked', true);
                }

                if (uiData["slidegrid_" + _objID].isSlideGrid()) {
                    $("#slideGridButtonsCheck").prop('checked', false);
                    $("#cslidepick").show();
                } else {
                    $("#slideGridButtonsY").val(uiData["slidegrid_" + _objID].last_grid_x);
                    $("#slideGridButtonsX").val(uiData["slidegrid_" + _objID].last_grid_y);
                    $("#slideGridButtonsCheck").prop('checked', true);
                    $("#cslidepick").hide();
                }



                $("#slideGridButtonsCheck").on("change", function() {
                    var checked = $("#slideGridButtonsCheck").is(":checked");
                    if (checked) {
                        $("#cslidepick").hide('slow');
                    } else {
                        $("#cslidepick").show('slow');
                    }
                });



            },

            close: function() {
                form[0].reset();
            }
        });
        form = dialog.find("form").on("submit", function(event) {
            event.preventDefault();
            saveTable();
        });
        dialog.dialog("open");
    }

    this.editBackgroundForm = function() {
            var self = this;

            var _objID = this.procID;
            var _obj = $("#" + _objID);

            var dialog, form;

            function saveTable() {
                var _obj = $("#bgobref_slide").val();

                uiData["slidegrid_" + _obj].bgtype = "image";
                uiData["slidegrid_" + _obj].bgimage = $("#btSelectBgImageForm_slide").val();

                /*
                if (uiData["slidegrid_" + _obj].bgimage === "")
                {
                    uiData["slidegrid_" + _obj].bgimage = bofficeGlobals.DEFAULT_BUTTON_IMAGE;
                }
                */

                //redraw maybe?!
                uiData["slidegrid_" + _obj].setForceRedraw();
                uiData["slidegrid_" + _obj].drawSlideGrid(uiData["slidegrid_" + _obj].getActiveId(), true);

                if (!uiData["slidegrid_" + _obj].isSlideGrid()) {
                    $("div[id=" + _objID + "_" + activeID + "_page0] > a").resizable(bofficeScreen.enableResize());
                    $("div[id=" + _objID + "_" + activeID + "_page0] > a").draggable(bofficeScreen.enableDrag());

                }

                dialog.dialog("close");

                return

            }
            dialog = $("#editBackgroundForm_slide").dialog({
                autoOpen: false,
                //height: 500,
                width: 350,
                modal: true,
                buttons: {
                    "OK": saveTable,
                    "Cancelar": function() {
                        dialog.dialog("close");
                    }
                },
                open: function() {
                    var _obj = $("#bgobref_slide").val();
                    $("#btSelectBgImageForm_slide").val(uiData["slidegrid_" + _obj].bgimage);
                },

                close: function() {
                    form[0].reset();
                }
            });
            form = dialog.find("form").on("submit", function(event) {
                event.preventDefault();
                saveTable();
            });
            dialog.dialog("open");

        }
        /*
         *
         * Pass html buttons to inittialbuttons
         *
         */
    this.processCSlideGridButtons = function() {
        var self = this;
        //only current page
        //$("#" + this.procID+"Pages").find("a.cSlideGrid_Button").each(function() {
        var valid_keys = Object.keys(data);

        for (var i = 0; i < valid_keys.length; i++) {
            var active_id = valid_keys[i];

            $("#" + this.procID + "_" + active_id + "_page0").show();

            this.j_pages.find("div[id^=" + this.procID + "_" + active_id + "_page0] > a").each(function() {

                var snatch_id = $(this).attr("snatch_id");

                var element = {};

                var rect = bofficeScreen.toSnatchCoords(
                    $(this)[0].getBoundingClientRect().top,
                    $(this)[0].getBoundingClientRect().left,
                    $(this)[0].getBoundingClientRect().width,
                    $(this)[0].getBoundingClientRect().height);

                element['left'] = rect.left;
                element['top'] = rect.top;
                element['width'] = rect.width;
                element['height'] = rect.height;

                element['label'] = $(this).children().first().html();
                if ((windowID == 3) || (windowID == 138)) {
                    element['bColor'] = $(this).attr("snatch_color");
                    element['bIcon'] = $(this).attr("snatch_image");
                } else {
                    element['bColor'] = "";
                    element['bIcon'] = "";
                }

                element['parent'] = this.procID;
                var strech = $(this).attr("snatch_strech");
                if (strech == undefined) {
                    strech = 0;
                }
                element['strech'] = strech;

                //var pageGroupId = uiData["slidegrid_" + self.procID].getGroupId();
                /*
                for (var i = 0; i < uiData[this.procID].length; i++) {
                    if(uiData[this.procID][i].id==pageGroupId)
                    {
                        pageGroupId = i;
                        break;
                    }
                };
                */
                element['tab'] = active_id;


                if (snatch_id == "-1") {
                    snatch_id = $(this).attr("id");
                }
                initialButtons[snatch_id] = element;
            });
            if (active_id != activeID) {
                $("#" + this.procID + "_" + active_id + "_page0").hide();
            }
        }


    }


    this.createVisualElement = function(left, top) {
        //must be set:
        this.setActiveID(activeID);

        var snatch_grid_x = this.maxButtonX;
        var snatch_grid_y = this.maxButtonY;

        var width = this.j_pages[0].getBoundingClientRect().width / this.maxButtonX;
        var height = this.j_pages[0].getBoundingClientRect().height / this.maxButtonY;

        var recti = {
            'top': top,
            'left': left,
            'width': width,
            'height': height
        };
        var rect = bofficeScreen.snapToGrid(recti);



        var bId = -1;
        var classObj = "cSlideGrid_Button draggable btn btn-lg btn-default visEl";
        var parent = this.j_procID;
        var bIcon = "";
        var bColor = "";
        var _height = rect.height + "px"; //safe in admin mode
        var _width = rect.width + "px";
        var _left = rect.left + "px";
        var _top = rect.top + "px";
        var bText = "Novo";

        var ccss = "";



        var visNumber = parent.find("a[id^=vis_]").length + 1;

        bText += " " + visNumber;
        var btnId = "vis_" + activeID + "_" + visNumber;

        this.j_current_page.append("<a role=\"button\" id=\"" + btnId +
            "\" snatch_id=" + bId + " snatch_image=\"" + bIcon + "\" snatch_color=\"" + bColor + "\" style=\"" +
            "height:" + _height + "" + ";width:" + _width + "" + ";left:" + _left + "" + ";top:" + _top + ";" + ccss +
            "\" class=\"hover " + classObj + "\"><span>" + bText + "</span></a>");


        bofficeWidgetsMenu.bindContextMenu($("#" + btnId));

    }
    this.createSlideGridButtonAux = function(createButton) {
        var found = false;

        //check if all buttons are drawn
        var pageButtons = data_order[activeID]["order"];
        for (var i = 0; i < pageButtons.length; i++) {
            var snatch = pageButtons[i];
            if ($("#" + this.procID + "Pages > div > a[snatch_id=" + snatch + "]").length == 0) {
                found = true;
                if (createButton) {
                    initialButtons[snatch] = {};

                    this.createSlideGridButtons(lastMouseclick.left, lastMouseclick.top, activeID, snatch, true);
                    $(".draggable").draggable(bofficeScreen.enableDrag());
                    $(".draggable").draggable(bofficeScreen.enableDrag());
                    break;
                }
            }

        };

        return found;
    }

    this.addInitialButtons = function(cButtonArray) {
        var counter = 1;
        for (var i = 0; i < cButtonArray.length; i++) {
            if (initialButtons == undefined) {
                initialButtons = {};
            }
            var element = {};


            //var rect = bofficeScreen.fromSnatchCoords(cButtonArray[i].arguments[2].y, cButtonArray[i].arguments[1].x,
            //    cButtonArray[i].arguments[3].w, cButtonArray[i].arguments[4].h);


            element['left'] = cButtonArray[i].arguments[1].x;
            element['top'] = cButtonArray[i].arguments[2].y;
            element['width'] = cButtonArray[i].arguments[3].w;
            element['height'] = cButtonArray[i].arguments[4].h;


            element['label'] = cButtonArray[i].arguments[6].label;
            element['bColor'] = cButtonArray[i].arguments[8].bcolor;
            element['bIcon'] = cButtonArray[i].arguments[9].bicon;
            element['parent'] = cButtonArray[i].arguments[13].parent;
            element['tab'] = cButtonArray[i].arguments[12].tab;
            if (cButtonArray[i].arguments[14] != undefined) {
                element['strech'] = cButtonArray[i].arguments[14].strech;
            } else {
                element['strech'] = 0;
            }

            if (element['tab'] == undefined) {
                console.log("WARNING - Invalid tab!");
                element['tab'] = 1;
            }

            var key = cButtonArray[i].arguments[0].value;
            if (cButtonArray[i].arguments[0].value == -1) {
                key = "vis_" + counter;
                counter += 1;
            }
            initialButtons[key] = element;

        }
    }

    this.generatecSlideGridButtonsJson = function() {
        //append custombuttons:
        var parent = this.j_procID;

        //get current buttons first

        //parent.find("a.cSlideGrid_Button").each(function()
        var screenTmp = ",";

        for (var i = 0; i < Object.keys(initialButtons).length; i++) {
            var key = Object.keys(initialButtons)[i];
            var element = initialButtons[key];
            if (true) { //element != undefined


                var jsonid = Math.floor((Math.random() * 10000) + 1);
                screenTmp += ("{\"id\":\"" + jsonid + "\"," + "\"windowid\":\"" + this.window + "\"," + "\"type\":\"com.sage.components.CSlides.Button\",\n\"arguments\": [");

                //var rect = bofficeScreen.toSnatchCoords(element.top,element.left,element.width,element.height);

                screenTmp += "{\"value\":\"" + key + "\"},";
                screenTmp += "{\"x\":" + element.left + "},";
                screenTmp += "{\"y\":" + element.top + "},";
                screenTmp += "{\"w\":" + element.width + "},";
                screenTmp += "{\"h\":" + element.height + "},";

                var image = element.bIcon;
                if (image === undefined) {
                    image = "";
                } else if (image === "none") {
                    image = "";
                }
                if (image === "") {
                    if (this.default_image !== undefined) {
                        if (this.default_image !== "") {
                            image = this.default_image;
                        }
                    }
                }

                screenTmp += "{\"btype\":\"CButton\"},";
                screenTmp += "{\"label\":\"" + element.label + "\"},";
                screenTmp += "{\"down\":0},"; //?!
                screenTmp += "{\"bcolor\":\"" + element.bColor + "\"},";
                screenTmp += "{\"bicon\":\"" + image + "\"},";
                screenTmp += "{\"skin\":51},";
                screenTmp += "{\"referal\":-1},";
                screenTmp += "{\"tab\":" + element.tab + "},";

                screenTmp += "{\"parent\":" + parent.attr("snatch_id") + "}";
                var strech = 0;
                if (element.strech != undefined) {
                    strech = element.strech;
                }
                screenTmp += ",{\"strech\":" + strech + "}";
                screenTmp += "]},\n";
            }
        };


        return screenTmp.substring(0, screenTmp.length - 1);
    }

    this.updateUiData = function(id, elem, change) {
        var currentItem = data[activeID][change.id];
        if (change.v == "") //remove
        {
            //if (bofficeGlobals.DEBUG)
            console.log("boing");
            var targetButton = this.j_pages.find("a[snatch_id=" + change.id + "]");
            if (targetButton !== undefined) {

            }
            delete data[activeID][change.id];
            if (initialButtons != undefined) {
                if (initialButtons[change.id] != undefined) {
                    delete initialButtons[change.id];
                }
            }
        } else //update
        {
            //just update
            var targetButton = this.j_pages.find("a[snatch_id=" + change.id + "] > span");
            if (targetButton !== undefined) {
                $(targetButton).html(change.v);
                var bColor = GetHtmlColor(change.color);
                $(targetButton).css("color", "#" + bColor)
            }
            data[activeID][change.id] = change;
            if (initialButtons != undefined) {
                if (initialButtons[change.id] != undefined) {
                    initialButtons[change.id].label = change.v;
                    initialButtons[change.id].bColor = change.color;
                }
            }

        }



    }
    this.handleCache = function(content) {
        if (content.keys["slidegrid_" + this.procID] != undefined) {
            this.j_parent = $(content.keys["slidegrid_" + this.procID].j_parent);
            this.j_procID = $(content.keys["slidegrid_" + this.procID].j_procID);

            this.j_pages = $(content.keys["slidegrid_" + this.procID].j_pages);
            if (content.keys["slidegrid_" + this.procID].j_current_page != undefined) {
                this.j_current_page = $(content.keys["slidegrid_" + this.procID].j_current_page);
            }

        } else {
            //manual bind
            this.j_procID = $("#" + this.procID);
            this.j_parent = this.j_procID.parent();
            this.j_pages = $("#" + this.procID + "Pages");

        }
    }



});
/** STATIC  ***/
SnatchSlideGrid.drawVisualElement = function(parent, data) {
    parent = $("#" + parent);
    var visNumber = parent.find("a[id^=vis_]").length + 1;
    var bId = -1;
    var bIcon = data.bIcon;
    var bColor = data.bColor;
    var bText = data.label;
    var bTab = data.tab;
    var strech = data.strech;

    var classObj = "cSlideGrid_Button draggable btn btn-lg btn-default visEl";
    var ccss = "";

    //sanity check
    if (data.width < 2) {
        data.width = 4;
    }
    if (data.height < 2) {
        data.height = 4;
    }

    var rect = bofficeScreen.fromSnatchCoords(data.top, data.left, data.width, data.height);

    var mainID = "vis_" + bTab + "_" + visNumber;

    parent.append("<a role=\"button\" id=\"" + mainID +
        "\" snatch_id=" + bId + " snatch_image=\"" + bIcon + "\" snatch_color=\"" + bColor + "\" style=\"" +
        "height:" + rect.height + "" + ";width:" + rect.width + "" + ";left:" + rect.left + "" + ";top:" + rect.top + ";" + ccss +
        "\" class=\"hover " + classObj + "\"><span>" + bText + "</span></a>");

    if (bIcon !== "") {
        parent.find("a#" + mainID).css("background-image", "url(" + imagesPath + bIcon + ")");
        parent.find("a#" + mainID).attr("snatch_image", bIcon);
    } else {
        parent.find("a#" + mainID).addClass("no_image_" + this.procID);
        parent.find("a#" + mainID).attr("snatch_image", "");
    }
    if (strech == 1) {
        parent.find("a#" + mainID).addClass("imgStrech");
        parent.find("a#" + mainID).attr("snatch_strech", "1");
    } else {
        parent.find("a#" + mainID).css("background-size", "inherit inherit)");
        parent.find("a#" + mainID).removeClass("imgStrech");
    }

    parent.find("a#" + mainID).on("click", function() {
        $(this).effect("shake");
    });
}

SnatchSlideGrid.editSlideGridButtonForm = function(objID) {
    var _objID = objID;

    var dialog, form;
    var _table = $("#" + _objID);
    var table_id = _table[0].getAttribute("snatch_id");

    function saveTable() {

        var slideID = $("#uidata").val();
        var newSnatch = $("#dropButtonSID").val();
        var newLabel = $("#dropButtonSID option:selected").text();
        var newImage = $("#tableIcon").val();
        var imgElement = $("#imgElement").is(":checked")

        var btnID = slideID + "_" + newSnatch;
        var old_btnID = $("#btnID").val();
        var snatch_idx = uiData["slidegrid_" + slideID].getActiveId();
        var parent = $("#" + slideID + "_" + old_btnID + "_" + snatch_idx);

        if (_table.attr("snatch_id") != -1) { //normal button

            parent.attr("snatch_id", newSnatch);

            parent.attr("snatch_image", "");
            if (newImage != "") {
                parent.find("div").css("background-image", "url(" + imagesPath + newImage + ")");
                parent.attr("snatch_image", newImage);
            } else {
                parent.find("div").css("background-image", "none");
                /*
                if (uiData[slideID][0].d[snatch_idx].icon == undefined) {
                    parent.css("background-image", "none");
                } else {
                    newImage = uiData[slideID][0].d[old_btnID].icon;
                    parent.css("background-image", "url(" + imagesPath + newImage + ")");
                    //parent.attr("snatch_image", newImage);
                }
                */
            }

            parent.find("span").html(newLabel);

            var btn = uiData["slidegrid_" + slideID].getInitialButtons()[old_btnID];
            delete uiData["slidegrid_" + slideID].deleteInitialButton(old_btnID);
        } else {
            newLabel = $("#btnlabel").val();
            parent = _table.parent().find("#" + _table.attr("id"));
            parent.children().first().html(newLabel);

            if (newImage != "") {
                parent.css("background-image", "url(" + imagesPath + newImage + ")");
                parent.attr("snatch_image", newImage);

            } else {
                parent.css("background-image", "none");
                parent.attr("snatch_image", "");
            }


        }
        if (imgElement) {
            parent.addClass("imgStrech");
            parent.attr("snatch_strech", "1");
        } else {
            parent.removeClass("imgStrech");
            parent.attr("snatch_strech", "0");
        }

        /*
        uiData[slideID + "_initialButtons"][newSnatch] = btn;

        uiData[slideID + "_initialButtons"][newSnatch].label = newLabel;
        uiData[slideID + "_initialButtons"][newSnatch].bIcon = newImage;
        */



        dialog.dialog("close");
        return true;
    }
    var self = this;
    dialog = $("#editTableForm").dialog({
        autoOpen: false,
        //height: 500,
        width: 350,
        modal: true,
        buttons: {
            "OK": saveTable,
            "Cancelar": function() {
                dialog.dialog("close");
            }
        },
        open: function() {

            //var _obj = document.getElementById("w" + windowID);

            var parent = $(_table);
            var snatch_id = parent.attr("snatch_id");
            var slideID = parent.parent().parent().parent().attr("id");
            //var snatch_pagegroupid = parent.parent().parent().parent().find(".SlideGrid_Navigator").attr("snatch_pagegroupid");
            //var snatch_idx = parent.parent().parent().parent().find(".SlideGrid_Navigator").attr("snatch_idx");

            $("#uidata").val(slideID);
            $("#btnID").val(snatch_id);
            var imgElement = 0;

            if (parent.hasClass("imgStrech")) {
                imgElement = 1;
            }



            if (snatch_id != -1) { //a normal button
                $("#staticElement").show();
                $("#btnlbl").hide();
                var _drop = $("#dropButtonSID");

                _drop.html('');
                var activeID = uiData["slidegrid_" + slideID].getActiveId();
                for (var i = 0; i < uiData["slidegrid_" + slideID].getDataOrder()[activeID]["order"].length; i++) {
                    var key = uiData["slidegrid_" + slideID].getDataOrder()[activeID]["order"][i];
                    if ((parent.parent().children("[snatch_id=" + uiData["slidegrid_" + slideID].getData()[activeID][key].id + "]").length == 0) || (snatch_id == uiData["slidegrid_" + slideID].getData()[activeID][key].id)) {
                        addOption(_drop[0], uiData["slidegrid_" + slideID].getData()[activeID][key].id, uiData["slidegrid_" + slideID].getData()[activeID][key].v);
                    }
                };

                if ($("#dropButtonSID option").length > 0) {

                    $('#dropButtonSID option[value=' + snatch_id + ']').prop('selected', true);


                    var skillsSelect = document.getElementById("dropButtonSID");
                    var selectedText = skillsSelect.options[skillsSelect.selectedIndex].value;

                    $("#dropButtonSID").click(function() {
                        var skillsSelect = document.getElementById("dropButtonSID");
                        var selectedText = skillsSelect.options[skillsSelect.selectedIndex].value;
                        $("#tableName").val(selectedText);

                        if (initialButtons[selectedText] != undefined) {
                            $("#tableIcon").val(initialButtons[selectedText].bIcon); //even if no image
                        } else {
                            $("#tableIcon").val(""); //even if no image
                        }

                    })

                    //$("#tableName").val(_table[0].getAttribute("snatch_id"));
                    if (uiData["slidegrid_" + slideID].getInitialButtons()[selectedText] != undefined) {
                        $("#tableIcon").val(uiData["slidegrid_" + slideID].getInitialButtons()[table_id].bIcon);
                    } else {
                        $("#tableIcon").val("");
                    }

                }
            } else {
                $("#staticElement").hide();
                $("#btnlbl").show();
                $("#btnlabel").val(parent.children().first().text());



            }
            $("#tableIcon").val(parent.attr("snatch_image"));
            if (imgElement == 1) {
                $("#imgElement").prop('checked', true);
            } else {
                $("#imgElement").prop('checked', false);
            }
        },

        close: function() {
            form[0].reset();
        }
    });
    form = dialog.find("form").on("submit", function(event) {
        event.preventDefault();
        saveTable();
    });
    dialog.dialog("open");



}