"use strict";
var SnatchTextBox = SnatchBase.extend(function() {


    this.constructor = function(windowid, _id, json_id, rect, wtype, _arguments) {

        this.super(rect.left, rect.top, rect.width, rect.height, windowid, _id, json_id, rect, wtype);

        this.label = "";
        this.editable = 1;
        /* TYPE
        #define TB_TYPE_TEXT    0
        #define TB_TYPE_NUM     1
        #define TB_TYPE_DECIMAL 2
        #define TB_TYPE_TEXT20  3
        #define TB_TYPE_TEXT40  4
        #define TB_TYPE_TEXT250 5
        #define TB_TYPE_CURRENCY 6
        #define TB_TYPE_WEIGHT  7
        #define TB_TYPE_PASS    8
        #define TB_TYPE_DATE    9
        #define TB_TYPE_TIME    10
        #define TB_TYPE_PASSALPHA    11
        #define TB_TYPE_FILE    50
        #define TB_TYPE_DIR    51
        */

        this.type = 0;
        this.length = 0;
        this.fontsize = defaultFontSize;
        this.multiline = 0;
        this.skin = -1;
        this.tab = -1;

        //private
        this.inputType = "text";
        this.htmlInputType = "text"; //to be used directly in <input>
        if (_arguments!==undefined)
        {
            this.setArguments(_arguments);
        }

        isSearchInput = bofficeGlobals.searchBoxes_input.indexOf(this.procID);

        this.j_text = undefined;
        this.j_caption = undefined;


    }
    var isSearchInput = -1;
    var lastFormattedValue = "";

    var tabArray = [];
    this.getTabArray = function() {
        return tabArray;
    }
    this.putTab = function(val) {
        if (tabArray.indexOf(val) < 0) {
            tabArray.push(val);

        }
    }
    this.setParams = function() {
        this.params = {
            j_parent: this.j_parent.selector,
            j_procID: this.j_procID.selector,

            
            j_caption: this.j_caption.selector
        };
        /* might not have a textbox! */
        if (this.j_text!==undefined)
        {
            this.params.j_text = this.j_text.selector;
        }
    }
    this.setArguments = function(args) {
        if (args[5] !== undefined)
            this.label = args[5].value;
        if (args[6] !== undefined)
            this.editable = args[6].value;
        if (args[7] !== undefined) {
            this.type = args[7].value;

            if (this.type == 0) this.inputType = "text";
            else if (this.type == 1) {
                this.inputType = "num";
                this.htmlInputType = "text"; //number
            } else if (this.type == 2) {
                this.inputType = "decimal";
                this.htmlInputType = "text"; //number
            } else if (this.type == 3) this.inputType = "text20";
            else if (this.type == 4) this.inputType = "text40";
            else if (this.type == 5) this.inputType = "text250";
            else if (this.type == 6) {
                this.inputType = "currency";
                this.htmlInputType = "text"; //number has "eur" prexix
            } else if (this.type == 7) {
                this.inputType = "weigth"
                this.htmlInputType = "text"; //number
            } else if (this.type == 8) {
                this.inputType = "pass"
                this.htmlInputType = "password";
            } else if (this.type == 9) {
                this.inputType = "date";
                this.htmlInputType = "text"; //date
            } else if (this.type == 10) {
                this.inputType = "time";
                this.htmlInputType = "text"; //time
            } else if (this.type == 11) {
                this.inputType = "passalpha"
                this.htmlInputType = "password";
            } else if (this.type == 50) {
                this.inputType = "file"
                this.htmlInputType = "text";
            } else if (this.type == 51) {
                this.inputType = "dir"
                this.htmlInputType = "text";
            }

        }
        if (args[8] !== undefined)
            this.length = args[8].value;
        if (args[9] !== undefined)
            this.fontsize = args[9].value;
        if (args[10] !== undefined)
            this.multiline = args[10].value;

        if (args[11] !== undefined)
            this.skin = args[11].value;
        if (args[12] !== undefined) {
            this.tab = args[12].value;
            tabArray.push(this.tab);
        }
    }
    this.setTextBoxAttributes = function(_caption, _function) {

        $("#" + this.procID + " > .wcont > .caption").html(_caption);
        this.label = _caption;

        //change id
        if (_function.length > 0 && _function != "-1" && this.j_procID.attr("snatch_id") != _function) {

            var newID = windowID + "_" + _function;

            uiData[this.uiKey + newID] = uiData[this.uiKey + this.procID];
            delete(uiData[this.uiKey + this.procID]);

            this.j_procID.attr("id", newID);
            this.id = _function;
            this.procID = this.windowid + "_" + newID;


            $("#" + newID + " > .wcont > .caption").attr("id", newID + "Caption");
            $("#" + newID + " > .wcont > .field > input").attr("id", newID + "Text");
            $("#" + newID + " > .wcont > .field > input").attr("snatch_id", _function);

            //bofficeWidgetsMenu.bindContextMenu($("#" + newID), "textBoxMenu");
            return newID;
        }
    }
    this.createTextBox = function() {
        var self = this;
        //verifica se o object já foi adicionado.
        

        this.j_parent.append("<div st=\"textbox_" + this.procID + "\"  id=\"" + this.procID + "\" class=\"TextBox TB" +
            this.procID + " FieldBox draggable skin_" + this.skin + " fz_" + this.fontsize + "\"></div>");
        //rect
        this.super.setRect();


        this.j_procID.append("<div class=\"wcont\"></div>");

        $("#" + this.procID + " > div.wcont").append("<div id=\"" + this.procID + "Caption" +
            "\" class=\"caption skin_" + this.skin + "\">" + this.label + "</div>");

        this.j_caption = $("#" + this.procID + "Caption");

        $("#" + this.procID + " > div.wcont").append("<div class=\"field in_" + this.inputType + "\"></div>");

        if ((this.label == "") || ((this.label == " "))) { //leprechauns!!
            this.j_procID.addClass("noLabel");
            this.label = "";
        }

        this.setTextBoxAttributes(this.label, this.id);
        var readOnly = "";
        //is not just a label:
        if ($.inArray(this.procID, bofficeGlobals.labelFields) < 0) {
            if (this.multiline == 1) { //textarea
                $("#" + this.procID + " > div.wcont > div.field").append("<textarea id=\"" + this.procID + "Text" +
                    "\" snatch_id=\"" + this.id +
                    "\" class=\"clickable TextBox_Text Text_Area\"" + readOnly + "></textarea>");
                this.j_text = $("#" + this.procID + "Text");
                if (this.editable == 1) {
                    this.j_text.keyboard($.extend(bofficeGlobals.quertyKeyboard, bofficeGlobals.KeyboardConfig));
                }

                this.j_procID.addClass("textarea");

            } else {
                //textbox
                $("#" + this.procID + " > div.wcont > div.field").append("<input type=\"" + this.htmlInputType + "\" id=\"" + this.procID + "Text" + "\" " +
                    "snatch_id=\"" + this.id + "\"" +
                    " class=\"clickable TextBox_Text tb" + this.type + "\"" + readOnly + "></input>");
                this.j_text = $("#" + this.procID + "Text");

                if ((this.skin == 0) && this.label == "") {
                    this.j_text.attr("placeholder", "Procurar");
                    this.editable = 1; //HACK!!! 
                }

                if (this.inputType == "date") {
                    this.j_text.datetimepicker(bofficeGlobals.dateField);
                } else if (this.inputType == "time") {
                    this.j_text.datetimepicker(bofficeGlobals.timeField);
                } else if ((this.editable == 1) && ((this.type == 0) || ((this.type >= 3) && (this.type <= 5)) || (this.type == 11))) { //text
                    this.j_text.keyboard($.extend(bofficeGlobals.quertyKeyboard, bofficeGlobals.KeyboardConfig));

                } else if ((this.editable == 1) && ((this.type == 2) || (this.type == 6) || (this.type == 7) || (this.type == 8))) {
                    this.j_text.keyboard($.extend(bofficeGlobals.decimalKeyboard, bofficeGlobals.KeyboardConfig));

                } else if ((this.editable == 1) && (this.type == 1)) {
                    this.j_text.keyboard($.extend(bofficeGlobals.numericKeyboard, bofficeGlobals.KeyboardConfig));

                } else if (this.inputType == 'file') {
                    //this.j_caption.append("<i class='fa fa-plus'></i>");
                    this.j_text.prop('readonly', true);
                } else if (this.inputType == 'dir') {
                    this.j_caption.append("<i class='fa fa-folder'></i>");
                }

            }
        }
        if (bofficeGlobals.DEBUG) {
            this.j_caption.append("<span class=\"debugInfo\">" +
                this.procID + "_ " + this.type + " - " + this.inputType + ": " + this.skin + "</span>");
        }

        if (this.tab > 0)
            this.j_procID.hide();



        /*
        if (uiData[this.uiKey + this.procID] === undefined) {
            uiData[this.uiKey + this.procID] = this;
        }*/
        //reset lastFormattedValue
        lastFormattedValue = "";
        if ($.inArray(this.procID, bofficeGlobals.labelFields) < 0) {
            if ((this.skin != 0) && (this.label != "")) {
                if (this.editable == 0) {
                    this.j_text.attr('disabled', 'disabled');
                } else {
                    this.j_text.removeAttr('disabled');
                }
            }
            //override:
            if ($.inArray(this.procID, bofficeGlobals.forceReadOnlyFields) >= 0) {
                this.j_text.attr('disabled', 'disabled');
                this.j_text.removeClass("ui-keyboard-input");
            }
        }
    }
    this.bindClicks = function() {
        if ($.inArray(this.procID, bofficeGlobals.labelFields) >= 0) {
            return;
        }
        var self = this;
        this.j_text.on('change', function(e) {
            e.stopPropagation();
            self.ProcessClick(this, self);
        });
        if (isMobile) {
            this.j_text.on('focus click tap vclick', function(event) {

                this.blur();
            });
        }


        if (this.multiline == 1) {
            if (this.editable == 1) {
                this.j_text.keyboard($.extend(bofficeGlobals.quertyKeyboard, bofficeGlobals.KeyboardConfig));
            }
        }
        if (this.multiline == 0) {
            if ((this.skin == 0) && this.label == "") {
                this.j_text.attr("placeholder", "Procurar");
                this.editable = 1; //HACK!!! 
            }

            if (this.inputType == "time") {
                this.j_text.datetimepicker(bofficeGlobals.timeField);
            } else if ((this.editable == 1) && ((this.type == 0) || ((this.type >= 3) && (this.type <= 5)) || (this.type == 11))) { //text
                this.j_text.keyboard($.extend(bofficeGlobals.quertyKeyboard, bofficeGlobals.KeyboardConfig));

            } else if ((this.editable == 1) && ((this.type == 2) || (this.type == 6) || (this.type == 7) || (this.type == 8))) {
                this.j_text.keyboard($.extend(bofficeGlobals.decimalKeyboard, bofficeGlobals.KeyboardConfig));

            } else if ((this.editable == 1) && (this.type == 1)) {
                this.j_text.keyboard($.extend(bofficeGlobals.numericKeyboard, bofficeGlobals.KeyboardConfig));

            }

            if (this.inputType == 'file') {
                boffice.globalClick(this.j_text,
                    function() {
                        bofficeWidgetsForms.showSelectImageForm(self.procID + "Text", '0');
                    }
                );
            } else if (this.inputType == 'dir') {
                boffice.globalClick($("#" + this.procID + "Caption > i.fa"),
                    function() {
                        bofficeWidgetsForms.showSelectFolderForm(self.procID + "Text", '0'); /* TODO */
                    }
                );
            }
            if (this.editable) {
                if (isMobile) {
                    /*this.j_text.attr('disabled', 'disabled');
                    this.j_text.prop('disabled', 'disabled');
                    this.j_text.attr('readonly', 'readonly');
                    this.j_text.prop('readonly', 'readonly');*/
                    this.j_text.blur(function() {
                        $(this).prop('readonly', false);
                    });

                }
            }
        }


    }
    this.ProcessClick = function(objToHandle, parent) {
        var elem = this.j_procID;


        var formattedValue = this.ResetTextValue();
        /*
                if (formattedValue.length == 0) {
                    lastFormattedValue = "";
                    return;
                }
                */

        formattedValue = encodeURI(formattedValue);

        if ((this.skin == 0) && this.label == "") {
            //get a lisbox on same tab
            var target_listbox = this.j_procID.parent().find(".ListBox");

            if (target_listbox.length == 0) {
                target_listbox = this.j_procID.parent().find(".ListBox[snatch_tab=-1]");
            }
            if (target_listbox.length > 1) {
                console.log("WARNING: got two listboxes!");
            }
            uiData["listbox_" + target_listbox.attr("id")].searchOnListbox(formattedValue);
            $("#" + this.procID + " >div> div>input").val("");
        } else {
            if (formattedValue === lastFormattedValue) {
                return; //don't send dups
            }
            var urlCmd = "callback&windowID=" + windowID + "&objectID=" + parent.id + "&value=" + formattedValue;
            boffice.send_url(urlCmd);
        }
        lastFormattedValue = formattedValue;
    }

    this.ResetTextValue = function() {

        var elem = this.j_text;
        var ret_value;
        var value = elem.val();
        value.replace(",", ".");
        var snatchType = this.type;

        if ((snatchType == 1) || (snatchType == 2)) {
            ret_value = Number(value).toFixed(0);

        } else if (snatchType == 6) {
            value = value.replace(bofficeGlobals.currencySymbol, "").replace(" ", "");
            ret_value = Number(value * Math.pow(10, dec_geral)).toFixed(0);

        } else if (snatchType == 7) {
            ret_value = Number(value * Math.pow(10, dec_geral_weight)).toFixed(0);
        } else if (this.inputType == "date") //date field
        {
            var parts = value.split("/"); // dd/mm/YYYY
            ret_value = parts[0] + "-" + parts[1] + "-" + parts[2];
        } else if (this.inputType == "time") //time field
        {
            if (value.split(":").length == 2) {
                //append seconds
                value += ":00";
                ret_value = value;
            }

        } else {
            ret_value = value;
        }


        return ret_value;
    }
    this.editTextBoxForm = function() {
        var self = this;
        var _objID = this.procID;
        var dialog, form;
        var _obj = $("#" + _objID);

        function saveTable() {

            var valid = true;
            var _function = $("#dropTextBoxFunction").val();
            var _caption = $("#textBoxCaption").val();
            var _fontSize = $("#textBoxFontSize").val();

            if (_function == undefined || _function == null || _function == "null") _function = "";

            //so se existiu uma alteração
            if ($("#" + _objID).attr("snatch_id") != _function) {
                if (!validaNewFunction(windowID, _function)) {
                    alert("Esta função já está atribuída.");
                    valid = false;
                }
            }

            if (valid) {
                var newID =uiData["textbox_" + _objID].setTextBoxAttributes(_caption, _function);
                if (newID == undefined)
                {
                    newID = _objID;
                }
                bofficeWidgetsMenu.bindContextMenu($("#"+newID), "textBoxMenu");
                uiData["textbox_"+newID].procID = newID;
                uiData["textbox_"+newID].function = _function;
                $("#" + newID).attr("snatch_id",_function);
                dialog.dialog("close");
            }

            return valid;

        }

        dialog = $("#editTextBoxForm").dialog({
            autoOpen: false,
            //height: 400,
            width: 350,
            modal: true,
            title: 'Editar Caixa de Texto',
            buttons: {
                "OK": saveTable,
                "Cancelar": function() {
                    dialog.dialog("close");
                }
            },
            open: function() {
                $("#fx").hide();
                var _functions = SnatchTextBox.getTextBoxFunctions(windowID, 1);

                if (_functions.length > 1) {
                    $("#fx").show();
                }

                var _drop = $("#dropTextBoxFunction");
                var _drop_text = $("#dropTextBoxFunction");

                if (_functions.length > 1) {
                    _drop.show();
                    _drop_text.show();
                    _drop.html('');

                    for (var j = 0; j < _functions.length; j++) {
                        addOption(_drop[0], _functions[j].id, _functions[j].v);
                    }
                } else {
                    _drop.hide();
                    _drop_text.hide();
                }

                var bFunction = _obj[0].getAttribute("snatch_id");

                $("#dropTextBoxFunction").val(bFunction);
                var snatch_id = $(_obj[0]).attr("id");
                $("#textBoxCaption").val(uiData["textbox_" + snatch_id].label);
                $("#textBoxFontSize").val(uiData["textbox_" + snatch_id].fontsize);

                $("#dropTextBoxFunction").change(function() {
                    $("#textBoxCaption").val($("#dropTextBoxFunction option:selected").text());
                })

            },

            close: function() {
                form[0].reset();
            }
        });
        form = dialog.find("form").on("submit", function(event) {
            event.preventDefault();
            //saveTable();
        });
        dialog.dialog("open");
    }

    this.MaskDecimalsValue = function(_value, _numDecimais) {
        var ret = _value;
        if (_numDecimais > 0) {
            ret = (Number(_value) / Math.pow(10, _numDecimais)).toFixed(_numDecimais)
        }
        return ret;
    }


    this.updateTextBox = function(value) {
        var elem = this.j_text; //input or textarea
        if (value == " ")
            value = "";
        if (elem.length > 0) {


            var snatchType = this.type;
            if (value.length == 0) {
                $(elem).val("");
            } else if (snatchType == 2) {
                $(elem).val(Number(value).toFixed(0));

            } else if (snatchType == 6) {
                var currency = bofficeGlobals.currencySymbol + " " + SnatchTextBox.MaskDecimalsValue(value, dec_geral);
                $(elem).val(currency);

            } else if (snatchType == 7) {
                $(elem).val(SnatchTextBox.MaskDecimalsValue(value, dec_geral_weight));

            } else if (snatchType == 9) { //date
                var array = value.split('-');
                if (array.length >= 3) {
                    $(elem).val(SnatchTextBox.getFormattedDate(value));
                }

            } else if (snatchType == 10) { //time
                var array = value.split(':');
                if (array.length >= 3) {
                    $(elem).val(SnatchTextBox.getFormattedTime(value));
                }
            } else { //default is text
                $(elem).val(value);
            }
            lastFormattedValue = "__assd__a";

            if ((this.skin != 0) && (this.label != "")) {
                if (this.editable == 0) {
                    this.j_text.attr('disabled', 'disabled');
                } else {
                    this.j_text.removeAttr('disabled');
                }
            }
            //override:
            if ($.inArray(this.procID, bofficeGlobals.forceReadOnlyFields) >= 0) {
                this.j_text.attr('disabled', 'disabled');
                this.j_text.removeClass("ui-keyboard-input");
            }

        }


        //searchbox switcharoo
        if (isSearchInput >= 0) {

            var current_tab = uiData["window_" + windowID].getPanel();

            var show = false;

            if (this.tab == -1)
                show = true;
            else if (current_tab == undefined) { //has no panel
                show = true;
            } else {
                current_tab = uiData["panel_" + current_tab].getCurrentPage();
                if (current_tab == undefined) { //panel has no current tab ?!
                    show = true;
                } else if (this.tab == current_tab - 1) {
                    show = true;
                }
            }

            if (show) {
                this.j_procID.show();
                $("#" + bofficeGlobals.searchBoxes_select[isSearchInput]).hide();
            }


        }

        /* 

        if (elem[0].id == "11_60") {
            $("#11_60")[0].style.display = "inline";
            $("#11_10")[0].style.display = "none";

        } else if (elem[0].id == "123_35") {

            //apenas se o navigator estiver n tab 2
            if ($("#123_301Navigator")[0].getAttribute("snatch_current_page") == "2") {
                $("#123_37")[0].style.display = "show";
                $("#123_35")[0].style.display = "show";

            } else if ($("#123_301Navigator")[0].getAttribute("snatch_current_page") == "1") {
                $("#123_37")[0].style.display = "none";
                $("#123_35")[0].style.display = "none";
            }

        } else if (elem[0].id == "145_13") {
            $("#145_13")[0].style.display = "inline";
            $("#145_14")[0].style.display = "none";

        } else if (elem[0].id == "156_1") {
            $("#156_1")[0].style.display = "inline";
            $("#156_4")[0].style.display = "none";
        } else if (elem[0].id == "13_60") {
            $("#13_60")[0].style.display = "inline";
            $("#13_10")[0].style.display = "none";
        } else if (elem[0].id == "175_1") {
            $("#175_1")[0].style.display = "inline";
            $("#175_4")[0].style.display = "none";
        } else if (elem[0].id == "163_1") {
            $("#163_1")[0].style.display = "inline";
            $("#163_2")[0].style.display = "none";
        } else if (elem[0].id == "109_9") {
            $("#109_9")[0].style.display = "inline";
            $("#109_10")[0].style.display = "none";
        }
        */
    }

    this.handleCache = function(content) {
        if (content.keys["textbox_" + this.procID] !== undefined) {
            this.j_parent = $(content.keys["textbox_" + this.procID].j_parent);
            this.j_procID = $(content.keys["textbox_" + this.procID].j_procID);
            this.j_text = $(content.keys["textbox_" + this.procID].j_text);
            this.j_caption = $(content.keys["textbox_" + this.procID].j_caption);
        } else {
            this.j_procID = $("#" + this.procID);
            this.j_parent = this.j_procID.parent();
            this.j_text = $("#" + this.procID + "Text");
            this.j_caption = $("#" + this.procID + "Caption");
        }

    }


});

SnatchTextBox.MaskDecimalsValue = function(_value, _numDecimais) {
    var ret = _value;
    if (_numDecimais > 0) {
        ret = (Number(_value) / Math.pow(10, _numDecimais)).toFixed(_numDecimais)
    }
    return ret;
}
SnatchTextBox.getFormattedDate = function(value) {

    var array = value.split("-");

    var day, month, year;

    if (array[0].length == 4) {
        year = array[0];
        month = SnatchTextBox.getPadding(array[1], 2);
        day = SnatchTextBox.getPadding(array[2], 2);

    } else {
        day = SnatchTextBox.getPadding(array[0], 2);
        month = SnatchTextBox.getPadding(array[1], 2);
        year = array[2];
    }

    //return year + "-" + month + "-" + day;
    return day + "/" + month + "/" + year;
}
SnatchTextBox.getFormattedTime = function(value) {

    var array = value.split(":");
    var hour, min, sec;

    hour = SnatchTextBox.getPadding(array[0], 2);
    min = SnatchTextBox.getPadding(array[1], 2);
    sec = SnatchTextBox.getPadding(array[2], 2);

    return hour + ":" + min;
}

SnatchTextBox.getPadding = function(_val, _numberZeros) {
    var calc = Math.pow(10, _numberZeros);
    return String((calc + Number(_val))).substring(1, _numberZeros + 2);
}

SnatchTextBox.getTextBoxFunctions = function(_windowID, addEmpty) {

    var ret = [];

    if (addEmpty) {
        ret.push({
            "id": "-1",
            "v": ""
        });
    }

    if (_windowID == 4) {

        ret.push({
            "id": "2",
            "v": "Quantidade"
        });
        ret.push({
            "id": "12",
            "v": "Número de Mesa"
        });
        ret.push({
            "id": "13",
            "v": "Número Lugares"
        });
        ret.push({
            "id": "15",
            "v": "Edição Total"
        });
        ret.push({
            "id": "64",
            "v": "Pesquisa Artigo"
        });
        ret.push({
            "id": "65",
            "v": "Filtro Artigo por Família"
        });
        ret.push({
            "id": "66",
            "v": "Filtro Artigo por SubFamília"
        });
        ret.push({
            "id": "67",
            "v": "Nome Cliente"
        });
        ret.push({
            "id": "69",
            "v": "NIF Cliente"
        });
        ret.push({
            "id": "70",
            "v": "Cartão Cliente"
        });
        ret.push({
            "id": "74",
            "v": "Desconto Linha"
        });
        ret.push({
            "id": "75",
            "v": "Preço Unitário Linha"
        });
        ret.push({
            "id": "76",
            "v": "Total Linha"
        });
        ret.push({
            "id": "77",
            "v": "Descrição Linha"
        });
        ret.push({
            "id": "99",
            "v": "Troco"
        });
        ret.push({
            "id": "104",
            "v": "Valor Forma Pagamento"
        });
        ret.push({
            "id": "105",
            "v": "Total"
        });
        ret.push({
            "id": "106",
            "v": "Total Iva"
        });
        ret.push({
            "id": "107",
            "v": "Morada Cliente"
        });
        ret.push({
            "id": "108",
            "v": "Localidade Cliente"
        });
        ret.push({
            "id": "109",
            "v": "Código Postal Cliente"
        });
        ret.push({
            "id": "112",
            "v": "Total Líquido"
        });
        ret.push({
            "id": "115",
            "v": "Desconto"
        });
        ret.push({
            "id": "116",
            "v": "Retenção"
        });
        ret.push({
            "id": "120",
            "v": "Guia Data Levantamento"
        });
        ret.push({
            "id": "121",
            "v": "Guia Data Entrega"
        });
        ret.push({
            "id": "122",
            "v": "Guia Número"
        });
        ret.push({
            "id": "125",
            "v": "Guia Local Levantamento"
        });
        ret.push({
            "id": "126",
            "v": "Guia Local Entrega"
        });
        ret.push({
            "id": "133",
            "v": "Total Pago"
        });
        ret.push({
            "id": "140",
            "v": "Número de Clientes"
        });
        ret.push({
            "id": "141",
            "v": "Número Voo Cliente"
        });
        ret.push({
            "id": "142",
            "v": "País Cliente"
        });
        ret.push({
            "id": "145",
            "v": "Número Cópias"
        });

    }

    return ret;
}