"use strict";
var SnatchWindow = SnatchBase.extend(function() {

    this.constructor = function(windowid, _id, json_id, rect, wtype, _arguments, _rootWindow) {



        this.super(rect.left, rect.top, rect.width, rect.height, windowid, _id, json_id, rect, wtype);

        this.setArguments(_arguments);


    }

    var tabIndex = -1;
    var currentCaption;
    var panel; //reference to this window's panel

    var resizedListsBoxes = {};

    this.setPanel = function(p) {
        panel = p;
    }
    this.getPanel = function() {
        return panel;
    }
    this.getCurrentCaption = function() {
        return currentCaption;
    }
    this.setCurrentCaption = function(caption) {
        currentCaption = caption;
        $("#" + windowID + "Container > div.window-title").html(currentCaption);
    }

    this.setTabIndex = function(_tabIndex) {
        tabIndex = _tabIndex;
    }
    this.getTabIndex = function() {
        return tabIndex;
    }

    this.setParams = function() {
        if (panel == undefined) {
            panel = this.j_procID.find(".Panel").attr("id");
        }
        this.params = {
            j_parent: this.j_parent.selector,
            j_procID: this.j_procID.selector,

            panel: this.panel,
        }
    }
    this.setArguments = function(args) {
        if (args[5] !== undefined) {
            this.caption = args[5].value;
            currentCaption = args[5].value;
        }
        if (args[6] !== undefined)
            this.modal = args[6].value;
        if (args[7] !== undefined)
            this.visible = args[7].value;
        if (args[8] !== undefined)
            this.background = args[8].value;
    }


    this.createWindow = function(rootWindow) {
        if ($("#w" + this.id).length > 0) {
            console.log("Warning: tried to create already existing window: " + this.id);
        }

        var wclass = "Window";
        if ($.inArray(this.id, bofficeGlobals.notifWindows) >= 0) {
            wclass += " notifw";
        } else if ($.inArray(this.id, bofficeGlobals.unscaledWindows) >= 0) {
            wclass += " wall2";
        }

        //root elem
        $(this.parent).append("<div id=\"" + this.procID + "\" >");

        if ($.inArray(this.id, bofficeGlobals.unscaledWindows) < 0) {
            $("#" + this.procID).append("<div id='bbl" + this.procID + "' class='bblocky'></div>");
        }

        //rect
        this.super.setRect(rootWindow);

        //class
        $("#" + this.procID).addClass(wclass);

        //window main contanet
        $("#" + this.procID).append("<div st=\"window_" + this.procID + "\" id=\"" + this.window_id + "Container" + "\" class=\"WindowContainer\">");

        if ($.inArray(this.id, bofficeGlobals.unscaledWindows) >= 0) {
            $("#" + this.procID + " > div").append("<div id='bl" + this.procID + "' class='blocky'></div>");

            var rect = bofficeScreen.fromSnatchCoords(1, 4, 55, 51);

            $("#bl" + this.procID).css("left", rect.left);
            $("#bl" + this.procID).css("top", rect.top);
            $("#bl" + this.procID).css("width", rect.width);
            $("#bl" + this.procID).css("height", rect.height);

        }
        if (bofficeScreen.RESOLUTION == 1) {
            if ($.inArray(windowID, bofficeGlobals.backgroundDivWindows) >= 0) {
                if ($("#bl" + this.procID).length == 0) {
                    $("#" + this.procID + " > div").append("<div id='bl" + this.procID + "' class='blocky'></div>");
                }

                var rect = bofficeScreen.fromSnatchCoords(0, 0, 53, 53);

                $("#bl" + this.procID).css("left", rect.left);
                $("#bl" + this.procID).css("top", rect.top);
                $("#bl" + this.procID).css("width", rect.width);
                $("#bl" + this.procID).css("height", rect.height);
            };
        }



        //bind window clicks & swipes
        // TODO: SWIPES
        if (this.window_id == 1) {
            var year = new Date().getFullYear();
            var mobileStr = "";
            if (isMobile) {
                mobileStr = " Mobile";
            }

            var version = "WebFe: " + bofficeGlobals.webfeVersion + mobileStr + " BE: " + bofficeGlobals.versionInfo['detail'] + "<br>" + "Copyright Sage Portugal S.A. " + year;
            $("#w1").append("<span id=\"vInfo\">" + version + "</span>");
        }

        /*
            
            if (uiData[this.uiKey + windowID] === undefined) {
                uiData[this.uiKey + windowID] = this;
            }
            */

    }

    this.bindClicks = function() {
        if (this.window_id == 4) {


            //swipe
            //SnatchWindow.bindWindow4Swipe();

        } else if (this.window_id == 1) {
            $("#w1").off();
            $("#w1").on('click', function() {
                boffice.send_url("callback&windowID=1&objectID=101&value=3");
            });

            if (!isAdmin) {
                bofficeWidgetsMenu.bindContextMenu("#w1", "usermenu");
            }


        }
    }

    this.SetWindowTabIndex = function(_tabIndex) {
        _tabIndex = parseInt(_tabIndex);
        var tabs;
        //$("#" + this.window_id + "Container > div").each(function() {
        
        if ((cacheMode == 0) && (_tabIndex == tabIndex) && (($.inArray(windowID, bofficeGlobals.alwaysSwitchFirstTab) < 0))) {
            if (bofficeGlobals.DEBUG)
                console.log("PERFORMANCE: Window: " + windowID + " already at tab: " + _tabIndex);
            return;
        }
        
        //var objs = $("#" + this.window_id + "Container > div");
        var objs = $("#" + this.window_id + "Container").children();
        for (var i = 0; i < objs.length; i++) {


            if (uiData[$(objs[i]).attr("st")] != undefined) {
                if (uiData[$(objs[i]).attr("st")].getTabArray != undefined) {
                    tabs = uiData[$(objs[i]).attr("st")].getTabArray();
                    //$(objs[i]).show();
                    /*is this really needed ?*/



                    if (
                        (tabs.length == 0) ||
                        (tabs.indexOf(_tabIndex) >= 0) ||
                        (tabs.indexOf(-1) >= 0)
                    ) {


                        if (!$(objs[i]).is(":visible")) {
                            $(objs[i]).show();
                            if ($(objs[i]).hasClass("ListBox")) {

                                if (resizedListsBoxes[$(objs[i]).attr("st")] === undefined) {
                                    uiData[$(objs[i]).attr("st")].getSlickGrid().resizeCanvas();
                                    resizedListsBoxes[$(objs[i]).attr("st")] = "yap";


                                }
                            }
                        }
                    } else {
                        if ($(objs[i]).is(":visible"))
                            $(objs[i]).hide();
                    }

                } else {
                    //console.log("WARNING - #" + $(this).attr("st") + " has no tab!!");
                    //probably a panel
                    if ($(objs[i]).hasClass("Panel")) {
                        //uiData[$(objs[i]).attr("st")].setCurrentPage(_tabIndex + 1);
                    }

                }
            } else {
                //console.log("WARNING - #" + $(this).attr("st") + " not in uiData!");

            }
        };
        tabIndex = _tabIndex;
    }

    this.handleCache = function(content) {
        if (content.keys["window_" + this.id] != undefined) {
            if (content.keys["window_" + this.id].panel != undefined) {
                panel = content.keys["window_" + this.id]["panel"];
            } else {
                //try to get it:
                panel = $("#" + windowID + "Container").children(".Panel").attr("id");
            }
            this.j_parent = $(content.keys["window_" + this.id].j_parent);
            this.j_procID = $(content.keys["window_" + this.id].j_procID);
        } else {

            //manual bind
            this.j_procID = $("#w" + this.id);
            this.j_parent = $(this.j_procID).parent();

        }
    }


});

SnatchWindow.ShowWindow = function(_windowID, caption) {
    var j_procID = $("#w" + _windowID);
    if ((caption != undefined) && (caption != "")) {
        uiData["window_" + _windowID].setCurrentCaption(caption);
    }

    if ((cacheMode == 0) || (_windowID == "ShowMessage") || (_windowID == "AskQuestion")) {

        j_procID.addClass("currentw");
        j_procID.show();


        //atualiza a janela corrente. 
        //N adicionada se a atual for igual à ultima!
        windowID = _windowID;
        boffice.log("WINDOWS: '" + windows + "' PUSH " + windowID);
        var from = windows.indexOf(windowID + "");
        if (from < 0) { //already in stack?
            from = windows.length;
        }

        while (windows.length - 1 > from) //keep root 1
        {
            //if (windows[windows.length - 1] != windowID) {
            $("#w" + windows[windows.length - 1]).hide();
            $("#w" + windows[windows.length - 1]).removeClass("currentw");


            windows.pop();
            //}
        }
        if (windows[windows.length - 1] != windowID + "") {
            windows.push(windowID + "");
        }

        boffice.log("WINDOWS: '" + windows + "'");



        //popup keyboard?
        if (windowID == "AskPrice") {



            //$("#inputPrice").keyboard().getkeyboard().destroy();
            //if ($('#inputPrice').data('keyboard') == undefined) {
            $("#inputPrice").keyboard($.extend(bofficeGlobals.decimalKeyboard, bofficeGlobals.DialogKeyboardConfig));
            //}
            //$('#inputPrice').change();
            $('#inputPrice').data('keyboard').reveal();

        } else if (windowID == "AskNumeric") {


            //$("#inputNumeric").keyboard().getkeyboard().destroy();
            //if ($('#inputNumeric').data('keyboard') == undefined) {
            $("#inputNumeric").keyboard($.extend(bofficeGlobals.decimalKeyboard, bofficeGlobals.DialogKeyboardConfig));
            //}
            //$('#inputNumeric').change();
            $('#inputNumeric').data('keyboard').reveal();

        } else if (windowID == "AskPassword") {

            //$("#inputPassword").keyboard().getkeyboard().destroy();
            //if ($('#inputPassword').data('keyboard') == undefined) {
            $("#inputPassword").keyboard($.extend(bofficeGlobals.decimalKeyboard, bofficeGlobals.DialogKeyboardConfig));
            //}
            //$('#inputPassword').change();
            $('#inputPassword').data('keyboard').reveal();
        } else if (windowID == "AskWeight") {


            //$("#inputWeight").keyboard().getkeyboard().destroy();
            //if ($('#inputWeight').data('keyboard') == undefined) {
            $("#inputWeight").keyboard($.extend(bofficeGlobals.decimalKeyboard, bofficeGlobals.DialogKeyboardConfig));
            //}
            //$('#inputWeight').change();
            $('#inputWeight').data('keyboard').reveal();
        } else if (windowID == "ShowMessage") {
            //$("#w" + _windowID).css('z-index', windows.length*100);
        } else {

            if (bofficeGlobals.autoFocusFields[windowID] !== undefined) {
                $("#" + windowID + "_" + bofficeGlobals.autoFocusFields[windowID] + "Text").getkeyboard().reveal();
            }
            var winStr = windowID + "";
            if ((winStr.substring(0, 3) != "Ask") && (winStr.substring(0, 3) != "Sho")) {
                j_procID.css('z-index', windows.length * 10);
            }
            //$("#w" + _windowID).show();

            //if there is a panel, force tab 1
            //var _panel = $("#" + _windowID + "Container").find(".Panel");


            //always got to tab 0 on window show
            var currentPage = 0;
            var panel;
            if (uiData["window_" + _windowID] !== undefined) {
                panel = uiData["window_" + _windowID].getPanel();
            }
            if (panel != undefined) {
                //$("#" + _panel[0].id + "Navigator").attr("snatch_current_page", 1);
                //uiData["panel_" + _panel.attr("id")].setCurrentPage(1);
                currentPage = uiData["panel_" + panel].getCurrentPage();
                //uiData["panel_" + _panel.attr("id")].updatedPanelStatus(currentPage-1);
                if ($.inArray(windowID, bofficeGlobals.alwaysSwitchFirstTab) < 0)
                {
                    uiData["window_" + _windowID].SetWindowTabIndex(currentPage - 1);
                } else {
                    uiData["window_" + _windowID].SetWindowTabIndex(1);
                }

                //uiData["window_" + _windowID].SetWindowTabIndex(0);
            } else {
                // no need!!! :D
                //uiData["window_" + _windowID].SetWindowTabIndex(0);
            }



            //Desktop n tem caption 
            var _caption
            if (uiData["window_" + _windowID] != undefined) {
                _caption = uiData["window_" + _windowID].getCurrentCaption();
                /*if ((caption == "") || (caption == undefined)) {
                    if (uiData["window_" + windowID] !== undefined) {
                        _caption = uiData["window_" + windowID].caption;
                    }
                }*/



            }
            if ((caption !== undefined) && (caption != "")) {
                _caption = caption;
            }
            if (bofficeGlobals.DEBUG) {
                _caption += " (" + windowID + ")";
            }
            if ((windowID == 1) || (_caption == "null")) {
                _caption = ""; //no title in window 1
            }
            if ($("#" + windowID + "Container > div.window-title").length == 0)
                $("#" + windowID + "Container").append("<div class=\"window-title\"></div>"); // + "</div>";
            //adiciona a caption à janela
            $("#" + windowID + "Container > div.window-title").html(_caption);
            //$("#" + windowID + "Container").append(_obg);
        }
    }

}
SnatchWindow.HideWindow = function(_windowID) {
    // close all keyboards:

    //new code
    var w = $("#w" + _windowID).hide();
    $("#w" + _windowID).removeClass("currentw");
    windows.pop();
    windowID = windows[windows.length - 1];
    this.ShowWindow(windowID);

    //reset some states:
    $("#" + _windowID + "Container > div").each(function() {
        if (uiData[$(this).attr("st")] != undefined) {
            if (uiData[$(this).attr("st")].reset != undefined) {
                uiData[$(this).attr("st")].reset();
            }
        }
    });

    //remove any blocks 
    $("#w" + windowID + " > .kbblocky").remove();



}
SnatchWindow.unBindWindow4Swipe = function() {
    if (!isMobile) {
        $('DIV#4_103').unbind("swipeone");
        $('DIV#4_103Pages').find("a.btn").unbind("swipeone");
    }
}
SnatchWindow.bindWindow4Swipe = function() {
    $('DIV#4_103').off();
    //click
    $("DIV#4_103").on('click', function(ev) {
        if (!$(this).hasClass("editmode"))
        {
            boffice.send_url("callback&windowID=4&objectID=9999&value=a");
        }
    });
    /* 
    if (!isMobile) {
        //$('DIV#4_103').unbind("swipeone swipeleft swiperight");
        $('DIV#4_103').bind('swipeone swiperight',
            function(ev, obj) {
                if (ev != undefined) {
                    boffice.log(obj.description);

                    if (obj.description.split(":")[2] == "right") {
                        var target = uiData["slidegrid_4_103"].getActiveId();
                        boffice.send_url("/callback&windowID=4&objectID=63&value=" + target);
                        //var elem = document.elementFromPoint(obj.delta[0].startX, obj.delta[0].startY);
                    }
                }
                ev.preventDefault();
                ev.stopPropagation();
            });
        

    }
    */
}
SnatchWindow.bindWindow4ButtonsSwipe = function() {
    if (!isMobile) {
        //$('DIV#4_103').unbind("swipeone swipeleft swiperight");

        $('DIV#4_103Pages').find("a.btn").bind('swipeone swiperight swipeleft',
            function(ev, obj) {
                if (ev != undefined) {
                    boffice.log(obj.description);
                    if (obj.description.split(":")[2] == "left") {
                        var target = $(ev.currentTarget).parent().parent().parent().attr("snatch_id");
                        var obji = $(ev.currentTarget).attr("snatch_id");
                        boffice.send_url("/callback&windowID=4&objectID=" + target + "&value=-" + obji);
                    } else if (obj.description.split(":")[2] == "right") {
                        var target = uiData["slidegrid_4_103"].getActiveId();
                        boffice.send_url("/callback&windowID=4&objectID=63&value=" + target);
                        //var elem = document.elementFromPoint(obj.delta[0].startX, obj.delta[0].startY);
                    }
                }
                ev.preventDefault();
                ev.stopPropagation();
            });

    }
}