var boxes = {};
getTableTimes = function(products, table_creation_time) {
	var max_table_time = 0;
	var avg_table_time = 0;
	for (var i = 0; i < products.length; i++) {
		if (products[i]['time_max'] > 0) {
			if (products[i]['time_max'] > max_table_time) {
				max_table_time = products[i]['time_max'];
			}
			if (products[i]['time_avg'] > avg_table_time) {
				avg_table_time = products[i]['time_avg'];
			}
		}
	}
	var pair = {};
	pair['max_time'] = max_table_time;
	pair['avg_time'] = avg_table_time
	return pair;
}

calculateTopTimeProducts = function() {
	//populate productTimes

	var productTimes = {};
	allProducts = {};
	var keys = Object.keys(boxes);
	for (var i = 0; i < keys.length; i++) {
		for (var j = 0; j < boxes[keys[i]].products.length; j++) {
			if (boxes[keys[i]].products[j].time_max > 0) {
				productTimes[boxes[keys[i]].products[j].id] = boxes[keys[i]].products[j].time_max;
			}



			if (allProducts[boxes[keys[i]].products[j].id] === undefined) {
				allProducts[boxes[keys[i]].products[j].id] = {};
				allProducts[boxes[keys[i]].products[j].id]['name'] = boxes[keys[i]].products[j].name;
				allProducts[boxes[keys[i]].products[j].id]['qtd'] = boxes[keys[i]].products[j]['qtd'];
			} else {
				allProducts[boxes[keys[i]].products[j].id]['qtd'] += boxes[keys[i]].products[j]['qtd'];
			}
		}
	}
	//console.log("productTimes:" + JSON.stringify(productTimes));

	var values = sortMapByValue(productTimes);
	//console.log("Sorted productTimes:" + JSON.stringify(values));

	var ret = [];
	for (var i = 0; i < values.length; i++) {
		ret.push(values[i][0]);
	}
	//console.log(JSON.stringify(ret));
	return ret.reverse();
}
getRandomColor = function() {
	var letters = 'BCDEF'.split('');
	var color = '#';
	for (var i = 0; i < 6; i++) {
		color += letters[Math.floor(Math.random() * letters.length)];
	}
	return color;
}
recalculateProductTimes = function() {
	var keys = Object.keys(boxes);
	for (var i = 0; i < keys.length; i++) {
		var value = boxes[keys[i]];

		var end_table_time = value.due_time;

		if (value.products !== undefined) {
			for (var j = 0; j < value.products.length; j++) {
				if (boxes[keys[i]].products[j]["start_time"] === undefined) { // product start time not defined

					boxes[keys[i]].products[j]["start_time"] = boxes[keys[i]]["due_time"] - (((boxes[keys[i]].products[j]['time_max']) / 100) * 1000);
					console.log("Table: " + keys[i] + " DUE TIME: " + toTime(boxes[keys[i]]["due_time"]));

				}

				var avg = boxes[keys[i]].products[j]["start_time"];
				avg = avg + (((boxes[keys[i]].products[j]['time_avg']) / 100) * 1000); //secs * secs
				boxes[keys[i]].products[j]['due_avg'] = avg;

				if (boxes[keys[i]]["avg_time"] < avg) {
					boxes[keys[i]]["avg_time"] = avg;
				}

				var max = boxes[keys[i]].products[j]["start_time"];
				max = max + (((boxes[keys[i]].products[j]['time_max']) / 100) * 1000);
				boxes[keys[i]].products[j]['due_max'] = max;

				if (boxes[keys[i]]["due_time"] < max) {
					boxes[keys[i]]["due_time"] = max;
				}

			}
		}
	}

}
processMessage = function(message) {
	var imesg = JSON.parse(message);


	//console.log("ORIG MESSAGE: " + JSON.stringify(mesg.products));
	//console.log("ORIG MESSAGE: " + JSON.stringify(boxes[mesg.table_number]));


	var update = false;
	var ts = getTimeStamp();
	var requestedProducts = [];
	if ((imesg.products === undefined) && (imesg.queue === undefined)) {
		return; //empty message
	}
	var inputArray = {};
	if (imesg.queue === undefined) {
		inputArray["queue"] = [];
		inputArray["queue"].push(imesg);
	} else {
		inputArray = imesg;
	}
	for (var i = 0; i < inputArray.queue.length; i++) {
		//one table:
		mesg = inputArray.queue[i];

		requestedProducts = addProducts(mesg.products, ts); //remove dups (add quantities)

		//other way
		var new_light_color = 'rgb(' + (Math.floor((256 - 229) * Math.random()) + 230) + ',' +
			(Math.floor((256 - 229) * Math.random()) + 230) + ',' +
			(Math.floor((256 - 229) * Math.random()) + 230) + ')';

		if (boxes[mesg.table_number] === undefined) {
			boxes[mesg.table_number] = mesg;
			boxes[mesg.table_number]['created'] = ts / 1;
			boxes[mesg.table_number]['updated'] = ts / 1;

			boxes[mesg.table_number]['products'] = requestedProducts;



			boxes[mesg.table_number]['color'] = new_light_color;
			boxes[mesg.table_number]['color'] = getRandomColor();

		} else {
			update = true;
			//update fields
			boxes[mesg.table_number]['updated'] = ts / 1;
			boxes[mesg.table_number]['employee'] = mesg['employee'];

			//add new products
			if ((mesg.products.length) > 0) {
				//requestedProducts = [mesg.products[0]];
				for (var j = 0; j < requestedProducts.length; j++) {
					requestedProducts[i];

					console.log("Table: " + mesg.table_number + " added: " + JSON.stringify(requestedProducts[j], null, 4));
					boxes[mesg.table_number]['products'].push(requestedProducts[j]);
				}

			}
			console.log("Table: " + mesg.table_number + " updated!");
		}

		/* this is actually max_table_time*/
		var table_times = getTableTimes(boxes[mesg.table_number]['products'], boxes[mesg.table_number]['created']);

		boxes[mesg.table_number]['total_table_time'] = table_times.max_time;
		boxes[mesg.table_number]['avg_table_time'] = table_times.avg_time;

		boxes[mesg.table_number]['due_time'] = (getTimeStamp() / 1) + (table_times.max_time * 10);
		boxes[mesg.table_number]['avg_time'] = (getTimeStamp() / 1) + (table_times.avg_time * 10);

		console.log("Table: " + mesg.table_number + " DUE TIME1: " + toTime(boxes[mesg.table_number]['due_time']));
		console.log("Table: " + mesg.table_number + " TOTAL TABLE TIME: " + table_times.max_time);
		console.log("Table: " + mesg.table_number + " AVG TABLE TIME: " + table_times.avg_time);

		recalculateProductTimes(boxes); //again....


	}


	var keys = Object.keys(boxes);

	var topList = calculateTopTimeProducts();


	var values = keys.map(function(v) {
		return boxes[v];
	});

	tables = values;

	//sendStatus();
}

addProducts = function(prods, ts) {
	//console.log("ORIG PRODS: " + JSON.stringify(prods));
	var res = [];

	if (prods !== undefined) {
		for (var i = 0; i < prods.length; i++) {
			newProducts = {};

			var key = prods[i].id;
			
			newProducts[key] = prods[i];
			newProducts[key]['created'] = ts;

			var avg = ts / 1;
			avg = avg + (((newProducts[key]['time_avg']) / 100) * 1000); //secs * secs
			newProducts[key]['due_avg'] = avg;

			var max = ts / 1;
			max = max + (((newProducts[key]['time_max']) / 100) * 1000);
			newProducts[key]['due_max'] = max;

			res.push(newProducts[key]);

		}
	}
	return res;
}