var socket;

var host = "127.0.0.1";
//var port = 8082; //nodejs
var port = 2091; //gesrest

var updateTimer = 10 * 1000; //30 secs

/* GLOBAL ALERTS*/
var yellowTimer = 120; // 2 mins
var redTimer = 180; // 3 minutes

var tables = [];
var topList = [];
var allProducts = {};

var DISPATCH_ITEMS = true;
var DEBUG = false;


getTimeStamp = function() {
	var date = new Date();
	return (new Date());
}
var lastUpdate = getTimeStamp();

timeDelta = function(ts) {
	return (getTimeStamp() - ts) / 1000; /*seconds*/
}

timeDeltaRound = function(ts) {
	return Math.floor(timeDelta(ts)); /*seconds*/
}

formatDate = function(date) {
	if (date >= 60) {
		minutes = Math.floor(date / 60);
		return minutes + "m"
	} else
		return date + "s"
}
toTime = function(unix_timestamp) {
	var date = new Date(unix_timestamp);
	// Hours part from the timestamp
	var hours = date.getHours();
	// Minutes part from the timestamp
	var minutes = "0" + date.getMinutes();
	// Seconds part from the timestamp
	var seconds = "0" + date.getSeconds();

	// Will display time in 10:30:23 format
	var formattedTime = hours + ':' + minutes.substr(-2); // + ':' + seconds.substr(-2);

	return formattedTime;
}

function getUrlParameter(name) {
	name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
	var regexS = "[\\?&]" + name + "=([^&#]*)";
	var regex = new RegExp(regexS);
	var results = regex.exec(window.location.href);
	if (results == null)
		return null;
	else
		return results[1];
}

function sortMapByValue(map) {
	var tupleArray = [];
	for (var key in map) tupleArray.push([key, map[key]]);
	tupleArray.sort(function(a, b) {
		return a[1] - b[1]
	});
	return tupleArray;
}

createBox = function(mesg) {
	var table_number = mesg.table_number;
	var main_div = undefined;


	var update = false;
	var created = timeDeltaRound(mesg.created);
	if ($("DIV#tab_" + table_number).length > 0) {
		/* UPDATE TABLE*/
		main_div = $("DIV#tab_" + table_number);
		$("DIV#" + "tab_hits_" + table_number).html(mesg.hits);
		$("DIV[id=tab_created_" + table_number + "]").html("<strong title='" + toTime(mesg.avg_time) + "'>" + toTime(mesg.due_time) + "</strong>");


	} else {

		/* NEW TABLE */
		main_div = $("<div id='tab_" + table_number + "'></div>");

		main_div.append("<div class='well'><i id='disp_" + table_number + "' class='dispatch fa fa-check fa-3x fa-fw btn-success'></i></div>");
		main_div.append("<div class='createdData'>" + mesg.created + "</div>");



		main_div.find(".well").append("<h2>M: <strong>" + table_number + "</strong></h2>");
		main_div.find(".well").append("<div class='employee'>" + mesg.employee + "</div>");
		main_div.find(".well").append("<div class='createTime' id='tab_created_" + table_number + "'><strong>" + toTime(mesg.avg_time) + "/" + toTime(mesg.due_time) + "</strong></div>");
		

	}

	$(main_div).find("TABLE#list_" + table_number).remove();

	//product list
	var ul = $("<table class='table' id='list_" + table_number + "'></table>");
	for (var i = 0; i < mesg.products.length; i++) {
		var rclass = "";
		if (mesg.products[i].time_max == 0) {
			rclass += " anow";
		} else {
			if (getTimeStamp() / 1 < mesg.products[i].start_time) {
				rclass = "";
			} else if (getTimeStamp() / 1 < mesg.products[i].due_avg) {
				rclass = "aok";
			} else {
				if (getTimeStamp() / 1 >= mesg.products[i].due_max) {
					rclass = "nok";
				} else {
					rclass = "avg";
				}

			}

		}
		var li = $("<tr class='" + rclass + "'></tr>");

		if (mesg.products[i].created > mesg.created) {
			$(li).addClass("late");
		} else {
			$(li).removeClass("late");
		}
		$(li).append("<td class='p_qtd'>" + mesg.products[i].qtd + "</td>");

		var prettyTime = ((mesg.products[i].time_max / 100) / 60);
		var avgTime = ((mesg.products[i].time_avg / 100) / 60);

		var line = "<td class='p_name' ><div class='prodDescD' title='" + toTime(mesg.products[i].start_time) + "/" + toTime(mesg.products[i].due_avg) + "/" + toTime(mesg.products[i].due_max) + " (" + avgTime + "/" + prettyTime + ") " + "'>" + mesg.products[i].name;
		if (DEBUG) {
			line += "&nbsp;" + toTime(mesg.products[i].start_time) + "/" + toTime(mesg.products[i].due_avg) + "/" + toTime(mesg.products[i].due_max) + " (" + avgTime + "/" + prettyTime + ") ";
		}
		line += "";
		if (DISPATCH_ITEMS) {
			line += "<i id='disp_item_" + table_number + "_" + i + "' class='dispatch dispatch_item fa fa-check fa-fw btn-success'></i>";
		}
		line += "</div></td>";
		$(li).append(line);

		//$(li).append("<td class='p_time text-right'>" + toTime(mesg.products[i].due_avg) + "/" + toTime(mesg.products[i].due_max) + "</td>");

		$(ul).append($(li));
	}



	$(main_div).append($(ul));
	//$(".bricklayer").appendElements($(ul));


	var updated = timeDeltaRound(mesg.updated);

	$("DIV#tab_updated_" + table_number).html("Updated: " + toTime(mesg.updated));
	main_div.find(".employee").html(mesg.employee);

	/* GLOBAL ALERTS */
	main_div.removeClass("wyellow");
	main_div.removeClass("wred");
	if (getTimeStamp() / 1 >= mesg.due_time) {
		//main_div.removeClass();
		main_div.addClass("wred");
		//main_div.find(".well").addClass("alert-danger");
	} else if (getTimeStamp() / 1 >= mesg.avg_time) {
		main_div.addClass("wyellow");
		//main_div.removeClass();
		//main_div.find("h2").addClass("alert-warning");
	}

	/* TABLE ALERTS */
	if (mesg.due_time) {
		var date = new Date();
		var now = date.getTime();
		//console.log( toTime(mesg.due_time) +" <= "+ toTime(now));
		if (mesg.due_time <= now) {
			//console.log(table_number + " - Created: " + mesg.created + " DUE: " + mesg.due_time); {
			main_div.addClass("ared");
			//s}
		} else {
			main_div.removeClass("ared");
		}
	}

	main_div.css("background-color", mesg.color);
	if ($("DIV#tab_" + table_number).length == 0) {
		$(".bricklayer").appendElements(main_div);
		$("i#disp_" + table_number).on('click', function() {
			deleteElement($(this).attr("id").split("_")[1]);
		});
	}
	if (DISPATCH_ITEMS) {
		$(".dispatch_item").on('click', function() {
			deleteItem($(this));
		});
	}

}
createBoxes = function() {
	$("DIV#quants").html("");

	topList = calculateTopTimeProducts();
	//display quantities row
	var main_div;

	if (tables.length > 0) {
		$("#tableNum").html("Mesas: <strong>" + tables.length + "</strong>");
	} else {
		$("#tableNum").html("");
	}

	/* CLEAR EVERYTHING */
	$("DIV#main").html("");
	$(".bricklayer").bricklayer();

	//var visibleTables = {};
	var max_due_time = getTimeStamp();
	for (var i = 0; i < tables.length; i++) {

		for (var j = 0; j < tables[i].products.length; j++) {
			if (tables[i].products[j].due_max > max_due_time) {
				max_due_time = tables[i].products[j].due_max;
			}
		}

		tables[i]['table_due_time'] = tables[i]['due_time'];

		createBox(tables[i]);

	}

	for (var i = 0; i < topList.length; i++) {
		var pid = topList[i];
		var rclass = "";
		if (allProducts[pid] != undefined) {
			main_div = $("<div class='qtblock col-xs-12 col-sm-4 col-md-3 col-lg-2' id='tqt_" + pid + "'></div>");
			ul = $("<table class='table' id='quant_" + i + "'></table>");

			var li = $("<tr class='" + rclass + "'></tr>");
			$(li).append("<td class='p_name'><div class='prodDescT'>" + allProducts[pid].name + "</div></td>");
			$(li).append("<td class='text-right p_qtd'>" + allProducts[pid].qtd + "</td>");

			$(ul).append(li);
			$(main_div).append(ul);


			index = -1;
			for (var j = 0; j < topList.length; j++) {
				if (parseInt(topList[j]) == parseInt(pid)) {
					index = j;
					break;
				}
			}
			//this somehow does not work :(
			//var index = rev.indexOf(mesg.products[i].id + "");
			if (index >= 0) {
				var calc = index;
				rclass = " top" + calc;
			}
			main_div.addClass(rclass)


			$("DIV#quants").append(main_div);
		}

	}

}
findTable = function(pkey) {
	var key = parseInt(pkey);
	var index = undefined;
	for (var i = 0; i < tables.length; i++) {
		if (tables[i].table_number === parseInt(key)) {
			index = i;
			break;
		}
	}
	return index;
}
checkForEmptyCols = function(brick) {
	var element = $(brick);
	var columns = element.find(".bricklayer-column");
	var count = columns.size();

	var newArray = [];

	for (var i = 0; i < count; i++) {

		var rows = $(columns[i]).children();
		var row_count = rows.size();
		for (var j = 0; j < row_count; j++) {
			newArray.push($(rows[j]));
			$(rows[j]).remove();
		}
	}

	//updateBoard(true);
	createBoxes(true);
	updateBoard(true);

}


openSocket = function() {
	socket = new WebSocket('ws://' + host + ':' + port);

	socket.onopen = function() {

		socket.send('fullstatus');
		console.log("Sent 'fullstatus'");
	};

	socket.onmessage = function(message) {
		//console.log("WebSocket message: '" + message.data + "'");
		$("#spinner").addClass("fa-spin");
		setTimeout(function() {
			$("#spinner").removeClass("fa-spin");
		}, 1500);

		message_str = message.data;
		console.log(message_str);

		var command = message_str.split(":");

		if (command[0] == "delete") {
			var key = command[1];
			console.log("WEBSOCK: Deleting:" + key);
			$("DIV#main > DIV#" + "tab_" + command[1]).remove();

			delete boxes[key];
			var index = findTable(key);
			if (index !== undefined) {
				tables.splice(index, 1);
			}
			//force update
			//updateBoard();

		} else {

			processMessage(message_str);

		}
		//createBoxes();
		lastUpdate = getTimeStamp();
		//$("#spinner").toggleClass("fa-spin");
		updateBoard();
	};
	socket.onerror = function(error) {
		console.log('WebSocket error: ' + error);
	};
	socket.onclose = function(error) {
		console.log('WebSocket closed!');
		//display warning
		$("DIV#warn").show('slow');
		$("DIV#info").hide();
		$("DIV.mainButton").hide('slow');
		socket = undefined;
	};
}
updateBoard = function(force) {

	startTime();


	if (socket === undefined) {
		openSocket();
		//return; //keep updating times
	} else {
		$("DIV#warn").hide();
	}
	if ((timeDelta(lastUpdate) >= 30) || (force === true)) { //if not updated for 30 secs
		//console.log("Force update board...");
		if (socket !== undefined) {
			if (socket.readyState == 1) {
				//socket.send('Ping');
				//console.log("Sent 'Ping'");
			}
		}
	} else if (force == true) {
		return;
	}
	console.log("Update board...");

	//$("#spinner").toggleClass("fa-spin");
	if (tables.length == 0) {
		$("DIV#info").show('slow');
		$("DIV.mainButton").hide('slow');
		$("DIV#warn").hide();
		$("DIV#main").html("");
		$(".bricklayer").bricklayer();

		tables = [];
	} else {
		$("DIV#info").hide('');
		$("DIV.mainButton").show('slow');
	}

	createBoxes(true);


	//}
	//$("#spinner").toggleClass("fa-spin");

	//var t = setTimeout(updateBoard, 30000);


}
deleteElement = function(element, simulated) {
	table_id = element;
	var table_num = 0;
	if (table_id === undefined) {
		if ($("DIV#main").children().length == 0) {
			return;
		}
		console.log("Selecting netx table in queue: Table "+tables[0].table_number);
		//table_id = $("DIV#main").children().first().attr("id").split("_")[1];
		table_id = tables[0].table_number;
	}
	console.log("drop table " + table_id);
	var date = new Date();
	var now = date.getTime();
	var index = findTable(table_id);
	if (tables[index].due_time > now) {
		console.log("table " + table_id + " not finished yet!");
		if (simulated !== undefined) {
			return
		}
	}
	table_num = table_id;
	table_id = "tab_" + table_id;
	$("DIV#main").children().find("#" + table_id).hide(function() {
		$(this).remove();
		checkForEmptyCols('.bricklayer');
	});
	//send to socket
	if (socket !== undefined) {
		if (socket.readyState == 1) {
			socket.send('delete:' + table_num);
			console.log("Sent 'delete'");
		}
	}
}

deleteItem = function(elem)
{
	var eid = $(elem).id;
	eis = $(elem).attr("id").split("_");
	var table = eis[2];
	var item = eis[3];

	//delete boxes[table].products[item];

	boxes[table].products.splice(item, 1);

	//check if table empty
	if (boxes[table].products.length==0)
	{
		deleteElement(table);
	}
	updateBoard(true);
}

function closingCode() {
	if (socket !== undefined) {
		socket.close();
	}
	return null;
}
$(document).ready(function() {
	$(".bricklayer").bricklayer();

	if (getUrlParameter("debug") == "1") {
		DEBUG = true;
	}

	$("a#dispatch").on('click', function() {
		deleteElement();
	});
	//host = window.location.hostname;
	openSocket();


	setInterval(function() {
		updateBoard(true);
	}, updateTimer); //every 30 secs



	//updateBoard(true);
	//startTime();

	window.onbeforeunload = closingCode;


	//startDemo();
	window.onbeforeunload = closingCode;

	function closingCode() {
		if (socket !== undefined) {
			socket.close();
		}
		return null;
	}

});

startTime = function() {

	var today = new Date();
	var h = today.getHours();
	var m = today.getMinutes();
	var s = today.getSeconds();
	m = checkTime(m);
	s = checkTime(s);
	document.getElementById('clk').innerHTML =
		h + ":" + m; //+ ":" + s;
	//var t = setTimeout(startTime, 500);
}

function checkTime(i) {
	if (i < 10) {
		i = "0" + i
	}; // add zero in front of numbers < 10
	return i;
}

function startDemo() {
	deleteElement(undefined, true);
	var secs = Math.floor(Math.random() * 45) + 1;

	setTimeout(function() {
		startDemo();
	}, secs * 1000);
}