/*v0517*/

UPDATE `reportsections` SET `DetailQuery`="SELECT 
    #Q.rate,
    if(Q.rate=999,\"Total\",Q.rate),
    replace(Q.valueTaxOff,'.',','),
    replace(Q.taxValue,'.',','),
    replace(Q.totalValue,'.',','),
    #Q.docType,
    Q.DocDescription
    FROM(     
    SELECT
        taxes.UID as TaxUID,
        taxes.TaxRate as rate,
        round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2) as 'valueTaxOff',
        round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2) as 'taxValue',
        round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2)as 'totalValue',
        headers.DocumentTypeUID as DocType,
        (SELECT Description FROM documenttypes WHERE DocumentType=headers.DocumentTypeUID AND RecordDeleted=0 GROUP BY DocumentType) as  DocDescription
    FROM transactionsdetails details
    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
    -- INNER JOIN documenttypes ON headers.DocumentTypeUID=documenttypes.DocumentType 
    WHERE DATE(headers.TransactionEndTime) =   '(101)' 
    AND  headers.TransactionStatus = 'N' 
    AND  headers.DocumentTypeUID != 13 
    GROUP by headers.DocumentTypeUID,TaxUID
UNION
    SELECT
        999,
        999,
        round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2) as 'valueTaxOff',
        round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2) as 'taxValue',
        round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2)as 'totalValue',
        headers.DocumentTypeUID as DocType,
         (SELECT Description FROM documenttypes WHERE DocumentType=headers.DocumentTypeUID AND RecordDeleted=0 GROUP BY DocumentType) as  DocDescription
    FROM transactionsdetails details
    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID
    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID 
    -- INNER JOIN documenttypes ON headers.DocumentTypeUID=documenttypes.DocumentType 
    WHERE DATE(headers.TransactionEndTime) =   '(101)' 
    AND  headers.TransactionStatus = 'N' 
    AND  headers.DocumentTypeUID != 13 
    GROUP by headers.DocumentTypeUID 
)AS Q ORDER BY Q.DocType,Q.TaxUID;" WHERE `UID`='1001';


UPDATE `reportsections` SET `DetailQuery`="SELECT 
    DATE_FORMAT(H.ModifyDate, '%Hh%i') as doc_date,
    DocumentID,
    S.SalesmanShortName,
    REPLACE(ROUND(TableTotal/100,2),'.',',') as doc_value
    FROM 
        transactionsheaders AS H INNER JOIN salesmans AS S ON H.CreateSalesmanUID=S.UID
    WHERE 
        TransactionStatus='A'
    AND
        DATE(H.ModifyDate) = '(101)' 
    ORDER BY
       doc_date;" WHERE `UID`='1005';
	   
	   
-- ATUALIZA o campo NetValue quando com valor 0 e Taxa de IVA = 0
UPDATE transactionsdetails 
LEFT JOIN taxes ON taxes.UID = transactionsdetails.SaleTaxUID
SET NetValue = SaleValue
WHERE NetValue = 0 AND TaxRate = 0;


DELETE FROM `languagedictionaries` WHERE StringID in (1912,1913,1914,1915);
INSERT INTO `languagedictionaries`
(`RecordDeleted`,`SyncCounter`,`Description`,`StringID`,`Alias`,`LanguageID`,`Context`)
VALUES
('0', '1', 'Data Descarga', '1913', 'TableCloseUnloadDate', '1', 'SCREEN_TABLE_CLOSE'),
('0', '1', 'Data Carga', '1912', 'TableCloseLoadDate', '1', 'SCREEN_TABLE_CLOSE'),
('0', '1', 'Carga', '1914', 'TableEditCargoDateShort', '1', 'SCREEN_TABLE_CLOSE'),
('0', '1', 'Descarga', '1915', 'TableEditDropOffDateShort', '1', 'SCREEN_TABLE_CLOSE');


DELETE FROM `screens` WHERE `ScreenType` = 1 AND `ID` in (11,11054);
INSERT INTO `screens`
(`RecordDeleted`,`SyncCounter`,`Description`,`ID`,`UserInterfaceDescription`,`SalesTerminalUID`,`ScreenType`)
VALUES
('0', '3210', 'SCREEN_TABLE_CLOSE', '11',"{\"objects\":[{\"id\":\"3717\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":11},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#262#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"5533\",\"windowid\":\"3717\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":47},{\"value\":4},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"13677\",\"windowid\":\"3717\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":42},{\"value\":17},{\"value\":11},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"13802\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":57},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"22296\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":51},{\"value\":29},{\"value\":34},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#264#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1101\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":58},{\"value\":42},{\"value\":4},{\"value\":11},{\"value\":3},{\"value\":\"#265#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8295\",\"windowid\":\"3717\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":29},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"7963\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":59},{\"value\":42},{\"value\":7},{\"value\":11},{\"value\":3},{\"value\":\"#266#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12136\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":52},{\"value\":33},{\"value\":34},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#267#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2297\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":37},{\"value\":34},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#268#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3535\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":68},{\"value\":29},{\"value\":31},{\"value\":12},{\"value\":3},{\"value\":\"#269#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30686\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":54},{\"value\":29},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#270#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2152\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":55},{\"value\":33},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#271#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"343\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":56},{\"value\":37},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#272#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4816\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":60},{\"value\":42},{\"value\":17},{\"value\":11},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13766\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":62},{\"value\":45},{\"value\":23},{\"value\":8},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8756\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":63},{\"value\":42},{\"value\":31},{\"value\":11},{\"value\":3},{\"value\":\"#277#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2731\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32500\",\"windowid\":\"3717\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":42},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13377\",\"windowid\":\"3717\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":7},{\"value\":12},{\"value\":26},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":1}]},{\"id\":\"19536\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":16},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"20722\",\"windowid\":\"3717\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16012\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":70},{\"value\":42},{\"value\":10},{\"value\":11},{\"value\":3},{\"value\":\"#769#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7533\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":49},{\"value\":57},{\"value\":10},{\"value\":3},{\"value\":\"#773#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"31536\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":42},{\"value\":38},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#776#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"24160\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":74},{\"value\":42},{\"value\":42},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#777#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"15441\",\"windowid\":\"3717\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":16},{\"value\":42},{\"value\":33},{\"value\":4},{\"value\":5},{\"value\":-2},{\"value\":-1},{\"value\":2}]},{\"id\":\"21805\",\"windowid\":\"3717\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":10},{\"value\":12},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":2},{\"value\":1}]},{\"id\":\"22270\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":16},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"32525\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":16},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#773#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"1611\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":76},{\"value\":16},{\"value\":33},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#774#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"6781\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":78},{\"value\":16},{\"value\":37},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#778#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"10135\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":79},{\"value\":12},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#781#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"3308\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":49},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#779#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"14834\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":82},{\"value\":42},{\"value\":20},{\"value\":11},{\"value\":3},{\"value\":\"#813#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21250\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":663},{\"value\":42},{\"value\":28},{\"value\":11},{\"value\":3},{\"value\":\"#1459#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16855\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":88},{\"value\":31},{\"value\":69},{\"value\":10},{\"value\":3},{\"value\":\"#1392#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14332\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":42},{\"value\":69},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1619#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31636\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":42},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13541\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":42},{\"value\":23},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23062\",\"windowid\":\"3717\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":120},{\"value\":42},{\"value\":13},{\"value\":11},{\"value\":3},{\"value\":\"#1729#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"7874\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"31990\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"17122\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"24562\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":12},{\"value\":26},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"19190\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":12},{\"value\":19},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"22334\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"20124\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"18255\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"26237\",\"windowid\":\"3717\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":12},{\"value\":26},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"15376\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":12},{\"value\":19},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"30004\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":125},{\"value\":13},{\"value\":8},{\"value\":13},{\"value\":3},{\"value\":\"#1912#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"25245\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":13},{\"value\":14},{\"value\":13},{\"value\":3},{\"value\":\"#1913#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"15511\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":13},{\"value\":21},{\"value\":13},{\"value\":3},{\"value\":\"#1878#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"16888\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":123},{\"value\":13},{\"value\":24},{\"value\":13},{\"value\":8},{\"value\":\"#1879#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":3}]},{\"id\":\"18969\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":124},{\"value\":13},{\"value\":32},{\"value\":13},{\"value\":8},{\"value\":\"#1880#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":3}]},{\"id\":\"12890\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":126},{\"value\":13},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#1876#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"23386\",\"windowid\":\"3717\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":127},{\"value\":13},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"#1877#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]}]}", '0', '1'),
('0', '3214', 'SCREEN_TABLE_EDIT_GUIAS_SERVICES', '11054', "{\"objects\":[{\"id\":\"32386\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":54},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1882#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"26720\",\"windowid\":\"32386\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":0},{\"value\":37},{\"value\":27},{\"value\":[{\"v\":3},{\"v\":19},{\"v\":3},{\"v\":4},{\"v\":3},{\"v\":4}]},{\"value\":\"#1771#\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"15590\",\"windowid\":\"32386\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10338\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":25},{\"value\":43},{\"value\":12},{\"value\":3},{\"value\":\"#1773#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"3192\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":27},{\"value\":5},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"1926\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":106},{\"value\":27},{\"value\":40},{\"value\":10},{\"value\":3},{\"value\":\"#1755#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3990\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":26},{\"value\":27},{\"value\":4},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32297\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":19},{\"value\":27},{\"value\":7},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1755\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":5},{\"value\":27},{\"value\":14},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30074\",\"windowid\":\"32386\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":71},{\"value\":6},{\"value\":47},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1701#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1080.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15787\",\"windowid\":\"32386\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":38},{\"value\":0},{\"value\":15},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":15}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"24155\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":38},{\"value\":0},{\"value\":15},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12334\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":38},{\"value\":3},{\"value\":15},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32764\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":105},{\"value\":27},{\"value\":31},{\"value\":10},{\"value\":3},{\"value\":\"#1756#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24050\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":30},{\"value\":27},{\"value\":7},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17505\",\"windowid\":\"32386\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":97},{\"value\":12},{\"value\":47},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1734#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1081.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5838\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":107},{\"value\":38},{\"value\":6},{\"value\":15},{\"value\":3},{\"value\":\"#1758#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14922\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":109},{\"value\":46},{\"value\":9},{\"value\":7},{\"value\":3},{\"value\":\"#1759#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15297\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":112},{\"value\":27},{\"value\":34},{\"value\":10},{\"value\":3},{\"value\":\"#1883#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32520\",\"windowid\":\"32386\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":0},{\"value\":31},{\"value\":15},{\"value\":15},{\"value\":[{\"v\":5},{\"v\":5},{\"v\":5}]},{\"value\":\"#1777#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31711\",\"windowid\":\"32386\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":38},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1695#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6212\",\"windowid\":\"32386\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":38},{\"value\":33},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1697#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1079.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5514\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":108},{\"value\":38},{\"value\":9},{\"value\":8},{\"value\":3},{\"value\":\"#1760#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17610\",\"windowid\":\"32386\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":111},{\"value\":15},{\"value\":31},{\"value\":11},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1762#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"9862\",\"windowid\":\"32386\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":18},{\"value\":47},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1831#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1150.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17614\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":120},{\"value\":38},{\"value\":17},{\"value\":9},{\"value\":3},{\"value\":\"#1914#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10671\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":38},{\"value\":20},{\"value\":9},{\"value\":3},{\"value\":\"#1915#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23886\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":38},{\"value\":29},{\"value\":15},{\"value\":3},{\"value\":\"#1850#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30552\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":125},{\"value\":38},{\"value\":23},{\"value\":15},{\"value\":3},{\"value\":\"#1879#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14198\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":126},{\"value\":38},{\"value\":26},{\"value\":15},{\"value\":3},{\"value\":\"#1880#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1432\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":128},{\"value\":47},{\"value\":17},{\"value\":6},{\"value\":3},{\"value\":\"#58#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1074\",\"windowid\":\"32386\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":129},{\"value\":47},{\"value\":20},{\"value\":6},{\"value\":3},{\"value\":\"#58#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}", '0', '1');

DELETE FROM `screens` WHERE `ScreenType` = 2 AND `ID` in (11054);
INSERT INTO `screens`
(`RecordDeleted`,`SyncCounter`,`Description`,`ID`,`UserInterfaceDescription`,`SalesTerminalUID`,`ScreenType`)
VALUES
('0', '3215', 'SCREEN_TABLE_EDIT_GUIAS_SERVICES', '11054', "{\"objects\":[{\"id\":\"20499\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":54},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#1882#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"19799\",\"windowid\":\"20499\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":0},{\"value\":49},{\"value\":27},{\"value\":[{\"v\":4},{\"v\":25},{\"v\":4},{\"v\":5},{\"v\":4},{\"v\":5}]},{\"value\":\"#1771#\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"19204\",\"windowid\":\"20499\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26887\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":37},{\"value\":43},{\"value\":12},{\"value\":3},{\"value\":\"#1773#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"9100\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":27},{\"value\":9},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"26940\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":106},{\"value\":39},{\"value\":40},{\"value\":10},{\"value\":3},{\"value\":\"#1755#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24476\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":34},{\"value\":27},{\"value\":5},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28829\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":24},{\"value\":27},{\"value\":10},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16873\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":9},{\"value\":27},{\"value\":15},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24329\",\"windowid\":\"20499\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":71},{\"value\":6},{\"value\":47},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1701#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1080.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15054\",\"windowid\":\"20499\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":50},{\"value\":0},{\"value\":15},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":15}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"7041\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":50},{\"value\":0},{\"value\":15},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13584\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":50},{\"value\":3},{\"value\":15},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11863\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":105},{\"value\":39},{\"value\":31},{\"value\":10},{\"value\":3},{\"value\":\"#1756#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17880\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":39},{\"value\":27},{\"value\":10},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13765\",\"windowid\":\"20499\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":97},{\"value\":12},{\"value\":47},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1734#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1081.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16736\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":107},{\"value\":50},{\"value\":6},{\"value\":15},{\"value\":3},{\"value\":\"#1758#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20575\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":109},{\"value\":58},{\"value\":9},{\"value\":7},{\"value\":3},{\"value\":\"#1759#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"547\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":112},{\"value\":39},{\"value\":34},{\"value\":10},{\"value\":3},{\"value\":\"#1883#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13311\",\"windowid\":\"20499\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":0},{\"value\":31},{\"value\":15},{\"value\":15},{\"value\":[{\"v\":5},{\"v\":5},{\"v\":5}]},{\"value\":\"#1777#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24222\",\"windowid\":\"20499\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":50},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1695#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7449\",\"windowid\":\"20499\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":50},{\"value\":28},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1697#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1079.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27091\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":108},{\"value\":50},{\"value\":9},{\"value\":8},{\"value\":3},{\"value\":\"#1760#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24980\",\"windowid\":\"20499\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":111},{\"value\":27},{\"value\":31},{\"value\":11},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1762#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"15666\",\"windowid\":\"20499\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":18},{\"value\":47},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1831#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1150.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2981\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":50},{\"value\":23},{\"value\":15},{\"value\":3},{\"value\":\"#1850#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16028\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":120},{\"value\":50},{\"value\":17},{\"value\":9},{\"value\":3},{\"value\":\"#1914#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17463\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":50},{\"value\":20},{\"value\":9},{\"value\":3},{\"value\":\"#1915#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11155\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":128},{\"value\":59},{\"value\":17},{\"value\":6},{\"value\":3},{\"value\":\"#58#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20969\",\"windowid\":\"20499\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":129},{\"value\":59},{\"value\":20},{\"value\":6},{\"value\":3},{\"value\":\"#58#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}", '5', '2');