-- MySQL dump 10.19  Distrib 10.3.39-MariaDB, for debian-linux-gnu (x86_64)
--
-- Host: localhost    Database: #DB_NAME#
-- ------------------------------------------------------
-- Server version	10.3.39-MariaDB-0ubuntu0.20.04.2

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES latin1 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Current Database: `#DB_NAME#`
--

CREATE DATABASE /*!32312 IF NOT EXISTS*/ `#DB_NAME#` /*!40100 DEFAULT CHARACTER SET latin1 COLLATE latin1_swedish_ci */;

USE `#DB_NAME#`;

--
-- Table structure for table `appcore`
--

DROP TABLE IF EXISTS `appcore`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `appcore` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `SyncCounter` int(11) NOT NULL,
  `Name` varchar(45) NOT NULL,
  `Value` varchar(128) NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=22 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `appcore`
--

LOCK TABLES `appcore` WRITE;
/*!40000 ALTER TABLE `appcore` DISABLE KEYS */;
INSERT INTO `appcore` VALUES (1,1,'max_save_retries','10'),(2,1,'db_version','410'),(3,1,'max_visible_tables','100'),(4,1,'curl_connect_timeout','300'),(5,1,'detail_line_type','1'),(6,1,'socket_timeout','2'),(7,1,'updated_taxes','1'),(8,1,'tax_change_date','01-01-2014'),(9,1,'user_data_v1','34764C6B6F364D73536259776263514A4B645177647A54786C4C614447644D3365707861323859530A'),(10,1,'user_data_v2','1'),(12,1,'current_certificate','1280'),(13,0,'data_version','722'),(14,1,'tax_change_from','1'),(15,1,'tax_change_to','2'),(17,1,'tax_change_from2','1'),(18,1,'tax_change_to2','2'),(19,1,'tax_change_from3','1'),(20,1,'tax_change_to3','2'),(21,1,'sendEdocs2AT','0,0,0');
/*!40000 ALTER TABLE `appcore` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cancelrecords`
--

DROP TABLE IF EXISTS `cancelrecords`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `cancelrecords` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `SyncCounter` int(11) NOT NULL,
  `OperationDate` datetime NOT NULL,
  `SalesmanUID` int(11) NOT NULL,
  `TableID` int(11) NOT NULL,
  `ItemUID` int(11) NOT NULL,
  `Quantity` int(11) NOT NULL,
  `OperationType` int(3) NOT NULL,
  `OpDetail` int(3) NOT NULL,
  `UserNote` mediumtext NOT NULL,
  `SalesmanSessionID` int(11) NOT NULL,
  `ItemValue` int(11) NOT NULL,
  `SalesTerminal` int(11) NOT NULL,
  `OrderDate` datetime NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `cancelrecord_has_salesman` (`SalesmanUID`),
  KEY `cancelrecord_has_plu` (`ItemUID`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cancelrecords`
--

LOCK TABLES `cancelrecords` WRITE;
/*!40000 ALTER TABLE `cancelrecords` DISABLE KEYS */;
/*!40000 ALTER TABLE `cancelrecords` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cashdrawer_movements`
--

DROP TABLE IF EXISTS `cashdrawer_movements`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `cashdrawer_movements` (
  `UID` int(11) NOT NULL,
  `CashDrawerUID` int(11) DEFAULT NULL,
  `SalesTerminalUID` int(11) DEFAULT NULL,
  `SalesmanUID` int(11) DEFAULT NULL,
  `Date` datetime DEFAULT NULL,
  `Value` int(11) DEFAULT NULL,
  `MovementTypeID` int(11) DEFAULT NULL,
  `Description` varchar(2000) DEFAULT NULL,
  `EntityUID` int(11) DEFAULT NULL,
  `DocumentID` varchar(45) DEFAULT NULL,
  `CashDrawerMovementUID` int(11) DEFAULT NULL,
  `Voided` int(11) NOT NULL DEFAULT 0,
  `IsRIC` int(11) NOT NULL DEFAULT 0,
  `ModifyDate` timestamp NOT NULL DEFAULT current_timestamp() ON UPDATE current_timestamp(),
  `atcud` varchar(100) NOT NULL DEFAULT '',
  `atqrcode` varchar(1000) NOT NULL DEFAULT '',
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cashdrawer_movements`
--

LOCK TABLES `cashdrawer_movements` WRITE;
/*!40000 ALTER TABLE `cashdrawer_movements` DISABLE KEYS */;
INSERT INTO `cashdrawer_movements` VALUES (2,1,1,1,'2013-03-21 11:44:46',0,1,'',0,'',0,0,0,'2023-05-18 16:31:08','0','');
/*!40000 ALTER TABLE `cashdrawer_movements` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cashdrawer_movements_docs`
--

DROP TABLE IF EXISTS `cashdrawer_movements_docs`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `cashdrawer_movements_docs` (
  `SaleTransactionUID` int(11) NOT NULL,
  `SaleTransactionTenderUID` int(11) NOT NULL,
  `CashDrawerMovementUID` int(11) NOT NULL,
  `TransactionValue` int(11) NOT NULL,
  PRIMARY KEY (`SaleTransactionUID`,`SaleTransactionTenderUID`,`CashDrawerMovementUID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cashdrawer_movements_docs`
--

LOCK TABLES `cashdrawer_movements_docs` WRITE;
/*!40000 ALTER TABLE `cashdrawer_movements_docs` DISABLE KEYS */;
/*!40000 ALTER TABLE `cashdrawer_movements_docs` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cashdrawermovementtypes`
--

DROP TABLE IF EXISTS `cashdrawermovementtypes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `cashdrawermovementtypes` (
  `UID` int(11) NOT NULL,
  `Description` varchar(45) DEFAULT NULL,
  `MovementFlow` int(11) DEFAULT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cashdrawermovementtypes`
--

LOCK TABLES `cashdrawermovementtypes` WRITE;
/*!40000 ALTER TABLE `cashdrawermovementtypes` DISABLE KEYS */;
INSERT INTO `cashdrawermovementtypes` VALUES (1,'Fundo Maneio Entrada',1),(2,'Fundo Maneio Saida',0),(3,'Sangria',0),(4,'Compra Direta',0),(5,'Vale',0),(6,'Emprstimo',1),(7,'Devoluo',1),(8,'Pag. Conta Corrente',1),(9,'Rec. Conta Corrente',2),(10,'Rec. CC empr.',2),(11,'Pag. CC empr.',1),(12,'Estorno',0),(13,'Pag. comisso',0);
/*!40000 ALTER TABLE `cashdrawermovementtypes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cashdrawers`
--

DROP TABLE IF EXISTS `cashdrawers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `cashdrawers` (
  `UID` int(11) NOT NULL,
  `RecordDeleted` tinyint(1) NOT NULL DEFAULT 0,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  `ShortDescription` varchar(20) NOT NULL,
  `WorkingFund` int(11) NOT NULL DEFAULT 0,
  `IsOpen` int(11) DEFAULT 0,
  `OpenCashDrawerMov` int(11) DEFAULT NULL,
  `isPending` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cashdrawers`
--

LOCK TABLES `cashdrawers` WRITE;
/*!40000 ALTER TABLE `cashdrawers` DISABLE KEYS */;
INSERT INTO `cashdrawers` VALUES (1,0,5,0,'Caixa 1','Cx1',0,1,2,0);
/*!40000 ALTER TABLE `cashdrawers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `cashdrawertenders`
--

DROP TABLE IF EXISTS `cashdrawertenders`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `cashdrawertenders` (
  `uid` int(11) NOT NULL AUTO_INCREMENT,
  `CashDrawerMovementUID` int(11) DEFAULT NULL,
  `CashDrawerUID` int(11) DEFAULT NULL,
  `SalesTerminalUID` int(11) DEFAULT NULL,
  `SalesmanUID` int(11) DEFAULT NULL,
  `Date` varchar(45) DEFAULT NULL,
  `PaymentTypeUID` int(11) DEFAULT NULL,
  `Value` int(11) DEFAULT NULL,
  `Commission` int(11) DEFAULT NULL,
  PRIMARY KEY (`uid`)
) ENGINE=InnoDB AUTO_INCREMENT=3 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `cashdrawertenders`
--

LOCK TABLES `cashdrawertenders` WRITE;
/*!40000 ALTER TABLE `cashdrawertenders` DISABLE KEYS */;
/*!40000 ALTER TABLE `cashdrawertenders` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commissiongroup`
--

DROP TABLE IF EXISTS `commissiongroup`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `commissiongroup` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commissiongroup`
--

LOCK TABLES `commissiongroup` WRITE;
/*!40000 ALTER TABLE `commissiongroup` DISABLE KEYS */;
INSERT INTO `commissiongroup` VALUES (1,0,1,'Comisso Base');
/*!40000 ALTER TABLE `commissiongroup` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commissiongroupdetails`
--

DROP TABLE IF EXISTS `commissiongroupdetails`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `commissiongroupdetails` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `ZoneUID` int(11) NOT NULL,
  `Value` int(11) NOT NULL,
  `Percent` int(11) NOT NULL,
  `StartTime` time NOT NULL,
  `EndTime` time NOT NULL,
  `CommisionGroupUID` int(11) NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_group_has_zone` (`ZoneUID`),
  KEY `fk_ComissionGroupDetails_CommisionGroup` (`CommisionGroupUID`),
  CONSTRAINT `fk_ComissionGroupDetails_CommisionGroup` FOREIGN KEY (`CommisionGroupUID`) REFERENCES `commissiongroup` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_group_has_zone` FOREIGN KEY (`ZoneUID`) REFERENCES `zones` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commissiongroupdetails`
--

LOCK TABLES `commissiongroupdetails` WRITE;
/*!40000 ALTER TABLE `commissiongroupdetails` DISABLE KEYS */;
/*!40000 ALTER TABLE `commissiongroupdetails` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `commissiongroupplus`
--

DROP TABLE IF EXISTS `commissiongroupplus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `commissiongroupplus` (
  `UID` int(11) NOT NULL,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `ComissionGroupDetailsUID` int(11) NOT NULL,
  `PluUID` int(11) NOT NULL,
  `Value` int(11) NOT NULL,
  `Percent` int(11) NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_CommisionGroupPLUs_ComissionGroupDetails` (`ComissionGroupDetailsUID`),
  KEY `fk_pluuid` (`PluUID`),
  CONSTRAINT `fk_CommisionGroupPLUs_ComissionGroupDetails` FOREIGN KEY (`ComissionGroupDetailsUID`) REFERENCES `commissiongroupdetails` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_pluuid` FOREIGN KEY (`PluUID`) REFERENCES `plus` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `commissiongroupplus`
--

LOCK TABLES `commissiongroupplus` WRITE;
/*!40000 ALTER TABLE `commissiongroupplus` DISABLE KEYS */;
/*!40000 ALTER TABLE `commissiongroupplus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `costcenters`
--

DROP TABLE IF EXISTS `costcenters`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `costcenters` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL DEFAULT 0,
  `SyncCounter` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `costcenters`
--

LOCK TABLES `costcenters` WRITE;
/*!40000 ALTER TABLE `costcenters` DISABLE KEYS */;
INSERT INTO `costcenters` VALUES (1,0,1,'Centro de custo');
/*!40000 ALTER TABLE `costcenters` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customergroups`
--

DROP TABLE IF EXISTS `customergroups`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `customergroups` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) DEFAULT NULL,
  `Description` varchar(45) DEFAULT NULL,
  `ShortDescription` varchar(20) DEFAULT NULL,
  `DiscountPercentage` int(11) DEFAULT NULL,
  `DeferredDiscountPercentage` int(11) DEFAULT NULL,
  `CreditLimit` int(11) DEFAULT NULL,
  `SalesPriceID` int(11) DEFAULT NULL,
  `BillToGroup` int(11) NOT NULL,
  `CustomerUID` int(11) NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customergroups`
--

LOCK TABLES `customergroups` WRITE;
/*!40000 ALTER TABLE `customergroups` DISABLE KEYS */;
INSERT INTO `customergroups` VALUES (1,0,1,1,'Grupo de clientes','grupo',0,0,0,0,0,0);
/*!40000 ALTER TABLE `customergroups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `customers`
--

DROP TABLE IF EXISTS `customers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `customers` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `CreateDate` datetime NOT NULL,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `CustomerID` int(11) NOT NULL,
  `Name` varchar(45) NOT NULL,
  `ShortName` varchar(20) DEFAULT NULL,
  `OrganizationName` varchar(250) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `UseGlobalDiscount` tinyint(1) DEFAULT NULL,
  `GlobalDiscount` int(11) DEFAULT NULL,
  `CardID` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `SalesPrice` int(11) NOT NULL,
  `CustomerGroupID` int(11) DEFAULT NULL,
  `TotalPoints` int(11) DEFAULT NULL,
  `CreditLimit` int(11) DEFAULT NULL,
  `SalesPercentForCustomerBalance` int(5) DEFAULT NULL,
  `Balance` int(11) DEFAULT NULL,
  `TotalSpent` int(11) DEFAULT NULL,
  `NumberOfVisits` int(11) DEFAULT NULL,
  `LastVisit` datetime NOT NULL,
  `Telephone1` varchar(200) DEFAULT NULL,
  `MobileTelephone1` varchar(200) DEFAULT NULL,
  `EmailAddress` varchar(300) DEFAULT NULL,
  `FederalTaxID` varchar(250) DEFAULT NULL,
  `PartyAddressLine1` varchar(250) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `PartyAddressLine2` varchar(250) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `PartyPostalCode` varchar(250) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `PartyCountryID` varchar(45) DEFAULT NULL,
  `PartyLocationID` varchar(45) DEFAULT NULL,
  `Website` varchar(250) DEFAULT NULL,
  `Comments` varchar(250) DEFAULT NULL,
  `Warning` varchar(250) DEFAULT NULL,
  `ModifyDate` datetime DEFAULT NULL,
  `SalesmanUID` int(11) NOT NULL DEFAULT 0,
  `IsRIC` int(11) NOT NULL DEFAULT 0,
  `Consent` int(11) NOT NULL DEFAULT 0,
  `SendBySafe` tinyint(1) DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `fk_customer_has_customergroup` (`CustomerGroupID`),
  KEY `nameindex` (`Name`),
  CONSTRAINT `fk_customer_has_customergroup` FOREIGN KEY (`CustomerGroupID`) REFERENCES `customergroups` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `customers`
--

LOCK TABLES `customers` WRITE;
/*!40000 ALTER TABLE `customers` DISABLE KEYS */;
INSERT INTO `customers` VALUES (1,'2011-04-18 00:00:00',0,7,9999,'Consumidor final','Consumidor final',NULL,NULL,NULL,'9999',0,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2013-04-08 10:24:06',NULL,NULL,NULL,'999999990',NULL,NULL,NULL,'PT',NULL,NULL,NULL,NULL,'2013-04-08 10:24:06',0,0,0,0);
/*!40000 ALTER TABLE `customers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `database_upgrades`
--

DROP TABLE IF EXISTS `database_upgrades`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `database_upgrades` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `VersionFrom` int(11) DEFAULT NULL,
  `VersionTo` int(11) DEFAULT NULL,
  `Data` datetime DEFAULT NULL,
  `Terminal` int(11) DEFAULT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=601 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `database_upgrades`
--

LOCK TABLES `database_upgrades` WRITE;
/*!40000 ALTER TABLE `database_upgrades` DISABLE KEYS */;
INSERT INTO `database_upgrades` VALUES (309,400,345,'2013-01-25 17:08:00',1),(310,400,345,'2013-01-25 17:08:00',1),(311,400,345,'2013-01-25 17:08:01',1),(312,400,345,'2013-01-25 17:08:01',1),(313,400,345,'2013-01-25 17:08:02',1),(314,400,345,'2013-01-25 17:08:02',1),(315,400,345,'2013-01-25 17:08:03',1),(316,400,345,'2013-01-25 17:08:03',1),(317,400,345,'2013-01-25 17:08:03',1),(318,400,345,'2013-01-25 17:08:04',1),(319,400,345,'2013-01-25 17:08:04',1),(320,400,350,'2013-01-25 17:08:04',1),(321,400,350,'2013-01-25 17:08:05',1),(322,400,351,'2013-01-25 17:08:05',1),(323,400,351,'2013-01-25 17:08:05',1),(324,400,351,'2013-01-25 17:08:06',1),(325,400,351,'2013-01-25 17:08:06',1),(326,400,351,'2013-01-25 17:08:07',1),(327,400,351,'2013-01-25 17:08:07',1),(328,400,351,'2013-01-25 17:08:07',1),(329,400,351,'2013-01-25 17:08:08',1),(330,400,352,'2013-01-25 17:08:08',1),(331,400,352,'2013-01-25 17:08:08',1),(332,400,352,'2013-01-25 17:08:09',1),(333,400,352,'2013-01-25 17:08:09',1),(334,400,353,'2013-01-25 17:08:10',1),(335,400,353,'2013-01-25 17:08:10',1),(336,400,353,'2013-01-25 17:08:11',1),(337,400,354,'2013-01-25 17:08:11',1),(338,400,354,'2013-01-25 17:08:11',1),(339,400,354,'2013-01-25 17:08:12',1),(340,400,354,'2013-01-25 17:08:12',1),(341,400,354,'2013-01-25 17:08:12',1),(342,400,354,'2013-01-25 17:08:13',1),(343,400,401,'2013-03-21 11:20:55',1),(344,400,402,'2013-03-21 11:20:55',1),(345,400,403,'2013-03-21 11:20:55',1),(346,400,404,'2013-03-21 11:20:55',1),(347,400,405,'2013-03-21 11:20:55',1),(348,400,406,'2013-03-21 11:20:55',1),(349,400,407,'2013-03-21 11:20:55',1),(350,400,408,'2013-03-21 11:20:55',1),(351,400,409,'2013-03-21 11:20:55',1),(352,400,410,'2013-03-21 11:20:55',1),(353,400,411,'2013-03-21 11:20:55',1),(354,400,412,'2013-03-21 11:20:55',1),(355,400,413,'2013-03-21 11:20:55',1),(356,400,414,'2013-03-21 11:20:55',1),(357,400,415,'2013-03-21 11:20:55',1),(358,400,416,'2013-03-21 11:20:55',1),(359,400,417,'2013-03-21 11:20:55',1),(360,400,418,'2013-03-21 11:20:55',1),(361,400,419,'2013-03-21 11:20:55',1),(362,400,420,'2013-03-21 11:20:55',1),(363,400,421,'2013-03-21 11:20:55',1),(364,400,422,'2013-03-21 11:20:55',1),(365,400,423,'2013-03-21 11:20:55',1),(366,400,424,'2013-03-21 11:20:55',1),(367,400,425,'2013-03-21 11:20:56',1),(368,400,426,'2013-03-21 11:20:56',1),(369,400,427,'2013-03-21 11:20:56',1),(370,400,428,'2013-03-21 11:20:56',1),(371,400,429,'2013-03-21 11:20:56',1),(372,400,430,'2013-03-21 11:20:56',1),(373,400,431,'2013-03-21 11:20:56',1),(374,400,432,'2013-03-21 11:20:56',1),(375,400,433,'2013-03-21 11:20:56',1),(376,400,434,'2013-03-21 11:20:56',1),(377,400,435,'2013-03-21 11:20:56',1),(378,400,436,'2013-03-21 11:20:56',1),(379,400,437,'2013-03-21 11:20:56',1),(380,400,438,'2013-03-21 11:20:56',1),(381,400,439,'2013-03-21 11:20:56',1),(382,400,440,'2013-03-21 11:20:56',1),(383,400,441,'2013-03-21 11:20:56',1),(384,400,442,'2013-03-21 11:20:56',1),(385,400,443,'2013-03-21 11:20:56',1),(386,400,444,'2013-03-21 11:20:56',1),(387,400,445,'2013-03-21 11:20:57',1),(388,400,446,'2013-03-21 11:20:57',1),(389,400,447,'2013-03-21 11:20:57',1),(390,400,448,'2013-03-21 11:20:57',1),(391,400,449,'2013-03-21 11:20:57',1),(392,400,450,'2013-03-21 11:20:57',1),(393,400,451,'2013-03-21 11:20:57',1),(394,400,452,'2013-03-21 11:20:57',1),(395,400,453,'2013-03-21 11:20:57',1),(396,400,454,'2013-03-21 11:20:57',1),(397,400,455,'2013-03-21 11:20:57',1),(398,400,456,'2013-03-21 11:20:57',1),(399,400,457,'2013-03-21 11:20:57',1),(400,400,458,'2013-03-21 11:20:57',1),(401,400,459,'2013-03-21 11:20:57',1),(402,400,460,'2013-03-21 11:20:57',1),(403,400,461,'2013-03-21 11:20:57',1),(404,400,462,'2013-03-21 11:20:57',1),(405,400,463,'2013-03-21 11:20:57',1),(406,463,464,'2013-04-08 10:22:56',1),(407,463,465,'2013-04-08 10:22:56',1),(408,463,466,'2013-04-08 10:22:57',1),(409,463,467,'2013-04-08 10:22:57',1),(410,463,468,'2013-04-08 10:22:57',1),(411,463,469,'2013-04-08 10:22:57',1),(412,463,470,'2013-04-08 10:22:57',1),(413,470,471,'2013-04-17 11:16:16',1),(414,470,471,'2013-04-17 15:42:45',1),(415,471,472,'2013-04-19 10:02:04',1),(416,470,471,'2013-04-19 10:03:32',1),(417,470,472,'2013-04-19 10:03:32',1),(418,470,471,'2013-04-24 16:42:35',1),(419,470,472,'2013-04-24 16:42:35',1),(420,472,473,'2013-05-06 15:18:03',1),(421,472,474,'2013-05-06 15:18:03',1),(422,472,475,'2013-05-06 15:18:03',1),(423,475,476,'2014-02-07 16:37:59',1),(424,475,477,'2014-02-07 16:37:59',1),(425,475,478,'2014-02-07 16:37:59',1),(426,475,479,'2014-02-07 16:37:59',1),(427,475,480,'2014-02-07 16:37:59',1),(428,475,481,'2014-02-07 16:38:00',1),(429,475,482,'2014-02-07 16:38:00',1),(430,475,483,'2014-02-07 16:38:00',1),(431,475,484,'2014-02-07 16:38:00',1),(432,475,485,'2014-02-07 16:38:00',1),(433,475,486,'2014-02-07 16:38:00',1),(434,475,487,'2014-02-07 16:38:00',1),(435,475,488,'2014-02-07 16:38:00',1),(436,475,489,'2014-02-07 16:38:00',1),(437,475,490,'2014-02-07 16:38:00',1),(438,475,491,'2014-02-07 16:38:00',1),(439,475,492,'2014-02-07 16:38:00',1),(440,475,493,'2014-02-07 16:38:00',1),(441,475,494,'2014-02-07 16:38:00',1),(442,475,495,'2014-02-07 16:38:01',1),(443,475,496,'2014-02-07 16:38:01',1),(444,475,497,'2014-02-07 16:38:01',1),(445,475,498,'2014-02-07 16:38:01',1),(446,475,499,'2014-02-07 16:38:01',1),(447,475,500,'2014-02-07 16:38:01',1),(448,475,501,'2014-02-07 16:38:01',1),(449,475,502,'2014-02-07 16:38:01',1),(450,475,503,'2014-02-07 16:38:01',1),(451,475,504,'2014-02-07 16:38:01',1),(452,475,505,'2014-02-07 16:38:01',1),(453,475,506,'2014-02-07 16:38:01',1),(454,475,507,'2014-02-07 16:38:01',1),(455,475,508,'2014-02-07 16:38:01',1),(456,475,509,'2014-02-07 16:38:02',1),(457,475,510,'2014-02-07 16:38:02',1),(458,475,511,'2014-02-07 16:38:02',1),(459,475,512,'2014-02-07 16:38:02',1),(460,475,513,'2014-02-07 16:38:02',1),(461,475,514,'2014-02-07 16:38:02',1),(462,475,515,'2014-02-07 16:38:02',1),(463,475,516,'2014-02-07 16:38:02',1),(464,475,517,'2014-02-07 16:38:02',1),(465,475,518,'2014-02-07 16:38:02',1),(466,475,519,'2014-02-07 16:38:02',1),(467,519,520,'2014-02-07 16:38:44',1),(468,519,521,'2014-02-07 16:38:44',1),(469,519,522,'2014-02-07 16:38:44',1),(470,519,523,'2014-02-07 16:38:44',1),(471,519,524,'2014-02-07 16:38:44',1),(472,519,525,'2014-02-07 16:38:45',1),(473,519,526,'2014-02-07 16:38:45',1),(474,519,527,'2014-02-07 16:38:45',1),(475,519,528,'2014-02-07 16:38:45',1),(476,519,529,'2014-02-07 16:38:45',1),(477,519,530,'2014-02-07 16:38:45',1),(478,519,531,'2014-02-07 16:38:45',1),(479,519,532,'2014-02-07 16:38:45',1),(480,519,533,'2014-02-07 16:38:45',1),(481,519,534,'2014-02-07 16:38:45',1),(482,519,535,'2014-02-07 16:38:45',1),(483,519,536,'2014-02-07 16:38:45',1),(484,519,537,'2014-02-07 16:38:45',1),(485,519,538,'2014-02-07 16:38:45',1),(486,519,539,'2014-02-07 16:38:46',1),(487,519,540,'2014-02-07 16:38:46',1),(488,519,541,'2014-02-07 16:38:46',1),(489,519,542,'2014-02-07 16:38:46',1),(490,519,543,'2014-02-07 16:38:46',1),(491,519,544,'2014-02-07 16:38:46',1),(492,519,545,'2014-02-07 16:38:46',1),(493,519,546,'2014-02-07 16:38:46',1),(494,519,547,'2014-02-07 16:38:46',1),(495,519,548,'2014-02-07 16:38:46',1),(496,519,549,'2014-02-07 16:38:46',1),(497,519,550,'2014-02-07 16:38:46',1),(498,519,551,'2014-02-07 16:38:46',1),(499,519,552,'2014-02-07 16:38:46',1),(500,519,553,'2014-02-07 16:38:46',1),(501,519,554,'2014-02-07 16:38:47',1),(502,519,601,'2014-02-07 16:38:47',1),(503,519,602,'2014-02-07 16:38:47',1),(504,519,603,'2014-02-07 16:38:47',1),(505,519,604,'2014-02-07 16:38:47',1),(506,519,605,'2014-02-07 16:38:47',1),(507,519,606,'2014-02-07 16:38:47',1),(508,519,607,'2014-02-07 16:38:47',1),(509,519,608,'2014-02-07 16:38:47',1),(510,519,609,'2014-02-07 16:38:47',1),(511,519,610,'2014-02-07 16:38:47',1),(512,519,611,'2014-02-07 16:38:47',1),(513,519,612,'2014-02-07 16:38:47',1),(514,519,613,'2014-02-07 16:38:47',1),(515,519,614,'2014-02-07 16:38:48',1),(516,614,615,'2014-07-21 10:01:20',1),(517,614,616,'2014-07-21 10:01:20',1),(518,614,617,'2014-07-21 10:01:20',1),(519,614,618,'2014-07-21 10:01:21',1),(520,614,619,'2014-07-21 10:01:21',1),(521,614,620,'2014-07-21 10:01:21',1),(522,614,621,'2014-07-21 10:01:21',1),(523,614,622,'2014-07-21 10:01:21',1),(524,614,623,'2014-07-21 10:01:21',1),(525,614,624,'2014-07-21 10:01:21',1),(526,614,625,'2014-07-21 10:01:21',1),(527,614,626,'2014-07-21 10:01:21',1),(528,614,627,'2014-07-21 10:01:21',1),(529,614,628,'2014-07-21 10:01:21',1),(530,614,629,'2014-07-21 10:01:21',1),(531,614,630,'2014-07-21 10:01:21',1),(532,614,631,'2014-07-21 10:01:21',1),(533,614,632,'2014-07-21 10:01:21',1),(534,614,633,'2014-07-21 10:01:21',1),(535,614,634,'2014-07-21 10:01:21',1),(536,614,355,'2014-07-21 10:01:22',1),(537,634,635,'2021-11-30 14:50:13',1),(538,634,636,'2021-11-30 14:50:13',1),(539,634,637,'2021-11-30 14:50:13',1),(540,634,638,'2021-11-30 14:50:13',1),(541,634,639,'2021-11-30 14:50:13',1),(542,634,640,'2021-11-30 14:50:13',1),(543,634,641,'2021-11-30 14:50:13',1),(544,634,642,'2021-11-30 14:50:13',1),(545,634,643,'2021-11-30 14:50:13',1),(546,634,644,'2021-11-30 14:50:13',1),(547,634,645,'2021-11-30 14:50:13',1),(548,634,646,'2021-11-30 14:50:13',1),(549,634,647,'2021-11-30 14:50:13',1),(550,634,648,'2021-11-30 14:50:13',1),(551,634,649,'2021-11-30 14:50:13',1),(552,634,650,'2021-11-30 14:50:13',1),(553,634,651,'2021-11-30 14:50:13',1),(554,634,652,'2021-11-30 14:50:13',1),(555,634,653,'2021-11-30 14:50:13',1),(556,634,654,'2021-11-30 14:50:13',1),(557,634,655,'2021-11-30 14:50:13',1),(558,634,656,'2021-11-30 14:50:13',1),(559,634,657,'2021-11-30 14:50:13',1),(560,634,658,'2021-11-30 14:50:13',1),(561,634,659,'2021-11-30 14:50:13',1),(562,634,660,'2021-11-30 14:50:13',1),(563,634,661,'2021-11-30 14:50:13',1),(564,634,662,'2021-11-30 14:50:13',1),(565,634,663,'2021-11-30 14:50:13',1),(566,634,664,'2021-11-30 14:50:13',1),(567,634,665,'2021-11-30 14:50:13',1),(568,634,666,'2021-11-30 14:50:13',1),(569,634,667,'2021-11-30 14:50:13',1),(570,634,668,'2021-11-30 14:50:13',1),(571,634,669,'2021-11-30 14:50:13',1),(572,634,670,'2021-11-30 14:50:13',1),(573,634,671,'2021-11-30 14:50:13',1),(574,634,672,'2021-11-30 14:50:13',1),(575,634,673,'2021-11-30 14:50:13',1),(576,634,674,'2021-11-30 14:50:13',1),(577,634,675,'2021-11-30 14:50:13',1),(578,634,676,'2021-11-30 14:50:13',1),(579,634,677,'2021-11-30 14:50:13',1),(580,634,678,'2021-11-30 14:50:13',1),(581,634,679,'2021-11-30 14:50:13',1),(582,634,680,'2021-11-30 14:50:13',1),(583,634,681,'2021-11-30 14:50:13',1),(584,634,682,'2021-11-30 14:50:13',1),(585,634,683,'2021-11-30 14:50:13',1),(586,634,684,'2021-11-30 14:50:13',1),(587,634,685,'2021-11-30 14:50:13',1),(588,634,686,'2021-11-30 14:50:13',1),(589,634,687,'2021-11-30 14:50:13',1),(590,634,688,'2021-11-30 14:50:13',1),(591,634,689,'2021-11-30 14:50:14',1),(592,634,690,'2021-11-30 14:50:14',1),(593,634,692,'2021-11-30 14:50:14',1),(594,634,693,'2021-11-30 14:50:14',1),(595,634,694,'2021-11-30 14:50:14',1),(596,634,695,'2021-11-30 14:50:14',1),(597,634,696,'2021-11-30 14:50:14',1),(598,634,697,'2021-11-30 14:50:14',1),(599,634,698,'2021-11-30 14:50:14',1),(600,634,699,'2021-11-30 14:50:14',1);
/*!40000 ALTER TABLE `database_upgrades` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dayclosedeposittenders`
--

DROP TABLE IF EXISTS `dayclosedeposittenders`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `dayclosedeposittenders` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `Date` varchar(45) DEFAULT NULL,
  `PaymentTypeUID` int(11) DEFAULT NULL,
  `Value` int(11) DEFAULT NULL,
  `ComissionValue` int(11) DEFAULT NULL,
  `FFinMovementNumber` int(11) NOT NULL DEFAULT 0,
  `synccounter` int(11) DEFAULT NULL,
  `Envelope` varchar(100) DEFAULT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dayclosedeposittenders`
--

LOCK TABLES `dayclosedeposittenders` WRITE;
/*!40000 ALTER TABLE `dayclosedeposittenders` DISABLE KEYS */;
/*!40000 ALTER TABLE `dayclosedeposittenders` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `dayclosetenders`
--

DROP TABLE IF EXISTS `dayclosetenders`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `dayclosetenders` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `Date` varchar(45) DEFAULT NULL,
  `PaymentTypeUID` int(11) DEFAULT NULL,
  `Value` int(11) DEFAULT NULL,
  `FFinMovementNumber` int(11) NOT NULL DEFAULT 0,
  `synccounter` int(11) DEFAULT NULL,
  `comissionvalue` int(11) DEFAULT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `dayclosetenders`
--

LOCK TABLES `dayclosetenders` WRITE;
/*!40000 ALTER TABLE `dayclosetenders` DISABLE KEYS */;
/*!40000 ALTER TABLE `dayclosetenders` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `devicedrivers`
--

DROP TABLE IF EXISTS `devicedrivers`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `devicedrivers` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Description` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `Red` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `Black` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `NormalSize` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `DoubleSize` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `Underline` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `LineFeed` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `Beep` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `PrintCRLF` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `SepChar` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `OpenDrawer` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `GraphicLine` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `AfterBitmap` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `BeforeBitmap` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `BitmapName` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `BitmapX` int(11) DEFAULT NULL,
  `BitmapY` int(11) DEFAULT NULL,
  `BirmapInverted` tinyint(1) DEFAULT NULL,
  `StartChar` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `EndChar` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `Filter1` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `Filter2` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `StartSeq` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `InvertReading` tinyint(1) DEFAULT NULL,
  `AverageReadings` int(4) DEFAULT NULL,
  `DeviceType` int(11) DEFAULT NULL,
  `PrnInitSeq` varchar(40) NOT NULL DEFAULT ' ',
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=1014 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `devicedrivers`
--

LOCK TABLES `devicedrivers` WRITE;
/*!40000 ALTER TABLE `devicedrivers` DISABLE KEYS */;
INSERT INTO `devicedrivers` VALUES (1,0,0,'TM-88','1B45011B7410','1B45001B7410','1B2100','1B2120','1B2D01','0D0A','07','1B64040D0A1B69','B1','1B703060FF','1B2A00F000','1B32','1B3310',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'1B7410'),(2,0,0,'Balana Dibal',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'\'+\'','0x13',NULL,NULL,'D',NULL,NULL,5,' '),(3,0,0,'Balana Ruby',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0x0D','%2B%25.%25',NULL,'0x2B',NULL,NULL,5,' '),(4,0,0,'Balana Ipesa',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,5,' '),(5,0,0,'TM-60',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'1B7410'),(6,0,0,'TM-220','1B45011B7410','1B45001B7410','1B2100','1B2131','1B2181','0D0A','07','1B64040D041B69','B1','1B700164FA','1B2A00C800','1B3310','1B32',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'1B7410'),(7,0,0,'Customer Display',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'1F240102','1F240101',NULL,'1B40',NULL,NULL,1,' '),(8,0,0,'Barcode PS2 Datalogic',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,4,' '),(9,0,0,'MSR PS2 Promag',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,2,' '),(10,0,0,'RFID Promag',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,2,' '),(11,0,0,'Nenhum',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,99,' '),(12,0,0,'Leitor Teclado padro',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'%s','%s',NULL,NULL,NULL,2,' '),(13,0,0,'TSP100','1B45011B7410','1B45001B7410','14','0E','1B2D01','0D0A','1E','0D0A0A0A1B6431','B1','1B070B3707','1B2A00F000','1B32','1B3310',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'1B7410'),(14,0,0,'Customer display Toshiba LIUST-51',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'1B5B323B3148','1B5B313B3148',NULL,'0C',NULL,NULL,1,' '),(15,0,0,'TM-210B','1B45011B7410','1B45001B7410','1B2101','1B2131','1B2181','0D0A','07','1B640A0D041B69','B1','1B703060FF','1B2A00C800','1B3310','1B32',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'1B7410'),(21,0,0,'FL2024',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0A0D','0B',NULL,'1B401B430107081E081E080700',NULL,NULL,1,' '),(22,0,0,'Venux ITV 150','1B45011B7410','1B45001B7410','1B2100','1B2120','1B2D01','0D0A','07','1B640A0D0A1B69','B1','1B70002019','1B2A00F000','1B32','1B3310',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'1B7410'),(23,0,0,'Epson TM-T20','1B45011B7410','1B45001B7410','1B21001B6100','1B2120','1B2D01','0D0A','07','1B64050D0A1B69','B1','1B70006464','1B2A00F000','1B32','1B61011D284C06003045202001011B6100',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'1B7410'),(24,0,0,'IBM 4610','1B21011B7410','1B21001B7410','1B2100','1B2120','1B2D01','0D0A','07','1B64040D0A1B69','B1','1B703060FF','1B2A00F000','1B32','1B3310',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'1B7410'),(25,0,0,'STAR SRP200','1B341B7410','1B351B7410','1B5700','1B5701','1B2D01','0D0A','07','1B64040D0A1B69','B1','1B070A641C','1B2A00F000','1B32','1B3310',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'1B7410'),(27,0,0,'Epson TM295','1B341B7410','1B2101','1B2101','1B2121','1B2181','0A','07','1B46010C1B691B71','B1','1B700040F0','1B2A00F000','1B32','1B3310',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,0,'1B7410'),(28,0,0,'Balanca EPELSA III',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'$','0x0D','%25d.%25d',NULL,'0',NULL,NULL,5,' '),(29,0,0,'ARM','1B341B7410','1B2101','1B2101','1B2121','1B2181','0A','07','0A0D0A0D1B46010C1B691B71','B1','1B700040F0','1B2A00F000','1B32','1B3310',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,' '),(1006,0,0,'Dibal Linux Delta',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'D','0x0D','%2B%25d.%25d',NULL,'0x2B',NULL,NULL,5,' '),(1007,0,0,'Dibal Prot TISA',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'98100000','0x0D','%*c%*c%*c%252d%253d',NULL,'',NULL,NULL,5,' '),(1008,0,0,'AM 15',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'W','0x03','%0A%25d.%25d',NULL,'0x0A',NULL,NULL,5,' '),(1009,0,0,'Epelsa Marques B0',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'P','0x0A','P%25d.%25d',NULL,'',NULL,NULL,5,' '),(1010,0,0,'CAS ER PLUS',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0x050xFF0x11','0x03','%25*c%25*c%25*c%25*c%25d.%253d',NULL,'0x02',NULL,NULL,5,' '),(1011,0,0,'Epelsa III',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'$','0x0D','%25d.%25d',NULL,'0',NULL,NULL,5,' '),(1012,0,0,'Dibal Prot Delta',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'D','0x0D','%2B%25d.%25d',NULL,'0x2B',NULL,NULL,5,' '),(1013,0,0,'Ruby 50',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'0x0D','%2B%25d.%25d',NULL,'0x2B',NULL,NULL,5,' ');
/*!40000 ALTER TABLE `devicedrivers` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `devicemanager`
--

DROP TABLE IF EXISTS `devicemanager`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `devicemanager` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `IP` varchar(45) NOT NULL,
  `Port` varchar(45) NOT NULL,
  `Description` varchar(45) NOT NULL,
  `SalesTerminalUID` int(11) NOT NULL,
  `Code` int(11) NOT NULL,
  `print_to_spooler` int(11) DEFAULT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=32 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `devicemanager`
--

LOCK TABLES `devicemanager` WRITE;
/*!40000 ALTER TABLE `devicemanager` DISABLE KEYS */;
INSERT INTO `devicemanager` VALUES (1,0,4,'192.168.187.1','9090','DM1',1,1,NULL),(2,0,5,'127.0.0.1','9090','DM2',1,2,NULL),(3,0,5,'127.0.0.1','9090','DM3',1,3,NULL),(4,0,5,'127.0.0.1','9090','DM4',1,4,NULL),(5,0,5,'127.0.0.1','9090','DM5',1,5,NULL),(6,0,5,'127.0.0.1','9090','DM6',1,6,NULL),(7,0,5,'127.0.0.1','9090','DM7',1,7,NULL),(8,0,5,'127.0.0.1','9090','DM8',1,8,NULL),(9,0,5,'127.0.0.1','9090','DM9',1,9,NULL),(10,0,5,'127.0.0.1','9090','DM10',1,10,NULL),(11,0,5,'127.0.0.1','9090','DM11',1,11,NULL),(12,0,5,'127.0.0.1','9090','DM12',1,12,NULL),(13,0,5,'127.0.0.1','9090','DM13',1,13,NULL),(14,0,5,'127.0.0.1','9090','DM14',1,14,NULL),(15,0,5,'127.0.0.1','9090','DM15',1,15,NULL),(16,0,5,'127.0.0.1','9090','DM16',1,16,NULL),(17,0,5,'127.0.0.1','9090','DM17',1,17,NULL),(18,0,5,'127.0.0.1','9090','DM18',1,18,NULL),(19,0,5,'127.0.0.1','9090','DM19',1,19,NULL),(20,0,5,'127.0.0.1','9090','DM20',1,20,NULL),(21,0,5,'127.0.0.1','9090','DM21',1,21,NULL),(22,0,5,'127.0.0.1','9090','DM22',1,22,NULL),(23,0,5,'127.0.0.1','9090','DM23',1,23,NULL),(24,0,5,'127.0.0.1','9090','DM24',1,24,NULL),(25,0,5,'127.0.0.1','9090','DM25',1,25,NULL),(26,0,5,'127.0.0.1','9090','DM26',1,26,NULL),(27,0,5,'127.0.0.1','9090','DM27',1,27,NULL),(28,0,5,'127.0.0.1','9090','DM28',1,28,NULL),(29,0,5,'127.0.0.1','9090','DM29',1,29,NULL),(30,0,5,'127.0.0.1','9090','DM30',1,30,NULL),(31,0,6,'127.0.0.1','9090','DM31',1,31,NULL);
/*!40000 ALTER TABLE `devicemanager` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `documentcounters`
--

DROP TABLE IF EXISTS `documentcounters`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `documentcounters` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `DataChar` varchar(45) NOT NULL DEFAULT 'Z',
  `SeqNum` int(11) NOT NULL DEFAULT 0,
  `LastSignature` blob DEFAULT NULL,
  `DocumentType` int(11) NOT NULL,
  `SalesTerminal` int(11) NOT NULL DEFAULT 0,
  `Active` int(11) NOT NULL DEFAULT 1,
  `SavedTimestamp` int(10) unsigned NOT NULL DEFAULT 0,
  `ValidationCode` varchar(100) NOT NULL DEFAULT '',
  `CodeFromWS` int(3) DEFAULT 0,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=31 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `documentcounters`
--

LOCK TABLES `documentcounters` WRITE;
/*!40000 ALTER TABLE `documentcounters` DISABLE KEYS */;
INSERT INTO `documentcounters` VALUES (1,'C',0,'',1,0,1,1359133933,'',0),(2,'Z',0,'',17,0,1,0,'',0),(3,'F',0,'',11,0,1,1359137794,'',0),(5,'X',0,'',16,0,1,1359137974,'',0),(6,'P',0,'',21,0,1,1363864995,'',0),(7,'G',0,'',13,0,1,0,'',0),(8,'E',0,'',20,0,1,0,'',0),(9,'S',0,'',1017,0,1,1363864996,'',0),(10,'NC',0,'',25,0,1,1363865032,'',0),(30,'AD',0,NULL,26,0,1,0,'',0);
/*!40000 ALTER TABLE `documentcounters` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `documentparts`
--

DROP TABLE IF EXISTS `documentparts`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `documentparts` (
  `UID` int(11) NOT NULL,
  `RecordDeleted` tinyint(1) NOT NULL DEFAULT 0,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  `PartType` tinyint(4) NOT NULL DEFAULT 1,
  `Contents` blob NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `documentparts`
--

LOCK TABLES `documentparts` WRITE;
/*!40000 ALTER TABLE `documentparts` DISABLE KEYS */;
INSERT INTO `documentparts` VALUES (1,0,57,1,'Cabealho Subtotal',1,'\\FD  \\FN\n\\LE\n\\LM \\LR\n\\LC \\LL\nNIF: \\LF\n---------------------------------------\nData: \\DD, \\DH\n\\DT n: \\DS\n---------------------------------------\nCliente: \\MC\nNIF: \\MN\n----------------------------------------\nQt     Un Desc.        IVA p.unit  total\n----------------------------------------\n'),(2,0,56,2,'Rodap Subtotal',2,'----------------------------------------\n \\FD    Total:\\10MT\\FN\nEmpregado: \\ME \nMesa:           \\MM\n\\DA\n----------------------------------------\nPreencha os seus dados para a factura\nNome:____________________\nNIF :____________________'),(3,0,107,3,'Corpo SubTotal',3,'\\FN\\-6BQ \\-15BN \\3BT \\6BU \\6BV\n\\FN    \\-20BN\\16BV\n'),(4,0,84,4,'Cabecalho Pedido',1,'\\FD   PEDIDO \\DS \\FN\n           \\DD \\DH\n----------------------------------------\n'),(5,0,7,5,'Corpo Pedido',3,'\\FD\\-3BQ \\-16B1\\FN\n\\FN    \\-4BQ \\-30B1\n'),(6,0,83,6,'Rodap do Pedido\n',2,'----------------------------------------\nMesa:           \\MM\nEmpregado: \\ME'),(7,0,88,7,'Cab FacturaVD',1,'\\FD  \\FN\n\\LE\n\\LM \\LR\n\\LC \\LL\nNIF: \\LF\n---------------------------------------\nData: \\DD, \\DH\n\\DT n: \\DS \\DV\n\n\n---------------------------------------\nCliente: \\MC\nNIF: \\MN\n---------------------------------------\nQt     Un Desc.        IVA p.unit  total\n---------------------------------------\n'),(8,0,107,8,'Corpo FacturaVD',3,'\\FN\\-6BQ \\2BI \\-12BN \\3BT \\6BU \\6BV\n\\FN  \\-20BN\\3BT\\15BV\n'),(11,0,89,11,'Rodape Factura VD',2,'----------------------------------------\n \\FD    Total:\\10MT\\FN\nMetodos de Pagamento:\n\\MP\n----------------------------------------\n\\MV\n \nEmpregado: \\ME \nMesa:      \\MM\n\\DO\n\\DA\n*       Obrigado - Volte Sempre        *'),(12,0,84,12,'Cabealho Relatorio',1,'\\FD  \\FN\n\\LE\n\\LM \n\\LC \nNIF: \\LF\n---------------------------------------\nData: \\DD, \\DH\n---------------------------------------\n'),(31,0,80,13,'Rodape Relatorio',2,'\\FN----------------------------------------'),(32,0,108,8,'Cabealho Recibo',1,'\\FN\\-6BQ \\-15BN \\3BT \\6BU \\6BV\n\\FN \\-20BN\\3BT\\15BV\n'),(33,0,114,9,'Rodap Recibo',2,'----------------------------------------\n\\MV\n\\MP'),(34,0,86,10,'Cabealho doc. Sesses',1,'\\FD  \\FN\n---------------------------------------\nData: \\DD, \\DH\n---------------------------------------\n\n---------------------------------------\n'),(35,0,87,14,'Rodap doc. Sesses',2,'----------------------------------------\n \\FD    Total:\\10MT\\FN\n\n---------------------------------------'),(36,0,108,36,'Cabealho Adiantamento',1,'\\FD  \\FN\n\\LE\n\\LM \n\\LC \n\\MC \n\\MN \nNIF: \\LF\n---------------------------------------\nData: \\DD, \\DH\n\\DT n: \\DS\n---------------------------------------'),(37,0,114,37,'Rodap Adiantamento',2,'----------------------------------------\n\\MP'),(50,0,88,7,'Cab FacturaSimp',1,'\\FD  \\FN\n\\LE\n\\LM \\LR\n\\LC \\LL\nNIF: \\LF\n---------------------------------------\nData: \\DD, \\DH\n\\DT n: \\DS \\DV\n---------------------------------------\nNIF: \\MN\n---------------------------------------\nQt     Un Desc.        IVA p.unit  total\n---------------------------------------\n'),(997,0,100,30,'Cab. Relatorio',1,'\\FD  \\FN\n\\LE\n\\LM \n\\LC \nNIF: \\LF\n---------------------------------------\nData: \\DD, \\DH\n---------------------------------------\n'),(998,0,100,31,'Rod. Relatorio',2,'\\FN----------------------------------------'),(1036,0,90,15,'Cab. Nota de credito',1,'\\FD\\LE\\FN\n\\LM \\LR\n\\LC \\LL\nNIF: \\LF\n\n---------------------------------------\n\nData: \\DD, \\DH\n\\DT n: \\DS \\DV\n\\MR\n\n---------------------------------------\n\nCliente: \\MC\nNIF: \\MN\n\n---------------------------------------\n\nQt     Un Desc.        IVA p.unit  total\n---------------------------------------\n'),(1037,0,90,16,'Rod. Nota de credito',2,'----------------------------------------\n \\FD    Total:\\10MT\\FN\nMetodos de Pagamento:\n\\MP\n----------------------------------------\n\\MV\n\nEmpregado: \\ME \nMesa:      \\MM\n\\DO\n\\DA\n*       Obrigado - Volte Sempre        *'),(1038,0,94,17,'Cab. Guia',1,'\\FD\\LE\\FN\n\\LM \\LR\n\\LC \\LL\nNIF: \\LF\n---------------------------------------\nData: \\DD, \\DH\n\\DT n: \\DS \n\\DV\n---------------------------------------\nCliente: \\MC \nNIF: \\MN\n---------------------------------------\nLocal de Carga: \\GL\nLocal de Descarga: \\GU\nHora carga: \\GC\nHora descarga: \\GD\nTransporte: \\GT\nCod.Transporte: \\GI\nQt     Un Desc.        IVA p.unit  total\n---------------------------------------\n'),(1039,0,90,18,'Rod. Guia',2,'----------------------------------------\n \\FD    Total:\\10MT\\FN\n\nEmpregado: \\ME \n\n\\DO\n\\DA\n*       Obrigado - Volte Sempre        *');
/*!40000 ALTER TABLE `documentparts` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `documenttypes`
--

DROP TABLE IF EXISTS `documenttypes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `documenttypes` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL DEFAULT 0,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL DEFAULT 'novo tipo de documento',
  `ShortDescription` varchar(20) NOT NULL,
  `HeaderUID` int(11) NOT NULL DEFAULT 0,
  `FooterUID` int(11) NOT NULL,
  `BodyUID` int(11) NOT NULL,
  `NumberOfColumns` int(11) NOT NULL,
  `DocumentCounterUID` int(11) DEFAULT NULL,
  `DocumentType` int(11) NOT NULL,
  `NumVias` int(11) NOT NULL DEFAULT 1,
  PRIMARY KEY (`UID`),
  KEY `fk_documenttype_has_header` (`HeaderUID`),
  KEY `fk_doctype_has_footer` (`FooterUID`),
  KEY `fk_doctype_has_body` (`BodyUID`),
  KEY `fk_doctype_has_counter` (`DocumentCounterUID`)
) ENGINE=InnoDB AUTO_INCREMENT=1014 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `documenttypes`
--

LOCK TABLES `documenttypes` WRITE;
/*!40000 ALTER TABLE `documenttypes` DISABLE KEYS */;
INSERT INTO `documenttypes` VALUES (1,0,36,1,'Subtotal','Conta',1,2,3,40,0,1,1),(2,0,36,2,'Factura/Recibo','FacRecibo',7,11,8,40,0,17,1),(3,0,36,3,'Pedido','Pedido',4,6,5,40,0,21,1),(4,0,36,4,'Factura','Factura',7,11,8,40,0,11,1),(5,0,43,5,'Recibo','Recibo',32,33,8,40,0,16,1),(6,0,36,6,'Abertura de Caixa','Abertura de Caixa',997,998,8,40,0,2,1),(7,0,36,7,'Movimentos de caixa','Movimentos de caixa',997,998,8,40,0,4,1),(8,0,45,8,'Abertura de sesso','Abertura de sesso',997,998,8,40,0,6,1),(9,0,36,9,'Relatorios','Relatorios',997,998,8,40,0,19,1),(11,0,36,11,'Anulacao','Anulacao',1,2,8,40,0,14,1),(12,0,12,12,'Factura Nao Descriminada','Factura Nao Descrimi',1,2,8,40,0,18,1),(13,0,12,13,'Consumo proprio','Consumo proprio',1,2,8,40,0,5,1),(14,0,40,14,'Documentos manuais','DocMan',1,2,8,40,0,20,1),(15,0,45,10,'Fecho de sesso','Fecho de sesso',997,998,8,40,0,7,1),(16,0,46,15,'Factura simplificada','FacSimp',50,11,8,40,0,1017,1),(1000,0,49,16,'Nota de Crdito','NC',1036,1037,8,40,0,25,1),(1001,0,49,17,'Guia de transporte','Guia',1038,1039,8,40,0,13,1),(1003,0,50,16,'Adiantamento','AD',36,37,8,40,0,26,1),(1004,0,51,105,'Factura Rec.Inf','Factura Rec.Inf',7,11,8,40,0,4011,1),(1005,0,51,100,'Factura Manual','Factura Manual',7,11,8,40,0,2011,1),(1006,0,51,101,'Fac.Simplif. Manual','Fac.Simplif. Manual',50,11,8,40,0,3017,1),(1007,0,51,106,'Fac.Simplif. Rec.Inf','Fac.Simplif. Rec.Inf',50,11,8,40,0,5017,1),(1008,0,51,102,'FacRecibo Manual','FacRecibo Manual',7,11,8,40,0,2017,1),(1009,0,51,107,'FacRecibo Rec.Inf','FacRecibo Rec.Inf',7,11,8,40,0,4017,1),(1010,0,51,103,'Guia Trans. Manual','Guia Trans. Manual',1038,1039,8,40,0,2013,1),(1011,0,51,108,'Guia Trans. Rec.Inf','Guia Trans. Rec.Inf',1038,1039,8,40,0,4013,1),(1012,0,51,104,'Nota Crdito Manual','Nota Crdito Manual',7,11,8,40,0,2025,1),(1013,0,51,109,'Nota Crdito Rec.Inf','Nota Crdito Rec.Inf',7,11,8,40,0,4025,1);
/*!40000 ALTER TABLE `documenttypes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `families`
--

DROP TABLE IF EXISTS `families`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `families` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL DEFAULT 0,
  `Description` varchar(45) NOT NULL DEFAULT 'familia',
  `ShortDescription` varchar(20) DEFAULT NULL,
  `Code` int(11) NOT NULL,
  `DefaultSalesPrice` int(11) NOT NULL DEFAULT 0,
  `DefaultSalesTax` int(11) NOT NULL DEFAULT 0,
  `PropertyUID` int(11) NOT NULL,
  `ComissionGroupUID` int(11) DEFAULT NULL,
  `PrintLocationUID` int(11) DEFAULT NULL,
  `ModifyDate` datetime DEFAULT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_family_has_properties` (`PropertyUID`),
  KEY `fk_family_has_tax` (`DefaultSalesTax`),
  KEY `fk_families_PrintLocations1` (`PrintLocationUID`),
  CONSTRAINT `fk_families_PrintLocations1` FOREIGN KEY (`PrintLocationUID`) REFERENCES `printlocations` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_family_has_properties` FOREIGN KEY (`PropertyUID`) REFERENCES `properties` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_family_has_tax` FOREIGN KEY (`DefaultSalesTax`) REFERENCES `taxes` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `families`
--

LOCK TABLES `families` WRITE;
/*!40000 ALTER TABLE `families` DISABLE KEYS */;
INSERT INTO `families` VALUES (1,0,1,'Familia 1','familia 1',1,1,1,1,NULL,NULL,'2012-01-11 17:26:13');
/*!40000 ALTER TABLE `families` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ffin`
--

DROP TABLE IF EXISTS `ffin`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `ffin` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `FFinMovementNumber` int(11) DEFAULT NULL,
  `Date` varchar(45) DEFAULT NULL,
  `FFinTypesUID` int(11) DEFAULT NULL,
  `DocNumber` varchar(45) DEFAULT NULL,
  `NetValue` varchar(45) DEFAULT NULL,
  `TaxRate` int(11) DEFAULT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ffin`
--

LOCK TABLES `ffin` WRITE;
/*!40000 ALTER TABLE `ffin` DISABLE KEYS */;
/*!40000 ALTER TABLE `ffin` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ffin_paymenttypes`
--

DROP TABLE IF EXISTS `ffin_paymenttypes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `ffin_paymenttypes` (
  `UID` int(11) NOT NULL,
  `Commission` int(11) NOT NULL,
  `Type` int(11) NOT NULL,
  `Description` varchar(45) DEFAULT NULL,
  `synccounter` int(11) DEFAULT NULL,
  `recorddeleted` int(11) DEFAULT NULL,
  `is_deposit` int(11) DEFAULT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ffin_paymenttypes`
--

LOCK TABLES `ffin_paymenttypes` WRITE;
/*!40000 ALTER TABLE `ffin_paymenttypes` DISABLE KEYS */;
INSERT INTO `ffin_paymenttypes` VALUES (1,0,1,'Dinheiro',NULL,NULL,NULL),(2,1000,0,'Multibanco',NULL,NULL,NULL),(3,2000,0,'Visa2',NULL,NULL,NULL);
/*!40000 ALTER TABLE `ffin_paymenttypes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `ffintypes`
--

DROP TABLE IF EXISTS `ffintypes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `ffintypes` (
  `UID` int(11) NOT NULL,
  `description` varchar(45) DEFAULT NULL,
  `synccounter` int(11) DEFAULT NULL,
  `recorddeleted` int(11) DEFAULT NULL
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `ffintypes`
--

LOCK TABLES `ffintypes` WRITE;
/*!40000 ALTER TABLE `ffintypes` DISABLE KEYS */;
INSERT INTO `ffintypes` VALUES (1,'Tipo A',NULL,NULL),(2,'Tipo B',NULL,NULL);
/*!40000 ALTER TABLE `ffintypes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `generalconfig`
--

DROP TABLE IF EXISTS `generalconfig`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `generalconfig` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  `LanguageUID` int(11) NOT NULL,
  `DefaultSalesPrice` int(11) NOT NULL,
  `DefaultTaxUID` int(11) NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_generalconfig_has_language` (`LanguageUID`),
  KEY `fk_generalconfig_has_tax` (`DefaultTaxUID`),
  CONSTRAINT `fk_generalconfig_has_language` FOREIGN KEY (`LanguageUID`) REFERENCES `languages` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_generalconfig_has_tax` FOREIGN KEY (`DefaultTaxUID`) REFERENCES `taxes` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `generalconfig`
--

LOCK TABLES `generalconfig` WRITE;
/*!40000 ALTER TABLE `generalconfig` DISABLE KEYS */;
INSERT INTO `generalconfig` VALUES (1,0,25,'Configurao Geral 1',1,0,1);
/*!40000 ALTER TABLE `generalconfig` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `generalconfigproperties`
--

DROP TABLE IF EXISTS `generalconfigproperties`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `generalconfigproperties` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL DEFAULT 0,
  `SyncCounter` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  `Value` varchar(45) NOT NULL,
  `GeneralConfigUID` int(11) NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_gcproperties_has_generalconfig` (`GeneralConfigUID`),
  CONSTRAINT `fk_gcproperties_has_generalconfig` FOREIGN KEY (`GeneralConfigUID`) REFERENCES `generalconfig` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=29 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `generalconfigproperties`
--

LOCK TABLES `generalconfigproperties` WRITE;
/*!40000 ALTER TABLE `generalconfigproperties` DISABLE KEYS */;
INSERT INTO `generalconfigproperties` VALUES (1,0,25,'shop_code','1000',1),(2,0,25,'font_size','4',1),(3,0,25,'jackpot_value','100000',1),(4,0,25,'default_discount','50',1),(5,0,25,'decimal_separator',',',1),(6,0,25,'decimal_digits','2',1),(7,0,25,'customer_display_message','Obrigado pela sua visita!',1),(8,0,25,'currency_character','',1),(9,0,25,'end_day_time','5',1),(10,0,25,'minimum_invoice_value','10000',1),(11,0,25,'check_printer_status','0',1),(12,0,25,'currency_conversion','1',1),(13,0,25,'check_open_tables_on_close','0',1),(27,0,25,'terminal_use_own_database','1',1),(28,0,25,'ask_on_deletion','0',1);
/*!40000 ALTER TABLE `generalconfigproperties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `helpdictionaries`
--

DROP TABLE IF EXISTS `helpdictionaries`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `helpdictionaries` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL DEFAULT 0,
  `SyncCounter` int(11) NOT NULL,
  `HelpName` varchar(45) NOT NULL,
  `HelpText` longtext NOT NULL,
  `StringID` int(11) NOT NULL,
  `LanguageID` int(11) NOT NULL,
  `Context` varchar(45) DEFAULT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_language_applicationlanguages1` (`LanguageID`),
  CONSTRAINT `fk_helpdict_has_language` FOREIGN KEY (`LanguageID`) REFERENCES `languages` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `helpdictionaries`
--

LOCK TABLES `helpdictionaries` WRITE;
/*!40000 ALTER TABLE `helpdictionaries` DISABLE KEYS */;
/*!40000 ALTER TABLE `helpdictionaries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `hwproperties`
--

DROP TABLE IF EXISTS `hwproperties`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `hwproperties` (
  `UID` int(11) NOT NULL,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  `Value` varchar(45) NOT NULL,
  `TerminalHardwareUID` int(11) NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_HwProperties_TerminalsHardware1` (`TerminalHardwareUID`),
  CONSTRAINT `fk_HwProperties_TerminalsHardware1` FOREIGN KEY (`TerminalHardwareUID`) REFERENCES `terminalshardware` (`UID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `hwproperties`
--

LOCK TABLES `hwproperties` WRITE;
/*!40000 ALTER TABLE `hwproperties` DISABLE KEYS */;
INSERT INTO `hwproperties` VALUES (2,0,4,'PORT','Generic',1);
/*!40000 ALTER TABLE `hwproperties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `iso3166`
--

DROP TABLE IF EXISTS `iso3166`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `iso3166` (
  `UID` int(11) NOT NULL,
  `CountryCode` varchar(3) NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `iso3166`
--

LOCK TABLES `iso3166` WRITE;
/*!40000 ALTER TABLE `iso3166` DISABLE KEYS */;
/*!40000 ALTER TABLE `iso3166` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `languagedictionaries`
--

DROP TABLE IF EXISTS `languagedictionaries`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `languagedictionaries` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL DEFAULT 0,
  `SyncCounter` int(11) NOT NULL,
  `Description` longtext CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `StringID` int(11) NOT NULL,
  `Alias` varchar(50) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `LanguageID` int(11) NOT NULL,
  `Context` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_languagedict_has_language` (`LanguageID`),
  CONSTRAINT `fk_languagedict_has_language` FOREIGN KEY (`LanguageID`) REFERENCES `languages` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=16765 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `languagedictionaries`
--

LOCK TABLES `languagedictionaries` WRITE;
/*!40000 ALTER TABLE `languagedictionaries` DISABLE KEYS */;
INSERT INTO `languagedictionaries` VALUES (1291,0,1,'OK',1,NULL,1,''),(1292,0,1,'Ajuda',2,NULL,1,''),(1293,0,1,'Erro',3,NULL,1,''),(1294,0,1,'No foi possvel gravar',4,NULL,1,''),(1295,0,1,'Cancelar',5,NULL,1,''),(1296,0,1,'No foi possvel guardar as modificaes feitas a: ',6,NULL,1,''),(1297,0,1,'Texto de ajuda para este tpico no foi encontrado!',7,NULL,1,''),(1298,0,1,'Execuo da query falhou!',8,NULL,1,''),(1299,0,1,'No foi possvel apagar artigo da mesa!',9,NULL,1,''),(1300,0,1,'Artigo no existe na mesa',10,NULL,1,''),(1301,0,1,'No foi possvel adicionar artigo  mesa',11,NULL,1,''),(1302,0,1,'No  possvel abrir a mesa',12,NULL,1,''),(1304,0,1,'No foi possvel terminar transao!',14,NULL,1,''),(1305,0,1,'No  possvel carregar dados do dia ',15,NULL,1,''),(1306,0,1,'No foi possvel carregar os detalhes pretendidos!',16,NULL,1,''),(1307,0,1,'artigos na mesa',17,NULL,1,''),(1308,0,1,'metodos de pagamento',18,NULL,1,''),(1309,0,1,'No foi possvel obter os seguintes detalhes: ',19,NULL,1,''),(1310,0,1,'No foi possvel obter o nmero de srie do documento ',20,NULL,1,''),(1311,0,1,'Sub-total',21,NULL,1,''),(1312,0,1,'Factura/Recibo',22,NULL,1,''),(1313,0,1,'No descriminada ',23,NULL,1,''),(1314,0,1,'Relatorios',24,NULL,1,''),(1315,0,1,'Factura',25,NULL,1,''),(1316,0,1,'Anulacoes',26,NULL,1,''),(1317,0,1,'Pedidos',27,NULL,1,''),(1318,0,1,'Recibo',28,NULL,1,''),(1319,0,1,'No  possvel fechar a conta!',29,NULL,1,''),(1322,0,1,'No  possvel actualizar os contadores!',30,NULL,1,''),(1323,0,1,'Descricao',31,NULL,1,''),(1324,0,1,'Descricao Curta',32,NULL,1,''),(1325,0,1,'Codigo',33,NULL,1,''),(1326,0,1,'Comissao',34,NULL,1,''),(1327,0,1,'Facturacao Externa',35,NULL,1,''),(1328,0,1,'Terminal',36,NULL,1,''),(1329,0,1,'Snatch :: Versao DEMO!',37,NULL,1,''),(1330,0,1,'Empregados',38,NULL,1,''),(1331,0,1,'Configuracoes',39,NULL,1,''),(1332,0,1,'Caixas',40,NULL,1,''),(1333,0,1,' Sessoes',41,NULL,1,''),(1334,0,1,'Snatch - Desktop',42,NULL,1,''),(1335,0,1,'No foi possvel encontrar artigo na base de dados',43,NULL,1,''),(1336,0,1,'Moreira',44,NULL,1,''),(1337,0,1,'Gilardino',45,NULL,1,''),(1338,0,1,'Mesa',46,NULL,1,''),(1339,0,1,'Selecao Mesa',47,NULL,1,''),(1340,0,1,'Desktop',48,NULL,1,''),(1341,0,1,'Ecra de Venda',49,NULL,1,''),(1342,0,1,'Fechar Conta',50,NULL,1,''),(1343,0,1,'Pedir',51,NULL,1,''),(1344,0,1,'Gaveta',52,NULL,1,''),(1345,0,1,'Mapa Mesas',53,NULL,1,''),(1346,0,1,'Avancado',54,NULL,1,''),(1347,0,1,'SubTotal',55,NULL,1,''),(1348,0,1,'+',56,NULL,1,''),(1349,0,1,'-',57,NULL,1,''),(1350,0,1,' ',58,'Empty',1,''),(1351,0,1,'Total Mesa',59,NULL,1,''),(1352,0,1,'Mesas',60,NULL,1,''),(1353,0,1,'Selecao Empregado',61,NULL,1,''),(1354,0,1,'Formas Pagamento',62,NULL,1,''),(1355,0,1,'Configs. Gerais',63,NULL,1,''),(1356,0,1,'Menu Tecnico',64,NULL,1,''),(1357,0,1,'Formas Pagamento',65,NULL,1,''),(1358,0,1,'Produtos',66,NULL,1,''),(1359,0,1,'Empregados',67,NULL,1,''),(1360,0,1,'Clientes',68,NULL,1,''),(1361,0,1,'Zonas',69,NULL,1,''),(1362,0,1,'Taxas de IVA',70,NULL,1,''),(1364,0,1,'Novo',72,NULL,1,''),(1365,0,1,'Eliminar',73,NULL,1,''),(1366,0,1,'No foi possvel gravar o mtodo de pagamento: ',74,NULL,1,''),(1367,0,1,'No foi possvel carregar os mtodos de pagamento',75,NULL,1,''),(1368,0,1,'Erro na query executada',76,NULL,1,''),(1369,0,1,'Total Mesa',77,NULL,1,''),(1370,0,1,'Total Pago',78,NULL,1,''),(1371,0,1,'Troco',79,NULL,1,''),(1372,0,1,'1',80,NULL,1,''),(1373,0,1,'2',81,NULL,1,''),(1374,0,1,'5',82,NULL,1,''),(1375,0,1,'10',83,NULL,1,''),(1376,0,1,'20',84,NULL,1,''),(1377,0,1,'50',85,NULL,1,''),(1378,0,1,'Cliente',86,NULL,1,''),(1379,0,1,'NIF',87,NULL,1,''),(1380,0,1,'Pessoas',88,NULL,1,''),(1381,0,1,'Factura',89,NULL,1,''),(1382,0,1,'Nao-Descriminado',90,NULL,1,''),(1384,0,1,'Limpar Lista',92,NULL,1,''),(1385,0,1,'...',93,'App...',1,''),(1386,0,1,'Mesa no encontrada',94,NULL,1,''),(1388,0,1,'Query no retornou nenhum resultado',95,NULL,1,'  '),(1389,0,1,'No foi possvel carregar a permisso pretendida',96,NULL,1,'  '),(1392,0,1,'Query retornou mais do que um resultado',97,NULL,1,' '),(1393,0,1,'No foi possvel guardar as alteraes feitas  permisso',98,NULL,1,' '),(1394,0,1,'No foi possvel guardar nova permisso',99,NULL,1,' '),(1395,0,1,'No foi possvel carregar dados do empregado',100,NULL,1,' '),(1396,0,1,'No foi possvel guardar as modificaes feitas ao empregado',101,NULL,1,' '),(1397,0,1,'No foi possvel guardar novo empregado',102,NULL,1,' '),(1398,0,1,'No foi possvel carregar nivel de empregado',103,NULL,1,' '),(1399,0,1,'No foi possvel guardar modificaes feitas ao nvel de empregado',104,NULL,1,' '),(1402,0,1,'No foi possvel criar novo empregado',105,NULL,1,' '),(1404,0,1,'A mesa j est aberta noutro posto!',107,NULL,1,' '),(1405,0,1,'Valor',108,NULL,1,''),(1406,0,1,'Fehar Conta',109,NULL,1,''),(1408,0,1,'PLUS',110,NULL,1,'PLUS Config'),(1409,0,1,'Descricao',111,NULL,1,'PLUS Config'),(1410,0,1,'Descricao Curta 1',112,NULL,1,'PLUS Config'),(1411,0,1,'Descricao Curta 2',113,NULL,1,'PLUS Config'),(1412,0,1,'Codigo',114,NULL,1,'PLUS Config'),(1413,0,1,'PLU',115,NULL,1,'PLUS Config'),(1414,0,1,'Normal',116,'ITEMTYPE_NORMAL',1,'DROPBOX'),(1415,0,1,'Extra',117,'ITEMTYPE_EXTRA',1,'DROPBOX'),(1416,0,1,'Link',118,'ITEMTYPE_LINK',1,'DROPBOX'),(1417,0,1,'Compensao',119,'ITEMTYPE_COMPENSATION',1,'DROPBOX'),(1418,0,1,'Aberto',120,'ITEMTYPE_OPEN',1,'DROPBOX'),(1419,0,1,'Menu',121,'ITEMTYPE_MENU',1,'DROPBOX'),(1420,0,1,'Preo 1',122,'PRICE1',1,'DROPBOX'),(1421,0,1,'Preo 2',123,'PRICE2',1,'DROPBOX'),(1422,0,1,'Preo 3',124,'PRICE3',1,'DROPBOX'),(1423,0,1,'Preo 4',125,'PRICE4',1,'DROPBOX'),(1424,0,1,'Preo 5',126,'PRICE5',1,'DROPBOX'),(1425,0,1,'XON/XOFF',127,'PORT_FLOW_SOFT',1,'DROPBOX'),(1426,0,1,'Hardware',128,'PORT_FLOW_HARD',1,'DROPBOX'),(1427,0,1,'Sem',129,'PORT_FLOW_NONE',1,'DROPBOX'),(1428,0,1,'Par',130,'PORT_PARITY_PAIR',1,'DROPBOX'),(1429,0,1,'mpar',131,'PORT_PARITY_ODD',1,'DROPBOX'),(1430,0,1,'None',132,'PORT_PARITY_NONE',1,'DROPBOX'),(1431,0,1,'Impressora',133,'TYPE_DEV_WSC',1,'DROPBOX'),(1432,0,1,'Mostrador',134,'TYPE_DEV_DIS',1,'DROPBOX'),(1433,0,1,'Leitor Cartes ',135,'TYPE_DEV_MAG',1,'DROPBOX'),(1434,0,1,'Dallas Key',136,'TYPE_DEV_DAL',1,'DROPBOX'),(1435,0,1,'leitor Cdigo Barras',137,'TYPE_DEV_BAR',1,'DROPBOX'),(1436,0,1,'Balana',138,'TYPE_DEV_WSC',1,'DROPBOX'),(1437,0,1,'Cabealho',139,'PART_TYPE_HEADER',1,'DROPBOX'),(1438,0,1,'Detalhe',140,'PART_TYPE_DETAIL',1,'DROPBOX'),(1439,0,1,'Rodap',141,'PART_TYPE_FOOTER',1,'DROPBOX'),(1440,0,1,'Cor',142,NULL,1,'PLUS Config'),(1441,0,1,'Porta Paralela',143,'TYPE_PORT_PAR',1,'DROPBOX'),(1442,0,1,'Porta Srie',144,'TYPE_PORT_SER',1,'DROPBOX'),(1443,0,1,'Driver Windows',145,'TYPE_PORT_DRV',1,'DROPBOX'),(1444,0,1,'Socket',146,'TYPE_PORT_IPP',1,'DROPBOX'),(1445,0,1,'Hardware',147,'TYPE_PORT_HWP',1,'DROPBOX'),(1446,0,1,'Teclado',148,'TYPE_PORT_KB',1,'DROPBOX'),(1447,0,1,'Ficheiro',149,'TYPE_PORT_FIL',1,'DROPBOX'),(1448,0,1,'Cancelar',150,NULL,1,'PLUS Config'),(1449,0,1,'Erro ao carregar a coleco de registos.',151,NULL,1,''),(1450,0,1,'Erro ao carregar o registo: ',152,NULL,1,''),(1451,0,1,'No foi possvel gravar mtodo de pagamento',153,NULL,1,'Load'),(1452,0,1,'No foi possvel gravar o artigo: ',154,NULL,1,'Save'),(1453,0,1,'Descricao',155,NULL,1,'Tax Config'),(1454,0,1,'Taxa (%)',156,NULL,1,'Tax Config'),(1455,0,1,'Data Expirao',157,NULL,1,'Tax Config'),(1456,0,1,'Tipo Iva',158,NULL,1,'Tax Config'),(1457,0,1,'Regio Iva',159,NULL,1,'Tax Config'),(1458,0,1,'Comentrios',160,NULL,1,'Tax Config'),(1459,0,1,'Taxas de Iva',161,NULL,1,'Tax Config'),(1460,0,1,'Empregados',162,NULL,1,'Salesman Config'),(1461,0,1,'Nome',163,NULL,1,'Salesman Config'),(1462,0,1,'Nome Curto',164,NULL,1,'Salesman Config'),(1463,0,1,'Acesso Mesas',165,NULL,1,'Salesman Config'),(1464,0,1,'Mesa Defeito',166,NULL,1,'Salesman Config'),(1465,0,1,'Cor',167,NULL,1,'Salesman Config'),(1466,0,1,'Num. Carto',168,NULL,1,'Salesman Config'),(1467,0,1,'Cdigo',169,NULL,1,'Salesman Config'),(1468,0,1,'G.Comisso',170,NULL,1,'Salesman Config'),(1469,0,1,'Lim. Comisso Diria',171,NULL,1,'Salesman Config'),(1470,0,1,'Lim. Comisso Trans',172,NULL,1,'Salesman Config'),(1471,0,1,'Nvel Acesso',173,NULL,1,'Salesman Config'),(1472,0,1,'Palavra Passe',174,NULL,1,'Salesman Config'),(1473,0,1,'Comentrios',175,NULL,1,'Salesman Config'),(1474,0,1,'Foto',176,NULL,1,'Salesman Config'),(1475,0,1,'Lngua',177,NULL,1,'Salesman Config'),(1476,0,1,'Lim.Despesas Dirias',178,NULL,1,'Salesman Config'),(1477,0,1,'PVP Consumo',179,NULL,1,'Salesman Config'),(1478,0,1,'Email',180,NULL,1,'Salesman Config'),(1479,0,1,'Endereo 1',181,NULL,1,'Salesman Config'),(1480,0,1,'Endereo 2',182,NULL,1,'Salesman Config'),(1481,0,1,'Cod.Postal',183,NULL,1,'Salesman Config'),(1482,0,1,'Localidade',184,NULL,1,'Salesman Config'),(1483,0,1,'Pas',185,NULL,1,'Salesman Config'),(1484,0,1,'Telefone',186,NULL,1,'Salesman Config'),(1485,0,1,'Telemovel',187,NULL,1,'Salesman Config'),(1486,0,1,'Cdigo',188,NULL,1,'Tax Config'),(1487,0,1,'Caixas',189,NULL,1,'Caixas Config'),(1488,0,1,'Descrio',190,NULL,1,'Caixas Config'),(1489,0,1,'Descrio Curta',191,NULL,1,'Caixas Config'),(1490,0,1,'Cdigo',192,NULL,1,'Caixas Config'),(1491,0,1,'Fundo Maneio',193,NULL,1,'Caixas Config'),(1492,0,1,'Caixa Aberta',194,NULL,1,'Caixas Config'),(1493,0,1,'Clientes',195,NULL,1,'Customers Config'),(1494,0,1,'Nome',196,NULL,1,'Customers Config'),(1495,0,1,'Morada 1',197,NULL,1,'Customers Config'),(1496,0,1,'Morada 2',198,NULL,1,'Customers Config'),(1497,0,1,'Pas',199,NULL,1,'Customers Config'),(1498,0,1,'Empresa',200,NULL,1,'Customers Config'),(1499,0,1,'NIF',201,NULL,1,'Customers Config'),(1500,0,1,'Site',202,NULL,1,'Customers Config'),(1501,0,1,'Limite Crdito',203,NULL,1,'Customers Config'),(1502,0,1,'Carto',204,NULL,1,'Customers Config'),(1503,0,1,'Desconto',205,NULL,1,'Customers Config'),(1504,0,1,'Cdigo',206,NULL,1,'Customers Config'),(1505,0,1,'Saldo',207,NULL,1,'Customers Config'),(1506,0,1,'Usar Desconto Global',208,NULL,1,'Customers Config'),(1507,0,1,'% Vendas para Balano',209,NULL,1,'Customers Config'),(1508,0,1,'Consumo',210,NULL,1,'Customers Config'),(1509,0,1,'Visitas',211,NULL,1,'Customers Config'),(1510,0,1,'ltima Visita',212,NULL,1,'Customers Config'),(1511,0,1,'Cod.Postal',213,NULL,1,'Customers Config'),(1512,0,1,'Cidade',214,NULL,1,'Customers Config'),(1513,0,1,'Telefone',215,NULL,1,'Customers Config'),(1514,0,1,'Telemvel',216,NULL,1,'Customers Config'),(1515,0,1,'Email',217,NULL,1,'Customers Config'),(1516,0,1,'Grupo',218,NULL,1,'Customers Config'),(1517,0,1,'Preo',219,NULL,1,'Customers Config'),(1518,0,1,'Pontos',220,NULL,1,'Customers Config'),(1519,0,1,'Comentrios',221,NULL,1,'Customers Config'),(1520,0,1,'Aviso',222,NULL,1,'Customers Config'),(1521,0,1,'Zonas',223,NULL,1,'Zones Config'),(1522,0,1,'Cdigo',224,NULL,1,'Zones Config'),(1523,0,1,'Descrio',225,NULL,1,'Zones Config'),(1524,0,1,'Descrio Curta',226,NULL,1,'Zones Config'),(1525,0,1,'Intervalo Mesas',227,NULL,1,'Zones Config'),(1526,0,1,'Preo',228,NULL,1,'Zones Config'),(1527,0,1,'Iva',229,NULL,1,'Zones Config'),(1528,0,1,'Usa Mapa Zona',230,NULL,1,'Zones Config'),(1529,0,1,'Preos c/IVA',231,NULL,1,'Zones Config'),(1530,0,1,'Pede nmero pessoas',232,NULL,1,'Zones Config'),(1531,0,1,'Consumo Prprio',233,NULL,1,'Zones Config'),(1532,0,1,'Artigo Automtico',234,NULL,1,'Zones Config'),(1533,0,1,'Valor Mximo Mesa',235,NULL,1,'Zones Config'),(1534,0,1,'Entrega Carto',236,NULL,1,'Zones Config'),(1535,0,1,'Identifica Cliente',237,NULL,1,'Zones Config'),(1536,0,1,'N Artigos Includos',238,NULL,1,'Zones Config'),(1537,0,1,'Pergunta Cliente antes venda',239,NULL,1,'Zones Config'),(1956,0,1,'Desktop',240,'DesktopWindow',1,'SCREEN_DESKTOP'),(1957,0,1,'Mesas',241,'DesktopBtnTables',1,'SCREEN_DESKTOP'),(1959,0,1,'Caixas',243,'DesktopBtnCashDrawers',1,'SCREEN_DESKTOP'),(1960,0,1,'Config',244,'DesktopBtnConfig',1,'SCREEN_DESKTOP'),(1961,0,1,'Seleo Empregado',245,'SalesmanSelectionWindow',1,'SCREEN_SALESMAN_SELECTION'),(1962,0,1,'Seleo Mesa',246,'TableSelectionWindow',1,'SCREEN_TABLE_SELECTION'),(1963,0,1,'Voltar',247,'AppBack',1,'SCREEN_TABLE_SELECTION'),(1964,0,1,'[[99]]',248,'TableEditWindow',1,'SCREEN_TABLE_EDIT'),(1965,0,1,'Sub-Total',249,'TableEditSubTotal',1,'SCREEN_TABLE_EDIT'),(1966,0,1,'Pedir',250,'TableEditOrder',1,'SCREEN_TABLE_EDIT'),(1967,0,1,'+',251,'TableEditAddQtyItemSelected',1,'SCREEN_TABLE_EDIT'),(1968,0,1,'Gaveta',252,'TableEditOpenDrawer',1,'SCREEN_TABLE_EDIT'),(1970,0,1,'-',254,'TableEditRemoveQtyItemSelected',1,'SCREEN_TABLE_EDIT'),(1971,0,1,'Anulaes',255,'TableEditAdvanced',1,'SCREEN_TABLE_EDIT'),(1972,0,1,'Voltar',256,'TableEditTableMap',1,'SCREEN_TABLE_EDIT'),(1973,0,1,'Total',257,'TableEditTotalTable',1,'SCREEN_TABLE_EDIT'),(1974,0,1,'Qt',258,'TableEditQtySelectedItem',1,'SCREEN_TABLE_EDIT'),(1975,0,1,'Configuraes',259,'ConfigurationsWindow',1,'SCREEN_CONFIG_MAIN'),(1976,0,1,'Sesses',260,'SessionsWindow',1,'SCREEN_SESSIONS'),(1977,0,1,'Caixas',261,'CashesWindow',1,'SCREEN_CASHES'),(1980,0,1,'1',264,'TableCloseCurrency1',1,'SCREEN_TABLE_CLOSE'),(1981,0,1,'Total Pago',265,'TableClosePaidValue',1,'SCREEN_TABLE_CLOSE'),(1982,0,1,'Troco',266,'TableCloseChange',1,'SCREEN_TABLE_CLOSE'),(1983,0,1,'2',267,'TableCloseCurrency2',1,'SCREEN_TABLE_CLOSE'),(1984,0,1,'5',268,'TableCloseCurrency3',1,'SCREEN_TABLE_CLOSE'),(1985,0,1,'Valor',269,'TableCloseSelectedValue',1,'SCREEN_TABLE_CLOSE'),(1986,0,1,'10',270,'TableCloseCurrency4',1,'SCREEN_TABLE_CLOSE'),(1987,0,1,'20',271,'TableCloseCurrency5',1,'SCREEN_TABLE_CLOSE'),(1988,0,1,'50',272,'TableCloseCurrency6',1,'SCREEN_TABLE_CLOSE'),(1989,0,1,'Sub-Total',273,'TableCloseSubTotal',1,'SCREEN_TABLE_CLOSE'),(1990,0,1,'...',274,'TableCloseClientSearch',1,'SCREEN_TABLE_CLOSE'),(1991,0,1,'Cliente',275,'TableCloseClientName',1,'SCREEN_TABLE_CLOSE'),(1992,0,1,'NIF',276,'TableCloseFederalTaxIdClient',1,'SCREEN_TABLE_CLOSE'),(1993,0,1,'N Pessoas',277,'TableClosePersonsNumber',1,'SCREEN_TABLE_CLOSE'),(1995,0,1,'Imprime No Desc.',279,'TableCloseNonDetailedInvoice',1,'SCREEN_TABLE_CLOSE'),(1996,0,1,'Voltar',280,'TableCloseCancel',1,'SCREEN_TABLE_CLOSE'),(1998,0,1,'Message2ButtonsWindow',282,'Message2ButtonsWindow',1,'SCREEN_MESSAGEBOX2BUTTONS'),(1999,0,1,'Sim',283,'Message2ButtonsBt1',1,'SCREEN_MESSAGEBOX2BUTTONS'),(2000,0,1,'No',284,'Message2ButtonsBt2',1,'SCREEN_MESSAGEBOX2BUTTONS'),(2001,0,1,'Mensagem',285,'Message2ButtonsMessage',1,'SCREEN_MESSAGEBOX2BUTTONS'),(2002,0,1,'Mensagem',286,'MessageBoxWindow',1,'SCREEN_MESSAGEBOX'),(2003,0,1,'OK',287,'MessageBoxOK',1,'SCREEN_MESSAGEBOX'),(2004,0,1,'Mensagem',288,'MessageBoxShortText',1,'SCREEN_MESSAGEBOX'),(2005,0,1,'Detalhe',289,'MessageBoxLongText',1,'SCREEN_MESSAGEBOX'),(2006,0,1,'Formas Pagamento',290,'PaymentTypesWindow',1,'SCREEN_CONFIG_PAYMENTTYPES'),(2007,0,1,'Descrio curta',291,'PaymentTypesShortDescription',1,'SCREEN_CONFIG_PAYMENTTYPES'),(2008,0,1,'Descrio',292,'PaymentTypesDescription',1,'SCREEN_CONFIG_PAYMENTTYPES'),(2009,0,1,'Cdigo',293,'PaymentTypesCode',1,'SCREEN_CONFIG_PAYMENTTYPES'),(2010,0,1,'Comisso',294,'PaymentTypesComission',1,'SCREEN_CONFIG_PAYMENTTYPES'),(2011,0,1,'Usar em terminais rdio',295,'PaymentTypesHandTerminal',1,'SCREEN_CONFIG_PAYMENTTYPES'),(2012,0,1,'Faturao Externa',296,'PaymentTypesExternalBilling',1,'SCREEN_CONFIG_PAYMENTTYPES'),(2013,0,1,'Cancel',297,'AppCancel',1,'SCREEN_CONFIG_PAYMENTTYPES'),(2014,0,1,'OK',298,'AppOK',1,'SCREEN_CONFIG_PAYMENTTYPES'),(2015,0,1,'Novo',299,'AppNew',1,'SCREEN_CONFIG_PAYMENTTYPES'),(2016,0,1,'Eliminar',300,'AppDelete',1,'SCREEN_CONFIG_PAYMENTTYPES'),(2017,0,1,'Artigos',301,'ItemWindow',1,'SCREEN_CONFIG_ITEMS'),(2018,0,1,'Tipo',302,'ItemType',1,'SCREEN_CONFIG_ITEMS'),(2019,0,1,'Descrio',303,'ItemDescription',1,'SCREEN_CONFIG_ITEMS'),(2020,0,1,'Iva 1',304,'ItemTax1',1,'SCREEN_CONFIG_ITEMS'),(2021,0,1,'Cdigo',305,'ItemCode',1,'SCREEN_CONFIG_ITEMS'),(2022,0,1,'Iva 2',306,'ItemTax2',1,'SCREEN_CONFIG_ITEMS'),(2023,0,1,'Preo 1',307,'ItemPrice1',1,'SCREEN_CONFIG_ITEMS'),(2024,0,1,'Preo 2',308,'ItemPrice2',1,'SCREEN_CONFIG_ITEMS'),(2025,0,1,'Preo 3',309,'ItemPrice3',1,'SCREEN_CONFIG_ITEMS'),(2026,0,1,'Preo 4',310,'ItemPrice4',1,'SCREEN_CONFIG_ITEMS'),(2027,0,1,'Preo 5',311,'ItemPrice5',1,'SCREEN_CONFIG_ITEMS'),(2028,0,1,'Descrio Curta 1',312,'ItemShortDescription1',1,'SCREEN_CONFIG_ITEMS'),(2029,0,1,'Descrio Curta 2',313,'ItemShortDescription2',1,'SCREEN_CONFIG_ITEMS'),(2030,0,1,'Famlia',314,'ItemFamily',1,'SCREEN_CONFIG_ITEMS'),(2031,0,1,'PLU',315,'ItemLookUp',1,'SCREEN_CONFIG_ITEMS'),(2032,0,1,'SubFamlia',316,'ItemSubFamily',1,'SCREEN_CONFIG_ITEMS'),(2033,0,1,'Stock',317,'ItemStock',1,'SCREEN_CONFIG_ITEMS'),(2034,0,1,'Alarme Stock',318,'ItemStockAlarm',1,'SCREEN_CONFIG_ITEMS'),(2035,0,1,'Comentrios',319,'ItemComments',1,'SCREEN_CONFIG_ITEMS'),(2036,0,1,'Controla Stock',320,'ItemStockManagement',1,'SCREEN_CONFIG_ITEMS'),(2037,0,1,'Activo',321,'ItemEnabled',1,'SCREEN_CONFIG_ITEMS'),(2038,0,1,'Cor',322,'ItemColor',1,'SCREEN_CONFIG_ITEMS'),(2039,0,1,'Taxa Converso',323,'ItemWeightConversionPrice',1,'SCREEN_CONFIG_ITEMS'),(2040,0,1,'Tara',324,'ItemTareValue',1,'SCREEN_CONFIG_ITEMS'),(2041,0,1,'Preo Custo',325,'ItemCostPrice',1,'SCREEN_CONFIG_ITEMS'),(2042,0,1,'Imagem',326,'ItemPictureName',1,'SCREEN_CONFIG_ITEMS'),(2043,0,1,'Vdeo',327,'ItemVideoName',1,'SCREEN_CONFIG_ITEMS'),(2044,0,1,'Tempo Max Prep',328,'ItemKdsMaxCookTime',1,'SCREEN_CONFIG_ITEMS'),(2045,0,1,'Tempo Mdio Prep',329,'ItemKdsAvgCookTime',1,'SCREEN_CONFIG_ITEMS'),(2046,0,1,'Leitura Balana',330,'ItemReadQuantityFromScale',1,'SCREEN_CONFIG_ITEMS'),(2047,0,1,'G.Comisso',331,'ItemComissionGroup',1,'SCREEN_CONFIG_ITEMS'),(2048,0,1,'Prxima Pgina',332,'ItemNextItemPage',1,'SCREEN_CONFIG_ITEMS'),(2049,0,1,'Preo Varivel',333,'ItemVariablePrice',1,'SCREEN_CONFIG_ITEMS'),(2050,0,1,'Cdigo Barras',334,'ItemBarCode',1,'SCREEN_CONFIG_ITEMS'),(2051,0,1,'Pontos',335,'ItemSalesPoints',1,'SCREEN_CONFIG_ITEMS'),(2052,0,1,'Ordem Impresso',336,'ItemPrintingOrder',1,'SCREEN_CONFIG_ITEMS'),(2053,0,1,'Localizao Impressora',337,'ItemPrintLocation',1,'SCREEN_CONFIG_ITEMS'),(2054,0,1,'Empregados',338,'SalesmanWindow',1,'SCREEN_CONFIG_SALESMEN'),(2055,0,1,'Nome Curto',339,'SalesmanShortName',1,'SCREEN_CONFIG_SALESMEN'),(2056,0,1,'Nome',340,'SalesmanName',1,'SCREEN_CONFIG_SALESMEN'),(2057,0,1,'Intervalo Mesas',341,'SalesmanTableRange',1,'SCREEN_CONFIG_SALESMEN'),(2058,0,1,'Mesa defeito',342,'SalesmanDefaulTable',1,'SCREEN_CONFIG_SALESMEN'),(2059,0,1,'Cor',343,'SalesmanColor',1,'SCREEN_CONFIG_SALESMEN'),(2060,0,1,'',344,'',1,'SCREEN_CONFIG_SALESMEN'),(2061,0,1,'Carto',345,'SalesmanCard',1,'SCREEN_CONFIG_SALESMEN'),(2062,0,1,'Cdigo',346,'SalesmanID',1,'SCREEN_CONFIG_SALESMEN'),(2063,0,1,'G.Comisso',347,'SalesmanComissionGroup',1,'SCREEN_CONFIG_SALESMEN'),(2064,0,1,'Lim. Dirio Comisso',348,'SalesmanComissionDailyLimit',1,'SCREEN_CONFIG_SALESMEN'),(2065,0,1,'Lim. Transao Comisso',349,'SalesmanComissionTransactionLimit',1,'SCREEN_CONFIG_SALESMEN'),(2066,0,1,'Nvel',350,'SalesmanLevel',1,'SCREEN_CONFIG_SALESMEN'),(2067,0,1,'Comentrios',351,'SalesmanComments',1,'SCREEN_CONFIG_SALESMEN'),(2068,0,1,'Foto',352,'SalesmanPhoto',1,'SCREEN_CONFIG_SALESMEN'),(2069,0,1,'Lngua',353,'SalesmanLanguage',1,'SCREEN_CONFIG_SALESMEN'),(2070,0,1,'L.Cons. Prprio',354,'SalesmanSelfExpLimit',1,'SCREEN_CONFIG_SALESMEN'),(2071,0,1,'PVP Cons. Prprio',355,'SalesmanSelfExpSalesPrice',1,'SCREEN_CONFIG_SALESMEN'),(2072,0,1,'Email',356,'SalesmanEmail',1,'SCREEN_CONFIG_SALESMEN'),(2073,0,1,'Endereo 1',357,'SalesmanAddressLine1',1,'SCREEN_CONFIG_SALESMEN'),(2074,0,1,'Endereo 2',358,'SalesmanAddressLine2',1,'SCREEN_CONFIG_SALESMEN'),(2075,0,1,'Cod.Postal',359,'SalesmanPostalCode',1,'SCREEN_CONFIG_SALESMEN'),(2076,0,1,'Localidade',360,'SalesmanLocality',1,'SCREEN_CONFIG_SALESMEN'),(2077,0,1,'Pas',361,'SalesmanCountry',1,'SCREEN_CONFIG_SALESMEN'),(2078,0,1,'Telefone',362,'SalesmanTelephone',1,'SCREEN_CONFIG_SALESMEN'),(2079,0,1,'Telemovel',363,'SalesmanMobile',1,'SCREEN_CONFIG_SALESMEN'),(2080,0,1,'Palavra-Passe',364,'SalesmanPassword',1,'SCREEN_CONFIG_SALESMEN'),(2081,0,1,'Clientes',365,'CustomerWindow',1,'SCREEN_CONFIG_CUSTOMERS'),(2082,0,1,'Endereo 1',366,'CustomerAddressLine1',1,'SCREEN_CONFIG_CUSTOMERS'),(2083,0,1,'Nome',367,'CustomerName',1,'SCREEN_CONFIG_CUSTOMERS'),(2084,0,1,'Endereo 2',368,'CustomerAddressLine2',1,'SCREEN_CONFIG_CUSTOMERS'),(2085,0,1,'Cod.Postal',369,'CustomerPostalCode',1,'SCREEN_CONFIG_CUSTOMERS'),(2086,0,1,'Pas',370,'CustomerCountry',1,'SCREEN_CONFIG_CUSTOMERS'),(2087,0,1,'Localidade',371,'CustomerLocality',1,'SCREEN_CONFIG_CUSTOMERS'),(2088,0,1,'Telefone',372,'CustomerTelephone',1,'SCREEN_CONFIG_CUSTOMERS'),(2089,0,1,'Email',373,'CustomerEmail',1,'SCREEN_CONFIG_CUSTOMERS'),(2090,0,1,'Telemovel',374,'CustomerMobile',1,'SCREEN_CONFIG_CUSTOMERS'),(2091,0,1,'Saldo',375,'CustomerBalance',1,'SCREEN_CONFIG_CUSTOMERS'),(2092,0,1,'Total Gasto',376,'CustomerTotalSpent',1,'SCREEN_CONFIG_CUSTOMERS'),(2093,0,1,'Nmero Visitas',377,'CustomerNumberVisits',1,'SCREEN_CONFIG_CUSTOMERS'),(2094,0,1,'Grupo Clientes',378,'CustomerGroup',1,'SCREEN_CONFIG_CUSTOMERS'),(2095,0,1,'ltima Visita',379,'CustomerLastVisit',1,'SCREEN_CONFIG_CUSTOMERS'),(2096,0,1,'Preo Venda',380,'CustomerSalesPrice',1,'SCREEN_CONFIG_CUSTOMERS'),(2097,0,1,'Comentrios',381,'CustomerComments',1,'SCREEN_CONFIG_CUSTOMERS'),(2098,0,1,'Pontos',382,'CustomerTotalPoints',1,'SCREEN_CONFIG_CUSTOMERS'),(2099,0,1,'Organizao',383,'CustomerOrganization',1,'SCREEN_CONFIG_CUSTOMERS'),(2100,0,1,'NIF',384,'CustomerFederalTaxID',1,'SCREEN_CONFIG_CUSTOMERS'),(2101,0,1,'Website',385,'CustomerWebsite',1,'SCREEN_CONFIG_CUSTOMERS'),(2102,0,1,'Carto',386,'CustomerCardID',1,'SCREEN_CONFIG_CUSTOMERS'),(2103,0,1,'Limite Crdito',387,'CustomerCreditLimit',1,'SCREEN_CONFIG_CUSTOMERS'),(2104,0,1,'Desconto',388,'CustomerGlobalDiscount',1,'SCREEN_CONFIG_CUSTOMERS'),(2105,0,1,'Cdigo',389,'CustomerID',1,'SCREEN_CONFIG_CUSTOMERS'),(2106,0,1,'Percentagem Venda',390,'CustomerSalesPercentageForBalance',1,'SCREEN_CONFIG_CUSTOMERS'),(2107,0,1,'Aviso',391,'CustomerWarning',1,'SCREEN_CONFIG_CUSTOMERS'),(2108,0,1,'Usar Desconto',392,'CustomerUseGlobalDiscountlbl',1,'SCREEN_CONFIG_CUSTOMERS'),(2109,0,1,'Zonas',393,'ZoneWindow',1,'SCREEN_CONFIG_ZONES'),(2110,0,1,'Descrio Curta',394,'ZoneShortDescription',1,'SCREEN_CONFIG_ZONES'),(2111,0,1,'Descrio',395,'ZoneDescription',1,'SCREEN_CONFIG_ZONES'),(2112,0,1,'Intervalo Mesas',396,'ZoneTableRange',1,'SCREEN_CONFIG_ZONES'),(2113,0,1,'Preo',397,'ZoneSalesPrice',1,'SCREEN_CONFIG_ZONES'),(2114,0,1,'Imposto',398,'ZoneTax',1,'SCREEN_CONFIG_ZONES'),(2116,0,1,'Cdigo',400,'ZoneCode',1,'SCREEN_CONFIG_ZONES'),(2120,0,1,'Artigo Automtico',404,'ZoneAutoPLU',1,'SCREEN_CONFIG_ZONES'),(2121,0,1,'Limite Venda',405,'ZoneTableSalesLimit',1,'SCREEN_CONFIG_ZONES'),(2122,0,1,'Usar Carto',406,'ZoneTableIsCard',1,'SCREEN_CONFIG_ZONES'),(2124,0,1,'Taxas IVA',408,'TaxWindow',1,'SCREEN_CONFIG_TAXES'),(2125,0,1,'Percentagem',409,'TaxRate',1,'SCREEN_CONFIG_TAXES'),(2126,0,1,'Descrio',410,'TaxDescription',1,'SCREEN_CONFIG_TAXES'),(2127,0,1,'Data Expirao',411,'TaxExpirationDate',1,'SCREEN_CONFIG_TAXES'),(2128,0,1,'Tipo Imposto',412,'TaxType',1,'SCREEN_CONFIG_TAXES'),(2129,0,1,'Regio',413,'TaxRegion',1,'SCREEN_CONFIG_TAXES'),(2130,0,1,'Comentrios',414,'TaxComments',1,'SCREEN_CONFIG_TAXES'),(2131,0,1,'Cdigo',415,'TaxCode',1,'SCREEN_CONFIG_TAXES'),(2132,0,1,'Caixas',416,'CashDrawerWindow',1,'SCREEN_CONFIG_CASHDRAWERS'),(2133,0,1,'Descrio Curta',417,'CashDrawerShortDescription',1,'SCREEN_CONFIG_CASHDRAWERS'),(2134,0,1,'Descrio',418,'CashDrawerDescription',1,'SCREEN_CONFIG_CASHDRAWERS'),(2135,0,1,'Fundo Maneio',419,'CashDrawerWorkingFund',1,'SCREEN_CONFIG_CASHDRAWERS'),(2136,0,1,'Caixa Aberta',420,'CashDrawerIsOpen',1,'SCREEN_CONFIG_CASHDRAWERS'),(2137,0,1,'Cdigo',421,'CashDrawerCode',1,'SCREEN_CONFIG_CASHDRAWERS'),(2138,0,1,'Grupos Cliente',422,'ClientGroupsWindow',1,'SCREEN_CONFIG_CLIENTGROUPS'),(2139,0,1,'Descrio',423,'ClientGroupsDescription',1,'SCREEN_CONFIG_CLIENTGROUPS'),(2140,0,1,'Cdigo',424,'ClientGroupsCode',1,'SCREEN_CONFIG_CLIENTGROUPS'),(2141,0,1,'Descrio Curta',425,'ClientGroupsShortDescription',1,'SCREEN_CONFIG_CLIENTGROUPS'),(2142,0,1,'Preo',426,'ClientGroupsPrice',1,'SCREEN_CONFIG_CLIENTGROUPS'),(2143,0,1,'Limite Crdito',427,'ClientGroupsCreditLimit',1,'SCREEN_CONFIG_CLIENTGROUPS'),(2144,0,1,'% Venda',428,'ClientGroupsDeferredDiscount',1,'SCREEN_CONFIG_CLIENTGROUPS'),(2145,0,1,'Desconto',429,'ClientGroupsDiscount',1,'SCREEN_CONFIG_CLIENTGROUPS'),(2146,0,1,'Lnguas',430,'LanguageWindow',1,'SCREEN_CONFIG_LANGUAGES'),(2147,0,1,'Descrio Curta',431,'LanguageShortDescription',1,'SCREEN_CONFIG_LANGUAGES'),(2148,0,1,'Descrio',432,'LanguageDescription',1,'SCREEN_CONFIG_LANGUAGES'),(2149,0,1,'Cdigo',433,'LanguageCode',1,'SCREEN_CONFIG_LANGUAGES'),(2150,0,1,'Ficheiro Linguagem',434,'LanguageFilePath',1,'SCREEN_CONFIG_LANGUAGES'),(2151,0,1,'Imagem',435,'LanguageImagePath',1,'SCREEN_CONFIG_LANGUAGES'),(2152,0,1,'Tipos Documento',436,'DocumentTypeWindow',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2153,0,1,'Descrio Curta',437,'DocumentTypeShortDescription',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2154,0,1,'Descrio',438,'DocumentTypeDescription',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2155,0,1,'Cdigo',439,'DocumentTypeCode',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2156,0,1,'Cabealho',440,'DocumentTypeHeader',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2157,0,1,'Detalhe',441,'DocumentTypeBody',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2158,0,1,'Colunas',442,'DocumentTypeNumberColumns',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2159,0,1,'Rodap',443,'DocumentTypeFooter',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2160,0,1,'Contador',444,'DocumentTypeCounter',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2168,0,1,'ItemPrintingOrderPrice3',445,'ItemPrintingOrderPrice3',1,'SCREEN_CONFIG_ITEMS'),(2169,0,1,'Nomes Mesas',446,'TableNamesWindow',1,'SCREEN_TABLE_NAMES'),(2170,0,1,'Descrio Curta',447,'ItemGroupSelectionShortDescription',1,'SCREEN_CONFIG_ITEMS_GROUP_SELECTION'),(2171,0,1,'Descrio',448,'ItemGroupSelectionDescription',1,'SCREEN_CONFIG_ITEMS_GROUP_SELECTION'),(2172,0,1,'Cdigo',449,'ItemGroupSelectionCode',1,'SCREEN_CONFIG_ITEMS_GROUP_SELECTION'),(2173,0,1,'Descrio',450,'TableNamesDescription',1,'SCREEN_CONFIG_TABLE_NAMES'),(2174,0,1,'Cdigo',451,'TableNamesCode',1,'SCREEN_CONFIG_TABLE_NAMES'),(2175,0,1,'Grupo Comisses',452,'ComissionGroupsWindow',1,'SCREEN_CONFIG_COMISSIONGROUPS'),(2176,0,1,'Descrio Curta',453,'ComissionGroupsShortDescription',1,'SCREEN_CONFIG_COMISSIONGROUPS'),(2177,0,1,'Descrio',454,'ComissionGroupsDescription',1,'SCREEN_CONFIG_COMISSIONGROUPS'),(2178,0,1,'Cdigo',455,'ComissionGroupsCode',1,'SCREEN_CONFIG_COMISSIONGROUPS'),(2179,0,1,'Mximo Valor',456,'ComissionGroupsMaxValue',1,'SCREEN_CONFIG_COMISSIONGROUPS'),(2180,0,1,'Mximo Valor Venda',457,'ComissionGroupsMaxSaleValue',1,'SCREEN_CONFIG_COMISSIONGROUPS'),(2181,0,1,'Hora Incio',458,'ComissionGroupsInitialTime',1,'SCREEN_CONFIG_COMISSIONGROUPS'),(2182,0,1,'Hora Fim',459,'ComissionGroupsEndTime',1,'SCREEN_CONFIG_COMISSIONGROUPS'),(2183,0,1,'Zona',460,'ComissionGroupsZone',1,'SCREEN_CONFIG_COMISSIONGROUPS'),(2184,0,1,'Grupo Seleo Artigos',461,'ItemGroupSelectionWindow',1,'SCREEN_CONFIG_ITEMS_GROUP_SELECTION'),(2185,0,1,'Familias',462,'FamiliesWindow',1,'SCREEN_CONFIG_FAMILIES'),(2186,0,1,'Descrio Curta',463,'FamiliesShortDescription',1,'SCREEN_CONFIG_FAMILIES'),(2187,0,1,'Descrio',464,'FamiliesDescription',1,'SCREEN_CONFIG_FAMILIES'),(2188,0,1,'Cdigo',465,'FamiliesCode',1,'SCREEN_CONFIG_FAMILIES'),(2189,0,1,'Impressora',466,'FamiliesPrintLocation',1,'SCREEN_CONFIG_FAMILIES'),(2190,0,1,'G.Comisso',467,'FamiliesComissionGroup',1,'SCREEN_CONFIG_FAMILIES'),(2191,0,1,'Peso',468,'FamiliesReadFromScale',1,'SCREEN_CONFIG_FAMILIES'),(2192,0,1,'Iva 1',469,'FamiliesTax1',1,'SCREEN_CONFIG_FAMILIES'),(2193,0,1,'Iva 2',470,'FamiliesTax2',1,'SCREEN_CONFIG_FAMILIES'),(2194,0,1,'Preo 1',471,'FamiliesPrice1',1,'SCREEN_CONFIG_FAMILIES'),(2195,0,1,'Preo 2',472,'FamiliesPrice2',1,'SCREEN_CONFIG_FAMILIES'),(2196,0,1,'Preo 3',473,'FamiliesPrice3',1,'SCREEN_CONFIG_FAMILIES'),(2197,0,1,'Preo 4',474,'FamiliesPrice4',1,'SCREEN_CONFIG_FAMILIES'),(2198,0,1,'Preo 5',475,'FamiliesPrice5',1,'SCREEN_CONFIG_FAMILIES'),(2199,0,1,'Preo Custo',476,'FamiliesCostPrice',1,'SCREEN_CONFIG_FAMILIES'),(2200,0,1,'Tipo Artigo',477,'FamiliesItemType',1,'SCREEN_CONFIG_FAMILIES'),(2201,0,1,'Ordem Impresso',478,'FamiliesPrintingOrder',1,'SCREEN_CONFIG_FAMILIES'),(2202,0,1,'Tempo Max Prep.',479,'FamiliesKdsMaxCookTime',1,'SCREEN_CONFIG_FAMILIES'),(2203,0,1,'Tempo Mdio Prep.',480,'FamiliesKdsAvgCookTime',1,'SCREEN_CONFIG_FAMILIES'),(2204,0,1,'Pontos',481,'FamiliesSalesPoints',1,'SCREEN_CONFIG_FAMILIES'),(2205,0,1,'Preo Varivel',482,'FamiliesVariablePrice',1,'SCREEN_CONFIG_FAMILIES'),(2206,0,1,'IVA Defeito',483,'FamiliesDefaultTax',1,'SCREEN_CONFIG_FAMILIES'),(2207,0,1,'Preo Defeito',484,'FamiliesDefaultSalesPrice',1,'SCREEN_CONFIG_FAMILIES'),(2208,0,1,'Factor Converso Peso',485,'FamiliesWeightConverstionFactor',1,'SCREEN_CONFIG_FAMILIES'),(2210,0,1,'Desconto Defeito',487,'SystemConfigDefaultDiscount',1,'SCREEN_CONFIG_SYSTEM'),(2211,0,1,'Cdigo Loja',488,'SystemConfigShopCode',1,'SCREEN_CONFIG_SYSTEM'),(2214,0,1,'Mensagem Visor',491,'SystemConfigScreenMessageToClient',1,'SCREEN_CONFIG_SYSTEM'),(2215,0,1,'Iva Defeito',492,'SystemConfigDefaultTax',1,'SCREEN_CONFIG_SYSTEM'),(2216,0,1,'Sigla Moeda',493,'SystemConfigCurrencySymbol',1,'SCREEN_CONFIG_SYSTEM'),(2217,0,1,'Hora a que muda dia',494,'SystemConfigDayChangeTime',1,'SCREEN_CONFIG_SYSTEM'),(2220,0,1,'Jackpot',497,'SystemConfigJackpot',1,'SCREEN_CONFIG_SYSTEM'),(2221,0,1,'Lngua',498,'SystemConfigLanguage',1,'SCREEN_CONFIG_SYSTEM'),(2222,0,1,'Permisses',499,'UserPermissionsWindow',1,'SCREEN_CONFIG_USER_PERMISSIONS'),(2223,0,1,'Descrio',500,'UserPermissionsDescription',1,'SCREEN_CONFIG_USER_PERMISSIONS'),(2224,0,1,'Cdigo',501,'UserPermissionsCode',1,'SCREEN_CONFIG_USER_PERMISSIONS'),(2225,0,1,'Excluses',502,'ExclusionsWindow',1,''),(2226,0,1,'Descrio',503,'ExclusionsDescription',1,''),(2227,0,1,'Cdigo',504,'ExclusionsCode',1,''),(2228,0,1,'Descrio',505,'TerminalConfigurationDescription',1,''),(2229,0,1,'Cdigo',506,'TerminalConfigurationCode',1,''),(2230,0,1,'Perfis',507,'TerminalConfigurationWindow',1,''),(2232,0,1,'Total',509,'OpenTablesTableTotal',1,'SCREEN_CONFIG_OPEN_TABLES'),(2233,0,1,'Procura Mesa',510,'OpenTablesTableSearch',1,'SCREEN_CONFIG_OPEN_TABLES'),(2234,0,1,'Procura Empregado',511,'OpenTablesSalesmanSearch',1,'SCREEN_CONFIG_OPEN_TABLES'),(2235,0,1,'Total Mesas',512,'OpenTablesTotal',1,'SCREEN_CONFIG_OPEN_TABLES'),(2236,0,1,'Empregado',513,'OpenTablesTableSalesman',1,'SCREEN_CONFIG_OPEN_TABLES'),(2237,0,1,'Eliminar',514,'OpenTablesBtnDeleteTable',1,'SCREEN_CONFIG_OPEN_TABLES'),(2238,0,1,'Imprimir',515,'OpenTablesBtnPrintTable',1,'SCREEN_CONFIG_OPEN_TABLES'),(2239,0,1,'Transf/ Produtos',516,'OpenTablesBtnTransferProducts',1,'SCREEN_CONFIG_OPEN_TABLES'),(2240,0,1,'Transf/ Empregado',517,'OpenTablesBtnTransferSaleman',1,'SCREEN_CONFIG_OPEN_TABLES'),(2241,0,1,'Abrir Mesa',518,'OpenTablesBtnOpenTable',1,'SCREEN_CONFIG_OPEN_TABLES'),(2242,0,1,'Nome Curto',519,'CustomerShortName',1,'SCREEN_CONFIG_CUSTOMERS'),(2243,0,1,'Consulta Registos',520,'DailyJournalWindow',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2244,0,1,'Fechar',521,'AppClose',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2245,1,1,'Intervalo Horas',522,'DailyJournalTimeSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2246,0,1,'Nmero Mesa',523,'DailyJournalTableSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2248,0,1,'Empregado',525,'DailyJournalSalesmanSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2249,0,1,'Documento',526,'DailyJournalDocSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2250,0,1,'Tipo Doc.',527,'DailyJournalDocTypeSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2251,0,1,'Intervalo Datas',528,'DailyJournalDateSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2253,0,1,'Vendedor',530,'DailyJournalSalesman',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2254,0,1,'Nmero Doc.',531,'DailyJournalDocNumber',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2255,0,1,'Mesa',532,'DailyJournalTable',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2256,0,1,'Forma Pagamento',533,'DailyJournalPaymentType',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2257,0,1,'Cliente',534,'DailyJournalCostumer',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2260,0,1,'Emprstimos',537,'CashDrawerLoanWindow',1,'SCREEN_CASHDRAWER_LOAN'),(2261,0,1,'Vendedor',538,'CashDrawerLoanSalesman',1,'SCREEN_CASHDRAWER_LOAN'),(2262,0,1,'Valor',539,'CashDrawerLoanValue',1,'SCREEN_CASHDRAWER_LOAN'),(2263,0,1,'Notas',540,'CashDrawerLoanNotes',1,'SCREEN_CASHDRAWER_LOAN'),(2264,0,1,'Vales',541,'CashDrawerBorrowWindow',1,'SCREEN_CASHDRAWER_BORROW'),(2265,0,1,'Vendedor',542,'CashDrawerBorrowSalesman',1,'SCREEN_CASHDRAWER_BORROW'),(2266,0,1,'Valor',543,'CashDrawerBorrowValue',1,'SCREEN_CASHDRAWER_BORROW'),(2267,0,1,'Notas',544,'CashDrawerBorrowNotes',1,'SCREEN_CASHDRAWER_BORROW'),(2268,0,1,'Pag. Conta Corrente',545,'CashDrawerBalanceSettlementWindow',1,'SCREEN_CASHDRAWER_BALANCESETTLEMENT'),(2269,0,1,'Cliente',546,'CashDrawerBalanceSettlementClient',1,'SCREEN_CASHDRAWER_BALANCESETTLEMENT'),(2270,0,1,'Valor',547,'CashDrawerBalanceSettlementValue',1,'SCREEN_CASHDRAWER_BALANCESETTLEMENT'),(2271,0,1,'Notas',548,'CashDrawerBalanceSettlementNotes',1,'SCREEN_CASHDRAWER_BALANCESETTLEMENT'),(2272,0,1,'Devolues',549,'CashDrawerReturnWindow',1,'SCREEN_CASHDRAWER_RETURN'),(2273,0,1,'Valor',550,'CashDrawerReturnValue',1,'SCREEN_CASHDRAWER_RETURN'),(2274,0,1,'Notas',551,'CashDrawerReturnNotes',1,'SCREEN_CASHDRAWER_RETURN'),(2275,0,1,'Sangria',552,'CashDrawerBleedWindow',1,'SCREEN_CASHDRAWER_BLEED'),(2276,0,1,'Valor',553,'CashDrawerBleedValue',1,'SCREEN_CASHDRAWER_BLEED'),(2277,0,1,'Notas',554,'CashDrawerBleedNotes',1,'SCREEN_CASHDRAWER_BLEED'),(2278,0,1,'Compras',555,'CashDrawerPurchaseWindow',1,'SCREEN_CASHDRAWER_PURCHASE'),(2279,0,1,'Valor',556,'CashDrawerPurchaseValue',1,'SCREEN_CASHDRAWER_PURCHASE'),(2280,0,1,'Notas',557,'CashDrawerPurchaseNotes',1,'SCREEN_CASHDRAWER_PURCHASE'),(2281,0,1,'Cancel',558,'AppCancel',1,''),(2282,0,1,'Fecho Caixa',559,'CloseCashierWindow',1,'SCREEN_CASHIER_CLOSE'),(2283,0,1,'Fecho Dia',560,'CloseCashierBtnClose',1,'SCREEN_CASHIER_CLOSE'),(2284,0,1,'Abrir Caixa',561,'OpenCashierWindow',1,'SCREEN_CASHIER_OPEN'),(2285,0,1,'Abrir Caixa',562,'OpenCashierBtnOpens',1,'SCREEN_CASHIER_OPEN'),(2287,0,1,'Abrir Sesso',564,'OpenSessionBtnOpens',1,'SCREEN_SESSION_OPEN'),(2288,0,1,'Fecho Sesso',565,'CloseSessionWindow',1,'SCREEN_SESSION_CLOSE'),(2289,0,1,'Fechar Sesso',566,'CloseSessionBtnClose',1,'SCREEN_SESSION_CLOSE'),(2291,0,1,'Imprimir Sesso',568,'PrintSessionBtnPrint',1,'SCREEN_SESSION_PRINT'),(2292,0,1,'Abrir Caixa',569,'OpenCashierBtnOpen',1,'SCREEN_CASHIER_OPEN'),(2293,0,1,'Devolues',570,'TableReturnWindow',1,'SCREEN_TABLE_RETURN'),(2294,0,1,'Descontos',571,'TableDiscountsWindow',1,'SCREEN_TABLE_DISCOUNTS'),(2295,0,1,'Diviso Conta',572,'TableCheckSplitWindow',1,'SCREEN_TABLE_CHECK_SPLIT'),(2296,0,1,'Transferncia Produtos',573,'TableProductTransfWindow',1,'SCREEN_TABLE_PRODUCT_TRANSF'),(2297,0,1,'%',574,'TableDiscountsLineDiscount',1,'SCREEN_TABLE_DISCOUNTS'),(2298,0,1,'Valor c/Desconto',575,'TableDiscountsLineDiscountValue',1,'SCREEN_TABLE_DISCOUNTS'),(2299,0,1,'Valor Original',576,'TableDiscountsLineOriValue',1,'SCREEN_TABLE_DISCOUNTS'),(2300,0,1,'Valor c/Desconto',577,'TableDiscountsLineDiscValue',1,'SCREEN_TABLE_DISCOUNTS'),(2301,0,1,'Desconto',578,'TableDiscountsLineDisc',1,'SCREEN_TABLE_DISCOUNTS'),(2302,0,1,'Desconto',579,'TableDiscountsDocDiscount',1,'SCREEN_TABLE_DISCOUNTS'),(2303,0,1,'Valor c/Desconto',580,'TableDiscountsDocDiscountValue',1,'SCREEN_TABLE_DISCOUNTS'),(2304,0,1,'Valor Original',581,'TableDiscountsDocOriValue',1,'SCREEN_TABLE_DISCOUNTS'),(2305,0,1,'Valor c/Desconto',582,'TableDiscountsDocDiscValue',1,'SCREEN_TABLE_DISCOUNTS'),(2306,0,1,'Desconto',583,'TableDiscountsDocDisc',1,'SCREEN_TABLE_DISCOUNTS'),(2307,0,1,'Diviso Conta',584,'TableCheckSplitWindow',1,'SCREEN_TABLE_CHECK_SPLIT'),(2308,0,1,'Total',585,'TableCheckSplitTotalCheck',1,'SCREEN_TABLE_CHECK_SPLIT'),(2309,0,1,'Total por Pagar',586,'TableCheckSplitTotalUnpaid',1,'SCREEN_TABLE_CHECK_SPLIT'),(2310,0,1,'N Contas',587,'TableCheckSplitPayersNum',1,'SCREEN_TABLE_CHECK_SPLIT'),(2311,0,1,'Montante Conta',588,'TableCheckSplitParcialAmmount',1,'SCREEN_TABLE_CHECK_SPLIT'),(2312,0,1,'Limite Conta',589,'TableCheckSplitParcialLimit',1,'SCREEN_TABLE_CHECK_SPLIT'),(2317,0,1,'Processo Automtico',594,'TableCheckSplitBtnAutomatic',1,'SCREEN_TABLE_CHECK_SPLIT'),(2318,0,1,'Correo',595,'TableCheckSplitCorrection',1,'SCREEN_TABLE_CHECK_SPLIT'),(2319,0,1,'Transferncia Produtos',596,'TableProductTransfWindow',1,'SCREEN_TABLE_PRODUCT_TRANSF'),(2320,0,1,'Mesa Origem',597,'TableProductTransfTableFrom',1,'SCREEN_TABLE_PRODUCT_TRANSF'),(2321,0,1,'Mesa Destino',598,'TableProductTransfTableTo',1,'SCREEN_TABLE_PRODUCT_TRANSF'),(2322,0,1,'Nova Famlia',599,'FamiliesNewFamily',1,'SCREEN_CONFIG_FAMILIES'),(2323,0,1,'Nova SubFamlia',600,'FamiliesNewSubFamily',1,'SCREEN_CONFIG_FAMILIES'),(2403,0,1,'Descrio',663,'UserProfilesDescription',1,'SCREEN_CONFIG_TABLE_NAMES'),(2404,0,1,'Cdigo',664,'UserProfilesCode',1,'SCREEN_CONFIG_TABLE_NAMES'),(2408,0,1,'Sesses',667,'ScreenMenuSessions',1,'SCREEN_MENU'),(2409,0,1,'Caixas',668,'ScreenMenuCashDrawers',1,'SCREEN_MENU'),(2410,0,1,'Consultas',669,'ScreenMenuConsulting',1,'SCREEN_MENU'),(2411,0,1,'Verifica estado das impressoras',670,'check_printers_status',1,'GENERAL_CONFIG'),(2414,0,1,'O Terminal deve usar a prpria Base de Dados',673,'terminal_use_own_database',1,'GENERAL_CONFIG'),(2415,0,1,'Hora Incio',674,'ProfileStartTime',1,'SCREEN_CONFIG_PROFILES'),(2416,0,1,'Hora Fim',675,'ProfileEndTime',1,'SCREEN_CONFIG_PROFILES'),(2417,0,1,'Preo',676,'ProfileSalesPrice',1,'SCREEN_CONFIG_PROFILES'),(2418,0,1,'Desconto (%)',677,'ProfileDiscountPercentage',1,'SCREEN_CONFIG_PROFILES'),(2419,0,1,'Terminais',678,'ProfileTerminals',1,'SCREEN_CONFIG_PROFILES'),(2420,0,1,'Zonas',679,'ProfileZones',1,'SCREEN_CONFIG_PROFILES'),(2421,0,1,'Segunda-Feira',680,'ProfileMonday',1,'SCREEN_CONFIG_PROFILES'),(2422,0,1,'Tera-Feira',681,'ProfileTuesday',1,'SCREEN_CONFIG_PROFILES'),(2423,0,1,'Quarta-Feira',682,'ProfileWednesday',1,'SCREEN_CONFIG_PROFILES'),(2424,0,1,'Quinta-feira',683,'ProfileThursday',1,'SCREEN_CONFIG_PROFILES'),(2425,0,1,'Sexta-Feira',684,'ProfileFriday',1,'SCREEN_CONFIG_PROFILES'),(2426,0,1,'Sbado',685,'ProfileSaturday',1,'SCREEN_CONFIG_PROFILES'),(2427,0,1,'Domingo',686,'ProfileSunday',1,'SCREEN_CONFIG_PROFILES'),(2428,0,1,'Dispositivos',687,'DeviceManagerWindow',1,'SCREEN_CONFIG_DEVICES'),(2429,0,1,'Novo M.Dispositivo',688,'DeviceManagerButtonNewDeviceManager',1,'SCREEN_CONFIG_DEVICES'),(2430,0,1,'Novo Dispositivo',689,'DeviceManagerButtonNewDevice',1,'SCREEN_CONFIG_DEVICES'),(2431,0,1,'Cod Terminal',690,'DeviceManagerCode',1,'SCREEN_CONFIG_DEVICES'),(2432,0,1,'Nome',691,'DeviceManagerName',1,'SCREEN_CONFIG_DEVICES'),(2433,0,1,'IP',692,'DeviceManagerIP',1,'SCREEN_CONFIG_DEVICES'),(2434,0,1,'Porta',693,'DeviceManagerPort',1,'SCREEN_CONFIG_DEVICES'),(2435,0,1,'Init Terminal',694,'DeviceManagerTerminal',1,'SCREEN_CONFIG_DEVICES'),(2436,0,1,'Tipo Dispositivo',695,'DeviceManagerDeviceType',1,'SCREEN_CONFIG_DEVICES'),(2437,0,1,'Descrio',696,'DeviceManagerDeviceDescription',1,'SCREEN_CONFIG_DEVICES'),(2438,0,1,'Driver',697,'DeviceManagerDeviceDriver',1,'SCREEN_CONFIG_DEVICES'),(2439,0,1,'Porta',698,'DeviceManagerDevicePort',1,'SCREEN_CONFIG_DEVICES'),(2440,0,1,'Tipo Porta',699,'DeviceManagerPortType',1,'SCREEN_CONFIG_DEVICES'),(2441,0,1,'Nome',700,'DeviceManagerPortName',1,'SCREEN_CONFIG_DEVICES'),(2442,0,1,'Baud Rate',701,'DeviceManagerPortBaudRate',1,'SCREEN_CONFIG_DEVICES'),(2443,0,1,'Flow',702,'DeviceManagerPortFlow',1,'SCREEN_CONFIG_DEVICES'),(2444,0,1,'Bit',703,'DeviceManagerPortBit',1,'SCREEN_CONFIG_DEVICES'),(2445,0,1,'Stop',704,'DeviceManagerPortStop',1,'SCREEN_CONFIG_DEVICES'),(2446,0,1,'Parity',705,'DeviceManagerPortParity',1,'SCREEN_CONFIG_DEVICES'),(2447,0,1,'Impressoras',706,'PrintersWindow',1,'SCREEN_CONFIG_PRINTERS'),(2448,0,1,'Cabealho',707,'PrintersHeaderType',1,'SCREEN_CONFIG_PRINTERS'),(2449,0,1,'Detalhe',708,'PrintersDetailType',1,'SCREEN_CONFIG_PRINTERS'),(2450,0,1,'Descrio',709,'PrintersDescription',1,'SCREEN_CONFIG_PRINTERS'),(2451,0,1,'Cdigo',710,'PrintersCode',1,'SCREEN_CONFIG_PRINTERS'),(2452,0,1,'Perfis',711,'ProfileWindow',1,'SCREEN_CONFIG_PROFILES'),(2453,0,1,'Descrio',712,'ProfileDescription',1,'SCREEN_CONFIG_PROFILES'),(2454,0,1,'Cdigo',713,'ProfileCode',1,'SCREEN_CONFIG_PROFILES'),(2455,0,1,'Terminais',714,'TerminalsWindow',1,'SCREEN_CONFIG_TERMINALS'),(2456,0,1,'Descrio',715,'TerminalsDescription',1,'SCREEN_CONFIG_TERMINALS'),(2457,0,1,'Cdigo',716,'TerminalsCode',1,'SCREEN_CONFIG_TERMINALS'),(2458,0,1,'Timeout',717,'TerminalsTimeout',1,'SCREEN_CONFIG_TERMINALS'),(2459,0,1,'Preo',718,'TerminalsPrice',1,'SCREEN_CONFIG_TERMINALS'),(2460,0,1,'Mesa',719,'TerminalsTable',1,'SCREEN_CONFIG_TERMINALS'),(2461,0,1,'Caixa',720,'TerminalsCashDrawer',1,'SCREEN_CONFIG_TERMINALS'),(2462,0,1,'Centro Custo',721,'TerminalsCostCenter',1,'SCREEN_CONFIG_TERMINALS'),(2587,0,1,'Abertura de Gaveta',722,'ST_OPEN_DRAWER',1,'SALES_TERMINAL_PROPERTIES'),(2588,0,1,'Impresso do Sub-Total no Pedido',723,'ST_PRINT_SUBTOTAL_ON_PLU_ORDER         ',1,'SALES_TERMINAL_PROPERTIES'),(2589,0,1,'Ao fechar mesa, pedir e imprimir Sub-Total',724,'ST_ORDER_AND_PRINT_SUB_TOTAL_ON_CLOSE',1,'SALES_TERMINAL_PROPERTIES'),(2590,0,1,'Sub-Total Pequeno',725,'ST_SMALL_SUB_TOTAL',1,'SALES_TERMINAL_PROPERTIES'),(2591,0,1,'Pedido de todas as mesas',726,'ST_ORDER_ALL_TABLES_AT_ONCE',1,'SALES_TERMINAL_PROPERTIES'),(2592,0,1,'Tem leitor de cartes',727,'ST_HAS_CARD_READER',1,'SALES_TERMINAL_PROPERTIES'),(2594,0,1,'Empregado pode entrar em todas as mesas',729,'ST_SALESMAN_CAN_ENTER_ALL_TABLES',1,'SALES_TERMINAL_PROPERTIES'),(2595,0,1,'Empregado controla um PLU',730,'ST_SALESMAN_OWNS_PLU',1,'SALES_TERMINAL_PROPERTIES'),(2596,0,1,'Mostra nome Empregado nos botes das mesas',731,'ST_SHOW_SALESMAN_NAME',1,'SALES_TERMINAL_PROPERTIES'),(2597,0,1,'Mostra artigos com a cor do Empregado',732,'ST_SHOW_PLUS_WITH_SALESMAN_COLOR',1,'SALES_TERMINAL_PROPERTIES'),(2598,0,1,'Pedido Automtico dos artigos',733,'ST_AUTO_ORDER_PLU',1,'SALES_TERMINAL_PROPERTIES'),(2600,0,1,'Desenha acumulado ao invs de pedir',735,'ST_DRAW_ACCUMULATE_INSTEAD_OF_ORDER',1,'SALES_TERMINAL_PROPERTIES'),(2601,0,1,'Mostra acumulado',736,'ST_SHOW_ACCUMULATE',1,'SALES_TERMINAL_PROPERTIES'),(2603,0,1,'Entrada Automtica',738,'ST_AUTO_COUVERT',1,'SALES_TERMINAL_PROPERTIES'),(2604,0,1,'Modo Take-away',739,'ST_TAKE_AWAY_MODE',1,'SALES_TERMINAL_PROPERTIES'),(2605,0,1,'Artigo pertencente ao Empregado do fecho',740,'ST_PLU_OWNED_BY_CLOSING_SALESMAN',1,'SALES_TERMINAL_PROPERTIES'),(2606,0,1,'Consumo Fixo',741,'ST_FIXED_CONSUMPTION',1,'SALES_TERMINAL_PROPERTIES'),(2607,0,1,'Modo Cantina',742,'ST_CANTEEN_MODE',1,'SALES_TERMINAL_PROPERTIES'),(2608,0,1,'Lana Front End',743,'ST_PRINT_RECEIPT_DUPLICATE',1,'SALES_TERMINAL_PROPERTIES'),(2609,0,1,'Impresso do mapa de IVA\'s no recibo',744,'ST_PRINT_TAX_TABLE_IN_RECEIPT',1,'SALES_TERMINAL_PROPERTIES'),(2610,0,1,'Apenas uma moeda',745,'ST_ONE_CURRENCY',1,'SALES_TERMINAL_PROPERTIES'),(2611,0,1,'Modo Pub',746,'ST_PUB_MODE',1,'SALES_TERMINAL_PROPERTIES'),(2612,0,1,'Lana Device Manager',747,'ST_PRINT_A4_RECEIPT',1,'SALES_TERMINAL_PROPERTIES'),(2614,0,1,'Cabealhos Rodaps',749,'DocumentPartsWindow',1,'SCREEN_CONFIG_DOCUMENTPARTS'),(2615,0,1,'Descrio',750,'DocumentPartsDescription',1,'SCREEN_CONFIG_DOCUMENTPARTS'),(2616,0,1,'Cdigo',751,'DocumentPartsCode',1,'SCREEN_CONFIG_DOCUMENTPARTS'),(2617,0,1,'Tipo',752,'DocumentPartsType',1,'SCREEN_CONFIG_DOCUMENTPARTS'),(2618,0,1,'',753,'DocumentPartsContent',1,'SCREEN_CONFIG_DOCUMENTPARTS'),(2620,0,1,'Procurar',755,'DailyJournalBtnSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2621,0,1,'Total:',756,'TableProductTransfTableFromAmmount',1,'SCREEN_TABLE_PRODUCT_TRANSF'),(2624,0,1,'Hora Inicio',759,'DailyJournalTimeFromSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2625,0,1,'Total De',760,'DailyJournalTotalFromSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2626,0,1,'Data Inic.',761,'DailyJournalDateFromSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2627,0,1,'Hora Final',762,'DailyJournalTimeToSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2628,0,1,'Data Final',763,'DailyJournalDateToSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2629,0,1,'Total At',764,'DailyJournalTotalToSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2630,0,1,'Limpar',765,'DailyJournalBtnCleanFilters',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2631,0,1,'Intervalo Datas',766,'DailyJournalDateSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2632,0,1,'QT:',767,'TableProductTransfQt',1,'SCREEN_TABLE_PRODUCT_TRANSF'),(2634,0,1,'Gorjeta',769,'TableCloseTip',1,'SCREEN_TABLE_CLOSE'),(2635,0,1,'Critrios Filtragem',770,'DailyJournalSearchCaption',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2636,0,1,'Detalhes Documento',771,'DailyJournalDetailsCaption',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2637,0,1,'Imprimir Sub-Total',772,'DailyJournalBtnPrintSubTotal',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2638,0,1,'Valor desejado',773,'TableCloseTargetSalesValue',1,'SCREEN_TABLE_CLOSE'),(2639,0,1,'Correco',774,'TableCloseUseCorrectionItem',1,'SCREEN_TABLE_CLOSE'),(2640,0,1,'QT:',775,'TableCloseQt',1,'SCREEN_TABLE_CLOSE'),(2641,0,1,'Pagamento parcial',776,'TableCloseBtPartial',1,'SCREEN_TABLE_CLOSE'),(2642,0,1,'Contas mltiplas',777,'TableCloseBtMultiple',1,'SCREEN_TABLE_CLOSE'),(2643,0,1,'Diviso automtica',778,'TableCloseBtAutomaticSplit',1,'SCREEN_TABLE_CLOSE'),(2644,0,1,'+',779,'TableCloseBtAddPartial',1,'SCREEN_TABLE_CLOSE'),(2645,0,1,'Conta nica',780,'TableCloseBtCancelPartial',1,'SCREEN_TABLE_CLOSE'),(2646,0,1,'-',781,'TableCloseBtRemovePartial',1,'SCREEN_TABLE_CLOSE'),(2647,0,1,'Tipo',782,'DocumentTypeType',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2648,0,1,'Cab. subtotais',783,'PrintersDocumentType0',1,'SCREEN_CONFIG_PRINTERS'),(2649,0,1,'Cab. pedidos',784,'PrintersDocumentType1',1,'SCREEN_CONFIG_PRINTERS'),(2650,0,1,'Consulta de mesa',785,'DocTypeSubtotal',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2651,0,1,'Factura',786,'DocTypeInvoice',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2652,0,1,'Invoice Copy',787,'DocTypeInvoiceCopy',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2653,0,1,'Guia de Transporte',788,'DocTypeVoided',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2654,0,1,'Anulao Sem Desperdicio',789,'DocTypeRefundNoWaste',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2655,0,1,'Anulao Com Desperdicio',790,'DocTypeRefundWaste',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2656,0,1,'Recibo',791,'DocTypeReceipt',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2657,0,1,'Factura\\Recibo',792,'DocTypeFacReceipt',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2658,0,1,'Factura No descriminada',793,'DocTypeNdesc',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2659,0,1,'Abertura de Caixa',794,'DocTypeOpenDrawer',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2660,0,1,'Declarao de Caixa',795,'DocTypeCashDeclare',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2661,0,1,'Movimento de Caixa',796,'DocTypeCashMovemet',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2662,0,1,'Consumo prprio',797,'DocTypeConsumo',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2663,0,1,'Conta corrente',798,'DocTypeContaCorrente',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2664,0,1,'Relatrios',799,'DocTypeReport',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2665,0,1,'Pedidos',800,'DocTypePedidos',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(2666,0,1,'Normal',801,'PaymentTypeNormal',1,'SCREEN_CONFIG_PAYMENT_TYPES'),(2667,0,1,'Dinheiro',802,'PaymenTypeCash',1,'SCREEN_CONFIG_PAYMENT_TYPES'),(2668,0,1,'Facturao externa',803,'PaymentTypeExternalBilling',1,'SCREEN_CONFIG_PAYMENT_TYPES'),(2669,0,1,'Conta corrente',804,'PaymentTypeChargeAccount',1,'SCREEN_CONFIG_PAYMENT_TYPES'),(2670,0,1,'Tipos pag.',805,'PaymentTypesTypes',1,'SCREEN_CONFIG_PAYMENTTYPES'),(2673,0,1,'Empregados',806,'ExclusionsSalesmanLabel',1,'SCREEN_CONFIG_EXCLUSIONS'),(2674,0,1,'Zonas',807,'ExclusionsZonesLabel',1,'SCREEN_CONFIG_EXCLUSIONS'),(2675,0,1,'Famlias',808,'ExclusionsFamiliesLabel',1,'SCREEN_CONFIG_EXCLUSIONS'),(2676,0,1,'SubFamlias',809,'ExclusionsSubFamiliesLabel',1,'SCREEN_CONFIG_EXCLUSIONS'),(2677,0,1,'Perfis',810,'ExclusionsProfilesLabel',1,'SCREEN_CONFIG_EXCLUSIONS'),(2678,0,1,'No pode excluir todos os empregados!|Por favore seleccione pelo menos um empregado.',811,'ExclusionsMsgBox1',1,'SCREEN_CONFIG_EXCLUSIONS'),(2679,0,1,'Excluses',812,'ProfileExclusions',1,'SCREEN_CONFIG_PROFILES'),(2680,0,1,'Carto',813,'TableCloseClientCardID',1,'SCREEN_TABLE_CLOSE'),(2681,0,1,'Este produto est inactivo. ',814,'MSG_PRODUCT_NOTACTIVE',1,'MSGBOX'),(2682,0,1,'O ltimo registo no pode ser eliminado.',815,'MSG_DELETE_LAST_ELEMENT_LIST',1,'MSGBOX'),(2683,0,1,'Ocorreu uma situao inesperada ao eliminar o registo. Por favor tente novamente.',816,'MSG_GENERAL_ERROR_ON_DELETE',1,'MSGBOX'),(2684,0,1,'Perguntar antes eliminar um registo',817,'ask_on_deletion',1,'GENERAL_CONFIG'),(2685,0,1,'Aviso|Tem a certeza que deseja eliminar o registo?',818,'MSG_ARE_U_SURE_DUDE',1,'MSGBOX'),(2686,0,1,'Aviso|Tem certeza que quer anular este documento?',819,'DailyJournalConfirmRefund',1,'MSGBOX'),(2687,0,1,'Aviso|Este documento j foi anulado!',820,'DailyJournalCantRefund',1,'MSG_BOX'),(2688,0,1,'Erro|No foi possvel guardar alteraes ao documento!',821,'Generic',1,'MSG_BOX'),(2689,0,1,'Estado',822,'DailyJournalDocumentState',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2690,0,1,'Normal',823,'DailyJournalDocumentStateString',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2691,0,1,'Anulado',824,'DailyJournalDocumentStateString',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2692,0,1,'Todos',825,'Generic',1,'GENERIC'),(2693,0,1,'Esta impressora no pode ser apagada',826,'PrinterLocationsWarning',1,'PRINTER_MAPS'),(2694,0,1,'Default',827,'DropBoxText',1,'DEFAULT_TEXT'),(2695,0,1,'Erro ao gravar a entidade.',828,'MSG_ENTITY_SAVE',1,'MSGBOX'),(2696,0,1,'Erro ao adicionar a entidade ',829,'MSG_ENTITY_ADD',1,'MSGBOX'),(2697,0,1,'Erro ao atualizar a entidade ',830,'MSG_ENTITY_UPDATE',1,'MSGBOX'),(2698,0,1,'Erro ao ler a entidade ',831,'MSG_ENTITY_LOAD',1,'MSGBOX'),(2699,0,1,'No foi possvel fechar a mesa!',832,'MSG_TABLE_CLOSE_FAILED',1,'SCREEN_TABLE_CLOSE'),(2700,0,1,'No existem artigos na mesa!',833,'MSG_TABLE_EDIT',1,'SCREEN_TABLE_EDIT'),(2701,0,1,'No pode efectuar esta operao|Este documento j foi anulado',834,'MSG_DAILY_JOURNAL',1,'SCREEN_DAILY_JOURNAL'),(2702,0,1,'Aviso!|Este parcial tem artigos\\nQuer transferi-los para a mesa de origem?',835,'MSG_TABLE_CLOSE',1,'SCREEN_TABLE_CLOSE'),(2703,0,1,'Aviso!|Tem que ter pelo menos um parcial!',836,'MSG_TABLE_CLOSE',1,'SCREEN_TABLE_CLOSE'),(2704,0,1,'Sem excluses',837,'ProfilesExclusionDropBox',1,'SCREEN_CONFIG_ESCLUSIONS'),(2705,0,1,'IVA1',838,'ItemTaxIndex0',1,'SCREEN_CONFIG_ZONES'),(2706,0,1,'IVA2',839,'ItemTaxIndex1',1,'SCREEN_CONFIG_ZONES'),(2709,0,1,'Aviso|No possui permisso para aceder a esta funcionalidade.',842,'MSG_PERMISSION_DENIED',1,'MSGBOX'),(2710,0,1,'Licenciamento',843,'LicencesWindow',1,'SCREEN_LICENCES'),(2711,0,1,'Continuar',844,'BtnContinue1',1,'SCREEN_LICENCES'),(2712,0,1,'Cancelar',845,'BtnCancel',1,'SCREEN_LICENCES'),(2713,0,1,'Utilizador',846,'LicencesUser',1,'SCREEN_LICENCES'),(2714,0,1,'Continuar',847,'BtnContinue2',1,'SCREEN_LICENCES'),(2715,0,1,'Voltar',848,'BtnBack',1,'SCREEN_LICENCES'),(2716,0,1,'Senha',849,'LicencesPwd',1,''),(2717,0,1,'Ficheiro de licenciamento',850,'LicencesFile',1,''),(2719,0,1,'O artigo no pode ser adicionado. J atingiu o seu limite mximo de venda.',852,'MsgBoxTableEditCantAddMore',1,'SCREEN_TABLE_EDIT'),(2721,0,1,'Indique o valor desejado|',854,'MsgBoxAskPrice',1,'SCREEN_TABLE_EDIT'),(2722,0,1,'Data Fecho Dia',855,'CloseCashierDayClose',1,'SCREEN_CASHIER_CLOSE'),(2723,0,1,'',856,'CloseCashierDay',1,'SCREEN_CASHIER_CLOSE'),(2724,0,1,'',857,'CloseCashierMonth',1,'SCREEN_CASHIER_CLOSE'),(2725,0,1,'',858,'CloseCashierYear',1,'SCREEN_CASHIER_CLOSE'),(2726,0,1,'Aviso|No possui permisses para aceder a mesas de outros empregados.',859,NULL,1,NULL),(2727,0,1,'Filtro',860,'ItemFilters',1,'SCREEN_CONFIG_ITEMS'),(2728,0,1,'TerminalsC',861,'TerminalsC',1,'SCREEN_CONFIG_TERMINALS'),(2729,0,1,'Gaveta',862,'TerminalsCDDevice',1,'SCREEN_CONFIG_TERMINALS'),(2730,0,1,'Normal',863,'DocStatusNormal',1,NULL),(2731,0,1,'Anulado',864,'DocStatusAnulate',1,NULL),(2732,0,1,'Estado',865,'DailyJournalStatusSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2733,0,1,'Tipo',866,'DailyJournalDocumentType',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2734,0,1,'Empregado',867,'OpenTablesSalesman',1,'SCREEN_CONFIG_OPEN_TABLES'),(2735,0,1,'Sub-Total',868,'OpenTablesBtnSubTotal',1,'SCREEN_CONFIG_OPEN_TABLES'),(2736,0,1,'Transferir Artigos',869,'OpenTablesBtnProdutTransfer',1,'SCREEN_CONFIG_OPEN_TABLES'),(2737,0,1,'Fechar Mesa',870,'OpenTablesBtnCloseTable',1,'SCREEN_CONFIG_OPEN_TABLES'),(2738,0,1,'Limpar Mesa',871,'OpenTablesBtnCleanTable',1,'SCREEN_CONFIG_OPEN_TABLES'),(2740,0,1,'Erro|No tem permisso para anular artigos',873,'DailyJournalRefundMessageBox',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(2741,0,1,'Aviso|A mesa de destino no pode ser a mesa de origem!\\nPor favor seleccione outra mesa.',874,'TransferMsgBox',1,'SCREEN_PRODUCT_TRANSFER'),(2743,0,1,'Aviso|Este artigo no se encontra activo!',876,'TableEditMsgBoxCanAddItem',1,'SCREEN_TABLE_EDIT'),(2744,0,1,'Aviso|As formas de pagamento devem ser maiores que o total dos artigos!',877,'TableCloseMessageBOx',1,'SCREEN_TABLE_CLOSE'),(2745,0,1,'',878,'CloseCashierSaftDay',1,'SCREEN_CASHIER_CLOSE'),(2746,0,1,'',879,'CloseCashierSaftMonth',1,'SCREEN_CASHIER_CLOSE'),(2747,0,1,'',880,'CloseCashierSaftYear',1,'SCREEN_CASHIER_CLOSE'),(2748,0,1,'Aviso|Pretende transferir esta(s) mesa(s) para ',881,'OpenTablesMsgBox',1,'SCREEN_CONFIG_OPEN_TABLES'),(2750,0,1,'Abertura',883,'OpenTablesOpenTime',1,'SCREEN_CONFIG_OPEN_TABLES'),(2751,0,1,'Actividade',884,'OpenTablesLastActivity',1,'SCREEN_CONFIG_OPEN_TABLES'),(2752,0,1,'Erro|No foi possvel guardar alteraes  mesa!',885,'OpenTablesErrorMsgBox',1,'SCREEN_CONFIG_OPEN_TABLES'),(2753,0,1,'Aviso|Pretende transferir todas as mesas?',886,'OoenTablesMessageBox2',1,'SCREEN_CONFIG_OPEN_TABLES'),(2754,0,1,'Relatrios',887,'ReportsWindow',1,'SCREEN_REPORTS'),(2755,0,1,'Data',888,'ReportSingleDate',1,'SCREEN_REPORTS'),(2756,0,1,'Empregado',889,'ReportSalesman',1,'SCREEN_REPORTS'),(2757,0,1,'Imprimir',890,'ReportBtnPrint',1,'SCREEN_REPORTS'),(2758,0,1,'',891,'ReportPreview',1,'SCREEN_REPORTS'),(2759,0,1,'Pr-visualizar',892,'ReportBtnPreview',1,'SCREEN_REPORTS'),(2760,0,1,'Modo Utilizao',893,'ReportHint',1,'SCREEN_REPORTS'),(2761,0,1,'N1 do D.L.N346/85 de 23 de Agosto',894,'MSG_IVATABACO',1,'MSG INSENAO'),(2762,0,1,'',895,'ReportsDay',1,'SCREEN_REPORTS'),(2763,0,1,'',896,'ReportsMonth',1,'SCREEN_REPORTS'),(2764,0,1,'',897,'ReportsYear',1,'SCREEN_REPORTS'),(2765,0,1,'Desconto de linha',898,'TableDiscountsLblLinel',1,'SCREEN_TABLE_DISCOUNTS'),(2766,0,1,'Reset',899,'TableDiscountsTableReset',1,'SCREEN_TABLE_DISCOUNTS'),(2767,0,1,'Desconto Todas Linhas',900,'TableDiscountsLblHeader',1,'SCREEN_TABLE_DISCOUNTS'),(2768,0,1,'',901,'TableDiscountsLineQt',1,'SCREEN_TABLE_DISCOUNTS'),(2769,0,1,'-',902,'TableDiscountsDecrementLineQt',1,'SCREEN_TABLE_DISCOUNTS'),(2770,0,1,'+',903,'TableDiscountsIncrementLineQt',1,'SCREEN_TABLE_DISCOUNTS'),(2771,0,1,'- 1%',904,'TableDiscountsDecrementLineDiscount',1,'SCREEN_TABLE_DISCOUNTS'),(2772,0,1,'+ 1%',905,'TableDiscountsIncrementLineDiscount',1,'SCREEN_TABLE_DISCOUNTS'),(2773,0,1,'0%',906,'TableDiscountsLineDiscount1',1,'SCREEN_TABLE_DISCOUNTS'),(2774,0,1,'5%',907,'TableDiscountsLineDiscount2',1,'SCREEN_TABLE_DISCOUNTS'),(2775,0,1,'10%',908,'TableDiscountsLineDiscount3',1,'SCREEN_TABLE_DISCOUNTS'),(2776,0,1,'25%',909,'TableDiscountsLineDiscount4',1,'SCREEN_TABLE_DISCOUNTS'),(2777,0,1,'50%',910,'TableDiscountsLineDiscount5',1,'SCREEN_TABLE_DISCOUNTS'),(2778,0,1,' ',911,'TableDiscountsHeaderQt',1,'SCREEN_TABLE_DISCOUNTS'),(2779,0,1,'-',912,'TableDiscountsDecrementHeaderQt',1,'SCREEN_TABLE_DISCOUNTS'),(2780,0,1,'+',913,'TableDiscountsIncrementHeaderQt',1,'SCREEN_TABLE_DISCOUNTS'),(2781,0,1,'',914,'TableDiscountsHeaderDiscount',1,'SCREEN_TABLE_DISCOUNTS'),(2782,0,1,'- 1%',915,'TableDiscountsDecrementHeaderDiscount',1,'SCREEN_TABLE_DISCOUNTS'),(2783,0,1,'+ 1%',916,'TableDiscountsIncrementHeaderDiscount',1,'SCREEN_TABLE_DISCOUNTS'),(2784,0,1,'0%',917,'TableDiscountsHeaderDiscount1',1,'SCREEN_TABLE_DISCOUNTS'),(2785,0,1,'5%',918,'TableDiscountsHeaderDiscount2',1,'SCREEN_TABLE_DISCOUNTS'),(2786,0,1,'10%',919,'TableDiscountsHeaderDiscount3',1,'SCREEN_TABLE_DISCOUNTS'),(2787,0,1,'25%',920,'TableDiscountsHeaderDiscount4',1,'SCREEN_TABLE_DISCOUNTS'),(2788,0,1,'50%',921,'TableDiscountsHeaderDiscount5',1,'SCREEN_TABLE_DISCOUNTS'),(2789,0,1,'Total c/ desconto',922,'TableDiscountsTotalWithDiscount',1,'SCREEN_TABLE_DISCOUNTS'),(2790,0,1,'Total s/ desconto',923,'TableDiscountsTotalWithoutDiscount',1,'SCREEN_TABLE_DISCOUNTS'),(2791,0,1,'Total Desconto',924,'TableDiscountsTotalDiscount',1,'SCREEN_TABLE_DISCOUNTS'),(2792,0,1,'Caixa',925,'OpenSessionCashDrawers',1,'SCREEN_SESSION_OPEN'),(2793,0,1,'Fundo maneio',926,'OpenSessionWorkingFund',1,'SCREEN_SESSION_OPEN'),(2795,0,1,'Fechar Sesso',928,NULL,1,'SCREEN_SESSION_CLOSE'),(2796,0,1,'Abertura Caixa',929,'CashDrawerOpenWindow',1,'SCREEN_CASHIER_OPEN'),(2797,0,1,'Abrir Caixa',930,'CashDrawerOpenBtnOpens',1,'SCREEN_CASHIER_OPEN'),(2798,0,1,'Fundo Maneio',931,'CashDrawerOpenWorkingFund',1,'SCREEN_CASHIER_OPEN'),(2799,0,1,'Fechar Caixa',932,'CashDrawerCloseWindow',1,'SCREEN_CASHIER_CLOSE'),(2801,0,1,' ',934,'CashDrawerCloseDay',1,'SCREEN_CASHIER_CLOSE'),(2802,0,1,' ',935,'CashDrawerCloseMonth',1,'SCREEN_CASHIER_CLOSE'),(2803,0,1,' ',936,'CashDrawerCloseYear',1,'SCREEN_CASHIER_CLOSE'),(2804,0,1,' ',937,'CashDrawerCloseSaftDay',1,'SCREEN_CASHIER_CLOSE'),(2805,0,1,' ',938,'CashDrawerCloseSaftMonth',1,'SCREEN_CASHIER_CLOSE'),(2806,0,1,' ',939,'CashDrawerCloseSaftYear',1,'SCREEN_CASHIER_CLOSE'),(2807,0,1,'Fechar Caixa',940,'CashDrawerCloseBtnClose',1,'SCREEN_CASHIER_CLOSE'),(2808,0,1,'Fundo',941,'CashDrawerCloseFund',1,'SCREEN_CASHIER_CLOSE'),(2809,0,1,'Fechar Caixa',942,' ',1,'SCREEN_CASHIER_CLOSE'),(2810,0,1,'Saft',944,'DayCloseWindow',1,'SCREEN_DAY_CLOSE'),(2811,0,1,'Saft',943,'DayCloseCaption',1,'SCREEN_DAY_CLOSE'),(2812,0,1,'Valor',945,'CashDrawerCloseSelectedValue',1,'SCREEN_CASHIER_CLOSE'),(2813,0,1,'Total Caixa',946,'CashDrawerCloseTotal',1,'SCREEN_CASHIER_CLOSE'),(2814,0,1,'Move Baixo',947,'FamiliesOrderDown',1,'SCREEN_CONFIG_FAMILIES'),(2815,0,1,'Move Cima',948,'FamiliesOrderUp',1,'SCREEN_CONFIG_FAMILIES'),(2816,0,1,'Nova Famlia',949,'FamiliesNewItemFamily',1,'SCREEN_CONFIG_FAMILIES'),(2817,0,1,'Aviso|Pretende mudar para o perfil ',950,'ProfileChange',1,'SCREEN_TABLE_EDIT'),(2818,0,1,'Aviso|O perfil actual expirou!\\n\\nPretende manter o perfil [1] (no) ou mudar para [2](sim)?',951,'ProfileChange',1,'SCREEN_TABLE_EDIT'),(2820,0,1,'Activar Perfil',953,'ProfilesManagement',1,'SCREEN_PROFILES_SELECTION'),(2821,0,1,'Aviso|Tem a certeza que quer activar o perfil ',954,'ProfilesManagement',1,'SCREEN_PROFILES_SELECTION'),(2822,0,1,'Aviso|Tem a certeza que quer desactivar o perfil ',955,'ProfilesManagement',1,'SCREEN_PROFILES_SELECTION'),(2823,0,1,'Aviso|O perfil activo para as configuraes actuais mudou. Quer activar o perfil ',956,'Profiles',1,'SCREEN_CONFIG_PROFILES'),(2824,0,1,'Empregados',957,'ExclusionsCustomersLabel',1,'SCREEN_CONFIG_EXCLUSIONS'),(2825,0,1,'AppBacks',958,'AppBacks',1,'SCREEN_DAY_CLOSE'),(2826,0,1,'Aviso|No pode ter artigos com nome vazio!',959,'CallbackNoItemName',1,'SCREEN_CONFIG_ITEMS'),(2827,0,1,'Substituir dados em falta por \'omisso\'',960,'CashDrawerCloseBtnGerarOmissos',1,'SCREEN_DAY_CLOSE'),(2829,0,1,'Aviso|Este cabealho/rodap est a ser usado!\\nPor favor altere os tipos de documento que o usam para poder elimin-lo!',961,'Docpart removal check',1,'SCREEN_CONFIG_DOCUMENTPARTS'),(2830,0,1,'Aviso|Deseja sair da aplicao?',964,'',1,NULL),(2831,0,1,'Aviso|Deseja sair da aplicao?',962,'',1,NULL),(2833,0,1,'Fecho Dia',965,NULL,1,NULL),(2836,0,1,'Aviso|Funcionalidade ainda no implementada.',968,'App',1,NULL),(2837,0,1,'Preos',969,'TableEditPriceChange',1,'SCREEN_TABLE_EDIT'),(2838,0,1,'Histrico',970,'TableEditHistoric',1,'SCREEN_TABLE_EDIT'),(2839,0,1,'Acumular Mesas',971,'TableEditJoinTables',1,'SCREEN_TABLE_EDIT'),(2841,0,1,'Ajuda',973,'DocumentPartsHints',1,'SCREEN_CONFIG_DOCUMENTPARTS'),(2842,0,1,'No foi possvel gravar mapa da zona',974,'ZoneErrorStr',1,'ZoneSave'),(2843,0,1,'No foi possvel gravar as propriedades da zona',975,'ZoneErrorStr',1,'ZoneSave'),(2844,0,1,'No foi possvel gravar zona',976,'ZoneErrorStr',1,'ZoneSave'),(2845,0,1,'No foi possvel guardar nova entidade',977,'GenericSaveError',1,'SaveError'),(2846,0,1,'No foi possvel guardar as modificaes feitas  entidade',978,'GenericSaveError',1,'SaveError'),(2847,0,1,'No foi possvel carregar entidade',979,'GenericLoadError',1,'LoadError'),(2848,0,1,'No foi possvel carregar zonas',980,'ZoneLoadError',1,'ZoneLoad'),(2849,0,1,'erro ao carregar as propriedades',981,'ZoneLoadError',1,'ZoneLoad'),(2850,0,1,'erro ao carregar os mapas',982,'ZoneLoadError',1,'ZoneLoad'),(2851,0,1,'No foi possvel carregar a zona pretendida',983,'ZoneLoadError',1,'ZoneLoad'),(2852,0,1,'No foi possvel gravar Configurao Geral',984,'GeneralConfigZSaveError',1,'GeneralConfigSave'),(2853,0,1,'DELETE no executado',985,'GenericDeleteError',1,'Generic'),(2855,0,1,'NIF',987,'NewClientNIF',1,''),(2856,0,1,'Nome',988,'NewClientName',1,''),(2857,0,1,'Localidade',989,'NewClientLocality',1,''),(2858,0,1,'Erro|No foi possvel efectuar a ligao  base de dados!\\nNo  possvel continuar!',990,'DatabaseConnectError',1,'PreDesktopError'),(2859,0,1,'Erro|No existe configurao para este posto',991,'NoConfigurationError',1,'PreDesktopError'),(2860,0,1,'Erro|Tem que ter uma licena vlida no servidor para licenciar este posto',992,'NoLicenseError',1,'PreDesktopError'),(2861,0,1,'Ocorreram erros ao carregar a tabela ',993,'DatabaseLoadError',1,'PreDesktopError'),(2862,0,1,'No foi possvel carregar a mesa:',994,'LoadTable',1,'ScreenTableEdit'),(2863,0,1,'',995,'ReportsDay2',1,'SCREEN_REPORTS'),(2864,0,1,'',996,'ReportsMonth2',1,'SCREEN_REPORTS'),(2865,0,1,'',997,'ReportsYear2',1,'SCREEN_REPORTS'),(2866,0,1,'Produto',998,'ReportsItemName',1,'SCREEN_REPORTS'),(2867,0,1,'Guarda registos na base de dados do posto',999,'SalesTerminalPropertyString',1,''),(2868,0,1,'Socket',1000,'DeviceManagerDeviceTextSocket',1,'SCREEN_CONFIG_DEVICES'),(2869,0,1,'IP',1001,'DeviceManagerDeviceTextIP',1,'SCREEN_CONFIG_DEVICES'),(2870,0,1,'Nome',1002,'DeviceManagerDeviceTextName',1,'SCREEN_CONFIG_DEVICES'),(2873,0,1,'DeviceManagerDeviceName',1003,'DeviceManagerDeviceName',1,'SCREEN_CONFIG_DEVICES'),(2874,0,1,'Nome Mesa',1004,'TableNamesTableName',1,'SCREEN_TABLE_NAMES'),(2875,0,1,'Zonas',1005,'TableNamesZones',1,'SCREEN_TABLE_NAMES'),(2876,0,1,'Terminal',1007,'CashDrawerOpenTerminal',1,'SCREEN_CASHIER_OPEN'),(2877,0,1,'Comandos rdio',1008,'TecConfigOption',1,'SCREEN_CONFIG'),(2878,0,1,'Terminais rdio',1009,'RadioTerminalsWindow',1,'SCREEN_CONFIG_RADIO_TERMINALS'),(2879,0,1,'Porta Srie em uso:',1010,'RadioTerminalsSerial',1,'SCREEN_CONFIG_RADIO_TERMINALS'),(2880,0,1,'Configurao activa:',1011,'RadioTerminalsConfig',1,'SCREEN_CONFIG_RADIO_TERMINALS'),(2881,0,1,'Estas operaes s esto disponveis em terminais que tenham antenas rdio X64',1012,'RadioTerminalsComments',1,'SCREEN_CONFIG_RADIO_TERMINALS'),(2882,0,1,'Enviar PLUs',1013,'RadioTerminalsSendPlus',1,'SCREEN_CONFIG_RADIO_TERMINALS'),(2883,0,1,'Enviar string',1014,'RadioTerminalsSendMenus',1,'SCREEN_CONFIG_RADIO_TERMINALS'),(2884,0,1,'Enviar formas pag.',1015,'RadioTerminalsSendPaymentTypes',1,'SCREEN_CONFIG_RADIO_TERMINALS'),(2885,0,1,'Enviar config. do comando',1016,'RadioTerminalsSendConfig',1,'SCREEN_CONFIG_RADIO_TERMINALS'),(2886,0,1,'Pede pessoas',1017,'RadioTerminalsAskPpl',1,'SCREEN_CONFIG_RADIO_TERMINALS'),(2887,0,1,'Pede met. pag.',1018,'RadioTerminalsAskPaymentTypes',1,'SCREEN_CONFIG_RADIO_TERMINALS'),(2888,0,1,'Iluminao',1019,'RadioTerminalsLight',1,'SCREEN_CONFIG_RADIO_TERMINALS'),(2890,0,1,'Eliminar Licena',1020,'LicencesDelete',1,'SCREEN_CONFIG_LICENCE'),(2891,0,1,'Dados Licena',1021,'LicencesDetail',1,'SCREEN_CONFIG_LICENCE'),(2893,0,1,' ',1023,'MovementsPrintTimeFromSearch',1,'SCREEN_MOVEMENTS_PRINT'),(2894,0,1,' ',1024,'MovementsPrintTotalFromSearch',1,'SCREEN_MOVEMENTS_PRINT'),(2895,0,1,' ',1025,'MovementsPrintDateFromSearch',1,'SCREEN_MOVEMENTS_PRINT'),(2896,0,1,'Empregado',1026,'MovementsPrintSalesman',1,'SCREEN_MOVEMENTS_PRINT'),(2897,0,1,'Procurar',1027,'MovementsPrintBtnSearch',1,'SCREEN_MOVEMENTS_PRINT'),(2898,0,1,' ',1028,'MovementsPrintTimeToSearch',1,'SCREEN_MOVEMENTS_PRINT'),(2899,0,1,' ',1029,'MovementsPrintDateToSearch',1,'SCREEN_MOVEMENTS_PRINT'),(2900,0,1,' ',1030,'MovementsPrintTotalToSearch',1,'SCREEN_MOVEMENTS_PRINT'),(2901,0,1,'Intervalo Horas',1031,'MovementsPrintTimeSearch',1,'SCREEN_MOVEMENTS_PRINT'),(2902,0,1,'Intervalo Datas',1032,'MovementsPrintDateSearch',1,'SCREEN_MOVEMENTS_PRINT'),(2903,0,1,'Intervalo Totais',1033,'MovementsPrintTotalCaption',1,'SCREEN_MOVEMENTS_PRINT'),(2904,0,1,'Limpar',1034,'MovementsPrintBtnCleanFilters',1,'SCREEN_MOVEMENTS_PRINT'),(2905,0,1,'Detalhes',1035,'MovementsPrintDetailsCaption',1,'SCREEN_MOVEMENTS_PRINT'),(2906,0,1,'Imprimir',1036,'MovementsPrintBtnPrint',1,'SCREEN_MOVEMENTS_PRINT'),(2907,0,1,'Empregado',1037,'MovementsPrintSalesmanSearch',1,'SCREEN_MOVEMENTS_PRINT'),(2908,0,1,'Tipo Movimento',1038,'MovementsPrintMovementTypeSearch',1,'SCREEN_MOVEMENTS_PRINT'),(2909,0,1,'Critrios Pesquisa',1039,'MovementsPrintSearchCaption',1,'SCREEN_MOVEMENTS_PRINT'),(2910,0,1,'Tipo Mov.',1040,'MovementsPrintMovementType',1,'SCREEN_MOVEMENTS_PRINT'),(2911,0,1,'Data/Hora',1041,'MovementsPrintDatetime',1,'SCREEN_MOVEMENTS_PRINT'),(2912,0,1,'Valor',1042,'MovementsPrintValue',1,'SCREEN_MOVEMENTS_PRINT'),(2913,0,1,'Caixas',1043,'MovementsPrintCasdrawerSearch',1,'SCREEN_MOVEMENTS_PRINT'),(2914,0,1,'Descrio',1044,'MovementsPrintDescription',1,'SCREEN_MOVEMENTS_PRINT'),(2915,0,1,'Caixa',1045,'MovementsPrintCashDrawer',1,'SCREEN_MOVEMENTS_PRINT'),(2916,0,1,'Novo Movimento',1046,'ScreenMovementsWindow',1,'SCREEN_MOVEMENTS'),(2917,0,1,'Descritivo',1047,'ScreenMovementsDescription',1,'SCREEN_MOVEMENTS'),(2918,0,1,'Valor',1048,'ScreenMovementsValue',1,'SCREEN_MOVEMENTS'),(2919,0,1,'Movimento',1049,'ScreenMovementsMovType',1,'SCREEN_MOVEMENTS'),(2920,0,1,'Empregado',1050,'ScreenMovementsSalesman',1,'SCREEN_MOVEMENTS'),(2921,0,1,'Cliente',1051,'ScreenMovementsClientName',1,'SCREEN_MOVEMENTS'),(2922,0,1,'115 Vendas - Descontos',1052,NULL,1,'TABLE EDIT'),(2923,0,1,'116 Vendas - Fecha Mesas Abertas ( consulta)',1053,NULL,1,'OPENTABLES'),(2925,0,1,'Pagamento CC',1055,'CustomerAccountWindow',1,'SCREEN_CUSTOMER_ACCOUNT'),(2926,0,1,'Saldo',1056,'CustomerAccountBalance',1,'SCREEN_CUSTOMER_ACCOUNT'),(2927,0,1,'Pagar',1057,'CustomerAccountBthPay',1,'SCREEN_CUSTOMER_ACCOUNT'),(2928,0,1,'A Pagar',1058,'CustomerAccountPayable',1,'SCREEN_CUSTOMER_ACCOUNT'),(2929,0,1,'Cliente',1059,'CustomerAccountClientName',1,'SCREEN_CUSTOMER_ACCOUNT'),(2930,0,1,'215 Sesses - Perfis',1072,'PERM_SESSIONS_PROFILES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2931,0,1,'213 Sesses - SAFT',1071,'PERM_SESSIONS_SAFT',1,'SALESMAN_LEVEL_PERMISSIONS'),(2932,0,1,'213 Sesses - Relatrios',1070,'PERM_SESSIONS_REPORTS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2934,0,1,'210 Sesses - Consulta Registos',1068,'PERM_SESSIONS_DAILY_JOURNAL',1,'SALESMAN_LEVEL_PERMISSIONS'),(2935,0,1,'209 Sesses - Fecho Dia',1067,'PERM_SESSIONS_CLOSE_DAY',1,'SALESMAN_LEVEL_PERMISSIONS'),(2937,0,1,'207 Sesses - Pagamento Conta Corrente',1065,'PERM_SESSIONS_CC',1,'SALESMAN_LEVEL_PERMISSIONS'),(2938,0,22,'206 Sesses - Sadas Caixa',1064,'PERM_SESSIONS_CASHDRAWER_OUT',1,'SALESMAN_LEVEL_PERMISSIONS'),(2939,0,1,'205 Sesses - Entradas Caixa',1063,'PERM_SESSIONS_CASHDRAWER_IN',1,'SALESMAN_LEVEL_PERMISSIONS'),(2940,0,1,'204 Sesses - Fechar Caixa',1062,'PERM_SESSIONS_CLOSE_CASHDRAWER',1,'SALESMAN_LEVEL_PERMISSIONS'),(2944,0,1,'113 Vendas - Acumula Cartes',1006,'PERM_SALESMAN_ACUMULATE',1,'SALESMAN_LEVEL_PERMISSIONS'),(2949,0,1,'113 Vendas - Faz pedidos 2',662,'PERM_SALESMAN_TESTE_1',1,'SALESMAN_LEVEL_PERMISSIONS'),(2961,0,1,'not in use',650,NULL,1,'SALESMAN_LEVEL_PERMISSIONS'),(2962,0,1,'407 Tcnico - Linguagens',649,'PERM_CONFIG_TEC_LANGUAGES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2963,0,1,'406 Tcnico - Impressoras',648,'PERM_CONFIG_TEC_PRINT_ZONES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2964,0,1,'405 Tcnico - Dispositivos',647,'PERM_CONFIG_TEC_HARDWARE',1,'SALESMAN_LEVEL_PERMISSIONS'),(2965,0,1,'404 Tcnico - Terminais',646,'PERM_CONFIG_TEC_TERMINALS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2966,0,1,'403 Tcnico - Excluses',645,'PERM_CONFIG_TEC_EXCLUSIONS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2967,0,1,'402 Tcnico - Sistema',644,'PERM_CONFIG_TEC_SYSTEM',1,'SALESMAN_LEVEL_PERMISSIONS'),(2968,0,1,'401 Tcnico - Tipos Documento',643,'PERM_CONFIG_TEC_DOC_TYPES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2969,0,1,'400 Tcnico - Perfis',642,'PERM_CONFIG_TEC_PROFILES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2970,0,1,'321 Config - Edio Nomes Mesas',641,'PERM_CONFIG_EDIT_TABLE_NAMES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2971,0,1,'320 Config - Ver Nomes Mesas',640,'PERM_CONFIG_SEE_TABLE_NAMES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2974,0,1,'319 Config - Edio Grupos Clientes',637,'PERM_CONFIG_EDIT_CUSTOMER_GROUPS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2975,0,1,'318 Config - Ver Grupos Clientes',636,'PERM_CONFIG_SEE_CUSTOMER_GROUPS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2976,0,1,'317 Config - Edio Caixas',635,'PERM_CONFIG_EDIT_CASHDRAWERS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2977,0,1,'316 Config - Ver Caixas',634,'PERM_CONFIG_SEE_CASHDRAWERS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2978,0,1,'315 Config - Edio Taxas IVA',633,'PERM_CONFIG_EDIT_TAXES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2979,0,1,'314 Config - Ver Taxas IVA',632,'PERM_CONFIG_SEE_TAXES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2980,0,1,'313 Config - Edio Clientes',631,'PERM_CONFIG_EDIT_CUSTOMERS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2981,0,1,'312 Config - Ver Clientes',630,'PERM_CONFIG_SEE_CUSTOMERS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2982,0,1,'311 Config - Edio Zonas',629,'PERM_CONFIG_EDIT_ZONES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2983,0,1,'310 Config - Ver Zonas',628,'PERM_CONFIG_SEE_ZONES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2984,0,1,'309 Config - Edio Formas Pagamento',627,'PERM_CONFIG_EDIT_PAYMENT_TYPES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2985,0,1,'308 Config - Ver Formas Pagamento',626,'PERM_CONFIG_SEE_PAYMENT_TYPES',1,'SALESMAN_LEVEL_PERMISSIONS'),(2986,0,1,'AVAILABLE FOR USE',625,NULL,1,'SALESMAN_LEVEL_PERMISSIONS'),(2987,0,1,'AVAILABLE FOR USE',624,NULL,1,'SALESMAN_LEVEL_PERMISSIONS'),(2990,0,1,'303 Config - Edio Empregados',621,'PERM_PERM_CONFIG_EDIT_SALESMANS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2991,0,1,'302 Config - Ver Empregados',620,'PERM_CONFIG_SEE_SALESMANS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2992,0,1,'301 Config - Edio Artigos',619,'PERM_CONFIG_EDIT_ITEMS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2993,0,1,'300 Config - Ver Artigos',618,'PERM_CONFIG_SEE_ITEMS',1,'SALESMAN_LEVEL_PERMISSIONS'),(2994,0,1,'203 Sesses - Abrir Caixa',617,'PERM_SESSIONS_OPEN_CASHDRAWER',1,'SALESMAN_LEVEL_PERMISSIONS'),(2996,0,1,'201 Sesses - Fecha Sesses',615,'PERM_SESSIONS_CLOSE_SESSION',1,'SALESMAN_LEVEL_PERMISSIONS'),(2997,0,1,'200 Sesses - Abre Sesses',614,'PERM_SESSIONS_OPEN_SESSION',1,'SALESMAN_LEVEL_PERMISSIONS'),(2999,0,1,'111 Vendas - Venda acima do limite mximo',612,'PERM_SALESMAN_ABOVE_LIMIT',1,'SALESMAN_LEVEL_PERMISSIONS'),(3000,0,1,'110 Vendas - Altera preo',611,'PERM_SALESMAN_CAN_CHANGE_PRICE',1,'SALESMAN_LEVEL_PERMISSIONS'),(3001,0,1,'109 Vendas - Fecha contas',610,'PERM_SALESMAN_CAN_CLOSE_TABLE',1,'SALESMAN_LEVEL_PERMISSIONS'),(3002,0,1,'108 Vendas - Consulta registos',609,'PERM_SALESMAN_CAN_ACCESS_HISTORY',1,'SALESMAN_LEVEL_PERMISSIONS'),(3003,0,1,'107 Vendas - Factura mltipla e parcial',608,'PERM_SALESMAN_MULTIPLE_PARCIAL_RECEIPT',1,'SALESMAN_LEVEL_PERMISSIONS'),(3004,0,1,'106 Vendas - Transferncias',607,'PERM_SALESMAN_CAN_TRANSFER_ITEMS',1,'SALESMAN_LEVEL_PERMISSIONS'),(3005,0,1,'105 Vendas - Imprime apenas 1 subtotal',606,'PERM_SALESMAN_CAN_ONLY_PRINT_ONE_SUBTOTAL',1,'SALESMAN_LEVEL_PERMISSIONS'),(3006,0,1,'104 Vendas -  Devolues',605,'PERM_SALESMAN_CAN_REFUND',1,'SALESMAN_LEVEL_PERMISSIONS'),(3007,0,1,'103 Vendas - Anulaes',604,'PERM_SALESMAN_CAN_VOID_ORDERS',1,'SALESMAN_LEVEL_PERMISSIONS'),(3008,0,1,'102 Vendas - Cancela Pedidos',603,'PERM_SALESMAN_CAN_CANCEL_ORDERS',1,'SALESMAN_LEVEL_PERMISSIONS'),(3009,0,1,'101 Vendas - Abre Gaveta',602,'PERM_SALESMAN_CAN_OPEN_DRAWER',1,'SALESMAN_LEVEL_PERMISSIONS'),(3010,0,1,'100 Vendas - Entra nas mesas de outros',601,'PERM_SALESMAN_CAN_ENTER_OTHERS_TABLES',1,'SALESMAN_LEVEL_PERMISSIONS'),(3011,0,1,'Imprimir Apuramento Caixa',1073,'CashDrawerCloseBtnMovements',1,'SCREEN_CASHIER_CLOSE'),(3088,0,1,'Usar prpria base de dados',1074,'ProfileOwnDatabase',1,'SCREEN_CONFIG_PROFILES'),(3089,0,1,'Este posto nao pode fechar mesas',1075,'RadioMsg',1,'RadioMsg'),(3090,0,1,'Nao tem permissao para fechar mesas',1076,'RadioMsg',1,'RadioMsg'),(3091,0,1,'Nao tem permissao para abrir gaveta!',1077,'RadioMsg',1,'RadioMsg'),(3092,0,1,'Aviso|A mesa por defeito est fora do intervalo de mesas',1078,'DEFAULT_TABLE',1,'SCREEN_CONFIG_SALESMAN'),(3093,0,1,'100%',1079,'TableDiscountsLineDiscount6',1,'SCREEN_TABLE_DISCOUNTS'),(3094,0,1,'100%',1080,'TableDiscountsHeaderDiscount6',1,'SCREEN_TABLE_DISCOUNTS'),(3095,0,1,'Aviso|O perfil do radio actual expirou!\\n\\nPretende manter o perfil [1] (no), ou mudar para [2]( sim)?',1081,'RadioProfileMsg',1,'PROFILE_SELECTION'),(3096,0,1,'nenhum',1082,'RadioProfileMsg',1,'PROFILE_SELECTION'),(3097,0,1,'Erro de impresso|No foi possvel imprimir [Erro: %d]\\n\\nQuer tentar outra vez?',1083,'PrintError',1,'MSG_BOX_STRING'),(3098,0,1,'Erro de impresso|No foi possvel reimprimir\\n\\nQuer ignorar este erro e no tentar imprimir mais para esta impressora?\\n',1084,'PrintErrorMsg',1,'MSG_BOX_STRING'),(3099,0,1,'Aviso|Este cdigo j est a ser usado por %s!\n\nUm novo cdigo foi sugerido.',1085,'InvalidPluMsg',1,'MSG_BOX_STRING'),(3100,0,1,'Aviso|Por favor seleccione um cliente.',1086,'Msg',1,'MSG_BOX_STRING'),(3101,0,1,'Aviso|Possuindo pelo menos um documento seleccionado, o total a pagar dever ser igual ao somatrios dos documentos seleccionados.',1087,'Msg',1,'MSG_BOX_STRING'),(3102,0,1,'Erro ao atualizar o movimento de caixa no tendertenders com o UID \'%i\' da TransactionUID \'%i\'',1088,'Msg',1,'MSG_BOX_STRING'),(3103,0,1,'Erro ao gravar o movimento de crdito.',1089,'Msg',1,'MSG_BOX_STRING'),(3104,0,1,'Eventual',1090,'EventualName',1,'CUSTOMER_SCREEN'),(3105,0,1,'Foi encontrado um problema ao ler a entidade: ',1091,'LOAD_ERROR_MSG',1,'LOAD_ERROR'),(3107,0,1,'O NIF  um campo obrigatrio. Cliente \'%s\'.',1093,'CUSTOMER_ERROR',1,'CUSTOMER_ERROR'),(3108,0,1,'O callback \'%i\' no  vlido!',1094,'INVALID_CALLBACK',1,'INVALID_CALLBACK_MSG'),(3109,0,1,'Cliente',1095,'ClientGroupsClientName',1,'SCREEN_CONFIG_CLIENTGROUPS'),(3110,0,1,'Factura ao Grupo',1096,'ClientGroupsInvoices',1,'SCREEN_CONFIG_CLIENTGROUPS'),(3112,0,1,'Aviso|A caixa associada a este terminal ainda no foi aberta.',1098,'CashDrawerWarning',1,'CASH_DRAWER_MSG'),(3113,0,1,'Aviso|J existe um cliente com este NIF - %s',1099,'CustomerNIFWarning',1,'CUSTOMER_MSGBOX_STRING'),(3116,0,1,'Activa perfis automaticamente',1102,'ProfileChange',1,'SCREEN_TERMINAL_CONFIG'),(3118,0,1,'Configurao Menus',1104,'ItemMenuConfigWindow',1,'SCREEN_ITEM_MENU_CONFIG'),(3119,0,1,'Famla',1105,'ItemMenuConfigFamilyFilter',1,'SCREEN_ITEM_MENU_CONFIG'),(3120,0,1,'Procurar',1106,'ItemMenuConfigSearch',1,'SCREEN_ITEM_MENU_CONFIG'),(3121,0,1,'Preo',1107,'ItemMenuConfigItemPrice',1,'SCREEN_ITEM_MENU_CONFIG'),(3122,0,1,'Limpar Nvel',1108,'ItemMenuConfigCleanMenu',1,'SCREEN_ITEM_MENU_CONFIG'),(3123,0,1,'Descrio',1109,'ItemMenuConfigItemDescription',1,'SCREEN_ITEM_MENU_CONFIG'),(3124,0,1,'Menus',1110,'ItemMenuSelectionWindow',1,'SCREEN_ITEM_MENU_SELECTION'),(3125,0,1,'Prximo >',1111,'ItemMenuSelectionNext',1,'SCREEN_ITEM_MENU_SELECTION'),(3126,0,1,' ',1112,'ItemMenuSelectionDescription',1,'SCREEN_ITEM_MENU_SELECTION'),(3127,0,1,'Finalizar',1113,'ItemMenuSelectionFinalize',1,'SCREEN_ITEM_MENU_SELECTION'),(3128,0,1,'< Anterior',1114,'ItemMenuSelectionPrevious',1,'SCREEN_ITEM_MENU_SELECTION'),(3130,0,1,'Identifique o cliente',1116,'PromptCustomerWindow',1,'SCREEN_PROMPT_CUSTOMER'),(3132,0,1,'- NOTUSED - ',1118,'CustomerNIF',1,'SCREEN_PROMPT_CUSTOMER'),(3133,0,1,'Histrico',1119,'LastDetails',1,'SCREEN_PROMPT_CUSTOMER'),(3136,0,1,'Perfis de Posto',1100,'ProfilesOpenRadioTerminals',1,'SCREEN_PROFILES_SELECTION'),(3137,0,1,'Telefone',1121,'FilterTextBox',1,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(3138,0,1,'Morada',1122,'Detail2',1,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(3139,0,1,'Nome',1123,'Detail1',1,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(3140,0,1,' ',1124,'RecordDate1',1,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(3141,0,1,' ',1125,'RecordDate2',1,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(3142,0,1,' ',1126,'RecordDate3',1,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(3143,0,1,'Copia Mesa',1127,'CopyDetails1',1,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(3144,0,1,'Copia Mesa',1128,'CopyDetails2',1,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(3145,0,1,'Copia Mesa',1129,'CopyDetails3',1,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(3146,0,1,'Seleccione cliente para delivery',1130,'IPromptDeliveryCustomerWindow',1,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(3147,0,1,'Cod. Postal',1131,'Detail3',1,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(3148,0,1,'Localidade',1132,'Detail4',1,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(3149,0,1,'Morada 1',1133,'NewClientAddress1',1,'SCREEN_NEW_CLIENT'),(3150,0,1,'Morada 2',1134,'NewClientAddress2',1,'SCREEN_NEW_CLIENT'),(3151,0,1,'Cod. Postal',1135,'NewClientPostalCode',1,'SCREEN_NEW_CLIENT'),(3155,0,1,'Ecr por defeito',1139,'SalesmanDefaulScreen',1,'SCREEN_CONFIG_SALESMEN'),(3156,0,1,'Identifique o carto',1140,'lblActivationText',1,'SCREEN_CARD_ACTIVATION'),(3157,0,1,'Cdigo do carto',1141,'InputTableCode',1,'SCREEN_CARD_ACTIVATION'),(3158,0,1,'Activao de cartes',1142,'ScreenActivateCard',1,'SCREEN_CARD_ACTIVATION'),(3159,0,1,'Porta',1143,'ScreenCardExit',1,'SCREEN_CARD_EXIT'),(3171,0,1,'Escolha uma mesa',1155,'TableKeyboard',1,'SCREEN_TABLE_KEYBOARD'),(3172,0,1,'1',1156,'1',1,'SCREEN_TABLE_KEYBOARD'),(3173,0,1,'2',1157,'2',1,'SCREEN_TABLE_KEYBOARD'),(3174,0,1,'3',1158,'3',1,'SCREEN_TABLE_KEYBOARD'),(3175,0,1,'4',1159,'4',1,'SCREEN_TABLE_KEYBOARD'),(3176,0,1,'5',1160,'5',1,'SCREEN_TABLE_KEYBOARD'),(3177,0,1,'6',1161,'6',1,'SCREEN_TABLE_KEYBOARD'),(3178,0,1,'7',1162,'7',1,'SCREEN_TABLE_KEYBOARD'),(3179,0,1,'8',1163,'8',1,'SCREEN_TABLE_KEYBOARD'),(3180,0,1,'9',1164,'9',1,'SCREEN_TABLE_KEYBOARD'),(3181,0,1,'0',1165,'0',1,'SCREEN_TABLE_KEYBOARD'),(3182,0,1,'C',1166,'C',1,'SCREEN_TABLE_KEYBOARD'),(3183,0,1,'Mesa',1167,'TableCode',1,'SCREEN_TABLE_KEYBOARD'),(3184,0,1,'OK',1168,'OK',1,'SCREEN_TABLE_KEYBOARD'),(3185,0,1,'Seleco de mesas',1169,'SCREEN_NAME',1,'SCREEN_NAME'),(3186,0,1,'Cartes/Porta entrada',1170,'SCREEN_NAME',1,'SCREEN_NAME'),(3187,0,1,'Cartes/Porta sada',1171,'SCREEN_NAME',1,'SCREEN_NAME'),(3188,0,1,'Teclado sel. mesas',1172,'SCREEN_NAME',1,'SCREEN_NAME'),(3189,0,1,'Usar mapa de mesas',399,'ZoneUseZoneMap',1,'SCREEN_CONFIG_ZONES'),(3190,0,1,'C/IVA includo',401,'ZonePricesTaxesIncluded',1,'SCREEN_CONFIG_ZONES'),(3191,0,1,'Identifica Cliente antes da venda',402,'ZoneAskCustomerNumber',1,'SCREEN_CONFIG_ZONES'),(3192,0,1,'Consumo Prprio',403,'ZoneSelfConsuption',1,'SCREEN_CONFIG_ZONES'),(3193,0,1,'Identifica mesa para pedidos (uso com cartes)',407,'ZoneAskCustomerBeforeSale',1,'SCREEN_CONFIG_ZONES'),(3194,0,1,'Modo Delivery',1137,'ZoneIsDelivery',1,'SCREEN_CONFIG_ZONES'),(3195,0,1,'Disco/Verifica estado dos cartes',1138,'ZoneIsCardCheck',1,'SCREEN_CONFIG_ZONES'),(3199,0,1,'Executar plugin',1173,'Run',1,'SCREEN_PLUGINS'),(3200,0,1,'Descrio',1174,'Description',1,'SCREEN_PLUGINS'),(3201,0,1,'1',1175,'Var1',1,'SCREEN_PLUGINS'),(3202,0,1,'2',1176,'Var2',1,'SCREEN_PLUGINS'),(3203,0,1,'3',1177,'Var3',1,'SCREEN_PLUGINS'),(3204,0,1,'4',1178,'Var4',1,'SCREEN_PLUGINS'),(3205,0,1,'5',1179,'Var5',1,'SCREEN_PLUGINS'),(3206,0,1,'6',1180,'Var6',1,'SCREEN_PLUGINS'),(3207,0,1,'7',1181,'Var7',1,'SCREEN_PLUGINS'),(3208,0,1,'8',1182,'Var8',1,'SCREEN_PLUGINS'),(3209,0,1,'9',1183,'Var9',1,'SCREEN_PLUGINS'),(3210,0,1,'10',1184,'Var10',1,'SCREEN_PLUGINS'),(3211,0,1,'Plugins',1185,'PluginsWindow',1,'SCREEN_PLUGINS'),(3213,0,1,'Consultas Caixa',1022,'MovementsPrintWindow',1,'SCREEN_MOVEMENTS_PRINT'),(3214,0,1,'Caixa-bolsa aberta|%s tem uma caixa-bolsa aberta!\n\nPara poder efectuar o fecho da sesso tem que fechar a caixa-bolsa - %s - primeiro',1152,'MSG_BOX_MESSAGE',1,'MSG_BOX_MESSAGE'),(3215,0,1,'Aviso|Por favor seleccione um empregado para iniciar sesso.',1153,'MSG_BOX_MESSAGE',1,'MSG_BOX_MESSAGE'),(3216,0,1,'Aviso|Ainda tem mesas abertas!\n\nPor favor feche ou transfira as suas mesas para fechar a sua sesso',1154,'MSG_BOX_MESSAGE',1,'MSG_BOX_MESSAGE'),(3217,0,1,'Aviso|Por favor seleccione um empregado para fechar sesso.',1149,'MSG_BOX_MESSAGE',1,'MSG_BOX_MESSAGE'),(3218,0,1,'Sem caixa-bolsa',1148,'GENERIC_TEXT',1,'GENERIC_TEXT'),(3219,0,1,'Cdigo',1186,'User',1,'SCREEN_CONFIG_LICENCE'),(3220,0,1,'Senha',1187,'Password',1,'SCREEN_CONFIG_LICENCE'),(3221,0,1,'Registar nova licena',1188,'Register',1,'SCREEN_CONFIG_LICENCE'),(3222,0,1,'Actualizar licena',1189,'LicencesUpgrade',1,'SCREEN_CONFIG_LICENCE'),(3223,0,1,'Fecha a zero',1144,'CloseAsZero',1,'SCREEN_CONFIG_OPEN_TABLES'),(3224,0,1,'Lista negra',1145,'SetBlackList',1,'SCREEN_CONFIG_OPEN_TABLES'),(3225,0,1,'Mostra mesas na lista negra',1146,'ShowTablesInBlackList',1,'SCREEN_CONFIG_OPEN_TABLES'),(3226,0,1,'Sage IVA',1190,'SageIVA',1,'SCREEN_CONFIG_TAXES'),(3251,0,1,'208 Sesses - Mesas abertas',1066,'PERM_SESSIONS_OPEN_TABLES',1,'SALESMAN_LEVEL_PERMISSIONS'),(3252,0,1,'211 Sesses - Consulta de caixa',1069,'PERM_SESSIONS_CASHDRAWER_MOVEMENTS',1,'SALESMAN_LEVEL_PERMISSIONS'),(3253,0,1,'Manter preos',1215,'DoNoChanges',1,'SCREEN_SAGE_IVA'),(3255,0,1,'Sage IVA',1213,'SageIVAWindow',1,'SCREEN_SAGE_IVA'),(3256,0,1,'TaxChangeUpdatePrices',1212,'TaxChangeUpdatePrices',1,'SCREEN_SAGE_IVA'),(3258,0,1,'Arredonda PVP',1210,'TaxChangeRound',1,'SCREEN_SAGE_IVA'),(3259,0,1,'Data de mudanas do IVA',1209,'TaxChangeDate',1,'SCREEN_SAGE_IVA'),(3260,0,1,'PVP actualizado',1208,'NextItemPrice',1,'SCREEN_SAGE_IVA'),(3261,0,1,'PVP5',1207,'NextItemPrice5',1,'SCREEN_SAGE_IVA'),(3262,0,1,'PVP4',1206,'NextItemPrice4',1,'SCREEN_SAGE_IVA'),(3263,0,1,'PVP3',1205,'NextItemPrice3',1,'SCREEN_SAGE_IVA'),(3264,0,1,'PVP2',1204,'NextItemPrice2',1,'SCREEN_SAGE_IVA'),(3265,0,1,'PVP1',1203,'NextItemPrice1',1,'SCREEN_SAGE_IVA'),(3266,0,1,'PVP actual',1202,'CurrentItemPrice',1,'SCREEN_SAGE_IVA'),(3267,0,1,'PVP5',1201,'CurrentItemPrice5',1,'SCREEN_SAGE_IVA'),(3268,0,1,'PVP4',1200,'CurrentItemPrice4',1,'SCREEN_SAGE_IVA'),(3269,0,1,'PVP3',1199,'CurrentItemPrice3',1,'SCREEN_SAGE_IVA'),(3270,0,1,'PVP2',1198,'CurrentItemPrice2',1,'SCREEN_SAGE_IVA'),(3271,0,1,'PVP1',1197,'CurrentItemPrice1',1,'SCREEN_SAGE_IVA'),(3272,0,1,'Diferena',1196,'DiffItemPrice',1,'SCREEN_SAGE_IVA'),(3273,0,1,'PVP4',1195,'DiffItemPrice4',1,'SCREEN_SAGE_IVA'),(3274,0,1,'PVP3',1194,'DiffItemPrice3',1,'SCREEN_SAGE_IVA'),(3275,0,1,'PVP2',1193,'DiffItemPrice2',1,'SCREEN_SAGE_IVA'),(3276,0,1,'PVP1',1192,'DiffItemPrice1',1,'SCREEN_SAGE_IVA'),(3277,0,1,'PVP5',1191,'DiffItemPrice5',1,'SCREEN_SAGE_IVA'),(3278,0,1,'Sries de documentos',1216,'DocumentCountersWindow',1,'SCREEN_CONFIG_COUNTERS'),(3279,0,1,'Criar nova srie',1217,'NewDocumentSeries',1,'SCREEN_CONFIG_COUNTERS'),(3280,0,1,'Srie',1218,'DataChar',1,'SCREEN_CONFIG_COUNTERS'),(3281,0,1,'Contador',1219,'Counter',1,'SCREEN_CONFIG_COUNTERS'),(3283,0,1,'Numerao Doc.',1221,'COnfigButton',1,'ConfigBUtton'),(3284,0,1,'Imprime secundrios',1222,'PrintSecondary',1,'SCREEN_CONFIG_PRINTERS'),(3286,0,1,'Valor por fechar',1226,'TablesTotal',1,'SCREEN_CONFIG_OPEN_TABLES'),(3287,0,1,'Mesas abertas',1225,'TablesCount',1,'SCREEN_CONFIG_OPEN_TABLES'),(3288,0,1,'Procurar',1224,'TableFilter',1,'SCREEN_CONFIG_OPEN_TABLES'),(3289,0,1,'Link',1227,'Link',1,'SCREEN_CONFIG_ITEMS'),(3290,0,1,'Seleccione artigo',1228,'LinkItemSelectionWindow',1,'SCREEN_LINK_ITEM_SELECTION'),(3291,0,1,'Mostrar sries inactivas',1233,'ShowInactive',1,'SCREEN_CONFIG_COUNTERS'),(3293,0,1,'Terminal',1231,'SalesTermianl',1,'SCREEN_CONFIG_COUNTERS'),(3294,0,1,'Tipo de documento',1230,'DocType',1,'SCREEN_CONFIG_COUNTERS'),(3295,0,1,'Srie activa',1229,'Active',1,'SCREEN_CONFIG_COUNTERS'),(3302,0,1,'',1240,'SeriesLabel',1,'SCREEN_CONFIG_TERMINALS'),(3303,0,1,'Visualizar',1241,'PreviewSessionBtnPrint',1,'SCREEN_SESSION_PRINT'),(3304,0,1,'Data',1242,'SessionDate',1,'SCREEN_SESSION_PRINT'),(3305,0,1,'Empregado',1243,'SessionSalesman',1,'SCREEN_SESSION_PRINT'),(3306,0,1,'',1244,'SessionReportPreview',1,'SCREEN_SESSION_PRINT'),(3307,0,1,'Consulta Sesses',567,'PrintSessionWindow',1,'SCREEN_SESSION_PRINT'),(3313,0,1,'X64 - Envia msg com total da mesa',1232,'ST_X64_SEND_TABLE_TOTAL_MSG',1,'ST_X64_SEND_TABLE_TOTAL_MSG'),(3530,0,1,'Assistente de licenciamento',1245,'ScreenLicenseWizard',1,'SCREEN_LICENSING_WIZARD'),(3533,0,1,'Cancelar',1248,'Abort',1,'SCREEN_LICENSING_WIZARD'),(3534,0,1,'Licena',1249,'File',1,'SCREEN_LICENSING_WIZARD'),(3535,0,1,'Pronto',1250,'Done',1,'SCREEN_LICENSING_WIZARD'),(3536,0,1,'',1251,'SuccessLabel',1,'SCREEN_LICENSING_WIZARD'),(3537,0,1,'Registar',1252,'RegisterLicense',1,'SCREEN_LICENSING_WIZARD'),(3538,0,1,'Continuar',1253,'GotoDemos',1,'SCREEN_LICENSING_WIZARD'),(3539,0,1,'Chave do cliente',1254,'ClientKey',1,'SCREEN_LICENSING_WIZARD'),(3540,0,1,'Chave de activao',1255,'ActivationKey',1,'SCREEN_LICENSING_WIZARD'),(3541,0,1,'Insira a chave de activao para completar o processo',1256,'LicensingWizardLabel',1,'SCREEN_LICENSING_WIZARD'),(3545,0,1,'Seleccione a licena que pretende activar',1260,'LicensingWizardLabel',1,'SCREEN_LICENSING_WIZARD'),(3547,0,1,'Insira o nome do ficheiro da licena',1262,'LicensingWizardLabel',1,'SCREEN_LICENSING_WIZARD'),(3583,0,1,'Importao de documento manuais',1264,'PromptManualDocumentWindow',1,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(3584,0,1,'Srie',1265,'SeriesChar',1,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(3585,0,1,'Nmero',1266,'SeriesNumber',1,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(3586,0,1,'Sub-totais (contas)',1234,'CounterSubTotal',1,'SCREEN_CONFIG_TERMINALS'),(3587,0,1,'Factura/Recibo',1235,'CounterFacRecibo',1,'SCREEN_CONFIG_TERMINALS'),(3588,0,1,'Conta Corrente',1236,'CounterInvoice',1,'SCREEN_CONFIG_TERMINALS'),(3589,0,1,'Recibos',1237,'CounterRecibo',1,'SCREEN_CONFIG_TERMINALS'),(3590,0,1,'Pedidos',1238,'CounterPedidos',1,'SCREEN_CONFIG_TERMINALS'),(3591,0,1,'Fac. Externa',1239,'CounterGuia',1,'SCREEN_CONFIG_TERMINALS'),(3592,0,1,'Documentos manuais',1267,'ManualDocsString',1,'ManualDocsString'),(3594,0,1,'Actualizao da base de dados',1269,'MSG_BOX_TITLE',1,'MSG_BOX_TITLE'),(3595,0,1,'Por favor contacte o seu parceiro Sage ou a linha de suporte Sage atravs do nmero de telefone 707 200 482',1270,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3596,0,1,'No foi possvel actualizar a base de dados do posto para a verso ',1271,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3597,0,1,'Criao da base de dados',1272,'MSG_BOX_TITLE',1,'MSG_BOX_TITLE'),(3598,0,1,'A criao da base de dados da aplicao falhou (o script de criao da base de dados existe?)\\nA aplicacao nao pode continuar e vai terminar!',1273,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3599,0,1,'Falha de ligao  base de dados',1274,'MSG_BOX_TITLE',1,'MSG_BOX_TITLE'),(3600,0,1,'No foi possvel efectuar a ligao  base de dados!\\nA aplicao no pode continuar e vai terminar!',1275,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3601,0,1,'Terminais rdio',1276,'MSG_BOX_TITLE',1,'MSG_BOX_TITLE'),(3602,0,1,'No foi possvel inicializar a porta srie da antena!\\n\\nNo vai ser possvel usar os comandos rdio',1277,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3603,0,1,'Falhou arranque da antena!\\nNo vai ser possvel usar os comandos rdio',1278,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3604,0,1,'Sries de documentos',1279,'MSG_BOX_TITLE',1,'MSG_BOX_TITLE'),(3605,0,1,'Tem que existir uma srie activa para cada tipo de documento!\\n\\nPor favor aceda a Config->Geral->Numerao Doc. e adicione as sries em falta para poder efectuar registos correctamente!',1280,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3606,0,1,'Existem sries de documentos com caracteres de dados repetidos!\\n\\nPor favor aceda a Config->Geral->Numerao Doc. e corrija as sries em erro para poder efectuar registos correctamente!',1281,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3607,0,1,'Existem mltiplas sries de documentos em uso!\\n\\nPor favor aceda a Config->Geral->Numerao Doc. e corrija as sries em erro para poder efectuar registos correctamente!',1282,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3608,0,1,'Aviso',1283,'MSG_BOX_TITLE',1,'MSG_BOX_TITLE'),(3609,0,1,'Erro na ligao  base de dados! [Erro: %d]',1284,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3644,0,1,'No tem permisso para entrar nesta mesa',1285,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3645,0,1,'No consegui fazer lock a mesa!',1286,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3646,0,1,'Esta mesa j est aberta noutro posto!',1287,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3647,0,1,'Mesa invlida!',1288,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3648,0,1,'No foi possvel obter os detalhes da mesa',1289,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3649,0,1,'Operao no permitida!',1290,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3650,0,1,'No foi possvel adicionar artigo  mesa',1291,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3651,0,1,'No foi possvel fechar a mesa',1292,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3652,0,1,'No consegui obter a mesa!',1293,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3653,0,1,'Mesas de destino e origem so as mesmas',1294,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3654,0,1,'A mesa est fora do seu intervalo de mesas',1295,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3655,0,1,'Esta mesa est na lista negra e no pode ser usada!',1296,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3656,0,1,'Este carto est inactivo!',1297,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3657,0,1,'ESTE CARTO NO EST PAGO!',1298,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3658,0,1,'Este carto j est pago e no podem ser adicionados artigos at o carto ser desactivado!',1299,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3659,0,1,'O empregado actual no tem sesso aberta!',1300,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3660,0,1,'Ocorreu um erro inesperado! n: %d',1301,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3661,0,1,'Aviso',1302,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3662,0,1,'No foi possvel gravar a mesa [Erro: %d]\\nQuer tentar outra vez?',1303,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3663,0,1,'No  possvel imprimir pedidos correctamente. %s\\n\\nAceda a Config->Geral->Numerao Doc. e crie uma srie para este tipo de documento',1304,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3664,0,1,'No  possvel imprimir o subotal. %s\\n\\nAceda a Config->Geral->Numerao Doc. e crie uma srie para este tipo de documento',1305,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3665,0,1,'O preo deste artigo no pode ser alterado. Tem quantidade maior que um.',1306,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3666,0,1,'O preo deste artigo no pode ser alterado. Possui descontos associados.',1307,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3667,0,1,'O preo de artigos com extras no pode ser alterado',1308,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3668,0,1,'Por favor indique o novo preo do artigo',1309,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3670,0,1,'Quer limpar descontos aplicados?',1311,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3671,0,1,'Acumular mesas',1312,'MSG_BOX_TITLE',1,'MSG_BOX_TITLE'),(3672,0,1,'Esta mesa j est acumulada!\\nPretende remov-la das mesas acumuladas?',1313,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3673,0,1,'Tem certeza que quer Acumular?',1314,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3674,0,1,'Pretende remover todas as mesas acumuladas?',1315,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3675,0,1,'No  possvel efectuar a operao. [Err: %d - %s]\\n\\nAceda a Config->Geral->Numerao Doc. e crie uma srie para este tipo de documento',1316,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3677,0,1,'No pode usar este mtodo de pagamento nesta mesa!',1318,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3678,0,1,'No existe um cliente com os dados introduzidos. Deseja criar um novo cliente?',1319,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3679,0,1,'No pode efectuar esta operao nesta mesa.',1320,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3680,0,1,'O valor desta venda vai ultrapassar o limite de crdito do cliente!\\n\\nEsta venda no pode ser fechada para Conta Corrente',1321,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3681,0,1,'Por favor identifique um cliente',1322,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3682,0,1,'Como seleccionou mtodo de pagamento \'Conta Corrente\', no pode ter outras formas de pagamento.',1323,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3683,0,1,'Como seleccionou mtodo de pagamento \'Facturao Externa\', no pode ter outras formas de pagamento.',1324,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3684,0,1,'Quando utilizados os mtodos de pagamento \'Conta Corrente\' e \'Ext\' nao pode haver troco.',1325,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3685,0,1,'O fecho das mesas acumuladas falhou [Erro: %d]\\nAs mesas que seleccionou j no esto acumuladas',1326,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3689,0,1,'O fecho da venda falhou [Erro: %d - %s]\\nQuer tentar outra vez?\\n\\nPressione - No -  para abortar a operao.',1327,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3690,0,1,'Erro na ligacao SQL. Execute novamente a operacao',1328,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3691,0,1,'Nao consegui fazer lock a mesa!',1329,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3692,0,1,'A mesa esta ocupada noutro posto!',1330,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3693,0,1,'Nao tem permissao para efectuar operacao',1331,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3694,0,1,'Nao foi possivel obter os detalhes da mesa',1332,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3695,0,1,'Operacao nao permitida!',1333,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3696,0,1,'Mesa vazia',1334,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3697,0,1,'Nao foi possivel adicionar artigo a mesa',1335,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3698,0,1,'Nao foi possivel fechar a mesa',1336,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3699,0,1,'Nao consegui obter a mesa!',1337,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3700,0,1,'Mesas de destino e origem sao as mesmas',1338,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3701,0,1,'Operacao com um artigo invalido',1339,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3702,0,1,'Empregado invalido!',1340,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3703,0,1,'Mesa fora do seu intervalo de mesas!',1341,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3704,0,1,'Mesa nao existe',1342,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3705,0,1,'Este terminal nao possui nenhuma caixa associada',1343,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3706,0,1,'Nao foi possivel imprimir!',1344,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3707,0,1,'Ocorreu um erro inesperado',1345,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3708,0,1,'Comandos rdio',1346,'MSG_BOX_TITLE',1,'MSG_BOX_TITLE'),(3709,0,1,'Tem todos os comandos rdio em modo de download?',1347,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3710,0,1,'Por favor coloque todos os comandos rdio em modo de download e tente outra vez',1348,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3721,0,1,'Verificao o estado do carto',1349,'MSG_BOX_TITLE',1,'MSG_BOX_TITLE'),(3722,0,1,'O carto %d no est em nenhuma zona!',1350,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3723,0,1,'O CARTO %d NO EST PAGO!\\n\\nPor favor dirija-se a um caixa!',1351,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3724,0,1,'O carto %d j se encontra activo!',1352,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3725,0,1,'Carto %d activado!',1353,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3726,0,1,'O carto %d no est activo.\\n\\nPretende activa-lo?',1354,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3727,0,1,'CARTO %d PAGO',1355,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3728,0,1,'ESTE CARTO NO EST PAGO!\\n\\nPor favor dirija-se a um caixa!',1356,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3729,0,1,'Este carto j se encontra activo!',1357,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3730,0,1,'No foi possvel activar o carto [Erro: %d]\\nQuer tentar outra vez?',1358,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3731,0,1,'No tem criada a srie de documentos do tipo %s.\\n\\nPor favor aceda a Config->Geral->Numerao Doc. e esta srie para poder efectuar registos correctamente!',1359,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3732,0,1,'operacao nao permitida!!',1360,'RADIO_TERMINAL_MSG',1,'RADIO_TERMINAL_MSG'),(3733,0,1,'Leitura de carto',1361,'MSG_BOX_TITLE',1,'MSG_BOX_TITLE'),(3734,0,1,'No foi possvel identificar o cliente!\\n\\nPor favor tente novamente ou identifique o cliente usando o interface disponvel.',1362,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3735,0,1,'No tem permisso para entrar nesta mesa',1363,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3736,0,1,'No consegui fazer lock  mesa!',1364,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3737,0,1,'Esta mesa j est aberta noutro posto!',1365,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3738,0,1,'Mesa invlida!',1366,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3739,0,1,'No foi possvel obter os detalhes da mesa',1367,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3740,0,1,'Operao no permitida!',1368,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3741,0,1,'Mesa vazia',1369,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3742,0,1,'No foi possvel adicionar artigo  mesa',1370,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3743,0,1,'No foi possvel fechar a mesa',1371,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3744,0,1,'No consegui obter a mesa!',1372,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3745,0,1,'Mesas de destino e origem so as mesmas',1373,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3746,0,1,'Operao com um artigo invlido',1374,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3747,0,1,'A mesa est fora do seu intervalo de mesas',1375,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3748,0,1,'Esta mesa est na lista negra e no pode ser usada!',1376,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3749,0,1,'Este carto est inactivo!',1377,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3750,0,1,'ESTE CARTO NO EST PAGO!',1378,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3751,0,1,'Este carto j est pago e no podem ser adicionados artigos at o carto ser desactivado!',1379,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3752,0,1,'O empregado actual no tem sesso aberta!',1380,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3753,0,1,'Ocorreu um erro inesperado',1381,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3754,0,1,'Clique no boto + para identificar o cliente para entrega',1382,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3755,0,1,'Delivery',1383,'MSG_BOX_TITLE',1,'MSG_BOX_TITLE'),(3756,0,1,'Insira a mesa de destino dos pedidos',1384,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3757,0,1,'No  possvel alterar o preo deste artigo!',1385,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3758,0,1,'Est abaixo do limite de stock de aviso para este artigo\\n\\nPode no conseguir pedir todos os artigos  cozinha!',1386,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3848,0,1,'Total',1387,'CUSTOMER_DISPLAY_MESSAGE',1,'CUSTOMER_DISPLAY_MESSAGE'),(3849,0,1,'J existem artigos na mesa com descontos!\n\nQuer aplicar os dois descontos (SIM)?\nOu usar apenas o desconto do clientes(NO)?',1388,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3850,0,1,'Quer aplicar o desconto do cliente aos artigos restantes?',1389,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3851,0,1,'%Desc. cabealho',1390,'HeaderPercDiscount',1,'SCREEN_TABLE_CLOSE'),(3852,0,1,'Desc. linha',1391,'SumLineDiscount',1,'SCREEN_TABLE_CLOSE'),(3854,0,1,'Fact. Conv. pontos',1393,'SystemConfigPointsConversionFactor',1,'SCREEN_CONFIG_SYSTEM'),(3855,0,1,'Pontos',1394,'PaymentTypePoints',1,'SCREEN_CONFIG_PAYMENT_TYPES'),(3856,0,1,'O cliente consumidor final no pode pagar com mtodos de pagamento do tipo Pontos',1395,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3857,0,1,'O cliente seleccionado tem %d pontos disponveis para usar nesta venda\n\nQuer usar os pontos nesta venda?',1396,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3858,0,1,'Acumulou %d pontos nesta venda para usar na sua prxima visita\n\nTem agora %d pontos disponveis para usar!',1397,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(3859,0,1,'Acumulou %d pontos nesta venda',1398,'PRINT_TAG_TEXT',1,'POINTS_PRINT_TEXT'),(3860,0,1,'Tem agora %d pontos para usar!',1399,'PRINT_TAG_TEXT',1,'POINTS_PRINT_TEXT'),(3861,0,1,'Cliente acumula pontos na venda',1400,'UsePoints',1,'SCREEN_CONFIG_SYSTEM'),(3862,0,1,'Pontos dos artigos em vez do valor da venda',1401,'ConfigPropertyUseItemPoints',1,'GENERAL_CONFIG'),(3863,0,1,'Cartes de papel',1402,'ConfigPropertyText',1,'GENERAL_CONFIG'),(3864,0,1,'Fecha mesas/cartes extraviados a zero',1403,'ConfigPropertyText',1,'GENERAL_CONFIG'),(3865,0,1,'Imprime sempre o nome do artigo principal',1404,'ConfigPropertyText',1,'GENERAL_CONFIG'),(3866,0,1,'Verifica validade do NIF (novos clientes)',1405,'ConfigPropertyText',1,'GENERAL_CONFIG'),(3867,0,1,'Tem a certeza que quer atribuir este valor de pontos ao cliente?',1406,'MSG_BOX_TEXT',1,'CUSTOMER_CONFIG_SCREEN'),(3906,0,1,'Saldo conta corrente',1407,'AccountBalance',1,'SCREEN_CONFIG_SALESMEN'),(3907,0,1,'Tem a certeza que quer alterar o saldo da conta corrente?',1408,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_SALESMEN'),(3908,0,1,'Comisso(%)',1409,'ComissionPercent',1,'SCREEN_CONFIG_SALESMEN'),(3909,0,1,'Para um correcto funcionamento da aplicao certifique-se que o driver que est a usar  Generic Text e no o driver do fabricante da impressora!',1410,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DEVICES'),(3910,0,1,'Limpa caractres acentuados',1411,'DeviceManagerCleanChars',1,'SCREEN_CONFIG_DEVICES'),(3911,0,1,'Qt mxima de artigos',1412,'SalesmanSelfExpLimitqT',1,'SCREEN_CONFIG_SALESMEN'),(3912,0,1,'No pode efectuar esta operao nas mesas das zona de consumo prprio.\\n\\nA mesa ser fechada quando fechar a sua sesso.',1413,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(3913,0,1,'No pode adicionar mais artigos!\\n\\nJ atingiu o limite de valor do seu consumo prprio',1414,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(3914,0,1,'No pode adicionar mais artigos!\\n\\nJ atingiu o limite de artigos do seu consumo prprio',1415,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(3915,0,1,'No pode efectuar esta operao nas mesas das zona de consumo prprio.',1416,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(3916,0,1,'No pode transferir artigos para mesas de zonas de consumo prprio.\\n\\nPor favor escolha uma mesa noutra zona.',1417,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(3917,0,1,'Este documento tem um recibo associado e no pode ser anulado',1418,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_ITEMS'),(3918,0,1,'Foi encontrado um problema ao anular o documento.',1419,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_ITEMS'),(3919,0,1,'Seleccione um documento.',1420,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_ITEMS'),(3920,0,1,'Esta mesa no est na lista',1421,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_OPEN_TABLES'),(3922,0,1,'Tem certeza que quer retirar a mesa %s da lista negra?',1422,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_OPEN_TABLES'),(3923,0,1,'Tem certeza que quer colocar a mesa %s na lista negra?',1423,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_OPEN_TABLES'),(3924,0,1,'Tem certeza que quer fechar %s?',1424,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_OPEN_TABLES'),(3925,0,1,'Tem certeza que quer fechar todas as mesas da lista?',1425,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_OPEN_TABLES'),(3926,0,1,'No possui permisses para aceder a mesas de outros empregados.',1426,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_OPEN_TABLES'),(3927,0,1,'O empregado de destino no tem acesso  mesa que lhe pretende transferir!',1427,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_OPEN_TABLES'),(3928,0,1,'%s j tem este cdigo!\\n\\nUm novo cdigo vai ser sugerido!',1428,'MSG_BOX_TEXT',1,'GENERIC'),(3929,0,1,'No foi possvel inicializar a porta srie da antena!\\n\\nDeseja continuar mesmo assim?',1429,'MSG_BOX_TEXT',1,'RADIO_TERMINALS_MSG'),(3930,0,1,'Falhou arranque da antena!\\nNo vai ser possvel usar os comandos rdio!\\n\\n\\Deseja continuar mesmo assim?',1430,'MSG_BOX_TEXT',1,'RADIO_TERMINALS_MSG'),(3938,0,1,'Perfis de posto',1103,'ProfilesOpenWorkstation',1,'SCREEN_PROFILES_SELECTION'),(3939,0,1,'No discrim.',1438,'DailyJournalBtnPrintNdesc',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(3940,0,1,'S as vendas a dinheiro  que podem ser no discriminadas',1439,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(3941,0,1,'Nmero de pessoas',1440,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(3943,0,1,'Esta mesa est em uso pela aplicao',1441,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(3944,0,1,'O NIF %s introduzido no  vlido!\n\nPor favor introduza um NIF vlido...',1442,'MSG_BOX_TEXT',1,'NEW_CUSTOMER'),(3945,0,1,'NIF invlido',1443,'MSG_BOX_TITLE',1,'NEW_CUSTOMER'),(3946,0,1,'Nome invlido',1444,'MSG_BOX_TITLE',1,'NAME_VALIDATION'),(3947,0,1,'O nome introduzido no  vlido!\n\nPor favor introduza um nome vlido...',1445,'MSG_BOX_TEXT',1,'NAME_VALIDATION'),(3948,0,1,'O cliente %s j tem esse NIF atribudo',1446,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_CUSTOMERS'),(3949,0,1,'No pode mudar os detalhes do cliente Consumidor final!',1447,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_CUSTOMERS'),(3950,0,1,'O cliente %s j tem este cdigo!\n\nUm novo cdigo vai ser sugerido',1448,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_CUSTOMERS'),(3951,0,1,'Pginas Rpidas',1449,'QuikPagesWindow',1,'SCREEN_CONFIG_QUICK_PAGES'),(3952,0,1,'Descrio',1450,'QuickPageDescription',1,'SCREEN_CONFIG_QUICK_PAGES'),(3953,0,1,'Famlias',1451,'QuikPageFamily',1,'SCREEN_CONFIG_QUICK_PAGES'),(3954,0,1,'Limpar',1452,'QuickPageClean',1,'SCREEN_CONFIG_QUICK_PAGES'),(3955,0,1,'Descrio curta',1453,'QuickPageShortDescription',1,'SCREEN_CONFIG_QUICK_PAGES'),(3957,0,1,'Tem certeza que quer eliminar esta pgina rpida?',1455,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_QUICK_PAGES'),(3958,0,1,'Peso|',853,'MsgBoxAskWeight',1,'SCREEN_TABLE_EDIT'),(3959,0,1,'305 Config - Edio Famlias/Pg. Rpidas',623,'PERM_CONFIG_EDIT_FAMILIES',1,'SALESMAN_LEVEL_PERMISSIONS'),(3960,0,1,'304 Config - Ver Famlias/Pg. Rpidas',622,'PERM_CONFIG_SEE_FAMILIES',1,'SALESMAN_LEVEL_PERMISSIONS'),(3961,0,1,'Cancelar artigos',1431,'TableEditMultiCancel',1,'SCREEN_TABLE_EDIT'),(3962,0,1,'Cancelar artigos',1432,'TableMultiCancel',1,'SCREEN_TABLE_CANCEL_ITEMS'),(3963,0,1,'Imprime',1433,'PrintCanceled',1,'SCREEN_TABLE_CANCEL_ITEMS'),(3964,0,1,'No possui permisses para pedir artigos!',1434,'PERM',1,'MSG_BOX_TEXT'),(3965,0,1,'No possui permisses para cancelar pedidos!',1435,'PERM',1,'MSG_BOX_TEXT'),(3966,0,1,'Refeio(es)',1436,'NDESC_TEXT',1,'PRNT_DOCUMENT'),(3967,0,1,'Desperdcio',1437,'Waste',1,'SCREEN_TABLE_CANCEL_ITEMS'),(3969,0,1,'No imprime consultas de mesa / subtotais',1456,'ST_CAN_PRINT_SUB_TOTAL',1,'ST_CAN_PRINT_SUB_TOTAL'),(3970,0,1,'No foi possvel criar um novo artigo\\n\\nOcorreu um erro inesperado',1457,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_ITEMS'),(3971,0,1,'Aviso|O nmero de certificado da aplicao foi modificado com esta actualizao pelo que deve ir a Config->Geral->Numerao Doc. e criar novas sries de documentos.',1458,'MSG_BOX_TEXT',1,'USER_PROMPT_CERTIFICATE_SERIES'),(3972,0,1,'Obs.',1459,'TableCloseObs',1,'SCREEN_TABLE_CLOSE'),(4048,0,1,'Ecrs',1460,'TerminalsScreenType',1,'SCREEN_CONFIG_TERMINALS'),(4049,0,1,'Normal (4:3)',1461,'SCREEN_TYPE',1,'SCREEN_CONFIG_TERMINALS'),(4050,0,1,'Tablet (16:9)',1462,'SCREEN_TYPE',1,'SCREEN_CONFIG_TERMINALS'),(4051,0,1,'PDA\'s (3:4)',1463,'SCREEN_TYPE',1,'SCREEN_CONFIG_TERMINALS'),(4052,0,1,'Default',1464,'SCREEN_TYPE',1,'SCREEN_CONFIG_TERMINALS'),(4053,0,1,'Obs.',1465,'DailyJournalObs',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4055,0,1,'Indique a nmero da mesa.',1467,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4056,0,1,'Seleccione um documento',1468,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4057,0,1,'Este documento tem um recibo associado e no pode ser anulado.',1469,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4058,0,1,'Foi encontrado um problema ao anular o documento.',1470,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4059,0,1,'Erro ao efetuar a pesquisa. <<CDailyJournalManager::Search()>>',1471,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4060,0,1,'Pesquisa no retornou qualquer resultado.',1472,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4061,0,1,'No foi possvel carregar Tender pretendida',1473,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4062,0,1,'No foi possvel carregar a cabealho de venda pretendido',1474,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4063,0,1,'No foi possvel carregar os dados pretendidos',1475,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4064,0,1,'Erro ao gravar os artigos da mesa!',1476,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4065,0,1,'Detalhes das formas de pagamento!',1477,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4066,0,1,'Sem ligao  base de dados para efectuar a operao',1478,'MSG_BOX_TEXT',1,'DATABSE'),(4067,0,1,'Erro ao carregar os artigos da mesa %i',1479,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(4069,0,1,'A mesa j est aberta noutro posto!',1481,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(4070,0,1,'No foi possvel bloquear a mesa para uso!',1482,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(4071,0,1,'Sem empregado vlido para efectuar operao',1483,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(4072,0,1,'A subfamlia link no est definida. Por favor configure o artigo correctamente em Config->Tabelas->Artigos.',1484,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(4074,0,1,'Este nmero de srie no  vlido!\\n\\nPor favor introduza um nmero de srie vlido.',1486,'MSG_BOX_TEXT',1,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(4075,0,1,'Identificador da srie  invlido!\\n\\nPor favor introduza uma srie vlida',1487,'MSG_BOX_TEXT',1,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(4076,0,1,'Este nmero de srie no  vlido!\\n\\nPor favor introduza um nmero de srie vlido.',1488,'MSG_BOX_TEXT',1,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(4077,0,1,'Por favor preencha ambos os campos para poder prosseguir',1489,'MSG_BOX_TEXT',1,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(4078,0,1,'Vai importar o documento %s',1490,'MSG_BOX_TEXT',1,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(4081,0,1,'Quando utilizados os mtodos de pagamento \'Conta Corrente\' e \'Ext\' nao pode haver troco.',1493,'MSG_BOX_TEXT',1,'SCREEN_TABLE_CLOSE'),(4082,0,1,'Mesa de destino:',1494,'MSG_BOX_TEXT',1,'SCREEN_TABLE_PRODUCT_TRANSF'),(4083,0,1,'Fecho da venda falhou!\nTente outra vez por favor...',1495,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(4084,0,1,'Total',1496,'TotalString',1,'TotalString'),(4085,0,1,'Tem que fazer login!',1497,'X64_MESSAGE',1,'RadioHandler'),(4086,0,1,'Impossivel pedir produtos',1498,'X64_MESSAGE',1,'RadioHandler'),(4087,0,1,'Impossivel pedir extras antes de artigo normal',1499,'X64_MESSAGE',1,'RadioHandler'),(4088,0,1,'Nao foi possivel remover artigo a mesa!',1500,'X64_MESSAGE',1,'RadioHandler'),(4089,0,1,'Nao foi possivel efectuar a transferencia de artigos',1501,'X64_MESSAGE',1,'RadioHandler'),(4090,0,1,'Transferencia nao concluida',1502,'X64_MESSAGE',1,'RadioHandler'),(4091,0,1,'Transferido %i linhas',1503,'X64_MESSAGE',1,'RadioHandler'),(4092,0,1,'%s pagou %s',1504,'X64_MESSAGE',1,'RadioHandler'),(4093,0,1,'Nao foi possivel efectuar pagamento parcial!',1505,'X64_MESSAGE',1,'RadioHandler'),(4094,0,1,'Nao foi possivel abrir sessao de %s',1506,'X64_MESSAGE',1,'RadioHandler'),(4095,0,1,'Ola %s',1507,'X64_MESSAGE',1,'RadioHandler'),(4096,0,1,'Ja fez login no terminal %i',1508,'X64_MESSAGE',1,'RadioHandler'),(4097,0,1,'%s tem que fazer logout do terminal %i antes de novo login',1509,'X64_MESSAGE',1,'RadioHandler'),(4098,0,1,'%s tem que fazer logout primeiro!',1510,'X64_MESSAGE',1,'RadioHandler'),(4099,0,1,'%s nao tem sessao aberta',1511,'X64_MESSAGE',1,'RadioHandler'),(4100,0,1,'Password nao reconhecida',1512,'X64_MESSAGE',1,'RadioHandler'),(4101,0,1,'Empregado %i nao reconhecido',1513,'X64_MESSAGE',1,'RadioHandler'),(4102,0,1,'Ainda tem mesas abertas! Nao pode fechar a sessao',1514,'X64_MESSAGE',1,'RadioHandler'),(4103,0,1,'Nao foi possivel fechar sessao de %s',1515,'X64_MESSAGE',1,'RadioHandler'),(4104,0,1,'Adeus %s',1516,'X64_MESSAGE',1,'RadioHandler'),(4105,0,1,'A query executada falhou',1517,'ErrorStr',1,'QueryFailed'),(4106,0,1,'Ocorreu um erro no definido!',1518,'ErrorStr',1,'UNDEFINED_ERROR'),(4107,0,1,'Sem erro',1519,'ErrorStr',1,'NO_ERROR'),(4108,0,1,'No  possvel desbloquear esta mesa',1520,'ErrorStr',1,'TABLE_CANT_UNLOCK'),(4109,0,1,'No  possvel obter contador para o tipo de documento desejado',1521,'ErrorStr',1,'SALE_CANT_GET_COUNTER'),(4110,0,1,'Erro ao carregar dados',1522,'ErrorStr',1,'LOAD_FAILED'),(4111,0,1,'Erro ao gravar os dados',1523,'ErrorStr',1,'SAVE_FAILED'),(4112,0,1,'Falta o contador para este tipo de documento',1524,'ErrorStr',1,'NO_COUNTER_TO_LOAD'),(4113,0,1,'No foi possvel gerar uma assinatura para este documento',1525,'ErrorStr',1,'SIGNATURE_FAILED'),(4114,0,1,'Erro desconhecido',1526,'ErrorStr',1,'DEFAULT_ERROR'),(4116,0,1,'Sem descrio de utilizao',1528,'use_description',1,'SCREEN_PLUGINS'),(4117,0,1,'Plugins|No foi possvel executar o plugin',1529,'MSG_BOX_TEXT',1,'SCREEN_PLUGINS'),(4118,0,1,'Plugins|O plugin no foi executado com sucesso',1530,'MSG_BOX_TEXT',1,'SCREEN_PLUGINS'),(4119,0,1,'Plugins|Plugin executado com sucesso!',1531,'MSG_BOX_TEXT',1,'SCREEN_PLUGINS'),(4121,0,1,'Plugins|O plugin no foi executado com sucesso\\n\\nPor favor indique o nome do ficheiro',1533,'MSG_BOX_TEXT',1,'SCREEN_PLUGINS'),(4123,0,1,' ',1535,'Dummy',1,'SCREEN_TABLE_EDIT'),(4125,0,1,'No foi possvel adicionar artigo\n\nS pode ter um artigo do tipo compensao na mesa!',1537,'TABLE_CANT_ADD_MORE_COMPENSATION',1,'TABLE_CANT_ADD_MORE_COMPENSATION'),(4126,0,1,'Aviso|No foi possvel concluir o processo de criao da cache da aplicao devido a um erro inesperado.\\n\\nPor favor reinicie a aplicao!',1538,'CACHE_BUILD',1,'CACHE_BUILD'),(4127,0,1,'No  possvel imprimir o documento pretendido - %s',1539,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(4128,0,1,'Desc. valor',1392,'HeaderValuDiscount',1,'SCREEN_TABLE_CLOSE'),(4129,0,1,'Histrico|No foi possvel carregar os detalhes deste documento',1540,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(4132,0,1,'Empregado',1543,'Empregado',1,'SCREEN_SALESMAN_SELECTION'),(4133,0,1,'117 Vendas - Abrir gaveta ao fechar a venda',1544,'PERM_SALESMAN_OPEN_DRAWER_ON_TABLE_CLOSE',1,'SALESMAN_LEVEL_PERMISSIONS'),(4134,0,1,'Aviso|No foi possvel identificar o empregado!\n\nPor favor tente outra vez.',1545,'MSG_BOX_TEXT',1,'SALESMAN_SELECTION'),(4137,0,1,'Erro de impresso|Quer imprimir para a impressora de backup %s?',1548,'MSG_BOX_TEXT',1,'SCREEN_PRINTER_ERROR'),(4138,0,1,'Erro de impresso|No tem impressora de backup definida para %s ou no foi possvel encontr-la.\n\nQuer ignorar esta impressora?',1549,'MSG_BOX_TEXT',1,'SCREEN_PRINTER_ERROR'),(4139,0,1,'Erro de impresso|No foi possvel imprimir para %s!\n\nQuer tentar imprimir novamente?',1550,'MSG_BOX_TEXT',1,'SCREEN_PRINTER_ERROR'),(4140,0,1,'Erro de impresso|No foi possvel encontrar a impressora de destino da impresso!',1551,'MSG_BOX_TEXT',1,'SCREEN_PRINTER_ERROR'),(4141,0,1,'118 Vendas - Permisso Altera Lista Negra',1552,'ChangeBlackList',1,'SCREEN_OPEN_TABLES'),(4142,0,1,'Usa Bolsa no comando',1553,'UsesPurse',1,'SCREEN_CONFIG_SALESMAN'),(4250,0,1,'Pagamento CC de empregado',1554,'SalesmanAccountWindow',1,'SCREEN_SALESMAN_ACCOUNT'),(4251,0,1,'Saldo',1555,'SalesmanAccountBalance',1,'SCREEN_SALESMAN_ACCOUNT'),(4252,0,1,'Pagar',1556,'SalesmanAccountBtnPay',1,'SCREEN_SALESMAN_ACCOUNT'),(4253,0,1,'A pagar',1557,'SalesmanAccountPayable',1,'SCREEN_SALESMAN_ACCOUNT'),(4254,0,1,'Empregado',1558,'SalesmanAccountClientName',1,'SCREEN_SALESMAN_ACCOUNT'),(4255,0,1,'Pag. CC emp.',1559,'GetDesktopSessionsSecondMenuSelectionData',1,'SCREEN_SALESMAN_ACCOUNT'),(4256,0,1,'Pag. CC cliente',1560,'GetDesktopSessionsSecondMenuSelectionData',1,'SCREEN_CUSTOMER_ACCOUNT'),(4257,0,1,'Saidas Caixa',1561,'GetDesktopSessionsSecondMenuSelectionData',1,'SCREEN_MOVEMENTS_CLOSING_MOV'),(4258,0,1,'Entradas Caixa',1562,'GetDesktopSessionsSecondMenuSelectionData',1,'SCREEN_MOVEMENTS'),(4259,0,1,'Limpar Imp. SOS',1563,'GetDesktopSessionsSecondMenuSelectionData',1,'F8_CLEAR_BACKUP_PRINTERS'),(4260,0,1,'No  possvel alterar os dados deste empregado (no foi possvel encontrar/criar o cliente associado).\n\nPor favor tente outra vez.',1564,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_SALESMEN'),(4261,0,1,'No foi possvel criar o cliente associado a este empregado.\n\nTente outra vez ou associe um cliente a este empregado na ficha de empregados.',1565,'MSG_BOX_TEXT',1,'CloseSession'),(4262,0,1,'O NIF  um campo obrigatrio do cliente. Por favor indique um NIF vlido',1566,'MSG_BOX_TEXT',1,'CUSTOMERS'),(4263,0,1,'Cliente associado',1567,'SalesmanAssociatedCustomer',1,'SCREEN_CONFIG_SALESMEN'),(4264,0,1,'NIF',1568,'SalesmanNIF',1,'SCREEN_CONFIG_SALESMEN'),(4265,0,1,'O cliente seleccionado j est associado ao empregado %s.\n\nPor favor escolha outro cliente.',1569,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_SALESMEN'),(4266,0,1,'Este NIF j est atribudo a %s',1570,'MSG_BOX_TEXT1',1,'SCREEN_CONFIG_SALESMEN'),(4267,0,1,'119 Vendas - Entra na mesa de consumo prprio de outros empregados',1571,'PERM_SALESMAN_ENTER_OTHERS_EXPENDITURE_TABLES',1,'SALESMAN_LEVEL_PERMISSIONS'),(4268,0,1,'A sesso do empregado desejado no est aberta',1572,'MSG_BOX_TEXT',1,'NO_OPEN_SESSION'),(4270,0,1,'Imprimir extracto de conta',1574,'CustomerAccountPrintStatement',1,'SCREEN_CUSTOMER_ACCOUNT'),(4271,0,1,'Este cliente est associado ao empregado %s.\n\nSe o pretende eliminar  por favor desassocie-o na ficha do empregado respectivo',1575,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_CUSTOMERS'),(4272,0,1,'Ocorreu um erro ao efectuar a operao!\n\nNo foi possvel encontrar o relatrio pretendido.',1576,'MSG_BOX_TEXT',1,'SCREEN_CUSTOMER_ACCOUNT'),(4273,0,1,'Imprimir extracto de conta',1577,'SalesmanAccountPrintStatement',1,'SCREEN_SALESMAN_ACCOUNT'),(4274,0,1,'Como tem uma mesa de consumo prprio precisa de ter um mtodo de pagamento do tipo Conta Corrente definido.\n\nAceda a - Config->Tabelas->Formas pagamento - e crie o mtodo de pagamento em falta',1578,'MSG_BOX_TEXT',1,'CloseSessionErrorMessage'),(4275,0,1,'Impressoras SOS',1579,'BackupPrinterWindow',1,'SCREEN_SOS_PRINTERS'),(4276,0,1,'Reencaminhada',1580,'PrintingToBackup',1,'SCREEN_SOS_PRINTERS'),(4277,0,1,'Limpar impressoras reencaminhadas',1581,'ClearAllBackupPrinters',1,'SCREEN_SOS_PRINTERS'),(4278,0,1,'Drivers de dispositivos',1582,'DeviceDriversrWindow',1,'SCREEN_DEVICE_DRIVERS'),(4279,0,1,'Nome',1583,'DeviceDriverName',1,'SCREEN_DEVICE_DRIVERS'),(4280,0,1,'Tipo',1584,'DeviceDriversDeviceType',1,'SCREEN_DEVICE_DRIVERS'),(4281,0,1,'Cdigo',1585,'DeviceDriverCode',1,'SCREEN_DEVICE_DRIVERS'),(4282,0,1,'Vermelho',1586,'DeviceDriverRed',1,'SCREEN_DEVICE_DRIVERS'),(4283,0,1,'Preto',1587,'DeviceDriverBlack',1,'SCREEN_DEVICE_DRIVERS'),(4284,0,1,'Texto normal',1588,'DeviceDriverNormalText',1,'SCREEN_DEVICE_DRIVERS'),(4285,0,1,'Texto grande',1589,'DeviceDriverDoubleText',1,'SCREEN_DEVICE_DRIVERS'),(4286,0,1,'texto sublinhado',1590,'DeviceDriverUnderlineText',1,'SCREEN_DEVICE_DRIVERS'),(4287,0,1,'linha',1591,'DeviceDriverLineFeed',1,'SCREEN_DEVICE_DRIVERS'),(4288,0,1,'Imprime e corta',1592,'DeviceDriverPrintCRLF',1,'SCREEN_DEVICE_DRIVERS'),(4289,0,1,'Separador',1593,'DeviceDriverSepChar',1,'SCREEN_DEVICE_DRIVERS'),(4290,0,1,'Gaveta',1594,'DeviceDriverOpenDrawer',1,'SCREEN_DEVICE_DRIVERS'),(4291,0,1,'Linha grafica',1595,'DeviceDriverGraphicLine',1,'SCREEN_DEVICE_DRIVERS'),(4292,0,1,'Pre bitmap',1596,'DeviceDriverPreBitmap',1,'SCREEN_DEVICE_DRIVERS'),(4293,0,1,'Pos bitmap',1597,'DeviceDriverPostBitmap',1,'SCREEN_DEVICE_DRIVERS'),(4294,0,1,'bitmap',1598,'DeviceDriverBitmap',1,'SCREEN_DEVICE_DRIVERS'),(4295,0,1,'Seq. Inicializao',1599,'DeviceDriverPrinterInitSeq',1,'SCREEN_DEVICE_DRIVERS'),(4296,0,1,'Imprime invertido',1600,'DeviceDriverPrintUpsideDown',1,'SCREEN_DEVICE_DRIVERS'),(4297,0,1,'Caracter incio',1601,'DeviceDriverStartChar',1,'SCREEN_DEVICE_DRIVERS'),(4298,0,1,'Caracter fim',1602,'DeviceDriverEndChar',1,'SCREEN_DEVICE_DRIVERS'),(4299,0,1,'Filtro1',1603,'DeviceDriverFilter1',1,'SCREEN_DEVICE_DRIVERS'),(4300,0,1,'Filtro2',1604,'DeviceDriverFilter2',1,'SCREEN_DEVICE_DRIVERS'),(4301,0,1,'Seq. incio',1605,'DeviceDriverStartSeq',1,'SCREEN_DEVICE_DRIVERS'),(4302,0,1,'Mdia de leituras',1606,'DeviceDriverAvgReadings',1,'SCREEN_DEVICE_DRIVERS'),(4303,0,1,'Inverte leitura',1607,'DeviceDriverInvertReading',1,'SCREEN_DEVICE_DRIVERS'),(4304,0,1,'Por favor introduza apenas caracateres entre 0 e 9 e A a F! ',1608,'DeviceDriverHexMessage',1,'SCREEN_DEVICE_DRIVERS'),(4305,0,1,'Por favor escolha outra impressora!\n\nA impressora SOS no pode apontar para si prpria.',1609,'MSG_BOX_TEXT',1,'SCREEN_SOS_PRINTERS'),(4306,0,1,'Por favor seleccione uma impressora',1610,'MSG_BOX_TEXT',1,'SCREEN_SOS_PRINTERS'),(4307,0,1,'Reinicializa contador dos pedidos no incio do dia',1611,'ConfigProperty',1,'ConfigProperty'),(4308,0,1,'No foi possvel reinicializar o contador de pedido devido a um erro interno da aplicao',1612,'MSG_BOX_TEXT',1,'ResetOrderCounter'),(4309,0,1,'Quer limpar os reencaminhamentos de todas as impressoras e passar a imprimir para as impressoras definidas',1613,'MSG_BOX_TEXT',1,'SCREEN_SOS_PRINTERS'),(4312,0,1,'Quer deixar de imprimir para a impressora SOS \\\"%s\\\" e voltar a imprimir para a impressora \\\"%s\\\"?',1614,'MSG_BOX_TEXT',1,'SCREEN_SOS_PRINTERS'),(4313,0,1,'Quer ignorar a impressora \\\"%s\\\" e reencaminhar os trabalhos de impresso para a sua impressora SOS \\\"%s\\\"?',1615,'MSG_BOX_TEXT',1,'SCREEN_SOS_PRINTERS'),(4314,0,1,'Nenhum',1616,'GenericText',1,'GenericText'),(4315,0,1,'A impressora \\\"%s\\\" no tem definida nenhuma impressora SOS. Todos os tickets para esta impressora no sero impressos.\\n\\nSe pretender pode definir uma impressora SOS na checklist.',1617,'MSG_BOX_TEXT',1,'SCREEN_SOS_PRINTERS'),(4316,0,1,'Menus - adiciona artigos de niveis com um elemento',1618,'ConfigProperty',1,'ConfigProperty'),(11890,0,1,'Editar cliente',986,'NewClientWindow',1,''),(11891,0,1,'Ficha do cliente',1619,'TableCloseEditCustomer',1,'SCREEN_TABLE_CLOSE'),(11892,0,1,'Fecha caixa bolsa no fecho da sesso',1620,'ConfigProperty',1,'ConfigProperty'),(11893,0,1,'Caixa bolsa ainda esta aberta',1621,'RADIO_MSG',1,'RADIO_MSG'),(11894,0,1,'Aviso|Este terminal no possui nenhuma caixa associada.\n\nPor favor abra uma caixa para poder registar os movimentos necessrios',1097,'CashDrawerWarning',1,'CASH_DRAWER_MSG'),(11895,0,1,'Configurao das ofertas',1622,'ItemOffersConfigWindow',1,'SCREEN_OFFERS_CONFIG'),(11896,0,1,'Nome',1623,'OfferName',1,'SCREEN_OFFERS_CONFIG'),(11897,0,1,'Valor max de oferta',1624,'MaxOfferValue',1,'SCREEN_OFFERS_CONFIG'),(11898,0,1,'n de linha a oferecer',1625,'MaxOfferQuantity',1,'SCREEN_OFFERS_CONFIG'),(11899,0,1,'Adiciona se PVP >',1626,'AddWithDifference',1,'SCREEN_OFFERS_CONFIG'),(11900,0,1,'PVP',1627,'OfferPVP',1,'SCREEN_OFFERS_CONFIG'),(11901,0,1,'Famlias',1628,'OfferConfigFamilyFilter',1,'SCREEN_OFFERS_CONFIG'),(11902,0,1,'Preo oferta',1629,'OfferSalesValue',1,'SCREEN_OFFERS_CONFIG'),(11903,0,1,'',1630,'LabelItemsInPromo',1,'SCREEN_OFFERS_CONFIG'),(11904,0,1,'',1631,'LabelZonesInPromo',1,'SCREEN_OFFERS_CONFIG'),(11905,0,1,'',1632,'LabelTerminalsInPromo',1,'SCREEN_OFFERS_CONFIG'),(11906,0,1,'+',1633,'DetailedEdit',1,'SCREEN_OFFERS_CONFIG'),(11907,0,1,'AllLevelsAlike',1634,'AllLevelsAlike',1,'SCREEN_OFFERS_CONFIG'),(11908,0,1,'Ofertas',1635,'OffersWindow',1,'SCREEN_OFFERS'),(11909,0,1,'Num max. ofertas',1636,'MaxOffers',1,'SCREEN_OFFERS'),(11910,0,1,'Nova oferta',1637,'NewOffer',1,'SCREEN_OFFERS'),(11911,0,1,'Editar oferta',1638,'EditOffer',1,'SCREEN_OFFERS'),(11912,0,1,'Apagar oferta',1639,'DeleteOffer',1,'SCREEN_OFFERS'),(11914,0,1,'Activa/Desactiva',1641,'OfferInUse',1,'SCREEN_OFFERS'),(11915,0,1,'Nova promoo',1642,'SCREEN_OFFERS',1,'SCREEN_OFFERS'),(11916,0,1,'Apagar artigo automatico',1643,'DeleteAuto',1,'SCREEN_CONFIG_ZONES'),(11917,0,1,'Artigos/Familias oferta',1644,'SCREEN_OFFERS_CONFIG',1,'SCREEN_OFFERS_CONFIG'),(11918,0,1,'Zonas activas',1645,'F178_LBL_PROMOTION_ZONES',1,'SCREEN_OFFERS_CONFIG'),(11919,0,1,'Terminais activos',1646,'F178_LBL_PROMOTION_TERMINALS',1,'SCREEN_OFFERS_CONFIG'),(11920,0,1,'Tipo de oferta',1647,'OfferType',1,'SCREEN_OFFERS_CONFIG'),(11921,0,1,'Oferece n registo',1648,'OFFER_TYPES',1,'OFFER_TYPES'),(11922,0,1,'Oferece n artigo/famlia',1649,'OFFER_TYPES',1,'OFFER_TYPES'),(11923,0,1,'Menu normal',1650,'OFFER_TYPES',1,'OFFER_TYPES'),(11924,0,1,'Preo oferta',1651,'DropBoxPriceLevels_ADD_ON_TOP',1,'SCREEN_OFFERS_CONFIG'),(11925,0,1,'Aplicar desconto',1652,'TableEditDirectDiscount',1,'SCREEN_TABLE_EDIT'),(11926,0,1,'Oferta',1653,'TableEditOfferItem',1,'SCREEN_TABLE_EDIT'),(11927,0,1,'J atingiu o seu limite e no pode efectuar mais ofertas',1654,'MSG_BOX_TEXT',1,'MAX_OFFERS_REACHED'),(11928,0,1,'120 Vendas - Adiciona ofertas alm do limite',1655,'PERM_SALESMAN_CAN_OFFER_ABOVE_LIMIT',1,'SALESMAN_LEVEL_PERMISSIONS'),(11929,0,1,'Aviso|Este artigo j  oferta',1656,'MSG_BOX_TEXT',1,'OFFERS'),(11930,0,1,'Aviso|Por favor indique um nvel maior que 0 para poder adicionar artigos',1657,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_OFFERS'),(11931,0,1,'Repeties',1658,'RepeatCount',1,'SCREEN_OFFERS_CONFIG'),(11933,0,1,'Nenhum',1660,'DropBoxPriceLevels_ADD_ON_TOP',1,'SCREEN_OFFERS_CONFIG'),(11934,0,1,'Imprimir',1661,'OpenTablesPrintTablesList',1,'SCREEN_CONFIG_OPEN_TABLES'),(11935,0,1,'Mesas pagas',1662,'TablesCountClosed',1,'SCREEN_CONFIG_OPEN_TABLES'),(11936,0,1,'Total apurado',1663,'TablesTotalClosed',1,'SCREEN_CONFIG_OPEN_TABLES'),(11937,0,1,'Total previsto',1664,'TablesExpectedTotal',1,'SCREEN_CONFIG_OPEN_TABLES'),(11938,0,1,'Exclui de consumo mnimo',1665,'ItemExcludeForCompensation',1,'SCREEN_CONFIG_ITEMS'),(11939,0,1,'OK',1,NULL,2,''),(11940,0,1,'Ajuda',2,NULL,2,''),(11941,0,1,'Erro',3,NULL,2,''),(11942,0,1,'No foi possvel gravar',4,NULL,2,''),(11943,0,1,'Cancelar',5,NULL,2,''),(11944,0,1,'No foi possvel guardar as modificaes feitas a: ',6,NULL,2,''),(11945,0,1,'Texto de ajuda para este tpico no foi encontrado!',7,NULL,2,''),(11946,0,1,'Execuo da query falhou!',8,NULL,2,''),(11947,0,1,'No foi possvel apagar artigo do carto!',9,NULL,2,''),(11948,0,1,'Artigo no existe no carto',10,NULL,2,''),(11949,0,1,'No foi possvel adicionar artigo ao carto',11,NULL,2,''),(11950,0,1,'No  possvel abrir o carto',12,NULL,2,''),(11952,0,1,'No foi possvel terminar transao!',14,NULL,2,''),(11953,0,1,'No  possvel carregar dados do dia ',15,NULL,2,''),(11954,0,1,'No foi possvel carregar os detalhes pretendidos!',16,NULL,2,''),(11955,0,1,'artigos no carto',17,NULL,2,''),(11956,0,1,'metodos de pagamento',18,NULL,2,''),(11957,0,1,'No foi possvel obter os seguintes detalhes: ',19,NULL,2,''),(11958,0,1,'No foi possvel obter o nmero de srie do documento ',20,NULL,2,''),(11959,0,1,'Sub-total',21,NULL,2,''),(11960,0,1,'Factura/Recibo',22,NULL,2,''),(11961,0,1,'No descriminada ',23,NULL,2,''),(11962,0,1,'Relatorios',24,NULL,2,''),(11963,0,1,'Factura',25,NULL,2,''),(11964,0,1,'Anulacoes',26,NULL,2,''),(11965,0,1,'Pedidos',27,NULL,2,''),(11966,0,1,'Recibo',28,NULL,2,''),(11967,0,1,'No  possvel fechar a conta!',29,NULL,2,''),(11968,0,1,'No  possvel actualizar os contadores!',30,NULL,2,''),(11969,0,1,'Descricao',31,NULL,2,''),(11970,0,1,'Descricao Curta',32,NULL,2,''),(11971,0,1,'Codigo',33,NULL,2,''),(11972,0,1,'Comissao',34,NULL,2,''),(11973,0,1,'Facturacao Externa',35,NULL,2,''),(11974,0,1,'Terminal',36,NULL,2,''),(11975,0,1,'Snatch :: Versao DEMO!',37,NULL,2,''),(11976,0,1,'Empregados',38,NULL,2,''),(11977,0,1,'Configuracoes',39,NULL,2,''),(11978,0,1,'Caixas',40,NULL,2,''),(11979,0,1,' Sessoes',41,NULL,2,''),(11980,0,1,'Snatch - Desktop',42,NULL,2,''),(11981,0,1,'No foi possvel encontrar artigo na base de dados',43,NULL,2,''),(11982,0,1,'Moreira',44,NULL,2,''),(11983,0,1,'Gilardino',45,NULL,2,''),(11984,0,1,'Carto',46,NULL,2,''),(11985,0,1,'Selecao Carto',47,NULL,2,''),(11986,0,1,'Desktop',48,NULL,2,''),(11987,0,1,'Ecra de Venda',49,NULL,2,''),(11988,0,1,'Fechar Conta',50,NULL,2,''),(11989,0,1,'Pedir',51,NULL,2,''),(11990,0,1,'Gaveta',52,NULL,2,''),(11991,0,1,'Mapa Cartes',53,NULL,2,''),(11992,0,1,'Avancado',54,NULL,2,''),(11993,0,1,'SubTotal',55,NULL,2,''),(11994,0,1,'+',56,NULL,2,''),(11995,0,1,'-',57,NULL,2,''),(11996,0,1,' ',58,'Empty',2,''),(11997,0,1,'Total Carto',59,NULL,2,''),(11998,0,1,'Cartes',60,NULL,2,''),(11999,0,1,'Selecao Empregado',61,NULL,2,''),(12000,0,1,'Formas Pagamento',62,NULL,2,''),(12001,0,1,'Configs. Gerais',63,NULL,2,''),(12002,0,1,'Menu Tecnico',64,NULL,2,''),(12003,0,1,'Formas Pagamento',65,NULL,2,''),(12004,0,1,'Produtos',66,NULL,2,''),(12005,0,1,'Empregados',67,NULL,2,''),(12006,0,1,'Clientes',68,NULL,2,''),(12007,0,1,'Sries',69,NULL,2,''),(12008,0,1,'Taxas de IVA',70,NULL,2,''),(12010,0,1,'Novo',72,NULL,2,''),(12011,0,1,'Eliminar',73,NULL,2,''),(12012,0,1,'No foi possvel gravar o mtodo de pagamento: ',74,NULL,2,''),(12013,0,1,'No foi possvel carregar os mtodos de pagamento',75,NULL,2,''),(12014,0,1,'Erro na query executada',76,NULL,2,''),(12015,0,1,'Total Carto',77,NULL,2,''),(12016,0,1,'Total Pago',78,NULL,2,''),(12017,0,1,'Troco',79,NULL,2,''),(12018,0,1,'1',80,NULL,2,''),(12019,0,1,'2',81,NULL,2,''),(12020,0,1,'5',82,NULL,2,''),(12021,0,1,'10',83,NULL,2,''),(12022,0,1,'20',84,NULL,2,''),(12023,0,1,'50',85,NULL,2,''),(12024,0,1,'Cliente',86,NULL,2,''),(12025,0,1,'NIF',87,NULL,2,''),(12026,0,1,'Pessoas',88,NULL,2,''),(12027,0,1,'Factura',89,NULL,2,''),(12028,0,1,'Nao-Descriminado',90,NULL,2,''),(12030,0,1,'Limpar Lista',92,NULL,2,''),(12031,0,1,'...',93,'App...',2,''),(12032,0,1,'Carto no encontrado',94,NULL,2,''),(12033,0,1,'Query no retornou nenhum resultado',95,NULL,2,'  '),(12034,0,1,'No foi possvel carregar a permisso pretendida',96,NULL,2,'  '),(12035,0,1,'Query retornou mais do que um resultado',97,NULL,2,' '),(12036,0,1,'No foi possvel guardar as alteraes feitas  permisso',98,NULL,2,' '),(12037,0,1,'No foi possvel guardar nova permisso',99,NULL,2,' '),(12038,0,1,'No foi possvel carregar dados do empregado',100,NULL,2,' '),(12039,0,1,'No foi possvel guardar as modificaes feitas ao empregado',101,NULL,2,' '),(12040,0,1,'No foi possvel guardar novo empregado',102,NULL,2,' '),(12041,0,1,'No foi possvel carregar nvel de empregado',103,NULL,2,' '),(12042,0,1,'No foi possvel guardar modificaes feitas ao nvel de empregado',104,NULL,2,' '),(12043,0,1,'No foi possvel criar novo empregado',105,NULL,2,' '),(12045,0,1,'O carto j est aberto noutro posto!',107,NULL,2,' '),(12046,0,1,'Valor',108,NULL,2,''),(12047,0,1,'Fehar Conta',109,NULL,2,''),(12048,0,1,'PLUS',110,NULL,2,'PLUS Config'),(12049,0,1,'Descricao',111,NULL,2,'PLUS Config'),(12050,0,1,'Descricao Curta 1',112,NULL,2,'PLUS Config'),(12051,0,1,'Descricao Curta 2',113,NULL,2,'PLUS Config'),(12052,0,1,'Codigo',114,NULL,2,'PLUS Config'),(12053,0,1,'PLU',115,NULL,2,'PLUS Config'),(12054,0,1,'Normal',116,'ITEMTYPE_NORMAL',2,'DROPBOX'),(12055,0,1,'Extra',117,'ITEMTYPE_EXTRA',2,'DROPBOX'),(12056,0,1,'Link',118,'ITEMTYPE_LINK',2,'DROPBOX'),(12057,0,1,'Compensao',119,'ITEMTYPE_COMPENSATION',2,'DROPBOX'),(12058,0,1,'Aberto',120,'ITEMTYPE_OPEN',2,'DROPBOX'),(12059,0,1,'Menu',121,'ITEMTYPE_MENU',2,'DROPBOX'),(12060,0,1,'Preo 1',122,'PRICE1',2,'DROPBOX'),(12061,0,1,'Preo 2',123,'PRICE2',2,'DROPBOX'),(12062,0,1,'Preo 3',124,'PRICE3',2,'DROPBOX'),(12063,0,1,'Preo 4',125,'PRICE4',2,'DROPBOX'),(12064,0,1,'Preo 5',126,'PRICE5',2,'DROPBOX'),(12065,0,1,'XON/XOFF',127,'PORT_FLOW_SOFT',2,'DROPBOX'),(12066,0,1,'Hardware',128,'PORT_FLOW_HARD',2,'DROPBOX'),(12067,0,1,'Sem',129,'PORT_FLOW_NONE',2,'DROPBOX'),(12068,0,1,'Par',130,'PORT_PARITY_PAIR',2,'DROPBOX'),(12069,0,1,'mpar',131,'PORT_PARITY_ODD',2,'DROPBOX'),(12070,0,1,'None',132,'PORT_PARITY_NONE',2,'DROPBOX'),(12071,0,1,'Impressora',133,'TYPE_DEV_WSC',2,'DROPBOX'),(12072,0,1,'Mostrador',134,'TYPE_DEV_DIS',2,'DROPBOX'),(12073,0,1,'Leitor Cartes ',135,'TYPE_DEV_MAG',2,'DROPBOX'),(12074,0,1,'Dallas Key',136,'TYPE_DEV_DAL',2,'DROPBOX'),(12075,0,1,'leitor Cdigo Barras',137,'TYPE_DEV_BAR',2,'DROPBOX'),(12076,0,1,'Balana',138,'TYPE_DEV_WSC',2,'DROPBOX'),(12077,0,1,'Cabealho',139,'PART_TYPE_HEADER',2,'DROPBOX'),(12078,0,1,'Detalhe',140,'PART_TYPE_DETAIL',2,'DROPBOX'),(12079,0,1,'Rodap',141,'PART_TYPE_FOOTER',2,'DROPBOX'),(12080,0,1,'Cor',142,NULL,2,'PLUS Config'),(12081,0,1,'Porta Paralela',143,'TYPE_PORT_PAR',2,'DROPBOX'),(12082,0,1,'Porta Srie',144,'TYPE_PORT_SER',2,'DROPBOX'),(12083,0,1,'Driver Windows',145,'TYPE_PORT_DRV',2,'DROPBOX'),(12084,0,1,'Socket',146,'TYPE_PORT_IPP',2,'DROPBOX'),(12085,0,1,'Hardware',147,'TYPE_PORT_HWP',2,'DROPBOX'),(12086,0,1,'Teclado',148,'TYPE_PORT_KB',2,'DROPBOX'),(12087,0,1,'Ficheiro',149,'TYPE_PORT_FIL',2,'DROPBOX'),(12088,0,1,'Cancelar',150,NULL,2,'PLUS Config'),(12089,0,1,'Erro ao carregar a coleco de registos.',151,NULL,2,''),(12090,0,1,'Erro ao carregar o registo: ',152,NULL,2,''),(12091,0,1,'No foi possvel gravar mtodo de pagamento',153,NULL,2,'Load'),(12092,0,1,'No foi possvel gravar o artigo: ',154,NULL,2,'Save'),(12093,0,1,'Descricao',155,NULL,2,'Tax Config'),(12094,0,1,'Taxa (%)',156,NULL,2,'Tax Config'),(12095,0,1,'Data Expirao',157,NULL,2,'Tax Config'),(12096,0,1,'Tipo Iva',158,NULL,2,'Tax Config'),(12097,0,1,'Regio Iva',159,NULL,2,'Tax Config'),(12098,0,1,'Comentrios',160,NULL,2,'Tax Config'),(12099,0,1,'Taxas de Iva',161,NULL,2,'Tax Config'),(12100,0,1,'Empregados',162,NULL,2,'Salesman Config'),(12101,0,1,'Nome',163,NULL,2,'Salesman Config'),(12102,0,1,'Nome Curto',164,NULL,2,'Salesman Config'),(12103,0,1,'Acesso Cartes',165,NULL,2,'Salesman Config'),(12104,0,1,'Carto Defeito',166,NULL,2,'Salesman Config'),(12105,0,1,'Cor',167,NULL,2,'Salesman Config'),(12106,0,1,'Num. Carto',168,NULL,2,'Salesman Config'),(12107,0,1,'Cdigo',169,NULL,2,'Salesman Config'),(12108,0,1,'G.Comisso',170,NULL,2,'Salesman Config'),(12109,0,1,'Lim. Comisso Diria',171,NULL,2,'Salesman Config'),(12110,0,1,'Lim. Comisso Trans',172,NULL,2,'Salesman Config'),(12111,0,1,'Nvel Acesso',173,NULL,2,'Salesman Config'),(12112,0,1,'Palavra Passe',174,NULL,2,'Salesman Config'),(12113,0,1,'Comentrios',175,NULL,2,'Salesman Config'),(12114,0,1,'Foto',176,NULL,2,'Salesman Config'),(12115,0,1,'Lngua',177,NULL,2,'Salesman Config'),(12116,0,1,'Lim.Despesas Dirias',178,NULL,2,'Salesman Config'),(12117,0,1,'PVP Consumo',179,NULL,2,'Salesman Config'),(12118,0,1,'Email',180,NULL,2,'Salesman Config'),(12119,0,1,'Endereo 1',181,NULL,2,'Salesman Config'),(12120,0,1,'Endereo 2',182,NULL,2,'Salesman Config'),(12121,0,1,'Cod.Postal',183,NULL,2,'Salesman Config'),(12122,0,1,'Localidade',184,NULL,2,'Salesman Config'),(12123,0,1,'Pas',185,NULL,2,'Salesman Config'),(12124,0,1,'Telefone',186,NULL,2,'Salesman Config'),(12125,0,1,'Telemovel',187,NULL,2,'Salesman Config'),(12126,0,1,'Cdigo',188,NULL,2,'Tax Config'),(12127,0,1,'Caixas',189,NULL,2,'Caixas Config'),(12128,0,1,'Descrio',190,NULL,2,'Caixas Config'),(12129,0,1,'Descrio Curta',191,NULL,2,'Caixas Config'),(12130,0,1,'Cdigo',192,NULL,2,'Caixas Config'),(12131,0,1,'Fundo Maneio',193,NULL,2,'Caixas Config'),(12132,0,1,'Caixa Aberta',194,NULL,2,'Caixas Config'),(12133,0,1,'Clientes',195,NULL,2,'Customers Config'),(12134,0,1,'Nome',196,NULL,2,'Customers Config'),(12135,0,1,'Morada 1',197,NULL,2,'Customers Config'),(12136,0,1,'Morada 2',198,NULL,2,'Customers Config'),(12137,0,1,'Pas',199,NULL,2,'Customers Config'),(12138,0,1,'Empresa',200,NULL,2,'Customers Config'),(12139,0,1,'NIF',201,NULL,2,'Customers Config'),(12140,0,1,'Site',202,NULL,2,'Customers Config'),(12141,0,1,'Limite Crdito',203,NULL,2,'Customers Config'),(12142,0,1,'Carto',204,NULL,2,'Customers Config'),(12143,0,1,'Desconto',205,NULL,2,'Customers Config'),(12144,0,1,'Cdigo',206,NULL,2,'Customers Config'),(12145,0,1,'Saldo',207,NULL,2,'Customers Config'),(12146,0,1,'Usar Desconto Global',208,NULL,2,'Customers Config'),(12147,0,1,'% Vendas para Balano',209,NULL,2,'Customers Config'),(12148,0,1,'Consumo',210,NULL,2,'Customers Config'),(12149,0,1,'Visitas',211,NULL,2,'Customers Config'),(12150,0,1,'ltima Visita',212,NULL,2,'Customers Config'),(12151,0,1,'Cod.Postal',213,NULL,2,'Customers Config'),(12152,0,1,'Cidade',214,NULL,2,'Customers Config'),(12153,0,1,'Telefone',215,NULL,2,'Customers Config'),(12154,0,1,'Telemvel',216,NULL,2,'Customers Config'),(12155,0,1,'Email',217,NULL,2,'Customers Config'),(12156,0,1,'Grupo',218,NULL,2,'Customers Config'),(12157,0,1,'Preo',219,NULL,2,'Customers Config'),(12158,0,1,'Pontos',220,NULL,2,'Customers Config'),(12159,0,1,'Comentrios',221,NULL,2,'Customers Config'),(12160,0,1,'Aviso',222,NULL,2,'Customers Config'),(12161,0,1,'Sries',223,NULL,2,'Zones Config'),(12162,0,1,'Cdigo',224,NULL,2,'Zones Config'),(12163,0,1,'Descrio',225,NULL,2,'Zones Config'),(12164,0,1,'Descrio Curta',226,NULL,2,'Zones Config'),(12165,0,1,'Intervalo Cartes',227,NULL,2,'Zones Config'),(12166,0,1,'Preo',228,NULL,2,'Zones Config'),(12167,0,1,'Iva',229,NULL,2,'Zones Config'),(12168,0,1,'Usa Mapa Srie',230,NULL,2,'Zones Config'),(12169,0,1,'Preos c/IVA',231,NULL,2,'Zones Config'),(12170,0,1,'Pede nmero pessoas',232,NULL,2,'Zones Config'),(12171,0,1,'Consumo Prprio',233,NULL,2,'Zones Config'),(12172,0,1,'Artigo Automtico',234,NULL,2,'Zones Config'),(12173,0,1,'Valor Mximo Carto',235,NULL,2,'Zones Config'),(12174,0,1,'Entrega Carto',236,NULL,2,'Zones Config'),(12175,0,1,'Identifica Cliente',237,NULL,2,'Zones Config'),(12176,0,1,'N Artigos Includos',238,NULL,2,'Zones Config'),(12177,0,1,'Pergunta Cliente antes venda',239,NULL,2,'Zones Config'),(12178,0,1,'Desktop',240,'DesktopWindow',2,'SCREEN_DESKTOP'),(12179,0,1,'Cartes',241,'DesktopBtnTables',2,'SCREEN_DESKTOP'),(12181,0,1,'Caixas',243,'DesktopBtnCashDrawers',2,'SCREEN_DESKTOP'),(12182,0,1,'Config',244,'DesktopBtnConfig',2,'SCREEN_DESKTOP'),(12183,0,1,'Seleo Empregado',245,'SalesmanSelectionWindow',2,'SCREEN_SALESMAN_SELECTION'),(12184,0,1,'Seleo Carto',246,'TableSelectionWindow',2,'SCREEN_TABLE_SELECTION'),(12185,0,1,'Voltar',247,'AppBack',2,'SCREEN_TABLE_SELECTION'),(12186,0,1,'[[99]]',248,'TableEditWindow',2,'SCREEN_TABLE_EDIT'),(12187,0,1,'Sub-Total',249,'TableEditSubTotal',2,'SCREEN_TABLE_EDIT'),(12188,0,1,'Pedir',250,'TableEditOrder',2,'SCREEN_TABLE_EDIT'),(12189,0,1,'+',251,'TableEditAddQtyItemSelected',2,'SCREEN_TABLE_EDIT'),(12190,0,1,'Gaveta',252,'TableEditOpenDrawer',2,'SCREEN_TABLE_EDIT'),(12192,0,1,'-',254,'TableEditRemoveQtyItemSelected',2,'SCREEN_TABLE_EDIT'),(12193,0,1,'Anulaes',255,'TableEditAdvanced',2,'SCREEN_TABLE_EDIT'),(12194,0,1,'Voltar',256,'TableEditTableMap',2,'SCREEN_TABLE_EDIT'),(12195,0,1,'Total Carto',257,'TableEditTotalTable',2,'SCREEN_TABLE_EDIT'),(12196,0,1,'Qt',258,'TableEditQtySelectedItem',2,'SCREEN_TABLE_EDIT'),(12197,0,1,'Configuraes',259,'ConfigurationsWindow',2,'SCREEN_CONFIG_MAIN'),(12198,0,1,'Sesses',260,'SessionsWindow',2,'SCREEN_SESSIONS'),(12199,0,1,'Caixas',261,'CashesWindow',2,'SCREEN_CASHES'),(12202,0,1,'1',264,'TableCloseCurrency1',2,'SCREEN_TABLE_CLOSE'),(12203,0,1,'Total Pago',265,'TableClosePaidValue',2,'SCREEN_TABLE_CLOSE'),(12204,0,1,'Troco',266,'TableCloseChange',2,'SCREEN_TABLE_CLOSE'),(12205,0,1,'2',267,'TableCloseCurrency2',2,'SCREEN_TABLE_CLOSE'),(12206,0,1,'5',268,'TableCloseCurrency3',2,'SCREEN_TABLE_CLOSE'),(12207,0,1,'Valor',269,'TableCloseSelectedValue',2,'SCREEN_TABLE_CLOSE'),(12208,0,1,'10',270,'TableCloseCurrency4',2,'SCREEN_TABLE_CLOSE'),(12209,0,1,'20',271,'TableCloseCurrency5',2,'SCREEN_TABLE_CLOSE'),(12210,0,1,'50',272,'TableCloseCurrency6',2,'SCREEN_TABLE_CLOSE'),(12211,0,1,'Sub-Total',273,'TableCloseSubTotal',2,'SCREEN_TABLE_CLOSE'),(12212,0,1,'...',274,'TableCloseClientSearch',2,'SCREEN_TABLE_CLOSE'),(12213,0,1,'Cliente',275,'TableCloseClientName',2,'SCREEN_TABLE_CLOSE'),(12214,0,1,'NIF',276,'TableCloseFederalTaxIdClient',2,'SCREEN_TABLE_CLOSE'),(12215,0,1,'N Pessoas',277,'TableClosePersonsNumber',2,'SCREEN_TABLE_CLOSE'),(12217,0,1,'Imprime No Desc.',279,'TableCloseNonDetailedInvoice',2,'SCREEN_TABLE_CLOSE'),(12218,0,1,'Voltar',280,'TableCloseCancel',2,'SCREEN_TABLE_CLOSE'),(12220,0,1,'Message2ButtonsWindow',282,'Message2ButtonsWindow',2,'SCREEN_MESSAGEBOX2BUTTONS'),(12221,0,1,'Sim',283,'Message2ButtonsBt1',2,'SCREEN_MESSAGEBOX2BUTTONS'),(12222,0,1,'No',284,'Message2ButtonsBt2',2,'SCREEN_MESSAGEBOX2BUTTONS'),(12223,0,1,'Mensagem',285,'Message2ButtonsMessage',2,'SCREEN_MESSAGEBOX2BUTTONS'),(12224,0,1,'Mensagem',286,'MessageBoxWindow',2,'SCREEN_MESSAGEBOX'),(12225,0,1,'OK',287,'MessageBoxOK',2,'SCREEN_MESSAGEBOX'),(12226,0,1,'Mensagem',288,'MessageBoxShortText',2,'SCREEN_MESSAGEBOX'),(12227,0,1,'Detalhe',289,'MessageBoxLongText',2,'SCREEN_MESSAGEBOX'),(12228,0,1,'Formas Pagamento',290,'PaymentTypesWindow',2,'SCREEN_CONFIG_PAYMENTTYPES'),(12229,0,1,'Descrio curta',291,'PaymentTypesShortDescription',2,'SCREEN_CONFIG_PAYMENTTYPES'),(12230,0,1,'Descrio',292,'PaymentTypesDescription',2,'SCREEN_CONFIG_PAYMENTTYPES'),(12231,0,1,'Cdigo',293,'PaymentTypesCode',2,'SCREEN_CONFIG_PAYMENTTYPES'),(12232,0,1,'Comisso',294,'PaymentTypesComission',2,'SCREEN_CONFIG_PAYMENTTYPES'),(12233,0,1,'Usar em terminais rdio',295,'PaymentTypesHandTerminal',2,'SCREEN_CONFIG_PAYMENTTYPES'),(12234,0,1,'Faturao Externa',296,'PaymentTypesExternalBilling',2,'SCREEN_CONFIG_PAYMENTTYPES'),(12235,0,1,'Cancel',297,'AppCancel',2,'SCREEN_CONFIG_PAYMENTTYPES'),(12236,0,1,'OK',298,'AppOK',2,'SCREEN_CONFIG_PAYMENTTYPES'),(12237,0,1,'Novo',299,'AppNew',2,'SCREEN_CONFIG_PAYMENTTYPES'),(12238,0,1,'Eliminar',300,'AppDelete',2,'SCREEN_CONFIG_PAYMENTTYPES'),(12239,0,1,'Artigos',301,'ItemWindow',2,'SCREEN_CONFIG_ITEMS'),(12240,0,1,'Tipo',302,'ItemType',2,'SCREEN_CONFIG_ITEMS'),(12241,0,1,'Descrio',303,'ItemDescription',2,'SCREEN_CONFIG_ITEMS'),(12242,0,1,'Iva 1',304,'ItemTax1',2,'SCREEN_CONFIG_ITEMS'),(12243,0,1,'Cdigo',305,'ItemCode',2,'SCREEN_CONFIG_ITEMS'),(12244,0,1,'Iva 2',306,'ItemTax2',2,'SCREEN_CONFIG_ITEMS'),(12245,0,1,'Preo 1',307,'ItemPrice1',2,'SCREEN_CONFIG_ITEMS'),(12246,0,1,'Preo 2',308,'ItemPrice2',2,'SCREEN_CONFIG_ITEMS'),(12247,0,1,'Preo 3',309,'ItemPrice3',2,'SCREEN_CONFIG_ITEMS'),(12248,0,1,'Preo 4',310,'ItemPrice4',2,'SCREEN_CONFIG_ITEMS'),(12249,0,1,'Preo 5',311,'ItemPrice5',2,'SCREEN_CONFIG_ITEMS'),(12250,0,1,'Descrio Curta 1',312,'ItemShortDescription1',2,'SCREEN_CONFIG_ITEMS'),(12251,0,1,'Descrio Curta 2',313,'ItemShortDescription2',2,'SCREEN_CONFIG_ITEMS'),(12252,0,1,'Famlia',314,'ItemFamily',2,'SCREEN_CONFIG_ITEMS'),(12253,0,1,'PLU',315,'ItemLookUp',2,'SCREEN_CONFIG_ITEMS'),(12254,0,1,'SubFamlia',316,'ItemSubFamily',2,'SCREEN_CONFIG_ITEMS'),(12255,0,1,'Stock',317,'ItemStock',2,'SCREEN_CONFIG_ITEMS'),(12256,0,1,'Alarme Stock',318,'ItemStockAlarm',2,'SCREEN_CONFIG_ITEMS'),(12257,0,1,'Comentrios',319,'ItemComments',2,'SCREEN_CONFIG_ITEMS'),(12258,0,1,'Controla Stock',320,'ItemStockManagement',2,'SCREEN_CONFIG_ITEMS'),(12259,0,1,'Activo',321,'ItemEnabled',2,'SCREEN_CONFIG_ITEMS'),(12260,0,1,'Cor',322,'ItemColor',2,'SCREEN_CONFIG_ITEMS'),(12261,0,1,'Taxa Converso',323,'ItemWeightConversionPrice',2,'SCREEN_CONFIG_ITEMS'),(12262,0,1,'Tara',324,'ItemTareValue',2,'SCREEN_CONFIG_ITEMS'),(12263,0,1,'Preo Custo',325,'ItemCostPrice',2,'SCREEN_CONFIG_ITEMS'),(12264,0,1,'Imagem',326,'ItemPictureName',2,'SCREEN_CONFIG_ITEMS'),(12265,0,1,'Vdeo',327,'ItemVideoName',2,'SCREEN_CONFIG_ITEMS'),(12266,0,1,'Tempo Max Prep',328,'ItemKdsMaxCookTime',2,'SCREEN_CONFIG_ITEMS'),(12267,0,1,'Tempo Mdio Prep',329,'ItemKdsAvgCookTime',2,'SCREEN_CONFIG_ITEMS'),(12268,0,1,'Leitura Balana',330,'ItemReadQuantityFromScale',2,'SCREEN_CONFIG_ITEMS'),(12269,0,1,'G.Comisso',331,'ItemComissionGroup',2,'SCREEN_CONFIG_ITEMS'),(12270,0,1,'Prxima Pgina',332,'ItemNextItemPage',2,'SCREEN_CONFIG_ITEMS'),(12271,0,1,'Preo Varivel',333,'ItemVariablePrice',2,'SCREEN_CONFIG_ITEMS'),(12272,0,1,'Cdigo Barras',334,'ItemBarCode',2,'SCREEN_CONFIG_ITEMS'),(12273,0,1,'Pontos',335,'ItemSalesPoints',2,'SCREEN_CONFIG_ITEMS'),(12274,0,1,'Ordem Impresso',336,'ItemPrintingOrder',2,'SCREEN_CONFIG_ITEMS'),(12275,0,1,'Localizao Impressora',337,'ItemPrintLocation',2,'SCREEN_CONFIG_ITEMS'),(12276,0,1,'Empregados',338,'SalesmanWindow',2,'SCREEN_CONFIG_SALESMEN'),(12277,0,1,'Nome Curto',339,'SalesmanShortName',2,'SCREEN_CONFIG_SALESMEN'),(12278,0,1,'Nome',340,'SalesmanName',2,'SCREEN_CONFIG_SALESMEN'),(12279,0,1,'Intervalo Cartes',341,'SalesmanTableRange',2,'SCREEN_CONFIG_SALESMEN'),(12280,0,1,'Carto defeito',342,'SalesmanDefaulTable',2,'SCREEN_CONFIG_SALESMEN'),(12281,0,1,'Cor',343,'SalesmanColor',2,'SCREEN_CONFIG_SALESMEN'),(12282,0,1,'',344,'',2,'SCREEN_CONFIG_SALESMEN'),(12283,0,1,'Carto',345,'SalesmanCard',2,'SCREEN_CONFIG_SALESMEN'),(12284,0,1,'Cdigo',346,'SalesmanID',2,'SCREEN_CONFIG_SALESMEN'),(12285,0,1,'G.Comisso',347,'SalesmanComissionGroup',2,'SCREEN_CONFIG_SALESMEN'),(12286,0,1,'Lim. Dirio Comisso',348,'SalesmanComissionDailyLimit',2,'SCREEN_CONFIG_SALESMEN'),(12287,0,1,'Lim. Transao Comisso',349,'SalesmanComissionTransactionLimit',2,'SCREEN_CONFIG_SALESMEN'),(12288,0,1,'Nvel',350,'SalesmanLevel',2,'SCREEN_CONFIG_SALESMEN'),(12289,0,1,'Comentrios',351,'SalesmanComments',2,'SCREEN_CONFIG_SALESMEN'),(12290,0,1,'Foto',352,'SalesmanPhoto',2,'SCREEN_CONFIG_SALESMEN'),(12291,0,1,'Lngua',353,'SalesmanLanguage',2,'SCREEN_CONFIG_SALESMEN'),(12292,0,1,'L.Cons. Prprio',354,'SalesmanSelfExpLimit',2,'SCREEN_CONFIG_SALESMEN'),(12293,0,1,'PVP Cons. Prprio',355,'SalesmanSelfExpSalesPrice',2,'SCREEN_CONFIG_SALESMEN'),(12294,0,1,'Email',356,'SalesmanEmail',2,'SCREEN_CONFIG_SALESMEN'),(12295,0,1,'Endereo 1',357,'SalesmanAddressLine1',2,'SCREEN_CONFIG_SALESMEN'),(12296,0,1,'Endereo 2',358,'SalesmanAddressLine2',2,'SCREEN_CONFIG_SALESMEN'),(12297,0,1,'Cod.Postal',359,'SalesmanPostalCode',2,'SCREEN_CONFIG_SALESMEN'),(12298,0,1,'Localidade',360,'SalesmanLocality',2,'SCREEN_CONFIG_SALESMEN'),(12299,0,1,'Pas',361,'SalesmanCountry',2,'SCREEN_CONFIG_SALESMEN'),(12300,0,1,'Telefone',362,'SalesmanTelephone',2,'SCREEN_CONFIG_SALESMEN'),(12301,0,1,'Telemovel',363,'SalesmanMobile',2,'SCREEN_CONFIG_SALESMEN'),(12302,0,1,'Palavra-Passe',364,'SalesmanPassword',2,'SCREEN_CONFIG_SALESMEN'),(12303,0,1,'Clientes',365,'CustomerWindow',2,'SCREEN_CONFIG_CUSTOMERS'),(12304,0,1,'Endereo 1',366,'CustomerAddressLine1',2,'SCREEN_CONFIG_CUSTOMERS'),(12305,0,1,'Nome',367,'CustomerName',2,'SCREEN_CONFIG_CUSTOMERS'),(12306,0,1,'Endereo 2',368,'CustomerAddressLine2',2,'SCREEN_CONFIG_CUSTOMERS'),(12307,0,1,'Cod.Postal',369,'CustomerPostalCode',2,'SCREEN_CONFIG_CUSTOMERS'),(12308,0,1,'Pas',370,'CustomerCountry',2,'SCREEN_CONFIG_CUSTOMERS'),(12309,0,1,'Localidade',371,'CustomerLocality',2,'SCREEN_CONFIG_CUSTOMERS'),(12310,0,1,'Telefone',372,'CustomerTelephone',2,'SCREEN_CONFIG_CUSTOMERS'),(12311,0,1,'Email',373,'CustomerEmail',2,'SCREEN_CONFIG_CUSTOMERS'),(12312,0,1,'Telemovel',374,'CustomerMobile',2,'SCREEN_CONFIG_CUSTOMERS'),(12313,0,1,'Saldo',375,'CustomerBalance',2,'SCREEN_CONFIG_CUSTOMERS'),(12314,0,1,'Total Gasto',376,'CustomerTotalSpent',2,'SCREEN_CONFIG_CUSTOMERS'),(12315,0,1,'Nmero Visitas',377,'CustomerNumberVisits',2,'SCREEN_CONFIG_CUSTOMERS'),(12316,0,1,'Grupo Clientes',378,'CustomerGroup',2,'SCREEN_CONFIG_CUSTOMERS'),(12317,0,1,'ltima Visita',379,'CustomerLastVisit',2,'SCREEN_CONFIG_CUSTOMERS'),(12318,0,1,'Preo Venda',380,'CustomerSalesPrice',2,'SCREEN_CONFIG_CUSTOMERS'),(12319,0,1,'Comentrios',381,'CustomerComments',2,'SCREEN_CONFIG_CUSTOMERS'),(12320,0,1,'Pontos',382,'CustomerTotalPoints',2,'SCREEN_CONFIG_CUSTOMERS'),(12321,0,1,'Organizao',383,'CustomerOrganization',2,'SCREEN_CONFIG_CUSTOMERS'),(12322,0,1,'NIF',384,'CustomerFederalTaxID',2,'SCREEN_CONFIG_CUSTOMERS'),(12323,0,1,'Website',385,'CustomerWebsite',2,'SCREEN_CONFIG_CUSTOMERS'),(12324,0,1,'Carto',386,'CustomerCardID',2,'SCREEN_CONFIG_CUSTOMERS'),(12325,0,1,'Limite Crdito',387,'CustomerCreditLimit',2,'SCREEN_CONFIG_CUSTOMERS'),(12326,0,1,'Desconto',388,'CustomerGlobalDiscount',2,'SCREEN_CONFIG_CUSTOMERS'),(12327,0,1,'Cdigo',389,'CustomerID',2,'SCREEN_CONFIG_CUSTOMERS'),(12328,0,1,'Percentagem Venda',390,'CustomerSalesPercentageForBalance',2,'SCREEN_CONFIG_CUSTOMERS'),(12329,0,1,'Aviso',391,'CustomerWarning',2,'SCREEN_CONFIG_CUSTOMERS'),(12330,0,1,'Usar Desconto',392,'CustomerUseGlobalDiscountlbl',2,'SCREEN_CONFIG_CUSTOMERS'),(12331,0,1,'Sries',393,'ZoneWindow',2,'SCREEN_CONFIG_ZONES'),(12332,0,1,'Descrio Curta',394,'ZoneShortDescription',2,'SCREEN_CONFIG_ZONES'),(12333,0,1,'Descrio',395,'ZoneDescription',2,'SCREEN_CONFIG_ZONES'),(12334,0,1,'Intervalo Cartes',396,'ZoneTableRange',2,'SCREEN_CONFIG_ZONES'),(12335,0,1,'Preo',397,'ZoneSalesPrice',2,'SCREEN_CONFIG_ZONES'),(12336,0,1,'Imposto',398,'ZoneTax',2,'SCREEN_CONFIG_ZONES'),(12337,0,1,'Cdigo',400,'ZoneCode',2,'SCREEN_CONFIG_ZONES'),(12338,0,1,'Artigo Automtico',404,'ZoneAutoPLU',2,'SCREEN_CONFIG_ZONES'),(12339,0,1,'Limite Venda',405,'ZoneTableSalesLimit',2,'SCREEN_CONFIG_ZONES'),(12340,0,1,'Usar Carto',406,'ZoneTableIsCard',2,'SCREEN_CONFIG_ZONES'),(12341,0,1,'Taxas IVA',408,'TaxWindow',2,'SCREEN_CONFIG_TAXES'),(12342,0,1,'Percentagem',409,'TaxRate',2,'SCREEN_CONFIG_TAXES'),(12343,0,1,'Descrio',410,'TaxDescription',2,'SCREEN_CONFIG_TAXES'),(12344,0,1,'Data Expirao',411,'TaxExpirationDate',2,'SCREEN_CONFIG_TAXES'),(12345,0,1,'Tipo Imposto',412,'TaxType',2,'SCREEN_CONFIG_TAXES'),(12346,0,1,'Regio',413,'TaxRegion',2,'SCREEN_CONFIG_TAXES'),(12347,0,1,'Comentrios',414,'TaxComments',2,'SCREEN_CONFIG_TAXES'),(12348,0,1,'Cdigo',415,'TaxCode',2,'SCREEN_CONFIG_TAXES'),(12349,0,1,'Caixas',416,'CashDrawerWindow',2,'SCREEN_CONFIG_CASHDRAWERS'),(12350,0,1,'Descrio Curta',417,'CashDrawerShortDescription',2,'SCREEN_CONFIG_CASHDRAWERS'),(12351,0,1,'Descrio',418,'CashDrawerDescription',2,'SCREEN_CONFIG_CASHDRAWERS'),(12352,0,1,'Fundo Maneio',419,'CashDrawerWorkingFund',2,'SCREEN_CONFIG_CASHDRAWERS'),(12353,0,1,'Caixa Aberta',420,'CashDrawerIsOpen',2,'SCREEN_CONFIG_CASHDRAWERS'),(12354,0,1,'Cdigo',421,'CashDrawerCode',2,'SCREEN_CONFIG_CASHDRAWERS'),(12355,0,1,'Grupos Cliente',422,'ClientGroupsWindow',2,'SCREEN_CONFIG_CLIENTGROUPS'),(12356,0,1,'Descrio',423,'ClientGroupsDescription',2,'SCREEN_CONFIG_CLIENTGROUPS'),(12357,0,1,'Cdigo',424,'ClientGroupsCode',2,'SCREEN_CONFIG_CLIENTGROUPS'),(12358,0,1,'Descrio Curta',425,'ClientGroupsShortDescription',2,'SCREEN_CONFIG_CLIENTGROUPS'),(12359,0,1,'Preo',426,'ClientGroupsPrice',2,'SCREEN_CONFIG_CLIENTGROUPS'),(12360,0,1,'Limite Crdito',427,'ClientGroupsCreditLimit',2,'SCREEN_CONFIG_CLIENTGROUPS'),(12361,0,1,'% Venda',428,'ClientGroupsDeferredDiscount',2,'SCREEN_CONFIG_CLIENTGROUPS'),(12362,0,1,'Desconto',429,'ClientGroupsDiscount',2,'SCREEN_CONFIG_CLIENTGROUPS'),(12363,0,1,'Lnguas',430,'LanguageWindow',2,'SCREEN_CONFIG_LANGUAGES'),(12364,0,1,'Descrio Curta',431,'LanguageShortDescription',2,'SCREEN_CONFIG_LANGUAGES'),(12365,0,1,'Descrio',432,'LanguageDescription',2,'SCREEN_CONFIG_LANGUAGES'),(12366,0,1,'Cdigo',433,'LanguageCode',2,'SCREEN_CONFIG_LANGUAGES'),(12367,0,1,'Ficheiro Linguagem',434,'LanguageFilePath',2,'SCREEN_CONFIG_LANGUAGES'),(12368,0,1,'Imagem',435,'LanguageImagePath',2,'SCREEN_CONFIG_LANGUAGES'),(12369,0,1,'Tipos Documento',436,'DocumentTypeWindow',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12370,0,1,'Descrio Curta',437,'DocumentTypeShortDescription',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12371,0,1,'Descrio',438,'DocumentTypeDescription',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12372,0,1,'Cdigo',439,'DocumentTypeCode',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12373,0,1,'Cabealho',440,'DocumentTypeHeader',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12374,0,1,'Detalhe',441,'DocumentTypeBody',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12375,0,1,'Colunas',442,'DocumentTypeNumberColumns',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12376,0,1,'Rodap',443,'DocumentTypeFooter',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12377,0,1,'Contador',444,'DocumentTypeCounter',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12378,0,1,'ItemPrintingOrderPrice3',445,'ItemPrintingOrderPrice3',2,'SCREEN_CONFIG_ITEMS'),(12379,0,1,'Nomes Cartes',446,'TableNamesWindow',2,'SCREEN_TABLE_NAMES'),(12380,0,1,'Descrio Curta',447,'ItemGroupSelectionShortDescription',2,'SCREEN_CONFIG_ITEMS_GROUP_SELECTION'),(12381,0,1,'Descrio',448,'ItemGroupSelectionDescription',2,'SCREEN_CONFIG_ITEMS_GROUP_SELECTION'),(12382,0,1,'Cdigo',449,'ItemGroupSelectionCode',2,'SCREEN_CONFIG_ITEMS_GROUP_SELECTION'),(12383,0,1,'Descrio',450,'TableNamesDescription',2,'SCREEN_CONFIG_TABLE_NAMES'),(12384,0,1,'Cdigo',451,'TableNamesCode',2,'SCREEN_CONFIG_TABLE_NAMES'),(12385,0,1,'Grupo Comisses',452,'ComissionGroupsWindow',2,'SCREEN_CONFIG_COMISSIONGROUPS'),(12386,0,1,'Descrio Curta',453,'ComissionGroupsShortDescription',2,'SCREEN_CONFIG_COMISSIONGROUPS'),(12387,0,1,'Descrio',454,'ComissionGroupsDescription',2,'SCREEN_CONFIG_COMISSIONGROUPS'),(12388,0,1,'Cdigo',455,'ComissionGroupsCode',2,'SCREEN_CONFIG_COMISSIONGROUPS'),(12389,0,1,'Mximo Valor',456,'ComissionGroupsMaxValue',2,'SCREEN_CONFIG_COMISSIONGROUPS'),(12390,0,1,'Mximo Valor Venda',457,'ComissionGroupsMaxSaleValue',2,'SCREEN_CONFIG_COMISSIONGROUPS'),(12391,0,1,'Hora Incio',458,'ComissionGroupsInitialTime',2,'SCREEN_CONFIG_COMISSIONGROUPS'),(12392,0,1,'Hora Fim',459,'ComissionGroupsEndTime',2,'SCREEN_CONFIG_COMISSIONGROUPS'),(12393,0,1,'Srie',460,'ComissionGroupsZone',2,'SCREEN_CONFIG_COMISSIONGROUPS'),(12394,0,1,'Grupo Seleo Artigos',461,'ItemGroupSelectionWindow',2,'SCREEN_CONFIG_ITEMS_GROUP_SELECTION'),(12395,0,1,'Familias',462,'FamiliesWindow',2,'SCREEN_CONFIG_FAMILIES'),(12396,0,1,'Descrio Curta',463,'FamiliesShortDescription',2,'SCREEN_CONFIG_FAMILIES'),(12397,0,1,'Descrio',464,'FamiliesDescription',2,'SCREEN_CONFIG_FAMILIES'),(12398,0,1,'Cdigo',465,'FamiliesCode',2,'SCREEN_CONFIG_FAMILIES'),(12399,0,1,'Impressora',466,'FamiliesPrintLocation',2,'SCREEN_CONFIG_FAMILIES'),(12400,0,1,'G.Comisso',467,'FamiliesComissionGroup',2,'SCREEN_CONFIG_FAMILIES'),(12401,0,1,'Peso',468,'FamiliesReadFromScale',2,'SCREEN_CONFIG_FAMILIES'),(12402,0,1,'Iva 1',469,'FamiliesTax1',2,'SCREEN_CONFIG_FAMILIES'),(12403,0,1,'Iva 2',470,'FamiliesTax2',2,'SCREEN_CONFIG_FAMILIES'),(12404,0,1,'Preo 1',471,'FamiliesPrice1',2,'SCREEN_CONFIG_FAMILIES'),(12405,0,1,'Preo 2',472,'FamiliesPrice2',2,'SCREEN_CONFIG_FAMILIES'),(12406,0,1,'Preo 3',473,'FamiliesPrice3',2,'SCREEN_CONFIG_FAMILIES'),(12407,0,1,'Preo 4',474,'FamiliesPrice4',2,'SCREEN_CONFIG_FAMILIES'),(12408,0,1,'Preo 5',475,'FamiliesPrice5',2,'SCREEN_CONFIG_FAMILIES'),(12409,0,1,'Preo Custo',476,'FamiliesCostPrice',2,'SCREEN_CONFIG_FAMILIES'),(12410,0,1,'Tipo Artigo',477,'FamiliesItemType',2,'SCREEN_CONFIG_FAMILIES'),(12411,0,1,'Ordem Impresso',478,'FamiliesPrintingOrder',2,'SCREEN_CONFIG_FAMILIES'),(12412,0,1,'Tempo Max Prep.',479,'FamiliesKdsMaxCookTime',2,'SCREEN_CONFIG_FAMILIES'),(12413,0,1,'Tempo Mdio Prep.',480,'FamiliesKdsAvgCookTime',2,'SCREEN_CONFIG_FAMILIES'),(12414,0,1,'Pontos',481,'FamiliesSalesPoints',2,'SCREEN_CONFIG_FAMILIES'),(12415,0,1,'Preo Varivel',482,'FamiliesVariablePrice',2,'SCREEN_CONFIG_FAMILIES'),(12416,0,1,'IVA Defeito',483,'FamiliesDefaultTax',2,'SCREEN_CONFIG_FAMILIES'),(12417,0,1,'Preo Defeito',484,'FamiliesDefaultSalesPrice',2,'SCREEN_CONFIG_FAMILIES'),(12418,0,1,'Factor Converso Peso',485,'FamiliesWeightConverstionFactor',2,'SCREEN_CONFIG_FAMILIES'),(12420,0,1,'Desconto Defeito',487,'SystemConfigDefaultDiscount',2,'SCREEN_CONFIG_SYSTEM'),(12421,0,1,'Cdigo Loja',488,'SystemConfigShopCode',2,'SCREEN_CONFIG_SYSTEM'),(12424,0,1,'Mensagem Visor',491,'SystemConfigScreenMessageToClient',2,'SCREEN_CONFIG_SYSTEM'),(12425,0,1,'Iva Defeito',492,'SystemConfigDefaultTax',2,'SCREEN_CONFIG_SYSTEM'),(12426,0,1,'Sigla Moeda',493,'SystemConfigCurrencySymbol',2,'SCREEN_CONFIG_SYSTEM'),(12427,0,1,'Hora a que muda dia',494,'SystemConfigDayChangeTime',2,'SCREEN_CONFIG_SYSTEM'),(12430,0,1,'Jackpot',497,'SystemConfigJackpot',2,'SCREEN_CONFIG_SYSTEM'),(12431,0,1,'Lngua',498,'SystemConfigLanguage',2,'SCREEN_CONFIG_SYSTEM'),(12432,0,1,'Permisses',499,'UserPermissionsWindow',2,'SCREEN_CONFIG_USER_PERMISSIONS'),(12433,0,1,'Descrio',500,'UserPermissionsDescription',2,'SCREEN_CONFIG_USER_PERMISSIONS'),(12434,0,1,'Cdigo',501,'UserPermissionsCode',2,'SCREEN_CONFIG_USER_PERMISSIONS'),(12435,0,1,'Excluses',502,'ExclusionsWindow',2,''),(12436,0,1,'Descrio',503,'ExclusionsDescription',2,''),(12437,0,1,'Cdigo',504,'ExclusionsCode',2,''),(12438,0,1,'Descrio',505,'TerminalConfigurationDescription',2,''),(12439,0,1,'Cdigo',506,'TerminalConfigurationCode',2,''),(12440,0,1,'Perfis',507,'TerminalConfigurationWindow',2,''),(12441,0,1,'Total',509,'OpenTablesTableTotal',2,'SCREEN_CONFIG_OPEN_TABLES'),(12442,0,1,'Procura Carto',510,'OpenTablesTableSearch',2,'SCREEN_CONFIG_OPEN_TABLES'),(12443,0,1,'Procura Empregado',511,'OpenTablesSalesmanSearch',2,'SCREEN_CONFIG_OPEN_TABLES'),(12444,0,1,'Total Cartes',512,'OpenTablesTotal',2,'SCREEN_CONFIG_OPEN_TABLES'),(12445,0,1,'Empregado',513,'OpenTablesTableSalesman',2,'SCREEN_CONFIG_OPEN_TABLES'),(12446,0,1,'Eliminar',514,'OpenTablesBtnDeleteTable',2,'SCREEN_CONFIG_OPEN_TABLES'),(12447,0,1,'Imprimir',515,'OpenTablesBtnPrintTable',2,'SCREEN_CONFIG_OPEN_TABLES'),(12448,0,1,'Transf/ Produtos',516,'OpenTablesBtnTransferProducts',2,'SCREEN_CONFIG_OPEN_TABLES'),(12449,0,1,'Transf/ Empregado',517,'OpenTablesBtnTransferSaleman',2,'SCREEN_CONFIG_OPEN_TABLES'),(12450,0,1,'Abrir Carto',518,'OpenTablesBtnOpenTable',2,'SCREEN_CONFIG_OPEN_TABLES'),(12451,0,1,'Nome Curto',519,'CustomerShortName',2,'SCREEN_CONFIG_CUSTOMERS'),(12452,0,1,'Consulta Registos',520,'DailyJournalWindow',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12453,0,1,'Fechar',521,'AppClose',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12454,0,1,'Intervalo Horas',522,'DailyJournalTimeSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12455,0,1,'Nmero Carto',523,'DailyJournalTableSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12457,0,1,'Empregado',525,'DailyJournalSalesmanSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12458,0,1,'Documento',526,'DailyJournalDocSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12459,0,1,'Tipo Doc.',527,'DailyJournalDocTypeSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12460,0,1,'Intervalo Datas',528,'DailyJournalDateSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12462,0,1,'Vendedor',530,'DailyJournalSalesman',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12463,0,1,'Nmero Doc.',531,'DailyJournalDocNumber',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12464,0,1,'Carto',532,'DailyJournalTable',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12465,0,1,'Forma Pagamento',533,'DailyJournalPaymentType',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12466,0,1,'Cliente',534,'DailyJournalCostumer',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12468,0,1,'Emprstimos',537,'CashDrawerLoanWindow',2,'SCREEN_CASHDRAWER_LOAN'),(12469,0,1,'Vendedor',538,'CashDrawerLoanSalesman',2,'SCREEN_CASHDRAWER_LOAN'),(12470,0,1,'Valor',539,'CashDrawerLoanValue',2,'SCREEN_CASHDRAWER_LOAN'),(12471,0,1,'Notas',540,'CashDrawerLoanNotes',2,'SCREEN_CASHDRAWER_LOAN'),(12472,0,1,'Vales',541,'CashDrawerBorrowWindow',2,'SCREEN_CASHDRAWER_BORROW'),(12473,0,1,'Vendedor',542,'CashDrawerBorrowSalesman',2,'SCREEN_CASHDRAWER_BORROW'),(12474,0,1,'Valor',543,'CashDrawerBorrowValue',2,'SCREEN_CASHDRAWER_BORROW'),(12475,0,1,'Notas',544,'CashDrawerBorrowNotes',2,'SCREEN_CASHDRAWER_BORROW'),(12476,0,1,'Pag. Conta Corrente',545,'CashDrawerBalanceSettlementWindow',2,'SCREEN_CASHDRAWER_BALANCESETTLEMENT'),(12477,0,1,'Cliente',546,'CashDrawerBalanceSettlementClient',2,'SCREEN_CASHDRAWER_BALANCESETTLEMENT'),(12478,0,1,'Valor',547,'CashDrawerBalanceSettlementValue',2,'SCREEN_CASHDRAWER_BALANCESETTLEMENT'),(12479,0,1,'Notas',548,'CashDrawerBalanceSettlementNotes',2,'SCREEN_CASHDRAWER_BALANCESETTLEMENT'),(12480,0,1,'Devolues',549,'CashDrawerReturnWindow',2,'SCREEN_CASHDRAWER_RETURN'),(12481,0,1,'Valor',550,'CashDrawerReturnValue',2,'SCREEN_CASHDRAWER_RETURN'),(12482,0,1,'Notas',551,'CashDrawerReturnNotes',2,'SCREEN_CASHDRAWER_RETURN'),(12483,0,1,'Sangria',552,'CashDrawerBleedWindow',2,'SCREEN_CASHDRAWER_BLEED'),(12484,0,1,'Valor',553,'CashDrawerBleedValue',2,'SCREEN_CASHDRAWER_BLEED'),(12485,0,1,'Notas',554,'CashDrawerBleedNotes',2,'SCREEN_CASHDRAWER_BLEED'),(12486,0,1,'Compras',555,'CashDrawerPurchaseWindow',2,'SCREEN_CASHDRAWER_PURCHASE'),(12487,0,1,'Valor',556,'CashDrawerPurchaseValue',2,'SCREEN_CASHDRAWER_PURCHASE'),(12488,0,1,'Notas',557,'CashDrawerPurchaseNotes',2,'SCREEN_CASHDRAWER_PURCHASE'),(12489,0,1,'Cancel',558,'AppCancel',2,''),(12490,0,1,'Fecho Caixa',559,'CloseCashierWindow',2,'SCREEN_CASHIER_CLOSE'),(12491,0,1,'Fecho Dia',560,'CloseCashierBtnClose',2,'SCREEN_CASHIER_CLOSE'),(12492,0,1,'Abrir Caixa',561,'OpenCashierWindow',2,'SCREEN_CASHIER_OPEN'),(12493,0,1,'Abrir Caixa',562,'OpenCashierBtnOpens',2,'SCREEN_CASHIER_OPEN'),(12495,0,1,'Abrir Sesso',564,'OpenSessionBtnOpens',2,'SCREEN_SESSION_OPEN'),(12496,0,1,'Fecho Sesso',565,'CloseSessionWindow',2,'SCREEN_SESSION_CLOSE'),(12497,0,1,'Fechar Sesso',566,'CloseSessionBtnClose',2,'SCREEN_SESSION_CLOSE'),(12498,0,1,'Imprimir Sesso',568,'PrintSessionBtnPrint',2,'SCREEN_SESSION_PRINT'),(12499,0,1,'Abrir Caixa',569,'OpenCashierBtnOpen',2,'SCREEN_CASHIER_OPEN'),(12500,0,1,'Devolues',570,'TableReturnWindow',2,'SCREEN_TABLE_RETURN'),(12501,0,1,'Descontos',571,'TableDiscountsWindow',2,'SCREEN_TABLE_DISCOUNTS'),(12502,0,1,'Diviso Conta',572,'TableCheckSplitWindow',2,'SCREEN_TABLE_CHECK_SPLIT'),(12503,0,1,'Transferncia Produtos',573,'TableProductTransfWindow',2,'SCREEN_TABLE_PRODUCT_TRANSF'),(12504,0,1,'%',574,'TableDiscountsLineDiscount',2,'SCREEN_TABLE_DISCOUNTS'),(12505,0,1,'Valor c/Desconto',575,'TableDiscountsLineDiscountValue',2,'SCREEN_TABLE_DISCOUNTS'),(12506,0,1,'Valor Original',576,'TableDiscountsLineOriValue',2,'SCREEN_TABLE_DISCOUNTS'),(12507,0,1,'Valor c/Desconto',577,'TableDiscountsLineDiscValue',2,'SCREEN_TABLE_DISCOUNTS'),(12508,0,1,'Desconto',578,'TableDiscountsLineDisc',2,'SCREEN_TABLE_DISCOUNTS'),(12509,0,1,'Desconto',579,'TableDiscountsDocDiscount',2,'SCREEN_TABLE_DISCOUNTS'),(12510,0,1,'Valor c/Desconto',580,'TableDiscountsDocDiscountValue',2,'SCREEN_TABLE_DISCOUNTS'),(12511,0,1,'Valor Original',581,'TableDiscountsDocOriValue',2,'SCREEN_TABLE_DISCOUNTS'),(12512,0,1,'Valor c/Desconto',582,'TableDiscountsDocDiscValue',2,'SCREEN_TABLE_DISCOUNTS'),(12513,0,1,'Desconto',583,'TableDiscountsDocDisc',2,'SCREEN_TABLE_DISCOUNTS'),(12514,0,1,'Diviso Conta',584,'TableCheckSplitWindow',2,'SCREEN_TABLE_CHECK_SPLIT'),(12515,0,1,'Total',585,'TableCheckSplitTotalCheck',2,'SCREEN_TABLE_CHECK_SPLIT'),(12516,0,1,'Total por Pagar',586,'TableCheckSplitTotalUnpaid',2,'SCREEN_TABLE_CHECK_SPLIT'),(12517,0,1,'N Contas',587,'TableCheckSplitPayersNum',2,'SCREEN_TABLE_CHECK_SPLIT'),(12518,0,1,'Montante Conta',588,'TableCheckSplitParcialAmmount',2,'SCREEN_TABLE_CHECK_SPLIT'),(12519,0,1,'Limite Conta',589,'TableCheckSplitParcialLimit',2,'SCREEN_TABLE_CHECK_SPLIT'),(12524,0,1,'Processo Automtico',594,'TableCheckSplitBtnAutomatic',2,'SCREEN_TABLE_CHECK_SPLIT'),(12525,0,1,'Correo',595,'TableCheckSplitCorrection',2,'SCREEN_TABLE_CHECK_SPLIT'),(12526,0,1,'Transferncia Produtos',596,'TableProductTransfWindow',2,'SCREEN_TABLE_PRODUCT_TRANSF'),(12527,0,1,'Carto Origem',597,'TableProductTransfTableFrom',2,'SCREEN_TABLE_PRODUCT_TRANSF'),(12528,0,1,'Carto Destino',598,'TableProductTransfTableTo',2,'SCREEN_TABLE_PRODUCT_TRANSF'),(12529,0,1,'Nova Famlia',599,'FamiliesNewFamily',2,'SCREEN_CONFIG_FAMILIES'),(12530,0,1,'Nova SubFamlia',600,'FamiliesNewSubFamily',2,'SCREEN_CONFIG_FAMILIES'),(12531,0,1,'Descrio',663,'UserProfilesDescription',2,'SCREEN_CONFIG_TABLE_NAMES'),(12532,0,1,'Cdigo',664,'UserProfilesCode',2,'SCREEN_CONFIG_TABLE_NAMES'),(12535,0,1,'Sesses',667,'ScreenMenuSessions',2,'SCREEN_MENU'),(12536,0,1,'Caixas',668,'ScreenMenuCashDrawers',2,'SCREEN_MENU'),(12537,0,1,'Consultas',669,'ScreenMenuConsulting',2,'SCREEN_MENU'),(12538,0,1,'Verifica estado das impressoras',670,'check_printers_status',2,'GENERAL_CONFIG'),(12541,0,1,'O Terminal deve usar a prpria Base de Dados',673,'terminal_use_own_database',2,'GENERAL_CONFIG'),(12542,0,1,'Hora Incio',674,'ProfileStartTime',2,'SCREEN_CONFIG_PROFILES'),(12543,0,1,'Hora Fim',675,'ProfileEndTime',2,'SCREEN_CONFIG_PROFILES'),(12544,0,1,'Preo',676,'ProfileSalesPrice',2,'SCREEN_CONFIG_PROFILES'),(12545,0,1,'Desconto (%)',677,'ProfileDiscountPercentage',2,'SCREEN_CONFIG_PROFILES'),(12546,0,1,'Terminais',678,'ProfileTerminals',2,'SCREEN_CONFIG_PROFILES'),(12547,0,1,'Sries',679,'ProfileZones',2,'SCREEN_CONFIG_PROFILES'),(12548,0,1,'Segunda-Feira',680,'ProfileMonday',2,'SCREEN_CONFIG_PROFILES'),(12549,0,1,'Tera-Feira',681,'ProfileTuesday',2,'SCREEN_CONFIG_PROFILES'),(12550,0,1,'Quarta-Feira',682,'ProfileWednesday',2,'SCREEN_CONFIG_PROFILES'),(12551,0,1,'Quinta-feira',683,'ProfileThursday',2,'SCREEN_CONFIG_PROFILES'),(12552,0,1,'Sexta-Feira',684,'ProfileFriday',2,'SCREEN_CONFIG_PROFILES'),(12553,0,1,'Sbado',685,'ProfileSaturday',2,'SCREEN_CONFIG_PROFILES'),(12554,0,1,'Domingo',686,'ProfileSunday',2,'SCREEN_CONFIG_PROFILES'),(12555,0,1,'Dispositivos',687,'DeviceManagerWindow',2,'SCREEN_CONFIG_DEVICES'),(12556,0,1,'Novo M.Dispositivo',688,'DeviceManagerButtonNewDeviceManager',2,'SCREEN_CONFIG_DEVICES'),(12557,0,1,'Novo Dispositivo',689,'DeviceManagerButtonNewDevice',2,'SCREEN_CONFIG_DEVICES'),(12558,0,1,'Cod Terminal',690,'DeviceManagerCode',2,'SCREEN_CONFIG_DEVICES'),(12559,0,1,'Nome',691,'DeviceManagerName',2,'SCREEN_CONFIG_DEVICES'),(12560,0,1,'IP',692,'DeviceManagerIP',2,'SCREEN_CONFIG_DEVICES'),(12561,0,1,'Porta',693,'DeviceManagerPort',2,'SCREEN_CONFIG_DEVICES'),(12562,0,1,'Init Terminal',694,'DeviceManagerTerminal',2,'SCREEN_CONFIG_DEVICES'),(12563,0,1,'Tipo Dispositivo',695,'DeviceManagerDeviceType',2,'SCREEN_CONFIG_DEVICES'),(12564,0,1,'Descrio',696,'DeviceManagerDeviceDescription',2,'SCREEN_CONFIG_DEVICES'),(12565,0,1,'Driver',697,'DeviceManagerDeviceDriver',2,'SCREEN_CONFIG_DEVICES'),(12566,0,1,'Porta',698,'DeviceManagerDevicePort',2,'SCREEN_CONFIG_DEVICES'),(12567,0,1,'Tipo Porta',699,'DeviceManagerPortType',2,'SCREEN_CONFIG_DEVICES'),(12568,0,1,'Nome',700,'DeviceManagerPortName',2,'SCREEN_CONFIG_DEVICES'),(12569,0,1,'Baud Rate',701,'DeviceManagerPortBaudRate',2,'SCREEN_CONFIG_DEVICES'),(12570,0,1,'Flow',702,'DeviceManagerPortFlow',2,'SCREEN_CONFIG_DEVICES'),(12571,0,1,'Bit',703,'DeviceManagerPortBit',2,'SCREEN_CONFIG_DEVICES'),(12572,0,1,'Stop',704,'DeviceManagerPortStop',2,'SCREEN_CONFIG_DEVICES'),(12573,0,1,'Parity',705,'DeviceManagerPortParity',2,'SCREEN_CONFIG_DEVICES'),(12574,0,1,'Impressoras',706,'PrintersWindow',2,'SCREEN_CONFIG_PRINTERS'),(12575,0,1,'Cabealho',707,'PrintersHeaderType',2,'SCREEN_CONFIG_PRINTERS'),(12576,0,1,'Detalhe',708,'PrintersDetailType',2,'SCREEN_CONFIG_PRINTERS'),(12577,0,1,'Descrio',709,'PrintersDescription',2,'SCREEN_CONFIG_PRINTERS'),(12578,0,1,'Cdigo',710,'PrintersCode',2,'SCREEN_CONFIG_PRINTERS'),(12579,0,1,'Perfis',711,'ProfileWindow',2,'SCREEN_CONFIG_PROFILES'),(12580,0,1,'Descrio',712,'ProfileDescription',2,'SCREEN_CONFIG_PROFILES'),(12581,0,1,'Cdigo',713,'ProfileCode',2,'SCREEN_CONFIG_PROFILES'),(12582,0,1,'Terminais',714,'TerminalsWindow',2,'SCREEN_CONFIG_TERMINALS'),(12583,0,1,'Descrio',715,'TerminalsDescription',2,'SCREEN_CONFIG_TERMINALS'),(12584,0,1,'Cdigo',716,'TerminalsCode',2,'SCREEN_CONFIG_TERMINALS'),(12585,0,1,'Timeout',717,'TerminalsTimeout',2,'SCREEN_CONFIG_TERMINALS'),(12586,0,1,'Preo',718,'TerminalsPrice',2,'SCREEN_CONFIG_TERMINALS'),(12587,0,1,'Carto',719,'TerminalsTable',2,'SCREEN_CONFIG_TERMINALS'),(12588,0,1,'Caixa',720,'TerminalsCashDrawer',2,'SCREEN_CONFIG_TERMINALS'),(12589,0,1,'Centro Custo',721,'TerminalsCostCenter',2,'SCREEN_CONFIG_TERMINALS'),(12590,0,1,'Abertura de Gaveta',722,'ST_OPEN_DRAWER',2,'SALES_TERMINAL_PROPERTIES'),(12591,0,1,'Impresso do Sub-Total no Pedido',723,'ST_PRINT_SUBTOTAL_ON_PLU_ORDER         ',2,'SALES_TERMINAL_PROPERTIES'),(12592,0,1,'Ao fechar carto, pedir e imprimir Sub-Total',724,'ST_ORDER_AND_PRINT_SUB_TOTAL_ON_CLOSE',2,'SALES_TERMINAL_PROPERTIES'),(12593,0,1,'Sub-Total Pequeno',725,'ST_SMALL_SUB_TOTAL',2,'SALES_TERMINAL_PROPERTIES'),(12594,0,1,'Pedido de todas as cartes',726,'ST_ORDER_ALL_TABLES_AT_ONCE',2,'SALES_TERMINAL_PROPERTIES'),(12595,0,1,'Tem leitor de cartes',727,'ST_HAS_CARD_READER',2,'SALES_TERMINAL_PROPERTIES'),(12597,0,1,'Empregado pode entrar em todas as cartes',729,'ST_SALESMAN_CAN_ENTER_ALL_TABLES',2,'SALES_TERMINAL_PROPERTIES'),(12598,0,1,'Empregado controla um PLU',730,'ST_SALESMAN_OWNS_PLU',2,'SALES_TERMINAL_PROPERTIES'),(12599,0,1,'Mostra nome Empregado nos botes das cartes',731,'ST_SHOW_SALESMAN_NAME',2,'SALES_TERMINAL_PROPERTIES'),(12600,0,1,'Mostra artigos com a cor do Empregado',732,'ST_SHOW_PLUS_WITH_SALESMAN_COLOR',2,'SALES_TERMINAL_PROPERTIES'),(12601,0,1,'Pedido Automtico dos artigos',733,'ST_AUTO_ORDER_PLU',2,'SALES_TERMINAL_PROPERTIES'),(12603,0,1,'Desenha acumulado ao invs de pedir',735,'ST_DRAW_ACCUMULATE_INSTEAD_OF_ORDER',2,'SALES_TERMINAL_PROPERTIES'),(12604,0,1,'Mostra acumulado',736,'ST_SHOW_ACCUMULATE',2,'SALES_TERMINAL_PROPERTIES'),(12606,0,1,'Entrada Automtica',738,'ST_AUTO_COUVERT',2,'SALES_TERMINAL_PROPERTIES'),(12607,0,1,'Modo Take-away',739,'ST_TAKE_AWAY_MODE',2,'SALES_TERMINAL_PROPERTIES'),(12608,0,1,'Artigo pertencente ao Empregado do fecho',740,'ST_PLU_OWNED_BY_CLOSING_SALESMAN',2,'SALES_TERMINAL_PROPERTIES'),(12609,0,1,'Consumo Fixo',741,'ST_FIXED_CONSUMPTION',2,'SALES_TERMINAL_PROPERTIES'),(12610,0,1,'Modo Cantina',742,'ST_CANTEEN_MODE',2,'SALES_TERMINAL_PROPERTIES'),(12611,0,1,'Lana Front End',743,'ST_PRINT_RECEIPT_DUPLICATE',2,'SALES_TERMINAL_PROPERTIES'),(12612,0,1,'Impresso do mapa de IVA\'s no recibo',744,'ST_PRINT_TAX_TABLE_IN_RECEIPT',2,'SALES_TERMINAL_PROPERTIES'),(12613,0,1,'Apenas uma moeda',745,'ST_ONE_CURRENCY',2,'SALES_TERMINAL_PROPERTIES'),(12614,0,1,'Modo Pub',746,'ST_PUB_MODE',2,'SALES_TERMINAL_PROPERTIES'),(12615,0,1,'Lana Device Manager',747,'ST_PRINT_A4_RECEIPT',2,'SALES_TERMINAL_PROPERTIES'),(12617,0,1,'Cabealhos Rodaps',749,'DocumentPartsWindow',2,'SCREEN_CONFIG_DOCUMENTPARTS'),(12618,0,1,'Descrio',750,'DocumentPartsDescription',2,'SCREEN_CONFIG_DOCUMENTPARTS'),(12619,0,1,'Cdigo',751,'DocumentPartsCode',2,'SCREEN_CONFIG_DOCUMENTPARTS'),(12620,0,1,'Tipo',752,'DocumentPartsType',2,'SCREEN_CONFIG_DOCUMENTPARTS'),(12621,0,1,'',753,'DocumentPartsContent',2,'SCREEN_CONFIG_DOCUMENTPARTS'),(12623,0,1,'Procurar',755,'DailyJournalBtnSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12624,0,1,'Total:',756,'TableProductTransfTableFromAmmount',2,'SCREEN_TABLE_PRODUCT_TRANSF'),(12627,0,1,'',759,'DailyJournalTimeFromSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12628,0,1,'',760,'DailyJournalTotalFromSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12629,0,1,'',761,'DailyJournalDateFromSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12630,0,1,'',762,'DailyJournalTimeToSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12631,0,1,'',763,'DailyJournalDateToSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12632,0,1,'',764,'DailyJournalTotalToSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12633,0,1,'Limpar',765,'DailyJournalBtnCleanFilters',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12634,0,1,'Intervalo Datas',766,'DailyJournalDateSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12635,0,1,'QT:',767,'TableProductTransfQt',2,'SCREEN_TABLE_PRODUCT_TRANSF'),(12637,0,1,'Gorjeta',769,'TableCloseTip',2,'SCREEN_TABLE_CLOSE'),(12638,0,1,'Critrios Filtragem',770,'DailyJournalSearchCaption',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12639,0,1,'Detalhes Documento',771,'DailyJournalDetailsCaption',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12640,0,1,'Imprimir Sub-Total',772,'DailyJournalBtnPrintSubTotal',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12641,0,1,'Valor desejado',773,'TableCloseTargetSalesValue',2,'SCREEN_TABLE_CLOSE'),(12642,0,1,'Correco',774,'TableCloseUseCorrectionItem',2,'SCREEN_TABLE_CLOSE'),(12643,0,1,'QT:',775,'TableCloseQt',2,'SCREEN_TABLE_CLOSE'),(12644,0,1,'Pagamento parcial',776,'TableCloseBtPartial',2,'SCREEN_TABLE_CLOSE'),(12645,0,1,'Contas mltiplas',777,'TableCloseBtMultiple',2,'SCREEN_TABLE_CLOSE'),(12646,0,1,'Diviso automtica',778,'TableCloseBtAutomaticSplit',2,'SCREEN_TABLE_CLOSE'),(12647,0,1,'+',779,'TableCloseBtAddPartial',2,'SCREEN_TABLE_CLOSE'),(12648,0,1,'Conta nica',780,'TableCloseBtCancelPartial',2,'SCREEN_TABLE_CLOSE'),(12649,0,1,'-',781,'TableCloseBtRemovePartial',2,'SCREEN_TABLE_CLOSE'),(12650,0,1,'Tipo',782,'DocumentTypeType',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12651,0,1,'Cab. subtotais',783,'PrintersDocumentType0',2,'SCREEN_CONFIG_PRINTERS'),(12652,0,1,'Cab. pedidos',784,'PrintersDocumentType1',2,'SCREEN_CONFIG_PRINTERS'),(12653,0,1,'Consulta de mesa',785,'DocTypeSubtotal',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12654,0,1,'Factura',786,'DocTypeInvoice',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12655,0,1,'Invoice Copy',787,'DocTypeInvoiceCopy',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12656,0,1,'Guia de Transporte',788,'DocTypeVoided',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12657,0,1,'Anulao Sem Desperdicio',789,'DocTypeRefundNoWaste',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12658,0,1,'Anulao Com Desperdicio',790,'DocTypeRefundWaste',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12659,0,1,'Recibo',791,'DocTypeReceipt',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12660,0,1,'Factura\\Recibo',792,'DocTypeFacReceipt',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12661,0,1,'Factura No descriminada',793,'DocTypeNdesc',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12662,0,1,'Abertura de Caixa',794,'DocTypeOpenDrawer',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12663,0,1,'Declarao de Caixa',795,'DocTypeCashDeclare',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12664,0,1,'Movimento de Caixa',796,'DocTypeCashMovemet',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12665,0,1,'Consumo prprio',797,'DocTypeConsumo',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12666,0,1,'Conta corrente',798,'DocTypeContaCorrente',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12667,0,1,'Relatrios',799,'DocTypeReport',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12668,0,1,'Pedidos',800,'DocTypePedidos',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(12669,0,1,'Normal',801,'PaymentTypeNormal',2,'SCREEN_CONFIG_PAYMENT_TYPES'),(12670,0,1,'Dinheiro',802,'PaymenTypeCash',2,'SCREEN_CONFIG_PAYMENT_TYPES'),(12671,0,1,'Facturao externa',803,'PaymentTypeExternalBilling',2,'SCREEN_CONFIG_PAYMENT_TYPES'),(12672,0,1,'Conta corrente',804,'PaymentTypeChargeAccount',2,'SCREEN_CONFIG_PAYMENT_TYPES'),(12673,0,1,'Tipos pag.',805,'PaymentTypesTypes',2,'SCREEN_CONFIG_PAYMENTTYPES'),(12674,0,1,'Empregados',806,'ExclusionsSalesmanLabel',2,'SCREEN_CONFIG_EXCLUSIONS'),(12675,0,1,'Srie',807,'ExclusionsZonesLabel',2,'SCREEN_CONFIG_EXCLUSIONS'),(12676,0,1,'Famlias',808,'ExclusionsFamiliesLabel',2,'SCREEN_CONFIG_EXCLUSIONS'),(12677,0,1,'SubFamlias',809,'ExclusionsSubFamiliesLabel',2,'SCREEN_CONFIG_EXCLUSIONS'),(12678,0,1,'Perfis',810,'ExclusionsProfilesLabel',2,'SCREEN_CONFIG_EXCLUSIONS'),(12679,0,1,'No pode excluir todos os empregados!|Por favore seleccione pelo menos um empregado.',811,'ExclusionsMsgBox1',2,'SCREEN_CONFIG_EXCLUSIONS'),(12680,0,1,'Excluses',812,'ProfileExclusions',2,'SCREEN_CONFIG_PROFILES'),(12681,0,1,'Carto',813,'TableCloseClientCardID',2,'SCREEN_TABLE_CLOSE'),(12682,0,1,'Este produto est inactivo. ',814,'MSG_PRODUCT_NOTACTIVE',2,'MSGBOX'),(12683,0,1,'O ltimo registo no pode ser eliminado.',815,'MSG_DELETE_LAST_ELEMENT_LIST',2,'MSGBOX'),(12684,0,1,'Ocorreu uma situao inesperada ao eliminar o registo. Por favor tente novamente.',816,'MSG_GENERAL_ERROR_ON_DELETE',2,'MSGBOX'),(12685,0,1,'Perguntar antes eliminar um registo',817,'ask_on_deletion',2,'GENERAL_CONFIG'),(12686,0,1,'Aviso|Tem a certeza que deseja eliminar o registo?',818,'MSG_ARE_U_SURE_DUDE',2,'MSGBOX'),(12687,0,1,'Aviso|Tem certeza que quer anular este documento?',819,'DailyJournalConfirmRefund',2,'MSGBOX'),(12688,0,1,'Aviso|Este documento j foi anulado!',820,'DailyJournalCantRefund',2,'MSG_BOX'),(12689,0,1,'Erro|No foi possvel guardar alteraes ao documento!',821,'Generic',2,'MSG_BOX'),(12690,0,1,'Estado',822,'DailyJournalDocumentState',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12691,0,1,'Normal',823,'DailyJournalDocumentStateString',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12692,0,1,'Anulado',824,'DailyJournalDocumentStateString',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12693,0,1,'Todos',825,'Generic',2,'GENERIC'),(12694,0,1,'Esta impressora no pode ser apagada',826,'PrinterLocationsWarning',2,'PRINTER_MAPS'),(12695,0,1,'Default',827,'DropBoxText',2,'DEFAULT_TEXT'),(12696,0,1,'Erro ao gravar a entidade.',828,'MSG_ENTITY_SAVE',2,'MSGBOX'),(12697,0,1,'Erro ao adicionar a entidade ',829,'MSG_ENTITY_ADD',2,'MSGBOX'),(12698,0,1,'Erro ao atualizar a entidade ',830,'MSG_ENTITY_UPDATE',2,'MSGBOX'),(12699,0,1,'Erro ao ler a entidade ',831,'MSG_ENTITY_LOAD',2,'MSGBOX'),(12700,0,1,'No foi possvel fechar o carto!',832,'MSG_TABLE_CLOSE_FAILED',2,'SCREEN_TABLE_CLOSE'),(12701,0,1,'No existem artigos no carto!',833,'MSG_TABLE_EDIT',2,'SCREEN_TABLE_EDIT'),(12702,0,1,'No pode efectuar esta operao|Este documento j foi anulado',834,'MSG_DAILY_JOURNAL',2,'SCREEN_DAILY_JOURNAL'),(12703,0,1,'Aviso!|Este parcial tem artigos\\nQuer transferi-los para o carto de origem?',835,'MSG_TABLE_CLOSE',2,'SCREEN_TABLE_CLOSE'),(12704,0,1,'Aviso!|Tem que ter pelo menos um parcial!',836,'MSG_TABLE_CLOSE',2,'SCREEN_TABLE_CLOSE'),(12705,0,1,'Sem excluses',837,'ProfilesExclusionDropBox',2,'SCREEN_CONFIG_ESCLUSIONS'),(12706,0,1,'IVA1',838,'ItemTaxIndex0',2,'SCREEN_CONFIG_ZONES'),(12707,0,1,'IVA2',839,'ItemTaxIndex1',2,'SCREEN_CONFIG_ZONES'),(12708,0,1,'Aviso|No possui permisso para aceder a esta funcionalidade.',842,'MSG_PERMISSION_DENIED',2,'MSGBOX'),(12709,0,1,'Licenciamento',843,'LicencesWindow',2,'SCREEN_LICENCES'),(12710,0,1,'Continuar',844,'BtnContinue1',2,'SCREEN_LICENCES'),(12711,0,1,'Cancelar',845,'BtnCancel',2,'SCREEN_LICENCES'),(12712,0,1,'Utilizador',846,'LicencesUser',2,'SCREEN_LICENCES'),(12713,0,1,'Continuar',847,'BtnContinue2',2,'SCREEN_LICENCES'),(12714,0,1,'Voltar',848,'BtnBack',2,'SCREEN_LICENCES'),(12715,0,1,'Senha',849,'LicencesPwd',2,''),(12716,0,1,'Ficheiro de licenciamento',850,'LicencesFile',2,''),(12718,0,1,'O artigo no pode ser adicionado. J atingiu o seu limite mximo de venda.',852,'MsgBoxTableEditCantAddMore',2,'SCREEN_TABLE_EDIT'),(12719,0,1,'Indique o valor desejado|',854,'MsgBoxAskPrice',2,'SCREEN_TABLE_EDIT'),(12720,0,1,'Data Fecho Dia',855,'CloseCashierDayClose',2,'SCREEN_CASHIER_CLOSE'),(12721,0,1,'',856,'CloseCashierDay',2,'SCREEN_CASHIER_CLOSE'),(12722,0,1,'',857,'CloseCashierMonth',2,'SCREEN_CASHIER_CLOSE'),(12723,0,1,'',858,'CloseCashierYear',2,'SCREEN_CASHIER_CLOSE'),(12724,0,1,'Aviso|No possui permisses para aceder a cartes de outros empregados.',859,NULL,2,NULL),(12725,0,1,'Filtro',860,'ItemFilters',2,'SCREEN_CONFIG_ITEMS'),(12726,0,1,'TerminalsC',861,'TerminalsC',2,'SCREEN_CONFIG_TERMINALS'),(12727,0,1,'Gaveta',862,'TerminalsCDDevice',2,'SCREEN_CONFIG_TERMINALS'),(12728,0,1,'Normal',863,'DocStatusNormal',2,NULL),(12729,0,1,'Anulado',864,'DocStatusAnulate',2,NULL),(12730,0,1,'Estado',865,'DailyJournalStatusSearch',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12731,0,1,'Tipo',866,'DailyJournalDocumentType',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12732,0,1,'Empregado',867,'OpenTablesSalesman',2,'SCREEN_CONFIG_OPEN_TABLES'),(12733,0,1,'Sub-Total',868,'OpenTablesBtnSubTotal',2,'SCREEN_CONFIG_OPEN_TABLES'),(12734,0,1,'Transferir Artigos',869,'OpenTablesBtnProdutTransfer',2,'SCREEN_CONFIG_OPEN_TABLES'),(12735,0,1,'Fechar Carto',870,'OpenTablesBtnCloseTable',2,'SCREEN_CONFIG_OPEN_TABLES'),(12736,0,1,'Limpar Carto',871,'OpenTablesBtnCleanTable',2,'SCREEN_CONFIG_OPEN_TABLES'),(12738,0,1,'Erro|No tem permisso para anular artigos',873,'DailyJournalRefundMessageBox',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(12739,0,1,'Aviso|O carto de destino no pode ser o carto de origem!\\nPor favor seleccione outro carto.',874,'TransferMsgBox',2,'SCREEN_PRODUCT_TRANSFER'),(12740,0,1,'Aviso|Este artigo no se encontra activo!',876,'TableEditMsgBoxCanAddItem',2,'SCREEN_TABLE_EDIT'),(12741,0,1,'Aviso|As formas de pagamento devem ser maiores que o total dos artigos!',877,'TableCloseMessageBOx',2,'SCREEN_TABLE_CLOSE'),(12742,0,1,'',878,'CloseCashierSaftDay',2,'SCREEN_CASHIER_CLOSE'),(12743,0,1,'',879,'CloseCashierSaftMonth',2,'SCREEN_CASHIER_CLOSE'),(12744,0,1,'',880,'CloseCashierSaftYear',2,'SCREEN_CASHIER_CLOSE'),(12745,0,1,'Aviso|Pretende transferir este(s) carto(s) para ',881,'OpenTablesMsgBox',2,'SCREEN_CONFIG_OPEN_TABLES'),(12747,0,1,'Abertura',883,'OpenTablesOpenTime',2,'SCREEN_CONFIG_OPEN_TABLES'),(12748,0,1,'Actividade',884,'OpenTablesLastActivity',2,'SCREEN_CONFIG_OPEN_TABLES'),(12749,0,1,'Erro|No foi possvel guardar alteraes ao carto!',885,'OpenTablesErrorMsgBox',2,'SCREEN_CONFIG_OPEN_TABLES'),(12750,0,1,'Aviso|Pretende transferir todas as cartes?',886,'OoenTablesMessageBox2',2,'SCREEN_CONFIG_OPEN_TABLES'),(12751,0,1,'Relatrios',887,'ReportsWindow',2,'SCREEN_REPORTS'),(12752,0,1,'Data',888,'ReportSingleDate',2,'SCREEN_REPORTS'),(12753,0,1,'Empregado',889,'ReportSalesman',2,'SCREEN_REPORTS'),(12754,0,1,'Imprimir',890,'ReportBtnPrint',2,'SCREEN_REPORTS'),(12755,0,1,'',891,'ReportPreview',2,'SCREEN_REPORTS'),(12756,0,1,'Pr-visualizar',892,'ReportBtnPreview',2,'SCREEN_REPORTS'),(12757,0,1,'Modo Utilizao',893,'ReportHint',2,'SCREEN_REPORTS'),(12758,0,1,'N1 do D.L.N346/85 de 23 de Agosto',894,'MSG_IVATABACO',2,'MSG INSENAO'),(12759,0,1,'',895,'ReportsDay',2,'SCREEN_REPORTS'),(12760,0,1,'',896,'ReportsMonth',2,'SCREEN_REPORTS'),(12761,0,1,'',897,'ReportsYear',2,'SCREEN_REPORTS'),(12762,0,1,'Desconto de linha',898,'TableDiscountsLblLinel',2,'SCREEN_TABLE_DISCOUNTS'),(12763,0,1,'Reset',899,'TableDiscountsTableReset',2,'SCREEN_TABLE_DISCOUNTS'),(12764,0,1,'Desconto Todas Linhas',900,'TableDiscountsLblHeader',2,'SCREEN_TABLE_DISCOUNTS'),(12765,0,1,'',901,'TableDiscountsLineQt',2,'SCREEN_TABLE_DISCOUNTS'),(12766,0,1,'-',902,'TableDiscountsDecrementLineQt',2,'SCREEN_TABLE_DISCOUNTS'),(12767,0,1,'+',903,'TableDiscountsIncrementLineQt',2,'SCREEN_TABLE_DISCOUNTS'),(12768,0,1,'- 1%',904,'TableDiscountsDecrementLineDiscount',2,'SCREEN_TABLE_DISCOUNTS'),(12769,0,1,'+ 1%',905,'TableDiscountsIncrementLineDiscount',2,'SCREEN_TABLE_DISCOUNTS'),(12770,0,1,'0%',906,'TableDiscountsLineDiscount1',2,'SCREEN_TABLE_DISCOUNTS'),(12771,0,1,'5%',907,'TableDiscountsLineDiscount2',2,'SCREEN_TABLE_DISCOUNTS'),(12772,0,1,'10%',908,'TableDiscountsLineDiscount3',2,'SCREEN_TABLE_DISCOUNTS'),(12773,0,1,'25%',909,'TableDiscountsLineDiscount4',2,'SCREEN_TABLE_DISCOUNTS'),(12774,0,1,'50%',910,'TableDiscountsLineDiscount5',2,'SCREEN_TABLE_DISCOUNTS'),(12775,0,1,' ',911,'TableDiscountsHeaderQt',2,'SCREEN_TABLE_DISCOUNTS'),(12776,0,1,'-',912,'TableDiscountsDecrementHeaderQt',2,'SCREEN_TABLE_DISCOUNTS'),(12777,0,1,'+',913,'TableDiscountsIncrementHeaderQt',2,'SCREEN_TABLE_DISCOUNTS'),(12778,0,1,'',914,'TableDiscountsHeaderDiscount',2,'SCREEN_TABLE_DISCOUNTS'),(12779,0,1,'- 1%',915,'TableDiscountsDecrementHeaderDiscount',2,'SCREEN_TABLE_DISCOUNTS'),(12780,0,1,'+ 1%',916,'TableDiscountsIncrementHeaderDiscount',2,'SCREEN_TABLE_DISCOUNTS'),(12781,0,1,'0%',917,'TableDiscountsHeaderDiscount1',2,'SCREEN_TABLE_DISCOUNTS'),(12782,0,1,'5%',918,'TableDiscountsHeaderDiscount2',2,'SCREEN_TABLE_DISCOUNTS'),(12783,0,1,'10%',919,'TableDiscountsHeaderDiscount3',2,'SCREEN_TABLE_DISCOUNTS'),(12784,0,1,'25%',920,'TableDiscountsHeaderDiscount4',2,'SCREEN_TABLE_DISCOUNTS'),(12785,0,1,'50%',921,'TableDiscountsHeaderDiscount5',2,'SCREEN_TABLE_DISCOUNTS'),(12786,0,1,'Total c/ desconto',922,'TableDiscountsTotalWithDiscount',2,'SCREEN_TABLE_DISCOUNTS'),(12787,0,1,'Total s/ desconto',923,'TableDiscountsTotalWithoutDiscount',2,'SCREEN_TABLE_DISCOUNTS'),(12788,0,1,'Total Desconto',924,'TableDiscountsTotalDiscount',2,'SCREEN_TABLE_DISCOUNTS'),(12789,0,1,'Caixa',925,'OpenSessionCashDrawers',2,'SCREEN_SESSION_OPEN'),(12790,0,1,'Fundo maneio',926,'OpenSessionWorkingFund',2,'SCREEN_SESSION_OPEN'),(12791,0,1,'Fechar Sesso',928,NULL,2,'SCREEN_SESSION_CLOSE'),(12792,0,1,'Abertura Caixa',929,'CashDrawerOpenWindow',2,'SCREEN_CASHIER_OPEN'),(12793,0,1,'Abrir Caixa',930,'CashDrawerOpenBtnOpens',2,'SCREEN_CASHIER_OPEN'),(12794,0,1,'Fundo Maneio',931,'CashDrawerOpenWorkingFund',2,'SCREEN_CASHIER_OPEN'),(12795,0,1,'Fechar Caixa',932,'CashDrawerCloseWindow',2,'SCREEN_CASHIER_CLOSE'),(12797,0,1,' ',934,'CashDrawerCloseDay',2,'SCREEN_CASHIER_CLOSE'),(12798,0,1,' ',935,'CashDrawerCloseMonth',2,'SCREEN_CASHIER_CLOSE'),(12799,0,1,' ',936,'CashDrawerCloseYear',2,'SCREEN_CASHIER_CLOSE'),(12800,0,1,' ',937,'CashDrawerCloseSaftDay',2,'SCREEN_CASHIER_CLOSE'),(12801,0,1,' ',938,'CashDrawerCloseSaftMonth',2,'SCREEN_CASHIER_CLOSE'),(12802,0,1,' ',939,'CashDrawerCloseSaftYear',2,'SCREEN_CASHIER_CLOSE'),(12803,0,1,'Fechar Caixa',940,'CashDrawerCloseBtnClose',2,'SCREEN_CASHIER_CLOSE'),(12804,0,1,'Fundo',941,'CashDrawerCloseFund',2,'SCREEN_CASHIER_CLOSE'),(12805,0,1,'Fechar Caixa',942,' ',2,'SCREEN_CASHIER_CLOSE'),(12806,0,1,'Saft',944,'DayCloseWindow',2,'SCREEN_DAY_CLOSE'),(12807,0,1,'Saft',943,'DayCloseCaption',2,'SCREEN_DAY_CLOSE'),(12808,0,1,'Valor',945,'CashDrawerCloseSelectedValue',2,'SCREEN_CASHIER_CLOSE'),(12809,0,1,'Total Caixa',946,'CashDrawerCloseTotal',2,'SCREEN_CASHIER_CLOSE'),(12810,0,1,'Move Baixo',947,'FamiliesOrderDown',2,'SCREEN_CONFIG_FAMILIES'),(12811,0,1,'Move Cima',948,'FamiliesOrderUp',2,'SCREEN_CONFIG_FAMILIES'),(12812,0,1,'Nova Famlia',949,'FamiliesNewItemFamily',2,'SCREEN_CONFIG_FAMILIES'),(12813,0,1,'Aviso|Pretende mudar para o perfil ',950,'ProfileChange',2,'SCREEN_TABLE_EDIT'),(12814,0,1,'Aviso|O perfil actual expirou!\\n\\nPretende manter o perfil [1] (no) ou mudar para [2](sim)?',951,'ProfileChange',2,'SCREEN_TABLE_EDIT'),(12816,0,1,'Activar Perfil',953,'ProfilesManagement',2,'SCREEN_PROFILES_SELECTION'),(12817,0,1,'Aviso|Tem a certeza que quer activar o perfil ',954,'ProfilesManagement',2,'SCREEN_PROFILES_SELECTION'),(12818,0,1,'Aviso|Tem a certeza que quer desactivar o perfil ',955,'ProfilesManagement',2,'SCREEN_PROFILES_SELECTION'),(12819,0,1,'Aviso|O perfil activo para as configuraes actuais mudou. Quer activar o perfil ',956,'Profiles',2,'SCREEN_CONFIG_PROFILES'),(12820,0,1,'Empregados',957,'ExclusionsCustomersLabel',2,'SCREEN_CONFIG_EXCLUSIONS'),(12821,0,1,'AppBacks',958,'AppBacks',2,'SCREEN_DAY_CLOSE'),(12822,0,1,'Aviso|No pode ter artigos com nome vazio!',959,'CallbackNoItemName',2,'SCREEN_CONFIG_ITEMS'),(12823,0,1,'Substituir dados em falta por \'omisso\'',960,'CashDrawerCloseBtnGerarOmissos',2,'SCREEN_DAY_CLOSE'),(12824,0,1,'Aviso|Este cabealho/rodap est a ser usado!\\nPor favor altere os tipos de documento que o usam para poder elimin-lo!',961,'Docpart removal check',2,'SCREEN_CONFIG_DOCUMENTPARTS'),(12825,0,1,'Aviso|Deseja sair da aplicao?',964,'',2,NULL),(12826,0,1,'Aviso|Deseja sair da aplicao?',962,'',2,NULL),(12828,0,1,'Fecho Dia',965,NULL,2,NULL),(12831,0,1,'Aviso|Funcionalidade ainda no implementada.',968,'App',2,NULL),(12832,0,1,'Preos',969,'TableEditPriceChange',2,'SCREEN_TABLE_EDIT'),(12833,0,1,'Histrico',970,'TableEditHistoric',2,'SCREEN_TABLE_EDIT'),(12834,0,1,'Acumular Cartes',971,'TableEditJoinTables',2,'SCREEN_TABLE_EDIT'),(12836,0,1,'Ajuda',973,'DocumentPartsHints',2,'SCREEN_CONFIG_DOCUMENTPARTS'),(12837,0,1,'No foi possvel gravar mapa da srie',974,'ZoneErrorStr',2,'ZoneSave'),(12838,0,1,'No foi possvel gravar as propriedades da srie',975,'ZoneErrorStr',2,'ZoneSave'),(12839,0,1,'No foi possvel gravar srie',976,'ZoneErrorStr',2,'ZoneSave'),(12840,0,1,'No foi possvel guardar nova entidade',977,'GenericSaveError',2,'SaveError'),(12841,0,1,'No foi possvel guardar as modificaes feitas  entidade',978,'GenericSaveError',2,'SaveError'),(12842,0,1,'No foi possvel carregar entidade',979,'GenericLoadError',2,'LoadError'),(12843,0,1,'No foi possvel carregar sries',980,'ZoneLoadError',2,'ZoneLoad'),(12844,0,1,'erro ao carregar as propriedades',981,'ZoneLoadError',2,'ZoneLoad'),(12845,0,1,'erro ao carregar os mapas',982,'ZoneLoadError',2,'ZoneLoad'),(12846,0,1,'No foi possvel carregar a srie pretendida',983,'ZoneLoadError',2,'ZoneLoad'),(12847,0,1,'No foi possvel gravar Configurao Geral',984,'GeneralConfigZSaveError',2,'GeneralConfigSave'),(12848,0,1,'DELETE no executado',985,'GenericDeleteError',2,'Generic'),(12849,0,1,'NIF',987,'NewClientNIF',2,''),(12850,0,1,'Nome',988,'NewClientName',2,''),(12851,0,1,'Localidade',989,'NewClientLocality',2,''),(12852,0,1,'Erro|No foi possvel efectuar a ligao  base de dados!\\nNo  possvel continuar!',990,'DatabaseConnectError',2,'PreDesktopError'),(12853,0,1,'Erro|No existe configurao para este posto',991,'NoConfigurationError',2,'PreDesktopError'),(12854,0,1,'Erro|Tem que ter uma licena vlida no servidor para licenciar este posto',992,'NoLicenseError',2,'PreDesktopError'),(12855,0,1,'Ocorreram erros ao carregar a tabela ',993,'DatabaseLoadError',2,'PreDesktopError'),(12856,0,1,'No foi possvel carregar o carto:',994,'LoadTable',2,'ScreenTableEdit'),(12857,0,1,'',995,'ReportsDay2',2,'SCREEN_REPORTS'),(12858,0,1,'',996,'ReportsMonth2',2,'SCREEN_REPORTS'),(12859,0,1,'',997,'ReportsYear2',2,'SCREEN_REPORTS'),(12860,0,1,'Produto',998,'ReportsItemName',2,'SCREEN_REPORTS'),(12861,0,1,'Guarda registos na base de dados do posto',999,'SalesTerminalPropertyString',2,''),(12862,0,1,'Socket',1000,'DeviceManagerDeviceTextSocket',2,'SCREEN_CONFIG_DEVICES'),(12863,0,1,'IP',1001,'DeviceManagerDeviceTextIP',2,'SCREEN_CONFIG_DEVICES'),(12864,0,1,'Nome',1002,'DeviceManagerDeviceTextName',2,'SCREEN_CONFIG_DEVICES'),(12865,0,1,'DeviceManagerDeviceName',1003,'DeviceManagerDeviceName',2,'SCREEN_CONFIG_DEVICES'),(12866,0,1,'Nome Carto',1004,'TableNamesTableName',2,'SCREEN_TABLE_NAMES'),(12867,0,1,'Sries',1005,'TableNamesZones',2,'SCREEN_TABLE_NAMES'),(12868,0,1,'Terminal',1007,'CashDrawerOpenTerminal',2,'SCREEN_CASHIER_OPEN'),(12869,0,1,'Comandos rdio',1008,'TecConfigOption',2,'SCREEN_CONFIG'),(12870,0,1,'Terminais rdio',1009,'RadioTerminalsWindow',2,'SCREEN_CONFIG_RADIO_TERMINALS'),(12871,0,1,'Porta Srie em uso:',1010,'RadioTerminalsSerial',2,'SCREEN_CONFIG_RADIO_TERMINALS'),(12872,0,1,'Configurao activa:',1011,'RadioTerminalsConfig',2,'SCREEN_CONFIG_RADIO_TERMINALS'),(12873,0,1,'Estas operaes s esto disponveis em terminais que tenham antenas rdio X64',1012,'RadioTerminalsComments',2,'SCREEN_CONFIG_RADIO_TERMINALS'),(12874,0,1,'Enviar PLUs',1013,'RadioTerminalsSendPlus',2,'SCREEN_CONFIG_RADIO_TERMINALS'),(12875,0,1,'Enviar string',1014,'RadioTerminalsSendMenus',2,'SCREEN_CONFIG_RADIO_TERMINALS'),(12876,0,1,'Enviar formas pag.',1015,'RadioTerminalsSendPaymentTypes',2,'SCREEN_CONFIG_RADIO_TERMINALS'),(12877,0,1,'Enviar config. do comando',1016,'RadioTerminalsSendConfig',2,'SCREEN_CONFIG_RADIO_TERMINALS'),(12878,0,1,'Pede pessoas',1017,'RadioTerminalsAskPpl',2,'SCREEN_CONFIG_RADIO_TERMINALS'),(12879,0,1,'Pede met. pag.',1018,'RadioTerminalsAskPaymentTypes',2,'SCREEN_CONFIG_RADIO_TERMINALS'),(12880,0,1,'Iluminao',1019,'RadioTerminalsLight',2,'SCREEN_CONFIG_RADIO_TERMINALS'),(12881,0,1,'Eliminar Licena',1020,'LicencesDelete',2,'SCREEN_CONFIG_LICENCE'),(12882,0,1,'Dados Licena',1021,'LicencesDetail',2,'SCREEN_CONFIG_LICENCE'),(12883,0,1,' ',1023,'MovementsPrintTimeFromSearch',2,'SCREEN_MOVEMENTS_PRINT'),(12884,0,1,' ',1024,'MovementsPrintTotalFromSearch',2,'SCREEN_MOVEMENTS_PRINT'),(12885,0,1,' ',1025,'MovementsPrintDateFromSearch',2,'SCREEN_MOVEMENTS_PRINT'),(12886,0,1,'Empregado',1026,'MovementsPrintSalesman',2,'SCREEN_MOVEMENTS_PRINT'),(12887,0,1,'Procurar',1027,'MovementsPrintBtnSearch',2,'SCREEN_MOVEMENTS_PRINT'),(12888,0,1,' ',1028,'MovementsPrintTimeToSearch',2,'SCREEN_MOVEMENTS_PRINT'),(12889,0,1,' ',1029,'MovementsPrintDateToSearch',2,'SCREEN_MOVEMENTS_PRINT'),(12890,0,1,' ',1030,'MovementsPrintTotalToSearch',2,'SCREEN_MOVEMENTS_PRINT'),(12891,0,1,'Intervalo Horas',1031,'MovementsPrintTimeSearch',2,'SCREEN_MOVEMENTS_PRINT'),(12892,0,1,'Intervalo Datas',1032,'MovementsPrintDateSearch',2,'SCREEN_MOVEMENTS_PRINT'),(12893,0,1,'Intervalo Totais',1033,'MovementsPrintTotalCaption',2,'SCREEN_MOVEMENTS_PRINT'),(12894,0,1,'Limpar',1034,'MovementsPrintBtnCleanFilters',2,'SCREEN_MOVEMENTS_PRINT'),(12895,0,1,'Detalhes',1035,'MovementsPrintDetailsCaption',2,'SCREEN_MOVEMENTS_PRINT'),(12896,0,1,'Imprimir',1036,'MovementsPrintBtnPrint',2,'SCREEN_MOVEMENTS_PRINT'),(12897,0,1,'Empregado',1037,'MovementsPrintSalesmanSearch',2,'SCREEN_MOVEMENTS_PRINT'),(12898,0,1,'Tipo Movimento',1038,'MovementsPrintMovementTypeSearch',2,'SCREEN_MOVEMENTS_PRINT'),(12899,0,1,'Critrios Pesquisa',1039,'MovementsPrintSearchCaption',2,'SCREEN_MOVEMENTS_PRINT'),(12900,0,1,'Tipo Mov.',1040,'MovementsPrintMovementType',2,'SCREEN_MOVEMENTS_PRINT'),(12901,0,1,'Data/Hora',1041,'MovementsPrintDatetime',2,'SCREEN_MOVEMENTS_PRINT'),(12902,0,1,'Valor',1042,'MovementsPrintValue',2,'SCREEN_MOVEMENTS_PRINT'),(12903,0,1,'Caixas',1043,'MovementsPrintCasdrawerSearch',2,'SCREEN_MOVEMENTS_PRINT'),(12904,0,1,'Descrio',1044,'MovementsPrintDescription',2,'SCREEN_MOVEMENTS_PRINT'),(12905,0,1,'Caixa',1045,'MovementsPrintCashDrawer',2,'SCREEN_MOVEMENTS_PRINT'),(12906,0,1,'Novo Movimento',1046,'ScreenMovementsWindow',2,'SCREEN_MOVEMENTS'),(12907,0,1,'Descritivo',1047,'ScreenMovementsDescription',2,'SCREEN_MOVEMENTS'),(12908,0,1,'Valor',1048,'ScreenMovementsValue',2,'SCREEN_MOVEMENTS'),(12909,0,1,'Movimento',1049,'ScreenMovementsMovType',2,'SCREEN_MOVEMENTS'),(12910,0,1,'Empregado',1050,'ScreenMovementsSalesman',2,'SCREEN_MOVEMENTS'),(12911,0,1,'Cliente',1051,'ScreenMovementsClientName',2,'SCREEN_MOVEMENTS'),(12912,0,1,'115 Vendas - Descontos',1052,NULL,2,'TABLE EDIT'),(12913,0,1,'116 Vendas - Fecha Cartes Abertos ( consulta)',1053,NULL,2,'OPENTABLES'),(12914,0,1,'Pagamento CC',1055,'CustomerAccountWindow',2,'SCREEN_CUSTOMER_ACCOUNT'),(12915,0,1,'Saldo',1056,'CustomerAccountBalance',2,'SCREEN_CUSTOMER_ACCOUNT'),(12916,0,1,'Pagar',1057,'CustomerAccountBthPay',2,'SCREEN_CUSTOMER_ACCOUNT'),(12917,0,1,'A Pagar',1058,'CustomerAccountPayable',2,'SCREEN_CUSTOMER_ACCOUNT'),(12918,0,1,'Cliente',1059,'CustomerAccountClientName',2,'SCREEN_CUSTOMER_ACCOUNT'),(12919,0,1,'215 Sesses - Perfis',1072,'PERM_SESSIONS_PROFILES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12920,0,1,'213 Sesses - SAFT',1071,'PERM_SESSIONS_SAFT',2,'SALESMAN_LEVEL_PERMISSIONS'),(12921,0,1,'213 Sesses - Relatrios',1070,'PERM_SESSIONS_REPORTS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12922,0,1,'210 Sesses - Consulta Registos',1068,'PERM_SESSIONS_DAILY_JOURNAL',2,'SALESMAN_LEVEL_PERMISSIONS'),(12923,0,1,'209 Sesses - Fecho Dia',1067,'PERM_SESSIONS_CLOSE_DAY',2,'SALESMAN_LEVEL_PERMISSIONS'),(12924,0,1,'207 Sesses - Pagamento Conta Corrente',1065,'PERM_SESSIONS_CC',2,'SALESMAN_LEVEL_PERMISSIONS'),(12925,0,22,'206 Sesses - Sadas Caixa',1064,'PERM_SESSIONS_CASHDRAWER_OUT',2,'SALESMAN_LEVEL_PERMISSIONS'),(12926,0,1,'205 Sesses - Entradas Caixa',1063,'PERM_SESSIONS_CASHDRAWER_IN',2,'SALESMAN_LEVEL_PERMISSIONS'),(12927,0,1,'204 Sesses - Fechar Caixa',1062,'PERM_SESSIONS_CLOSE_CASHDRAWER',2,'SALESMAN_LEVEL_PERMISSIONS'),(12931,0,1,'113 Vendas - Acumula Cartes',1006,'PERM_SALESMAN_ACUMULATE',2,'SALESMAN_LEVEL_PERMISSIONS'),(12936,0,1,'113 Vendas - Faz pedidos 2',662,'PERM_SALESMAN_TESTE_1',2,'SALESMAN_LEVEL_PERMISSIONS'),(12948,0,1,'not in use',650,NULL,2,'SALESMAN_LEVEL_PERMISSIONS'),(12949,0,1,'407 Tcnico - Linguagens',649,'PERM_CONFIG_TEC_LANGUAGES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12950,0,1,'406 Tcnico - Impressoras',648,'PERM_CONFIG_TEC_PRINT_ZONES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12951,0,1,'405 Tcnico - Dispositivos',647,'PERM_CONFIG_TEC_HARDWARE',2,'SALESMAN_LEVEL_PERMISSIONS'),(12952,0,1,'404 Tcnico - Terminais',646,'PERM_CONFIG_TEC_TERMINALS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12953,0,1,'403 Tcnico - Excluses',645,'PERM_CONFIG_TEC_EXCLUSIONS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12954,0,1,'402 Tcnico - Sistema',644,'PERM_CONFIG_TEC_SYSTEM',2,'SALESMAN_LEVEL_PERMISSIONS'),(12955,0,1,'401 Tcnico - Tipos Documento',643,'PERM_CONFIG_TEC_DOC_TYPES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12956,0,1,'400 Tcnico - Perfis',642,'PERM_CONFIG_TEC_PROFILES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12957,0,1,'321 Config - Edio Nomes Cartes',641,'PERM_CONFIG_EDIT_TABLE_NAMES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12958,0,1,'320 Config - Ver Nomes Cartes',640,'PERM_CONFIG_SEE_TABLE_NAMES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12961,0,1,'319 Config - Edio Grupos Clientes',637,'PERM_CONFIG_EDIT_CUSTOMER_GROUPS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12962,0,1,'318 Config - Ver Grupos Clientes',636,'PERM_CONFIG_SEE_CUSTOMER_GROUPS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12963,0,1,'317 Config - Edio Caixas',635,'PERM_CONFIG_EDIT_CASHDRAWERS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12964,0,1,'316 Config - Ver Caixas',634,'PERM_CONFIG_SEE_CASHDRAWERS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12965,0,1,'315 Config - Edio Taxas IVA',633,'PERM_CONFIG_EDIT_TAXES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12966,0,1,'314 Config - Ver Taxas IVA',632,'PERM_CONFIG_SEE_TAXES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12967,0,1,'313 Config - Edio Clientes',631,'PERM_CONFIG_EDIT_CUSTOMERS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12968,0,1,'312 Config - Ver Clientes',630,'PERM_CONFIG_SEE_CUSTOMERS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12969,0,1,'311 Config - Edio Sries',629,'PERM_CONFIG_EDIT_ZONES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12970,0,1,'310 Config - Ver Sries',628,'PERM_CONFIG_SEE_ZONES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12971,0,1,'309 Config - Edio Formas Pagamento',627,'PERM_CONFIG_EDIT_PAYMENT_TYPES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12972,0,1,'308 Config - Ver Formas Pagamento',626,'PERM_CONFIG_SEE_PAYMENT_TYPES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12973,0,1,'AVAILABLE FOR USE',625,NULL,2,'SALESMAN_LEVEL_PERMISSIONS'),(12974,0,1,'AVAILABLE FOR USE',624,NULL,2,'SALESMAN_LEVEL_PERMISSIONS'),(12975,0,1,'303 Config - Edio Empregados',621,'PERM_PERM_CONFIG_EDIT_SALESMANS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12976,0,1,'302 Config - Ver Empregados',620,'PERM_CONFIG_SEE_SALESMANS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12977,0,1,'301 Config - Edio Artigos',619,'PERM_CONFIG_EDIT_ITEMS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12978,0,1,'300 Config - Ver Artigos',618,'PERM_CONFIG_SEE_ITEMS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12979,0,1,'203 Sesses - Abrir Caixa',617,'PERM_SESSIONS_OPEN_CASHDRAWER',2,'SALESMAN_LEVEL_PERMISSIONS'),(12981,0,1,'201 Sesses - Fecha Sesses',615,'PERM_SESSIONS_CLOSE_SESSION',2,'SALESMAN_LEVEL_PERMISSIONS'),(12982,0,1,'200 Sesses - Abre Sesses',614,'PERM_SESSIONS_OPEN_SESSION',2,'SALESMAN_LEVEL_PERMISSIONS'),(12984,0,1,'111 Vendas - Venda acima do limite mximo',612,'PERM_SALESMAN_ABOVE_LIMIT',2,'SALESMAN_LEVEL_PERMISSIONS'),(12985,0,1,'110 Vendas - Altera preo',611,'PERM_SALESMAN_CAN_CHANGE_PRICE',2,'SALESMAN_LEVEL_PERMISSIONS'),(12986,0,1,'109 Vendas - Fecha contas',610,'PERM_SALESMAN_CAN_CLOSE_TABLE',2,'SALESMAN_LEVEL_PERMISSIONS'),(12987,0,1,'108 Vendas - Consulta registos',609,'PERM_SALESMAN_CAN_ACCESS_HISTORY',2,'SALESMAN_LEVEL_PERMISSIONS'),(12988,0,1,'107 Vendas - Factura mltipla e parcial',608,'PERM_SALESMAN_MULTIPLE_PARCIAL_RECEIPT',2,'SALESMAN_LEVEL_PERMISSIONS'),(12989,0,1,'106 Vendas - Transferncias',607,'PERM_SALESMAN_CAN_TRANSFER_ITEMS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12990,0,1,'105 Vendas - Imprime apenas 1 subtotal',606,'PERM_SALESMAN_CAN_ONLY_PRINT_ONE_SUBTOTAL',2,'SALESMAN_LEVEL_PERMISSIONS'),(12991,0,1,'104 Vendas -  Devolues',605,'PERM_SALESMAN_CAN_REFUND',2,'SALESMAN_LEVEL_PERMISSIONS'),(12992,0,1,'103 Vendas - Anulaes',604,'PERM_SALESMAN_CAN_VOID_ORDERS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12993,0,1,'102 Vendas - Cancela Pedidos',603,'PERM_SALESMAN_CAN_CANCEL_ORDERS',2,'SALESMAN_LEVEL_PERMISSIONS'),(12994,0,1,'101 Vendas - Abre Gaveta',602,'PERM_SALESMAN_CAN_OPEN_DRAWER',2,'SALESMAN_LEVEL_PERMISSIONS'),(12995,0,1,'100 Vendas - Entra nos cartes de outros',601,'PERM_SALESMAN_CAN_ENTER_OTHERS_TABLES',2,'SALESMAN_LEVEL_PERMISSIONS'),(12996,0,1,'Imprimir Apuramento Caixa',1073,'CashDrawerCloseBtnMovements',2,'SCREEN_CASHIER_CLOSE'),(12997,0,1,'Usar prpria base de dados',1074,'ProfileOwnDatabase',2,'SCREEN_CONFIG_PROFILES'),(12998,0,1,'Este posto nao pode fechar cartoes',1075,'RadioMsg',2,'RadioMsg'),(12999,0,1,'Nao tem permissao para fechar cartoes',1076,'RadioMsg',2,'RadioMsg'),(13000,0,1,'Nao tem permissao para abrir gaveta!',1077,'RadioMsg',2,'RadioMsg'),(13001,0,1,'Aviso|O carto por defeito est fora do intervalo de cartes',1078,'DEFAULT_TABLE',2,'SCREEN_CONFIG_SALESMAN'),(13002,0,1,'100%',1079,'TableDiscountsLineDiscount6',2,'SCREEN_TABLE_DISCOUNTS'),(13003,0,1,'100%',1080,'TableDiscountsHeaderDiscount6',2,'SCREEN_TABLE_DISCOUNTS'),(13004,0,1,'Aviso|O perfil do radio actual expirou!\\n\\nPretende manter o perfil [1] (no), ou mudar para [2]( sim)?',1081,'RadioProfileMsg',2,'PROFILE_SELECTION'),(13005,0,1,'nenhum',1082,'RadioProfileMsg',2,'PROFILE_SELECTION'),(13006,0,1,'Erro de impresso|No foi possvel imprimir [Erro: %d]\\n\\nQuer tentar outra vez?',1083,'PrintError',2,'MSG_BOX_STRING'),(13007,0,1,'Erro de impresso|No foi possvel reimprimir\\n\\nQuer ignorar este erro e no tentar imprimir mais para esta impressora?\\n',1084,'PrintErrorMsg',2,'MSG_BOX_STRING'),(13008,0,1,'Aviso|Este cdigo j est a ser usado por %s!\n\nUm novo cdigo foi sugerido.',1085,'InvalidPluMsg',2,'MSG_BOX_STRING'),(13009,0,1,'Aviso|Por favor seleccione um cliente.',1086,'Msg',2,'MSG_BOX_STRING'),(13010,0,1,'Aviso|Possuindo pelo menos um documento seleccionado, o total a pagar dever ser igual ao somatrios dos documentos seleccionados.',1087,'Msg',2,'MSG_BOX_STRING'),(13011,0,1,'Erro ao atualizar o movimento de caixa no tendertenders com o UID \'%i\' da TransactionUID \'%i\'',1088,'Msg',2,'MSG_BOX_STRING'),(13012,0,1,'Erro ao gravar o movimento de crdito.',1089,'Msg',2,'MSG_BOX_STRING'),(13013,0,1,'Eventual',1090,'EventualName',2,'CUSTOMER_SCREEN'),(13014,0,1,'Foi encontrado um problema ao ler a entidade: ',1091,'LOAD_ERROR_MSG',2,'LOAD_ERROR'),(13016,0,1,'O NIF  um campo obrigatrio. Cliente \'%s\'.',1093,'CUSTOMER_ERROR',2,'CUSTOMER_ERROR'),(13017,0,1,'O callback \'%i\' no  vlido!',1094,'INVALID_CALLBACK',2,'INVALID_CALLBACK_MSG'),(13018,0,1,'Cliente',1095,'ClientGroupsClientName',2,'SCREEN_CONFIG_CLIENTGROUPS'),(13019,0,1,'Factura ao Grupo',1096,'ClientGroupsInvoices',2,'SCREEN_CONFIG_CLIENTGROUPS'),(13020,0,1,'Aviso|A caixa associada a este terminal ainda no foi aberta.',1098,'CashDrawerWarning',2,'CASH_DRAWER_MSG'),(13021,0,1,'Aviso|J existe um cliente com este NIF - %s',1099,'CustomerNIFWarning',2,'CUSTOMER_MSGBOX_STRING'),(13022,0,1,'Activa perfis automaticamente',1102,'ProfileChange',2,'SCREEN_TERMINAL_CONFIG'),(13023,0,1,'Configurao Menus',1104,'ItemMenuConfigWindow',2,'SCREEN_ITEM_MENU_CONFIG'),(13024,0,1,'Famla',1105,'ItemMenuConfigFamilyFilter',2,'SCREEN_ITEM_MENU_CONFIG'),(13025,0,1,'Procurar',1106,'ItemMenuConfigSearch',2,'SCREEN_ITEM_MENU_CONFIG'),(13026,0,1,'Preo',1107,'ItemMenuConfigItemPrice',2,'SCREEN_ITEM_MENU_CONFIG'),(13027,0,1,'Limpar Nvel',1108,'ItemMenuConfigCleanMenu',2,'SCREEN_ITEM_MENU_CONFIG'),(13028,0,1,'Descrio',1109,'ItemMenuConfigItemDescription',2,'SCREEN_ITEM_MENU_CONFIG'),(13029,0,1,'Menus',1110,'ItemMenuSelectionWindow',2,'SCREEN_ITEM_MENU_SELECTION'),(13030,0,1,'Prximo >',1111,'ItemMenuSelectionNext',2,'SCREEN_ITEM_MENU_SELECTION'),(13031,0,1,' ',1112,'ItemMenuSelectionDescription',2,'SCREEN_ITEM_MENU_SELECTION'),(13032,0,1,'Finalizar',1113,'ItemMenuSelectionFinalize',2,'SCREEN_ITEM_MENU_SELECTION'),(13033,0,1,'< Anterior',1114,'ItemMenuSelectionPrevious',2,'SCREEN_ITEM_MENU_SELECTION'),(13035,0,1,'Identifique o cliente',1116,'PromptCustomerWindow',2,'SCREEN_PROMPT_CUSTOMER'),(13037,0,1,'- NOTUSED - ',1118,'CustomerNIF',2,'SCREEN_PROMPT_CUSTOMER'),(13038,0,1,'Histrico',1119,'LastDetails',2,'SCREEN_PROMPT_CUSTOMER'),(13041,0,1,'Perfis de Posto',1100,'ProfilesOpenRadioTerminals',2,'SCREEN_PROFILES_SELECTION'),(13042,0,1,'Telefone',1121,'FilterTextBox',2,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(13043,0,1,'Morada',1122,'Detail2',2,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(13044,0,1,'Nome',1123,'Detail1',2,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(13045,0,1,' ',1124,'RecordDate1',2,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(13046,0,1,' ',1125,'RecordDate2',2,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(13047,0,1,' ',1126,'RecordDate3',2,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(13048,0,1,'Copia carto',1127,'CopyDetails1',2,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(13049,0,1,'Copia carto',1128,'CopyDetails2',2,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(13050,0,1,'Copia carto',1129,'CopyDetails3',2,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(13051,0,1,'Seleccione cliente para delivery',1130,'IPromptDeliveryCustomerWindow',2,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(13052,0,1,'Cod. Postal',1131,'Detail3',2,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(13053,0,1,'Localidade',1132,'Detail4',2,'SCREEN_PROMPT_DELIVERY_CUSTOMER'),(13054,0,1,'Morada 1',1133,'NewClientAddress1',2,'SCREEN_NEW_CLIENT'),(13055,0,1,'Morada 2',1134,'NewClientAddress2',2,'SCREEN_NEW_CLIENT'),(13056,0,1,'Cod. Postal',1135,'NewClientPostalCode',2,'SCREEN_NEW_CLIENT'),(13058,0,1,'Ecr por defeito',1139,'SalesmanDefaulScreen',2,'SCREEN_CONFIG_SALESMEN'),(13059,0,1,'Identifique o carto',1140,'lblActivationText',2,'SCREEN_CARD_ACTIVATION'),(13060,0,1,'Cdigo do carto',1141,'InputTableCode',2,'SCREEN_CARD_ACTIVATION'),(13061,0,1,'Activao de cartes',1142,'ScreenActivateCard',2,'SCREEN_CARD_ACTIVATION'),(13062,0,1,'Porta',1143,'ScreenCardExit',2,'SCREEN_CARD_EXIT'),(13065,0,1,'Escolha um carto',1155,'TableKeyboard',2,'SCREEN_TABLE_KEYBOARD'),(13066,0,1,'1',1156,'1',2,'SCREEN_TABLE_KEYBOARD'),(13067,0,1,'2',1157,'2',2,'SCREEN_TABLE_KEYBOARD'),(13068,0,1,'3',1158,'3',2,'SCREEN_TABLE_KEYBOARD'),(13069,0,1,'4',1159,'4',2,'SCREEN_TABLE_KEYBOARD'),(13070,0,1,'5',1160,'5',2,'SCREEN_TABLE_KEYBOARD'),(13071,0,1,'6',1161,'6',2,'SCREEN_TABLE_KEYBOARD'),(13072,0,1,'7',1162,'7',2,'SCREEN_TABLE_KEYBOARD'),(13073,0,1,'8',1163,'8',2,'SCREEN_TABLE_KEYBOARD'),(13074,0,1,'9',1164,'9',2,'SCREEN_TABLE_KEYBOARD'),(13075,0,1,'0',1165,'0',2,'SCREEN_TABLE_KEYBOARD'),(13076,0,1,'C',1166,'C',2,'SCREEN_TABLE_KEYBOARD'),(13077,0,1,'Carto',1167,'TableCode',2,'SCREEN_TABLE_KEYBOARD'),(13078,0,1,'OK',1168,'OK',2,'SCREEN_TABLE_KEYBOARD'),(13079,0,1,'Seleco de cartes',1169,'SCREEN_NAME',2,'SCREEN_NAME'),(13080,0,1,'Cartes/Porta entrada',1170,'SCREEN_NAME',2,'SCREEN_NAME'),(13081,0,1,'Cartes/Porta sada',1171,'SCREEN_NAME',2,'SCREEN_NAME'),(13082,0,1,'Teclado sel. cartes',1172,'SCREEN_NAME',2,'SCREEN_NAME'),(13083,0,1,'Usar mapa de cartes',399,'ZoneUseZoneMap',2,'SCREEN_CONFIG_ZONES'),(13084,0,1,'C/IVA includo',401,'ZonePricesTaxesIncluded',2,'SCREEN_CONFIG_ZONES'),(13085,0,1,'Identifica Cliente antes da venda',402,'ZoneAskCustomerNumber',2,'SCREEN_CONFIG_ZONES'),(13086,0,1,'Consumo Prprio',403,'ZoneSelfConsuption',2,'SCREEN_CONFIG_ZONES'),(13087,0,1,'Identifica mesa para pedidos (uso com cartes)',407,'ZoneAskCustomerBeforeSale',2,'SCREEN_CONFIG_ZONES'),(13088,0,1,'Modo Delivery',1137,'ZoneIsDelivery',2,'SCREEN_CONFIG_ZONES'),(13089,0,1,'Disco/Verifica estado dos cartes',1138,'ZoneIsCardCheck',2,'SCREEN_CONFIG_ZONES'),(13090,0,1,'Executar plugin',1173,'Run',2,'SCREEN_PLUGINS'),(13091,0,1,'Descrio',1174,'Description',2,'SCREEN_PLUGINS'),(13092,0,1,'1',1175,'Var1',2,'SCREEN_PLUGINS'),(13093,0,1,'2',1176,'Var2',2,'SCREEN_PLUGINS'),(13094,0,1,'3',1177,'Var3',2,'SCREEN_PLUGINS'),(13095,0,1,'4',1178,'Var4',2,'SCREEN_PLUGINS'),(13096,0,1,'5',1179,'Var5',2,'SCREEN_PLUGINS'),(13097,0,1,'6',1180,'Var6',2,'SCREEN_PLUGINS'),(13098,0,1,'7',1181,'Var7',2,'SCREEN_PLUGINS'),(13099,0,1,'8',1182,'Var8',2,'SCREEN_PLUGINS'),(13100,0,1,'9',1183,'Var9',2,'SCREEN_PLUGINS'),(13101,0,1,'10',1184,'Var10',2,'SCREEN_PLUGINS'),(13102,0,1,'Plugins',1185,'PluginsWindow',2,'SCREEN_PLUGINS'),(13104,0,1,'Consultas Caixa',1022,'MovementsPrintWindow',2,'SCREEN_MOVEMENTS_PRINT'),(13105,0,1,'Caixa-bolsa aberta|%s tem uma caixa-bolsa aberta!\n\nPara poder efectuar o fecho da sesso tem que fechar a caixa-bolsa - %s - primeiro',1152,'MSG_BOX_MESSAGE',2,'MSG_BOX_MESSAGE'),(13106,0,1,'Aviso|Por favor seleccione um empregado para iniciar sesso.',1153,'MSG_BOX_MESSAGE',2,'MSG_BOX_MESSAGE'),(13107,0,1,'Aviso|Ainda tem cartes abertas!\n\nPor favor feche ou transfira os seus cartes para fechar a sua sesso',1154,'MSG_BOX_MESSAGE',2,'MSG_BOX_MESSAGE'),(13108,0,1,'Aviso|Por favor seleccione um empregado para fechar sesso.',1149,'MSG_BOX_MESSAGE',2,'MSG_BOX_MESSAGE'),(13109,0,1,'Sem caixa-bolsa',1148,'GENERIC_TEXT',2,'GENERIC_TEXT'),(13110,0,1,'Cdigo',1186,'User',2,'SCREEN_CONFIG_LICENCE'),(13111,0,1,'Senha',1187,'Password',2,'SCREEN_CONFIG_LICENCE'),(13112,0,1,'Registar nova licena',1188,'Register',2,'SCREEN_CONFIG_LICENCE'),(13113,0,1,'Actualizar licena',1189,'LicencesUpgrade',2,'SCREEN_CONFIG_LICENCE'),(13114,0,1,'Fecha a zero',1144,'CloseAsZero',2,'SCREEN_CONFIG_OPEN_TABLES'),(13115,0,1,'Lista negra',1145,'SetBlackList',2,'SCREEN_CONFIG_OPEN_TABLES'),(13116,0,1,'Mostra cartes na lista negra',1146,'ShowTablesInBlackList',2,'SCREEN_CONFIG_OPEN_TABLES'),(13117,0,1,'Sage IVA',1190,'SageIVA',2,'SCREEN_CONFIG_TAXES'),(13118,0,1,'208 Sesses - Cartes abertas',1066,'PERM_SESSIONS_OPEN_TABLES',2,'SALESMAN_LEVEL_PERMISSIONS'),(13119,0,1,'211 Sesses - Consulta de caixa',1069,'PERM_SESSIONS_CASHDRAWER_MOVEMENTS',2,'SALESMAN_LEVEL_PERMISSIONS'),(13120,0,1,'Manter preos',1215,'DoNoChanges',2,'SCREEN_SAGE_IVA'),(13122,0,1,'Sage IVA',1213,'SageIVAWindow',2,'SCREEN_SAGE_IVA'),(13123,0,1,'TaxChangeUpdatePrices',1212,'TaxChangeUpdatePrices',2,'SCREEN_SAGE_IVA'),(13125,0,1,'Arredonda PVP',1210,'TaxChangeRound',2,'SCREEN_SAGE_IVA'),(13126,0,1,'Data de mudanas do IVA',1209,'TaxChangeDate',2,'SCREEN_SAGE_IVA'),(13127,0,1,'PVP actualizado',1208,'NextItemPrice',2,'SCREEN_SAGE_IVA'),(13128,0,1,'PVP5',1207,'NextItemPrice5',2,'SCREEN_SAGE_IVA'),(13129,0,1,'PVP4',1206,'NextItemPrice4',2,'SCREEN_SAGE_IVA'),(13130,0,1,'PVP3',1205,'NextItemPrice3',2,'SCREEN_SAGE_IVA'),(13131,0,1,'PVP2',1204,'NextItemPrice2',2,'SCREEN_SAGE_IVA'),(13132,0,1,'PVP1',1203,'NextItemPrice1',2,'SCREEN_SAGE_IVA'),(13133,0,1,'PVP actual',1202,'CurrentItemPrice',2,'SCREEN_SAGE_IVA'),(13134,0,1,'PVP5',1201,'CurrentItemPrice5',2,'SCREEN_SAGE_IVA'),(13135,0,1,'PVP4',1200,'CurrentItemPrice4',2,'SCREEN_SAGE_IVA'),(13136,0,1,'PVP3',1199,'CurrentItemPrice3',2,'SCREEN_SAGE_IVA'),(13137,0,1,'PVP2',1198,'CurrentItemPrice2',2,'SCREEN_SAGE_IVA'),(13138,0,1,'PVP1',1197,'CurrentItemPrice1',2,'SCREEN_SAGE_IVA'),(13139,0,1,'Diferena',1196,'DiffItemPrice',2,'SCREEN_SAGE_IVA'),(13140,0,1,'PVP4',1195,'DiffItemPrice4',2,'SCREEN_SAGE_IVA'),(13141,0,1,'PVP3',1194,'DiffItemPrice3',2,'SCREEN_SAGE_IVA'),(13142,0,1,'PVP2',1193,'DiffItemPrice2',2,'SCREEN_SAGE_IVA'),(13143,0,1,'PVP1',1192,'DiffItemPrice1',2,'SCREEN_SAGE_IVA'),(13144,0,1,'PVP5',1191,'DiffItemPrice5',2,'SCREEN_SAGE_IVA'),(13145,0,1,'Sries de documentos',1216,'DocumentCountersWindow',2,'SCREEN_CONFIG_COUNTERS'),(13146,0,1,'Criar nova srie',1217,'NewDocumentSeries',2,'SCREEN_CONFIG_COUNTERS'),(13147,0,1,'Srie',1218,'DataChar',2,'SCREEN_CONFIG_COUNTERS'),(13148,0,1,'Contador',1219,'Counter',2,'SCREEN_CONFIG_COUNTERS'),(13149,0,1,'Numerao Doc.',1221,'COnfigButton',2,'ConfigBUtton'),(13150,0,1,'Imprime secundrios',1222,'PrintSecondary',2,'SCREEN_CONFIG_PRINTERS'),(13152,0,1,'Valor por fechar',1226,'TablesTotal',2,'SCREEN_CONFIG_OPEN_TABLES'),(13153,0,1,'Cartes abertos',1225,'TablesCount',2,'SCREEN_CONFIG_OPEN_TABLES'),(13154,0,1,'Procurar',1224,'TableFilter',2,'SCREEN_CONFIG_OPEN_TABLES'),(13155,0,1,'Link',1227,'Link',2,'SCREEN_CONFIG_ITEMS'),(13156,0,1,'Seleccione artigo',1228,'LinkItemSelectionWindow',2,'SCREEN_LINK_ITEM_SELECTION'),(13157,0,1,'Mostrar sries inactivas',1233,'ShowInactive',2,'SCREEN_CONFIG_COUNTERS'),(13158,0,1,'Terminal',1231,'SalesTermianl',2,'SCREEN_CONFIG_COUNTERS'),(13159,0,1,'Tipo de documento',1230,'DocType',2,'SCREEN_CONFIG_COUNTERS'),(13160,0,1,'Srie activa',1229,'Active',2,'SCREEN_CONFIG_COUNTERS'),(13161,0,1,'',1240,'SeriesLabel',2,'SCREEN_CONFIG_TERMINALS'),(13162,0,1,'Visualizar',1241,'PreviewSessionBtnPrint',2,'SCREEN_SESSION_PRINT'),(13163,0,1,'Data',1242,'SessionDate',2,'SCREEN_SESSION_PRINT'),(13164,0,1,'Empregado',1243,'SessionSalesman',2,'SCREEN_SESSION_PRINT'),(13165,0,1,'',1244,'SessionReportPreview',2,'SCREEN_SESSION_PRINT'),(13166,0,1,'Consulta Sesses',567,'PrintSessionWindow',2,'SCREEN_SESSION_PRINT'),(13167,0,1,'X64 - Envia msg com total do cartao',1232,'ST_X64_SEND_TABLE_TOTAL_MSG',2,'ST_X64_SEND_TABLE_TOTAL_MSG'),(13168,0,1,'Assistente de licenciamento',1245,'ScreenLicenseWizard',2,'SCREEN_LICENSING_WIZARD'),(13171,0,1,'Cancelar',1248,'Abort',2,'SCREEN_LICENSING_WIZARD'),(13172,0,1,'Licena',1249,'File',2,'SCREEN_LICENSING_WIZARD'),(13173,0,1,'Pronto',1250,'Done',2,'SCREEN_LICENSING_WIZARD'),(13174,0,1,'',1251,'SuccessLabel',2,'SCREEN_LICENSING_WIZARD'),(13175,0,1,'Registar',1252,'RegisterLicense',2,'SCREEN_LICENSING_WIZARD'),(13176,0,1,'Continuar',1253,'GotoDemos',2,'SCREEN_LICENSING_WIZARD'),(13177,0,1,'Chave do cliente',1254,'ClientKey',2,'SCREEN_LICENSING_WIZARD'),(13178,0,1,'Chave de activao',1255,'ActivationKey',2,'SCREEN_LICENSING_WIZARD'),(13179,0,1,'Insira a chave de activao para completar o processo',1256,'LicensingWizardLabel',2,'SCREEN_LICENSING_WIZARD'),(13183,0,1,'Seleccione a licena que pretende activar',1260,'LicensingWizardLabel',2,'SCREEN_LICENSING_WIZARD'),(13185,0,1,'Insira o nome do ficheiro da licena',1262,'LicensingWizardLabel',2,'SCREEN_LICENSING_WIZARD'),(13187,0,1,'Importao de documento manuais',1264,'PromptManualDocumentWindow',2,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(13188,0,1,'Srie',1265,'SeriesChar',2,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(13189,0,1,'Nmero',1266,'SeriesNumber',2,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(13190,0,1,'Sub-totais (contas)',1234,'CounterSubTotal',2,'SCREEN_CONFIG_TERMINALS'),(13191,0,1,'Factura/Recibo',1235,'CounterFacRecibo',2,'SCREEN_CONFIG_TERMINALS'),(13192,0,1,'Conta Corrente',1236,'CounterInvoice',2,'SCREEN_CONFIG_TERMINALS'),(13193,0,1,'Recibos',1237,'CounterRecibo',2,'SCREEN_CONFIG_TERMINALS'),(13194,0,1,'Pedidos',1238,'CounterPedidos',2,'SCREEN_CONFIG_TERMINALS'),(13195,0,1,'Fac. Externa',1239,'CounterGuia',2,'SCREEN_CONFIG_TERMINALS'),(13196,0,1,'Documentos manuais',1267,'ManualDocsString',2,'ManualDocsString'),(13198,0,1,'Actualizao da base de dados',1269,'MSG_BOX_TITLE',2,'MSG_BOX_TITLE'),(13199,0,1,'Por favor contacte o seu parceiro Sage ou a linha de suporte Sage atravs do nmero de telefone 707 200 482',1270,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13200,0,1,'No foi possvel actualizar a base de dados do posto para a verso ',1271,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13201,0,1,'Criao da base de dados',1272,'MSG_BOX_TITLE',2,'MSG_BOX_TITLE'),(13202,0,1,'A criao da base de dados da aplicao falhou (o script de criao da base de dados existe?)\\nA aplicacao nao pode continuar e vai terminar!',1273,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13203,0,1,'Falha de ligao  base de dados',1274,'MSG_BOX_TITLE',2,'MSG_BOX_TITLE'),(13204,0,1,'No foi possvel efectuar a ligao  base de dados!\\nA aplicao no pode continuar e vai terminar!',1275,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13205,0,1,'Terminais rdio',1276,'MSG_BOX_TITLE',2,'MSG_BOX_TITLE'),(13206,0,1,'No foi possvel inicializar a porta srie da antena!\\n\\nNo vai ser possvel usar os comandos rdio',1277,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13207,0,1,'Falhou arranque da antena!\\nNo vai ser possvel usar os comandos rdio',1278,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13208,0,1,'Sries de documentos',1279,'MSG_BOX_TITLE',2,'MSG_BOX_TITLE'),(13209,0,1,'Tem que existir uma srie activa para cada tipo de documento!\\n\\nPor favor aceda a Config->Geral->Numerao Doc. e adicione as sries em falta para poder efecutar registos correctamente!',1280,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13210,0,1,'Existem sries de documentos com caracteres de dados repetidos!\\n\\nPor favor aceda a Config->Geral->Numerao Doc. e corrija as sries em erro para poder efecutar registos correctamente!',1281,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13211,0,1,'Existem mltiplas sries de documentos  em uso!\\n\\nPor favor aceda a Config->Geral->Numerao Doc. e corrija as sries em erro para poder efecutar registos correctamente!',1282,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13212,0,1,'Aviso',1283,'MSG_BOX_TITLE',2,'MSG_BOX_TITLE'),(13213,0,1,'Erro na ligao  base de dados! [Erro: %d]',1284,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13214,0,1,'No tem permisso para entrar neste carto',1285,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13215,0,1,'No consegui fazer lock ao carto!',1286,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13216,0,1,'Este carto j est aberta noutro posto!',1287,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13217,0,1,'Carto invlida!',1288,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13218,0,1,'No foi possvel obter os detalhes do carto',1289,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13219,0,1,'Operao no permitida!',1290,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13220,0,1,'No foi possivel adicionar artigo ao carto',1291,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13221,0,1,'No foi possvel fechar carto',1292,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13222,0,1,'No consegui obter carto!',1293,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13223,0,1,'Cartes de destino e origem so as mesmas',1294,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13224,0,1,'O carto est fora do seu intervalo de cartes',1295,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13225,0,1,'Este carto est na lista negra e no pode ser usado!',1296,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13226,0,1,'Este carto est inactivo!',1297,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13227,0,1,'ESTE CARTO NO EST PAGO!',1298,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13228,0,1,'Este carto j est pago e no podem ser adicionados artigos at o carto ser desactivado!',1299,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13229,0,1,'O empregado actual no tem sesso aberta!',1300,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13230,0,1,'Ocorreu um erro inesperado! n: %d',1301,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13231,0,1,'Aviso',1302,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13232,0,1,'No foi possvel gravar carto [Erro: %d]\\nQuer tentar outra vez?',1303,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13233,0,1,'No  possvel imprimir pedidos correctamente. %s\\n\\nAceda a Config->Geral->Numerao Doc. e crie uma srie para este tipo de documento',1304,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13234,0,1,'No  possvel imprimir o subotal. %s\\n\\nAceda a Config->Geral->Numerao Doc. e crie uma srie para este tipo de documento',1305,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13235,0,1,'O preo deste artigo no pode ser alterado. Tem quantidade maior que um.',1306,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13236,0,1,'O preo deste artigo no pode ser alterado. Possui descontos associados.',1307,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13237,0,1,'O preo de artigos com extras no pode ser alterado',1308,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13238,0,1,'Por favor indique o novo preco do artigo',1309,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13240,0,1,'Quer limpar descontos aplicados?',1311,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13241,0,1,'Acumular cartes',1312,'MSG_BOX_TITLE',2,'MSG_BOX_TITLE'),(13242,0,1,'Este carto j est acumulado!\\nPretende remov-lo dos cartes acumuladas?',1313,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13243,0,1,'Tem certeza que quer Acumular?',1314,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13244,0,1,'Pretende remover todos os cartes acumulados?',1315,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13245,0,1,'No  possvel efectuar a operao. [Err: %d - %s]\\n\\nAceda a Config->Geral->Numerao Doc. e crie uma srie para este tipo de documento',1316,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13247,0,1,'No pode usar este mtodo de pagamento neste carto!',1318,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13248,0,1,'No existe um cliente com os dados introduzidos. Deseja criar um novo cliente?',1319,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13249,0,1,'No pode efectuar esta operao neste carto.',1320,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13250,0,1,'O valor desta venda vai ultrapassar o limite de crdito do cliente!\\n\\nEsta venda no pode ser fechada para Conta Corrente',1321,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13251,0,1,'Por favor identifique um cliente',1322,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13252,0,1,'Como seleccionou mtodo de pagamento \'Conta Corrente\', no pode ter outras formas de pagamento.',1323,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13253,0,1,'Como seleccionou mtodo de pagamento \'Facturao Externa\', no pode ter outras formas de pagamento.',1324,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13254,0,1,'Quando utilizados os mtodos de pagamento \'Conta Corrente\' e \'Ext\' no pode haver troco.',1325,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13255,0,1,'O fecho dos cartes acumulados falhou [Erro: %d]\\nOs cartes que seleccionou j no esto acumulados',1326,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13256,0,1,'O fecho da venda falhou [Erro: %d - %s]\\nQuer tentar outra vez?\\n\\nPressione - No -  para abortar a operao.',1327,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13257,0,1,'Erro na ligacao SQL. Execute novamente a operacao',1328,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13258,0,1,'Nao consegui fazer lock ao cartao!',1329,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13259,0,1,'O carto esta ocupada noutro posto!',1330,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13260,0,1,'Nao tem permissao para efectuar operacao',1331,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13261,0,1,'Nao foi possivel obter os detalhes do cartao',1332,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13262,0,1,'Operacao nao permitida!',1333,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13263,0,1,'Carto vazio',1334,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13264,0,1,'Nao foi possivel adicionar artigo ao carto',1335,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13265,0,1,'Nao foi possivel fechar o carto',1336,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13266,0,1,'Nao consegui obter o cartao!',1337,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13267,0,1,'Cartoes de destino e origem sao os mesmos',1338,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13268,0,1,'Operacao com um artigo invalido',1339,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13269,0,1,'Empregado invalido!',1340,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13270,0,1,'Cartao fora do seu intervalo de cartoes!',1341,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13271,0,1,'Cartao nao existe',1342,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13272,0,1,'Este terminal nao possui nenhuma caixa associada',1343,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13273,0,1,'Nao foi possivel imprimir!',1344,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13274,0,1,'Ocorreu um erro inesperado',1345,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13275,0,1,'Comandos rdio',1346,'MSG_BOX_TITLE',2,'MSG_BOX_TITLE'),(13276,0,1,'Tem todos os comandos rdio em modo de download?',1347,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13277,0,1,'Por favor coloque todos os comandos rdio em modo de download e tente outra vez',1348,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13278,0,1,'Verificao de estado do carto',1349,'MSG_BOX_TITLE',2,'MSG_BOX_TITLE'),(13279,0,1,'O carto %d no est em nenhuma srie!',1350,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13280,0,1,'O CARTO %d NO EST PAGO!\\n\\nPor favor dirija-se a um caixa!',1351,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13281,0,1,'O carto %d j se encontra activo!',1352,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13282,0,1,'Carto %d activado!',1353,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13283,0,1,'O carto %d no est activo.\\n\\nPretende activa-lo?',1354,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13284,0,1,'CARTO %d PAGO',1355,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13285,0,1,'ESTE CARTO NO EST PAGO!\\n\\nPor favor dirija-se a um caixa!',1356,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13286,0,1,'Este carto j se encontra activo!',1357,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13287,0,1,'No foi possvel activar carto [Erro: %d]\\nQuer tentar outra vez?',1358,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13288,0,1,'No tem criado a srie de documentos do tipo %s.\\n\\nPor favor aceda a Config->Geral->Numerao Doc. e esta srie para poder efecutar registos correctamente!',1359,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13289,0,1,'operacao nao permitida!!',1360,'RADIO_TERMINAL_MSG',2,'RADIO_TERMINAL_MSG'),(13290,0,1,'Leitura de carto',1361,'MSG_BOX_TITLE',2,'MSG_BOX_TITLE'),(13291,0,1,'No foi possvel identificar o cliente!\\n\\nPor favor tente novamente ou identifique o cliente usando o interface disponvel.',1362,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13292,0,1,'No tem permisso para entrar neste carto',1363,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13293,0,1,'No consegui fazer lock ao carto!',1364,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13294,0,1,'Este carto j est aberto noutro posto!',1365,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13295,0,1,'Carto invlido!',1366,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13296,0,1,'No foi possvel obter os detalhes do carto',1367,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13297,0,1,'Operao no permitida!',1368,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13298,0,1,'Carto vazia',1369,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13299,0,1,'No foi possivel adicionar artigo a carto',1370,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13300,0,1,'No foi possvel fechar carto',1371,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13301,0,1,'No consegui obter carto!',1372,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13302,0,1,'Cartes de destino e origem so os mesmos',1373,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13303,0,1,'Operao com um artigo invlido',1374,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13304,0,1,'O carto est fora do seu intervalo de cartes',1375,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13305,0,1,'Este carto est na lista negra e no pode ser usado!',1376,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13306,0,1,'Este carto est inactivo!',1377,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13307,0,1,'ESTE CARTO NO EST PAGO!',1378,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13308,0,1,'Este carto j est pago e no podem ser adicionados artigos at o carto ser desactivado!',1379,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13309,0,1,'O empregado actual no tem sesso aberta!',1380,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13310,0,1,'Ocorreu um erro inesperado',1381,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13311,0,1,'Clique no boto + para identificar o cliente para entrega',1382,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13312,0,1,'Delivery',1383,'MSG_BOX_TITLE',2,'MSG_BOX_TITLE'),(13313,0,1,'Insira o carto de destino dos pedidos',1384,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13314,0,1,'No  possvel alterar o preo deste artigo!',1385,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13315,0,1,'Est abaixo do limite de stock de aviso para este artigo\\n\\nPode no conseguir pedir todos os artigos  cozinha!',1386,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13316,0,1,'Total',1387,'CUSTOMER_DISPLAY_MESSAGE',2,'CUSTOMER_DISPLAY_MESSAGE'),(13317,0,1,'J existem artigos no carto com descontos!\n\nQuer aplicar os dois descontos (SIM)?\nOu usar apenas o desconto do clientes(NO)?',1388,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13318,0,1,'Quer aplicar o desconto do cliente aos artigos restantes?',1389,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13319,0,1,'%Desc. cabealho',1390,'HeaderPercDiscount',2,'SCREEN_TABLE_CLOSE'),(13320,0,1,'Desc. linha',1391,'SumLineDiscount',2,'SCREEN_TABLE_CLOSE'),(13321,0,1,'Fact. Conv. pontos',1393,'SystemConfigPointsConversionFactor',2,'SCREEN_CONFIG_SYSTEM'),(13322,0,1,'Pontos',1394,'PaymentTypePoints',2,'SCREEN_CONFIG_PAYMENT_TYPES'),(13323,0,1,'O cliente Consumidor final no pode pagar com mtodo de pagamento do tipo Pontos',1395,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13324,0,1,'O cliente seleccionado tem %d pontos disponveis para usar nesta venda\n\nQuer usar os pontos nesta venda?',1396,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13325,0,1,'Acumulou %d pontos nesta venda para usar na sua prxima visita\n\nTem agora %d pontos disponveis para usar!',1397,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13326,0,1,'Acumulou %d pontos nesta venda',1398,'PRINT_TAG_TEXT',2,'POINTS_PRINT_TEXT'),(13327,0,1,'Tem agora %d pontos para usar!',1399,'PRINT_TAG_TEXT',2,'POINTS_PRINT_TEXT'),(13328,0,1,'Cliente acumula pontos na venda',1400,'UsePoints',2,'SCREEN_CONFIG_SYSTEM'),(13329,0,1,'Pontos dos artigos em vez do valor da venda',1401,'ConfigPropertyUseItemPoints',2,'GENERAL_CONFIG'),(13330,0,1,'Cartes de papel',1402,'ConfigPropertyText',2,'GENERAL_CONFIG'),(13331,0,1,'Fecha mesas/cartoes extraviados a zero',1403,'ConfigPropertyText',2,'GENERAL_CONFIG'),(13332,0,1,'Imprime sempre o nome do artigo principal',1404,'ConfigPropertyText',2,'GENERAL_CONFIG'),(13333,0,1,'Verifica validade do NIF (novos clientes)',1405,'ConfigPropertyText',2,'GENERAL_CONFIG'),(13334,0,1,'Tem que certeza que quer atribuir este valor de pontos ao cliente?',1406,'MSG_BOX_TEXT',2,'CUSTOMER_CONFIG_SCREEN'),(13336,0,1,'Saldo conta corrente',1407,'AccountBalance',2,'SCREEN_CONFIG_SALESMEN'),(13337,0,1,'Tem certeza que quer alterar o saldo da conta corrente?',1408,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_SALESMEN'),(13338,0,1,'Comisso(%)',1409,'ComissionPercent',2,'SCREEN_CONFIG_SALESMEN'),(13339,0,1,'Para um correcto funcionamento da aplicao certifique-se que o driver que est a usar  Generic Text e no o driver do fabricante da impressora!',1410,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DEVICES'),(13340,0,1,'Limpa caractres acentuados',1411,'DeviceManagerCleanChars',2,'SCREEN_CONFIG_DEVICES'),(13341,0,1,'Qt mxima de artigos',1412,'SalesmanSelfExpLimitqT',2,'SCREEN_CONFIG_SALESMEN'),(13342,0,1,'No pode efectuar esta operao nos cartes das srie de consumo prprio.\\n\\nO carto ser fechado quando fechar a sua sesso.',1413,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13343,0,1,'No pode adicionar mais artigos!\\n\\nJ atingiu o limite de valor do seu consumo prprio',1414,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13344,0,1,'No pode adicionar mais artigos!\\n\\nJ atingiu o limite de artigos do seu consumo prprio',1415,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13345,0,1,'No pode efectuar esta operao nos cartes das srie de consumo prprio.',1416,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13346,0,1,'No pode transferir artigos para cartes em sries de consumo prprio.\\n\\nPor favor escolha um carto de outra srie.',1417,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13347,0,1,'Este documento tem um recibo associado e no pode ser anulado',1418,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_ITEMS'),(13348,0,1,'Foi encontrado um problema ao anular o documento.',1419,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_ITEMS'),(13349,0,1,'Seleccione um documento.',1420,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_ITEMS'),(13350,0,1,'Este carto no est na lista',1421,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_OPEN_TABLES'),(13351,0,1,'Tem certeza que quer retirar o carto %s da lista negra?',1422,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_OPEN_TABLES'),(13352,0,1,'Tem certeza que quer colocar o carto %s na lista negra?',1423,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_OPEN_TABLES'),(13353,0,1,'Tem certeza que quer fechar %s?',1424,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_OPEN_TABLES'),(13354,0,1,'Tem certeza que quer fechar todas os cartes da lista?',1425,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_OPEN_TABLES'),(13355,0,1,'No possui permisses para aceder a cartes de outros empregados.',1426,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_OPEN_TABLES'),(13356,0,1,'O empregado de destino no tem acesso  carto que lhe pretende transferir!',1427,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_OPEN_TABLES'),(13357,0,1,'%s j tem este cdigo!\\n\\nUm novo cdigo vai ser sugerido!',1428,'MSG_BOX_TEXT',2,'GENERIC'),(13358,0,1,'No foi possvel inicializar a porta srie da antena!\\n\\nDeseja continuar mesmo assim?',1429,'MSG_BOX_TEXT',2,'RADIO_TERMINALS_MSG'),(13359,0,1,'Falhou arranque da antena!\\nNo vai ser possvel usar os comandos rdio!\\n\\n\\Deseja continuar mesmo assim?',1430,'MSG_BOX_TEXT',2,'RADIO_TERMINALS_MSG'),(13360,0,1,'Perfis de posto',1103,'ProfilesOpenWorkstation',2,'SCREEN_PROFILES_SELECTION'),(13361,0,1,'No discrim.',1438,'DailyJournalBtnPrintNdesc',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13362,0,1,'S as vendas a dinheiro  que podem ser no discriminadas',1439,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13363,0,1,'Nmero de pessoas',1440,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13365,0,1,'Este carto est em uso pela aplicao',1441,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13366,0,1,'O NIF %s introduzido no  vlido!\n\nPor favor introduza um NIF vlido...',1442,'MSG_BOX_TEXT',2,'NEW_CUSTOMER'),(13367,0,1,'NIF invlido',1443,'MSG_BOX_TITLE',2,'NEW_CUSTOMER'),(13368,0,1,'Nome invlido',1444,'MSG_BOX_TITLE',2,'NAME_VALIDATION'),(13369,0,1,'O nome introduzido no  vlido!\n\nPor favor introduza um nome vlido...',1445,'MSG_BOX_TEXT',2,'NAME_VALIDATION'),(13370,0,1,'O cliente %s j tem esse NIF atribuido',1446,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_CUSTOMERS'),(13371,0,1,'No pode mudar os detalhes do cliente Consumidor final!',1447,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_CUSTOMERS'),(13372,0,1,'O cliente %s j tem este cdigo!\n\nUm novo cdigo vai ser sugerido',1448,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_CUSTOMERS'),(13373,0,1,'Pginas Rpidas',1449,'QuikPagesWindow',2,'SCREEN_CONFIG_QUICK_PAGES'),(13374,0,1,'Descrio',1450,'QuickPageDescription',2,'SCREEN_CONFIG_QUICK_PAGES'),(13375,0,1,'Famlias',1451,'QuikPageFamily',2,'SCREEN_CONFIG_QUICK_PAGES'),(13376,0,1,'Limpar',1452,'QuickPageClean',2,'SCREEN_CONFIG_QUICK_PAGES'),(13377,0,1,'Descrio curta',1453,'QuickPageShortDescription',2,'SCREEN_CONFIG_QUICK_PAGES'),(13379,0,1,'Tem certeza que quer eliminar esta pgina rpida?',1455,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_QUICK_PAGES'),(13380,0,1,'Peso|',853,'MsgBoxAskWeight',2,'SCREEN_TABLE_EDIT'),(13381,0,1,'305 Config - Edio Famlias/Pg. Rpidas',623,'PERM_CONFIG_EDIT_FAMILIES',2,'SALESMAN_LEVEL_PERMISSIONS'),(13382,0,1,'304 Config - Ver Famlias/Pg. Rpidas',622,'PERM_CONFIG_SEE_FAMILIES',2,'SALESMAN_LEVEL_PERMISSIONS'),(13383,0,1,'Cancelar artigos',1431,'TableEditMultiCancel',2,'SCREEN_TABLE_EDIT'),(13384,0,1,'Cancelar artigos',1432,'TableMultiCancel',2,'SCREEN_TABLE_CANCEL_ITEMS'),(13385,0,1,'Imprime',1433,'PrintCanceled',2,'SCREEN_TABLE_CANCEL_ITEMS'),(13386,0,1,'No possui permisses para pedir artigos!',1434,'PERM',2,'MSG_BOX_TEXT'),(13387,0,1,'No possui permisses para cancelar pedidos!',1435,'PERM',2,'MSG_BOX_TEXT'),(13388,0,1,'Refeio(es)',1436,'NDESC_TEXT',2,'PRNT_DOCUMENT'),(13389,0,1,'Desperdcio',1437,'Waste',2,'SCREEN_TABLE_CANCEL_ITEMS'),(13391,0,1,'No imprime consultas de cartes / subtotais',1456,'ST_CAN_PRINT_SUB_TOTAL',2,'ST_CAN_PRINT_SUB_TOTAL'),(13392,0,1,'No foi possvel criar um novo artigo\\n\\nOcorreu um erro inesperado',1457,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_ITEMS'),(13393,0,1,'Aviso|O nmero de certificado da aplicao foi modificado com esta actualizao pelo que deve ir a Config->Geral->Numerao Doc. e criar novas sries de documentos.',1458,'MSG_BOX_TEXT',2,'USER_PROMPT_CERTIFICATE_SERIES'),(13394,0,1,'Obs.',1459,'TableCloseObs',2,'SCREEN_TABLE_CLOSE'),(13395,0,1,'Ecrs',1460,'TerminalsScreenType',2,'SCREEN_CONFIG_TERMINALS'),(13396,0,1,'Normal (4:3)',1461,'SCREEN_TYPE',2,'SCREEN_CONFIG_TERMINALS'),(13397,0,1,'Tablet (16:9)',1462,'SCREEN_TYPE',2,'SCREEN_CONFIG_TERMINALS'),(13398,0,1,'PDA\'s (3:4)',1463,'SCREEN_TYPE',2,'SCREEN_CONFIG_TERMINALS'),(13399,0,1,'Default',1464,'SCREEN_TYPE',2,'SCREEN_CONFIG_TERMINALS'),(13400,0,1,'Obs.',1465,'DailyJournalObs',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13402,0,1,'Indique a nmero do carto.',1467,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13403,0,1,'Seleccione um documento',1468,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13404,0,1,'Este documento tem um recibo associado e no pode ser anulado.',1469,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13405,0,1,'Foi encontrado um problema ao anular o documento.',1470,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13406,0,1,'Erro ao efetuar a pesquisa. <<CDailyJournalManager::Search()>>',1471,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13407,0,1,'Pesquisa no retornou qualquer resultado.',1472,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13408,0,1,'No foi possvel carregar Tender pretendida',1473,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13409,0,1,'No foi possvel carregar a cabealho de venda pretendido',1474,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13410,0,1,'No foi possvel carregar os dados pretendidos',1475,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13411,0,1,'Erro ao gravar os artigos do carto!',1476,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13412,0,1,'Detalhes das formas de pagamento!',1477,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13413,0,1,'Sem ligao  base de dados para efectuar a operao',1478,'MSG_BOX_TEXT',2,'DATABSE'),(13414,0,1,'Erro ao carregar os artigos do carto %i',1479,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13416,0,1,'O carto ja esta aberto noutro posto!',1481,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13417,0,1,'No foi possvel bloquear o carto para uso!',1482,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13418,0,1,'Sem empregado vlido para efectuar operao',1483,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13419,0,1,'A subfamlia link no est definida. Por favor configure o artigo correctamente em Config->Tabelas->Artigos.',1484,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13421,0,1,'Este nmero de srie no  vlido!\\n\\nPor favor introduza um nmero de srie vlido.',1486,'MSG_BOX_TEXT',2,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(13422,0,1,'Identificador da srie  invlido!\\n\\nPor favor introduza uma srie vlida',1487,'MSG_BOX_TEXT',2,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(13423,0,1,'Este nmero de srie no  vlido!\\n\\nPor favor introduza um nmero de srie vlido.',1488,'MSG_BOX_TEXT',2,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(13424,0,1,'Por favor preencha ambos os campos para poder prosseguir',1489,'MSG_BOX_TEXT',2,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(13425,0,1,'Vai importar o documento %s',1490,'MSG_BOX_TEXT',2,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(13428,0,1,'Quanto utilizados os metodos de pagamento \'Conta Corrente\' e \'Ext\' nao pode haver troco.',1493,'MSG_BOX_TEXT',2,'SCREEN_TABLE_CLOSE'),(13430,0,1,'Fecho da venda falhou!\nTente outra vez por favor...',1495,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13431,0,1,'Total',1496,'TotalString',2,'TotalString'),(13432,0,1,'Tem que fazer login!',1497,'X64_MESSAGE',2,'RadioHandler'),(13433,0,1,'Impossivel pedir produtos',1498,'X64_MESSAGE',2,'RadioHandler'),(13434,0,1,'Impossivel pedir extras antes de artigo normal',1499,'X64_MESSAGE',2,'RadioHandler'),(13435,0,1,'Nao foi possivel remover artigo no carto!',1500,'X64_MESSAGE',2,'RadioHandler'),(13436,0,1,'Nao foi possivel efectuar a transferencia de artigos',1501,'X64_MESSAGE',2,'RadioHandler'),(13437,0,1,'Transferencia nao concluida',1502,'X64_MESSAGE',2,'RadioHandler'),(13438,0,1,'Transferido %i linhas',1503,'X64_MESSAGE',2,'RadioHandler'),(13439,0,1,'%s pagou %s',1504,'X64_MESSAGE',2,'RadioHandler'),(13440,0,1,'Nao foi possivel efectuar pagamento parcial!',1505,'X64_MESSAGE',2,'RadioHandler'),(13441,0,1,'Nao foi possivel abrir sessao de %s',1506,'X64_MESSAGE',2,'RadioHandler'),(13442,0,1,'Ola %s',1507,'X64_MESSAGE',2,'RadioHandler'),(13443,0,1,'Ja fez login no terminal %i',1508,'X64_MESSAGE',2,'RadioHandler'),(13444,0,1,'%s tem que fazer logout do terminal %i antes de novo login',1509,'X64_MESSAGE',2,'RadioHandler'),(13445,0,1,'%s tem que fazer logout primeiro!',1510,'X64_MESSAGE',2,'RadioHandler'),(13446,0,1,'%s nao tem sessao aberta',1511,'X64_MESSAGE',2,'RadioHandler'),(13447,0,1,'Password nao reconhecida',1512,'X64_MESSAGE',2,'RadioHandler'),(13448,0,1,'Empregado %i nao reconhecido',1513,'X64_MESSAGE',2,'RadioHandler'),(13449,0,1,'Ainda tem cartoes abertos! Nao pode fechar a sessao',1514,'X64_MESSAGE',2,'RadioHandler'),(13450,0,1,'Nao foi possivel fechar sessao de %s',1515,'X64_MESSAGE',2,'RadioHandler'),(13451,0,1,'Adeus %s',1516,'X64_MESSAGE',2,'RadioHandler'),(13452,0,1,'A query executada falhou',1517,'ErrorStr',2,'QueryFailed'),(13453,0,1,'Ocorreu um erro no definido!',1518,'ErrorStr',2,'UNDEFINED_ERROR'),(13454,0,1,'Sem erro',1519,'ErrorStr',2,'NO_ERROR'),(13455,0,1,'No  possvel desbloquear este carto',1520,'ErrorStr',2,'TABLE_CANT_UNLOCK'),(13456,0,1,'No  possvel obter contador para o tipo de documento desejado',1521,'ErrorStr',2,'SALE_CANT_GET_COUNTER'),(13457,0,1,'Erro ao carregar dados',1522,'ErrorStr',2,'LOAD_FAILED'),(13458,0,1,'Erro ao gravar os dados',1523,'ErrorStr',2,'SAVE_FAILED'),(13459,0,1,'Falta o contador para este tipo de documento',1524,'ErrorStr',2,'NO_COUNTER_TO_LOAD'),(13460,0,1,'No foi possvel gerar uma assinatura para este documento',1525,'ErrorStr',2,'SIGNATURE_FAILED'),(13461,0,1,'Erro desconhecido',1526,'ErrorStr',2,'DEFAULT_ERROR'),(13463,0,1,'Sem descrio de utilizao',1528,'use_description',2,'SCREEN_PLUGINS'),(13464,0,1,'Plugins|No foi possvel executar o plugin',1529,'MSG_BOX_TEXT',2,'SCREEN_PLUGINS'),(13465,0,1,'Plugins|O plugin no foi executado com sucesso',1530,'MSG_BOX_TEXT',2,'SCREEN_PLUGINS'),(13466,0,1,'Plugins|Plugin executado com sucesso!',1531,'MSG_BOX_TEXT',2,'SCREEN_PLUGINS'),(13468,0,1,'Plugins|O plugin no foi executado com sucesso\\n\\nPor favor indique o nome do ficheiro',1533,'MSG_BOX_TEXT',2,'SCREEN_PLUGINS'),(13470,0,1,' ',1535,'Dummy',2,'SCREEN_TABLE_EDIT'),(13472,0,1,'No foi possvel adicionar artigo\n\nS pode ter um artigo do tipo compensao no carto!',1537,'TABLE_CANT_ADD_MORE_COMPENSATION',2,'TABLE_CANT_ADD_MORE_COMPENSATION'),(13473,0,1,'Aviso|No foi possvel concluir o processo de criao da cache da aplicao devido a um erro inesperado.\\n\\nPor favor reinicie a aplicao!',1538,'CACHE_BUILD',2,'CACHE_BUILD'),(13474,0,1,'No  possvel imprimir o documento pretendido - %s',1539,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(13475,0,1,'Desc. valor',1392,'HeaderValuDiscount',2,'SCREEN_TABLE_CLOSE'),(13476,0,1,'Histrico|No foi possvel carregar os detalhes deste documento',1540,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_DAILY_JOURNAL'),(13479,0,1,'Empregado',1543,'Empregado',2,'SCREEN_SALESMAN_SELECTION'),(13480,0,1,'117 Vendas - Abrir gaveta ao fechar a venda',1544,'PERM_SALESMAN_OPEN_DRAWER_ON_TABLE_CLOSE',2,'SALESMAN_LEVEL_PERMISSIONS'),(13481,0,1,'Aviso|No foi possvel identificar o empregado!\n\nPor favor tente outra vez.',1545,'MSG_BOX_TEXT',2,'SALESMAN_SELECTION'),(13484,0,1,'Erro de impresso|Quer imprimir para a impressora de backup %s?',1548,'MSG_BOX_TEXT',2,'SCREEN_PRINTER_ERROR'),(13485,0,1,'Erro de impresso|No tem impressora de backup definida para %s ou no foi possvel encontra-la.\n\nQuer ignorar esta impressora?',1549,'MSG_BOX_TEXT',2,'SCREEN_PRINTER_ERROR'),(13486,0,1,'Erro de impresso|No foi possvel imprimir para %s!\n\nQuer tentar imprimir novamente?',1550,'MSG_BOX_TEXT',2,'SCREEN_PRINTER_ERROR'),(13487,0,1,'Erro de impresso|No foi possvel encontrar a impressora de destino da impresso!',1551,'MSG_BOX_TEXT',2,'SCREEN_PRINTER_ERROR'),(13488,0,1,'118 Vendas - Permisso Altera Lista Negra',1552,'ChangeBlackList',2,'SCREEN_OPEN_TABLES'),(13489,0,1,'Usa Bolsa no comando',1553,'UsesPurse',2,'SCREEN_CONFIG_SALESMAN'),(13490,0,1,'Pagamento CC de empregado',1554,'SalesmanAccountWindow',2,'SCREEN_SALESMAN_ACCOUNT'),(13491,0,1,'Saldo',1555,'SalesmanAccountBalance',2,'SCREEN_SALESMAN_ACCOUNT'),(13492,0,1,'Pagar',1556,'SalesmanAccountBtnPay',2,'SCREEN_SALESMAN_ACCOUNT'),(13493,0,1,'A pagar',1557,'SalesmanAccountPayable',2,'SCREEN_SALESMAN_ACCOUNT'),(13494,0,1,'Empregado',1558,'SalesmanAccountClientName',2,'SCREEN_SALESMAN_ACCOUNT'),(13495,0,1,'Pag. CC emp.',1559,'GetDesktopSessionsSecondMenuSelectionData',2,'SCREEN_SALESMAN_ACCOUNT'),(13496,0,1,'Pag. CC cliente',1560,'GetDesktopSessionsSecondMenuSelectionData',2,'SCREEN_CUSTOMER_ACCOUNT'),(13497,0,1,'Saidas Caixa',1561,'GetDesktopSessionsSecondMenuSelectionData',2,'SCREEN_MOVEMENTS_CLOSING_MOV'),(13498,0,1,'Entradas Caixa',1562,'GetDesktopSessionsSecondMenuSelectionData',2,'SCREEN_MOVEMENTS'),(13499,0,1,'Limpar Imp. SOS',1563,'GetDesktopSessionsSecondMenuSelectionData',2,'F8_CLEAR_BACKUP_PRINTERS'),(13500,0,1,'No  possvel alterar os dados deste empregado (no foi possvel encontrar/criar o cliente associado).\n\nPor favor tente outra vez.',1564,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_SALESMEN'),(13501,0,1,'No foi possvel criar o cliente associado a este empregado.\n\nTente outra vez ou associe um cliente a este empregado na ficha de empregados.',1565,'MSG_BOX_TEXT',2,'CloseSession'),(13502,0,1,'O NIF  um campo obrigatrio do cliente. Por favor indique um NIF vlido',1566,'MSG_BOX_TEXT',2,'CUSTOMERS'),(13503,0,1,'Cliente associado',1567,'SalesmanAssociatedCustomer',2,'SCREEN_CONFIG_SALESMEN'),(13504,0,1,'NIF',1568,'SalesmanNIF',2,'SCREEN_CONFIG_SALESMEN'),(13505,0,1,'O cliente seleccionado j est associado ao empregado %s.\n\nPor favor escolha outro cliente.',1569,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_SALESMEN'),(13506,0,1,'Este NIF j est atribuido a %s',1570,'MSG_BOX_TEXT1',2,'SCREEN_CONFIG_SALESMEN'),(13507,0,1,'119 Vendas - Entra no carto de consumo prprio de outros empregados',1571,'PERM_SALESMAN_ENTER_OTHERS_EXPENDITURE_TABLES',2,'SALESMAN_LEVEL_PERMISSIONS'),(13508,0,1,'A sesso do empregado desejado no est aberta',1572,'MSG_BOX_TEXT',2,'NO_OPEN_SESSION'),(13510,0,1,'Imprimir extracto de conta',1574,'CustomerAccountPrintStatement',2,'SCREEN_CUSTOMER_ACCOUNT'),(13511,0,1,'Este cliente est associado ao empregado %s.\n\nSe o pretende eliminar  por favor desassocie-o na ficha do empregado respectivo',1575,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_CUSTOMERS'),(13512,0,1,'Ocorreu um erro ao efectuar a operao!\n\nNo foi possvel encontrar o relatrio pretendido.',1576,'MSG_BOX_TEXT',2,'SCREEN_CUSTOMER_ACCOUNT'),(13513,0,1,'Imprimir extracto de conta',1577,'SalesmanAccountPrintStatement',2,'SCREEN_SALESMAN_ACCOUNT'),(13514,0,1,'Como tem um carto de consumo prprio precisa de ter um mtodo de pagamento do tipo Conta Corrente definido.\n\nAceda  a - Config->Tabelas->Formas pagamento - e crie o mtodo de pagamento em falta',1578,'MSG_BOX_TEXT',2,'CloseSessionErrorMessage'),(13515,0,1,'Impressoras SOS',1579,'BackupPrinterWindow',2,'SCREEN_SOS_PRINTERS'),(13516,0,1,'Reencaminhada',1580,'PrintingToBackup',2,'SCREEN_SOS_PRINTERS'),(13517,0,1,'Limpar impressoras reencaminhadas',1581,'ClearAllBackupPrinters',2,'SCREEN_SOS_PRINTERS'),(13518,0,1,'Drivers de dispositivos',1582,'DeviceDriversrWindow',2,'SCREEN_DEVICE_DRIVERS'),(13519,0,1,'Nome',1583,'DeviceDriverName',2,'SCREEN_DEVICE_DRIVERS'),(13520,0,1,'Tipo',1584,'DeviceDriversDeviceType',2,'SCREEN_DEVICE_DRIVERS'),(13521,0,1,'Cdigo',1585,'DeviceDriverCode',2,'SCREEN_DEVICE_DRIVERS'),(13522,0,1,'Vermelho',1586,'DeviceDriverRed',2,'SCREEN_DEVICE_DRIVERS'),(13523,0,1,'Preto',1587,'DeviceDriverBlack',2,'SCREEN_DEVICE_DRIVERS'),(13524,0,1,'Texto normal',1588,'DeviceDriverNormalText',2,'SCREEN_DEVICE_DRIVERS'),(13525,0,1,'Texto grande',1589,'DeviceDriverDoubleText',2,'SCREEN_DEVICE_DRIVERS'),(13526,0,1,'texto sublinhado',1590,'DeviceDriverUnderlineText',2,'SCREEN_DEVICE_DRIVERS'),(13527,0,1,'linha',1591,'DeviceDriverLineFeed',2,'SCREEN_DEVICE_DRIVERS'),(13528,0,1,'Imprime e corta',1592,'DeviceDriverPrintCRLF',2,'SCREEN_DEVICE_DRIVERS'),(13529,0,1,'Separador',1593,'DeviceDriverSepChar',2,'SCREEN_DEVICE_DRIVERS'),(13530,0,1,'Gaveta',1594,'DeviceDriverOpenDrawer',2,'SCREEN_DEVICE_DRIVERS'),(13531,0,1,'Linha grafica',1595,'DeviceDriverGraphicLine',2,'SCREEN_DEVICE_DRIVERS'),(13532,0,1,'Pre bitmap',1596,'DeviceDriverPreBitmap',2,'SCREEN_DEVICE_DRIVERS'),(13533,0,1,'Pos bitmap',1597,'DeviceDriverPostBitmap',2,'SCREEN_DEVICE_DRIVERS'),(13534,0,1,'bitmap',1598,'DeviceDriverBitmap',2,'SCREEN_DEVICE_DRIVERS'),(13535,0,1,'Seq. Inicializao',1599,'DeviceDriverPrinterInitSeq',2,'SCREEN_DEVICE_DRIVERS'),(13536,0,1,'Imprime invertido',1600,'DeviceDriverPrintUpsideDown',2,'SCREEN_DEVICE_DRIVERS'),(13537,0,1,'Caracter incio',1601,'DeviceDriverStartChar',2,'SCREEN_DEVICE_DRIVERS'),(13538,0,1,'Caracter fim',1602,'DeviceDriverEndChar',2,'SCREEN_DEVICE_DRIVERS'),(13539,0,1,'Filtro1',1603,'DeviceDriverFilter1',2,'SCREEN_DEVICE_DRIVERS'),(13540,0,1,'Filtro2',1604,'DeviceDriverFilter2',2,'SCREEN_DEVICE_DRIVERS'),(13541,0,1,'Seq. incio',1605,'DeviceDriverStartSeq',2,'SCREEN_DEVICE_DRIVERS'),(13542,0,1,'Mdia de leituras',1606,'DeviceDriverAvgReadings',2,'SCREEN_DEVICE_DRIVERS'),(13543,0,1,'Inverte leitura',1607,'DeviceDriverInvertReading',2,'SCREEN_DEVICE_DRIVERS'),(13544,0,1,'Por favor introduza apenas caracateres entre 0 e 9 e A a F! ',1608,'DeviceDriverHexMessage',2,'SCREEN_DEVICE_DRIVERS'),(13545,0,1,'Por favor escolha outra impressora!\n\nA impressora SOS no pode apontar para si prpria.',1609,'MSG_BOX_TEXT',2,'SCREEN_SOS_PRINTERS'),(13546,0,1,'Por favor seleccione uma impressora',1610,'MSG_BOX_TEXT',2,'SCREEN_SOS_PRINTERS'),(13547,0,1,'Reinicializa contador dos pedidos no incio do dia',1611,'ConfigProperty',2,'ConfigProperty'),(13548,0,1,'No foi possvel reinicializar o contador de pedido devido a um erro interno da aplicao',1612,'MSG_BOX_TEXT',2,'ResetOrderCounter'),(13549,0,1,'Quer limpar os reencaminhamentos de todas as impressoras e passar a imprimir para as impressoras definidas',1613,'MSG_BOX_TEXT',2,'SCREEN_SOS_PRINTERS'),(13550,0,1,'Quer deixar de imprimir para a impressora SOS \\\"%s\\\" e voltar a imprimir para a impressora \\\"%s\\\"?',1614,'MSG_BOX_TEXT',2,'SCREEN_SOS_PRINTERS'),(13551,0,1,'Quer ignorar a impressora \\\"%s\\\" e reencaminhar os trabalhos de impresso para a sua impressora SOS \\\"%s\\\"?',1615,'MSG_BOX_TEXT',2,'SCREEN_SOS_PRINTERS'),(13552,0,1,'Nenhum',1616,'GenericText',2,'GenericText'),(13553,0,1,'A impressora \\\"%s\\\" no tem definida nenhuma impressora SOS. Todos os tickets para esta impressora no sero impressos.\\n\\nSe pretender pode definir uma impressora SOS na checklist.',1617,'MSG_BOX_TEXT',2,'SCREEN_SOS_PRINTERS'),(13554,0,1,'Menus - adiciona artigos de niveis com um elemento',1618,'ConfigProperty',2,'ConfigProperty'),(13555,0,1,'Editar cliente',986,'NewClientWindow',2,''),(13556,0,1,'Ficha do cliente',1619,'TableCloseEditCustomer',2,'SCREEN_TABLE_CLOSE'),(13557,0,1,'Fecha caixa bolsa no fecho da sesso',1620,'ConfigProperty',2,'ConfigProperty'),(13558,0,1,'Caixa bolsa ainda esta aberta',1621,'RADIO_MSG',2,'RADIO_MSG'),(13559,0,1,'Aviso|Este terminal no possui nenhuma caixa associada.\n\nPor favor abra uma caixa para poder registar os movimentos necessrios',1097,'CashDrawerWarning',2,'CASH_DRAWER_MSG'),(13560,0,1,'Configurao das ofertas',1622,'ItemOffersConfigWindow',2,'SCREEN_OFFERS_CONFIG'),(13561,0,1,'Nome',1623,'OfferName',2,'SCREEN_OFFERS_CONFIG'),(13562,0,1,'Valor max de oferta',1624,'MaxOfferValue',2,'SCREEN_OFFERS_CONFIG'),(13563,0,1,'n de linha a oferecer',1625,'MaxOfferQuantity',2,'SCREEN_OFFERS_CONFIG'),(13564,0,1,'Adiciona se PVP >',1626,'AddWithDifference',2,'SCREEN_OFFERS_CONFIG'),(13565,0,1,'PVP',1627,'OfferPVP',2,'SCREEN_OFFERS_CONFIG'),(13566,0,1,'Famlias',1628,'OfferConfigFamilyFilter',2,'SCREEN_OFFERS_CONFIG'),(13567,0,1,'Preo oferta',1629,'OfferSalesValue',2,'SCREEN_OFFERS_CONFIG'),(13568,0,1,'',1630,'LabelItemsInPromo',2,'SCREEN_OFFERS_CONFIG'),(13569,0,1,'',1631,'LabelZonesInPromo',2,'SCREEN_OFFERS_CONFIG'),(13570,0,1,'',1632,'LabelTerminalsInPromo',2,'SCREEN_OFFERS_CONFIG'),(13571,0,1,'+',1633,'DetailedEdit',2,'SCREEN_OFFERS_CONFIG'),(13572,0,1,'AllLevelsAlike',1634,'AllLevelsAlike',2,'SCREEN_OFFERS_CONFIG'),(13573,0,1,'Ofertas',1635,'OffersWindow',2,'SCREEN_OFFERS'),(13574,0,1,'Num max. ofertas',1636,'MaxOffers',2,'SCREEN_OFFERS'),(13575,0,1,'Nova oferta',1637,'NewOffer',2,'SCREEN_OFFERS'),(13576,0,1,'Editar oferta',1638,'EditOffer',2,'SCREEN_OFFERS'),(13577,0,1,'Apagar oferta',1639,'DeleteOffer',2,'SCREEN_OFFERS'),(13579,0,1,'Activa/Desactiva',1641,'OfferInUse',2,'SCREEN_OFFERS'),(13580,0,1,'Nova promoo',1642,'SCREEN_OFFERS',2,'SCREEN_OFFERS'),(13581,0,1,'Apagar artigo automatico',1643,'DeleteAuto',2,'SCREEN_CONFIG_ZONES'),(13582,0,1,'Artigos/Familias oferta',1644,'SCREEN_OFFERS_CONFIG',2,'SCREEN_OFFERS_CONFIG'),(13583,0,1,'Sries activas',1645,'F178_LBL_PROMOTION_ZONES',2,'SCREEN_OFFERS_CONFIG'),(13584,0,1,'Terminais activos',1646,'F178_LBL_PROMOTION_TERMINALS',2,'SCREEN_OFFERS_CONFIG'),(13585,0,1,'Tipo de oferta',1647,'OfferType',2,'SCREEN_OFFERS_CONFIG'),(13586,0,1,'Oferece n registo',1648,'OFFER_TYPES',2,'OFFER_TYPES'),(13587,0,1,'Oferece n artigo/familia',1649,'OFFER_TYPES',2,'OFFER_TYPES'),(13588,0,1,'Menu normal',1650,'OFFER_TYPES',2,'OFFER_TYPES'),(13589,0,1,'Preo oferta',1651,'DropBoxPriceLevels_ADD_ON_TOP',2,'SCREEN_OFFERS_CONFIG'),(13590,0,1,'Aplicar desconto',1652,'TableEditDirectDiscount',2,'SCREEN_TABLE_EDIT'),(13591,0,1,'Oferta',1653,'TableEditOfferItem',2,'SCREEN_TABLE_EDIT'),(13592,0,1,'J atingiu o seu limite e no pode efectuar mais ofertas',1654,'MSG_BOX_TEXT',2,'MAX_OFFERS_REACHED'),(13593,0,1,'120 Vendas - Adiciona ofertas alm do limite',1655,'PERM_SALESMAN_CAN_OFFER_ABOVE_LIMIT',2,'SALESMAN_LEVEL_PERMISSIONS'),(13594,0,1,'Aviso|Este artigo j  oferta',1656,'MSG_BOX_TEXT',2,'OFFERS'),(13595,0,1,'Aviso|Por favor indique um nvel maior que 0 para poder adicionar artigos',1657,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_OFFERS'),(13596,0,1,'Repeties',1658,'RepeatCount',2,'SCREEN_OFFERS_CONFIG'),(13598,0,1,'Nenhum',1660,'DropBoxPriceLevels_ADD_ON_TOP',2,'SCREEN_OFFERS_CONFIG'),(13599,0,1,'Imprimir',1661,'OpenTablesPrintTablesList',2,'SCREEN_CONFIG_OPEN_TABLES'),(13600,0,1,'Cartes pagos',1662,'TablesCountClosed',2,'SCREEN_CONFIG_OPEN_TABLES'),(13601,0,1,'Total apurado',1663,'TablesTotalClosed',2,'SCREEN_CONFIG_OPEN_TABLES'),(13602,0,1,'Total previsto',1664,'TablesExpectedTotal',2,'SCREEN_CONFIG_OPEN_TABLES'),(13603,0,1,'Exclui de consumo mnimo',1665,'ItemExcludeForCompensation',2,'SCREEN_CONFIG_ITEMS'),(13604,0,1,'Ecr de sada',1666,'SalesmanDefaultExitScreen',1,'SCREEN_CONFIG_SALESMEN'),(13605,0,1,'Ecr de sada',1666,'SalesmanDefaultExitScreen',2,'SCREEN_CONFIG_SALESMEN'),(13608,0,1,'A sua procura no retornou resultados!\\n\\nExperimente remover alguns dos critrios de filtragem.',1668,'MSG_BOX_TEXT',1,'SCREEN_DAILY_JOURNAL'),(13609,0,1,'A sua procura no retornou resultados!\\n\\nExperimente remover alguns dos critrios de filtragem.',1668,'MSG_BOX_TEXT',2,'SCREEN_DAILY_JOURNAL'),(13610,0,1,'Mesa no reconhecida!',1669,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(13611,0,1,'Carto no reconhecido!',1669,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13612,0,1,'O carto no pode ser usado neste ecr ou no foi reconhecido!',1670,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(13613,0,1,'O carto no pode ser usado neste ecr ou no foi reconhecido!',1670,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13614,0,1,'Tem certeza que quer oferecer este carto?',1671,'MSG_BOX_TEXT',2,'SCREEN_TABLE_CLOSE'),(13615,0,1,'Tem certeza que quer oferecer esta mesa?',1671,'MSG_BOX_TEXT',1,'SCREEN_TABLE_CLOSE'),(13616,0,1,'121 Vendas - Assina cartes/mesas',1672,'PERM_SALESMAN_CAN_SIGN_CARD',1,'SALESMAN_LEVEL_PERMISSIONS'),(13617,0,1,'121 Vendas - Assina cartes/mesas',1672,'PERM_SALESMAN_CAN_SIGN_CARD',2,'SALESMAN_LEVEL_PERMISSIONS'),(13618,0,1,'122 Vendas - Pode remover consumo mnimo',1673,'PERM_SALESMAN_CAN_REMOVE_COMPENSATION_ITEM',1,'SALESMAN_LEVEL_PERMISSIONS'),(13619,0,1,'122 Vendas - Pode remover consumo mnimo',1673,'PERM_SALESMAN_CAN_REMOVE_COMPENSATION_ITEM',2,'SALESMAN_LEVEL_PERMISSIONS'),(13620,0,1,'No pode efectuar esta operao com o seu nvel de acesso!',1674,'MSB_BOX',1,'MSG_BOX'),(13621,0,1,'No pode efectuar esta operao com o seu nvel de acesso!',1674,'MSB_BOX',2,'MSG_BOX'),(13622,0,1,'Assinar Carto',1675,'TableCloseSignCard',1,'SCREEN_TABLE_CLOSE'),(13623,0,1,'Retirar consumo',1676,'TableCloseClearCompensation',1,'SCREEN_TABLE_CLOSE'),(13624,0,1,'Assinar Carto',1675,'TableCloseSignCard',2,'SCREEN_TABLE_CLOSE'),(13625,0,1,'Retirar consumo',1676,'TableCloseClearCompensation',2,'SCREEN_TABLE_CLOSE'),(13626,0,1,'Tem certeza que quer remover o artigo de compensao?',1677,'MSG_BOX',1,'MSG_BOX'),(13627,0,1,'Tem certeza que quer remover consumo mnimo?',1677,'MSG_BOX',2,'MSG_BOX'),(13628,0,1,'Ecr de trabalho',1678,'SalesmanDefaultWorkScreen',1,'SCREEN_CONFIG_SALESMEN'),(13629,0,1,'Ecr de trabalho',1678,'SalesmanDefaultWorkScreen',2,'SCREEN_CONFIG_SALESMEN'),(13630,0,1,'Mesa',1679,'SCREEN_TABLE_EDIT',1,'SCREEN_TABLE_EDIT'),(13631,0,1,'Mesa',1679,'SCREEN_TABLE_EDIT',2,'SCREEN_TABLE_EDIT'),(13632,0,1,'Imprime extras/open com preo zero',1680,'ConfigProperty',1,'ConfigProperty'),(13633,0,1,'Imprime extras/open com preo zero',1680,'ConfigProperty',2,'ConfigProperty'),(13634,0,1,'Imprime componentes menu/promo com preo zero',1681,'ConfigProperty',1,'ConfigProperty'),(13635,0,1,'Imprime componentes menu/promo com preo zero',1681,'ConfigProperty',2,'ConfigProperty'),(13636,0,1,'Defeito',1682,'TableEditTypes',1,'ConfigTerminals'),(13637,0,1,'Defeito',1682,'TableEditTypes',2,'ConfigTerminals'),(13638,0,1,'c/ botes \"Oferta\", \"Aplicar desconto\" e \"Acumular\" (Discotecas)',1683,'TableEditTypes',1,'ConfigTerminals'),(13639,0,1,'c/ botes \"Oferta\", \"Aplicar desconto\"  e \"Acumular\" (Discotecas)',1683,'TableEditTypes',2,'ConfigTerminals'),(13642,0,1,'c/ boto \"Aplicar desconto\"',1685,'TableEditTypes',1,'TableEditTypes'),(13643,0,1,'c/ boto \"Aplicar desconto\"',1685,'TableEditTypes',2,'TableEditTypes'),(13644,0,1,'c/ boto \"Acumula cartes\"',1686,'TableEditTypes',1,'TableEditTypes'),(13645,0,1,'c/ boto \"Acumula cartes\"',1686,'TableEditTypes',2,'TableEditTypes'),(13646,0,1,'Defeito',1687,'TableClose',1,'TableClose'),(13647,0,1,'Defeito',1687,'TableClose',2,'TableClose'),(13648,0,1,'c/ botes \"Assinar carto\" e \"Remover consumo\"',1688,'TableClose',1,'TableClose'),(13649,0,1,'c/ botes \"Assinar carto\" e \"Remover consumo\"',1688,'TableClose',2,'TableClose'),(13654,0,1,'Informativo',1691,'ITEMTYPE_INFORMATIVE',1,'ITEMTYPE_INFORMATIVE'),(13655,0,1,'Informativo',1691,'ITEMTYPE_INFORMATIVE',2,'ITEMTYPE_INFORMATIVE'),(13656,0,1,'Os artigos do tipo mensagem/informativo no podem ter preo!',1692,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(13657,0,1,'Os artigos do tipo mensagem/informativo no podem ter preo!',1692,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13658,0,1,'Menus - adiciona directo',1693,'ConfigProperty',1,'GENERAL_CONFIG'),(13659,0,1,'Menus - adiciona directo',1693,'ConfigProperty',2,'GENERAL_CONFIG'),(13660,0,1,'CARTO %d PAGO\n\nQuer reactivar este carto?',1694,'MSG_BOX_TEXT',1,'SCREEN_CARD_EXIT'),(13661,0,1,'CARTO %d PAGO\n\nQuer reactivar este carto?',1694,'MSG_BOX_TEXT',2,'SCREEN_CARD_EXIT'),(13662,0,1,'Novo cliente',1695,'TableEditNewCustomer',1,'SCREEN_TABLE_EDIT'),(13663,0,1,'Artigo',1696,'TableEditItemName',1,'SCREEN_TABLE_EDIT'),(13664,0,1,'Novo artigo',1697,'TableEditNewItem',1,'SCREEN_TABLE_EDIT'),(13665,0,1,'Total',1698,'TableEditPLULineTota',1,'SCREEN_TABLE_EDIT'),(13666,0,1,'PUnit',1699,'TableEditPLUUnitPrice',1,'SCREEN_TABLE_EDIT'),(13667,0,1,'Descrio',1700,'TableEditPLUDescription',1,'SCREEN_TABLE_EDIT'),(13668,0,1,'Suspender',1701,'TableEditSuspend',1,'SCREEN_TABLE_EDIT'),(13669,0,1,'',1702,'TableEditKeyboard',1,'SCREEN_TABLE_EDIT'),(13671,0,1,'Total',1704,'TableEditPLULineTotal',1,'SCREEN_TABLE_EDIT'),(13672,0,1,'Empregado no reconhecido!',1705,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(13673,0,1,'Empregado actual mudado para %s',1706,'MSG_BOX_TEXT',1,'SALESMAN_CHANGE'),(13674,0,1,'%s j  o empregado em uso!',1707,'MSG_BOX_TEXT',1,'SALESMAN_CHANGE'),(13675,0,1,'Novo cliente',1695,'TableEditNewCustomer',2,'SCREEN_TABLE_EDIT'),(13676,0,1,'Artigo',1696,'TableEditItemName',2,'SCREEN_TABLE_EDIT'),(13677,0,1,'Novo artigo',1697,'TableEditNewItem',2,'SCREEN_TABLE_EDIT'),(13678,0,1,'Total',1698,'TableEditPLULineTota',2,'SCREEN_TABLE_EDIT'),(13679,0,1,'PUnit',1699,'TableEditPLUUnitPrice',2,'SCREEN_TABLE_EDIT'),(13680,0,1,'Descrio',1700,'TableEditPLUDescription',2,'SCREEN_TABLE_EDIT'),(13681,0,1,'Suspender',1701,'TableEditSuspend',2,'SCREEN_TABLE_EDIT'),(13682,0,1,'',1702,'TableEditKeyboard',2,'SCREEN_TABLE_EDIT'),(13684,0,1,'Total',1704,'TableEditPLULineTotal',2,'SCREEN_TABLE_EDIT'),(13685,0,1,'Empregado no reconhecido!',1705,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13686,0,1,'Empregado actual mudado para %s',1706,'MSG_BOX_TEXT',2,'SALESMAN_CHANGE'),(13687,0,1,'%s j  o empregado em uso!',1707,'MSG_BOX_TEXT',2,'SALESMAN_CHANGE'),(13688,0,1,'Seleccione um artigo a introduzir',1708,'ItemSelection',1,'SCREEN_ITEM_SELECTION'),(13689,0,1,'Tem certeza que quer suspender esta venda?',1709,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(13690,0,1,'Seleccione um artigo a introduzir',1708,'ItemSelection',2,'SCREEN_ITEM_SELECTION'),(13691,0,1,'Tem certeza que quer suspender esta venda?',1709,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(13692,0,1,'Anular movimento de caixa',1710,'MovementsVoid',1,'SCREEN_MOVEMENTS_PRINT'),(13693,0,1,'Anular movimento de caixa',1710,'MovementsVoid',2,'SCREEN_MOVEMENTS_PRINT'),(13694,0,1,'112 Vendas - Faz pedidos',613,'PERM_SALESMAN_CAN_ORDER',2,'SALESMAN_LEVEL_PERMISSIONS'),(13695,0,1,'112 Vendas - Faz pedidos',613,'PERM_SALESMAN_CAN_ORDER',1,'SALESMAN_LEVEL_PERMISSIONS'),(13698,0,1,'Quantidade',1711,'KeyboardQt',1,'SCREEN_TABLE_EDIT'),(13699,0,1,'Artigo',1712,'KeyboardIDItem',1,'SCREEN_TABLE_EDIT'),(13700,0,1,'.',1713,'KeyboardDot',1,'SCREEN_TABLE_EDIT'),(13702,0,1,'216 Sesses - Impressoras SOS',1715,'PERM_SESSION_CAN_SET_BACKUP_PRINTERS',1,'SALESMAN_LEVEL_PERMISSIONS'),(13703,0,1,'216 Sesses - Impressoras SOS',1715,'PERM_SESSION_CAN_SET_BACKUP_PRINTERS',2,'SALESMAN_LEVEL_PERMISSIONS'),(13704,0,1,'Quantidade',1711,'KeyboardQt',2,'SCREEN_TABLE_EDIT'),(13705,0,1,'Artigo',1712,'KeyboardIDItem',2,'SCREEN_TABLE_EDIT'),(13706,0,1,'.',1713,'KeyboardDot',2,'SCREEN_TABLE_EDIT'),(13707,0,1,'212 Sesses - Consulta de sesses',1716,'PERM_SESSION_CAN_SEE_SESSIONS',1,'SALESMAN_LEVEL_PERMISSIONS'),(13708,0,1,'212 Sesses - Consulta de sesses',1716,'PERM_SESSION_CAN_SEE_SESSIONS',2,'SALESMAN_LEVEL_PERMISSIONS'),(13709,0,1,'Factura simplificada',1717,'DocTypeFacSimple',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(13710,0,1,'Factura simplificada',1717,'DocTypeFacSimple',2,'SCREEN_CONFIG_DOCUMENT_TYPES'),(13713,0,1,'Esta actualizao prepara a aplicao para as novas regras de certificao a entrar em vigor em 1 de Janeiro de 2013.Foi criada uma nova srie de documentos para as facturas simplificadas que vai entrar em funcionamento em Janeiro.\\n\\nSe pretender configurar essa srie aceda a Config->Geral->Numerao Doc. e configure a nova srie.',1719,'MSG_BOX_TEXT',1,'CERT2013_MESSAGE'),(13714,0,1,'Esta actualizao prepara a aplicao para as novas regras de certificao a entrar em vigor em 1 de Janeiro de 2013.\\n\\nFoi criada uma nova srie de documentos para as facturas simplificadas que vai entrar em funcionamento em Janeiro. Se pretender configurar essa srie aceda a Config->Config->Numerao Doc. e configure a nova srie.',1719,'MSG_BOX_TEXT',2,'CERT2013_MESSAGE'),(13715,0,1,'No pode alterar este campo numa srie em preparao',1720,'MSG_BOX_TEXT',1,'CERT2013_MESSAGE'),(13716,0,1,'No pode alterar este campo numa srie em preparao',1720,'MSG_BOX_TEXT',2,'CERT2013_MESSAGE'),(13719,0,1,'Gesto',242,'DesktopBtnSessions',1,'SCREEN_DESKTOP'),(13720,0,1,'Gesto',242,'DesktopBtnSessions',2,'SCREEN_DESKTOP'),(13721,0,1,'Tabelas',665,'ScreenMenuGeneral',1,'SCREEN_MENU'),(13722,0,1,'Tabelas',665,'ScreenMenuGeneral',2,'SCREEN_MENU'),(13723,0,1,'Geral',666,'ScreenMenuTechnicial',1,'SCREEN_MENU'),(13724,0,1,'Geral',666,'ScreenMenuTechnicial',2,'SCREEN_MENU'),(13725,0,1,'Config. Geral',486,'SystemConfigWindow',1,'SCREEN_CONFIG_SYSTEM'),(13726,0,1,'Config. Geral',486,'SystemConfigWindow',2,'SCREEN_CONFIG_SYSTEM'),(13727,0,1,'Outros',952,'ProfilesOpenWindow',1,'SCREEN_PROFILES_SELECTION'),(13728,0,1,'Outros',952,'ProfilesOpenWindow',2,'SCREEN_PROFILES_SELECTION'),(13729,0,1,'407 Tcnico - Permisses',840,'PERM_CONFIG_TEC_SALESMAN_LEVEL',1,'SALESMAN_LEVEL_PERMISSIONS'),(13730,0,1,'407 Tcnico - Permisses',840,'PERM_CONFIG_TEC_SALESMAN_LEVEL',2,'SALESMAN_LEVEL_PERMISSIONS'),(13731,0,1,'408 Tcnico - Cabealhos/Rodaps',841,'PERM_CONFIG_TEC_DOC_PARTS',1,'SALESMAN_LEVEL_PERMISSIONS'),(13732,0,1,'408 Tcnico - Cabealhos/Rodaps',841,'PERM_CONFIG_TEC_DOC_PARTS',2,'SALESMAN_LEVEL_PERMISSIONS'),(13733,0,1,'409 Tcnico - Pode abrir/fechar sesses de outros',927,'PERM_CAN_MANAGE_OTHERS_SESSIONS',1,'SALESMAN_LEVEL_PERMISSIONS'),(13734,0,1,'409 Tcnico - Pode abrir/fechar sesses de outros',927,'PERM_CAN_MANAGE_OTHERS_SESSIONS',2,'SALESMAN_LEVEL_PERMISSIONS'),(13735,0,1,'410 Tcnico - Terminais Rdio',1060,'PERM_CONFIG_TEC_RADIO_TERMINALS',1,'SALESMAN_LEVEL_PERMISSIONS'),(13736,0,1,'410 Tcnico - Terminais Rdio',1060,'PERM_CONFIG_TEC_RADIO_TERMINALS',2,'SALESMAN_LEVEL_PERMISSIONS'),(13737,0,1,'410 Tcnico - Terminais Rdio',1150,'PERM_CONFIG_TEC_RADIO',1,'SALESMAN_LEVEL_PERMISSIONS'),(13738,0,1,'410 Tcnico - Terminais Rdio',1150,'PERM_CONFIG_TEC_RADIO',2,'SALESMAN_LEVEL_PERMISSIONS'),(13739,0,1,'411 Tcnico - Licenciamento',1061,'PERM_CONFIG_TEC_LICENCE',1,'SALESMAN_LEVEL_PERMISSIONS'),(13740,0,1,'411 Tcnico - Licenciamento',1061,'PERM_CONFIG_TEC_LICENCE',2,'SALESMAN_LEVEL_PERMISSIONS'),(13741,0,1,'411 Tcnico - Licenciamento',1151,'PERM_CONFIG_TEC_LICENSES',1,'SALESMAN_LEVEL_PERMISSIONS'),(13742,0,1,'411 Tcnico - Licenciamento',1151,'PERM_CONFIG_TEC_LICENSES',2,'SALESMAN_LEVEL_PERMISSIONS'),(13743,0,1,'412 Tcnico - Tem acesso ao ecr de plugins',1268,'PERM_CONFIG_TEC_PLUGINS',1,'SALESMAN_LEVEL_PERMISSIONS'),(13744,0,1,'412 Tcnico - Tem acesso ao ecr de plugins',1268,'PERM_CONFIG_TEC_PLUGINS',2,'SALESMAN_LEVEL_PERMISSIONS'),(13745,0,1,'413 Tcnico - Numerao Doc.',1220,'PERM_CONFIG_TEC_LICENSES',1,'SALESMAN_LEVEL_PERMISSIONS'),(13746,0,1,'414 Tcnico - Numerao Doc.',1220,'PERM_CONFIG_TEC_LICENSES',2,'SALESMAN_LEVEL_PERMISSIONS'),(13749,0,1,'No foi possvel fechar todas as mesas abertas!\\n\\nPara mesas com valor superior a 1000  necessrio identificar o cliente da factura. Por favor identifique o cliente para a(s) mesa(s) abertas e feche-as normalmente.',1723,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_OPEN_TABLES'),(13750,0,1,'No foi possvel fechar todos os cartes abertos!\\n\\nPara cartes com valor superior a 1000  necessrio identificar o cliente da factura. Por favor identifique o cliente para o(s) carte(s) abertos e feche-os normalmente.',1723,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_OPEN_TABLES'),(13751,0,1,'No foi possvel fechar algumas mesas.\\n\\n.Se forem mesas da zona de importao de documentos manuais, deve fecha-las normalmente!',1724,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_OPEN_TABLES'),(13752,0,1,'No foi possvel fechar alguns cates.\\n\\n.Se forem cares da zona de importao de documentos manuais, deve fecha-los normalmente!',1724,'MSG_BOX_TEXT',2,'SCREEN_CONFIG_OPEN_TABLES'),(13753,0,1,'Famlia',1725,'TableEditSubfamilyName',1,'SCREEN_TABLE_EDIT'),(13754,0,1,'Preo',1726,'KeyboardIDPVP',1,'SCREEN_TABLE_EDIT'),(13755,0,1,'Preo',1726,'KeyboardIDPVP',2,'SCREEN_TABLE_EDIT'),(13756,0,1,'Famlia',1725,'TableEditSubfamilyName',2,'SCREEN_TABLE_EDIT'),(13757,0,1,'',1727,'TableEditOperationData',1,'SCREEN_TABLE_EDIT'),(13760,0,1,'',1730,'TableEditStatusBar',1,'SCREEN_TABLE_EDIT'),(13761,0,1,'23:59:59 30/01/2012',1731,'Clock',1,'SCREEN_TABLE_EDIT'),(13764,0,1,'',1727,'TableEditOperationData',2,'SCREEN_TABLE_EDIT'),(13767,0,1,'',1730,'TableEditStatusBar',2,'SCREEN_TABLE_EDIT'),(13768,0,1,'23:59:59 30/01/2012',1731,'Clock',2,'SCREEN_TABLE_EDIT'),(14927,0,1,'Reactivar',1734,'TableEditRecall',1,'SCREEN_TABLE_EDIT'),(14928,0,1,'Reactivar',1734,'TableEditRecall',2,'SCREEN_TABLE_EDIT'),(14929,0,1,'Tem certeza que quer suspender esta venda activar outra suspensa?',1735,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(14930,0,1,'Tem certeza que quer suspender esta venda activar outra suspensa?',1735,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(14931,0,1,'No pode suspender uma transao vazia!',1736,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(14932,0,1,'No pode suspender uma transao vazia!',1736,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(14933,0,1,'No foram encontrados artigos!\n\nPor favor insira um novo termo de pesquisa.',1737,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(14934,0,1,'No foram encontrados artigos!\n\nPor favor insira um novo termo de pesquisa.',1737,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(14935,0,1,'O texto de procura  muito pequeno!\n\nIntroduza um texto maior sff',1738,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(14936,0,1,'O texto de procura  muito pequeno!\n\nIntroduza um texto maior sff',1738,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(14937,0,1,'No foram encontrados artigos com esse nome!\n\nQuer criar um novo artigo?',1739,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(14938,0,1,'No foram encontrados artigos com esse nome!\n\nQuer criar um novo artigo?',1739,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(14939,0,1,'Inverte impresso',1740,'DeviceManagerInvertPrintJob',1,'SCREEN_CONFIG_DEVICES'),(14940,0,1,'Inverte impresso',1740,'DeviceManagerInvertPrintJob',2,'SCREEN_CONFIG_DEVICES'),(14941,0,1,'Descontos',1741,'TableEditDiscount',1,'SCREEN_TABLE_EDIT'),(14942,0,1,'Descontos',1741,'TableEditDiscount',2,'SCREEN_TABLE_EDIT'),(14951,0,1,'Sair',963,NULL,1,NULL),(14952,0,1,'Sair',963,NULL,2,NULL),(14953,0,1,'Tcnico',1714,'ScreenMenuTechnicial',1,'SCREEN_MENU'),(14954,0,1,'Tcnico',1714,'ScreenMenuTechnicial',2,'SCREEN_MENU'),(15673,0,1,'Servios',301,'ItemWindow',4,'SCREEN_CONFIG_ITEMS'),(15676,0,1,'No foram encontrados artigos para fechar esta venda!',1541,'MSG_BOX_TEXT',1,'TABLE_HAS_NO_ITEMS_TO_SAVE'),(15677,0,1,'%',1703,'TableEditPLULineDiscount',1,'SCREEN_TABLE_EDIT'),(15678,0,1,'%',1703,'TableEditPLULineDiscount',2,'SCREEN_TABLE_EDIT'),(15679,0,1,'Bengaleiro',1742,'TableCloseAddBenga',1,'SCREEN_TABLE_CLOSE'),(15680,0,1,'Bengaleiro',1742,'TableCloseAddBenga',2,'SCREEN_TABLE_CLOSE'),(15681,0,1,'217 Sesses - Reactivar mesas',1743,'PERM_RESET_CARDS',1,'SALESMAN_LEVEL_PERMISSIONS'),(15682,0,1,'217 Sesses - Reactivar cartes',1743,'PERM_RESET_CARDS',2,'SALESMAN_LEVEL_PERMISSIONS'),(15683,0,1,'Reactivar mesas',1744,'SESSIONS_BUTTON_STR',1,'SESSIONS_BUTTON_STR'),(15684,0,1,'Reactivar cartes',1744,'SESSIONS_BUTTON_STR',2,'SESSIONS_BUTTON_STR'),(15685,0,1,'Tem certeza que quer reactivar as mesas?',1745,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(15686,0,1,'Tem certeza que quer reactivar os cartes?',1745,'MSG_BOX_TEXT',2,'MSG_BOX_TEXT'),(15687,0,1,'Venda',1746,'SCREEN_TABLE_EDIT_RETAIL',1,'SCREEN_TABLE_EDIT_RETAIL'),(15688,0,1,'Venda',1746,'SCREEN_TABLE_EDIT_RETAIL',2,'SCREEN_TABLE_EDIT_RETAIL'),(15691,0,1,'Retalho',1748,'TableEditType',1,'SCREEN_TABLE_EDIT_RETAIL'),(15692,0,1,'Retalho',1748,'TableEditType',2,'SCREEN_TABLE_EDIT_RETAIL'),(15693,0,1,'Desc. linha',1749,'KeyboardLineDiscount',1,'SCREEN_TABLE_EDIT_RETAIL'),(15696,0,1,'Desc. linha',1749,'KeyboardLineDiscount',2,'SCREEN_TABLE_EDIT_RETAIL'),(15699,0,1,'O mtodo de pagamento do tipo Conta Corrente no est definido.\n\nPor favor v a Config->Tabelas->Formas de pagamento e crie-o para poder usar esta funcionalidade',1752,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT_RETAIL'),(15700,0,1,'O mtodo de pagamento do tipo Conta Corrente no est definido.\n\nPor favor v a Config->Tabelas->Formas de pagamento e crie-o para poder usar esta funcionalidade',1752,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT_RETAIL'),(15701,0,1,'Quer fechar esta venda com desconto?',1753,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT_RETAIL'),(15702,0,1,'Quer fechar esta venda com desconto?',1753,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT_RETAIL'),(15703,0,1,'TableEditServicesWindow',1754,'TableEditServicesWindow',1,'SCREEN_TABLE_EDIT_SERVICES'),(15704,0,1,'Impostos',1755,'TableEditTotalTax',1,'SCREEN_TABLE_EDIT_SERVICES'),(15706,0,1,'Valor',1757,'TableEditTenderValue',1,'SCREEN_TABLE_EDIT_SERVICES'),(15707,0,1,'Morada',1758,'TableEditCustomerAddress',1,'SCREEN_TABLE_EDIT_SERVICES'),(15708,0,1,'C.P.',1759,'TableEditCustomerPostalCode',1,'SCREEN_TABLE_EDIT_SERVICES'),(15709,0,1,'Loc.',1760,'TableEditCustomerLocality',1,'SCREEN_TABLE_EDIT_SERVICES'),(15710,0,1,'Observaes',1761,'ItemObservation',1,'SCREEN_PLU_ADD_OBS'),(15711,0,1,'TableEditServicesWindow',1754,'TableEditServicesWindow',2,'SCREEN_TABLE_EDIT_SERVICES'),(15712,0,1,'Impostos',1755,'TableEditTotalTax',2,'SCREEN_TABLE_EDIT_SERVICES'),(15714,0,1,'Valor',1757,'TableEditTenderValue',2,'SCREEN_TABLE_EDIT_SERVICES'),(15715,0,1,'Morada',1758,'TableEditCustomerAddress',2,'SCREEN_TABLE_EDIT_SERVICES'),(15716,0,1,'C.P.',1759,'TableEditCustomerPostalCode',2,'SCREEN_TABLE_EDIT_SERVICES'),(15717,0,1,'Loc.',1760,'TableEditCustomerLocality',2,'SCREEN_TABLE_EDIT_SERVICES'),(15718,0,1,'Observaes',1761,'ItemObservation',2,'SCREEN_PLU_ADD_OBS'),(15719,0,1,'Iva incluido',1762,'VatIncluded',1,'SCREEN_TABLE_EDIT_SERVICES'),(15721,0,1,'Exmo Sr.',1764,'PDF_STR',1,'PDF_STR'),(15722,0,1,'Original',1765,'PDF_STR',1,'PDF_STR'),(15723,0,1,'Vencimento',1766,'PDF_STR',1,'PDF_STR'),(15724,0,1,'Condies de pagamento',1767,'PDF_STR',1,'PDF_STR'),(15725,0,1,'Duplicado',1768,'PDF_STR',1,'PDF_STR'),(15726,0,1,'Iva incluido',1762,'VatIncluded',2,'SCREEN_TABLE_EDIT_SERVICES'),(15728,0,1,'Exmo Sr.',1764,'PDF_STR',2,'PDF_STR'),(15729,0,1,'Original',1765,'PDF_STR',2,'PDF_STR'),(15730,0,1,'Vencimento',1766,'PDF_STR',2,'PDF_STR'),(15731,0,1,'Condies de pagamento',1767,'PDF_STR',2,'PDF_STR'),(15732,0,1,'Duplicado',1768,'PDF_STR',2,'PDF_STR'),(15733,0,1,'Descrio',1769,'ItemEditListLabel',1,'SCREEN_CONFIG_ITEMS'),(15734,0,1,'Qnt|Descrio|IVA|PUnit|Desc|Total',1770,'RetailItemListLabel',1,'SCREEN_TABLE_EDIT_RETAIL'),(15735,0,1,'Qnt|Descrio|IVA|PUnit|Desc|Total',1771,'ServiceListCaption',1,'SCREEN_TABLE_EDIT_SERVICES'),(15736,0,1,'Qnt|Descrio|Total',1772,'TableEditListLabel',1,'SCREEN_TABLE_EDIT'),(15737,0,1,'Descrio',1769,'ItemEditListLabel',2,'SCREEN_CONFIG_ITEMS'),(15738,0,1,'Qnt|Descrio|IVA|PUnit|Desc|Total',1770,'RetailItemListLabel',2,'SCREEN_TABLE_EDIT_RETAIL'),(15739,0,1,'Qnt|Descrio|IVA|PUnit|Desc|Total',1771,'ServiceListCaption',2,'SCREEN_TABLE_EDIT_SERVICES'),(15740,0,1,'Qnt|Descrio|Total',1772,'TableEditListLabel',2,'SCREEN_TABLE_EDIT'),(15741,0,1,'Total',1773,'TableEditTotalTableRetail',1,'SCREEN_TABLE_EDIT_SERVICES'),(15742,0,1,'Mtodo|Valor',1774,'TendersListLbl',1,'SCREEN_TABLE_EDIT_SERVICES'),(15743,0,1,'Desc. %',1775,'TableEditHeaderDiscountRate',1,'SCREEN_TABLE_EDIT_SERVICES'),(15744,0,1,'Desc. Valor',1776,'TableEditHeaderDiscountValue',1,'SCREEN_TABLE_EDIT_SERVICES'),(15745,0,1,'Taxa|Incidncia|Valor',1777,'VATListLabel',1,'SCREEN_TABLE_EDIT_SERVICES'),(15746,0,1,'Desc. Total',1778,'TableEditSumDiscounts',1,'SCREEN_TABLE_EDIT_SERVICES'),(15747,0,1,'Total',1773,'TableEditTotalTableRetail',2,'SCREEN_TABLE_EDIT_SERVICES'),(15748,0,1,'Mtodo|Valor',1774,'TendersListLbl',2,'SCREEN_TABLE_EDIT_SERVICES'),(15749,0,1,'Desc. %',1775,'TableEditHeaderDiscountRate',2,'SCREEN_TABLE_EDIT_SERVICES'),(15750,0,1,'Desc. Valor',1776,'TableEditHeaderDiscountValue',2,'SCREEN_TABLE_EDIT_SERVICES'),(15751,0,1,'Taxa|Incidncia|Valor',1777,'VATListLabel',2,'SCREEN_TABLE_EDIT_SERVICES'),(15752,0,1,'Desc. Total',1778,'TableEditSumDiscounts',2,'SCREEN_TABLE_EDIT_SERVICES'),(15753,0,1,'Fechar venda',1779,'TableEditCloseRetail',1,'SCREEN_TABLE_EDIT_SERVICES'),(15754,0,1,'Diferena',1780,'TableCloseChangeRetail',1,'SCREEN_TABLE_EDIT_SERVICES'),(15755,0,1,'Fechar',1779,'TableEditCloseRetail',2,'SCREEN_TABLE_EDIT_SERVICES'),(15756,0,1,'Diferena',1780,'TableCloseChangeRetail',2,'SCREEN_TABLE_EDIT_SERVICES'),(15757,0,1,'e-mail',1781,'NewClientEMail',1,'SCREEN_NEW_CLIENT'),(15758,0,1,'Nota de Crdito',1782,'TableEditCloseAsCreditNote',1,'SCREEN_TABLE_EDIT_SERVICES'),(15759,0,1,'Reteno',1783,'TableEditTaxRetention',1,'SCREEN_TABLE_EDIT_SERVICES'),(15760,0,1,'Nota de crdito',1784,'CreditNoteCounterStr',1,'CreditNoteCounterStr'),(15761,0,1,'Tem certeza que quer efectuar uma nota de crdito?',1785,'MSG_BOX_TEXT',1,'SERVICE_MODE_CREDIT_NOTE'),(15762,0,1,'No pode ter troco numa nota de crdito!',1786,'MSG_BOX_TEXT',1,'SERVICE_MODE_CREDIT_NOTE'),(15763,0,1,'No pode user facturao externa como mtodo de pagamento numa nota de crdito!',1787,'MSG_BOX_TEXT',1,'SERVICE_MODE_CREDIT_NOTE'),(15764,0,1,'Servio',1788,'ItemIsService',1,'SCREEN_CONFIG_ITEMS_SERVICES'),(15765,0,1,'Reteno na fonte',1789,'PAYMENTTYPE_WITHHOLDING',1,'SCREEN_CONFIG_PAYMENT_TYPES'),(15766,0,1,'No tem permisso para emitir Notas de Crdito',1790,'MSG_BOX_TEXT',1,'SCREEN_DAILY_JOURNAL'),(15767,0,1,'Data|Hora|Doc.|Valor',1791,'DailyJournalListLbl',1,'SCREEN_DAILY_JOURNAL_SERVICES'),(15768,0,1,'Qnt|Desc|Valor',1792,'ShortItemsListLbl',1,'SCREEN_DAILY_JOURNAL_SERVICES'),(15769,0,1,'Nota de crdito',1793,'DailyJournalBtnCreditNote',1,'SCREEN_DAILY_JOURNAL_SERVICES'),(15770,0,1,'No pode efectuar esta operao!\n\nO documento seleccionado  uma nota de crdito!',1794,'MSG_BOX_TEXT',1,'SCREEN_DAILY_JOURNAL_SERVICES'),(15771,0,1,'S pode emitir uma nota de crdito de um documento de venda com cliente identificado.',1795,'MSG_BOX_TEXT',1,'SCREEN_DAILY_JOURNAL_SERVICES'),(15772,0,1,'No pode efectuar esta operao numa nota de crdito!',1796,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT_SERVICES'),(15773,0,1,'%Ret.na fonte',1797,'WithholdingPerc',1,'SCREEN_PLU_EDIT'),(15774,0,1,'Referente ao doc:',1798,'CreditNotePrintTag',1,'CreditNotePrintTag'),(15775,0,1,'C/ reteno na fonte',1799,'hasWithholdingTax',1,'SCREEN_TABLE_EDIT_SERVICES'),(15776,0,1,'Cliente',1800,'DailyJournalCustomerName',1,'SCREEN_CONFIG_DAILY_JOURNAL_SERVICES'),(15777,0,1,'NIF',1801,'DailyJournalCustomerNIF',1,'SCREEN_CONFIG_DAILY_JOURNAL_SERVICES'),(15778,0,1,'Segunda via',1054,'FOOTER_TEXT',1,'FOOTER_TEXT'),(15781,0,1,'Mesa|Valor',1802,'OpenTablesListLbl',1,'SCREEN_CONFIG_OPEN_TABLES'),(15782,0,1,'Qnt|Artigo|Valor|Hora|Empregado',1803,'OpenTableDetailsListLbl',1,'SCREEN_CONFIG_OPEN_TABLES'),(15783,0,1,'Carto|Valor',1802,'OpenTableDetailsListLbl',2,'SCREEN_CONFIG_OPEN_TABLES_SERVICES'),(15784,0,1,'Cliente|Valor',1802,'OpenTableDetailsListLbl',4,'SCREEN_CONFIG_OPEN_TABLES_SERVICES'),(15785,0,1,'Qnt|Artigo/Servio|Valor|Hora|Utilizador',1803,'OpenTableDetailsListLbl',4,'SCREEN_CONFIG_OPEN_TABLES_SERVICES'),(15787,0,1,'Fechar',870,'OpenTablesBtnCloseTable',4,'SCREEN_CONFIG_OPEN_TABLES_SERVICES'),(15788,0,1,'Documentos abertos',1225,'TablesCount',4,'SCREEN_CONFIG_OPEN_TABLES_SERVICES'),(15789,0,1,'Documentos fechados',1662,'TablesCountClosed',4,'SCREEN_CONFIG_OPEN_TABLES_SERVICES'),(15790,0,1,'Nome',1804,'PaymentTypesListLbl',1,'SCREEN_CONFIG_PAYMENTTYPES_SERVICES'),(15791,0,1,'Nome',1805,'FamiliesLstLbl',1,'SCREEN_CONFIG_FAMILIES_SERVICES'),(15792,0,1,'Nome',1806,'GenericListLbl',1,'SCREEN_CONFIG_SALESMEN_SERVICES'),(15793,0,1,'Terminal',1807,'TerminalsListlbl',1,'SCREEN_CONFIG_TERMINALS_SERVICES'),(15794,0,1,'Analisar SAF-T',638,'AnalSaft',1,'SCREEN_SAFT'),(15795,0,1,'Abrir no explorador',639,'OpenInExplorer',1,'SCREEN_SAFT'),(15796,0,1,'Entidade',659,'TaxEntity',1,'SAFT_SCREEN'),(15799,0,1,'Gerar SAF-T',851,'CloseCashierBtnSaft',1,'SCREEN_CASHIER_CLOSE'),(15800,0,1,'No pode alterar o NIF do cliente \'%s\' por este j ter vendas associadas.\n\nSe o NIF deste cliente est errado e o pretende alterar por favor crie um cliente novo com o NIF correcto e elimine o cliente existente',1092,'CUSTOMER_ERROR',1,'CUSTOMER_ERROR'),(15801,0,1,'No pode gerar SAF-T com dados de anos diferentes! Por favor escolha datas dentro do mesmo ano civil!',1718,'MSG_BOX_TEXT',1,'SAFT_MESSGASE'),(15803,0,1,'Quer aplicar desconto de %d%%%%?',1310,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(15804,0,1,'Aviso|Quer aplicar um desconto de %d%%%% ao artigo seleccionado? ',1659,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(15805,0,1,'Vendas',241,'DesktopBtnTables',3,'SCREEN_DESKTOP'),(15806,0,1,'Faturas',241,'DesktopBtnTables',4,'SCREEN_DESKTOP'),(15807,0,1,'Transferir',882,'OpenTablesBtnTransferTable',1,'SCREEN_CONFIG_OPEN_TABLES'),(15808,0,1,'Transferir',754,'TableEditTransfer',1,'SCREEN_TABLE_EDIT'),(15809,0,1,'Fechar',91,NULL,1,''),(15810,0,1,'Fechar',253,'TableEditCloseTable',1,'SCREEN_TABLE_EDIT'),(15811,0,1,'Fechar',262,'TableCloseWindow',1,'SCREEN_TABLE_CLOSE'),(15812,0,1,'Fechar',281,'TableCloseTableClose',1,'SCREEN_TABLE_CLOSE'),(15813,0,1,'Fechar em aberto',872,'OpenTablesBtnCloseAllTables',1,'SCREEN_CONFIG_OPEN_TABLES'),(15817,0,1,'Vendas suspensas',246,'TableSelectionWindow',3,'SCREEN_TABLE_SELECTION'),(15818,0,1,'Faturas suspensas',246,'TableSelectionWindow',4,'SCREEN_TABLE_SELECTION'),(15819,0,1,'Intervalo Totais',524,'DailyJournalTotalSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(15820,1,1,'Intervalo Totais',768,'DailyJournalTotal',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(15821,0,1,'Quer usar estes artigos noutra operao de venda?',1466,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(15823,0,1,'100 Vendas - Tem acesso a vendas de outros utilizadores',601,'PERM_SALESMAN_CAN_ENTER_OTHERS_TABLES',4,'SALESMAN_LEVEL_PERMISSIONS'),(15824,0,1,'101 Vendas - Cancela Pedidos',603,'PERM_SALESMAN_CAN_CANCEL_ORDERS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15825,0,1,'102 Vendas - Anulaes',604,'PERM_SALESMAN_CAN_VOID_ORDERS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15826,0,1,'103 Vendas - Devolues',605,'PERM_SALESMAN_CAN_REFUND',4,'SALESMAN_LEVEL_PERMISSIONS'),(15827,0,1,'104 Vendas - Consulta registos',609,'PERM_SALESMAN_CAN_ACCESS_HISTORY',4,'SALESMAN_LEVEL_PERMISSIONS'),(15828,0,1,'105 Vendas - Fecha vendas',610,'PERM_SALESMAN_CAN_CLOSE_TABLE',4,'SALESMAN_LEVEL_PERMISSIONS'),(15829,0,1,'106 Vendas - Altera preo',611,'PERM_SALESMAN_CAN_CHANGE_PRICE',4,'SALESMAN_LEVEL_PERMISSIONS'),(15830,0,1,'107 Vendas - Venda acima do limite mximo',612,'PERM_SALESMAN_ABOVE_LIMIT',4,'SALESMAN_LEVEL_PERMISSIONS'),(15831,0,1,'108 Vendas - Descontos',1052,NULL,4,'TABLE EDIT'),(15832,0,1,'109 Vendas - Fecha documentos suspensos',1053,NULL,4,'OPENTABLES'),(15833,0,1,'110 Vendas - Pode emitir notas de crdito',1808,'PERM_SALESMAN_CAN_ISSUE_CREDIT_NOTES',4,'SALESMAN_LEVEL_PERMISSIONS'),(15835,0,1,'201 Gesto - Pagamento Conta Corrente',1065,'PERM_SESSIONS_CC',4,'SALESMAN_LEVEL_PERMISSIONS'),(15836,0,1,'202 Gesto - Documentos suspensos',1066,'PERM_SESSIONS_OPEN_TABLES',4,'SALESMAN_LEVEL_PERMISSIONS'),(15837,0,1,'203 Gesto - Consulta Registos',1068,'PERM_SESSIONS_DAILY_JOURNAL',4,'SALESMAN_LEVEL_PERMISSIONS'),(15838,0,1,'204 Gesto - Relatrios',1070,'PERM_SESSIONS_REPORTS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15839,0,1,'205 Gesto - SAFT',1071,'PERM_SESSIONS_SAFT',4,'SALESMAN_LEVEL_PERMISSIONS'),(15840,0,1,'206 Gesto - Impressoras SOS',1715,'PERM_SESSION_CAN_SET_BACKUP_PRINTERS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15841,0,1,'300 Config - Ver Artigos',618,'PERM_CONFIG_SEE_ITEMS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15842,0,1,'301 Config - Edio Artigos',619,'PERM_CONFIG_EDIT_ITEMS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15843,0,1,'302 Config - Ver Empregados',620,'PERM_CONFIG_SEE_SALESMANS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15844,0,1,'303 Config - Edio Empregados',621,'PERM_PERM_CONFIG_EDIT_SALESMANS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15845,0,1,'304 Config - Ver Formas Pagamento',626,'PERM_CONFIG_SEE_PAYMENT_TYPES',4,'SALESMAN_LEVEL_PERMISSIONS'),(15846,0,1,'305 Config - Edio Formas Pagamento',627,'PERM_CONFIG_EDIT_PAYMENT_TYPES',4,'SALESMAN_LEVEL_PERMISSIONS'),(15847,0,1,'306 Config - Ver Clientes',630,'PERM_CONFIG_SEE_CUSTOMERS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15848,0,1,'307 Config - Edio Clientes',631,'PERM_CONFIG_EDIT_CUSTOMERS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15849,0,1,'308 Config - Ver Taxas IVA',632,'PERM_CONFIG_SEE_TAXES',4,'SALESMAN_LEVEL_PERMISSIONS'),(15850,0,1,'309 Config - Edio Taxas IVA',633,'PERM_CONFIG_EDIT_TAXES',4,'SALESMAN_LEVEL_PERMISSIONS'),(15851,0,1,'310 Config - Ver Grupos Clientes',636,'PERM_CONFIG_SEE_CUSTOMER_GROUPS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15852,0,1,'311 Config - Edio Grupos Clientes',637,'PERM_CONFIG_EDIT_CUSTOMER_GROUPS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15853,0,1,'312 Config - Tipos Documento',643,'PERM_CONFIG_TEC_DOC_TYPES',4,'SALESMAN_LEVEL_PERMISSIONS'),(15854,0,1,'313 Config - Config. Geral',644,'PERM_CONFIG_TEC_SYSTEM',4,'SALESMAN_LEVEL_PERMISSIONS'),(15855,0,1,'314 Config - Terminais',646,'PERM_CONFIG_TEC_TERMINALS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15856,0,1,'315 Config - Dispositivos',647,'PERM_CONFIG_TEC_HARDWARE',4,'SALESMAN_LEVEL_PERMISSIONS'),(15857,0,1,'316 Config - Impressoras',648,'PERM_CONFIG_TEC_PRINT_ZONES',4,'SALESMAN_LEVEL_PERMISSIONS'),(15858,0,1,'317 Config - Permisses',840,'PERM_CONFIG_TEC_SALESMAN_LEVEL',4,'SALESMAN_LEVEL_PERMISSIONS'),(15859,0,1,'318 Config - Cabealhos/Rodaps',841,'PERM_CONFIG_TEC_DOC_PARTS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15860,0,1,'319 Config - Licenciamento',1151,'PERM_CONFIG_TEC_LICENSES',4,'SALESMAN_LEVEL_PERMISSIONS'),(15861,0,1,'207 Gesto - Tem acesso ao ecr de plugins',1268,'PERM_CONFIG_TEC_PLUGINS',4,'SALESMAN_LEVEL_PERMISSIONS'),(15862,0,1,'320 Config - Numerao Doc.',1220,'PERM_CONFIG_TEC_LICENSES',4,'SALESMAN_LEVEL_PERMISSIONS'),(15864,0,3,'100 Vendas - acede a vendas de outros vendedores',601,'PERM_SALESMAN_CAN_ENTER_OTHERS_TABLES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15865,0,3,'101 Vendas - Abre Gaveta',602,'PERM_SALESMAN_CAN_OPEN_DRAWER',3,'SALESMAN_LEVEL_PERMISSIONS'),(15866,0,3,'102 Vendas - Cancela Pedidos',603,'PERM_SALESMAN_CAN_CANCEL_ORDERS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15867,0,3,'103 Vendas - Anulaes',604,'PERM_SALESMAN_CAN_VOID_ORDERS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15868,0,3,'104 Vendas -  Devolues',605,'PERM_SALESMAN_CAN_REFUND',3,'SALESMAN_LEVEL_PERMISSIONS'),(15869,0,3,'105 Vendas - Imprime apenas 1 subtotal',606,'PERM_SALESMAN_CAN_ONLY_PRINT_ONE_SUBTOTAL',3,'SALESMAN_LEVEL_PERMISSIONS'),(15870,0,3,'106 Vendas - Transferncias',607,'PERM_SALESMAN_CAN_TRANSFER_ITEMS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15871,0,3,'107 Vendas - Factura mltipla e parcial',608,'PERM_SALESMAN_MULTIPLE_PARCIAL_RECEIPT',3,'SALESMAN_LEVEL_PERMISSIONS'),(15872,0,3,'108 Vendas - Consulta registos',609,'PERM_SALESMAN_CAN_ACCESS_HISTORY',3,'SALESMAN_LEVEL_PERMISSIONS'),(15873,0,3,'109 Vendas - Fecha venda',610,'PERM_SALESMAN_CAN_CLOSE_TABLE',3,'SALESMAN_LEVEL_PERMISSIONS'),(15874,0,3,'110 Vendas - Altera preo',611,'PERM_SALESMAN_CAN_CHANGE_PRICE',3,'SALESMAN_LEVEL_PERMISSIONS'),(15875,0,3,'111 Vendas - Venda acima do limite mximo',612,'PERM_SALESMAN_ABOVE_LIMIT',3,'SALESMAN_LEVEL_PERMISSIONS'),(15876,0,3,'112 Vendas - Descontos',1052,NULL,3,'TABLE EDIT'),(15877,0,3,'113 Vendas - Fecha vendas abertas ( consulta )',1053,NULL,3,'OPENTABLES'),(15878,0,3,'114 Vendas - Abrir gaveta ao fechar a venda',1544,'PERM_SALESMAN_OPEN_DRAWER_ON_TABLE_CLOSE',3,'SALESMAN_LEVEL_PERMISSIONS'),(15879,0,3,'115 Vendas - Acede a consumo prprio de outros empregados',1571,'PERM_SALESMAN_ENTER_OTHERS_EXPENDITURE_TABLES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15880,0,3,'116 Vendas - Adiciona ofertas alm do limite',1655,'PERM_SALESMAN_CAN_OFFER_ABOVE_LIMIT',3,'SALESMAN_LEVEL_PERMISSIONS'),(15881,0,1,'117 Vendas - Pode emitir notas de crdito',1808,'PERM_SALESMAN_CAN_ISSUE_CREDIT_NOTES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15882,0,3,'200 Gesto - Abre Sesses',614,'PERM_SESSIONS_OPEN_SESSION',3,'SALESMAN_LEVEL_PERMISSIONS'),(15883,0,3,'201 Gesto - Fecha Sesses',615,'PERM_SESSIONS_CLOSE_SESSION',3,'SALESMAN_LEVEL_PERMISSIONS'),(15885,0,3,'203 Gesto - Abrir Caixa',617,'PERM_SESSIONS_OPEN_CASHDRAWER',3,'SALESMAN_LEVEL_PERMISSIONS'),(15886,0,3,'204 Gesto - Fechar Caixa',1062,'PERM_SESSIONS_CLOSE_CASHDRAWER',3,'SALESMAN_LEVEL_PERMISSIONS'),(15887,0,3,'205 Gesto - Entradas Caixa',1063,'PERM_SESSIONS_CASHDRAWER_IN',3,'SALESMAN_LEVEL_PERMISSIONS'),(15888,0,3,'206 Gesto - Sadas Caixa',1064,'PERM_SESSIONS_CASHDRAWER_OUT',3,'SALESMAN_LEVEL_PERMISSIONS'),(15889,0,3,'207 Gesto - Pagamento Conta Corrente',1065,'PERM_SESSIONS_CC',3,'SALESMAN_LEVEL_PERMISSIONS'),(15890,0,3,'208 Gesto - Mesas abertas',1066,'PERM_SESSIONS_OPEN_TABLES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15891,0,3,'209 Gesto - Fecho Dia',1067,'PERM_SESSIONS_CLOSE_DAY',3,'SALESMAN_LEVEL_PERMISSIONS'),(15892,0,3,'210 Gesto - Consulta Registos',1068,'PERM_SESSIONS_DAILY_JOURNAL',3,'SALESMAN_LEVEL_PERMISSIONS'),(15893,0,3,'211 Gesto - Consulta de caixa',1069,'PERM_SESSIONS_CASHDRAWER_MOVEMENTS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15894,0,3,'212 Gesto - Consulta de Sesses',1716,'PERM_SESSION_CAN_SEE_SESSIONS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15895,0,3,'213 Gesto - Relatrios',1070,'PERM_SESSIONS_REPORTS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15896,0,3,'214 Gesto - SAFT',1071,'PERM_SESSIONS_SAFT',3,'SALESMAN_LEVEL_PERMISSIONS'),(15897,0,3,'215 Gesto - Perfis',1072,'PERM_SESSIONS_PROFILES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15898,0,3,'216 Gesto - Impressoras SOS',1715,'PERM_SESSION_CAN_SET_BACKUP_PRINTERS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15899,0,3,'300 Config - Ver Artigos',618,'PERM_CONFIG_SEE_ITEMS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15900,0,3,'301 Config - Edio Artigos',619,'PERM_CONFIG_EDIT_ITEMS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15901,0,3,'302 Config - Ver Empregados',620,'PERM_CONFIG_SEE_SALESMANS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15902,0,3,'303 Config - Edio Empregados',621,'PERM_PERM_CONFIG_EDIT_SALESMANS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15903,0,3,'304 Config - Ver Famlias/Pg. Rpidas',622,'PERM_CONFIG_SEE_FAMILIES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15904,0,3,'305 Config - Edio Famlias/Pg. Rpidas',623,'PERM_CONFIG_EDIT_FAMILIES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15905,0,3,'308 Config - Ver Formas Pagamento',626,'PERM_CONFIG_SEE_PAYMENT_TYPES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15906,0,3,'309 Config - Edio Formas Pagamento',627,'PERM_CONFIG_EDIT_PAYMENT_TYPES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15907,0,3,'310 Config - Ver Zonas',628,'PERM_CONFIG_SEE_ZONES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15908,0,3,'311 Config - Edio Zonas',629,'PERM_CONFIG_EDIT_ZONES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15909,0,3,'312 Config - Ver Clientes',630,'PERM_CONFIG_SEE_CUSTOMERS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15910,0,3,'313 Config - Edio Clientes',631,'PERM_CONFIG_EDIT_CUSTOMERS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15911,0,3,'314 Config - Ver Taxas IVA',632,'PERM_CONFIG_SEE_TAXES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15912,0,3,'315 Config - Edio Taxas IVA',633,'PERM_CONFIG_EDIT_TAXES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15913,0,3,'316 Config - Ver Caixas',634,'PERM_CONFIG_SEE_CASHDRAWERS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15914,0,3,'317 Config - Edio Caixas',635,'PERM_CONFIG_EDIT_CASHDRAWERS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15915,0,3,'318 Config - Ver Grupos Clientes',636,'PERM_CONFIG_SEE_CUSTOMER_GROUPS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15916,0,3,'319 Config - Edio Grupos Clientes',637,'PERM_CONFIG_EDIT_CUSTOMER_GROUPS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15917,0,3,'320 Config - Ver Nomes Mesas',640,'PERM_CONFIG_SEE_TABLE_NAMES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15918,0,3,'321 Config - Edio Nomes Mesas',641,'PERM_CONFIG_EDIT_TABLE_NAMES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15919,0,3,'400 Tcnico - Perfis',642,'PERM_CONFIG_TEC_PROFILES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15920,0,3,'401 Tcnico - Tipos Documento',643,'PERM_CONFIG_TEC_DOC_TYPES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15921,0,3,'402 Tcnico - Sistema',644,'PERM_CONFIG_TEC_SYSTEM',3,'SALESMAN_LEVEL_PERMISSIONS'),(15922,0,3,'403 Tcnico - Excluses',645,'PERM_CONFIG_TEC_EXCLUSIONS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15923,0,3,'404 Tcnico - Terminais',646,'PERM_CONFIG_TEC_TERMINALS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15924,0,3,'405 Tcnico - Dispositivos',647,'PERM_CONFIG_TEC_HARDWARE',3,'SALESMAN_LEVEL_PERMISSIONS'),(15925,0,3,'406 Tcnico - Impressoras',648,'PERM_CONFIG_TEC_PRINT_ZONES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15926,0,3,'407 Tcnico - Linguagens',649,'PERM_CONFIG_TEC_LANGUAGES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15927,0,3,'407 Tcnico - Permisses',840,'PERM_CONFIG_TEC_SALESMAN_LEVEL',3,'SALESMAN_LEVEL_PERMISSIONS'),(15928,0,3,'408 Tcnico - Cabealhos/Rodaps',841,'PERM_CONFIG_TEC_DOC_PARTS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15929,0,3,'409 Tcnico - Pode abrir/fechar sesses de outros',927,'PERM_CAN_MANAGE_OTHERS_SESSIONS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15930,0,3,'410 Tcnico - Terminais Rdio',1150,'PERM_CONFIG_TEC_RADIO',3,'SALESMAN_LEVEL_PERMISSIONS'),(15931,0,3,'411 Tcnico - Licenciamento',1151,'PERM_CONFIG_TEC_LICENSES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15932,0,3,'217 Gesto - Tem acesso ao ecr de plugins',1268,'PERM_CONFIG_TEC_PLUGINS',3,'SALESMAN_LEVEL_PERMISSIONS'),(15933,0,3,'413 Tcnico - Numerao Doc.',1220,'PERM_CONFIG_TEC_LICENSES',3,'SALESMAN_LEVEL_PERMISSIONS'),(15935,0,1,'Mesas abertas',508,'OpenTablesWindow',1,'SCREEN_CONFIG_OPEN_TABLES'),(15936,0,1,'Cartes abertas',508,'OpenTablesWindow',2,'SCREEN_CONFIG_OPEN_TABLES'),(15938,0,1,'Documentos suspensos',508,'OpenTablesWindow',4,'SCREEN_CONFIG_OPEN_TABLES'),(15939,0,1,'Fecha e Imprime',278,'TableCloseInvoice',1,'SCREEN_TABLE_CLOSE'),(15940,0,1,'Fecha e Imprime',278,'TableCloseInvoice',2,'SCREEN_TABLE_CLOSE'),(15941,0,1,'n de vias',875,'NumDocsToPrint',1,'SCREEN_CONFIG_TERMINALS'),(15942,0,1,'Data (YYYY-MM-DD)',1117,'ManualDocDate',1,'SCREEN_PROMPT_MANUAL_DOCUMENT'),(15943,0,1,'Vendas',508,'OpenTablesWindow',3,'SCREEN_CONFIG_OPEN_TABLES_RETAIL'),(15944,0,1,'Fechar',870,'OpenTablesBtnCloseTable',3,'SCREEN_CONFIG_OPEN_TABLES'),(15945,0,1,'Fechar tudo',872,'OpenTablesBtnCloseAllTables',3,'SCREEN_CONFIG_OPEN_TABLES_RETAIL'),(15946,0,1,'Vendas em aberto',1225,'Vendas em aberto',3,'SCREEN_CONFIG_OPEN_TABLES_RETAIL'),(15947,0,1,'Vendas efectuadas',1662,'TablesCountClosed',3,'SCREEN_CONFIG_OPEN_TABLES_RETAIL'),(15948,0,1,'A pagar',263,'TableCloseTotalTable',1,'SCREEN_TABLE_CLOSE'),(15949,0,1,'Parabns!\n\nCompletou o licenciamento do seu %s!',1261,'LicensingWizardLabel',1,'SCREEN_LICENSING_WIZARD'),(15950,0,1,'123 Vendas - Pode emitir notas de crdito',1808,'PERM_SALESMAN_CAN_ISSUE_CREDIT_NOTES',1,'SALESMAN_LEVEL_PERMISSIONS'),(15951,0,1,'Ecr de mesa defeito',1690,'TableEditScreenToUse',1,'SCREEN_CONFIG_TERMINALS'),(15952,0,1,'Ecr de pagamento defeito',1689,'TableCloseScreenToUse',1,'SCREEN_CONFIG_TERMINALS'),(15953,0,1,'Sai da ecr de registo depois de fechar a conta',1147,'ST_AFTER_CLOSE_TABLE_GOTO_SALESMAN_SELECTION',1,'ST_AFTER_CLOSE_TABLE_GOTO_SALESMAN_SELECTION'),(15954,0,1,'Verifica contas no fecho',672,'check_open_tables_on_close',1,'GENERAL_CONFIG'),(15955,0,1,'Imprimir Sub-Total no fecho de conta',728,'ST_PRINT_SUB_TOTAL_ON_CLOSE',1,'SALES_TERMINAL_PROPERTIES'),(15956,0,1,'Forar pedido no fecho de conta',748,'ST_FORCE_ORDER_TO_EXIT_TABLE',1,'SALES_TERMINAL_PROPERTIES'),(15957,0,1,'Fecho de conta',1317,'MSG_BOX_TITLE',1,'MSG_BOX_TITLE'),(15958,0,1,'Fecho de conta - %s - %s',1492,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(15959,0,1,'Para fechar esta conta  necessrio identificar o cliente.\n\nPor favor identifique um cliente e feche esta conta no ecr de fecho de contas',1722,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_OPEN_TABLES'),(15960,0,1,'Venda',1747,'TableEditRetailWindow',1,'SCREEN_TABLE_EDIT_RETAIL'),(15961,0,1,'Vendas',1809,'ZONE_SUSPENDED_TABLES',1,'ZONE_SUSPENDED_TABLES'),(15962,0,1,'Guias',1810,'ZONE_GUIAS',1,'ZONE_GUIAS'),(15963,0,1,'O limite de mesas para cada zona  de 5000',1811,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_ZONES'),(15964,0,1,'Est a definir esta zona para importao de documentos em papel!\n\nQuando entrar em alguma mesa desta zona ser-lhe- perguntado o nmero do documento e a srie.',1812,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_ZONES'),(15965,0,1,'A zona - %s - j tem este cdigo!\n\nUm novo cdigo vai ser sugerido',1813,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_ZONES'),(15967,0,1,'Para poder fechar esta venda precisa de ter definido um mtodo de pagamento do tipo Facturao externa. Por favor crie um em Config->Tabelas->Formas pagamento',1815,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(15968,0,1,'Para facturas acima de 1000 o cliente tem que estar identificado com nome e morada. Por favor corrija a ficha deste cliente para o poder utilizar neste caso',1816,'MSG_BOX_TEXT',1,'SCREEN_TABLE_CLOSE'),(15969,0,1,'Usa nome curto (artigo) nas listas',1817,'ConfigProperty',1,'ConfigProperty'),(15970,0,1,'Mostra valor total do menu',1818,'ConfigProperty',1,'ConfigProperty'),(15971,0,1,'Permite reactivar cartes (disco)',1819,'ConfigProperty',1,'ConfigProperty'),(15972,0,1,'Recalcula menus/ofertas',1820,'ConfigProperty',1,'ConfigProperty'),(15973,0,1,'Aplica desconto a artigos compensao',1821,'ConfigProperty',1,'ConfigProperty'),(15974,0,1,'Tipo',1822,'ZoneType',1,'SCREEN_CONFIG_ZONES_RET_SERV'),(15975,0,1,'Vendas',1823,'ZoneTypeStr',1,'SCREEN_CONFIG_ZONES_RET_SERV'),(15976,0,1,'Documentos manuais',1824,'ZoneTypeStr',1,'SCREEN_CONFIG_ZONES_RET_SERV'),(15977,0,1,'Guias de transporte',1825,'ZoneTypeStr',1,'SCREEN_CONFIG_ZONES_RET_SERV'),(15978,0,1,'Doc. Manuais',1826,'ZONE_MANUAL_DOCS',1,'ZONE_MANUAL_DOCS'),(15979,0,1,'Nova venda',1827,'NEW_SALE_TABLE_ID',1,'NEW_SALE_TABLE_ID'),(15980,0,1,'Nova guia',1828,'NEW_GUIA_TABLE_ID',1,'NEW_GUIA_TABLE_ID'),(15981,0,1,'Novo doc. manual',1829,'NEW_DOC_MANUAL_TABLE_ID',1,'NEW_DOC_MANUAL_TABLE_ID'),(15982,0,1,'Guia de transporte',1830,'TableEditRetailGuiaWindow',1,'SCREEN_TABLE_EDIT_RETAIL_GUIAS'),(15983,0,1,'Emitir Guia',1831,'TableEditEmitGuia',1,'SCREEN_TABLE_EDIT_RETAIL_GUIAS'),(15984,0,1,'No pode anular documentos de dias anteriores! Se pretender pode efectuar uma nota de crdito do documento desejado.',1832,'MSG_BOX_TEXT',1,'SCREEN_DAILY_JOURNAL'),(15985,0,1,'202 Sesses - Sair do GesRestII',616,'PERM_SESSIONS_CLOSE_APP',1,'SALESMAN_LEVEL_PERMISSIONS'),(15986,0,1,'202 Sesses - Sair do GesRestII',616,'PERM_SESSIONS_CLOSE_APP',2,'SALESMAN_LEVEL_PERMISSIONS'),(15987,0,3,'202 Gesto - Sair da aplicao',616,'PERM_SESSIONS_CLOSE_APP',3,'SALESMAN_LEVEL_PERMISSIONS'),(15988,0,1,'200 Gesto - Sair da aplicao',616,'PERM_SESSIONS_CLOSE_APP',4,'SALESMAN_LEVEL_PERMISSIONS'),(15989,0,1,'As alteraes efectuadas (se efectuou algumas), s tero efeito aps reiniciar a aplicao',1454,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_QUICK_PAGES'),(15991,0,1,'No foi possvel adicionar artigo  conta',11,NULL,3,''),(15992,0,1,'No foi possvel adicionar artigo  conta',1291,'MSG_BOX_TEXT',3,'MSG_BOX_TEXT'),(15993,0,1,'No foi possvel adicionar artigo  conta',1370,'MSG_BOX_TEXT',3,'MSG_BOX_TEXT'),(15994,0,1,'Aviso|Ainda tem contas abertas!\n\nPor favor feche ou transfira as suas contas para fechar a sua sesso',1154,'MSG_BOX_MESSAGE',3,'MSG_BOX_MESSAGE'),(15995,0,1,'Tem certeza que quer fechar todas as contas da lista?',1425,'MSG_BOX_TEXT',3,'SCREEN_CONFIG_OPEN_TABLES'),(15996,0,1,'No foi possvel fechar todas as contas abertas!\n\nPara contas com valor superior a 1000  necessrio identificar o cliente da factura. Por favor identifique o cliente para a(s) conta(s) abertas e feche-as normalmente.',1723,'MSG_BOX_TEXT',3,'SCREEN_CONFIG_OPEN_TABLES'),(15997,0,1,'No foi possvel adicionar artigo  conta',11,NULL,4,''),(15998,0,1,'No foi possvel adicionar artigo  conta',1291,'MSG_BOX_TEXT',4,'MSG_BOX_TEXT'),(15999,0,1,'No foi possvel adicionar artigo  conta',1370,'MSG_BOX_TEXT',4,'MSG_BOX_TEXT'),(16000,0,1,'Aviso|Ainda tem contas abertas!\n\nPor favor feche ou transfira as suas contas para fechar a sua sesso',1154,'MSG_BOX_MESSAGE',4,'MSG_BOX_MESSAGE'),(16001,0,1,'Tem certeza que quer fechar todas as contas da lista?',1425,'MSG_BOX_TEXT',4,'SCREEN_CONFIG_OPEN_TABLES'),(16002,0,1,'No foi possvel fechar todas as contas abertas!\n\nPara contas com valor superior a 1000  necessrio identificar o cliente da factura. Por favor identifique o cliente para a(s) conta(s) abertas e feche-as normalmente.',1723,'MSG_BOX_TEXT',4,'SCREEN_CONFIG_OPEN_TABLES'),(16003,0,1,'Total:',661,'PRINT_DOCUMENT',1,'PRINT_DOCUMENT'),(16004,0,1,'Valor liquido:',660,'PRINT_DOCUMENT',1,'PRINT_DOCUMENT'),(16005,0,1,'Desconto:',658,'PRINT_DOCUMENT',1,'PRINT_DOCUMENT'),(16006,0,1,'S/ Desconto:',657,'PRINT_DOCUMENT',1,'PRINT_DOCUMENT'),(16009,0,1,'Existem clientes com nomes vazios e nmeros de contribuinte invlidos. No ficheiro backend/export/saft_log.txt poder encontrar mais informao.\r\n\r\nOs clientes em falta vo ser corrigidos automaticamentete!',1833,'MSG_BOX_TEXT',1,'SCREEN_SAFT'),(16010,0,1,'Desc. global:',1834,'PRINT_DOCUMENT',1,'PRINT_DOCUMENT'),(16011,0,1,'Por favor seleccione um ficheiro para analisar',1835,'MSG_BOX_TEXT',1,'SCREEN_SAFT'),(16012,0,1,'artigos na conta',17,NULL,3,''),(16013,0,1,'Conta',46,NULL,3,''),(16014,0,1,'Total',59,NULL,3,''),(16015,0,1,'Contas',60,NULL,3,''),(16016,0,1,'Total Conta',77,NULL,3,''),(16017,0,1,'Conta no encontrada',94,NULL,3,''),(16018,0,1,'Esta conta j est aberta noutro posto!',107,NULL,3,' '),(16019,0,1,'Aviso|No possui permisses para aceder a vendas de outros empregados.',859,NULL,3,NULL),(16020,0,1,'Aviso|Pretende transferir esta(s) conta(s) para ',881,'OpenTablesMsgBox',3,'SCREEN_CONFIG_OPEN_TABLES'),(16021,0,1,'Erro|No foi possvel guardar alteraes  conta!',885,'OpenTablesErrorMsgBox',3,'SCREEN_CONFIG_OPEN_TABLES'),(16022,0,1,'Aviso|Pretende transferir todas as contas?',886,'OoenTablesMessageBox2',3,'SCREEN_CONFIG_OPEN_TABLES'),(16023,0,1,'No foi possvel carregar a venda:',994,'LoadTable',3,'ScreenTableEdit'),(16025,0,1,'No foi possvel fechar conta',1292,'MSG_BOX_TEXT',3,'MSG_BOX_TEXT'),(16026,0,1,'No pode efectuar esta operao nesta conta.',1320,'MSG_BOX_TEXT',3,'MSG_BOX_TEXT'),(16027,0,1,'No tem permisso para entrar nesta conta',1363,'MSG_BOX_TEXT',3,'MSG_BOX_TEXT'),(16028,0,1,'No consegui fazer lock  transao!',1364,'MSG_BOX_TEXT',3,'MSG_BOX_TEXT'),(16029,0,1,'Esta conta j est aberta noutro posto!',1365,'MSG_BOX_TEXT',3,'MSG_BOX_TEXT'),(16030,0,1,'Conta invlida!',1366,'MSG_BOX_TEXT',3,'MSG_BOX_TEXT'),(16031,0,1,'No foi possvel obter os detalhes da conta',1367,'MSG_BOX_TEXT',3,'MSG_BOX_TEXT'),(16032,0,1,'Conta vazia',1369,'MSG_BOX_TEXT',3,'MSG_BOX_TEXT'),(16033,0,1,'No consegui obter conta!',1372,'MSG_BOX_TEXT',3,'MSG_BOX_TEXT'),(16034,0,1,'Esta conta est fora do seu intervalo de contas!',1375,'MSG_BOX_TEXT',3,'MSG_BOX_TEXT'),(16035,0,1,'No pode efectuar esta operao nas contas das zona de consumo prprio.\n\nA conta ser fechada quando fechar a sua sesso.',1413,'MSG_BOX_TEXT',3,'SCREEN_TABLE_EDIT'),(16036,0,1,'Esta conta no est na lista',1421,'MSG_BOX_TEXT',3,'SCREEN_CONFIG_OPEN_TABLES'),(16037,0,1,'No possui permisses para aceder a contas de outros empregados.',1426,'MSG_BOX_TEXT',3,'SCREEN_CONFIG_OPEN_TABLES'),(16038,0,1,'Esta conta est em uso pela aplicao',1441,'MSG_BOX_TEXT',3,'SCREEN_TABLE_EDIT'),(16039,0,1,'Erro ao carregar os artigos da conta %i',1479,'MSG_BOX_TEXT',3,'SCREEN_TABLE_EDIT'),(16040,0,1,'A conta j est aberta noutro posto!',1481,'MSG_BOX_TEXT',3,'SCREEN_TABLE_EDIT'),(16041,0,1,'No foi possvel bloquear a conta para uso!',1482,'MSG_BOX_TEXT',3,'SCREEN_TABLE_EDIT'),(16042,0,1,'No  possvel desbloquear esta conta',1520,'ErrorStr',3,'TABLE_CANT_UNLOCK'),(16043,0,1,'No foi possvel adicionar artigo.\n\nS pode ter um artigo do tipo compensao na conta!',1537,'TABLE_CANT_ADD_MORE_COMPENSATION',3,'TABLE_CANT_ADD_MORE_COMPENSATION'),(16044,0,1,'Conta no reconhecida!',1669,'MSG_BOX_TEXT',3,'SCREEN_TABLE_EDIT'),(16045,0,1,'No foi possvel fechar algumas vendas.\n\n.Se forem vendas da zona de importao de documentos manuais, deve fecha-las normalmente!',1724,'MSG_BOX_TEXT',3,'SCREEN_CONFIG_OPEN_TABLES'),(16046,0,1,'artigos na conta',17,NULL,4,''),(16047,0,1,'Conta',46,NULL,4,''),(16048,0,1,'Total',59,NULL,4,''),(16049,0,1,'Contas',60,NULL,4,''),(16050,0,1,'Total Conta',77,NULL,4,''),(16051,0,1,'Conta no encontrada',94,NULL,4,''),(16052,0,1,'Esta conta j est aberta noutro posto!',107,NULL,4,' '),(16053,0,1,'Aviso|No possui permisses para aceder a vendas de outros empregados.',859,NULL,4,NULL),(16054,0,1,'Aviso|Pretende transferir esta(s) conta(s) para ',881,'OpenTablesMsgBox',4,'SCREEN_CONFIG_OPEN_TABLES'),(16055,0,1,'Erro|No foi possvel guardar alteraes  conta!',885,'OpenTablesErrorMsgBox',4,'SCREEN_CONFIG_OPEN_TABLES'),(16056,0,1,'Aviso|Pretende transferir todas as contas?',886,'OoenTablesMessageBox2',4,'SCREEN_CONFIG_OPEN_TABLES'),(16057,0,1,'No foi possvel carregar a venda:',994,'LoadTable',4,'ScreenTableEdit'),(16059,0,1,'No foi possvel fechar conta',1292,'MSG_BOX_TEXT',4,'MSG_BOX_TEXT'),(16060,0,1,'No pode efectuar esta operao nesta conta.',1320,'MSG_BOX_TEXT',4,'MSG_BOX_TEXT'),(16061,0,1,'No tem permisso para entrar nesta conta',1363,'MSG_BOX_TEXT',4,'MSG_BOX_TEXT'),(16062,0,1,'No consegui fazer lock  transao!',1364,'MSG_BOX_TEXT',4,'MSG_BOX_TEXT'),(16063,0,1,'Esta conta j est aberta noutro posto!',1365,'MSG_BOX_TEXT',4,'MSG_BOX_TEXT'),(16064,0,1,'Conta invlida!',1366,'MSG_BOX_TEXT',4,'MSG_BOX_TEXT'),(16065,0,1,'No foi possvel obter os detalhes da conta',1367,'MSG_BOX_TEXT',4,'MSG_BOX_TEXT'),(16066,0,1,'Conta vazia',1369,'MSG_BOX_TEXT',4,'MSG_BOX_TEXT'),(16067,0,1,'No consegui obter conta!',1372,'MSG_BOX_TEXT',4,'MSG_BOX_TEXT'),(16068,0,1,'Esta conta est fora do seu intervalo de contas!',1375,'MSG_BOX_TEXT',4,'MSG_BOX_TEXT'),(16069,0,1,'No pode efectuar esta operao nas contas das zona de consumo prprio.\n\nA conta ser fechada quando fechar a sua sesso.',1413,'MSG_BOX_TEXT',4,'SCREEN_TABLE_EDIT'),(16070,0,1,'Esta conta no est na lista',1421,'MSG_BOX_TEXT',4,'SCREEN_CONFIG_OPEN_TABLES'),(16071,0,1,'No possui permisses para aceder a contas de outros empregados.',1426,'MSG_BOX_TEXT',4,'SCREEN_CONFIG_OPEN_TABLES'),(16072,0,1,'Esta conta est em uso pela aplicao',1441,'MSG_BOX_TEXT',4,'SCREEN_TABLE_EDIT'),(16073,0,1,'Erro ao carregar os artigos da conta %i',1479,'MSG_BOX_TEXT',4,'SCREEN_TABLE_EDIT'),(16074,0,1,'A conta j est aberta noutro posto!',1481,'MSG_BOX_TEXT',4,'SCREEN_TABLE_EDIT'),(16075,0,1,'No foi possvel bloquear a conta para uso!',1482,'MSG_BOX_TEXT',4,'SCREEN_TABLE_EDIT'),(16076,0,1,'No  possvel desbloquear esta conta',1520,'ErrorStr',4,'TABLE_CANT_UNLOCK'),(16077,0,1,'No foi possvel adicionar artigo.\n\nS pode ter um artigo do tipo compensao na conta!',1537,'TABLE_CANT_ADD_MORE_COMPENSATION',4,'TABLE_CANT_ADD_MORE_COMPENSATION'),(16078,0,1,'Conta no reconhecida!',1669,'MSG_BOX_TEXT',4,'SCREEN_TABLE_EDIT'),(16079,0,1,'No foi possvel fechar algumas vendas.\n\n.Se forem vendas da zona de importao de documentos manuais, deve fecha-las normalmente!',1724,'MSG_BOX_TEXT',4,'SCREEN_CONFIG_OPEN_TABLES'),(16080,0,1,'No  possvel obter os artigos!',13,NULL,1,''),(16081,0,1,'No foi possvel actualizar o artigo',71,NULL,1,''),(16082,0,1,'Erro ao adicionar artigo  conta',106,NULL,1,' '),(16083,0,1,'Total Doc.',529,'DailyJournalInvoiceTotal',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16084,0,1,'Imprimir Doc.',535,'DailyJournalBtnPrintInvoice',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16085,0,1,'Pedir ao sair do ecr de venda',734,'ST_ORDER_ON_TABLE_EXIT',1,'SALES_TERMINAL_PROPERTIES'),(16086,0,1,'Pode fechar vendas',737,'ST_CAN_CLOSE_TABLES',1,'SALES_TERMINAL_PROPERTIES'),(16087,0,1,'Erro ao carregar os artigos (Header) %i',1480,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(16088,0,1,'Ao carregar uma transao no podemos ter mais do que um cabealho',1485,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(16089,0,1,'No foram encontrados mtodos de pagamento para fechar esta conta!',1542,'MSG_BOX_TEXT',1,'TABLE_HAS_NO_TENDERS_TO_SAVE'),(16090,0,1,'No tem permisso para aceder ao consumo prprio de outros empregados!',1573,'MSG_BOX_TEXT',1,'CANT_ACCESS_OTHERS_SELF_EXPENDITURE_TABLE'),(16091,0,1,'Por favor identifique um cliente para poder efectuar esta operao',1721,'MSG_BOX_TEXT',1,'SCREEN_TABLE_CLOSE'),(16092,0,1,'Carto de destino:',1494,'MSG_BOX_TEXT',2,'SCREEN_TABLE_PRODUCT_TRANSF'),(16093,0,1,'Ficheiros SAF-T existentes',1836,'SAFTListLabel',1,'SCREEN_SAFT'),(16097,0,1,'Desc. global:',654,'PRINT_DOCUMENT',1,'PRINT_DOCUMENT'),(16098,0,1,'Desconto:',653,'PRINT_DOCUMENT',1,'PRINT_DOCUMENT'),(16099,0,1,'S/ Desconto:',652,'PRINT_DOCUMENT',1,'PRINT_DOCUMENT'),(16100,0,1,'----------------------------------------',1547,'PRINTER_TEXT',1,'PRINTER_TEXT'),(16101,0,1,'----------------------------------------',1546,'PRINTER_TEXT',1,'PRINTER_TEXT'),(16102,0,1,'',1729,'TableCloseDocType',1,'SCREEN_TABLE_CLOSE'),(16103,0,1,'Abrir Sesso',563,'OpenSessionWindow',1,'SCREEN_SESSION_OPEN'),(16104,0,1,'',590,'AppRemOne',1,'SCREEN_TABLE_CHECK_SPLIT'),(16105,0,1,'',592,'AppAddOne',1,'SCREEN_TABLE_CHECK_SPLIT'),(16106,0,1,'Artigo',1841,'ItemSelectionSearch',1,'SCREEN_ITEM_SEARCH'),(16107,0,1,'No existe nenhum artigo que corresponda a esta pesquisa!',1842,'MSG_BOX_TEXT',1,'SCREEN_ITEM_SEARCH'),(16108,0,1,'Fechar directo',1536,'Fechar directo',1,'SCREEN_TABLE_EDIT'),(16109,0,1,'Pagar dinheiro',1536,'Fechar directo',3,'SCREEN_TABLE_EDIT_RETAIL'),(16110,0,1,'Fecho a crdito',1750,'TableEditCloseCredit',1,'SCREEN_TABLE_EDIT_RETAIL'),(16111,0,1,'Pagar c/ Desconto',1751,'TableEditCloseWithDiscount',1,'SCREEN_TABLE_EDIT_RETAIL'),(16112,0,1,' ',972,'ItemSubFamilySearch',1,'SCREEN_CONFIG_ITEMS'),(16113,0,1,' ',1728,'TableEditSwitchTab',1,'SCREEN_TABLE_EDIT'),(16114,0,1,'Pede nome da mesa ao sair do ecr de venda',1843,'ask_table_name_on_exit',1,'SCREEN_CONFIG_ZONES'),(16115,0,1,'Pede nome da transao ao sair do ecr de venda',1843,'ask_table_name_on_exit',3,'SCREEN_CONFIG_ZONES'),(16116,0,1,'',591,'AppRemAll',1,'SCREEN_TABLE_CHECK_SPLIT'),(16117,0,1,'',757,'AppRemAllList',1,'SCREEN_TABLE_PRODUCT_TRANSF'),(16118,0,1,'',593,'AppAddAll',1,'SCREEN_TABLE_CHECK_SPLIT'),(16119,0,1,'',758,'AppAddAllList',1,'SCREEN_TABLE_PRODUCT_TRANSF'),(16120,0,1,'',967,'AppPreviousSymbol',1,'SCREEN_TABLE_EDIT'),(16121,0,1,'',1247,'Previous',1,'SCREEN_LICENSING_WIZARD'),(16122,0,1,'',966,'AppNextSymbol',1,'SCREEN_TABLE_EDIT'),(16123,0,1,'',1246,'Next',1,'SCREEN_LICENSING_WIZARD'),(16124,0,1,'Pagar',253,'TableEditCloseTable',3,'SCREEN_TABLE_EDIT_RETAIL'),(16257,0,1,'Data Final',1845,'SaftDateTo',1,'SCREEN_SAFT'),(16258,0,1,'Data Inicial',1844,'SaftDateFrom',1,'SCREEN_SAFT'),(16259,0,1,'Gerar SAFT Simplificado 1.02',1847,'CashDrawerCloseBtnSaftSimplified102',1,'SCREEN_SAFT'),(16260,0,1,'Gerar SAFT 1.02',1846,'CashDrawerCloseBtnSaft102',1,'SCREEN_SAFT'),(16261,0,1,'Gerar Saft 1.01',933,'CashDrawerCloseBtnSaft',1,'SCREEN_SAFT'),(16262,0,1,'Gerar Saft Simplificado 1.01',1732,'CashDrawerCloseBtnSaftSimplified',1,'SCREEN_SAFT'),(16263,0,1,'Hora Carga',1848,'TableEditCargoTime',1,'SCREEN_TABLE_EDIT_RETAIL_GUIAS'),(16264,0,1,'Hora Descarga',1849,'TableEditDropOffTime',1,'SCREEN_TABLE_EDIT_RETAIL_GUIAS'),(16265,0,1,'Matrcula',1850,'TableEditTransportType',1,'SCREEN_TABLE_EDIT_RETAIL_GUIAS'),(16266,0,1,'Pedir Cdigo',1851,'TableEditAskMovWSCode',1,'SCREEN_TABLE_EDIT_RETAIL_GUIAS'),(16267,0,1,'',1852,'NoCaption',1,'GENERAL'),(16268,0,1,'Converter Guia',1853,'DailyJournalBtnGuia',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16269,0,1,'Cod.Guia',1854,'DailyJournalGuiaWsCode',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16270,0,1,'Esta funcionalidade s est disponvel para documentos do tipo Guia de Transporte',1855,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16272,0,1,'Est. Documento',1857,'DailyJournalGuiaWsState',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16273,0,1,'Esta funcionalidade s est disponvel para documentos do tipo Guia de Transporte',1858,'MSG_BOX_TEXT',1,'SCREEN_TABLE_CLOSE'),(16274,0,1,'Tem a certeza que deseja converter esta guia?',1859,'MSG_BOX_TEXT',1,'SCREEN_TABLE_CLOSE'),(16275,0,1,'No tem permisso para converter Guias',1860,'MSG_BOX_TEXT',1,'SCREEN_TABLE_CLOSE'),(16276,0,1,'Comunicao com WebService no Fecho de uma Guia',1861,'ws_on_movementOfGoods_close',1,'SCREEN_CONFIG_SYSTEM'),(16277,0,1,'Utilizador AT',1862,'SystemConfigATUser',1,'SCREEN_CONFIG_SYSTEM'),(16278,0,1,'Senha AT',1863,'SystemConfigATPwd',1,'SCREEN_CONFIG_SYSTEM'),(16282,0,1,'Tem a certeza que quer fechar esta mesa?',1491,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(16283,0,1,'Tem a certeza que quer fechar este carto?',1491,'MSG_BOX_TEXT',2,'SCREEN_TABLE_EDIT'),(16284,0,1,'Ofertas|Tem a certeza que quer adicionar todos os artigos a esta oferta?',1640,'MSGBOX_TEXT',2,'SCREEN_OFFERS_CONFIG'),(16285,0,1,'Tem a certeza que quer fechar esta venda?',1491,'MSG_BOX_TEXT',3,'SCREEN_TABLE_EDIT'),(16286,0,1,'Tem a certeza que quer fechar esta fatura?',1491,'MSG_BOX_TEXT',4,'SCREEN_TABLE_EDIT'),(16287,0,1,'A sua procura retornou mais do que 100 resultados.\n\nPor favor aplique critrios de filtragem mais restritos',1667,'MSG_BOX_TEXT',1,'SCREEN_DAILY_JOURNAL'),(16288,0,1,'V/Viatura',1840,'PARSE_HEADER',1,'TAG Meio Transporte Guia'),(16290,0,1,'Parece no ter uma licena vlida.\r\n\r\nPode registar a sua licena para este software\r\nou continuar em modo de demonstrao.',1257,'LicensingWizardLabel',1,'SCREEN_LICENSING_WIZARD'),(16291,0,1,'Est actualmente em modo demonstrativo.\r\n\r\nPode registar a sua licena \r\nou continuar em modo de demonstrao.',1263,'LicensingWizardLabel',1,'SCREEN_LICENSING_WIZARD'),(16341,0,1,'Valor liquido:',655,'PRINT_DOCUMENT',1,'PRINT_DOCUMENT'),(16342,0,1,'Total:',656,'PRINT_DOCUMENT',1,'PRINT_DOCUMENT'),(16343,0,1,'Tem a certeza que quer fechar esta Guia?',1864,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(16344,0,1,'Ser efetuada uma ligao com os servios da AT para obter o cdigo de transporte.',1865,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(16345,0,1,'Ocorreu um erro na ligao com os servios da AT. \nPor favor tente de novo.',1866,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(16346,0,1,'Doc. C/IVA Incluido',1867,'IVA_PRINT',1,'PRINT'),(16347,0,1,'Doc. S/IVA Incluido',1868,'IVA_PRINT',1,'PRINT'),(16350,0,1,'Bruto',1756,'TableEditTotalNet',1,'SCREEN_TABLE_EDIT_SERVICES'),(16351,0,1,'Lquido',1763,'TableEditTotalNet',1,'SCREEN_TABLE_EDIT_SERVICES'),(16352,0,1,'Guia de Transporte',1869,'WINDOW',1,'SCREEN_TABLE_EDIT_GUIAS'),(16353,0,1,'No pode fechar um documento com valores a negativo.',1870,'WARNING',1,'SCREEN_TABLE_CLOSE'),(16354,0,1,'Gerar SAFT Guias',1871,'CashDrawerCloseBtnGenerateGuia',1,'SCREEN_SAFT'),(16355,0,1,'Importar Resposta Guias AT',1872,'CashDrawerCloseBtnReadGuia',1,'SCREEN_SAFT'),(16356,0,1,'218 Gesto - Relatrios Fecho Caixa',1873,'PERM_REPORTS_CASHDRAWERS',1,'SALESMAN_LEVEL_PERMISSIONS'),(16357,0,1,'Lquido',1883,'TableEditTotalWithDiscount',1,'SCREEN_TABLE_EDIT_GUIAS_SERVICES'),(16358,0,1,'Guia Transporte',1882,'TableEditServicesGuiaWindow',1,'SCREEN_TABLE_EDIT_GUIAS_SERVICES'),(16359,0,1,'Guia Transporte',1881,'CounterGuia',1,'SCREEN_CONFIG_TERMINALS'),(16360,0,1,'Local Descarga',1880,'TableCloseUnloadPlace',1,'SCREEN_TABLE_CLOSE_RETAIL'),(16361,0,1,'Local Carga',1879,'TableCloseLoadPlace',1,'SCREEN_TABLE_CLOSE_RETAIL'),(16362,0,1,'Matrcula',1878,'TableCloseTransportType',1,'SCREEN_TABLE_CLOSE_RETAIL'),(16363,0,1,'Hora Descarga',1877,'TableCloseUnloadTime',1,'SCREEN_TABLE_CLOSE_RETAIL'),(16364,0,1,'Hora Carga',1876,'TableCloseLoadTime',1,'SCREEN_TABLE_CLOSE_RETAIL'),(16365,0,1,'Tipo Doc',1875,'TableEditDocType',1,'SCREEN_TABLE_EDIT_RETAIL'),(16366,0,1,'Fechar',1874,'TableEditCloseTableStandard',1,'SCREEN_TABLE_EDIT_RETAIL'),(16367,0,1,'Comunicao via SAFT no Fecho de uma Guia',1884,'saft_on_movementOfGoods_close',1,'SCREEN_CONFIG_SYSTEM'),(16368,0,1,'Ser gerado um SAFT de Guias de Transporte para submisso AT',1885,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(16370,0,1,'A obteno de cdigo de transporte falhou [Erro: %d - %s]\nDeseja prosseguir com a gravao do documento?\n\nPressione - No -  para correo dos erros.',1887,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(16371,0,1,'A data/hora de incio de carga no pode ser igual ou inferior  data/hora descarga.',1888,'MSG_BOX_TEXT',1,'SCREEN_CONFIG'),(16372,0,1,'Por favor preencha a morada de carga.',1889,'MSG_BOX_TEXT',1,'SCREEN_CONFIG'),(16373,0,1,'Por favor preencha a morada de descarga.',1890,'MSG_BOX_TEXT',1,'SCREEN_CONFIG'),(16374,0,1,'A data/hora de carga e descarga so obrigatrias.',1891,'MSG_BOX_TEXT',1,'SCREEN_CONFIG'),(16375,0,1,'Por favor prima OK quando a resposta ',1892,'MSG_BOX_TEXT',1,'SCREEN_CONFIG'),(16377,0,1,'O SAFT das Guias de Transporte foi exportado para a directoria ..\\\\backend\\\\export. Obtenha o ficheiro de resposta no site da AT e coloque-o na directoria ..\\\\backend\\\\import e prima OK',1886,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(16378,0,1,'A Guia de Transporte possui um Cdigo de Transporte. Por favor submeta esta alterao  AT!',1894,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(16379,0,1,'As datas de transporte tm de ser superiores  hora atual.',1893,'MSG_BOX_TEXT',1,'SCREEN_CONFIG'),(16380,0,1,'No pode anular esta guia. Possui cdigo de transporte e a data de incio de transporte j ocorreu!',1895,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(16381,0,1,'Documento Manual',1896,'DocumentTypeCode',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(16382,0,1,'219 Sesses - Imprime Abertura e Fecho Sesso',1897,'PERM_REPORTS_CASHDRAWERS',1,'SALESMAN_LEVEL_PERMISSIONS'),(16383,0,1,'220 Sesses - Imprime Abertura e Fecho Caixa',1898,'PERM_REPORTS_CASHDRAWERS',1,'SALESMAN_LEVEL_PERMISSIONS'),(16385,0,1,'124 Vendas - Cancela depois de SubTotal',1899,'PERM_REPORTS_CASHDRAWERS',1,'SALESMAN_LEVEL_PERMISSIONS'),(16388,0,1,'Aviso|Por favor seleccione uma mesa.',1900,'TransferMsgBox',1,'SCREEN_PRODUCT_TRANSFER'),(16389,0,1,'Aviso|Por favor seleccione um carto.',1900,'TransferMsgBox',2,'SCREEN_PRODUCT_TRANSFER'),(16390,0,1,'Promoo',1901,'TableCloseAddPomo',1,'SCREEN_TABLE_CLOSE_DISCO'),(16391,0,1,'Obter Cdigo Guia',1902,'DailyJournalWSBt',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16395,0,1,'Descarga',1908,'TableEditDropOffDateShort',1,'SCREEN_TABLE_EDIT_GUIAS_SERVICES'),(16396,0,1,'Carga',1907,'TableEditCargoDateShort',1,'SCREEN_TABLE_EDIT_GUIAS_SERVICES'),(16397,0,1,'Descarga',1906,'TableEditDropOffDate',1,'SCREEN_TABLE_EDIT_GUIAS_SERVICES'),(16398,0,1,'Carga',1905,'TableEditCargoDate',1,'SCREEN_TABLE_EDIT_GUIAS_SERVICES'),(16399,0,1,'Data Descarga',1904,'TableCloseUnloadDate',1,'SCREEN_TABLE_CLOSE_RETAIL_GUIAS'),(16400,0,1,'Data Carga',1903,'TableCloseLoadDate',1,'SCREEN_TABLE_CLOSE_RETAIL_GUIAS'),(16401,0,1,'No possui credenciais do webservice configuradas. Config->Configurao Geral',1909,'MSG',1,'MESSAGE'),(16402,0,1,'O cdigo actual j se encontra registado na Autoridade Tributria e no pode ser modificado',1910,'MSG',1,'MESSAGE'),(16404,0,1,'Esta guia de transporte j foi processada. O cdigo de transporte no pode ser indicado manualmente.',1856,'MSG_BOX_TEXT',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16406,0,1,'Data Descarga',1913,'TableCloseUnloadDate',1,'SCREEN_TABLE_CLOSE'),(16407,0,1,'Data Carga',1912,'TableCloseLoadDate',1,'SCREEN_TABLE_CLOSE'),(16408,0,1,'Carga',1914,'TableEditCargoDateShort',1,'SCREEN_TABLE_CLOSE'),(16409,0,1,'Descarga',1915,'TableEditDropOffDateShort',1,'SCREEN_TABLE_CLOSE'),(16410,0,1,'O cliente tem de ter preenchido os seguintes campos: morada, localidade e cdigo postal.',1916,'MSG',1,'MESSAGE'),(16411,0,1,'125 Vendas - Obriga a pedir ao sair',1917,'PERM_REPORTS_CASHDRAWERS',1,'SALESMAN_LEVEL_PERMISSIONS'),(16413,0,1,'Cliente RIC',1919,'CustomerRIC',1,'SCREEN_CONFIG_CUSTOMERS'),(16414,0,1,'T.Pagamento',1920,'CustomerAccountPaymentType',1,'SCREEN_CUSTOMER_ACCOUNT'),(16415,0,1,'Adiantamentos',1921,'CounterRecibo',1,'SCREEN_CONFIG_TERMINALS'),(16416,0,1,'Ver Histrico/Pendentes',1911,'CustomerAccountPaidInvoices',1,'SCREEN_CUSTOMER_ACCOUNT'),(16417,0,1,'Tem de desactivar o histrico para efetuar um pagamento.',1922,'CustomerAccountPaidInvoices',1,'SCREEN_CUSTOMER_ACCOUNT'),(16418,0,1,'No possui crdito para pagar de conta corrente.',1923,'CustomerAccountPaidInvoices',1,'SCREEN_CUSTOMER_ACCOUNT'),(16419,0,1,'Num Guia:',1924,'TableCloseGuiaManualCode',1,'SCREEN_TABLE_EDIT_RETAIL'),(16420,0,1,'Gerar Saft Simplificado 1.03',1926,'CashDrawerCloseBtnSaftSimplified103',1,'SCREEN_SAFT'),(16421,0,1,'Gerar SAFT 1.03',1925,'CashDrawerCloseBtnSaft103',1,'SCREEN_SAFT'),(16422,0,1,'Cliente RIC no pode emitir este tipo de documento.',1927,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(16425,0,1,'A ligao ao WebService da AT est indisponvel em Verso Demonstrao.',1929,'',1,''),(16427,0,1,'No pode anular este documento por ter recibos associados.',1930,'',1,''),(16428,0,1,'Utilizadores',338,'SalesmanWindow',4,'SCREEN_CONFIG_SALESMEN'),(16429,0,1,'Empregados',1931,'SalesmanWindow',4,'SCREEN_CONFIG_SALESMEN'),(16430,0,1,'Empregados',1931,'SalesmanWindow',1,'SCREEN_CONFIG_SALESMEN'),(16431,0,1,'Licenas',843,'LicencesWindow',4,'SCREEN_LICENCES'),(16463,0,1,'Pessoas',1965,'TableEditCustomerCount',1,'SCREEN_TABLE_EDIT'),(16464,0,1,'Limpa',1964,'TableEditClean',1,'SCREEN_TABLE_EDIT'),(16465,0,1,'Total Pago',1963,'TableTenderPaidValue',1,'SCREEN_TABLE_EDIT'),(16472,0,1,'Plugins',1928,'SESSIONS_BUTTON_STR',1,'SESSIONS_BUTTON_STR'),(16473,0,1,'Voo',1976,'TableEditCustomerFlight',1,'SCREEN_TABLE_EDIT'),(16474,0,1,'Passport',1975,'TableEditCountry',1,'SCREEN_TABLE_EDIT'),(16475,0,1,'Tot.Com.',1974,'DayCloseDepositTotalComissionCaption',1,'SCREEN_DAY_CLOSE'),(16476,0,1,'Copiar >',1973,'DayCloseCopyToDeposit',1,'SCREEN_DAY_CLOSE'),(16477,0,1,'Com.',1972,'DayCloseSelectedValueCom',1,'SCREEN_DAY_CLOSE'),(16478,0,1,'Total c/IVA',1971,'DayClosePurchasesTotalVat',1,'SCREEN_DAY_CLOSE'),(16479,0,1,'Tot.Dep.',1970,'DayCloseDepositTotalCaption',1,'SCREEN_DAY_CLOSE'),(16480,0,1,'Total s/IVA',1969,'DayClosePurchasesTotal',1,'SCREEN_DAY_CLOSE'),(16481,0,1,'Fecho Financeiro',1968,'DayCloseScreenWindow',1,'SCREEN_DAY_CLOSE'),(16482,0,1,'Avanado',1967,'TableEditCloseTableAdvanced',1,'SCREEN_TABLE_EDIT'),(16483,0,1,'+',1966,'DayClosePurchasesGravar',1,'SCREEN_DAY_CLOSE'),(16484,0,1,'Ainda tem artigos por pedir',1918,'MSG_BOX_TEXT',1,'MSG'),(16485,0,1,'Estornar',536,'DailyJournalBtnDevolution',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16486,0,1,'Mtodo|Valor|Comisso',1962,'DayCloseDepositPaymentTypesList',1,'SCREEN_DAY_CLOSE'),(16487,0,1,'Mtodo|Valor',1961,'DayClosePaymentTypesList',1,'SCREEN_DAY_CLOSE'),(16488,0,1,'Fechar Dia',1960,'DayClosePrint',1,'SCREEN_DAY_CLOSE'),(16489,0,1,'Taxa',1959,'DayClosePurchaseTaxesType',1,'SCREEN_DAY_CLOSE'),(16490,0,1,'Total C/IVA',1958,'DayCloseDocTotal',1,'SCREEN_DAY_CLOSE'),(16491,0,1,'Compras',1957,'DayClosePurchases',1,'SCREEN_DAY_CLOSE'),(16492,0,1,'Depsito',1956,'DayClosePaymentTypesDeposit',1,'SCREEN_DAY_CLOSE'),(16493,0,1,'Compra',1955,'DayClosePurchasesType',1,'SCREEN_DAY_CLOSE'),(16494,0,1,'N Doc',1954,'DayCloseDocNumber',1,'SCREEN_DAY_CLOSE'),(16495,0,1,'Tipo Compra|NDocumento|Total c/IVA|Taxa',1953,'DayCloseList',1,'SCREEN_DAY_CLOSE'),(16496,0,1,'Mtodos Pagamento',1952,'DayClosePaymentTypes',1,'SCREEN_DAY_CLOSE'),(16497,0,1,'Valor',1951,'DayCloseSelectedValue',1,'SCREEN_DAY_CLOSE'),(16498,0,1,'Limpar',1950,'CashDrawerCloseBtnCleanFundo',1,'SCREEN_CASHIER_CLOSE'),(16499,0,1,'50 Eur',1949,'CashDrawerCloseNota7',1,'SCREEN_CASHIER_CLOSE'),(16500,0,1,'500 Eur',1948,'CashDrawerCloseNota6',1,'SCREEN_CASHIER_CLOSE'),(16501,0,1,'20 Eur',1947,'CashDrawerCloseNota5',1,'SCREEN_CASHIER_CLOSE'),(16502,0,1,'200 Eur',1946,'CashDrawerCloseNota4',1,'SCREEN_CASHIER_CLOSE'),(16503,0,1,'10 Eur',1945,'CashDrawerCloseNota3',1,'SCREEN_CASHIER_CLOSE'),(16504,0,1,'100 Eur',1944,'CashDrawerCloseNota2',1,'SCREEN_CASHIER_CLOSE'),(16505,0,1,'5 Eur',1943,'CashDrawerCloseNota1',1,'SCREEN_CASHIER_CLOSE'),(16506,0,1,'2 Eur',1942,'CashDrawerCloseMoeda8',1,'SCREEN_CASHIER_CLOSE'),(16507,0,1,'10 cent',1941,'CashDrawerCloseMoeda7',1,'SCREEN_CASHIER_CLOSE'),(16508,0,1,'1 Eur',1940,'CashDrawerCloseMoeda6',1,'SCREEN_CASHIER_CLOSE'),(16509,0,1,'5 cent',1939,'CashDrawerCloseMoeda5',1,'SCREEN_CASHIER_CLOSE'),(16510,0,1,'50 cent',1938,'CashDrawerCloseMoeda4',1,'SCREEN_CASHIER_CLOSE'),(16511,0,1,'2 cent',1937,'CashDrawerCloseMoeda3',1,'SCREEN_CASHIER_CLOSE'),(16512,0,1,'20 cent',1936,'CashDrawerCloseMoeda2',1,'SCREEN_CASHIER_CLOSE'),(16513,0,1,'1 cent',1935,'CashDrawerCloseMoeda1',1,'SCREEN_CASHIER_CLOSE'),(16514,0,1,'Notas',1934,'CashDrawerCloseNotas',1,'SCREEN_CASHIER_CLOSE'),(16515,0,1,'Inclui Fundo de Maneio',1933,'CashDrawerCloseManeio',1,'SCREEN_CASHIER_CLOSE'),(16516,0,1,'Moedas',1932,'CashDrawerCloseMoedas',1,'SCREEN_CASHIER_CLOSE'),(16517,0,1,'Data Alterao',1979,'SageIvaDate',1,'SCREEN_SAGE_IVA'),(16518,0,1,'Iva Dest',1978,'SageIvaTo',1,'SCREEN_SAGE_IVA'),(16519,0,1,'Iva Origem',1977,'SageIvaFrom',1,'SCREEN_SAGE_IVA'),(16520,0,1,'Recalcular Valores',1214,'CleanChanges',1,'SCREEN_SAGE_IVA'),(16521,0,1,'Guardar Agendamento',1211,'TaxChangeSchedule',1,'SCREEN_SAGE_IVA'),(16522,0,1,'Insira o cdigo e senha',1258,'LicensingWizardLabelCode',1,'SCREEN_LICENSING_WIZARD'),(16523,0,1,'Ficheiro de licenciamento',1259,'LicensingWizardLabelFile',1,'SCREEN_LICENSING_WIZARD'),(16525,0,1,'Nmero Srie',1995,'LicensingWizardLabelSerial',1,'SCREEN_LICENSING_WIZARD'),(16526,0,1,'Local Compra*',1994,'LicenceSerialPurchasePlace',1,'SCREEN_LICENSING_WIZARD'),(16527,0,1,'Telefone*',1993,'LicenceSerialPhone',1,'SCREEN_LICENSING_WIZARD'),(16528,0,1,'Cargo',1992,'LicenceSerialCargo',1,'SCREEN_LICENSING_WIZARD'),(16529,0,1,'Nome Contacto*',1991,'LicenceSerialContactName',1,'SCREEN_LICENSING_WIZARD'),(16530,0,1,'Vol. Negcios*',1990,'LicenceSerialVolNeg',1,'SCREEN_LICENSING_WIZARD'),(16531,0,1,'Localidade*',1989,'LicenceSerialLocality',1,'SCREEN_LICENSING_WIZARD'),(16532,0,1,'Cod.Postal*',1988,'LicenceSerialPostalCode',1,'SCREEN_LICENSING_WIZARD'),(16533,0,1,' ',1987,'LicenceSerialAddr2',1,'SCREEN_LICENSING_WIZARD'),(16534,0,1,'Num. Func.*',1986,'LicenceSerialNumFunc',1,'SCREEN_LICENSING_WIZARD'),(16535,0,1,'CAE*',1985,'LicenceSerialCAE',1,'SCREEN_LICENSING_WIZARD'),(16536,0,1,'Email*',1984,'LicenceSerialEmail',1,'SCREEN_LICENSING_WIZARD'),(16537,0,1,'Morada*',1983,'LicenceSerialAddr1',1,'SCREEN_LICENSING_WIZARD'),(16538,0,1,'NIF*',1982,'LicenceSerialNIF',1,'SCREEN_LICENSING_WIZARD'),(16539,0,1,'Empresa*',1981,'LicenceSerialName',1,'SCREEN_LICENSING_WIZARD'),(16540,0,1,'Ativar',1980,'LicencesSerialBt',1,'SCREEN_LICENSING_WIZARD'),(16541,0,1,'Conhecimento*',1996,'LicenceSerialAck',1,'SCREEN_LICENSING_WIZARD'),(16544,0,1,'Max. Fac.Simplificada',496,'SystemConfigInvoiceMinValue',1,'SCREEN_CONFIG_SYSTEM'),(16546,0,1,'Anulao Artigos',1998,'TableEditMultiCancel',1,'SCREEN_TABLE_EDIT'),(16547,0,1,'Contas Mltiplas',1999,'TableCloseCaption',1,'SCREEN_TABLE_CLOSE'),(16548,0,1,'Impressora',2000,'DailyJournalPrinter',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16549,0,1,'O valor sem iva mximo para factura simplificado no pode ser maior do que 100Eur',1997,'GeneralConfigProperties',1,'SCREEN_CONFIG_SYSTEM'),(16550,0,1,'pre-selec',2001,'VARIOS',1,'MSG'),(16551,0,1,'Excluso de Artigos',2002,'TerminalsExclusionsCaption',1,'SCREEN_CONFIG_TERMINALS'),(16552,0,1,'SAFT: Utilizar campo NetValue',2003,'ConfigProperty',1,'ConfigProperty'),(16553,0,1,'O valor sem iva mximo para factura simplificado no pode ser maior do que 1000Eur',1733,'GeneralConfigProperties',1,'SCREEN_CONFIG_SYSTEM'),(16556,0,1,'Por favor feche todas as caixas antes de executar plugins!',2004,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(16557,0,1,'Testar Impressoras',2005,'DeviceManagerTestDevice',1,'SCREEN_CONFIG_DEVICES'),(16559,0,1,'O seu nivel de contrato no permite a utilizao do WebService da AT.',2006,'MSG_BOX_TEXT',1,'MSG_BOX_TEXT'),(16560,0,1,'Unid',2007,'ItemUnit',1,'SCREEN_CONFIG_ITEMS'),(16561,0,1,'Tem de pedir antes de prosseguir com a venda.',2008,'',1,'MSG'),(16562,0,1,'Existem artigos com valor de Reteno na Fonte. Para a incluir, por favor seleccione previamente um cliente. \n\nQuer fechar esta venda mesmo assim?',1814,'MSG_BOX_TEXT',1,'SCREEN_TABLE_EDIT'),(16563,0,1,'No pode anular este documento. Est associado a uma nota de crdito!',2009,'',1,'MSG'),(16564,0,1,'Todos os utilizadores tm de ter uma palavra-passe de pelo menos dois alfanumricos.',2010,'',1,'MSG'),(16565,0,1,'No se pode mudar o nome e morada a clientes com vendas efetudas e com NIF eventual/vazio.',2011,'',1,'MSG'),(16568,0,1,'Nova srie',2014,'SeriesMigrationDestiny',1,'SCREEN_SERIES_MIGRATION'),(16569,0,1,'Srie existente',2013,'SeriesMigrationOrigin',1,'SCREEN_SERIES_MIGRATION'),(16571,0,1,'Fazer backup',2019,'SystemConfig',1,'SCREEN_CONFIG_SYSTEM'),(16572,0,1,'ltimo backup:',2018,'SystemConfigNextBackup',1,'SCREEN_CONFIG_SYSTEM'),(16573,0,1,'Periodo',2017,'SystemConfigBackupPeriodic',1,'SCREEN_CONFIG_SYSTEM'),(16578,0,1,'Documentos Recuperao Manual',2020,'ManualRecManDocsString',1,'ManualRecManDocsString'),(16579,0,1,'Documentos Recuperao Informtica',2021,'ManualRecInfDocsString',1,'ManualRecInfDocsString'),(16582,0,1,'Todos os utilizadores tm de ter uma palavra-passe de pelo menos dois dgitos.',2010,'',1,'MSG'),(16583,0,1,'',2024,'SeriesMigrationExplanation',1,'SCREEN_SERIES_MIGRATION'),(16586,0,1,'Plugins|As operaes efectuadas por este plugin podero no ser revertidas.\n\nTem certeza que quer continuar?\n\n\nnota: o processo poder ser demorado.',1527,'MSG_BOX_TEXT',1,'SCREEN_PLUGINS'),(16587,0,1,'Plugins|O ficheiro indicado no foi encontrado. Verifique o caminho/nome e tente novamente.',1532,'MSG_BOX_TEXT',1,'SCREEN_PLUGINS'),(16588,0,1,'Plugins|O plugin foi executado.',1534,'MSG_BOX_TEXT',1,'SCREEN_PLUGINS'),(16589,0,1,'Tem a certeza que deseja inactivar as sries que tm novos descritivos?',2016,'SeriesMigrationOrigin',1,'SCREEN_SERIES_MIGRATION'),(16590,0,1,'Seleccionar tudo',2026,'CustomerAccountSelectAll',1,'SCREEN_CUSTOMER_ACCOUNT'),(16593,0,1,'Existe um backup programado para hoje. Deseja efetu-lo agora? \n\nNota: Como o ltimo agendamento j foi adiado, no poder aceder a todas as funcionalidades da aplicao enquanto no efectuar um backup.',2028,'',1,'MSG'),(16594,0,1,'Est prevista a execuo do backup at ao dia de hoje. Como o ltimo agendamento foi adiado, no poder aceder a todas as funcionalidades da aplicao enquanto no efectuar o backup em Gesto->Plugins',2029,'',1,'MSG'),(16595,0,1,'Existe um backup programado para hoje. Deseja efetu-lo agora? \n\nSe declinar, ir ser notificado novamente daqui a %d dia(s)',2030,'',1,'MSG'),(16596,0,1,'Est prevista a execuo de um backup para hoje. Poder faz-lo indo ao menu Gesto->Plugins. Deseja continuar e executar o backup mais tarde?',2031,'',1,'MSG'),(16597,0,1,'Est prevista a execuo de um backup para hoje. Poder faz-lo indo ao menu Gesto->Plugins. Deseja continuar e executar o backup mais tarde?',2031,'',1,'MSG'),(16598,0,1,'No se pode modificar a descrio a um artigo que j tenha vendas.',2012,'',1,'MSG'),(16599,0,1,'Est prevista a execuo de um backup para hoje. Poder faz-lo indo ao menu Gesto->Plugins. Deseja continuar e executar o backup mais tarde?',2013,'',1,'MSG'),(16601,0,1,'Tem a certeza que deseja fazer agora a cpia de dados? Mediante o tamanho da base de dados, poder demorar alguns minutos.',2033,'',1,'MSG'),(16602,0,1,'Em caso de perda de documentos aquando reposio de uma cpia de segurana, devero ser desactivadas as respectivas sries e criadas novas sries para substituio das mesmas. \nDeseja fazer isto agora via wizard?\nA aplicao ser encerrada posteriormente.',2015,'',1,'MSG'),(16603,0,1,'O restore da base de dados foi efetuado. Deseja inactivar todas as sries?\n\nnota: a aplicao ser encerrada posteriormente.',2034,'',1,'MSG'),(16604,0,1,'Por favor indique os novos descritivos das sries atuais que originaram perda de documentos. Sero inativas as sries que possuam novas designaes.',2025,'SeriesMigrationExplanationText',1,'SCREEN_SERIES_MIGRATION'),(16605,0,1,'Rec. Manual',2036,'ZONE_REC_MAN',1,'ZONE_REC_MAN'),(16606,0,1,'Doc.Inform.',2037,'ZONE_REC_INF',1,'ZONE_REC_INF'),(16607,0,1,'Novo doc. rec. manual',2038,'NEW_DOC_REC_MAN_TABLE_ID',1,'NEW_DOC_REC_MAN_TABLE_ID'),(16608,0,1,'Novo doc. informtico',2039,'NEW_DOC_REC_INF_TABLE_ID',1,'NEW_DOC_REC_INF_TABLE_ID'),(16609,0,1,'Restore Sries',2040,'MigracaoWindow',1,'SCREEN_SERIES_MIGRATION'),(16610,0,1,'Doc. Informtico',2023,'DocumentTypeCode',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(16611,0,1,'Rec. Manual',2022,'DocumentTypeCode',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(16612,0,1,'Factura Manual',2041,'',1,'MSG'),(16613,0,1,'Factura RecInf',2042,'',1,'MSG'),(16614,0,1,'FacSimplif. Manual',2043,'',1,'MSG'),(16615,0,1,'FacSimplif. RecInf',2044,'',1,'MSG'),(16616,0,1,'FacRecibo Manual',2045,'',1,'MSG'),(16617,0,1,'FacRecibo RecInf',2046,'',1,'MSG'),(16618,0,1,'Guia Trans Manual',2047,'',1,'MSG'),(16619,0,1,'Guia Trans RecInf',2048,'',1,'MSG'),(16620,0,1,'Nota Crdito Manual',2049,'',1,'MSG'),(16621,0,1,'Nota Crdito RecInf',2050,'',1,'MSG'),(16622,0,1,'Documento|Srie|Nova Srie',2051,'SeriesMigrationList',1,'SCREEN_SERIES_MIGRATION'),(16625,0,1,'No pode diminuir a preciso decimal numa base de dados que possua vendas.',2052,'',1,'MSG'),(16626,0,1,'Foi efetuado upgrade com sucesso  base de dados. A aplicao vai agora encerrar para finalizar o processo.\n\nInicie novamente a aplicao por favor.',2053,'',1,'MSG'),(16627,0,1,'Para se completar esta alterao, a aplicao ser encerrada na sada deste ecr. Deseja continuar? ',2054,'',1,'MSG'),(16628,0,1,'Apenas so suportadas casas decimais no intervalo de 2 a 4.',2055,'',1,'MSG'),(16629,0,1,'Telemvel',1136,'NewClientMobile',1,'SCREEN_NEW_CLIENT'),(16630,0,1,'No se pode modificar a descrio a um artigo que j tenha vendas. Deseja criar um artigo novo com base neste? \nO artigo actual ser desativado.',2032,'',1,'MSG'),(16631,0,1,'Decimais Preo Unitrio',2027,'SystemConfigNumberDecimalsPrice',1,'SCREEN_CONFIG_SYSTEM'),(16632,0,1,'Decimais Moeda',490,'SystemConfigNumberDecimals',1,'SCREEN_CONFIG_SYSTEM'),(16633,0,1,'Sep. Moeda',489,'SystemConfigCurrencySeparator',1,'SCREEN_CONFIG_SYSTEM'),(16634,0,1,'Conv. Moeda',671,'currency_conversion',1,'GENERAL_CONFIG'),(16635,0,1,'Ordem Visualiz.',1115,'ItemDisplayOrder',1,'SCREEN_CONFIG_ITEMS'),(16636,0,1,'Empregado transf. contas',1120,'TransferText',4,'SCREEN_CONFIG_OPEN_TABLES'),(16637,0,1,'Empregado transf. cartes',1120,'TransferText',1,'SCREEN_CONFIG_OPEN_TABLES'),(16638,0,1,'Perfis de Radio',1101,'ProfilesOpenRadioTerminals',1,'SCREEN_PROFILES_SELECTION'),(16639,0,1,'Na venda sugere ltima Guia Global',2056,'ConfigProperty',1,'ConfigProperty'),(16640,0,1,'\nDS-Contador\nDD-Data\nDH-Hora\nDA-Assinatura\nDO-Sub-totais\nDT-Natureza\nDN-Observacoes\nDQ-AT Qr Code\n\nDETALHE DOCUMENTO\nBQ-Quantidade\nBN-Nome Artigo\nB1-Descricao Curta 1\nB2-Descricao Curta 2\nBD-Desconto\nBT-Valor Taxa\nBU-Preco Unidade\nBV-Total Linha\nBI-Unidade\n\nGUIAS DE TRANSPORTE\nGC-Hora Carga\nGD-Hora Descarga\nGT-Transporte\nGI-Cod. Transporte\n\nCARTO\nMM-Nome carto\nME-Empregado\nMT-Total\nMC-Nome cliente\nMN-NIF cliente\nMA-Morada cli (1)\nMB-Morada cli (2)\nMD-C.Postal cliente\nML-Localidade cliente\nMV-Iva\nMO-Destino Ordem\nMP-Pagamento\nMQ-Saldo Cliente\nMI-Pedido\nMR-Doc Origem\n\nPor favor consulte o manual para visualizar a lista de tags completa.',1223,'HintText',1,'SCREEN_CONFIG_DOCUMENTPARTS'),(16641,0,1,'Nmero de Vias Impresso',2057,'DocumentTypeNumVias',1,'SCREEN_CONFIG_DOCUMENT_TYPES'),(16642,0,1,'Conv.Moeda',495,'SystemConfigAlternativeCurrencyConverstion',1,'SCREEN_CONFIG_SYSTEM'),(16643,0,1,'Caminho Backup',2059,'SystemConfigBackupPath',1,'SCREEN_CONFIG_SYSTEM'),(16644,0,1,'Caminho Saft',2058,'SystemConfigSaftPath',1,'SCREEN_CONFIG_SYSTEM'),(16645,0,1,'Gaveta',2060,'Gaveta',1,'SCREEN_TABLE_SELECTION'),(16646,0,1,'Fecho',2061,'TableCloseCaption',1,'SCREEN_TABLE_CLOSE'),(16647,0,1,'Take Away',2062,'TableEditTypes',1,'TableEditTypes'),(16648,0,1,'triplicado',2063,'PDF_STR',1,'PDF_STR'),(16649,0,1,'quadriplicado',2064,'PDF_STR',1,'PDF_STR'),(16650,0,1,'Sair',2065,'Sair',1,'SCREEN_TABLE_SELECTION'),(16651,0,1,'No pode criar uma nota de crdito de uma guia de transporte.',2066,'MSG_BOX_TEXT',1,'SCREEN_DAILY_JOURNAL_SERVICES'),(16652,0,1,'c/ \"Fechar directo\" e Famlias em cima',1684,'TableEditTypes',1,'TableEditTypes'),(16653,0,1,'Destino',2068,'TableEditDestiny',1,'SCREEN_TABLE_EDIT_RETAIL'),(16654,0,1,'Origem',2067,'TableEditOrigin',1,'SCREEN_TABLE_EDIT_RETAIL'),(16659,0,1,'Ficheiro Inventrio',2072,'CashDrawerCloseBtnGenerateInv',1,'SCREEN_SAFT'),(16660,0,1,'Limpa Total da ultima mesa',2078,'SCREEN_CONFIG_TERMINAL',1,'SCREEN_CONFIG_TERMINAL'),(16667,0,1,'Pag. Auto',2079,'AUTO_PAY_OPTION',1,'SCREEN_CONFIG_MAIN'),(16668,0,1,'CashDRO',2080,'CASHDRO device',1,'SCREEN_CONFIG_TERMINALS'),(16669,0,1,'Esquecer',2081,NULL,1,'GDPR'),(16670,0,1,'Password Encript',2082,NULL,1,'GDPR'),(16671,0,1,'322 - Ver dados pessoais',2083,NULL,1,'SALESMAN_LEVEL_PERMISSIONS'),(16672,0,1,'Consentimento',2084,NULL,1,'GDPR'),(16673,0,1,'Obriga Introduzir OBs na venda',2085,NULL,1,'ZONE OPTIONS'),(16674,0,1,'Contribuinte',2086,'DailyJournalNIFSearch',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16675,0,1,'Fatura Electrnica SAFE',2090,'company_uses_safe',1,'GENERAL_CONFIG'),(16676,0,1,'Configurao SAFE',2089,'SystemConfigSafePass',1,'SCREEN_CONFIG_SYSTEM'),(16677,0,1,'Cdigo da Srie',2091,'ATCUD',1,'SCREEN_CONFIG_COUNTERS'),(16678,0,1,'Data Download Documento',2098,'EmailReadTimestamp',1,'SCREEN_CONFIG_CUSTOMERS'),(16679,0,1,'Fatura Eletrnica',2097,'EmailSentTimestamp',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16680,0,1,'Reenviar Fatura Eletrnica',2096,'ResendBillSafe',1,'SCREEN_CONFIG_DAILY_JOURNAL'),(16681,0,1,'Fatura Eletrnica',2095,'SendBillSafe',1,'SCREEN_CONFIG_CUSTOMERS'),(16682,0,1,'Finalizar Srie',2094,'ATCUDCloseSeries',1,'SCREEN_CONFIG_COUNTERS'),(16683,0,1,'Anular Srie',2093,'ATCUDVoidSeries',1,'SCREEN_CONFIG_COUNTERS'),(16684,0,1,'Solicitar Cdigo',2092,'ATCUDGetSeries',1,'SCREEN_CONFIG_COUNTERS'),(16685,0,1,'Senha AT Sries',2100,'SerialsATPass',1,'SCREEN_CONFIG_SYSTEM'),(16686,0,1,'Utilizador AT Sries',2099,'SerialsATUser',1,'SCREEN_CONFIG_SYSTEM'),(16693,0,1,'126 Vendas - Anular Notas de Crdito emitidas at duas semanas',651,'PERM_VOID_CREDITNOTES',1,'SALESMAN_LEVEL_PERMISSIONS'),(16694,0,1,'No pode anular Notas de Crdito com mais de 14 dias.',2069,'TableEditDestiny',1,'SCREEN_TABLE_EDIT_RETAIL'),(16695,0,1,'A Faturao Externa apenas pode ser utilizada no ecr de fecho completo.',2070,'TableEditDestiny',1,'SCREEN_TABLE_EDIT_RETAIL'),(16696,0,1,'Valor desconto',2071,'TableCloseDiscount',1,'SCREEN_TABLE_CLOSE_SHORT'),(16713,0,1,'Aviso|Impossvel gravar artigo sem subfamlia',2117,'MSG_PERMISSION_DENIED',1,'MSGBOX'),(16714,0,1,'Funcionalidade indisponvel em Android.\nFicheiro gerado no caminho definido na configurao.',2107,'',1,NULL),(16715,0,1,'Inicio Perodo 1',2101,'AvailableFrom1',1,'SCREEN_CONFIG_ITEMS'),(16716,0,1,'Fim Perodo 1',2102,'AvailableTo1',1,'SCREEN_CONFIG_ITEMS'),(16717,0,1,'Inicio Perodo 2',2103,'AvailableFrom2',1,'SCREEN_CONFIG_ITEMS'),(16718,0,1,'Fim Perodo 2',2104,'AvailableTo2',1,'SCREEN_CONFIG_ITEMS'),(16719,0,1,'Inicio Perodo 3',2105,'AvailableFrom2',1,'SCREEN_CONFIG_ITEMS'),(16720,0,1,'Fim Perodo 3',2106,'AvailableTo2',1,'SCREEN_CONFIG_ITEMS'),(16721,0,1,'Domingo',2110,'Sunday',1,'SCREEN_CONFIG_ITEMS'),(16722,0,1,'Segunda',2111,'Monday',1,'SCREEN_CONFIG_ITEMS'),(16723,0,1,'Tera',2112,'Tuesday',1,'SCREEN_CONFIG_ITEMS'),(16724,0,1,'Quarta',2113,'Wednesday',1,'SCREEN_CONFIG_ITEMS'),(16725,0,1,'Quinta',2114,'Thursday',1,'SCREEN_CONFIG_ITEMS'),(16726,0,1,'Sexta',2115,'Friday',1,'SCREEN_CONFIG_ITEMS'),(16727,0,1,'Sbado',2116,'Saturday',1,'SCREEN_CONFIG_ITEMS'),(16728,0,1,'Guias com consumidor final s sero comunicadas se a respetiva opo estiver ativa em Config Geral.',2120,NULL,1,''),(16729,0,1,'No  possvel alterar leitura de balana a um artigo que j tenha vendas.',2121,NULL,1,''),(16730,0,1,'Documento sem cdigo de srie AT. J existem outros documentos configurados.',2122,'',1,NULL),(16731,0,1,'Comunicar documentos  AT por via eletrnica',2123,NULL,1,NULL),(16732,0,1,'Comunicar documentos  AT por via eletrnica:\n\nEsta operao efetivar-se- a partir de dia 1 do prximo ms e s ser reversvel no prximo ano (ou at ao fim do ms corrente).\n\nDeseja continuar?',2124,NULL,1,NULL),(16733,0,1,'Comunicar documentos  AT por via eletrnica:\n\nData de desativao 31/12 do corrente.',2125,NULL,1,NULL),(16734,0,1,'Consola AT',2126,NULL,1,NULL),(16735,0,1,'Por favor preencha primeiro as credenciais AT',2127,NULL,1,NULL),(16736,0,1,'Comunicado  AT',2128,NULL,1,NULL),(16737,0,1,'Documento j comunicado  AT.',2129,NULL,1,NULL),(16738,0,1,'Documento comunicado  AT com sucesso.',2130,NULL,1,NULL),(16739,0,1,'O motivo de iseno no  vlido. Por favor altere na ficha do Artigo.',2131,NULL,1,NULL),(16740,0,1,'Falha na comunicao do documento  AT.',2132,NULL,1,NULL),(16741,0,1,'Falha ao gerar documento para envio  AT.',2133,NULL,1,NULL),(16742,0,1,'No  possvel alterar nome, contador, tipo de documento ou cdigo a uma srie ativa.',2134,NULL,1,NULL),(16743,0,1,'Erro de validao de srie.',2135,NULL,1,NULL),(16744,0,1,'No pode alterar o tipo de documento pois j tem documentos associados.',2136,NULL,1,NULL),(16745,0,1,'Artigo com preo zero em zona com repartio de valor tributvel.',2137,NULL,1,NULL),(16746,0,1,'Assinatura do documento original no confere com dados que a originam.',2138,NULL,1,NULL),(16747,0,1,'No  possvel transferir mesa pois tem artigos de menu com preo zero e a zona de destino tem repartio de valor tributvel.',2139,NULL,1,NULL),(16748,0,1,'No  possvel eliminar este artigo.',2140,NULL,1,NULL),(16749,0,1,'Sage Exchange|Pretende desassociar o parceiro %s (%s)?',2141,NULL,1,NULL),(16750,0,1,'Sage Exchange|Parceiro no se encontra associado.',2142,NULL,1,NULL),(16751,0,1,'Sage Exchange|O parceiro %s (%s) j se encontra associado.',2143,NULL,1,NULL),(16752,0,1,'Sage Exchange|Pretende associar o parceiro %s (%s)?',2144,NULL,1,NULL),(16753,0,1,'Sage Exchange|Erro desconhecido ao obter URI para envio do SAF-T.',2145,NULL,1,NULL),(16754,0,1,'Sage Exchange|Por favor seleccione um ficheiro SAF-T para enviar.',2146,NULL,1,NULL),(16755,0,1,'Sage Exchange|Falha ao criar ficheiro zip a partir do ficheiro SAF-T %s',2147,NULL,1,NULL),(16756,0,1,'Sage Exchange|Sem parceiro associado.',2148,NULL,1,NULL),(16757,0,1,'Sage Exchange|Comunicado ficheiro ao parceiro.',2149,NULL,1,NULL),(16758,0,1,'Por favor introduza o cdigo do pas na norma ISO 3166 (duas letras, p.ex. PT).',2150,NULL,1,NULL),(16759,0,1,'No pode ter uma guia apenas com servios.',2151,NULL,1,NULL),(16760,0,1,'O Email indicado  invlido!',2152,NULL,1,NULL),(16761,0,1,'Imprime Artigos com preo zero',2153,NULL,1,NULL),(16762,0,1,'A taxa de IVA no pode ser eliminada pois est em uso.',2154,NULL,1,NULL),(16763,0,1,'Dados de licena so obrigatrios.',2155,NULL,1,NULL),(16764,0,1,'Mostrar artigos inativos nos menus',2156,NULL,1,NULL);
/*!40000 ALTER TABLE `languagedictionaries` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `languages`
--

DROP TABLE IF EXISTS `languages`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `languages` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL DEFAULT 0,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) NOT NULL,
  `Description` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `ShortDescription` varchar(10) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `FilePath` varchar(200) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `ImagePath` varchar(200) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `languages`
--

LOCK TABLES `languages` WRITE;
/*!40000 ALTER TABLE `languages` DISABLE KEYS */;
INSERT INTO `languages` VALUES (1,0,16,1,'Portugus - restaurao','PT','','pt_flag.png'),(2,0,16,2,'Portugus - discotecas','PT',NULL,'pt_flag.png'),(3,0,16,3,'Retalho','PT',NULL,'pt_flag.png'),(4,0,16,4,'Servios','PT',NULL,'pt_flag.png');
/*!40000 ALTER TABLE `languages` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `licenses`
--

DROP TABLE IF EXISTS `licenses`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `licenses` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(3) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `SalesTerminal` int(11) NOT NULL,
  `RegistrationDate` datetime NOT NULL,
  `UpgradeDate` datetime DEFAULT NULL COMMENT 'asasas',
  `ApplicationVersion` int(11) NOT NULL,
  `License` blob NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `licenses`
--

LOCK TABLES `licenses` WRITE;
/*!40000 ALTER TABLE `licenses` DISABLE KEYS */;
/*!40000 ALTER TABLE `licenses` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `maps`
--

DROP TABLE IF EXISTS `maps`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `maps` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `table_id` int(11) NOT NULL,
  `x_pos` int(11) NOT NULL,
  `y_pos` int(11) NOT NULL,
  `width` int(11) NOT NULL,
  `height` int(11) NOT NULL,
  `ImageFile` varchar(45) NOT NULL,
  `ZonesUID` int(11) NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_maps_zones1` (`ZonesUID`),
  CONSTRAINT `fk_maps_zones1` FOREIGN KEY (`ZonesUID`) REFERENCES `zones` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `maps`
--

LOCK TABLES `maps` WRITE;
/*!40000 ALTER TABLE `maps` DISABLE KEYS */;
/*!40000 ALTER TABLE `maps` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menulevelplus`
--

DROP TABLE IF EXISTS `menulevelplus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `menulevelplus` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `MenuLevelUID` int(11) NOT NULL DEFAULT 0,
  `PluUID` int(11) NOT NULL DEFAULT 0,
  `ExtraSalesValue` int(11) NOT NULL DEFAULT 0,
  `SubFamilyUID` int(11) NOT NULL DEFAULT 0,
  `SalesPVP` int(11) NOT NULL DEFAULT -99,
  `IsOffer` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `nivelmenu_id` (`MenuLevelUID`),
  KEY `fk_menulevel_plu_has_plu` (`PluUID`),
  CONSTRAINT `nivelmenu_id` FOREIGN KEY (`MenuLevelUID`) REFERENCES `menulevels` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menulevelplus`
--

LOCK TABLES `menulevelplus` WRITE;
/*!40000 ALTER TABLE `menulevelplus` DISABLE KEYS */;
/*!40000 ALTER TABLE `menulevelplus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menulevels`
--

DROP TABLE IF EXISTS `menulevels`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `menulevels` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) DEFAULT NULL,
  `Description` varchar(45) NOT NULL DEFAULT 'novo nivel de menu',
  `MenuUID` int(11) NOT NULL DEFAULT 0,
  `OrderNUmber` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `menu_id` (`MenuUID`),
  CONSTRAINT `menu_id` FOREIGN KEY (`MenuUID`) REFERENCES `menus` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menulevels`
--

LOCK TABLES `menulevels` WRITE;
/*!40000 ALTER TABLE `menulevels` DISABLE KEYS */;
/*!40000 ALTER TABLE `menulevels` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `menus`
--

DROP TABLE IF EXISTS `menus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `menus` (
  `UID` int(11) NOT NULL,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `PLUUID` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  `InUse` int(11) NOT NULL DEFAULT 0,
  `MaxPromotionValue` int(11) NOT NULL DEFAULT 0,
  `AddIfBiggerThenPromo` int(11) NOT NULL DEFAULT 0,
  `SalesPVP` int(11) NOT NULL DEFAULT -99,
  `SalesValue` int(11) NOT NULL DEFAULT 0,
  `AddInOrder` int(11) NOT NULL DEFAULT 0,
  `TerminalsInUse` varchar(200) NOT NULL DEFAULT ' ',
  `Type` int(11) NOT NULL DEFAULT 0,
  `RepeatCount` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `fk_menu_has_plu` (`PLUUID`),
  CONSTRAINT `fk_menu_has_plu` FOREIGN KEY (`PLUUID`) REFERENCES `plus` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `menus`
--

LOCK TABLES `menus` WRITE;
/*!40000 ALTER TABLE `menus` DISABLE KEYS */;
/*!40000 ALTER TABLE `menus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `offergroupplus`
--

DROP TABLE IF EXISTS `offergroupplus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `offergroupplus` (
  `UID` int(11) NOT NULL,
  `OfferGroups_UID` int(11) NOT NULL,
  PRIMARY KEY (`UID`,`OfferGroups_UID`),
  KEY `fk_OfferGroupPLUs_OfferGroups1` (`OfferGroups_UID`),
  CONSTRAINT `fk_OfferGroupPLUs_OfferGroups1` FOREIGN KEY (`OfferGroups_UID`) REFERENCES `offergroups` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `offergroupplus`
--

LOCK TABLES `offergroupplus` WRITE;
/*!40000 ALTER TABLE `offergroupplus` DISABLE KEYS */;
/*!40000 ALTER TABLE `offergroupplus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `offergroups`
--

DROP TABLE IF EXISTS `offergroups`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `offergroups` (
  `UID` int(11) NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `offergroups`
--

LOCK TABLES `offergroups` WRITE;
/*!40000 ALTER TABLE `offergroups` DISABLE KEYS */;
/*!40000 ALTER TABLE `offergroups` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `opensalesmansessions`
--

DROP TABLE IF EXISTS `opensalesmansessions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `opensalesmansessions` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `SessionID` int(11) NOT NULL,
  `SalesmanUID` int(11) NOT NULL,
  `WorkstationID` int(11) NOT NULL,
  `RemoteSessionID` int(11) NOT NULL,
  `StartTime` datetime NOT NULL,
  `LastTime` datetime NOT NULL,
  `CashDrawerUID` int(11) NOT NULL,
  `Commission` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `fk_salesmansession_has_salesman` (`SalesmanUID`),
  KEY `fk_salesmansession_has_cashdrawer` (`CashDrawerUID`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `opensalesmansessions`
--

LOCK TABLES `opensalesmansessions` WRITE;
/*!40000 ALTER TABLE `opensalesmansessions` DISABLE KEYS */;
INSERT INTO `opensalesmansessions` VALUES (6,0,0,0,1,1,0,'2013-03-21 11:44:37','2013-03-21 11:44:37',0,0);
/*!40000 ALTER TABLE `opensalesmansessions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `paymenttypes`
--

DROP TABLE IF EXISTS `paymenttypes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `paymenttypes` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) NOT NULL,
  `LongDescription` varchar(40) NOT NULL,
  `ShortDescription` varchar(20) NOT NULL,
  `HandTerminalCode` int(11) NOT NULL,
  `Commission` int(11) NOT NULL,
  `Type` int(11) NOT NULL,
  `DueDate` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=9998 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `paymenttypes`
--

LOCK TABLES `paymenttypes` WRITE;
/*!40000 ALTER TABLE `paymenttypes` DISABLE KEYS */;
INSERT INTO `paymenttypes` VALUES (1,0,1,1,'Dinheiro','MO',1,0,1,0),(2,0,1,2,'Multibanco','MB',2,0,0,0),(3,0,1,3,'Visa','VS',3,0,0,0),(4,0,1,9999,'Troco','TR',0,0,1,0),(5,0,1,9998,'Gorjeta','GR',0,0,1,0),(6,0,2,4,'Conta Corrente','CC',0,0,3,0),(7,0,3,5,'Facturaao Externa','Fact Externa',0,0,2,0),(8,0,5,6,'Pontos','Pontos',0,0,6,0),(9997,0,3,9997,'Debito em Saldo','CC',0,0,3,0);
/*!40000 ALTER TABLE `paymenttypes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `plus`
--

DROP TABLE IF EXISTS `plus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `plus` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `ItemID` int(11) NOT NULL,
  `Description` varchar(250) NOT NULL,
  `ShortDescription1` varchar(20) NOT NULL,
  `ShortDescription2` varchar(20) NOT NULL,
  `ProductLookUp` int(11) DEFAULT NULL,
  `BarCode` varchar(20) DEFAULT NULL,
  `FamilyID` int(11) DEFAULT NULL,
  `SubFamilyID` int(11) DEFAULT NULL,
  `TareValue` int(11) NOT NULL,
  `NextItemPage` int(11) DEFAULT NULL,
  `Comments` varchar(250) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `Enabled` int(11) NOT NULL,
  `PropertyUID` int(11) NOT NULL,
  `StockQuantity` int(11) NOT NULL,
  `StockAlarm` int(11) NOT NULL,
  `StockManagement` int(11) NOT NULL,
  `ItemPictureName` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `ItemVideoName` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci DEFAULT NULL,
  `CommissionGroupUID` int(11) DEFAULT NULL,
  `ModifyDate` datetime DEFAULT NULL,
  `unit` varchar(10) NOT NULL DEFAULT '',
  PRIMARY KEY (`UID`),
  KEY `fk_item_has_property` (`PropertyUID`),
  KEY `fk_item_has_family` (`FamilyID`),
  KEY `fk_item_has_subfamily` (`SubFamilyID`),
  CONSTRAINT `fk_item_has_family` FOREIGN KEY (`FamilyID`) REFERENCES `families` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_item_has_property` FOREIGN KEY (`PropertyUID`) REFERENCES `properties` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_item_has_subfamily` FOREIGN KEY (`SubFamilyID`) REFERENCES `subfamilies` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `plus`
--

LOCK TABLES `plus` WRITE;
/*!40000 ALTER TABLE `plus` DISABLE KEYS */;
INSERT INTO `plus` VALUES (1,0,2,1,'Artigo 1','Artigo 1','Artigo 1',1,'NULL',1,1,0,NULL,'NULL',1,3,0,0,0,'NULL','NULL',NULL,'2012-01-11 18:08:44',''),(2,0,1,9999,'correcao','correcao','correcao',NULL,'',1,1,0,NULL,'',1,4,0,0,0,'','',NULL,'2012-01-11 17:26:37',''),(3,0,2,9997,'OBS','OBS','OBS',NULL,'',1,1,0,NULL,'',1,5,0,0,0,'','',NULL,'2013-03-21 11:20:57','');
/*!40000 ALTER TABLE `plus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `printlocations`
--

DROP TABLE IF EXISTS `printlocations`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `printlocations` (
  `UID` int(11) NOT NULL,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_PrintLocations_Printers1` (`Code`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `printlocations`
--

LOCK TABLES `printlocations` WRITE;
/*!40000 ALTER TABLE `printlocations` DISABLE KEYS */;
INSERT INTO `printlocations` VALUES (1,0,1,1,'Internos'),(2,0,1,2,'Externos'),(3,0,1,101,'Grill'),(4,0,1,102,'Bar'),(5,0,1,103,'Cozinha');
/*!40000 ALTER TABLE `printlocations` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `printmap`
--

DROP TABLE IF EXISTS `printmap`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `printmap` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `PrintLocationUID` int(11) DEFAULT NULL,
  `ZoneUID` int(11) DEFAULT NULL,
  `SalesTerminalUID` int(11) DEFAULT NULL,
  `ProfileUID` int(11) DEFAULT NULL,
  `PrinterUID` int(11) DEFAULT NULL,
  `DocsUID0` int(11) DEFAULT NULL,
  `DocsUID1` int(11) DEFAULT NULL,
  `PrintSecondaryOrders` int(11) DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `fk_PrintMap_zones1` (`ZoneUID`),
  KEY `fk_PrintMap_SalesTerminal1` (`SalesTerminalUID`),
  KEY `fk_PrintMap_Profile1` (`ProfileUID`),
  KEY `fk_PrintLocations_has_plus_PrintLocations1` (`PrintLocationUID`),
  CONSTRAINT `fk_PrintLocations_has_plus_PrintLocations1` FOREIGN KEY (`PrintLocationUID`) REFERENCES `printlocations` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_PrintMap_Profile1` FOREIGN KEY (`ProfileUID`) REFERENCES `profile` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_PrintMap_zones1` FOREIGN KEY (`ZoneUID`) REFERENCES `zones` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=20 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `printmap`
--

LOCK TABLES `printmap` WRITE;
/*!40000 ALTER TABLE `printmap` DISABLE KEYS */;
INSERT INTO `printmap` VALUES (2,0,1,1,1,1,NULL,1,1,NULL,0),(3,0,1,1,NULL,1,NULL,1,NULL,NULL,0),(4,0,1,1,1,2,NULL,1,1,NULL,0),(5,0,1,1,NULL,2,NULL,1,NULL,NULL,0),(6,0,1,1,1,3,NULL,1,1,NULL,0),(7,0,1,1,NULL,3,NULL,1,NULL,NULL,0),(8,0,1,1,1,4,NULL,1,1,NULL,0),(9,0,1,1,NULL,4,NULL,1,NULL,NULL,0),(10,0,1,1,1,NULL,NULL,1,1,NULL,0),(11,0,1,2,NULL,1,NULL,1,NULL,NULL,0),(12,0,1,2,NULL,2,NULL,1,NULL,NULL,0),(13,0,1,2,NULL,3,NULL,1,NULL,NULL,0),(14,0,1,2,NULL,4,NULL,1,NULL,NULL,0),(15,0,1,2,1,1,NULL,1,NULL,NULL,0),(16,0,1,2,1,2,NULL,1,NULL,NULL,0),(17,0,1,2,1,3,NULL,1,NULL,NULL,0),(18,0,1,2,1,4,NULL,1,NULL,NULL,0);
/*!40000 ALTER TABLE `printmap` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `printspooler`
--

DROP TABLE IF EXISTS `printspooler`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `printspooler` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `PrintJob` longblob NOT NULL,
  `PrinterUID` int(11) NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_PrintSpooler_Printers1` (`PrinterUID`)
) ENGINE=InnoDB AUTO_INCREMENT=10311 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `printspooler`
--

LOCK TABLES `printspooler` WRITE;
/*!40000 ALTER TABLE `printspooler` DISABLE KEYS */;
INSERT INTO `printspooler` VALUES (10309,0,1,'',1),(10310,0,2,'',1);
/*!40000 ALTER TABLE `printspooler` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `profile`
--

DROP TABLE IF EXISTS `profile`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `profile` (
  `UID` int(11) NOT NULL,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) DEFAULT NULL,
  `Description` varchar(45) NOT NULL,
  `StartTime` time NOT NULL,
  `EndTime` time NOT NULL,
  `SalesPrice` int(3) DEFAULT NULL,
  `DiscountPercentage` int(3) DEFAULT NULL,
  `Terminals` varchar(45) DEFAULT NULL,
  `Zones` varchar(45) DEFAULT NULL,
  `Monday` int(1) NOT NULL,
  `Tuesday` int(1) NOT NULL,
  `Wednesday` int(1) NOT NULL,
  `Thursday` int(1) NOT NULL,
  `Friday` int(1) NOT NULL,
  `Saturday` int(1) NOT NULL,
  `Sunday` int(1) NOT NULL,
  `ExclusionUID` int(11) DEFAULT NULL,
  `RegisterInOwnDatabase` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `profile`
--

LOCK TABLES `profile` WRITE;
/*!40000 ALTER TABLE `profile` DISABLE KEYS */;
/*!40000 ALTER TABLE `profile` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `properties`
--

DROP TABLE IF EXISTS `properties`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `properties` (
  `UID` int(11) NOT NULL,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL DEFAULT 0,
  `Color` int(11) NOT NULL DEFAULT 0,
  `ItemType` int(11) DEFAULT NULL,
  `VariablePrice` int(11) DEFAULT NULL,
  `ReadQuantityFromScale` int(11) DEFAULT NULL,
  `SalesPrice1` float NOT NULL,
  `SalesPrice2` float NOT NULL,
  `SalesPrice3` float NOT NULL,
  `SalesPrice4` float NOT NULL,
  `SalesPrice5` float NOT NULL,
  `ItemTaxID1` int(11) DEFAULT NULL,
  `ItemTaxID2` int(11) DEFAULT NULL,
  `KitchenPrinters` varchar(45) NOT NULL,
  `KDSMaxCookTime` int(11) DEFAULT NULL,
  `KDSAverageCookTime` int(11) DEFAULT NULL,
  `PrintingOrder` int(11) DEFAULT NULL,
  `CostPrice` int(11) DEFAULT NULL,
  `WeightConversionFactor` int(11) DEFAULT NULL,
  `SalesPoints` int(11) DEFAULT NULL,
  `DisplayOrder` int(11) NOT NULL,
  `Link` int(11) DEFAULT -99,
  `ExcludeForCompensationTotal` int(11) NOT NULL DEFAULT 0,
  `IsService` int(11) NOT NULL DEFAULT 0,
  `WithholdingPercentage` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `fk_properties_has_taxID1` (`ItemTaxID1`),
  KEY `fk_properties_has_taxID2` (`ItemTaxID2`),
  CONSTRAINT `fk_properties_has_taxID1` FOREIGN KEY (`ItemTaxID1`) REFERENCES `taxes` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_properties_has_taxID2` FOREIGN KEY (`ItemTaxID2`) REFERENCES `taxes` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `properties`
--

LOCK TABLES `properties` WRITE;
/*!40000 ALTER TABLE `properties` DISABLE KEYS */;
INSERT INTO `properties` VALUES (1,0,1,0,1,0,0,100,150,200,300,400,1,1,'',NULL,NULL,NULL,NULL,NULL,NULL,50,-99,0,0,0),(2,0,1,0,1,0,0,100,150,200,300,400,1,1,'',NULL,NULL,NULL,NULL,NULL,NULL,50,-99,0,0,0),(3,0,2,0,1,0,0,100,150,200,300,400,1,1,'4',0,0,0,0,0,0,50,-99,0,0,0),(4,0,1,0,0,0,0,0,0,0,0,0,1,1,'',0,0,0,0,0,0,50,-99,0,0,0),(5,0,2,0,7,0,0,0,0,0,0,0,1,1,'',0,0,0,0,0,0,50,-99,0,0,0);
/*!40000 ALTER TABLE `properties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quickpage`
--

DROP TABLE IF EXISTS `quickpage`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `quickpage` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` varchar(45) NOT NULL DEFAULT '0',
  `SyncCounter` int(11) NOT NULL DEFAULT 1,
  `Code` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  `ShortDescription` varchar(45) NOT NULL,
  `FamilyUID` int(11) NOT NULL,
  `DisplayOrder` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quickpage`
--

LOCK TABLES `quickpage` WRITE;
/*!40000 ALTER TABLE `quickpage` DISABLE KEYS */;
/*!40000 ALTER TABLE `quickpage` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `quickpageplus`
--

DROP TABLE IF EXISTS `quickpageplus`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `quickpageplus` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) NOT NULL DEFAULT 0,
  `SyncCounter` int(11) NOT NULL DEFAULT 1,
  `QuickPageUID` int(11) NOT NULL,
  `PluUID` int(11) NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `quickpageplus`
--

LOCK TABLES `quickpageplus` WRITE;
/*!40000 ALTER TABLE `quickpageplus` DISABLE KEYS */;
/*!40000 ALTER TABLE `quickpageplus` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reports`
--

DROP TABLE IF EXISTS `reports`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `reports` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(4) DEFAULT NULL,
  `SyncCounter` tinyint(4) DEFAULT NULL,
  `Code` int(11) DEFAULT NULL,
  `Description` varchar(500) DEFAULT NULL,
  `HeaderText` varchar(500) DEFAULT NULL,
  `HeaderFormat` varchar(500) DEFAULT NULL,
  `FooterText` varchar(500) DEFAULT NULL,
  `FooterFormat` varchar(500) DEFAULT NULL,
  `Comments` varchar(500) DEFAULT NULL,
  `Hints` varchar(500) DEFAULT NULL,
  `Variables` varchar(500) DEFAULT NULL,
  `ReportType` int(11) DEFAULT NULL,
  `OrderField` int(11) DEFAULT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=128 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reports`
--

LOCK TABLES `reports` WRITE;
/*!40000 ALTER TABLE `reports` DISABLE KEYS */;
INSERT INTO `reports` VALUES (1,0,1,1,'Fecho Dia','REPORT FECHO DIA - (109)','%s\\n',' ','%s\\n',NULL,'Seleccione a data de Fecho de Dia','101,109,111',19,NULL),(2,0,1,2,'Abertura Caixa','Abertura Caixa\\n--------------------------------------\\nCaixa: (105)\\nFundo Maneio: (108)\\nData: (101)\\nUtilizador: (103)\\nTerminal: (107)','%s\\n','\\n',NULL,NULL,NULL,'101,103,105,107,108',2,NULL),(3,0,1,3,'Fecho Caixa','Fecho Caixa\\n----------------------------------------','%s\\n','\\n',NULL,NULL,NULL,'110,104,101,111,121',19,NULL),(4,0,1,4,'Abertura Sesso','Abertura Sesso\\n--------------------------------------\\nData: (101)\\nUtilizador: (103)\\nTerminal: (107)','%s\\n','\\n',NULL,NULL,NULL,'101,103,107',6,NULL),(5,0,1,5,'Fecho Sesso','Fecho Sesso \\n--------------------------------------\\nUtilizador: (103)\\nTerminal: (107)','%s\\n','\\n',NULL,NULL,NULL,'101,103,107,102,115,116,122',7,NULL),(6,0,1,6,'Vendas Por Empregado','Vendas Por Empregado\\n--------------------------------------\\nData Inicio: (109)\\nData Fim: (112)\\nProduto: (114)\\nEmpregado: (103)','%s\\n','\\n','%s\\n',' ','Seleccione Empregado, Data Inicial e Final, Produto','101,102,111,113,109,112,114,103',19,NULL),(7,0,1,7,'Documentos Anulados','Documentos Anulados\\n--------------------------------------\\nData Inicio: (109)\\nData Fim: (112)\\nProduto: (114)\\nEmpregado: (103)','%s\\n','\\n',NULL,NULL,'Seleccione Empregado, Data Inicial e Final, Produto','101,102,111,113,109,112,114,103',19,NULL),(8,0,1,8,'Vendas por Artigo','Vendas por Artigo\\n--------------------------------------\\nData Inicio: (109)\\nData Fim: (112)\\nProduto: (114)\\nEmpregado: (103)','%s\\n','\\n',NULL,NULL,'Seleccione Empregado, Data Inicial e Final, Produto','101,102,111,113,109,112,114,103',19,NULL),(9,0,1,9,'Sangria','Sangria\\n--------------------------------------\\nCaixa: (105)\\nValor: (108)\\nData: (101)\\nUtilizador: (103)\\nTerminal: (107)\\nDescrio: (117)','%s\\n','\\n',NULL,NULL,NULL,'101,103,105,107,108,117',4,NULL),(10,0,1,10,'Compra Direta','Compra Direta\\n--------------------------------------\\nCaixa: (105)\\nValor: (108)\\nData: (101)\\nUtilizador: (103)\\nTerminal: (107)\\nDescrio: (117)','%s\\n','\\n',NULL,NULL,NULL,'101,103,105,107,108,117',4,NULL),(11,0,1,11,'Vale','Vale\\n--------------------------------------\\nCaixa: (105)\\nValor: (108)\\nData: (101)\\nUtilizador: (103)\\nTerminal: (107)\\nDescrio: (117)\\nEmpregado: (120)','%s\\n','\\n',NULL,NULL,NULL,'101,103,105,107,108,117,120',4,NULL),(12,0,1,12,'Emprstimo','Emprstimo\\n--------------------------------------\\nCaixa: (105)\\nValor: (108)\\nData: (101)\\nUtilizador: (103)\\nTerminal: (107)\\nDescrio: (117)','%s\\n','\\n',NULL,NULL,NULL,'101,103,105,107,108,117',4,NULL),(13,0,1,13,'Devoluo','Devoluo\\n--------------------------------------\\nCaixa: (105)\\nValor: (108)\\nData: (101)\\nUtilizador: (103)\\nTerminal: (107)\\nDescrio: (117)','%s\\n','\\n',NULL,NULL,NULL,'101,103,105,107,108,117',4,NULL),(14,0,1,14,'Pag. Conta Corrente','Pag. Conta Corrente\\n--------------------------------------\\nCaixa: (105)\\nValor: (108)\\nData: (101)\\nUtilizador: (103)\\nTerminal: (107)\\nDescrio: (117)\\nCliente: (120)','%s\\n','\\n',NULL,NULL,NULL,'101,103,105,107,108,117,120',4,NULL),(15,0,1,15,'Listagem Vendas','Listagem Vendas\\n--------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','\\n','%s\\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(16,0,1,16,'Vendas por Mtodo Pagamento','Vendas por Mtodo Pagamento\\n--------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','\\n','%s\\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(17,0,1,17,'Listagem Artigos','Listagem Artigos\\n--------------------------------------','%s\\n','\\n','%s\\n',NULL,'No existem critrios de filtragem',NULL,19,NULL),(18,0,1,18,'Listagem Extras','Listagem Extras\\n--------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','\\n','%s\\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(19,0,1,19,'Apuramento Caixa','Apuramento Caixa\\n----------------------------------------','%s\\n','\\n',NULL,NULL,NULL,'110,104,101,111,121',19,NULL),(20,0,1,20,'Listagem Venda Artigos','Listagem Venda Artigos\\n--------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','\\n','%s\\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(21,0,1,21,'Listagem Totais por Hora','Listagem Totais por Hora\\n--------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','\\n','%s\\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(22,0,1,22,'Listagem Extras Totais','Listagem Extras\\n--------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','\\n','%s\\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(23,0,1,23,'Artigos cancelados/anulados','Artigos cancelados/anulados por empregado\\n--------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','\\n','%s\\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(24,0,1,24,'Transferncias de artigos','Artigos transferidos por empregado/data\\n--------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','\\n','%s\\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(25,0,1,25,'Artigos por empregado','Artigos por empregado\n--------------------------------------\nData inicio: (109)\nData fim: (112)','%s\n','\n','%s\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(26,0,1,26,'Vendas por fam/subfam','Vendas por familia/sub-familia\n--------------------------------------\nData inicio: (109)\nData fim: (112)','%s\n','\n','%s\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(27,0,1,27,'Fecho Mensal','\\nFecho Mensal\\n--------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','','%s\\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(28,0,1,28,'Artigos por Terminal','Artigos por Terminal\\n----------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s','','%s',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(29,0,1,29,'Resumo CC empregados','Resumo CC dos empregados\n----------------------------------------\n','%s','\n','%s',NULL,'Seleccione o empregado','102',19,NULL),(30,0,1,30,'Extracto de conta','Extracto de conta\n----------------------------------------\n','%s','\n','%s',NULL,'','125',19,NULL),(31,0,1,31,'Resumo CC clientes','Resumo CC clientes\n----------------------------------------\n','%s','\n','%s',NULL,' ','125',19,NULL),(32,0,1,32,'Pag. Comisso','Pagamento de comisso\n--------------------------------------\nCaixa: (105)\nValor: (108)\nData: (101)\nUtilizador: (103)\nTerminal: (107)\n','%s\n','\n',NULL,NULL,NULL,'101,103,105,107,108,117',4,NULL),(33,0,1,33,'Mesas/Cartes abertos','MESAS/CARTES ABERTOS\n---------------------------------------\n','%s','\n','%s\n',NULL,'No existe critrio de filtragem','101,109',19,NULL),(34,0,1,34,'Vendas por NIF','Vendas Por NIF\n----------------------------------------\nData Inicio:(109)\nData Fim:(112)\n','%s',NULL,'%s',NULL,'Listagem com detalhes das vendas por NIF, com vendas do Cliente Eventual agrupadas. Selecione o intervalo de Datas','101,111,109,112',19,NULL),(35,0,1,35,'Guias de Transporte','Guias de Transporte\r\n----------------------------------------\r\nData Inicio:(109)\r\nData Fim:(112)','%s',NULL,'%s',NULL,'Listagem com as guias de transporte emitidas. Selecione o intervalo de Datas.','101,111,109,112',19,NULL),(36,0,1,36,'Notas de crdito','Notas de crdito\r\n----------------------------------------\r\nData Inicio:(109)\r\nData Fim:(112)','%s','\n','%s',NULL,'Listagem com as notas de crdito emitidas entre datas. Seleccione o intervalo de datas.','101,111,109,112,125',19,NULL),(37,0,1,37,'Mapa de reteno na fonte','RETENO NA FONTE\n--------------------------------------\nData Inicio: (109)\nData Fim: (112)\n','%s\n','\n','%s\n',NULL,'Seleccione o intervalo de Datas','101,109,111,112,120,125',19,NULL),(38,0,1,38,'Cartes Assinados','\\n----------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','\\n','%s\\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(39,0,1,39,'Ofertas Artigos','\\n----------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','\\n','%s\\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(40,0,1,40,'Lista SubTotais','\\n----------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','\\n','%s\\n',NULL,'Lista de Subtotais com total superior ao da fatura correspondente.\n\nSeleccione o intervalo de Datas','101,111,109,112',19,NULL),(41,0,1,41,'Fecho Dia Financeiro','FECHO FINANCEIRO - (109)','%s\n','\n','%s\n',NULL,'Seleccione a data do Fecho Financeiro','101,109,111',19,NULL),(42,0,1,42,'Mapa Vendas Descontos','Mapa Vendas Descontos - (109)','%s',NULL,'%s',NULL,'Seleccione o intervalo de Datas','101,111,109,112',27,NULL),(43,0,1,43,'Metodos Pagamento Zona','Metodos Pagamento Zona\nData inicio: (109)\nData fim: (112)','%s\n',NULL,NULL,NULL,'Seleccione o intervalo de Datas','101,111,109,112',27,NULL),(44,0,1,44,'Listagem de Documentos','Listagem de Documentos\nData inicio: (109)\nData fim: (112)','%s\n',NULL,NULL,NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL),(45,0,1,45,'Fecho Dia Curto','Fecho Dia\nData (109)','%s\n',NULL,NULL,NULL,'Seleccione o intervalo de Datas','101,111,109,112',27,NULL),(46,0,1,46,'Estorno','Estorno\n--------------------------------------\nCaixa: (105)\nValor: (108)\nData: (101)\nUtilizador: (103)\nTerminal: (107)\nDescrio: (117)','%s\n','\n',NULL,NULL,NULL,'101,103,105,107,108,117',4,NULL),(47,0,1,47,'Vendas por Artigo/Zona','Vendas por Artigo/Zona\n--------------------------------------\nData Inicio: (109)\nData Fim: (112)\nProduto: (114)\nEmpregado: (103)','%s\n','\n',NULL,NULL,'Seleccione Empregado, Data Inicial e Final, Produto','101,102,111,113,109,112,114,103',27,NULL),(101,0,1,101,'Fecho Dia - Iva Total','REPORT FECHO DIA - (109)','%s\\n',' ','%s\\n',NULL,'Seleccione a data de Fecho de Dia','101,109,111',19,NULL),(127,0,1,127,'Fecho Mensal - IVA Total','\\nFecho Mensal\\n--------------------------------------\\nData inicio: (109)\\nData fim: (112)','%s\\n','','%s\\n',NULL,'Seleccione o intervalo de Datas','101,111,109,112',19,NULL);
/*!40000 ALTER TABLE `reports` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `reportsections`
--

DROP TABLE IF EXISTS `reportsections`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `reportsections` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(4) DEFAULT NULL,
  `SyncCounter` tinyint(4) DEFAULT NULL,
  `ReportUID` int(11) DEFAULT NULL,
  `HeaderText` varchar(500) DEFAULT NULL,
  `HeaderFormat` varchar(500) DEFAULT NULL,
  `DetailQuery` blob DEFAULT NULL,
  `DetailFormat` varchar(500) DEFAULT NULL,
  `FooterQuery` blob DEFAULT NULL,
  `FooterFormat` varchar(500) DEFAULT NULL,
  `Columns` tinyint(4) DEFAULT NULL,
  `OrderField` int(11) DEFAULT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=10027008 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `reportsections`
--

LOCK TABLES `reportsections` WRITE;
/*!40000 ALTER TABLE `reportsections` DISABLE KEYS */;
INSERT INTO `reportsections` VALUES (1001,0,1,1,'','\\n           -- TOTAL POR IVAS --         \\nTx    Incidencia       Valor       Total\\n----------------------------------------\\n','SELECT \r\n    CASE Q.rate\r\n             WHEN 999\r\n             THEN \'Total\'\r\n             ELSE Q.rate END,\r\n    replace(Q.valueTaxOff,\'.\',\',\'),\r\n    replace(Q.taxValue,\'.\',\',\'),\r\n    replace(Q.totalValue,\'.\',\',\'),\r\n    Q.DocDescription\r\n    FROM(     \r\n    SELECT\r\n        taxes.UID as TaxUID,\r\n    CASE WHEN (SELECT Value FROM appcore WHERE name =\'db_version\') > 385 THEN \r\n		CASE WHEN taxes.TaxRatePerc > 0 THEN \r\n			round(((taxes.TaxRate *100) + taxes.TaxRatePerc) / 100.0,2)\r\n		ELSE\r\n			round(taxes.TaxRate,0)\r\n		END\r\n	ELSE taxes.TaxRate \r\n	END AS \'rate\',\r\n        round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2) as \'valueTaxOff\', round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2) as \'taxValue\',\r\n        round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2)as \'totalValue\',\r\n        headers.DocumentTypeUID as DocType,\r\n        (SELECT Description FROM documenttypes WHERE DocumentType=headers.DocumentTypeUID AND RecordDeleted=0 GROUP BY DocumentType) as  DocDescription\r\n    FROM transactionsdetails details\r\n    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\r\n    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID \r\n    -- INNER JOIN documenttypes ON headers.DocumentTypeUID=documenttypes.DocumentType \r\n    WHERE DATE(headers.TransactionEndTime) =   \'(101)\' \r\n    AND  headers.TransactionStatus = \'N\' \r\n    AND  headers.DocumentTypeUID != 13 \r\n    GROUP by headers.DocumentTypeUID,TaxUID\r\nUNION\r\n  SELECT\r\n       999,\r\n       999,\r\n       round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2) as \'valueTaxOff\',\r\n       round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2) as \'taxValue\',\r\n       round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2)as \'totalValue\',\r\n       headers.DocumentTypeUID as DocType,\r\n       (SELECT Description FROM documenttypes WHERE DocumentType=headers.DocumentTypeUID AND RecordDeleted=0 GROUP BY DocumentType) as  DocDescription\r\n    FROM transactionsdetails details\r\n    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\r\n    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID \r\n    -- INNER JOIN documenttypes ON headers.DocumentTypeUID=documenttypes.DocumentType \r\n    WHERE DATE(headers.TransactionEndTime) =   \'(101)\' \r\n    AND  headers.TransactionStatus = \'N\' \r\n    AND  headers.DocumentTypeUID != 13 \r\n    GROUP by headers.DocumentTypeUID \r\n)AS Q ORDER BY Q.DocType,Q.TaxUID','%5.5s%12.12s%11.11s%12.12s\\n','SELECT\n    replace(round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2),\'.\',\',\') as \'valueTaxOff\',\n    replace(round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2),\'.\',\',\') as \'taxValue\',\n    replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'totalValue\'      \nFROM transactionsdetails details\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\nINNER JOIN taxes ON details.SaleTaxUID = taxes.UID \nWHERE     DATE(headers.TransactionEndTime) =  \'(101)\' \nAND  headers.TransactionStatus = \'N\' \nand  headers.DocumentTypeUID != 13;','        --------------------------------\\n%17.17s%11.11s%12.12s\\n',4,1),(1002,0,1,1,'','\\n\\n         -- TOTAL POR POSTOS --         \\nTerminal          Liquido          Valor\\n----------------------------------------\\n','SELECT \n    salesterminal.description as \'description\', \n    replace(round(sum(NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'net_value\',\n    replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'value\'\nFROM transactionsheaders headers\nINNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nINNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid\nWHERE DATE(headers.TransactionEndTime) = \'(101)\' \nAND headers.TransactionStatus = \'N\' \nAND headers.DocumentTypeUID!=13\nGroup by headers.TransactionStartTerminalUID;','%-15.15s%10.10s%15.15s\\n','SELECT \n    replace(round(sum(NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'net_value\',\n    replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'value\'\nFROM transactionsheaders headers\nINNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nINNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid\nWHERE DATE(headers.TransactionEndTime) = \'(101)\' \nAND headers.TransactionStatus = \'N\' \nAND headers.DocumentTypeUID!=13;','        --------------------------------\\n%25.25s%15.15s\\n',3,3),(1003,0,1,1,'','\n\n        -- FORMAS PAGAMENTO--           \nForma Pagamento                    Valor\n----------------------------------------\n','SELECT \r\n    pTypes.LongDescription as \'description\',\r\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE pTypes.Type in (0,3,6)\r\n    AND DATE(headers.TransactionEndTime) = \'(101)\'\r\n    and  headers.TransactionStatus = \'N\'\r\n    and  headers.DocumentTypeUID != 13 \r\nGroup by tenders.PaymentTypeUID\r\nunion\r\nSELECT \r\n    \'Dinheiro\',\r\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE pTypes.type = 1\r\n    AND DATE(headers.TransactionEndTime) = \'(101)\'\r\n    and  headers.TransactionStatus = \'N\'\r\n    and  headers.DocumentTypeUID != 13 \r\nGroup by pTypes.type\r\nUNION\r\nSELECT \r\n    \'Ret. Fonte\',\r\n    replace(SUM(ROUND(NetValue/100*WithholdingPercentage/10000,2)),\'.\',\',\') as \'value\' \r\nFROM \r\n    transactionsdetails details INNER JOIN transactionsheaders headers ON headers.UID=details.TransactionUID\r\n    WHERE \r\nWithholdingPercentage>0\r\n    AND DATE(headers.TransactionEndTime) = \'(101)\'\r\n    AND  headers.TransactionStatus = \'N\'\r\n    AND  headers.DocumentTypeUID != 13 ;','%-20.20s%20.20s\n','SELECT replace(SUM(v1),\'.\',\',\') as \'value\' FROM\r\n(\r\n    (\r\n        SELECT \r\n            round(IFNULL(sum(tenders.value),0)/100,2) as v1\r\n        FROM transactionstenders tenders\r\n            INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n            INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\n        WHERE pTypes.Type in (0,1,3,6)\r\n            AND DATE(headers.TransactionEndTime) = \'(101)\'\r\n            and headers.TransactionStatus = \'N\'\r\n            and  headers.DocumentTypeUID != 13\r\n    ) \r\n    UNION\r\n    (\r\n        SELECT\r\n            SUM(ROUND(NetValue/100*WithholdingPercentage/10000,2)) as v1\r\n        FROM \r\n            transactionsdetails details INNER JOIN transactionsheaders headers ON headers.UID=details.TransactionUID\r\n            WHERE \r\n        WithholdingPercentage>0\r\n            AND DATE(headers.TransactionEndTime) = \'(101)\'\r\n            AND  headers.TransactionStatus = \'N\'\r\n            AND  headers.DocumentTypeUID != 13\r\n    ) \r\n) AS Q;','        --------------------------------\n%40.40s\n',2,4),(1004,0,1,1,NULL,'\\n\\n        -- TOTAL POR FAMILIA  --\\nFam/Subfam        Qnt   Liquido    Valor\\n----------------------------------------\n','SELECT     Q.F,     Q.T,     Q.NV,     Q.V,     Q.C, Q.K FROM( (       SELECT         qry.fam AS F,  qry.qnt as T,         qry.net_value AS NV,         qry.value as V,     qry.code as C,         qry.fam2 as K     FROM(         SELECT         families.shortdescription as fam,      SUM(IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,1,details.Quantity)) as qnt,     replace(round(sum(details.NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as net_value, replace(round(sum(details.SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value, families.code AS code,            families.uid AS fam2 FROM transactionsdetails details INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID              INNER JOIN plus on details.PluUID = plus.uid INNER JOIN families on plus.familyid = families.uid RIGHT JOIN properties on properties.UID =plus.PropertyUID WHERE DATE(headers.TransactionEndTime) = \'(101)\' and headers.TransactionStatus = \'N\' and  headers.DocumentTypeUID != 13                      GROUP BY families.uid         ORDER by families.code     )     AS qry ) UNION (          SELECT         qry2.subfam AS F,         qry2.qnt as T,         qry2.net_value AS NV,         qry2.value as V,         qry2.code as C,         qry2.fam as K     FROM(         SELECT              concat(\"    \",subfamilies.shortdescription) as subfam,             SUM(IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,1,details.Quantity)) as qnt,             replace(round(sum(details.NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as net_value,             replace(round(sum(details.SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value,             (subfamilies.code+10000) AS code,             plus.familyid AS fam                    FROM transactionsdetails details             INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID               INNER JOIN plus on details.PluUID = plus.uid             INNER JOIN subfamilies on plus.subfamilyid = subfamilies.uid             RIGHT JOIN properties on properties.UID =plus.PropertyUID         WHERE DATE(headers.TransactionEndTime) = \'(101)\'              and headers.TransactionStatus = \'N\'              and  headers.DocumentTypeUID != 13          GROUP BY subfamilies.uid         ORDER by subfamilies.code     )     AS qry2 ) UNION (     SELECT         @label :=\"Total\" AS F,         SUM(IF(props.ReadQuantityFromScale or details.PLUDivisionState = 1,1,details.Quantity)) as T,         replace(round(sum(details.NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as NV,         replace(round(sum(details.SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as V,         999999 AS C,         999999 AS K     FROM transactionsdetails details         INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID         RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID         RIGHT JOIN properties props on props.UID =mainplus.PropertyUID     WHERE DATE(headers.TransactionEndTime) = \'(101)\'           AND headers.TransactionStatus = \'N\'         and  headers.DocumentTypeUID != 13  ) ORDER BY K,C) AS Q;','%-14.14s%6.6s%10.10s%10.10s\\n',NULL,NULL,4,5),(1005,0,1,1,NULL,'\\n\\n          -- DOC. ANULADOS --\\nHora  Doc        Empregado         Valor\\n----------------------------------------\\n','SELECT \n    DATE_FORMAT(H.ModifyDate, \'%Hh%i\') as doc_date,\n    DocumentID,\n    S.SalesmanShortName,\n    REPLACE(ROUND(TableTotal/100,2),\'.\',\',\') as doc_value\n    FROM \n        transactionsheaders AS H INNER JOIN salesmans AS S ON H.CreateSalesmanUID=S.UID\n    WHERE \n        TransactionStatus=\'A\'\n    AND\n        DATE(H.ModifyDate) = \'(101)\' \n    ORDER BY\n       doc_date;','%-5.5s %-10.10s %-10.10s %12.12s\\n','SELECT \n    REPLACE(SUM(ROUND(TableTotal/100,2)),\'.\',\',\') as doc_value\n    FROM \n        transactionsheaders H\n    WHERE \n        TransactionStatus=\'A\'\n    AND\n        DATE(TransactionEndTime) = \'(101)\' ;','        --------------------------------\\n%40.40s\\n',4,6),(1006,0,1,1,NULL,'\\n\\n          -- RESUMO DO DIA--           \\n----------------------------------------\\n','SELECT \"Ticket medio\",\nREPLACE(ROUND((SUM(TableTotal)/(SELECT COUNT(*) FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND TableTotal>0 AND DocumentTypeUID!=13 ))/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13 \nUNION\nSELECT \"Ticket maximo\",\nREPLACE(ROUND(MAX(TableTotal)/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13\nUNION\nSELECT \"Ticket minimo\",\nREPLACE(ROUND(MIN(TableTotal)/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\'  AND TableTotal>0  AND DocumentTypeUID!=13\nUNION\nSELECT \"Total\",\nREPLACE(ROUND(SUM(TableTotal)/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13 \nUNION\nSELECT \"Tickets estornados\",COUNT(*) FROM transactionsheaders WHERE TransactionStatus=\'A\' AND DATE(TransactionEndTime)>=\'(101)\' AND DATE (TransactionEndTime)<=\'(111)\' \nUNION\nSELECT \"Movimentos\",\nCOUNT(*) FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\' AND TransactionStatus = \'N\' AND DocumentTypeUID != 13;','%-20.20s%20.20s\\n',NULL,NULL,2,7),(1007,0,1,1,NULL,'\\n -- Movimentos por tipo de doc.\\n','SELECT \"Doc. inicial\",\"Doc. final\"\nUNION\nSELECT MIN(DocumentID),Max(DocumentID) From transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\' GROUP BY DocumentTypeUID;','%-18.18s -> %18.18s\\n',NULL,NULL,2,8),(1008,0,1,1,NULL,'\n          -- DESCONTOS --         \n    Pess     Total       Desc       Fact\n----------------------------------------\n','','%10.10s%10.10s%10.10s%10.10s\n','SELECT      (SELECT sum(if (headers.DocumentTypeUid <> 25,headers.CustomerCount,-1*headers.CustomerCount)) as pCount     FROM transactionsheaders headers      where headers.TransactionStatus = \'N\' AND headers.DocumentTypeUID != 13 AND DATE(headers.TransactionEndTime) between    \'(101)\'  and  \'(111)\'  ) as pessoas,    round(sum(     IF(headers.DocumentTypeUid <> 25,    (IF (details.VatIncluded,      (IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) ,     (IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) * (100 + taxes.TaxRate)/100 ))     ,-1*     (IF (details.VatIncluded,      (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) ,     (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) * (100 + taxes.TaxRate)/100 )))     )/100,2)  AS total,        round(sum(  IF(headers.DocumentTypeUid <> 25,  IF (details.VatIncluded,   (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) ,  (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) * (100 + taxes.TaxRate)/100 ),  -1*  IF (details.VatIncluded,   (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) ,  (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) * (100 + taxes.TaxRate)/100 )  )  - details.SaleValue   )/100,2)  AS descontos,         round(sum(details.SaleValue)/100,2) as faturado   FROM transactionsdetails details     INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID     INNER JOIN plus on details.PluUID = plus.uid     RIGHT JOIN properties on properties.UID =plus.PropertyUID     LEFT JOIN taxes on taxes.UID =details.SaleTaxUID WHERE headers.TransactionStatus = \'N\'     AND DATE(headers.TransactionEndTime) between    \'(101)\'  and  \'(111)\'       AND headers.DocumentTypeUID != 13    ','%10.10s%10.10s%10.10s%10.10s\n',4,10),(3001,0,1,3,NULL,'','SELECT  \n    cd.description,\n    `date`,\n    salesman.SalesmanName,\n    sales.description\n     \nFROM cashdrawer_movements mov\n    INNER JOIN cashdrawers cd on cd.UID = mov.CashDrawerUID\n    INNER JOIN salesterminal sales on sales.UID = mov.SalesTerminalUID\n    INNER JOIN salesmans salesman on salesman.UID = mov.SalesmanUID\nWHERE mov.UID = (121)','Caixa:      %-20.20s\nData:       %-20.20s\nUtilizador: %-20.20s\nTerminal:   %-20.20s',NULL,NULL,4,1),(3002,0,1,3,NULL,'\n----------------------------------------\nENTRADAS\n----------------------------------------\n    Movimentos Caixa     \n-----------------\n','SELECT \n CONCAT_WS(\' \',mType.description,mov.DocumentID) as description,\n  paytypes.longdescription as pm,\n replace(round(mov.value/100.0,2),\'.\',\',\') as \'value\'\nFROM cashdrawer_movements mov\ninner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\nleft join cashdrawertenders casht on mov.uid=casht.CashDrawerMovementUID\nleft join paymenttypes paytypes on paytypes.UID=casht.paymenttypeUID\nWHERE \n    (\n    mov.CashDrawerMovementUID = \'(121)\'\n    and mType.MovementFlow>0\n     )\n   || \n    mov.uid = \'(121)\'','%-20.20s%10.10s%10.10s\n','SELECT replace(round(sum(value)/100.0,2),\".\",\",\") as \"value\" FROM cashdrawer_movements mov inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid WHERE      (     mov.CashDrawerMovementUID = \"(121)\"     and mType.MovementFlow>0      )    ||      mov.uid =  \"(121)\"','                                   -----\n    Total: %29.29s ',3,2),(3003,0,1,3,NULL,'\n    Vendas\n    -----------------\n','SELECT \r\n    \'Dinheiro\',\r\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE pTypes.type = 1\r\n    AND tenders.MovementUID =  \'(121)\'\r\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\r\nGroup by pTypes.type\r\nUNION\r\nSELECT\r\n    pTypes.LongDescription as \'description\',\r\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE pTypes.type NOT IN (1,2,3,6) /* diferente dinheiro, facturacao externa e conta corrente*/\r\n    AND tenders.MovementUID =   \'(121)\'\r\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\r\nGroup by tenders.PaymentTypeUID;','    %-20.20s%16.16s\\n','SELECT \r\n    replace(round( IFNULL(sum(tenders.value),0)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE pTypes.type NOT IN (2,3,6) /* facturaca externa e conta corrente*/\r\n    AND tenders.MovementUID =  \'(121)\'\r\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/','                                   -----\n    Total: %29.29s',2,3),(3004,0,1,3,NULL,'',NULL,'%s','SELECT replace(round((\n(\n/*Movimentos Caixa Entrada Footer*/\nSELECT IFNULL( sum(value),0) \nFROM cashdrawer_movements mov\n    inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\nWHERE \n    (\n    mov.CashDrawerMovementUID = \'(121)\'\n    and mType.MovementFlow>0\n     )\n   || \n    mov.uid =  \'(121)\'\n)\n+\n(\n/*VENDAS DINHEIRO*/\nSELECT IFNULL( sum(value),0) \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.type = 1\n    AND tenders.MovementUID = \'(121)\'\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\n)\n+\n(\n/*VENDAS OUTROS*/\nSELECT IFNULL( sum(value),0) \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.type NOT IN (1,2,3) /* diferente dinheiro, facturacao externa e conta corrente*/\n    AND tenders.MovementUID = \'(121)\'\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\n)\n)/100,2),\'.\',\',\') as \'value\'','\\n\n                                   -----\n    Total Entradas: %20.20s\n',2,4),(3005,0,1,3,NULL,'\n----------------------------------------\nSAIDAS\n----------------------------------------\n    Movimentos Caixa\n    -----------------\n','SELECT \n    mType.description AS description,\n    IF(mov.DocumentID=\'\',mov.Description,mov.DocumentID) as DocOrDesc,\n    REPLACE(round(value/100,2),\'.\',\',\') as \'value\'\nFROM cashdrawer_movements mov\nINNER JOIN cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\nWHERE \n    mov.CashDrawerMovementUID =  \'(121)\'\n    AND mov.MovementTypeID != 2 /*exclui fecho caixa*/\n    AND mov.MovementTypeID != 12\n    AND mType.MovementFlow = 0\nAND  mov.Voided = 0 \n','    %-16.16s %-10.10s %8.8s\n','SELECT REPLACE(ROUND(\n(\n    SELECT IFNULL(sum(value),0)\n    FROM cashdrawer_movements mov\n    inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\n    WHERE \n        mov.CashDrawerMovementUID = \'(121)\'\n        and mov.MovementTypeID != 2 /*exclui fecho caixa*/\n        and mov.MovementTypeID != 12 /*exclui estornos*/\n        and mType.MovementFlow = 0\n       and mov.Voided = 0 \n)/100,2),\'.\',\',\') as \'value\';','                                   -----\\n    Total: %29.29s\\n',3,5),(3006,0,1,3,NULL,'\\n    Estornos\\n    -----------------\\n','SELECT \n    P.LongDescription AS description,\n    REPLACE(ROUND(SUM(T.Value)/100,2),\'.\',\',\') AS value\nFROM cashdrawer_movements M\nINNER JOIN cashdrawertenders T on M.UID = T.CashDrawerMovementUID\nINNER JOIN paymenttypes P on P.UID=T.PaymentTypeUID\nWHERE \n    M.CashDrawerMovementUID =  \'(121)\'\n    AND M.MovementTypeID != 2 /*exclui fecho caixa*/\n    AND M.MovementTypeID = 12\n    AND P.type NOT IN (2,3,6)\n    GROUP BY T.PaymentTypeUID;','    %-20.20s%16.16s\\n','SELECT \n    REPLACE(ROUND(SUM(T.Value)/100,2),\'.\',\',\') AS value\nFROM cashdrawer_movements M\nINNER JOIN cashdrawertenders T on M.UID = T.CashDrawerMovementUID\nINNER JOIN paymenttypes P on P.UID=T.PaymentTypeUID\nWHERE \n    M.CashDrawerMovementUID =  \'(121)\'\n    AND M.MovementTypeID != 2 /*exclui fecho caixa*/\n    AND M.MovementTypeID = 12\n    AND P.type NOT IN (2,3,6);','                                   -----\\n    Total: %29.29s',2,6),(3007,0,1,3,NULL,NULL,NULL,NULL,'SELECT \n    REPLACE(ROUND(SUM(mov.value)/100,2),\'.\',\',\') AS sum_value\nFROM cashdrawer_movements mov\nINNER JOIN cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\ninner join transactionsheaders th on th.DocumentID = mov.DocumentID\nWHERE \n    mov.CashDrawerMovementUID =  \'(121)\'\n    AND mov.MovementTypeID != 2 /*exclui fecho caixa*/\n    AND mType.MovementFlow = 0\nAND  mov.Voided = 0 \nand th.TransactionStatus = \'N\'','\\n\\n                                    ----\\n    Total saidas: %22.22s',2,7),(3008,0,1,3,NULL,'',NULL,NULL,'\nSELECT replace(round((\n(\n/*Movimentos Caixa Entrada Footer*/\nSELECT IFNULL( sum(value),0) \nFROM cashdrawer_movements mov\n    inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\nWHERE \n    (\n    mov.CashDrawerMovementUID = \'(121)\'\n    and mType.MovementFlow>0\n     )\n   || \n    mov.uid =  \'(121)\'\n)\n+\n(\n/*VENDAS DINHEIRO*/\nSELECT IFNULL( sum(value),0) \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.type = 1\n    AND  tenders.MovementUID = \'(121)\'\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\n   /*as notas de credito estao contabilizadas nas saidas de caixa!*/\n)\n+\n(\n/*VENDAS OUTROS*/\nSELECT IFNULL( sum(value),0) \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.type NOT IN (1,2,3,6) /* diferente dinheiro, facturacao externa e conta corrente*/\n    AND  tenders.MovementUID = \'(121)\'\n   AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\n)\n-\n(\n/*TOTAL DE SAIDAS*/\n(\nSELECT IFNULL(sum(0),0) \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.code = 9998\n    AND  tenders.MovementUID = \'(121)\'\n)\n+\n(\nSELECT \n    IFNULL(SUM(mov.value),0) AS sum_value\n\nFROM cashdrawer_movements mov\nINNER JOIN cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\nWHERE \n    mov.CashDrawerMovementUID =  \'(121)\'\n    AND mov.MovementTypeID != 2 /*exclui fecho caixa*/\n    AND mType.MovementFlow = 0\n    AND mov.Voided = 0 \n)\n)\n)/100,2),\'.\',\',\') as \'value\'','\\n\\n----------------------------------------\\nVALOR EM CAIXA: %-20.20s\\n',2,8),(3009,0,1,3,NULL,'\\n----------------------------------------\\nDECLARADO\\n----------------------------------------\\n','SELECT \n    pTypes.LongDescription as \'description\',\n    replace(round(tenders.value/100,2),\'.\',\',\') as \'value\'\nFROM cashdrawertenders tenders\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE CashDrawerMovementUID = (110);','    %-16.16s%20.20s\\n','SELECT \n    replace(round(IFNULL(sum(tenders.value),0)/100,2),\'.\',\',\') as \'value\'\n\nFROM cashdrawertenders tenders\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n\nWHERE CashDrawerMovementUID = (110);','                                   -----\\n    Total Declarado: %19.19s\\n',2,9),(3010,0,1,3,NULL,NULL,'SELECT REPLACE(ROUND(\r\n(\r\n   (\r\n        SELECT IFNULL( sum(value),0) \r\n        FROM cashdrawer_movements mov\r\n            INNER JOIN cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\r\n        WHERE \r\n        (\r\n        mov.CashDrawerMovementUID =  \'(121)\'\r\n        AND mType.MovementFlow>0\r\n        )\r\n       || \r\n        mov.uid =   \'(121)\'\r\n    )\r\n    +\r\n    (\r\n        SELECT IFNULL( sum(value),0) \r\n        FROM transactionstenders tenders\r\n            INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n            INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\n        WHERE pTypes.type NOT IN (2,3) /* diferente facturacao externa e conta corrente*/\r\n            AND  tenders.MovementUID =  \'(121)\'\r\n            AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\r\n    )\r\n    -\r\n    (  \r\n        SELECT IFNULL(sum(tenders.value),0) \r\n        FROM transactionstenders tenders\r\n            INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n            INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\n        WHERE pTypes.code = 9998\r\n            AND  tenders.MovementUID =  \'(121)\'\r\n            AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\r\n    )\r\n    -\r\n    (\r\n       SELECT \r\n   IFNULL(SUM(mov.value),0) AS sum_value\r\nFROM cashdrawer_movements mov\r\nINNER JOIN cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\r\nWHERE \r\n    mov.CashDrawerMovementUID =   \'(121)\'\r\n    /*AND mov.MovementTypeID != 2 exclui fecho caixa*/\r\n    AND mType.MovementFlow = 0\r\n    AND  mov.Voided = 0 \r\n    )\r\n    -\r\n    (\r\n    SELECT \r\n        IFNULL(sum(tenders.value),0) \r\n    FROM cashdrawertenders tenders\r\n        INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\n    WHERE CashDrawerMovementUID =  \'(110)\'\r\n    )\r\n)/100,2),\'.\',\',\') AS \'value\';',NULL,'SELECT REPLACE(ROUND(\n(\n   (\n        SELECT IFNULL( sum(value),0) \n        FROM cashdrawer_movements mov\n            INNER JOIN cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\n        WHERE \n        (\n        mov.CashDrawerMovementUID =  \'(121)\'\n        AND mType.MovementFlow>0\n        )\n       || \n        mov.uid =   \'(121)\'\n    )\n    +\n    (\n        SELECT IFNULL( sum(value),0) \n        FROM transactionstenders tenders\n            INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n            INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n        WHERE pTypes.type NOT IN (2,3) /* diferente facturacao externa e conta corrente*/\n            AND  tenders.MovementUID =  \'(121)\'\n            AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\n    )\n    -\n    (  \n        SELECT IFNULL(sum(0),0) \n        FROM transactionstenders tenders\n            INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n            INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n        WHERE pTypes.code = 9998\n            AND  tenders.MovementUID =  \'(121)\'\n            AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\n    )\n    -\n    (\n       SELECT \n   IFNULL(SUM(mov.value),0) AS sum_value\nFROM cashdrawer_movements mov\nINNER JOIN cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\nWHERE \n    mov.CashDrawerMovementUID =   \'(121)\'\n    AND mov.MovementTypeID != 2 /*exclui fecho caixa*/\n    AND mType.MovementFlow = 0\n    AND  mov.Voided = 0 \n    )\n    -\n    (\n    SELECT \n        IFNULL(sum(tenders.value),0) \n    FROM cashdrawertenders tenders\n        INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n    WHERE CashDrawerMovementUID =  \'(110)\'\n    )\n)/100,2),\'.\',\',\') AS \'value\';','\nDiferenca Caixa: %-20.20s\n----------------------------------------\n',2,10),(3011,0,1,3,NULL,'\\n----------------------------------------\\nDEPOSITO\\n----------------------------------------\\n','SELECT \n   \"Dinheiro Declarado\",\n    replace(round(tenders.value/100,2),\'.\',\',\') as \'value\'\n\nFROM cashdrawertenders tenders\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n\nWHERE CashDrawerMovementUID = (110)\nand pTypes.Type = 1;\n\n','    %-21.21s%15.15s\\n',NULL,NULL,2,11),(3012,0,1,3,NULL,'','SELECT mType.description, replace(round(value/100,2),\'.\',\',\') as \'value\'\nFROM cashdrawer_movements mov\ninner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\nWHERE \n    mov.uid = \'(110)\' \n    and mov.MovementTypeID = 2 /*apenas  fecho caixa*/;','    %-21.21s%15.15s\\n',NULL,NULL,2,12),(3013,0,1,3,NULL,'',NULL,'','SELECT replace(round(\n((\nSELECT IFNULL(sum(tenders.value),0) \nFROM cashdrawertenders tenders\n    INNER JOIN PaymentTypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE CashDrawerMovementUID = (110)\nand pTypes.Type = 1\n)\n-\n(\nSELECT IFNULL(sum(mov.value),0) \nFROM cashdrawer_movements mov\n	inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\nWHERE \n    mov.uid = \'(110)\' \n    and mov.MovementTypeID = 2 /*apenas  fecho caixa*/\n))	\n/100,2),\'.\',\',\') as \'value\'','                                   -----\\n      Para Deposito: %19.19s\\n',2,13),(5001,0,1,5,NULL,'\r\n\r\n         -- TOTAL FACTURADO--         \r\nTerminal                           Valor\r\n----------------------------------------\r\n','SELECT \n    salesterminal.description as \'description\', \n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\nFROM transactionsheaders headers\nINNER JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID\nINNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid\nWHERE \n    headers.SalesmanSessionID = \'(122)\' \n    and headers.TransactionStatus = \'N\' \n    and headers.documentTypeUID not in (13,25) \nGroup by headers.TransactionStartTerminalUID;','%-20.20s%20.20s\r\n','SELECT \n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\nFROM transactionsheaders headers\nINNER JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID\nINNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid\nWHERE \n	headers.SalesmanSessionID = \'(122)\' \n    and headers.TransactionStatus = \'N\'\n    and headers.documentTypeUID not in (13,25) ','        --------------------------------\r\n%40.40s\r\n',2,1),(5002,0,1,5,NULL,'\\n        -- DOC. ESTORNADOS --\\n      Data       Documento         Valor\\n----------------------------------------\\n','SELECT \n    DATE_FORMAT(ModifyDate, \'%y-%m-%d %Hh%i\') as doc_date,\n    DocumentID,\n    REPLACE(ROUND(TableTotal/100,2),\'.\',\',\') as doc_value\n    FROM \n        transactionsheaders \n    WHERE \n        TransactionStatus=\'A\'\n    AND\n        SalesmanSessionID= \'(122)\' ;\n','%-15.15s  %-10.10s %12.12s\\n','SELECT \n    REPLACE(SUM(ROUND(TableTotal/100,2)),\'.\',\',\') as doc_value\n    FROM \n        transactionsheaders H\n    WHERE \n        TransactionStatus=\'A\'\n    AND\n        SalesmanSessionID=\'(122)\';\n/*    GROUP BY \n        H.DocumentTypeUID;*/','        --------------------------------  %40.40s',3,2),(5003,0,1,5,NULL,'              --COMISSOES--            \n                                    Valor\n----------------------------------------\n','SELECT \r\n    replace(round(`Commission` /100,2),\'.\',\',\') as \'value\'\r\nFROM \r\n    `salesmansessions` \r\nWHERE \r\n    `SessionID`=\'(122)\';','%40.40s\r\n',NULL,NULL,1,5),(5004,0,1,5,NULL,'\r\n\r\n         -- CONSUMO PROPRIO --      \r\nArtigo                   Qt         Valor\r\n----------------------------------------\r\n','SELECT \r\n    details.PluName AS \'Name\',\r\n    details.Quantity AS \'qt\',\r\n    replace(round(details.SaleValue/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionsdetails details    \r\nINNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID\r\nWHERE \r\n    headers.SalesmanSessionID =  \'(122)\'\r\n    AND headers.TableID= \'(124)\'\r\n    AND headers.TransactionStatus = \'N\';','%-20.20s %6.6s %12.12s\r\n','SELECT \r\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionsheaders headers\r\nINNER JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID\r\nWHERE \r\n    headers.SalesmanSessionID =  \'(122)\'\r\n    AND headers.TableID= \'(124)\'\r\n    AND headers.TransactionStatus = \'N\';','        --------------------------------\r\n%40.40s\r\n',3,6),(5005,0,1,5,NULL,'\r\n\r\n         -- SALDO ACTUAL--                \r\n----------------------------------------\r\n','SELECT  replace(round(COALESCE(customers.Balance,0)/100,2),\'.\',\',\') as \'value\' FROM customers WHERE UID=\'(125)\';','%40.40s\r\n',NULL,NULL,1,7),(5006,0,1,5,NULL,'\\n        --   NOTAS CREDITO  --\\n      Data       Documento         Valor\\n----------------------------------------\\n','SELECT \n    DATE_FORMAT(ModifyDate, \'%y-%m-%d %Hh%i\') as doc_date,\n    DocumentID,\n    REPLACE(ROUND(TableTotal/100,2),\'.\',\',\') as doc_value\n    FROM \n        transactionsheaders \n    WHERE \n         DocumentTypeUID = 25\n		 AND TransactionStatus=\'N\'\n		 AND SalesmanSessionID= \'(122)\' ;','%-15.15s  %-10.10s %12.12s\\n','SELECT \n    REPLACE(SUM(ROUND(TableTotal/100,2)),\'.\',\',\') as doc_value\n    FROM \n        transactionsheaders H\n    WHERE \n		DocumentTypeUID = 25\n		AND TransactionStatus=\'N\'\n		AND SalesmanSessionID= \'(122)\' ;','        --------------------------------  %40.40s',3,3),(5007,0,1,5,NULL,'\\n        -- TOTAL APURADO --\\n',NULL,NULL,'SELECT \n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\nFROM transactionsheaders headers\nINNER JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID\nINNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid\nWHERE \n	headers.SalesmanSessionID = \'(122)\' \n    and headers.TransactionStatus = \'N\'','        --------------------------------  %40.40s',3,4),(6001,0,1,6,' ','\\n\\n         -- TOTAL POR Empregado --\\n\\nEmpregado                          Valor\\n----------------------------------------\\n','SELECT \r\n    salesmans.SalesmanName as \'description\', \r\n    REPLACE(round(sum(details.salevalue-details.salevalue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionsheaders headers\r\n    INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\r\n    INNER JOIN salesmans on headers.ModifySalesmanUID = salesmans.UID\r\nWHERE DATE(headers.TransactionEndTime)>= \'(101)\' \r\n    and DATE(headers.TransactionEndTime)<= \'(111)\' \r\n    and headers.TransactionStatus = \'N\' \r\n    and   headers.ModifySalesmanUID like\'(102)\'\r\n    and details.PluUID like \'(113)\'\r\n    and headers.documentTypeUid != 13 -- guias\r\nGroup by headers.ModifySalesmanUID;','%-20.20s%20.20s\\n','SELECT \r\n    replace(round(IFNULL(sum(details.salevalue-details.salevalue*headers.DiscountPercent/100),0)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionsheaders headers\r\n    INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\r\n    INNER JOIN salesmans on headers.ModifySalesmanUID = salesmans.UID\r\nWHERE DATE(headers.TransactionEndTime)>= \'(101)\' \r\n    and DATE(headers.TransactionEndTime)<= \'(111)\' \r\n    and headers.TransactionStatus = \'N\' \r\n    and   headers.ModifySalesmanUID like \'(102)\'\r\n    and details.PluUID like \'(113)\'\r\n    and headers.documentTypeUid != 13 -- guias','        --------------------------------\\n%40.40s\\n',2,0),(6002,0,1,6,NULL,'\\n\\n    -- TOTAL POR Empregado/Data --\\n\\nEmpregado           Data           Valor\\n----------------------------------------\\n','SELECT \r\n    salesmans.SalesmanName as \'description\', \r\n    Date(headers.TransactionEndTime),\r\n    replace(round(sum(details.salevalue-details.salevalue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionsheaders headers\r\n    INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\r\n    INNER JOIN salesmans on headers.ModifySalesmanUID = salesmans.UID\r\nWHERE DATE(headers.TransactionEndTime)>= \'(101)\' \r\n    and DATE(headers.TransactionEndTime)<= \'(111)\' \r\n    and headers.TransactionStatus = \'N\' \r\n    and   headers.ModifySalesmanUID like\'(102)\'\r\n    and details.PluUID like \'(113)\'\r\n    and headers.documentTypeUid != 13 -- guias\r\nGroup by headers.ModifySalesmanUID,Date(headers.TransactionEndTime)','%-20.20s%-12.12s%8.8s\\n','SELECT \r\n    replace(round(IFNULL(sum(details.salevalue-details.salevalue*headers.DiscountPercent/100),0)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionsheaders headers\r\n    INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\r\n    INNER JOIN salesmans on headers.ModifySalesmanUID = salesmans.UID\r\nWHERE DATE(headers.TransactionEndTime)>= \'(101)\' \r\n    and DATE(headers.TransactionEndTime)<= \'(111)\' \r\n    and headers.TransactionStatus = \'N\' \r\n    and   headers.ModifySalesmanUID like \'(102)\'\r\n    and details.PluUID like \'(113)\'\r\n    and headers.documentTypeUid != 13 -- guias','        --------------------------------\\n%40.40s\\n',3,0),(7001,0,1,7,NULL,'\\n\\n         -- DOCUMENTOS ANULADOS --\\n\\nDocumento Data        Empregado    Valor\\n----------------------------------------\\n','SELECT \n    DocumentID,\n    Date(headers.TransactionEndTime),\n    salesmans.salesmanname,\n    replace(round(sum(details.salevalue)/100,2),\'.\',\',\') as \'value\'\n\nFROM transactionsdetails details\n    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\n    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID \n    INNER JOIN salesmans on salesmans.uid = headers.CreateSalesmanUID\n\nWHERE DATE(headers.TransactionEndTime)>= \'(101)\' \n    and DATE(headers.TransactionEndTime)<= \'(111)\' \n    and headers.TransactionStatus = \'A\' \n    and   headers.ModifySalesmanUID like\'(102)\'\n    and details.PluUID like \'(113)\'\n\nGROUP BY headers.uid;\n','%-10.10s%-12.12s%10.10s%8.8s\\n','SELECT \n    replace(round(IFNULL(sum(details.salevalue),0)/100,2),\'.\',\',\') as \'value\'\n\nFROM transactionsdetails details\n    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\n    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID \n    INNER JOIN salesmans on salesmans.uid = headers.CreateSalesmanUID\n\nWHERE DATE(headers.TransactionEndTime)>= \'(101)\' \n    and DATE(headers.TransactionEndTime)<= \'(111)\' \n    and headers.TransactionStatus = \'A\' \n    and   headers.ModifySalesmanUID like\'(102)\'\n    and details.PluUID like \'(113)\'\n','        --------------------------------\\n%40.40s\\n',4,0),(8001,0,1,8,NULL,'\\nDescricao        Qtd    Liquido    Valor\\n----------------------------------------\\n','SELECT    details.PluName,    SUM(IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1, IF(headers.documentTypeUID != 25, details.Quantity/1000, -1*details.Quantity/1000), IF(headers.documentTypeUID != 25, details.Quantity, -1*details.Quantity))) AS q,   REPLACE(round(sum(details.NetValue-details.NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') AS \'net_value\',   REPLACE(round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') AS \'value\' FROM transactionsdetails details INNER JOIN transactionsheaders headers ON headers.uid = details.TransactionUID INNER JOIN taxes ON details.SaleTaxUID = taxes.UID INNER JOIN salesmans ON salesmans.uid = headers.CreateSalesmanUID INNER JOIN plus ON details.PluUID = plus.uid RIGHT JOIN properties ON properties.UID = plus.PropertyUID WHERE   DATE(headers.TransactionEndTime)>= \'(101)\'   AND DATE(headers.TransactionEndTime)<= \'(111)\'   AND headers.TransactionStatus = \'N\'   AND headers.ModifySalesmanUID LIKE \'(102)\'   AND details.PluUID LIKE \'(113)\'   AND headers.documentTypeUID != 13 GROUP BY details.pluuid, details.PluName ORDER BY q DESC','%-15.15s%5.5s%10.10s%10.10s\\n','SELECT \n    replace(round(sum(details.NetValue-details.NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'net_value\',\n    replace(round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'value\'\nFROM transactionsdetails details\n    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\n    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID \n    INNER JOIN salesmans on salesmans.uid = headers.CreateSalesmanUID\nWHERE DATE(headers.TransactionEndTime)>= \'(101)\' \n    and DATE(headers.TransactionEndTime)<= \'(111)\' \n    and headers.TransactionStatus = \'N\' \n    and   headers.ModifySalesmanUID like\'(102)\'\n    and details.PluUID like \'(113)\'\n    and headers.documentTypeUID  != 13 -- guias','        --------------------------------\\n%30.30s%10.10s\\n',4,0),(15001,0,1,15,NULL,'\n           -- IVAS--         \nTx    Incidencia       Valor       Total\n----------------------------------------\n','SELECT\r\n    CASE WHEN (SELECT Value FROM appcore WHERE name =\'db_version\') > 385 THEN \r\n		CASE WHEN taxes.TaxRatePerc > 0 THEN \r\n			round(((taxes.TaxRate *100) + taxes.TaxRatePerc) / 100.0,2)\r\n		ELSE\r\n			round(taxes.TaxRate,0)\r\n		END\r\n	ELSE taxes.TaxRate \r\n	END AS \'rate\',\r\n    replace(round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2),\'.\',\',\') as \'valueTaxOff\',\r\nreplace(round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2),\'.\',\',\') as \'taxValue\',\r\n    replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'totalValue\'      \r\nFROM transactionsdetails details\r\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\r\nINNER JOIN taxes ON details.SaleTaxUID = taxes.UID \r\nWHERE     DATE(headers.TransactionEndTime)  between \'(101)\'  and \'(111)\' \r\nAND  headers.TransactionStatus = \'N\' \r\nand  headers.DocumentTypeUID != 13\r\nGroup by SaleTaxUID','%5.5s%11.11s%12.12s%12.12s\\n\n','SELECT\n    replace(round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2),\'.\',\',\') as \'valueTaxOff\',\n    replace(round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2),\'.\',\',\') as \'taxValue\',\n    replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'totalValue\'      \nFROM transactionsdetails details\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\nINNER JOIN taxes ON details.SaleTaxUID = taxes.UID \nWHERE     DATE(headers.TransactionEndTime) between \'(101)\'  and \'(111)\' \nAND  headers.TransactionStatus = \'N\' \nand  headers.DocumentTypeUID != 13;','        --------------------------------\n%16.16s%12.12s%12.12s\n',4,4),(15002,0,1,15,NULL,'\\n\\n         -- VENDAS DIA (TOTAIS) --         \\nData               Liquido         Valor\\n----------------------------------------\\n','SELECT \r\n    DATE(headers.TransactionEndTime)as dateDay,\r\n    round(sum(details.NetValue-details.NetValue*headers.DiscountPercent/100)/100,2) as \'net_value\',\r\n    round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2) as \'value\'\r\nFROM transactionsdetails details\r\n    INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID\r\nWHERE DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\r\n   AND headers.TransactionStatus = \'N\'\r\n   and  headers.DocumentTypeUID != 13\r\nGROUP BY dateDay;','%-15.15s%10.10s%15.15s\\n','SELECT \r\n    round(sum(details.NetValue-details.NetValue*headers.DiscountPercent/100)/100,2) as \'net_value\',\r\n    round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2) as \'value\'\r\nFROM transactionsdetails details\r\n    INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID\r\nWHERE DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\r\n    AND headers.TransactionStatus = \'N\'\r\n    and  headers.DocumentTypeUID != 13','        --------------------------------\\n%25.25s%15.15s\\n',3,2),(16001,0,1,16,NULL,'\\n\\n        -- FORMAS PAGAMENTO--           \\nForma Pagamento                    Valor\\n----------------------------------------\\n','SELECT \n    (select case pTypes.code when \'9999\' then \'Dinheiro\' when \'9998\' then \'Dinheiro\' else pTypes.LongDescription end) AS description,\n    round(sum(tenders.value)/100,2) as \'value\'\n    \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n    \nWHERE DATE(headers.TransactionEndTime)between \'(101)\' and \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n    \nGROUP BY description;\n','%-20.20s%20.20s\\n','SELECT \n    round(sum(tenders.value)/100,2) as \'value\'\n    \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n    \nWHERE DATE(headers.TransactionEndTime)between \'(101)\' and \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n    \n','        --------------------------------\\n%40.40s\\n',2,3),(16002,0,1,16,NULL,'\\n\\n         -- VENDAS DIA --         \\nData      Forma Pagamento          Valor\\n----------------------------------------\\n','SELECT \n    DATE(headers.TransactionEndTime)as dateDay,\n    (select case pTypes.code when \'9999\' then \'Dinheiro\' when \'9998\' then \'Dinheiro\' else pTypes.LongDescription end) AS description,\n    round(sum(tenders.value)/100,2) as \'value\'\n    \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n    \nWHERE DATE(headers.TransactionEndTime)between \'(101)\' and \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n    \nGROUP BY dateDay,description;\n','%10.10s%20.20s%10.10s\\n','SELECT \n    round(sum(tenders.value)/100,2) as \'value\'\n    \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n    \nWHERE DATE(headers.TransactionEndTime)between \'(101)\' and \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n    ','        --------------------------------\\n%40.40s\\n',3,1),(17001,0,1,17,NULL,'\\n\\nFam SubFam   Cod   PLU   Artigo   Preco\\n----------------------------------------\\n','SELECT \r\n    IF(qry.pFamily =  @lastFamily,\'\',   @lastFamily:=   qry.pFamily) AS family,\r\n    IF(qry.pSubFamily =@lastSubFamily,\'\',@lastSubFamily:=qry.pSubFamily) AS subFamily,\r\n    qry.pUid,\r\n    qry.pPlu,\r\n    qry.pDescription, \r\n    replace(round(qry.pSalesPrice/100,2),\'.\',\',\') as pPrice,\r\n    replace(round(qry.pSalesPrice2/100,2),\'.\',\',\') as pPrice2,\r\n    replace(round(qry.pSalesPrice3/100,2),\'.\',\',\') as pPrice3,\r\n    replace(round(qry.pSalesPrice4/100,2),\'.\',\',\') as pPrice4,\r\n    replace(round(qry.pSalesPrice5/100,2),\'.\',\',\') as pPrice5\r\nFROM (\r\n    SELECT\r\n    @lastFamily =\'\',\r\n    @lastSubFamily =\'\',\r\n    IF(sf.RecordDeleted=0,\r\n        SUBSTR(concat(f.description,\"\r\n\"),1,20),\r\n        SUBSTR(concat(\"Sem familia\r\n\"),1,20)) AS pFamily,\r\n    IF(sf.RecordDeleted=0,\r\n        SUBSTR(concat(\"    \",sf.description,\"\r\n\"),1,30),\r\n        SUBSTR(concat(\"\"),1,30))\r\n        AS pSubFamily,\r\n    p.ItemID AS pUid,\r\n    IF(p.ProductLookUp IS NULL,\'0\',p.ProductLookUp) AS pPlu,\r\n    SUBSTR(p.ShortDescription1,1,20) AS pDescription, \r\n    SUBSTR(prop.SalesPrice1,1,10) AS pSalesPrice,\r\n    SUBSTR(prop.SalesPrice2,1,10) AS pSalesPrice2,\r\n    SUBSTR(prop.SalesPrice3,1,10) AS pSalesPrice3,\r\n    SUBSTR(prop.SalesPrice4,1,10) AS pSalesPrice4,\r\n    SUBSTR(prop.SalesPrice5,1,10) AS pSalesPrice5\r\n    FROM plus p\r\n    INNER JOIN properties prop on p.PropertyUID = prop.uid \r\n    INNER JOIN families f on p.FamilyID = f.UID\r\n    INNER JOIN subfamilies sf on p.SubFamilyID = sf.UID \r\n    WHERE p.RecordDeleted=0 \r\n    ORDER BY pFamily, pSubFamily,pDescription\r\n) AS qry','%s%s %10.10s %5.5s%15.20s\\n %7.7s %7.7s %7.7s %7.7s %7.7s\\n',NULL,NULL,10,0),(18001,0,1,18,NULL,'\n\n   -- ARTIGOS POR DIA/EXTRA --  \nExtra Qtd     Artigo               Total\n----------------------------------------\n','SELECT\n    IF(qry.pDate =  @lastDate,\'\',   @lastDate:=   qry.pDate) AS Data,\n    IF(qry.pExtra =@lastExtra,\'\',@lastExtra:=qry.pExtra) AS Extra,\n    qry.pCount,\n    qry.pParent,\n    replace(round(qry.pPrice/100,2),\'.\',\',\') as pPrice\nFROM(\n    SELECT \n        @lastDate :=\'\',\n        @lastExtra :=\'\',\n        CONCAT(DATE_FORMAT(H.TransactionEndTime,\"%d-%m-%y\"),\"\\n\") as pDate,\n        CONCAT(D.PluName,\"\\n\") pExtra,\n        D.PluName as pParent,\n        Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,\n        sum(D.SaleValue) as pPrice\n\n    FROM transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 \n    AND DATE(H.TransactionEndTime) BETWEEN  \'(101)\' AND \'(111)\' \n    GROUP BY pDate, pExtra, pParent\n) AS qry;','%s%s     %-5.5s %-19.19s %9.9s\n',NULL,NULL,5,0),(18002,0,1,18,NULL,'\\n\\n   -- TOTAIS POR DIA/EXTRA --  \\nData     Extra               Qtd   Total\\n----------------------------------------\\n','SELECT\n    IF(qry.pDate =  @lastDate2,\'\', @lastDate2:= qry.pDate) AS Data,\n    IF(qry.pExtra = @lastExtra2,\'\', @lastExtra2:=qry.pExtra) AS Extra,\n    qry.pCount,\n    round(qry.pPrice/100,2) as pPrice    \nFROM(\n    SELECT \n        @lastDate2 :=\'\',\n        @lastExtra2 :=\'\',\n        DATE_FORMAT(H.TransactionEndTime,\"%d-%m-%y\") as pDate,\n        D.PluName pExtra,\n        Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,\n        sum(D.SaleValue) as pPrice\n    FROM transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 \n    AND DATE(H.TransactionEndTime) BETWEEN  \'(101)\' AND \'(111)\' \n    GROUP BY pDate, pExtra\n) AS qry;','%-8.8s %-18.18s %3.3s %8.8s\\n',NULL,NULL,4,1),(18003,0,1,18,NULL,'\\n\\n   -- TOTAIS POR EXTRA  --  \\nExtra                       Qtd    Total\\n----------------------------------------\\n','SELECT\n    qry.pExtra,\n    qry.pCount,\n    round(qry.pPrice/100,2) as pPrice\nFROM(\n    SELECT \n        D.PluName pExtra,\n                Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,\n        sum(D.SaleValue) as pPrice\n    FROM \n        transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 \n        AND DATE(H.TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\' \n    GROUP BY pExtra\n) AS qry;','%-27.27s %3.3s %8.8s\\n','SELECT qry.pCount, round(qry.pPrice/100,2) AS pPrice FROM (SELECT D.PluName pExtra, SUM(IF(H.documentTypeUID != 25, D.quantity,-1 * D.quantity)) AS pCount, SUM(D.SaleValue) AS pPrice FROM transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID = H.UID WHERE D.ParentID != 0 AND DATE(H.TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\' GROUP BY pExtra) AS qry','        --------------------------------\\n%31.31s %8.8s\\n',3,2),(19001,0,1,19,NULL,'','SELECT  \n    cd.description,\n    `date`,\n    salesman.SalesmanName,\n    sales.description\n     \nFROM cashdrawer_movements mov\n    INNER JOIN cashdrawers cd on cd.UID = mov.CashDrawerUID\n    INNER JOIN salesterminal sales on sales.UID = mov.SalesTerminalUID\n    INNER JOIN salesmans salesman on salesman.UID = mov.SalesmanUID\nWHERE mov.UID = (121)','Caixa:      %-20.20s\nData:       %-20.20s\nUtilizador: %-20.20s\nTerminal:   %-20.20s',NULL,NULL,4,1),(19002,0,1,19,NULL,'\n----------------------------------------\nENTRADAS\n----------------------------------------\n    Movimentos Caixa     \n-----------------\n','SELECT \n CONCAT_WS(\' \',mType.description,mov.DocumentID) as description,\n  paytypes.longdescription as pm,\n replace(round(mov.value/100.0,2),\'.\',\',\') as \'value\'\nFROM cashdrawer_movements mov\ninner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\nleft join cashdrawertenders casht on mov.uid=casht.CashDrawerMovementUID\nleft join paymenttypes paytypes on paytypes.UID=casht.paymenttypeUID\nWHERE \n    (\n    mov.CashDrawerMovementUID = \'(121)\'\n    and mType.MovementFlow>0\n     )\n   || \n    mov.uid = \'(121)\'','%-20.20s%10.10s%10.10s\n','SELECT replace(round(sum(value)/100.0,2),\".\",\",\") as \"value\" FROM cashdrawer_movements mov inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid WHERE      (     mov.CashDrawerMovementUID = \"(121)\"     and mType.MovementFlow>0      )    ||      mov.uid =  \"(121)\"','                                   -----\n    Total: %29.29s ',3,2),(19003,0,1,19,NULL,'\n    Vendas\n    -----------------\n','SELECT \r\n    \'Dinheiro\',\r\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE pTypes.type = 1\r\n    AND tenders.MovementUID =  \'(121)\'\r\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\r\nGroup by pTypes.type\r\nUNION\r\nSELECT\r\n    pTypes.LongDescription as \'description\',\r\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE pTypes.type NOT IN (1,2,3,6) /* diferente dinheiro, facturacao externa e conta corrente*/\r\n    AND tenders.MovementUID =   \'(121)\'\r\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\r\nGroup by tenders.PaymentTypeUID;','    %-20.20s%16.16s\r\n','SELECT \n    replace(round( IFNULL(sum(tenders.value),0)/100,2),\'.\',\',\') as \'value\'\nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.type NOT IN (2,3,6) /* facturacao externa e conta corrente e pontos*/\n    AND tenders.MovementUID =  \'(121)\'\n   AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/','                                   -----\n    Total: %29.29s',2,3),(19004,0,1,19,NULL,'',NULL,'%s','SELECT replace(round((\n(\n/*Movimentos Caixa Entrada Footer*/\nSELECT IFNULL( sum(mov.value),0) \nFROM cashdrawer_movements mov\n    inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\nleft join cashdrawertenders t on t.CashDrawerMovementUID = mov.UID\nWHERE \n    (\n    mov.CashDrawerMovementUID = \'(121)\'\n    and mov.Voided = 0\n    and mType.MovementFlow>0\nand (t.PaymentTypeUID <> 9997 || t.PaymentTypeUID is NULL)\n     )\n   || \n    mov.uid =  \'(121)\'\n)\n+\n(\n/*VENDAS DINHEIRO*/\nSELECT IFNULL( sum(value),0) \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.type = 1\n    AND tenders.MovementUID = \'(121)\'\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\n)\n+\n(\n/*VENDAS OUTROS*/\nSELECT IFNULL( sum(value),0) \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.type NOT IN (1,2,3) /* diferente dinheiro, facturacaoo externa e conta corrente*/\n    AND tenders.MovementUID = \'(121)\'\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\n)\n)/100,2),\'.\',\',\') as \'value\'','\\n\n                                   -----\n    Total Entradas: %20.20s\n',2,4),(19005,0,1,19,NULL,'\n----------------------------------------\nSAIDAS\n----------------------------------------\n    Movimentos Caixa\n    -----------------\n','SELECT \n    mType.description AS description,\n    IF(mov.DocumentID=\'\',mov.Description,mov.DocumentID) as DocOrDesc,\n    REPLACE(round(value/100,2),\'.\',\',\') as \'value\'\nFROM cashdrawer_movements mov\nINNER JOIN cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\nWHERE \n    mov.CashDrawerMovementUID =  \'(121)\'\n    and mov.Voided = 0\n    AND mov.MovementTypeID != 2 /*exclui fecho caixa*/\n    AND mov.MovementTypeID != 12\n    AND mType.MovementFlow = 0;','    %-16.16s %-10.10s %8.8s\n','SELECT REPLACE(ROUND(\n(\n    SELECT IFNULL(sum(value),0)\n    FROM cashdrawer_movements mov\n    inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\n    WHERE \n        mov.CashDrawerMovementUID = \'(121)\'\n        and mov.Voided = 0\n        and mov.MovementTypeID != 2 /*exclui fecho caixa*/\n        and mov.MovementTypeID != 12 /*exclui estornos*/\n        and mType.MovementFlow = 0\n)/100,2),\'.\',\',\') as \'value\';','                                   -----\\n    Total: %29.29s\\n',3,5),(19006,0,1,19,NULL,'\\n    Estornos\\n    -----------------\\n','SELECT \n    P.LongDescription AS description,\n    REPLACE(ROUND(SUM(T.Value)/100,2),\'.\',\',\') AS value\nFROM cashdrawer_movements M\nINNER JOIN cashdrawertenders T on M.UID = T.CashDrawerMovementUID\nINNER JOIN paymenttypes P on P.UID=T.PaymentTypeUID\nWHERE \n    M.CashDrawerMovementUID =  \'(121)\'\n    and M.Voided = 0\n    AND M.MovementTypeID != 2 /*exclui fecho caixa*/\n    AND M.MovementTypeID = 12\n    AND P.type NOT IN (2,3,6)\n    GROUP BY T.PaymentTypeUID;','    %-20.20s%16.16s\\n','SELECT \n    REPLACE(ROUND(SUM(T.Value)/100,2),\'.\',\',\') AS value\nFROM cashdrawer_movements M\nINNER JOIN cashdrawertenders T on M.UID = T.CashDrawerMovementUID\nINNER JOIN paymenttypes P on P.UID=T.PaymentTypeUID\nWHERE \n    M.CashDrawerMovementUID =  \'(121)\'\n    and M.Voided = 0\n    AND M.MovementTypeID != 2 /*exclui fecho caixa*/\n    AND M.MovementTypeID = 12\n    AND P.type NOT IN (2,3,6);','                                   -----\\n    Total: %29.29s',2,6),(19007,0,1,19,NULL,NULL,NULL,NULL,'SELECT \nREPLACE(ROUND(SUM(mov.value)/100,2),\'.\',\',\') AS sum_value\nFROM cashdrawer_movements mov\nINNER JOIN cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\ninner join transactionsheaders th on th.DocumentID = M.DocumentID\n\nWHERE \n    mov.CashDrawerMovementUID =  \'(121)\'\n    AND mov.MovementTypeID != 2 /*exclui fecho caixa*/\n    AND mType.MovementFlow = 0\n    AND mov.Voided = 0 \nand th.TransactionStatus = \'N\' ','\\n\\n                                    ----\\n    Total saidas: %22.22s',2,7),(19008,0,1,19,NULL,'',NULL,NULL,'SELECT replace(round((\n(\n/*Movimentos Caixa Entrada Footer*/\nSELECT IFNULL( sum(mov.value),0) \nFROM cashdrawer_movements mov\n    inner join cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\n	left join cashdrawertenders t on t.CashDrawerMovementUID = mov.UID\nWHERE \n    (\n    mov.CashDrawerMovementUID = \'(121)\'\n	and mov.Voided = 0\n    and mType.MovementFlow>0\n	and (t.PaymentTypeUID <> 9997 || t.PaymentTypeUID is NULL)\n     )\n   || \n    mov.uid =  \'(121)\' \n)\n+\n(\n/*VENDAS DINHEIRO*/\nSELECT IFNULL( sum(value),0) \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.type = 1\n    AND  tenders.MovementUID = \'(121)\'\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\n)\n+\n(\n/*VENDAS OUTROS*/\nSELECT IFNULL( sum(value),0) \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.type NOT IN (1,2,3,6) /* diferente dinheiro, facturao externa e conta corrente*/\n    AND  tenders.MovementUID = \'(121)\'\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/\n)\n-\n(\n/*TOTAL DE SAIDAS*/\n(\nSELECT IFNULL(sum(tenders.value),0) \nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.code = 9998\n    AND  tenders.MovementUID = \'(121)\'\n    AND headers.DocumentTypeUID!=25 /*nao e nota de credito*/   \n)\n+\n(\nSELECT \n    IFNULL(SUM(mov.value),0) AS sum_value\n\nFROM cashdrawer_movements mov\nINNER JOIN cashdrawermovementtypes mType on mov.MovementTypeID = mType.uid\nWHERE \n    mov.CashDrawerMovementUID =  \'(121)\'\n    AND mov.MovementTypeID != 2 /*exclui fecho caixa*/\n    AND mType.MovementFlow = 0\n    AND mov.Voided = 0 \n)\n)\n)/100,2),\'.\',\',\') as \'value\'','\n\n----------------------------------------\nVALOR EM CAIXA: %-20.20s\n',2,8),(20001,0,1,20,NULL,'\n\nProduto            qt       Total   Perc\n----------------------------------------\n','SELECT     qry.plu,     IF(qry.ispeso>0,concat(format(qry.qt/1000,3),\"Kg\"),concat(qry.qt,\" Un\")) as qt,     round(qry.value/100,2) as lineValue,     truncate(qry.value*100/(         SELECT sum(details.SaleValue) FROM transactionsdetails details INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID WHERE DATE(headers.TransactionEndTime)BETWEEN  \'(101)\'  AND \'(111)\' AND headers.TransactionStatus = \'N\'   AND headers.documentTypeUID  != 13         ),2) as perc FROM(     SELECT          PluName as plu,         round(Sum(IF(headers.documentTypeUID != 25,IF(details.PLUDivisionState = 1, details.Quantity /1000,details.Quantity),-1*details.Quantity)),2) as qt,         props.ReadQuantityFromScale as ispeso,         sum(details.SaleValue-details.salevalue*headers.DiscountPercent/100) as value     FROM transactionsdetails details         INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID         RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID         RIGHT JOIN properties props on props.UID =mainplus.PropertyUID     WHERE DATE(headers.TransactionEndTime)BETWEEN  \'(101)\'  AND \'(111)\'          AND headers.TransactionStatus = \'N\'         AND headers.documentTypeUID  != 13   GROUP BY PluName     HAVING QT > 0       ORDER BY plu ) as qry;','%-13.13s %9.9s %10.10s %6.6s\n','SELECT SUM( IF(props.ReadQuantityFromScale  or details.PLUDivisionState = 1, IF(headers.documentTypeUID != 25,1,-1), IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity) )) as newqt,     round(sum(details.SaleValue-details.salevalue*headers.DiscountPercent/100)/100,2) as value  FROM transactionsdetails details        INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID        RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID        RIGHT JOIN properties props on props.UID =mainplus.PropertyUID     WHERE DATE(headers.TransactionEndTime)BETWEEN  \'(101)\'  AND \'(111)\'          AND headers.TransactionStatus = \'N\'         AND headers.documentTypeUID  != 13 -- guias','%21.21s %11.11s\n',4,0),(21001,0,1,21,NULL,'\n\nIntervalo                          Total\n----------------------------------------\n','\r\nSELECT CONCAT( LPAD(HOUR(headers.TransactionEndTime),2,\'0\'),\':\',LPAD( FLOOR(MINUTE(details.CreateDate)/15)*15, 2, \'0\'), \'-\', LPAD( (FLOOR(MINUTE(headers.TransactionEndTime)/15)+1)*15, 2, \'0\' )) AS minRange,\r\n       round(SUM(SaleValue-details.salevalue*headers.DiscountPercent/100)/100,2) AS sales\r\nFROM   transactionsdetails details \r\nINNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID \r\nWHERE DATE(headers.TransactionEndTime)BETWEEN  \'(101)\'  AND \'(111)\' \r\n        AND headers.TransactionStatus = \'N\'\r\n        AND headers.documentTypeUID  != 13 -- guias\r\nGROUP BY minRange\r\nORDER BY minRange;\r\n\r\n','%-20.20s%20.20s\n',NULL,NULL,2,0),(22001,0,1,22,NULL,'\\n\\n   -- Totais POR DIA/EXTRA --  \\nData      Extra            Qtd   Total\\n----------------------------------------\\n','SELECT\n    IF(qry.pDate =  @lastDate2,\'\', @lastDate2:= qry.pDate) AS Data,\n    IF(qry.pExtra = @lastExtra2,\'\', @lastExtra2:=qry.pExtra) AS Extra,\n    qry.pCount,\n    round(qry.pPrice/100,2) as pPrice\nFROM(\nSELECT \n    @lastDate2 :=\'\',\n    @lastExtra2 :=\'\',\n    DATE_FORMAT(H.TransactionEndTime,\"%d-%m-%y\") as pDate,\n    D.PluName pExtra,\n    Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,\n    sum(D.SaleValue) as pPrice\nFROM \n    transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 \n    AND DATE(H.TransactionEndTime) BETWEEN  \'(101)\' AND \'(111)\' \n    GROUP BY pDate, pExtra\n) AS qry','%-8.8s %-18.18s %3.3s %8.8s\\n',NULL,NULL,4,1),(22002,0,1,22,NULL,'\\n\\n   -- TOTAIS POR EXTRA  --  \\nExtra                       Qtd    Total\\n----------------------------------------\\n','SELECT\n    qry.pExtra,\n    qry.pCount,\n    round(qry.pPrice/100,2) as pPrice\n    \nFROM(\n    SELECT \n        D.PluName pExtra,\n        Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,\n        sum(D.SaleValue) as pPrice\n    FROM \n        transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 \n        AND DATE(H.TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\' \n    GROUP BY pExtra\n) AS qry;','%-27.27s %3.3s %8.8s\\n','SELECT\n    qry.pCount,\n    round(qry.pPrice/100,2) as pPrice\nFROM(\n    SELECT \n        D.PluName pExtra,\n        Sum(IF(H.documentTypeUID != 25,D.quantity,-1*D.quantity)) as pCount,\n        sum(D.SaleValue) as pPrice\n    FROM \n        transactionsheaders H INNER JOIN transactionsdetails D ON D.TransactionUID=H.UID  WHERE D.ParentID!=0 \n        AND DATE(H.TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\' \n) AS qry;','        --------------------------------\\n%31.31s %8.8s\\n',3,2),(23001,0,1,23,NULL,'\\n\\n -- Artigos cancelados por empregado -- \\n   Hora       Qt    Artigo      Valor\\n----------------------------------------\\n','SELECT  \r\n        IF(Q._name=@lastName,\'\',@lastName:=Q._name) AS OpSalesman,\r\n        IF(Q._date=@lastDate,\'\',@lastDate:=Q._date) AS OpDate,\r\n        Q._time AS OpTime,\r\n        Q._mesas AS OpTable,\r\n        Q._qt AS OpQt,\r\n        SUBSTR(Q._artigo,1,12) AS OpItem,\r\n        CONCAT(SUBSTR(Q._value,1,6),\"\\n\") AS OpValue\r\nFROM \r\n    (\r\n        SELECT            \r\n            @lastName:=\'\',\r\n            @lastDate:=\'\',\r\n            CONCAT(s.salesmanname,\"\\n\") AS _name,\r\n            CONCAT(DATE(c.OperationDate),\"\\n\") AS _date,\r\n            TIME(c.OperationDate) AS _time,\r\n            c.TableID AS _mesas,\r\n            c.Quantity AS _qt,\r\n            c.UserNote AS _artigo,\r\n            replace(round((c.ItemValue)/100,2),\'.\',\',\') AS _value\r\n        FROM \r\n            cancelrecords c INNER JOIN salesmans s \r\n            on s.UID = c.salesmanUID\r\n        WHERE \r\n            c.OperationType=0 AND   #cancel=0, anul=1\r\n            DATE(c.OperationDate) BETWEEN  \'(101)\'  AND \'(111)\' \r\n            ORDER BY s.UID \r\n)AS Q;','%s%s %9.9s%4.4s %-4.4s %-13.13s%7.7s',NULL,NULL,7,1),(23002,0,1,23,NULL,'\\n\\n -- Totais -- \\nEmpregado         Dia         Qt   Valor\\n----------------------------------------\\n','SELECT \r\n    IF(Q._name=@lastName,\'\',@lastName:=Q._name) As Salesman,\r\n    Q._date AS OperatioDate,\r\n    Q._qnt AS SumQuantity,\r\n    CONCAT(Q._value,\"\\n\") AS TotalValue\r\nFROM\r\n(SELECT \r\n        @lastName:=\'\',\r\n        s.salesmanname AS _name,\r\n        DATE(c.OperationDate) AS _date,\r\n        SUM(c.Quantity) AS _qnt,\r\n        replace(round(SUM(c.ItemValue)/100,2),\'.\',\',\') AS _value\r\n    FROM \r\n        cancelrecords c INNER JOIN salesmans s on s.UID = c.salesmanUID\r\n    WHERE \r\n        OperationType=0 AND\r\n        DATE(c.OperationDate) BETWEEN  \'(101)\'  AND \'(111)\'     \r\n        GROUP BY  s.UID, DATE(c.OperationDate)) AS Q\r\nUNION\r\n    SELECT \r\n        \' \',\r\n        \' \',\r\n        SUM(c.Quantity),\r\n        replace(round(SUM(c.ItemValue)/100,2),\'.\',\',\') \r\n    FROM \r\n        cancelrecords c INNER JOIN salesmans s on s.UID = c.salesmanUID\r\n    WHERE \r\n        OperationType=0 AND\r\n        DATE(c.OperationDate) BETWEEN  \'(101)\'  AND \'(111)\'; ','%-14.14s %10.10s %6.6s %7.7s',NULL,NULL,4,2),(23003,0,1,23,NULL,'\\n\\n  -- Artigos anulados por empregado -- \\n   Hora    Hora Pedido  Desp.  Mesa   Qt\\n            Artigo   Valor\\n----------------------------------------\\n','\nSELECT\n        IF(Q._name=@lastName,\'\',@lastName:=Q._name) AS OpSalesman,\n        IF(Q._date=@lastDate,\'\',@lastDate:=Q._date) AS OpDate,\n        Q._time AS OpTime,\n	Q._otime AS OrderTime,\n        IF(Q._waste=0,\'\',\'Desp\') AS Waste,\n        Q._mesas AS OpTable,\n        Q._qt AS OpQt,\n        SUBSTR(Q._artigo,1,12) AS OpItem,\n        CONCAT(SUBSTR(Q._value,1,6),\"\n\") AS OpValue\nFROM\n    (\n        SELECT\n            @lastName:=\'\',\n            @lastDate:=\'\',\n            CONCAT(s.salesmanname,\"\n\") AS _name,\n            CONCAT(DATE(c.OperationDate),\"\n\") AS _date,\n            TIME(c.OperationDate) AS _time,\n	    TIME(c.OrderDate) AS _otime,\n            c.TableID AS _mesas,\n            c.Quantity AS _qt,\n	    c.opdetail AS _waste,\n            c.UserNote AS _artigo,\n            replace(round((c.ItemValue)/100,2),\'.\',\',\') AS _value\n        FROM\n            cancelrecords c INNER JOIN salesmans s\n            on s.UID = c.salesmanUID\n        WHERE\n            c.OperationType=1 AND   #cancel=0, anul=1\n            DATE(c.OperationDate) BETWEEN  \'(101)\'  AND \'(111)\'\n            ORDER BY s.UID\n)AS Q;','%s%s %9.9s %9.9s %9.9s %4.4s %4.4s\\n          %-14.14s%7.7s',NULL,NULL,9,3),(23004,0,1,23,NULL,'\\n\\n -- Totais -- \\nEmpregado         Dia         Qt   Valor\\n----------------------------------------\\n','SELECT \r\n    IF(Q._name=@lastName,\'\',@lastName:=Q._name) As Salesman,\r\n    Q._date AS OperatioDate,\r\n    Q._qnt AS SumQuantity,\r\n    CONCAT(Q._value,\"\\n\") AS TotalValue\r\nFROM\r\n(SELECT \r\n        @lastName:=\'\',\r\n        s.salesmanname AS _name,\r\n        DATE(c.OperationDate) AS _date,\r\n        SUM(c.Quantity) AS _qnt,\r\n        replace(round(SUM(c.ItemValue)/100,2),\'.\',\',\') AS _value\r\n    FROM \r\n        cancelrecords c INNER JOIN salesmans s on s.UID = c.salesmanUID\r\n    WHERE \r\n        OperationType=1 AND\r\n        DATE(c.OperationDate) BETWEEN  \'(101)\'  AND \'(111)\'     \r\n        GROUP BY  s.UID, DATE(c.OperationDate)) AS Q\r\nUNION\r\n    SELECT \r\n        \' \',\r\n        \' \',\r\n        SUM(c.Quantity),\r\n        replace(round(SUM(c.ItemValue)/100,2),\'.\',\',\') \r\n    FROM \r\n        cancelrecords c INNER JOIN salesmans s on s.UID = c.salesmanUID\r\n    WHERE \r\n        OperationType=1 AND\r\n        DATE(c.OperationDate) BETWEEN  \'(101)\'  AND \'(111)\'; ','%-14.14s %10.10s %6.6s %7.7s',NULL,NULL,4,4),(24001,0,1,24,NULL,'\\n\\n   --- Transferencias de artigos ---      \\n  Hora  Origem->Destino   Qnt  Artigo\\n----------------------------------------\\n','SELECT  \r\n        IF(s._name=     @lastName,\'\',   @lastName:= s._name) AS OpSalesman,\r\n        IF(s._date =    @lastDate,\'\',   @lastDate:= s._date) AS OpDate,\r\n        IF(s._mesas =   @lastTable,\'\',  @lastTable:= s._mesas) AS OpTable,\r\n        SUBSTR(s._qt,1,10) AS OpQt,\r\n        SUBSTR(s._item,1,28) AS OpItem\r\nFROM \r\n    (\r\n        SELECT \r\n            @lastName :=\'\', \r\n            @lastTable :=\'\',    \r\n            @lastDate := \'\',\r\n            CONCAT(s.salesmanname ,\"\\n\") as _name,\r\n            CONCAT(DATE(OperationDate),\"\\n\") AS _date,\r\n            CONCAT(TIME(OperationDate),\"  \", SourceTable , \" -> \" , Destinationtable) _mesas,\r\n            Quantity AS _qt,\r\n            ItemDescription AS _item\r\n        FROM \r\n            transferrecords\r\n            inner join salesmans s on s.uid = salesmanUID\r\n        WHERE \r\n            DATE(OperationDate) BETWEEN  \'(101)\'  AND \'(111)\' \r\n        ORDER BY s.UID\r\n)as s;','%s%s  %20.20s %4.4s%12.12s\\n',NULL,NULL,5,1),(25001,0,1,25,NULL,'\\n\\n --- Artigos por empregado ---      \\nEmpregado  Artigo      Qnt       Valor\\n----------------------------------------\\n','SELECT       IF(Q._name=     @lastName,\'\',   @lastName:= Q._name) AS OpSalesman,      Q._item AS OpItem,      Q._qnt AS OpQnt,      Q._value AS OpValue FROM ( SELECT      @lastName:=\'\',     CONCAT(salesmans.SalesmanName,\' \') AS _name,     details.PluName AS _item,   round(SUM( IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1, IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000), IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity) )),2) as _qnt,     REPLACE(round(sum(details.salevalue-details.salevalue*headers.DiscountPercent/100)/100,2),\'.\',\',\') AS _value FROM transactionsdetails details     INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID     INNER JOIN taxes ON details.SaleTaxUID = taxes.UID      INNER JOIN salesmans on salesmans.uid = headers.CreateSalesmanUID     INNER JOIN plus on details.PluUID = plus.uid     RIGHT JOIN properties on properties.UID =plus.PropertyUID WHERE DATE(headers.TransactionEndTime)>= \'(101)\'      AND DATE(headers.TransactionEndTime)<= \'(111)\'     AND DATE(headers.TransactionEndTime)<= \'(111)\'     AND headers.TransactionStatus = \'N\'          AND headers.documentTypeUID  != 13  GROUP BY details.pluuid, salesmans.UID ORDER by _name)  AS Q','%s     %-18.18s %5.5s %9.9s\\n','',NULL,4,1),(25002,0,1,25,NULL,'\\n\\n ---          Totais            ---\\nEmpregado              Qnt        Valor\\n----------------------------------------\\n','SELECT       IF(Q._name=     @lastName,\'\',   @lastName:= Q._name) AS OpSalesman,      Q._item AS OpItem,      Q._qnt AS OpQnt,      Q._value AS OpValue FROM ( SELECT      @lastName:=\'\',     CONCAT(salesmans.SalesmanName,\' \') AS _name,     details.PluName AS _item,   round(SUM( IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1, IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000), IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity) )),2) as _qnt,     REPLACE(round(sum(details.salevalue-details.salevalue*headers.DiscountPercent/100)/100,2),\'.\',\',\') AS _value FROM transactionsdetails details     INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID     INNER JOIN taxes ON details.SaleTaxUID = taxes.UID      INNER JOIN salesmans on salesmans.uid = headers.CreateSalesmanUID     INNER JOIN plus on details.PluUID = plus.uid     RIGHT JOIN properties on properties.UID =plus.PropertyUID WHERE DATE(headers.TransactionEndTime)>= \'(101)\'      AND DATE(headers.TransactionEndTime)<= \'(111)\'     AND DATE(headers.TransactionEndTime)<= \'(111)\'     AND headers.TransactionStatus = \'N\'          AND headers.documentTypeUID  != 13 GROUP BY details.pluuid, salesmans.UID ORDER by _name)  AS Q',' %-18.18s  %6.6s     %9.9s\\n','',NULL,3,2),(26001,0,1,26,NULL,'\\n\\nFam/Subfam        Qnt   Liquido    Valor\\n----------------------------------------\\n','SELECT     Q.F,     Q.T,     Q.NV,     Q.V/*,     Q.C,     Q.K*/ FROM( (          SELECT         qry.fam AS F,         qry.qnt as T,         qry.net_value AS NV,         qry.value as V,         qry.code as C,         qry.fam2 as K     FROM(         SELECT              families.shortdescription as fam,             round(SUM(             IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,             IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000),             IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)             )),2) as qnt,             replace(round(sum(details.NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as net_value,              replace(round(sum(details.SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value,              families.code AS code,             families.uid AS fam2                     FROM transactionsdetails details             INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID              INNER JOIN plus on details.PluUID = plus.uid             INNER JOIN families on plus.familyid = families.uid             RIGHT JOIN properties on properties.UID =plus.PropertyUID    WHERE DATE(headers.TransactionEndTime) >= \'(101)\' AND DATE(headers.TransactionEndTime) <= \'(111)\'              and headers.TransactionStatus = \'N\'             and  headers.DocumentTypeUID != 13                      GROUP BY families.uid         ORDER by families.code     )     AS qry ) UNION (         SELECT         qry2.subfam AS F,         qry2.qnt as T,         qry2.net_value AS NV,         qry2.value as V,         qry2.code as C,         qry2.fam as K     FROM(         SELECT              concat(\"    \",subfamilies.shortdescription) as subfam,             round(SUM(             IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,             IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000),             IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)             )),2) as qnt,             replace(round(sum(details.NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as net_value,             replace(round(sum(details.SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value,             (subfamilies.code+10000) AS code,             plus.familyid AS fam                    FROM transactionsdetails details             INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID             INNER JOIN plus on details.PluUID = plus.uid             INNER JOIN subfamilies on plus.subfamilyid = subfamilies.uid             RIGHT JOIN properties on properties.UID =plus.PropertyUID         WHERE DATE(headers.TransactionEndTime) >= \'(101)\' AND DATE(headers.TransactionEndTime) <= \'(111)\'             and headers.TransactionStatus = \'N\'              and  headers.DocumentTypeUID != 13          GROUP BY subfamilies.uid         ORDER by subfamilies.code     )     AS qry2 ) UNION (     SELECT         @label :=\"Total\" AS F,   round(SUM(         IF(props.ReadQuantityFromScale  or details.PLUDivisionState = 1,         IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000),         IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)         )),2) as T,         replace(round(sum(details.NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as NV,         replace(round(sum(details.SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as V,         999999 AS C,         999999 AS K     FROM transactionsdetails details         INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID         RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID         RIGHT JOIN properties props on props.UID =mainplus.PropertyUID     WHERE DATE(headers.TransactionEndTime) >= \'(101)\' AND DATE(headers.TransactionEndTime) <= \'(111)\'         AND headers.TransactionStatus = \'N\'         and  headers.DocumentTypeUID != 13  ) ORDER BY K,C) AS Q;','%-14.14s%6.6s%10.10s%10.10s\\n',NULL,NULL,4,3),(27001,0,1,27,NULL,'\\n           -- TOTAL POR IVAS --         \\nTx    Incidencia       Valor       Total\\n----------------------------------------\\n','SELECT \r\n    #Q.rate,\r\n    if(Q.rate=999,\"Total\",Q.rate),\r\n    replace(Q.valueTaxOff,\'.\',\',\'),\r\n    replace(Q.taxValue,\'.\',\',\'),\r\n    replace(Q.totalValue,\'.\',\',\'),\r\n    #Q.docType,\r\n    Q.DocDescription\r\n    FROM(     \r\n    SELECT\r\n    CASE WHEN (SELECT Value FROM appcore WHERE name =\'db_version\') > 385 THEN \r\n		CASE WHEN taxes.TaxRatePerc > 0 THEN \r\n			round(((taxes.TaxRate *100) + taxes.TaxRatePerc) / 100.0,2)\r\n		ELSE\r\n			round(taxes.TaxRate,0)\r\n		END\r\n	ELSE taxes.TaxRate \r\n	END AS \'rate\',\r\n        round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2) as \'valueTaxOff\',\r\n        round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2) as \'taxValue\',\r\n        round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2)as \'totalValue\',\r\n        headers.DocumentTypeUID as DocType,\r\n        (SELECT Description FROM documenttypes WHERE DocumentType=headers.DocumentTypeUID AND RecordDeleted=0 GROUP BY DocumentType) as  DocDescription\r\n    FROM transactionsdetails details\r\n    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\r\n    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID \r\n    -- INNER JOIN documenttypes ON headers.DocumentTypeUID=documenttypes.DocumentType \r\n    WHERE DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\r\n    AND  headers.TransactionStatus = \'N\' \r\n    AND  headers.DocumentTypeUID != 13 \r\n    GROUP by headers.DocumentTypeUID,rate\r\nUNION\r\n    SELECT\r\n        999,\r\n        round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2) as \'valueTaxOff\',\r\n        round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2) as \'taxValue\',\r\n        round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2)as \'totalValue\',\r\n        headers.DocumentTypeUID as DocType,\r\n       (SELECT Description FROM documenttypes WHERE DocumentType=headers.DocumentTypeUID AND RecordDeleted=0 GROUP BY DocumentType) as  DocDescription\r\n    FROM transactionsdetails details\r\n    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\r\n    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID \r\n   --  INNER JOIN documenttypes ON headers.DocumentTypeUID=documenttypes.DocumentType \r\n    WHERE DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\r\n    AND  headers.TransactionStatus = \'N\' \r\n    AND  headers.DocumentTypeUID != 13 \r\n    GROUP by headers.DocumentTypeUID \r\n)AS Q ORDER BY Q.DocType,Q.rate','%5.5s%12.12s%11.11s%12.12s\\n','SELECT\n    replace(round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2),\'.\',\',\') as \'valueTaxOff\',\n    replace(round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2),\'.\',\',\') as \'taxValue\',\n    replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'totalValue\'      \nFROM transactionsdetails details\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\nINNER JOIN taxes ON details.SaleTaxUID = taxes.UID \nWHERE     DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\nAND  headers.TransactionStatus = \'N\' \nand  headers.DocumentTypeUID != 13;','        --------------------------------\\n%16.16s%12.12s%12.12s\\n',4,1),(27002,0,1,27,NULL,'\\n\\n         -- TOTAL POR POSTOS --         \\nTerminal                           Valor\\n----------------------------------------\\n','SELECT \n    salesterminal.description as \'description\', \n    replace(round(sum(NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'net_value\',\n    replace(round(sum(details.salevalue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'value\'\nFROM transactionsheaders headers\nINNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nINNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid\nWHERE DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\nand headers.TransactionStatus = \'N\' \nand headers.DocumentTypeUID!=13\nGroup by headers.TransactionStartTerminalUID;','%-15.15s%10.10s%15.15s\\n','SELECT \nreplace(round(sum(NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'net_value\',\nreplace(round(IFNULL(sum(details.salevalue-SaleValue*headers.DiscountPercent/100),0)/100,2),\'.\',\',\') as \'value\'\nFROM transactionsheaders headers\nINNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nINNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid\nWHERE  DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\nand headers.TransactionStatus = \'N\' \nand  headers.DocumentTypeUID != 13 ','        --------------------------------\\n%25.25s%15.15s\\n',3,3),(27003,0,1,27,NULL,'\n\n        -- FORMAS PAGAMENTO--           \nForma Pagamento                    Valor\n----------------------------------------\n','SELECT \r\n    pTypes.LongDescription as \'description\',\r\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE pTypes.Type in (0,3,6)\r\n    AND DATE(headers.TransactionEndTime)  between \'(101)\' and \'(111)\'\r\n    and  headers.TransactionStatus = \'N\'\r\n    and  headers.DocumentTypeUID != 13 \r\nGroup by tenders.PaymentTypeUID\r\nunion\r\nSELECT \r\n    \'Dinheiro\',\r\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE pTypes.type = 1\r\n    AND DATE(headers.TransactionEndTime)  between \'(101)\' and \'(111)\'\r\n    and  headers.TransactionStatus = \'N\'\r\n    and  headers.DocumentTypeUID != 13 \r\nGroup by pTypes.type\r\nUNION\r\nSELECT \r\n    \'Ret. Fonte\',\r\n    replace(SUM(ROUND(NetValue/100*WithholdingPercentage/10000,2)),\'.\',\',\') as \'value\' \r\nFROM \r\n    transactionsdetails details INNER JOIN transactionsheaders headers ON headers.UID=details.TransactionUID\r\n    WHERE \r\nWithholdingPercentage>0\r\n    AND DATE(headers.TransactionEndTime)  between \'(101)\' and \'(111)\'\r\n    AND  headers.TransactionStatus = \'N\'\r\n    AND  headers.DocumentTypeUID != 13 ;','%-20.20s%20.20s\n','SELECT replace(SUM(v1),\'.\',\',\') as \'value\' FROM\r\n(\r\n    (\r\n        SELECT \r\n            round(IFNULL(sum(tenders.value),0)/100,2) as v1\r\n        FROM transactionstenders tenders\r\n            INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n            INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\n        WHERE pTypes.Type in (0,1,3,6)\r\n            AND DATE(headers.TransactionEndTime)  between \'(101)\' and \'(111)\'\r\n            and headers.TransactionStatus = \'N\'\r\n            and  headers.DocumentTypeUID != 13\r\n    ) \r\n    UNION\r\n    (\r\n        SELECT\r\n            SUM(ROUND(NetValue/100*WithholdingPercentage/10000,2)) as v1\r\n        FROM \r\n            transactionsdetails details INNER JOIN transactionsheaders headers ON headers.UID=details.TransactionUID\r\n            WHERE \r\n        WithholdingPercentage>0\r\n            AND DATE(headers.TransactionEndTime)  between \'(101)\' and \'(111)\'\r\n            AND  headers.TransactionStatus = \'N\'\r\n            AND  headers.DocumentTypeUID != 13\r\n    ) \r\n) AS Q;','        --------------------------------\n%40.40s\n',2,4),(27004,0,1,27,NULL,'\\n\\n        -- TOTAL POR FAMILIA  --\\n\\nFam/Subfam              Qnt        Valor\\n----------------------------------------\\n','SELECT     Q.F,     Q.T,     Q.NV,     Q.V/*,     Q.C,     Q.K*/ FROM( (     SELECT         qry.fam AS F,         qry.qnt as T,         qry.net_value AS NV,         qry.value as V,         qry.code as C,         qry.fam2 as K     FROM(         SELECT              families.shortdescription as fam,             SUM(IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,1,details.Quantity)) as qnt,             replace(round(sum(details.NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as net_value,              replace(round(sum(details.SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value,              families.code AS code,             families.uid AS fam2                     FROM transactionsdetails details             INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID         INNER JOIN plus on details.PluUID = plus.uid             INNER JOIN families on plus.familyid = families.uid             RIGHT JOIN properties on properties.UID =plus.PropertyUID         WHERE DATE(headers.TransactionEndTime)  between \'(101)\' and \'(111)\'             and headers.TransactionStatus = \'N\'             and  headers.DocumentTypeUID != 13                      GROUP BY families.uid         ORDER by families.code     )     AS qry ) UNION (     SELECT         qry2.subfam AS F,         qry2.qnt as T,         qry2.net_value AS NV,         qry2.value as V,         qry2.code as C,         qry2.fam as K     FROM(         SELECT              concat(\"    \",subfamilies.shortdescription) as subfam,             SUM(IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,1,details.Quantity)) as qnt,             replace(round(sum(details.NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as net_value,             replace(round(sum(details.SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value,             (subfamilies.code+10000) AS code,             plus.familyid AS fam                    FROM transactionsdetails details             INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID               INNER JOIN plus on details.PluUID = plus.uid             INNER JOIN subfamilies on plus.subfamilyid = subfamilies.uid             RIGHT JOIN properties on properties.UID =plus.PropertyUID         WHERE DATE(headers.TransactionEndTime)  between \'(101)\' and \'(111)\'             and headers.TransactionStatus = \'N\'              and  headers.DocumentTypeUID != 13          GROUP BY subfamilies.uid         ORDER by subfamilies.code     )     AS qry2 ) UNION (     SELECT         @label :=\"Total\" AS F,         SUM(IF(props.ReadQuantityFromScale  or details.PLUDivisionState = 1,1,details.Quantity)) as T,         replace(round(sum(details.NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as NV,         replace(round(sum(details.SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as V,         999999 AS C,         999999 AS K     FROM transactionsdetails details         INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID         RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID         RIGHT JOIN properties props on props.UID =mainplus.PropertyUID     WHERE DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'         AND headers.TransactionStatus = \'N\'         and  headers.DocumentTypeUID != 13  ) ORDER BY K,C) AS Q;','%-14.14s%6.6s%10.10s%10.10s\\n',NULL,NULL,4,5),(27005,0,1,27,NULL,'\\n\\n          -- DOC. ANULADOS --\\nHora  Doc        Empregado         Valor\\n----------------------------------------\\n','SELECT \n    DATE_FORMAT(H.ModifyDate, \'%Hh%i\') as doc_date,\n    DocumentID,\n    S.SalesmanShortName,\n    REPLACE(ROUND(TableTotal/100,2),\'.\',\',\') as doc_value\n    FROM \n        transactionsheaders AS H INNER JOIN salesmans AS S ON H.CreateSalesmanUID=S.UID\n    WHERE \n        TransactionStatus=\'A\'\n    AND\n         DATE (H.ModifyDate) BETWEEN  \'(101)\'  AND \'(111)\' \n    and  H.DocumentTypeUID != 13 \n    ORDER BY\n       doc_date;','%-5.5s %-10.10s %-10.10s %12.12s\\n','SELECT \n    REPLACE(SUM(ROUND(TableTotal/100,2)),\'.\',\',\') as doc_value\n    FROM \n        transactionsheaders H\n    WHERE \n        TransactionStatus=\'A\'\n    AND\n        DATE(TransactionEndTime) >= \'(101)\' AND DATE(TransactionEndTime)<= \'(111)\'\n    and H.DocumentTypeUID != 13 ','        --------------------------------\\n%40.40s\\n',4,6),(27006,0,1,27,NULL,'\\n\\n               -- RESUMO --           \\n----------------------------------------\\n','SELECT \"Ticket medio\",\nREPLACE(ROUND((SUM(TableTotal)/(SELECT COUNT(*) FROM transactionsheaders WHERE DATE(TransactionEndTime) BETWEEN  \'(101)\'  AND \'(111)\'   AND TransactionStatus=\'N\' AND TableTotal>0 AND DocumentTypeUID!=13 ))/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime) BETWEEN  \'(101)\'  AND \'(111)\'    AND TransactionStatus=\'N\' AND DocumentTypeUID!=13 \nUNION\nSELECT \"Ticket maximo\",\nREPLACE(ROUND(MAX(TableTotal)/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13\nUNION\nSELECT \"Ticket minimo\",\nREPLACE(ROUND(MIN(TableTotal)/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\'  AND TableTotal>0 AND DocumentTypeUID!=13\nUNION\nSELECT \"Total\",\nREPLACE(ROUND(SUM(TableTotal)/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13 \nUNION\nSELECT \"Tickets estornados\",COUNT(*) FROM transactionsheaders WHERE TransactionStatus=\'A\' AND DATE(TransactionEndTime)>=\'(101)\' AND DATE (TransactionEndTime)<=\'(111)\' \nUNION\nSELECT \"Movimentos\",\nCOUNT(*) FROM transactionsheaders WHERE DATE(TransactionEndTime) BETWEEN  \'(101)\'  AND \'(111)\'  AND TransactionStatus = \'N\' AND DocumentTypeUID != 13;','%-20.20s%20.20s\\n',NULL,NULL,2,7),(27007,0,1,27,NULL,'\\n -- Movimentos por tipo de doc.\\n','SELECT \"Doc. inicial\",\"Doc. final\"\nUNION\nSELECT MIN(DocumentID),Max(DocumentID) From transactionsheaders WHERE DATE(TransactionEndTime) BETWEEN  \'(101)\'  AND \'(111)\' GROUP BY DocumentTypeUID;','%-18.18s -> %18.18s\\n',NULL,NULL,2,8),(27008,0,1,27,NULL,'\\n\\n       -- TOTAL POR DOCUMENTOS --         \\nTipo              Liquido          Valor\\n----------------------------------------\\n','SELECT \n    (SELECT Description FROM documenttypes WHERE DocumentType=headers.DocumentTypeUID AND RecordDeleted=0 GROUP BY documenttypes.DocumentType) as  DocDescription,\n    replace(round(sum(NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') AS \'net_value\',\n    replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') AS \'value\'\nFROM transactionsheaders headers\nINNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\n-- INNER JOIN documenttypes ON headers.DocumentTypeUID=documenttypes.DocumentType\nWHERE DATE(headers.TransactionEndTime) BETWEEN  \'(101)\'  AND \'(111)\'\nAND headers.TransactionStatus = \'N\' \nAND headers.DocumentTypeUID!=13\nGroup by  headers.DocumentTypeUID;','%-15.15s%10.10s%15.15s\\n','SELECT \n    replace(round(sum(NetValue-NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') AS \'net_value\',\n    replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') AS \'value\'\nFROM transactionsheaders headers\nINNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nWHERE DATE(headers.TransactionEndTime) BETWEEN  \'(101)\'  AND \'(111)\'\nAND headers.TransactionStatus = \'N\' \nAND headers.DocumentTypeUID!=13;','        --------------------------------\\n%25.25s%15.15s\\n',3,2),(28001,0,1,28,NULL,'\\n\\n            --- Totais ---\\nTerminal         Qnt   Liquido     Valor\\n----------------------------------------\\n','SELECT      salesterminal.Description AS \'Name\', round(SUM( IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1, IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000), IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity) )),2) as \'Qty\',     REPLACE(round(sum(details.NetValue-details.NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'net_value\',     REPLACE(round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'value\' FROM transactionsdetails details     INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID     INNER JOIN taxes ON details.SaleTaxUID = taxes.UID      INNER JOIN salesterminal on salesterminal.uid = details.OrderSalesTerminalUID    INNER JOIN plus on details.PluUID = plus.uid    RIGHT JOIN properties on properties.UID =plus.PropertyUID WHERE DATE(headers.TransactionEndTime) >= \'(101)\'      AND DATE(headers.TransactionEndTime) <= \'(111)\'     AND headers.TransactionStatus = \'N\'          AND headers.DocumentTypeUID !=13 GROUP BY salesterminal.UID ORDER by \'Name\';','%-14.14s %5.5s %9.9s %9.9s\\n',NULL,NULL,4,2),(28002,0,1,28,NULL,'\\n\\n       --- Artigos por Terminal ---      \\nTerminal  Artigo     Qnt  Liquido  Valor\\n----------------------------------------\\n','SELECT       IF(Q._name=     @lastName,\'\',   @lastName:= Q._name) AS OpSalesman,      Q._item AS OpItem,      Q._qnt AS OpQnt,      Q.net_value AS OpNetValue,      Q._value AS OpValue FROM ( SELECT      @lastName:=\'\',     CONCAT(salesterminal.Description,\' \') AS _name,     details.PluName AS _item, round(SUM( IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1, IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000), IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity) )),2) as _qnt,     REPLACE(round(sum(details.NetValue-details.NetValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') AS net_value,     REPLACE(round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') AS _value FROM transactionsdetails details     INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID     INNER JOIN taxes ON details.SaleTaxUID = taxes.UID      INNER JOIN salesterminal on salesterminal.uid = details.OrderSalesTerminalUID     INNER JOIN plus on details.PluUID = plus.uid     RIGHT JOIN properties on properties.UID =plus.PropertyUID WHERE DATE(headers.TransactionEndTime) >= \'(101)\'      AND DATE(headers.TransactionEndTime) <= \'(111)\'     AND headers.TransactionStatus = \'N\'         AND headers.DocumentTypeUID !=13 GROUP BY details.pluuid,salesterminal.UID ORDER by _name)  AS Q;','%s     %-13.13s %4.4s %8.8s%8.8s\\n',NULL,NULL,5,1),(29001,0,1,29,NULL,'\nNome             Visitas Pontos    Saldo\n----------------------------------------\n','SELECT \r\n    Name,\r\n    COALESCE(NumberOfVisits,0),\r\n    COALESCE(TotalPoints,0),\r\n    replace(round(COALESCE(Balance,0)/100,2),\'.\',\',\')\r\nFROM customers WHERE SalesmanUID>0 AND SalesmanUID LIKE \'(102)\' AND RecordDeleted=0\r\nORDER BY Name;','%-17.17s %4.4s %6.6s %10.10s\n',NULL,NULL,4,1),(29002,0,1,29,NULL,'\nTotais\n----------------------------------------\n','SELECT \"Saldo positivo\",REPLACE(ROUND(SUM(Balance)/100,2),\'.\',\',\') FROM customers WHERE Balance>=0 AND SalesmanUID>0 AND SalesmanUID LIKE \'(102)\' AND RecordDeleted=0\r\nUNION\r\nSELECT \"Saldo negativo\",REPLACE(ROUND(SUM(Balance)/100,2),\'.\',\',\') FROM customers WHERE Balance<0 AND SalesmanUID>0 AND SalesmanUID LIKE \'(102)\' AND RecordDeleted=0\r\nUNION\r\nSELECT \"Diferena\",   REPLACE(ROUND(SUM(Balance)/100,2),\'.\',\',\') FROM customers WHERE SalesmanUID>0 AND SalesmanUID LIKE \'(102)\' AND RecordDeleted=0;','%-30.30s %9.9s\n',NULL,NULL,2,2),(30001,0,1,30,NULL,'','SELECT \"Nome\", Name FROM customers WHERE UID=\'(125)\' AND RecordDeleted=0\nUNION\nSELECT \"Saldo Actual\",REPLACE(ROUND(COALESCE(Balance,0)/100,2),\'.\',\',\') FROM customers WHERE UID=\'(125)\' AND RecordDeleted=0\nUNION\nSELECT \"Total gasto\", REPLACE(ROUND(COALESCE(TotalSpent,0)/100,2),\'.\',\',\') FROM customers WHERE UID=\'(125)\' AND RecordDeleted=0\nUNION\nSELECT \"Visitas\", COALESCE(NumberOfVisits,0) FROM customers WHERE UID=\'(125)\' AND RecordDeleted=0\nUNION\nSELECT \"Pontos acumulados\", COALESCE(TotalPoints,0) FROM customers WHERE UID=\'(125)\' AND RecordDeleted=0\nUNION\nSELECT \"Ultima visita\", COALESCE(LastVisit,0) FROM customers WHERE UID=\'(125)\' AND RecordDeleted=0\nUNION\nSELECT \"Cliente desde\", COALESCE(CreateDate,0) FROM customers WHERE UID=\'(125)\' AND RecordDeleted=0;','%-20.20s %19.19s\n',NULL,NULL,2,1),(30002,0,1,30,NULL,'\r\n\r\nDocumentos Pendentes\r\n----------------------------------------\r\nData                Documento     Valor\r\n','SELECT  H.TransactionEndTime,h.DocumentID,REPLACE(ROUND(COALESCE(h.TableTotal ,0)/100,2),\'.\',\',\')\nFROM `transactionsheaders` as h   \n    inner join `transactionstenders` as t on h.UID = t.TransactionUID   \n    inner join `paymenttypes` as pTypes on t.PaymentTypeUID = pTypes.UID   \nWHERE h.CustomerUID = \'(125)\'\nAND t.UID not in      \n    (SELECT SaleTransactionTenderUID  \n    FROM cashdrawer_movements_docs cmd  \n    LEFT JOIN cashdrawer_movements cm on cm.UID = cmd.CashDrawerMovementUID \n    WHERE cm.Voided = 0) \nand pTypes.Type = 3  \nand h.TransactionStatus = \'N\'  \nORDER BY h.TransactionStartTime;','%-19.19s %8.8s %10.10s\r\n',NULL,NULL,3,2),(31001,0,1,31,NULL,'\nNome             Visitas Pontos    Saldo\\n----------------------------------------\n','SELECT \r\n    Name,\r\n    COALESCE(NumberOfVisits,0),\r\n    COALESCE(TotalPoints,0),\r\n    REPLACE(round(COALESCE(Balance,0)/100,2),\'.\',\',\')\r\nFROM customers WHERE SalesmanUID=0 AND CustomerID!=9999 AND UID LIKE \'%\' AND RecordDeleted=0 AND LENGTH(Name)>0\r\nORDER BY Name','%-17.17s %4.4s %6.6s %10.10s\n',NULL,NULL,4,1),(33001,0,1,33,NULL,'\\nMesa/Carto                       Valor\\n---------------------------------------\\n','SELECT * FROM(SELECT DISTINCT T.TableId, REPLACE(ROUND(T.Total/100,2),\'.\',\',\') FROM temp_tabletransactions AS T INNER JOIN temp_tabletransactiondetails AS D ON T.UID=D.TransactionUID\r\nWHERE T.TableID<10000 ORDER BY T.TableID) AS A\r\nUNION\r\nSELECT \"Total\",REPLACE(ROUND(SUM(Q.val)/100,2),\'.\',\',\')  FROM\r\n(SELECT DISTINCT T.TableId, T.Total, T.Total AS val FROM temp_tabletransactions AS T INNER JOIN temp_tabletransactiondetails AS D ON T.UID=D.TransactionUID\r\nWHERE T.TableID<10000) AS Q;','%-10.10s %28.28s\\n',NULL,NULL,2,2),(34001,0,1,34,NULL,'Data       Documento   NIF     Valor\\n----------------------------------------\\n','SELECT Date(headers.CreateDate),headers.DocumentID,C.FederalTaxID,\r\nreplace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value\r\nFROM transactionsdetails details\r\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\r\nJOIN customers AS C on headers.CustomerUID=C.UID\r\nWHERE C.FederalTaxID not like \'999999990\'\r\nAND headers.TransactionStatus = \'N\'\r\nAND DATE(headers.TransactionEndTime) >=  \'(101)\'\r\nAND DATE(headers.TransactionEndTime) <=  \'(111)\'\r\nAND headers.DocumentTypeUID !=13\r\nGROUP BY Date(headers.CreateDate),headers.DocumentID,C.FederalTaxID\r\nORDER by headers.Createdate','%-10.10s %-9.9s %-9.9s %8.8s\n','SELECT count(DISTINCT(headers.DocumentID)), \r\nreplace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value\r\nFROM transactionsdetails details\r\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\r\nJOIN customers AS C on headers.CustomerUID=C.UID\r\nWHERE C.FederalTaxID not like \'999999990\'\r\nAND headers.TransactionStatus = \'N\'\r\nAND DATE(headers.TransactionEndTime) >=  \'(101)\'\r\nAND DATE(headers.TransactionEndTime) <=  \'(111)\'\r\nAND headers.DocumentTypeUID !=13\r\nORDER by headers.Createdate','----------------------------------------\\nTotal c/ NIF: (%5.5s)  %17.17s\\n',4,1),(34002,0,1,34,NULL,'Total Eventuais: ','SELECT count(DISTINCT(headers.DocumentID)), replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value\r\nFROM transactionsdetails details\r\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\r\nJOIN customers AS C on headers.CustomerUID=C.UID\r\nWHERE C.FederalTaxID = \'999999990\'\r\nAND headers.TransactionStatus = \'N\'\r\nAND DATE(headers.TransactionEndTime) >=  \'(101)\'\r\nAND DATE(headers.TransactionEndTime) <=  \'(111)\'\r\nAND headers.DocumentTypeUID !=13\r\nORDER by headers.Createdate','(%5.5s)%16.16s\n','SELECT replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value\r\nFROM transactionsdetails details\r\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\r\nJOIN customers AS C on headers.CustomerUID=C.UID\r\nWHERE headers.TransactionStatus = \'N\'\r\nAND DATE(headers.TransactionEndTime) >=  \'(101)\'\r\nAND DATE(headers.TransactionEndTime) <=  \'(111)\'\r\nAND headers.DocumentTypeUID !=13','----------------------------------------\\nTotal Global:  %25.25s\\n ',2,1),(35001,0,1,35,NULL,'\n\n','SELECT col FROM(\nSELECT UID,2 AS col_order,\'data\', CONCAT(\'  \',\'Data: \',TransactionEndTime,\'\n\') as col FROM TransactionsHeaders WHERE DocumentTypeUID=13 AND TransactionStatus = \'N\' AND DATE(TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\'\nUNION\nSELECT UID,1 AS col_order,\'documento\',CONCAT(\'Guia: \',DocumentID,\'\n\') as col FROM TransactionsHeaders WHERE DocumentTypeUID=13 AND TransactionStatus = \'N\' AND DATE(TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\' \nUNION\nSELECT UID,3 AS col_order,\'cliente\',CONCAT(\'  \',\'Cliente: \',(SELECT ShortName FROM customers WHERE UID=CustomerUID),\'\n\') as col FROM TransactionsHeaders WHERE DocumentTypeUID=13 AND TransactionStatus = \'N\' AND DATE(TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\' \nUNION\n(SELECT \n    headers.UID, 5 AS col_order, \'total\',CONCAT(\'  \',\'Total: \',replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\'),\'\n\' )AS col\nFROM transactionsheaders headers\nINNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nWHERE DATE(headers.TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\'\nAND headers.TransactionStatus = \'N\' \nAND headers.DocumentTypeUID=13\nGroup by headers.UID)\nUNION\n(\nSELECT \n    headers.UID, 4 AS col_order, details.PluName, CONCAT(\'    \',details.PluName,\'	 \',replace(round(SaleValue/100,2),\'.\',\',\'),\'\n\') AS col\nFROM transactionsheaders headers\nINNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nWHERE DATE(headers.TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\'\nAND headers.TransactionStatus = \'N\' \nAND headers.DocumentTypeUID=13\nORDER by headers.UID\n)\nORDER BY UID, col_order) AS Q;','%s',NULL,NULL,1,1),(36001,0,1,36,NULL,'\n\n','SELECT \r\n    DocumentID, \r\n    TransactionEndTime, \r\n    REPLACE(ROUND(ABS(SUM(Value/100)),2),\'.\',\',\'),\r\n    (SELECT ShortName From customers WHERE UID=H.CustomerUID) \r\nFROM transactionsheaders AS H INNER JOIN transactionstenders AS T ON H.UID=T.TransactionUID\r\nWHERE \r\n    DocumentTypeUID=25 AND \r\n    DATE(TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\' AND \r\n    CustomerUID LIKE \'(125)\'\r\nGROUP BY H.DocumentID\r\nORDER BY H.CustomerUID,H.DocumentID;','%-10.10s %19.19s %9.9s\n','SELECT \r\n    REPLACE(ROUND(ABS(SUM(Value/100)),2),\'.\',\',\')\r\nFROM transactionsheaders AS H INNER JOIN transactionstenders AS T ON H.UID=T.TransactionUID\r\nWHERE \r\n    DocumentTypeUID=25 AND \r\n    DATE(TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\' AND\r\n    CustomerUID LIKE \'(125)\';','        --------------------------------\n%40.40s\n',3,1),(37001,0,1,37,NULL,'\\n\\n-- Totais por documento\\nDocumento           Incidncia    Valor\\n----------------------------------------\\n','SELECT \n    headers.DocumentID,\n    sum(round((details.NetValue/100),2)) as \'net\',\n    sum(round((details.NetValue/100)*((details.WithholdingPercentage/100)/100),2)) as \'withholding_v\'\nFROM transactionsheaders headers\n    INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nWHERE DATE(headers.TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n    AND details.WithholdingPercentage > 0\nGROUP BY DocumentID;','%-10.10s %17.17s %11.11s\\n','SELECT \n    sum(round((details.NetValue/100),2)) as \'net\',\n    sum(round((details.NetValue/100)*((details.WithholdingPercentage/100)/100),2)) as \'withholding_v\'\nFROM transactionsheaders headers\n    INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nWHERE DATE(headers.TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n    AND details.WithholdingPercentage > 0;','        --------------------------------\\n%28.28s %11.11s\\n',4,1),(37002,0,1,37,NULL,'\\n\\n-- Totais por cliente\\nNome                Incidncia     Valor\\n----------------------------------------\\n','SELECT \n    cust.ShortName,\n    sum(round((details.NetValue/100),2)) as \'net\',\n    sum(round((details.NetValue/100)*((details.WithholdingPercentage/100)/100),2)) as \'withholding_v\'\nFROM transactionsheaders headers\n    INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\n    INNER JOIN customers cust ON headers.CustomerUID = cust.UID\nWHERE DATE(headers.TransactionEndTime)  BETWEEN \'(101)\' AND \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n    AND details.WithholdingPercentage > 0\nGROUP BY customerUID;','%-16.16s %11.11s %11.11s\\n','SELECT \n    sum(round((details.NetValue/100),2)) as \'net\',\n    sum(round((details.NetValue/100)*((details.WithholdingPercentage/100)/100),2)) as \'withholding_v\'\nFROM transactionsheaders headers\n    INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\n    INNER JOIN customers cust ON headers.CustomerUID = cust.UID\nWHERE DATE(headers.TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n    AND details.WithholdingPercentage > 0;','        --------------------------------\\n%28.28s %11.11s\\n',3,2),(37003,0,1,37,NULL,'\\n\\n-- Totais por taxa\\nTaxa(%)                            Valor\\n----------------------------------------\\n','SELECT \n    round((details.WithholdingPercentage/100),2) as \'withholding_r\',\n    sum(round((details.NetValue/100)*((details.WithholdingPercentage/100)/100),2)) as \'withholding_v\'\nFROM transactionsheaders headers\n    INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\n    INNER JOIN customers cust ON headers.CustomerUID = cust.UID\nWHERE DATE(headers.TransactionEndTime)  BETWEEN \'(101)\' AND \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n    AND details.WithholdingPercentage > 0\nGROUP BY details.WithholdingPercentage; ','%-25.25s%15.15s\\n','SELECT \n    sum(round((details.NetValue/100)*((details.WithholdingPercentage/100)/100),2)) as \'withholding_v\'\nFROM transactionsheaders headers\n    INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\n    INNER JOIN customers cust ON headers.CustomerUID = cust.UID\nWHERE DATE(headers.TransactionEndTime) BETWEEN \'(101)\' AND \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n    AND details.WithholdingPercentage > 0;','        --------------------------------\\n%40.40s',2,3),(37004,0,1,37,NULL,'\r\n\r\n--Totais por servio\nDescr.                   Qnt       Valor\r\n----------------------------------------\r\n','SELECT\r\n    qry.plu,\r\n    qry.qt as qt,\r\n    qry.withholding_v as ret_val\r\nFROM(\r\n    SELECT \r\n        PluName as plu,\r\n        SUM(if (headers.DocumentTypeUid <> 25,details.Quantity,-1*details.Quantity)) as qt,\r\n        SUM(ROUND((details.NetValue/100)*((details.WithholdingPercentage/100)/100),2)) as \'withholding_v\'\r\n    FROM transactionsdetails details\r\n        INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID\r\n        RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID\r\n        RIGHT JOIN properties props on props.UID =mainplus.PropertyUID\r\n    WHERE DATE(headers.TransactionEndTime) BETWEEN  \'(101)\'  AND \'(111)\' \r\n        AND headers.TransactionStatus = \'N\'\r\n        AND details.WithholdingPercentage>0 \r\n    GROUP BY PluName\r\n    ORDER BY plu\r\n) as qry;','%-16.16s %11.11s %11.11s\r\n','SELECT \r\n    SUM(ROUND((details.NetValue/100)*((details.WithholdingPercentage/100)/100),2)) as \'withholding_v\'\r\nFROM transactionsdetails details\r\n    INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID\r\n    RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID\r\n    RIGHT JOIN properties props on props.UID =mainplus.PropertyUID\r\nWHERE DATE(headers.TransactionEndTime)BETWEEN  \'(101)\'  AND \'(111)\' \r\n    AND headers.TransactionStatus = \'N\'\r\n    AND details.WithholdingPercentage>0 ','        --------------------------------\r\n%40.40s',3,4),(37005,0,1,37,NULL,'\\n\\n               -- TOTAL -- \\n----------------------------------------\\n','SELECT \n    sum(round((details.NetValue/100)*((details.WithholdingPercentage/100)/100),2)) as \'withholding_v\'\nFROM transactionsheaders headers\n    INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\n    INNER JOIN customers cust ON headers.CustomerUID = cust.UID\nWHERE DATE(headers.TransactionEndTime)  BETWEEN \'(101)\' AND \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n    AND details.WithholdingPercentage > 0;','A entregar: %28.28s',NULL,NULL,1,5),(38001,0,1,38,NULL,'\\n          -- CARTOES ASSINADOS --    \\nData         Doc    Cartao    IVA   Total\\n----------------------------------------\\n','SELECT \n    DATE_FORMAT(headers.TransactionEndTime,\'%d%b %h:%m\'),\n    RIGHT(headers.DocumentID,8),\n    headers.TableID as \'table\',\n    round((sum(details.SaleValue) - sum(details.NetValue))/100,2) as \'tax_value\',\n    round(sum(details.SaleValue)/100,2) as \'value\'\nFROM transactionsdetails details\n    INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID\nWHERE \n    DATE(headers.TransactionEndTime) between \'(101)\'  and \'(111)\' \n    AND headers.TransactionStatus = \'N\'\n    AND headers.DocumentTypeUID != 13\n    AND headers.DiscountPercent = 100\nGROUP BY headers.UID\norder BY headers.TransactionEndTime','%11.11s %8.8s %4.4s %6.6s %7.7s\n',NULL,NULL,6,1),(38002,0,1,38,NULL,'----------------------------------------\\n','SELECT \n    round((sum(details.SaleValue) - sum(details.NetValue))/100,2) as \'tax_value\',\n    round(sum(details.SaleValue)/100,2) as \'value\'\nFROM transactionsdetails details\n    INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID\nWHERE \nDATE(headers.TransactionEndTime) between \'(101)\'  and \'(111)\' \nAND headers.TransactionStatus = \'N\'\nAND headers.DocumentTypeUID != 13\nAND headers.DiscountPercent = 100','Total:                 %8.8s %8.8s\n',NULL,NULL,3,2),(39001,0,1,39,NULL,'\n          -- OFERTAS --    \nQnt  Artigo                IVA    Total\n----------------------------------------\n','SELECT \n    count(details.Quantity),\n    details.PluName,\n\n    IF(details.IsOffer = 1, \n    CASE \n    WHEN (SELECT DefaultSalesPrice FROM generalconfig) = 0 THEN\n    round(sum(IF (details.VatIncluded = true,\n    ((details.Quantity *  p.SalesPrice1)-(\n    (details.Quantity *  p.SalesPrice1) / ((100+taxes.TaxRate)/100)))\n    ,details.Quantity *  p.SalesPrice1)\n    )/100,2)\n    \n    WHEN (SELECT DefaultSalesPrice FROM generalconfig) = 1 THEN\n    round(sum(IF (details.VatIncluded = true,\n    ((details.Quantity *  p.SalesPrice2)-(\n    (details.Quantity *  p.SalesPrice2) / ((100+taxes.TaxRate)/100)))\n    ,details.Quantity *  p.SalesPrice2)\n    )/100,2)\n    \n    WHEN (SELECT DefaultSalesPrice FROM generalconfig) = 2 THEN\n    round(sum(IF (details.VatIncluded = true,\n    ((details.Quantity *  p.SalesPrice3)-(\n    (details.Quantity *  p.SalesPrice3) / ((100+taxes.TaxRate)/100)))\n    ,details.Quantity *  p.SalesPrice3)\n    )/100,2)\n    \n    END \n    , \n    round(sum(IF (details.VatIncluded = true,\n    ((details.Quantity *  details.PluunitPrice)-(\n    (details.Quantity *  details.PluunitPrice) / ((100+taxes.TaxRate)/100)))\n    ,details.Quantity *  details.PluunitPrice)\n    )/100,2))as \'tax_value\',\n    \n    IF(details.IsOffer = 1, \n    \n    CASE \n    WHEN (SELECT DefaultSalesPrice FROM generalconfig) = 0 THEN\n    round(sum((details.Quantity *  p.SalesPrice1))/100,2)\n    WHEN (SELECT DefaultSalesPrice FROM generalconfig) = 1 THEN\n    round(sum((details.Quantity *  p.SalesPrice2))/100,2)\n    WHEN (SELECT DefaultSalesPrice FROM generalconfig) = 2 THEN\n    round(sum((details.Quantity *  p.SalesPrice3))/100,2)\n    END\n    ,\n    round(sum((details.Quantity *  details.PluunitPrice))/100,2)) as \'value\'\n        \nFROM transactionsdetails details\n    INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID\n    LEFT JOIN taxes on taxes.UID = details.SaleTaxUID\n    LEFT JOIN plus on plus.UID =  details.PluUID\n    LEFT JOIN properties p on p.UID =  plus.PropertyUID\nWHERE \n    DATE(headers.TransactionEndTime) between \'(101)\'  and \'(111)\'\n    AND TransactionStatus = \'N\'\n    AND headers.DocumentTypeUID != 13\n    AND (details.DiscountPercentage = 100 \n    or  details.IsOffer = 1)\nGROUP BY details.PluUID\nORDER BY headers.TransactionEndTime;','%5.5s %-16.16s %8.8s %8.8s\n',NULL,NULL,5,1),(39002,0,1,39,NULL,'----------------------------------------\n','SELECT \n    round(sum(\n    IF(details.IsOffer = 1, \n    \n    CASE \n    WHEN (SELECT DefaultSalesPrice FROM generalconfig) = 0 THEN\n    IF (details.VatIncluded = true,\n    ((details.Quantity *  p.SalesPrice1)-(\n    (details.Quantity *  p.SalesPrice1) / ((100+taxes.TaxRate)/100)))\n    ,details.Quantity *  p.SalesPrice1)\n    \n    \n    WHEN (SELECT DefaultSalesPrice FROM generalconfig) = 1 THEN\n    IF (details.VatIncluded = true,\n    ((details.Quantity *  p.SalesPrice2)-(\n    (details.Quantity *  p.SalesPrice2) / ((100+taxes.TaxRate)/100)))\n    ,details.Quantity *  p.SalesPrice2)\n    \n    \n    WHEN (SELECT DefaultSalesPrice FROM generalconfig) = 2 THEN\n    IF (details.VatIncluded = true,\n    ((details.Quantity *  p.SalesPrice3)-(\n    (details.Quantity *  p.SalesPrice3) / ((100+taxes.TaxRate)/100)))\n    ,details.Quantity *  p.SalesPrice3)\n    \n    \n    END \n    , \n    IF (details.VatIncluded = true,\n    ((details.Quantity *  details.PluunitPrice)-(\n    (details.Quantity *  details.PluunitPrice) / ((100+taxes.TaxRate)/100)))\n    ,details.Quantity *  details.PluunitPrice)\n    ))/100,2)as \'tax_value\',\n    \n    round(sum(\n    IF(details.IsOffer = 1, \n    \n    CASE \n    WHEN (SELECT DefaultSalesPrice FROM generalconfig) = 0 THEN\n    (details.Quantity *  p.SalesPrice1)\n    WHEN (SELECT DefaultSalesPrice FROM generalconfig) = 1 THEN\n    (details.Quantity *  p.SalesPrice2)\n    WHEN (SELECT DefaultSalesPrice FROM generalconfig) = 2 THEN\n    (details.Quantity *  p.SalesPrice3)\n    END\n    ,\n    (details.Quantity *  details.PluunitPrice)))/100,2) as \'value\'\n        \nFROM transactionsdetails details\n    INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID\n    LEFT JOIN taxes on taxes.UID = details.SaleTaxUID\n    LEFT JOIN plus on plus.UID =  details.PluUID\n    LEFT JOIN properties p on p.UID =  plus.PropertyUID\nWHERE \n    DATE(headers.TransactionEndTime) between \'(101)\'  and \'(111)\'\n    AND TransactionStatus = \'N\'\n    AND headers.DocumentTypeUID != 13\n    AND (details.DiscountPercentage = 100 \n    or  details.IsOffer = 1)\nORDER BY headers.TransactionEndTime','Total:                 %8.8s %8.8s',NULL,NULL,3,2),(40001,0,1,40,NULL,'           -- SubTotais --    \nData/Hora   Emp   Fat      Mesa Total  Dif\n---------------------------------------------\n',' SELECT\r\n    z.DocDate AS DocDate,\r\n    z.DocTime AS DocTime,\r\n    mid(z.SalesmanShortName, 1, 7),\r\n    z.DocID as DocID,\r\n    z.mesa,\r\n    z.subtot,\r\n    z.tot\r\nFROM\r\n    (\r\n        SELECT\r\n            @lastDocDate = a.DocDate,\r\n            a.DocDate,\r\n            a.DocTime,\r\n            a.DocType,\r\n            a.DocID,\r\n            a.DocInvoice,\r\n            a.SalesmanShortName,\r\n	    a.mesa,\r\n            a.subtot,\r\n            a.tot\r\n        FROM\r\n            (\r\n                SELECT\r\n                    distinct date_format(Date(th.ModifyDate),\"%d-%m \") as DocDate,\r\n                    TIME_FORMAT(th.ModifyDate, \"%H:%i\") as DocTime,\r\n                    th.DocumentID as DocID,\r\n                    th.DocumentID as DocInvoice,\r\n                    0.0 as DocType,\r\n                    s.SalesmanShortName,\r\n		    th.TableID as mesa,\r\n                    0.0 as tot,\r\n                    round(th.TableTotal / 100.0, 2) as subtot\r\n                FROM\r\n                    transactionsheaders th\r\n                    LEFT JOIN transactionssubtotals ts on ts.TransactionID = TH.UID\r\n                    LEFT JOIN subtotals st ON st.DataChar = ts.SubTotalChar\r\n                    AND st.ID = ts.SubTotalID\r\n                    LEFT JOIN salesmans s on s.UID = st.CreateUserUID\r\n                WHERE\r\n                    th.TransactionStatus = \"N\"\r\n                    AND th.TableTotal < st.tabletotal\r\n                    AND th.OrderReferences <> \"\"\r\n                    AND DATE(th.TransactionEndTime) between \"(101)\"\r\n                    and \"(101)\"\r\n                    AND DATE(st.CreateDate) between \"(101)\"\r\n                    and \"(101)\"\r\n            ) AS a\r\n        UNION\r\n        SELECT\r\n            @lastDocDate = b.DocDate,\r\n            b.DocDate,\r\n            b.DocTime,\r\n            b.DocType,\r\n            b.DocID,\r\n            b.DocInvoice,\r\n            b.SalesmanShortName,\r\n	    b.mesa,\r\n            b.subtot,\r\n            b.tot\r\n        FROM\r\n            (\r\n                SELECT\r\n                    ( date_format(Date(th.ModifyDate),\"%d-%m \")) as DocDate,\r\n                    TIME_FORMAT(th.ModifyDate, \"%H:%i\") as DocTime,\r\n                    1 as DocType,\r\n                    concat (\r\n                        st.DataChar,\r\n                        REPEAT(\"0\", 7 - length(st.ID)),\r\n                        st.ID\r\n                    ) as DocID,\r\n                    th.DocumentID as DocInvoice,\r\n                    s.SalesmanShortName,\r\n		    th.TableID as mesa,\r\n                    round((st.tabletotal) / 100.0, 2) as subtot,\r\n                    round((st.tabletotal - th.TableTotal) / 100.0, 2) as tot\r\n                FROM\r\n                    transactionsheaders th\r\n                    LEFT JOIN transactionssubtotals ts on ts.TransactionID = TH.UID\r\n                    LEFT JOIN subtotals st ON st.DataChar = ts.SubTotalChar\r\n                    AND st.ID = ts.SubTotalID\r\n                    LEFT JOIN salesmans s on s.UID = st.CreateUserUID\r\n                    INNER JOIN (\r\n                        SELECT\r\n                            th.DocumentID pID,\r\n                            max(\r\n                                concat(\r\n                                    st.DataChar,\r\n                                    REPEAT(\"0\", 7 - length(st.ID)),\r\n                                    st.ID\r\n                                )\r\n                            ) maxDocID\r\n                        FROM\r\n                            transactionsheaders th\r\n                            LEFT JOIN transactionssubtotals ts on ts.TransactionID = TH.UID\r\n                            LEFT JOIN subtotals st ON st.DataChar = ts.SubTotalChar\r\n                            AND st.ID = ts.SubTotalID\r\n                        WHERE\r\n                            th.TransactionStatus = \"N\"\r\n                            AND DATE(th.TransactionEndTime) between \"(101)\"\r\n                            and \"(101)\"\r\n                            AND DATE(st.CreateDate) between \"(101)\"\r\n                            and \"(101)\"\r\n                            AND th.OrderReferences <> \"\"\r\n                            AND th.TableTotal < st.tabletotal\r\n                        GROUP BY\r\n                            th.DocumentID\r\n                    ) sq on sq.pID = th.DocumentID\r\n                    AND SQ.maxDocID = concat(\r\n                        st.DataChar,\r\n                        REPEAT(\"0\", 7 - length(st.ID)),\r\n                        st.ID\r\n                    )\r\n                WHERE\r\n                    th.TransactionStatus = \"N\"\r\n                    AND th.OrderReferences <> \"\"\r\n                    AND th.TableTotal < st.tabletotal\r\n                    AND DATE(th.TransactionEndTime) between \"(101)\"\r\n                    and \"(101)\"\r\n                    AND DATE(st.CreateDate) between \"(101)\"\r\n                    and \"(101)\"\r\n            ) as b\r\n        ORDER BY\r\n            DocDate desc,\r\n            DocInvoice desc,\r\n            DocType,\r\n            DocID desc\r\n    ) as z','%s%5.5s %3.3s %10.10s %2.2s %6.8s %6.8s ',NULL,NULL,7,1),(40002,0,1,40,NULL,'----------------------------------------\n','\r\nSELECT\r\n    round(sum((st.tabletotal - th.TableTotal)) / 100.0, 2) as tot\r\nFROM transactionsheaders th\r\n    LEFT JOIN transactionssubtotals ts on ts.TransactionID = TH.UID\r\n    LEFT JOIN subtotals st ON st.DataChar = ts.SubTotalChar\r\n    AND st.ID = ts.SubTotalID\r\n    LEFT JOIN salesmans s on s.UID = st.CreateUserUID\r\n    INNER JOIN (\r\n        SELECT\r\n            th.DocumentID pID,\r\n            max(\r\n                concat(st.DataChar , REPEAT(\"0\", 7 - length(st.ID)),st.ID)\r\n            ) maxDocID\r\n        FROM\r\n            transactionsheaders th\r\n            LEFT JOIN transactionssubtotals ts on ts.TransactionID = TH.UID\r\n            LEFT JOIN subtotals st ON st.DataChar = ts.SubTotalChar\r\n            AND st.ID = ts.SubTotalID\r\n        WHERE\r\n            th.TransactionStatus = \"N\"\r\n            AND th.OrderReferences <> \"\"\r\n            AND th.TableTotal < st.tabletotal\r\n        GROUP BY\r\n            th.DocumentID\r\n    ) sq on sq.pID = th.DocumentID\r\n    AND SQ.maxDocID = concat(st.DataChar , REPEAT(\"0\", 7 - length(st.ID)),st.ID)\r\nWHERE\r\n    th.TransactionStatus = \"N\"\r\n    AND th.OrderReferences <> \"\"\r\n    AND th.TableTotal < st.tabletotal\r\n    AND DATE(th.TransactionEndTime) between \"(101)\"\r\n    and \"(111)\"','Total Diferenca:                %8.8s',NULL,NULL,2,2),(41001,0,1,41,NULL,'\n         -- DECLARADO --         \n','SELECT \r\n    pTypes.ShortDescription as \'description\',\r\n    replace(round(tenders.Value/100,2),\'.\',\',\') as \'value\'\r\nFROM dayclosetenders tenders\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE DATE(tenders.Date) =   \'(101)\'  ;','    %-16.16s%20.20s\n','SELECT \n    replace(round(IFNULL(sum(tenders.Value),0)/100,2),\'.\',\',\') as \'value\'\nFROM dayclosetenders tenders\nWHERE DATE(tenders.Date) =   \'(101)\' ','                                   -----\n    Total Declarado: %19.19s\n',2,1),(41002,0,1,41,NULL,'\n         -- PARA DEPOSITO --         \nT.Pagamento          Valor       Comissao\n----------------------------------------\n','SELECT \n    pTypes.Description as \'description\',\n    replace(round(tenders.Value/100,2),\'.\',\',\') as \'value\',\n    replace(round(tenders.ComissionValue/100,2),\'.\',\',\') as \'comissionvalue\'\nFROM dayclosedeposittenders tenders\n    INNER JOIN ffin_paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE DATE(tenders.Date) =   \'(101)\' \n','%-15.15s%10.10s%15.15s\n','SELECT \n    replace(round(IFNULL(sum(tenders.Value),0)/100,2),\'.\',\',\') as \'value\' , \n    replace(round(IFNULL(sum(tenders.ComissionValue),0)/100,2),\'.\',\',\') as \'comissionvalue\'\nFROM dayclosedeposittenders tenders\nWHERE DATE(tenders.Date) =   \'(101)\' ','        --------------------------------\n%25.25s%15.15s\n',3,2),(41003,0,1,41,NULL,'\n         -- DOCS COMPRA --         \nDocumento       Valor S/IVA     C/IVA\n----------------------------------------\n','\r\nSELECT \r\n    ffin.DocNumber,\r\n    replace(round(NetValue/100,2),\'.\',\',\') as \'value\',\r\n    replace(round(floor((NetValue*(100+ TaxRate))/100/100),2),\'.\',\',\') as \'value2\'\r\nFROM ffin\r\nWHERE DATE(ffin.Date) =   \'(101)\'','%-15.15s%10.10s%15.15s\n','SELECT \n    replace(round(IFNULL(sum(NetValue),0)/100,2),\'.\',\',\') as \'value\' ,\n    replace(round(IFNULL(sum(NetValue*(100+ TaxRate)/100),0)/100,2),\'.\',\',\') as \'value2\' \nFROM ffin\nWHERE DATE(ffin.Date) =   \'(101)\' \n','        --------------------------------\n%25.25s%15.15s\n',3,3),(41004,0,1,41,NULL,NULL,'',NULL,'SELECT \n		replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') AS \'value\'\nFROM transactionsheaders headers\n	INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nWHERE DATE(headers.TransactionEndTime) = \'(101)\' \nAND headers.TransactionStatus = \'N\' \nAND headers.DocumentTypeUID!=13\n','\n    Total Vendas: %22.22s',1,4),(41005,0,1,41,NULL,NULL,'',NULL,'SELECT replace(round((\n/* total vendas */\n(SELECT \n 	IFNULL(sum(SaleValue-SaleValue*headers.DiscountPercent/100),0)\nFROM transactionsheaders headers\n	INNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nWHERE DATE(headers.TransactionEndTime) = \'(101)\' \nAND headers.TransactionStatus = \'N\' \nAND headers.DocumentTypeUID!=13\n)\n-\n(\n	/*total de declarado - comissoes*/\n	(\n	SELECT \n		IFNULL(sum(tenders.Value),0) - IFNULL(sum(tenders.ComissionValue),0)\n	FROM dayclosedeposittenders tenders\n	WHERE DATE(tenders.Date) =   \'(101)\' \n	)\n	+\n	(\n		SELECT \n			IFNULL(sum(NetValue*(100+ TaxRate)/100),0) \n		FROM ffin\n		WHERE DATE(ffin.Date) =   \'(101)\' \n	)\n              \n)\n)/100,2),\'.\',\',\') as \'value\'','\n    Diferenca Caixa: %19.19s',1,5),(42001,0,1,42,NULL,'\n\nData     Pess    Total     Desc     Fact\n----------------------------------------\n','SELECT      DATE_FORMAT(headers.TransactionEndTime,\'%d-%m\') as dateDay,     a.pCount as pessoas,       round(sum(     IF(headers.DocumentTypeUid <> 25,    (IF (details.VatIncluded,      (IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) ,     (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) * (100 + taxes.TaxRate)/100 ))     ,-1*     (IF (details.VatIncluded,      (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) ,     (IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) * (100 + taxes.TaxRate)/100 )))     )/100,2)  AS total,        round(sum(  IF(headers.DocumentTypeUid <> 25,  IF (details.VatIncluded,   (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) ,  (IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) * (100 + taxes.TaxRate)/100 ),  -1*  IF (details.VatIncluded,   (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) ,  (IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) * (100 + taxes.TaxRate)/100 )  )  - details.SaleValue   )/100,2)  AS descontos,         round(sum(details.SaleValue)/100,2) as faturado   FROM transactionsdetails details     INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID     INNER JOIN plus on details.PluUID = plus.uid     RIGHT JOIN properties on properties.UID =plus.PropertyUID     LEFT JOIN taxes on taxes.UID =details.SaleTaxUID     INNER JOIN (SELECT DATE(headers.TransactionEndTime) as dateDay,      sum(if (headers.DocumentTypeUid <> 25,headers.CustomerCount,-1*headers.CustomerCount)) as pCount     FROM transactionsheaders headers WHERE headers.TransactionStatus = \'N\' AND headers.DocumentTypeUID != 13 GROUP BY dateDay) a on a.dateDay = DATE(headers.TransactionEndTime) WHERE headers.TransactionStatus = \'N\'     AND DATE(headers.TransactionEndTime) between    \'(101)\'  and  \'(111)\'       AND headers.DocumentTypeUID != 13 GROUP BY DATE(headers.TransactionEndTime);','%-8.8s%5.5s%9.9s%9.9s%9.9s\n','SELECT      (SELECT sum(if (headers.DocumentTypeUid <> 25,headers.CustomerCount,-1*headers.CustomerCount)) as pCount     FROM transactionsheaders headers where headers.TransactionStatus = \'N\' AND headers.DocumentTypeUID != 13 AND DATE(headers.TransactionEndTime) between \'(101)\'  and  \'(111)\'  ) as pessoas,    round(sum(     IF(headers.DocumentTypeUid <> 25,    (IF (details.VatIncluded,      (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) ,     (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) * (100 + taxes.TaxRate)/100 ))     ,-1*     (IF (details.VatIncluded,      (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) ,     (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) * (100 + taxes.TaxRate)/100 )))     )/100,2)  AS total,        round(sum(  IF(headers.DocumentTypeUid <> 25,  IF (details.VatIncluded,   (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) ,  (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) * (100 + taxes.TaxRate)/100 ),  -1*  IF (details.VatIncluded,   (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) ,  (IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,details.Quantity/1000,details.Quantity) * details.PluUnitPrice) * (100 + taxes.TaxRate)/100 )  )  - details.SaleValue   )/100,2)  AS descontos,         round(sum(details.SaleValue)/100,2) as faturado   FROM transactionsdetails details     INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID     INNER JOIN plus on details.PluUID = plus.uid     RIGHT JOIN properties on properties.UID =plus.PropertyUID     LEFT JOIN taxes on taxes.UID =details.SaleTaxUID WHERE headers.TransactionStatus = \'N\'     AND DATE(headers.TransactionEndTime) between    \'(101)\'  and  \'(111)\'       AND headers.DocumentTypeUID != 13    ;','        --------------------------------\n%13.13s%9.9s%9.9s%9.9s\n',5,1),(43001,0,1,43,NULL,'Zona      Forma Pagamento          Valor\n----------------------------------------\n','SELECT \nIF(Q.zone=     @lastName,\'\',   @lastName:= Q.zone) AS zona,\nQ.description, Q.value\nFROM\n(\nSELECT \n@lastName:=\'\',\n    CONCAT(zone,\'\n\') AS zone,\ndescription, round(value/100,2) as value FROM\n(\nSELECT \n    zones.Description as \'zone\',\n    pTypes.code as \'typeCode\',\n    (select case pTypes.code when \'9999\' then \'Dinheiro\' when \'9998\' then \'Dinheiro\' else pTypes.LongDescription end) AS \'description\',\n    sum(tenders.value) as \'value\'\nFROM transactionsheaders headers \n    LEFT JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID\n    LEFT JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n    LEFT JOIN zones on headers.zone = zones.UID \n WHERE DATE(headers.TransactionEndTime)between \'(101)\' and \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n	AND  headers.DocumentTypeUID <> 13\nGROUP BY zone,description\nUNION ALL\nSELECT \n    zones.Description as \'zone\',\n    9 as \'typeCode\',\n    \'-- Total --\' AS \'description\',\n   sum(tenders.value) as \'value\'\nFROM transactionsheaders headers \n    LEFT JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID\n    LEFT JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n    LEFT JOIN zones on headers.zone = zones.UID \n WHERE DATE(headers.TransactionEndTime)between \'(101)\' and \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n	AND  headers.DocumentTypeUID <> 13\nGROUP BY zone,description\n) AS A\nORDER BY zone,description\n) AS Q','%s     %-20.20s%15.15s\n','SELECT \r\n    round(sum(tenders.value)/100,2) as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE DATE(headers.TransactionEndTime)between \'(101)\' and \'(111)\'\r\n    AND headers.TransactionStatus = \'N\'\r\n	AND  headers.DocumentTypeUID <> 13\r\n    ','                       -----------------\n%40.40s\n',3,1),(43002,0,1,43,NULL,'Forma Pagamento                    Valor\n----------------------------------------\n','SELECT \r\n    (select case pTypes.code when \'9999\' then \'Dinheiro\' when \'9998\' then \'Dinheiro\' else pTypes.LongDescription end) AS description,\r\n    round(sum(tenders.value)/100,2) as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE DATE(headers.TransactionEndTime)between \'(101)\' and \'(111)\'\r\n    AND headers.TransactionStatus = \'N\'\r\nGROUP BY description\r\n','%-20.20s%20.20s\n','SELECT \r\n    round(sum(tenders.value)/100,2) as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE DATE(headers.TransactionEndTime)between \'(101)\' and \'(111)\'\r\n    AND headers.TransactionStatus = \'N\'\r\n    ','                       -----------------\n%40.40s\n',2,2),(44001,0,1,44,NULL,'Documento         Mesa     Pagam   Valor\n----------------------------------------\n','SELECT \n    documenttypes.ShortDescription,\n    headers.DocumentID,\n    headers.TableID,\n    (select case pTypes.code when \'9999\' then \'Dinheiro\' when \'9998\' then \'Dinheiro\' else pTypes.LongDescription end) AS description,\n    round(sum(tenders.value)/100,2) as \'value\'\nFROM transactionsheaders headers \n    LEFT JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID\n    LEFT JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n    LEFT JOIN documenttypes on documenttypes.DocumentType = headers.DocumentTypeUID\n        \nWHERE DATE(headers.TransactionEndTime)between \'(101)\' and \'(111)\'\n    AND headers.TransactionStatus = \'N\'\n    AND documenttypes.RecordDeleted = 0    \nGROUP BY headers.DocumentID, Description','%-4.4s %-11.11s %-8.8s %-6.6s %7.7s\n','SELECT \r\n    round(sum(tenders.value)/100,2) as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE DATE(headers.TransactionEndTime)between \'(101)\' and \'(111)\'\r\n    AND headers.TransactionStatus = \'N\'','                       -----------------\n%40.40s\n',5,1),(45001,0,1,45,NULL,'Forma Pagamento                    Valor\n----------------------------------------\n','SELECT \r\n    (select case pTypes.code when \'9999\' then \'Dinheiro\' when \'9998\' then \'Dinheiro\' else pTypes.LongDescription end) AS description,\r\n    round(sum(tenders.value)/100,2) as \'value\'\r\n\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\n    \r\nWHERE DATE(headers.TransactionEndTime) = \'(101)\'\r\n    AND headers.TransactionStatus = \'N\'\r\n    \r\nGROUP BY description\r\n','%-20.20s%20.20s\n','SELECT \r\n    round(sum(tenders.value)/100,2) as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE DATE(headers.TransactionEndTime) = \'(101)\'\r\n    AND headers.TransactionStatus = \'N\'\r\n','                       -----------------\n%40.40s\n',2,1),(45002,0,1,45,NULL,'Documento            Pagamento     Valor\n----------------------------------------\n','SELECT \r\n    documenttypes.ShortDescription,\r\n    headers.DocumentID,\r\n    pTypes.LongDescription,\r\n    round(tenders.value/100,2) as \'value\'\r\nFROM transactionsheaders headers \r\n    LEFT JOIN transactionstenders tenders ON headers.UID = tenders.TransactionUID\r\n    LEFT JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\n    LEFT JOIN documenttypes on documenttypes.DocumentType = headers.DocumentTypeUID\r\nWHERE DATE(headers.TransactionEndTime) = \'(101)\'\r\n    AND headers.TransactionStatus = \'N\'\r\n    AND documenttypes.RecordDeleted = 0    \r\nGROUP BY headers.DocumentID, tenders.PaymentTypeUID','%-8.8s %-11.11s %8.8s %10.10s\n','SELECT \r\n    round(sum(tenders.value)/100,2) as \'value\'\r\nFROM transactionstenders tenders\r\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\r\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\r\nWHERE DATE(headers.TransactionEndTime) = \'(101)\'\r\n    AND headers.TransactionStatus = \'N\'','                       -----------------\n%40.40s\n',4,2),(45003,0,1,45,NULL,'Recibo                             Valor\n----------------------------------------\n','SELECT \r\n    DocumentID, \r\n    round(Value/100,2) as value\r\nFROM \r\n    cashdrawer_movements mov\r\nWHERE DATE(mov.Date) = \'(101)\'\r\n    AND mov.Voided = 0 \r\n	AND mov.MovementTypeID = 8','%-20.20s%20.20s\n','SELECT \r\n    round(Value/100,2) as value\r\nFROM \r\n    cashdrawer_movements mov\r\nWHERE DATE(mov.Date) = \'(101)\'\r\n    AND mov.Voided = 0\r\n	AND mov.MovementTypeID = 8','                       -----------------\n%40.40s\n',2,3),(45004,0,1,45,NULL,'Tx    Incidencia       Valor       Total\n----------------------------------------\n','SELECT\r\n	CASE WHEN (SELECT Value FROM appcore WHERE name =\'db_version\') > 385 THEN \r\n		CASE WHEN taxes.TaxRatePerc > 0 THEN \r\n			round(((taxes.TaxRate *100) + taxes.TaxRatePerc) / 100.0,2)\r\n		ELSE\r\n			round(taxes.TaxRate,0)\r\n		END\r\n	ELSE taxes.TaxRate \r\n	END AS \'rate\',\r\n    replace(round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2),\'.\',\',\') as \'valueTaxOff\',\r\nreplace(round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2),\'.\',\',\') as \'taxValue\',\r\n    replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'totalValue\'      \r\nFROM transactionsdetails details\r\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\r\nINNER JOIN taxes ON details.SaleTaxUID = taxes.UID \r\nWHERE     DATE(headers.TransactionEndTime)  = \'(101)\'  \r\nAND  headers.TransactionStatus = \'N\' \r\nand  headers.DocumentTypeUID != 13\r\nGroup by SaleTaxUID','%5.5s%11.11s%12.12s%12.12s\\n','SELECT\r\n    replace(round((sum(NetValue-NetValue*headers.DiscountPercent/100))/100,2),\'.\',\',\') as \'valueTaxOff\',\r\n    replace(round((sum(SaleValue-SaleValue*headers.DiscountPercent/100)-(sum(NetValue-NetValue*headers.DiscountPercent/100)))/100,2),\'.\',\',\') as \'taxValue\',\r\n    replace(round(sum(SaleValue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'totalValue\'      \r\nFROM transactionsdetails details\r\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\r\nINNER JOIN taxes ON details.SaleTaxUID = taxes.UID \r\nWHERE     DATE(headers.TransactionEndTime) = \'(101)\'  \r\nAND  headers.TransactionStatus = \'N\' \r\nAND  headers.DocumentTypeUID != 13','        --------------------------------\n%16.16s%12.12s%12.12s\n',4,4),(47001,0,1,47,NULL,'\nZona/Descricao             Qtd     Valor\n----------------------------------------\n','  SELECT   IF(Q.zone=     @lastName,\'\',   @lastName:= Q.zone) AS zona,  pluDescription,  q,  sale_value  FROM   (  SELECT   @lastName:=\'\',      CONCAT(zone,\'  \') AS zone,  pluDescription,  round(q) as q,  sale_value as sale_value  FROM   (  SELECT       zones.Description as \'zone\',      1 as \'typeCode\',      details.PluName AS \'pluDescription\',   SUM(   IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,   IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000),   IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)   )) as q,      replace(round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as sale_value  FROM transactionsdetails details      INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID      INNER JOIN taxes ON details.SaleTaxUID = taxes.UID       INNER JOIN salesmans on salesmans.uid = headers.CreateSalesmanUID      INNER JOIN plus on details.PluUID = plus.uid      RIGHT JOIN properties on properties.UID =plus.PropertyUID      LEFT JOIN zones on headers.zone = zones.UID   WHERE DATE(headers.TransactionEndTime)>= \'(101)\'       and DATE(headers.TransactionEndTime)<= \'(111)\'       and headers.TransactionStatus = \'N\'       and headers.ModifySalesmanUID like\'(102)\'      and details.PluUID like \'(113)\'      and headers.documentTypeUID  != 13   GROUP BY zone, typeCode,  pluDescription  UNION ALL  SELECT       zones.Description as \'zone\',      9 as \'typeCode\',      \'-- Total --\' AS \'pluDescription\',   SUM(   IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,   IF(headers.documentTypeUID != 25,details.Quantity/1000,-1*details.Quantity/1000),   IF(headers.documentTypeUID != 25,details.Quantity,-1*details.Quantity)   )) as q,      replace(round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as sale_value  FROM transactionsdetails details      INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID      INNER JOIN taxes ON details.SaleTaxUID = taxes.UID       INNER JOIN salesmans on salesmans.uid = headers.CreateSalesmanUID      INNER JOIN plus on details.PluUID = plus.uid      RIGHT JOIN properties on properties.UID =plus.PropertyUID      LEFT JOIN zones on headers.zone = zones.UID   WHERE DATE(headers.TransactionEndTime)>= \'(101)\'       and DATE(headers.TransactionEndTime)<= \'(111)\'       and headers.TransactionStatus = \'N\'       and headers.ModifySalesmanUID like\'(102)\'      and details.PluUID like \'(113)\'      and headers.documentTypeUID  != 13    GROUP BY zone,typeCode, pluDescription      ) A  GROUP BY zone,typeCode,pluDescription  ) AS Q','%s     %-20.20s%5.5s%10.10s\n','\r\nSELECT \r\n    replace(round(sum(details.SaleValue-details.SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'value\'\r\nFROM transactionsdetails details\r\n    INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\r\n    INNER JOIN taxes ON details.SaleTaxUID = taxes.UID \r\n    INNER JOIN salesmans on salesmans.uid = headers.CreateSalesmanUID\r\nWHERE DATE(headers.TransactionEndTime)>= \'(101)\' \r\n    and DATE(headers.TransactionEndTime)<= \'(111)\' \r\n    and headers.TransactionStatus = \'N\' \r\n    and   headers.ModifySalesmanUID like\'(102)\'\r\n    and details.PluUID like \'(113)\'\r\n    and headers.documentTypeUID  != 13 -- guias','        --------------------------------\n%40.40s\n',5,0),(1001001,0,1,101,'','\\n           -- TOTAL POR IVAS --         \\nTx    Incidencia       Valor       Total\\n----------------------------------------\\n','SELECT\n    taxes.TaxRate as \'rate\',\n    replace(round((   sum(SaleValue-SaleValue*headers.DiscountPercent/100) / ((100+taxes.TaxRate)/100)                             )/100,2),\'.\',\',\') as \'valueTaxOff\',\n    replace(round((   sum(SaleValue-SaleValue*headers.DiscountPercent/100)    -    (sum(SaleValue-SaleValue*headers.DiscountPercent/100) / ((100+taxes.TaxRate)/100))    )/100,2),\'.\',\',\') as \'taxValue\',\n    replace(round(    sum(SaleValue-SaleValue*headers.DiscountPercent/100)                                                         /100,2),\'.\',\',\') as \'totalValue\'\nFROM transactionsdetails details\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\nINNER JOIN taxes ON details.SaleTaxUID = taxes.UID \nWHERE       DATE(headers.TransactionEndTime) = \'(101)\' \nand  headers.TransactionStatus = \'N\' \nand  headers.DocumentTypeUID != 13 \nGroup by SaleTaxUID;','%4.4s%12.12s%12.12s%12.12s\\n','SELECT \n    replace(round(  sum(    (SaleValue-SaleValue*headers.DiscountPercent/100) / ((100+taxes.TaxRate)/100))                  /100,2),\'.\',\',\')  as \'valueTaxOff\',\n    replace(round(  sum(    (SaleValue-SaleValue*headers.DiscountPercent/100) - ((SaleValue-SaleValue*headers.DiscountPercent/100) / ((100+taxes.TaxRate)/100)))    /100,2),\'.\',\',\')  as \'taxValue\',\n    replace(round(  sum(   ( SaleValue-SaleValue*headers.DiscountPercent/100))                                              /100,2),\'.\',\',\')  as \'totalValue\'\nFROM transactionsdetails details\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\nINNER JOIN taxes ON details.SaleTaxUID = taxes.UID \nWHERE DATE(headers.TransactionEndTime) = \'(101)\' \nand headers.TransactionStatus = \'N\'\nand  headers.DocumentTypeUID != 13 ','        --------------------------------\\n%16.16s%12.12s%12.12s\\n',4,1),(1001002,0,1,101,'','\\n\\n         -- TOTAL POR POSTOS --         \\nTerminal                           Valor\\n----------------------------------------\\n','\n\nSELECT \n\n    salesterminal.description as \'description\', \n\n    replace(round(sum(details.salevalue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'value\'\n\nFROM transactionsheaders headers\n\nINNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\n\nINNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid\n\nWHERE DATE(headers.TransactionEndTime) = \'(101)\' \n\nand headers.TransactionStatus = \'N\' \n\nand headers.DocumentTypeUID!=13\n\nGroup by headers.TransactionStartTerminalUID;','%-20.20s%20.20s\\n',' \nSELECT \n\nreplace(round(IFNULL(sum(details.salevalue-SaleValue*headers.DiscountPercent/100),0)/100,2),\'.\',\',\') as \'value\'\n\nFROM transactionsheaders headers\n\nINNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\n\nINNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid\n\nWHERE DATE(headers.TransactionEndTime) = \'(101)\' \n\nand headers.TransactionStatus = \'N\' \n\nand  headers.DocumentTypeUID != 13 ','        --------------------------------\\n%40.40s\\n',2,2),(1001003,0,1,101,'','\\n\\n        -- FORMAS PAGAMENTO--           \\nForma Pagamento                    Valor\\n----------------------------------------\\n','SELECT \n    pTypes.LongDescription as \'description\',\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.Type in (0,3,6)\n    AND DATE(headers.TransactionEndTime) = \'(101)\'\n    and  headers.TransactionStatus = \'N\'\n    and  headers.DocumentTypeUID != 13 \nGroup by tenders.PaymentTypeUID\nunion\nSELECT \n    \'Dinheiro\',\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.type = 1\n    AND DATE(headers.TransactionEndTime) = \'(101)\'\n    and  headers.TransactionStatus = \'N\'\n    and  headers.DocumentTypeUID != 13 \nGroup by pTypes.type;','%-20.20s%20.20s\\n','SELECT \n    replace(round(IFNULL(sum(tenders.value),0)/100,2),\'.\',\',\') as \'value\'\n\nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n\nWHERE pTypes.Type in (0,1,3,6)\n    AND DATE(headers.TransactionEndTime) = \'(101)\'\n    and headers.TransactionStatus = \'N\'\n    and  headers.DocumentTypeUID != 13 ','        --------------------------------\\n%40.40s\\n',2,3),(1001004,0,1,101,NULL,'\n\n        -- TOTAL POR FAMILIA  --\\n\n\nFam/Subfam              Qnt        Valor\n----------------------------------------\n','SELECT     Q.F,     Q.T,     Q.V/*,     Q.C,     Q.K*/ FROM( (          SELECT         qry.fam AS F,         qry.qnt as T,         qry.value as V,         qry.code as C,         qry.fam2 as K     FROM(         SELECT              families.shortdescription as fam,             round(SUM(IF(properties.ReadQuantityFromScale  or details.PLUDivisionState = 1,1,details.Quantity)),2) as qnt,             replace(round(sum(details.salevalue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value,              families.code AS code,             families.uid AS fam2                     FROM transactionsdetails details             INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID             INNER JOIN plus on details.PluUID = plus.uid             INNER JOIN families on plus.familyid = families.uid             RIGHT JOIN properties on properties.UID =plus.PropertyUID         WHERE DATE(headers.TransactionEndTime) = \'(101)\'              and headers.TransactionStatus = \'N\'             and  headers.DocumentTypeUID != 13                      GROUP BY families.uid         ORDER by families.code     )     AS qry ) UNION (          SELECT         qry2.subfam AS F,         qry2.qnt as T,         qry2.value as V,         qry2.code as C,         qry2.fam as K     FROM(         SELECT              concat(\"    \",subfamilies.shortdescription) as subfam,             round(SUM(IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,1,details.Quantity)),2) as qnt,             replace(round(sum(details.salevalue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value,             (subfamilies.code+10000) AS code,             plus.familyid AS fam                    FROM transactionsdetails details             INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID               INNER JOIN plus on details.PluUID = plus.uid             INNER JOIN subfamilies on plus.subfamilyid = subfamilies.uid             RIGHT JOIN properties on properties.UID =plus.PropertyUID         WHERE DATE(headers.TransactionEndTime) = \'(101)\'              and headers.TransactionStatus = \'N\'              and  headers.DocumentTypeUID != 13          GROUP BY subfamilies.uid         ORDER by subfamilies.code     )     AS qry2 ) UNION (     SELECT         @label :=\"Total\" AS F,         round(SUM(IF(props.ReadQuantityFromScale  or details.PLUDivisionState = 1,1,details.Quantity)),2) as T,         replace(round(sum(details.salevalue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as V,         999999 AS C,         999999 AS K     FROM transactionsdetails details         INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID         RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID         RIGHT JOIN properties props on props.UID =mainplus.PropertyUID     WHERE DATE(headers.TransactionEndTime) = \'(101)\'           AND headers.TransactionStatus = \'N\'         and  headers.DocumentTypeUID != 13  ) ORDER BY K,C) AS Q;','%-20.20s %6.6s %12.12s\n',NULL,NULL,3,4),(1001005,0,1,101,NULL,'\\n          -- DOC. ESTORNADOS --\\nHora  Doc        Empregado         Valor\\n----------------------------------------\\n','SELECT \n    DATE_FORMAT(H.ModifyDate, \'%Hh%i\') as doc_date,\n    DocumentID,\n    S.SalesmanShortName,\n    REPLACE(ROUND(TableTotal/100,2),\'.\',\',\') as doc_value\n    FROM \n        transactionsheaders AS H INNER JOIN salesmans AS S ON H.CreateSalesmanUID=S.UID\n    WHERE \n        TransactionStatus=\'A\'\n    AND\n        DATE(H.ModifyDate) = \'(101)\' \n        and  H.DocumentTypeUID != 13 \n    ORDER BY\n       doc_date;','%-5.5s %-10.10s %-10.10s %12.12s\\n','SELECT \n    REPLACE(SUM(ROUND(TableTotal/100,2)),\'.\',\',\') as doc_value\n    FROM \n        transactionsheaders H\n    WHERE \n        TransactionStatus=\'A\'\n    AND\n        DATE(TransactionEndTime) = \'(101)\' ;','        --------------------------------\\n%40.40s\\n',4,5),(1001006,0,1,101,NULL,'\\n\\n          -- RESUMO DO DIA--           \\n----------------------------------------\\n','SELECT \"Ticket medio\",\nREPLACE(ROUND((SUM(TableTotal)/(SELECT COUNT(*) FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13 ))/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13 \nUNION\nSELECT \"Ticket maximo\",\nREPLACE(ROUND(MAX(TableTotal)/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13\nUNION\nSELECT \"Ticket minimo\",\nREPLACE(ROUND(MIN(TableTotal)/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13\nUNION\nSELECT \"Total\",\nREPLACE(ROUND(SUM(TableTotal)/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13 \nUNION\nSELECT \"Tickets estornados\",COUNT(*) FROM transactionsheaders WHERE TransactionStatus=\'A\' AND DATE(TransactionEndTime)>=\'(101)\' AND DATE (TransactionEndTime)<=\'(111)\' \nUNION\nSELECT \"Movimentos\",\nCOUNT(*) FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\' AND TransactionStatus = \'N\' AND DocumentTypeUID != 13;','%-20.20s%20.20s\\n',NULL,NULL,2,6),(1001007,0,1,101,NULL,'\\n -- Movimentos por serie\\n','SELECT \"Doc. inicial\",\"Doc. final\"\nUNION\nSELECT MIN(DocumentID),Max(DocumentID) From transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\' GROUP BY DocumentTypeUID;','%-15.15s -> %15.15s\\n',NULL,NULL,2,7),(10027001,0,1,127,'','\\n           -- TOTAL POR IVAS --         \\nTx    Incidencia       Valor       Total\\n----------------------------------------\\n','SELECT\n    taxes.TaxRate as \'rate\',\n    replace(round((   sum(SaleValue-SaleValue*headers.DiscountPercent/100) / ((100+taxes.TaxRate)/100)                             )/100,2),\'.\',\',\') as \'valueTaxOff\',\n    replace(round((   sum(SaleValue-SaleValue*headers.DiscountPercent/100)    -    (sum(SaleValue-SaleValue*headers.DiscountPercent/100) / ((100+taxes.TaxRate)/100))    )/100,2),\'.\',\',\') as \'taxValue\',\n    replace(round(    sum(SaleValue-SaleValue*headers.DiscountPercent/100)                                                         /100,2),\'.\',\',\') as \'totalValue\'\nFROM transactionsdetails details\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\nINNER JOIN taxes ON details.SaleTaxUID = taxes.UID \nWHERE      DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\nand  headers.TransactionStatus = \'N\' \nand  headers.DocumentTypeUID != 13 \nGroup by SaleTaxUID;','%4.4s%12.12s%12.12s%12.12s\\n','SELECT \n    replace(round(  sum(    (SaleValue-SaleValue*headers.DiscountPercent/100) / ((100+taxes.TaxRate)/100))                  /100,2),\'.\',\',\')  as \'valueTaxOff\',\n    replace(round(  sum(    (SaleValue-SaleValue*headers.DiscountPercent/100) - ((SaleValue-SaleValue*headers.DiscountPercent/100) / ((100+taxes.TaxRate)/100)))    /100,2),\'.\',\',\')  as \'taxValue\',\n    replace(round(  sum(   ( SaleValue-SaleValue*headers.DiscountPercent/100))                                              /100,2),\'.\',\',\')  as \'totalValue\'\nFROM transactionsdetails details\nINNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID\nINNER JOIN taxes ON details.SaleTaxUID = taxes.UID \nWHERE  DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\nand headers.TransactionStatus = \'N\'\nand  headers.DocumentTypeUID != 13 ','        --------------------------------\\n%16.16s%12.12s%12.12s\\n',4,1),(10027002,0,1,127,'','\\n\\n         -- TOTAL POR POSTOS --         \\nTerminal                           Valor\\n----------------------------------------\\n','SELECT \n    salesterminal.description as \'description\', \n    replace(round(sum(details.salevalue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as \'value\'\nFROM transactionsheaders headers\nINNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nINNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid\nWHERE DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\nand headers.TransactionStatus = \'N\' \nand headers.DocumentTypeUID!=13\nGroup by headers.TransactionStartTerminalUID;','%-20.20s%20.20s\\n','SELECT \nreplace(round(IFNULL(sum(details.salevalue-SaleValue*headers.DiscountPercent/100),0)/100,2),\'.\',\',\') as \'value\'\nFROM transactionsheaders headers\nINNER JOIN transactionsdetails details ON headers.UID = details.TransactionUID\nINNER JOIN salesterminal on headers.TransactionStartTerminalUID = salesterminal.uid\nWHERE  DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\nand headers.TransactionStatus = \'N\' \nand  headers.DocumentTypeUID != 13 ','        --------------------------------\\n%40.40s\\n',2,2),(10027003,0,1,127,'','\\n\\n        -- FORMAS PAGAMENTO--           \\nForma Pagamento                    Valor\\n----------------------------------------\\n','SELECT \n    pTypes.LongDescription as \'description\',\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.Type in (0,3,6)\n    AND  DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\n    and  headers.TransactionStatus = \'N\'\n    and  headers.DocumentTypeUID != 13 \nGroup by tenders.PaymentTypeUID\nunion\nSELECT \n    \'Dinheiro\',\n    replace(round(sum(tenders.value)/100,2),\'.\',\',\') as \'value\'\nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\nWHERE pTypes.type = 1\n    AND  DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\n    and  headers.TransactionStatus = \'N\'\n    and  headers.DocumentTypeUID != 13 \nGroup by pTypes.type;','%-20.20s%20.20s\\n','SELECT \n    replace(round(IFNULL(sum(tenders.value),0)/100,2),\'.\',\',\') as \'value\'\n\nFROM transactionstenders tenders\n    INNER JOIN transactionsheaders headers ON headers.UID = tenders.TransactionUID\n    INNER JOIN paymenttypes pTypes on pTypes.uid = tenders.PaymentTypeUID\n\nWHERE pTypes.Type in (0,1,3,6)\n    AND  DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'\n    and headers.TransactionStatus = \'N\'\n    and  headers.DocumentTypeUID != 13 ','        --------------------------------\\n%40.40s\\n',2,3),(10027004,0,1,127,NULL,'\n\n        -- TOTAL POR FAMILIA  --\\n\n\nFam/Subfam              Qnt        Valor\n----------------------------------------\n','SELECT     Q.F,     Q.T,     Q.V/*,     Q.C,     Q.K*/ FROM( (        SELECT         qry.fam AS F,         qry.qnt as T,         qry.value as V,         qry.code as C,         qry.fam2 as K     FROM(         SELECT              families.shortdescription as fam,             round(SUM(IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,1,details.Quantity)),2) as qnt,             replace(round(sum(details.salevalue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value,              families.code AS code,             families.uid AS fam2                     FROM transactionsdetails details             INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID              INNER JOIN plus on details.PluUID = plus.uid             INNER JOIN families on plus.familyid = families.uid             RIGHT JOIN properties on properties.UID =plus.PropertyUID         WHERE DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'             and headers.TransactionStatus = \'N\'                      and  headers.DocumentTypeUID != 13             GROUP BY families.uid         ORDER by families.code     )     AS qry ) UNION (         SELECT         qry2.subfam AS F,         qry2.qnt as T,         qry2.value as V,         qry2.code as C,         qry2.fam as K     FROM(         SELECT              concat(\"    \",subfamilies.shortdescription) as subfam,             round(SUM(IF(properties.ReadQuantityFromScale or details.PLUDivisionState = 1,1,details.Quantity)),2) as qnt,             replace(round(sum(details.salevalue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as value,             (subfamilies.code+10000) AS code,             plus.familyid AS fam                    FROM transactionsdetails details             INNER JOIN transactionsheaders headers on headers.uid = details.TransactionUID              INNER JOIN plus on details.PluUID = plus.uid             INNER JOIN subfamilies on plus.subfamilyid = subfamilies.uid             RIGHT JOIN properties on properties.UID =plus.PropertyUID         WHERE  DATE(headers.TransactionEndTime) between \'(101)\' and \'(111)\'             and headers.TransactionStatus = \'N\'              and  headers.DocumentTypeUID != 13          GROUP BY subfamilies.uid         ORDER by subfamilies.code     )     AS qry2 ) UNION (     SELECT         @label :=\"Total\" AS F,         round(SUM(IF(props.ReadQuantityFromScale or details.PLUDivisionState = 1,1,details.Quantity)),2) as T,         replace(round(sum(details.salevalue-SaleValue*headers.DiscountPercent/100)/100,2),\'.\',\',\') as V,         999999 AS C,         999999 AS K     FROM transactionsdetails details         INNER JOIN transactionsheaders headers ON headers.UID = details.TransactionUID         RIGHT JOIN plus mainplus on mainplus.UID=details.PluUID         RIGHT JOIN properties props on props.UID =mainplus.PropertyUID     WHERE DATE(headers.TransactionEndTime) BETWEEN  \'(101)\'  AND \'(111)\'          AND headers.TransactionStatus = \'N\'         and  headers.DocumentTypeUID != 13  ) ORDER BY K,C) AS Q;','%-20.20s %6.6s %12.12s\n',NULL,NULL,3,4),(10027005,0,1,127,NULL,'\\n          -- DOC. ESTORNADOS --\\nHora  Doc        Empregado         Valor\\n----------------------------------------\\n','SELECT \n    DATE_FORMAT(H.ModifyDate, \'%Hh%i\') as doc_date,\n    DocumentID,\n    S.SalesmanShortName,\n    REPLACE(ROUND(TableTotal/100,2),\'.\',\',\') as doc_value\n    FROM \n        transactionsheaders AS H INNER JOIN salesmans AS S ON H.CreateSalesmanUID=S.UID\n    WHERE \n        TransactionStatus=\'A\'\n    AND\n         DATE (H.ModifyDate) BETWEEN  \'(101)\'  AND \'(111)\' \n    and  H.DocumentTypeUID != 13 \n    ORDER BY\n       doc_date;','%-5.5s %-10.10s %-10.10s %12.12s\\n','SELECT \n    REPLACE(SUM(ROUND(TableTotal/100,2)),\'.\',\',\') as doc_value\n    FROM \n        transactionsheaders H\n    WHERE \n        TransactionStatus=\'A\'\n    AND\n        DATE(TransactionEndTime) >= \'(101)\' AND DATE(TransactionEndTime)<= \'(111)\'\n    and H.DocumentTypeUID != 13 ','        --------------------------------\\n%40.40s\\n',4,5),(10027006,0,1,127,NULL,'\\n\\n          -- RESUMO DO DIA--           \\n----------------------------------------\\n','SELECT \"Ticket medio\",\nREPLACE(ROUND((SUM(TableTotal)/(SELECT COUNT(*) FROM transactionsheaders WHERE DATE(TransactionEndTime) BETWEEN  \'(101)\'  AND \'(111)\'   AND TransactionStatus=\'N\' AND DocumentTypeUID!=13 ))/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime) BETWEEN  \'(101)\'  AND \'(111)\'    AND TransactionStatus=\'N\' AND DocumentTypeUID!=13 \nUNION\nSELECT \"Ticket maximo\",\nREPLACE(ROUND(MAX(TableTotal)/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13\nUNION\nSELECT \"Ticket minimo\",\nREPLACE(ROUND(MIN(TableTotal)/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13\nUNION\nSELECT \"Total\",\nREPLACE(ROUND(SUM(TableTotal)/100,2),\'.\',\',\') FROM transactionsheaders WHERE DATE(TransactionEndTime)=\'(101)\'  AND TransactionStatus=\'N\' AND DocumentTypeUID!=13 \nUNION\nSELECT \"Tickets estornados\",COUNT(*) FROM transactionsheaders WHERE TransactionStatus=\'A\' AND DATE(TransactionEndTime)>=\'(101)\' AND DATE (TransactionEndTime)<=\'(111)\' \nUNION\nSELECT \"Movimentos\",\nCOUNT(*) FROM transactionsheaders WHERE DATE(TransactionEndTime) BETWEEN  \'(101)\'  AND \'(111)\'  AND TransactionStatus = \'N\' AND DocumentTypeUID != 13;','%-20.20s%20.20s\\n',NULL,NULL,2,6),(10027007,0,1,127,NULL,'\\n -- Movimentos por serie\\n','SELECT \"Doc. inicial\",\"Doc. final\"\nUNION\nSELECT MIN(DocumentID),Max(DocumentID) From transactionsheaders WHERE DATE(TransactionEndTime) BETWEEN  \'(101)\'  AND \'(111)\' GROUP BY DocumentTypeUID;','%-15.15s -> %15.15s\\n',NULL,NULL,2,7);
/*!40000 ALTER TABLE `reportsections` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesmanlevel`
--

DROP TABLE IF EXISTS `salesmanlevel`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `salesmanlevel` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) NOT NULL,
  `Description` varchar(55) NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesmanlevel`
--

LOCK TABLES `salesmanlevel` WRITE;
/*!40000 ALTER TABLE `salesmanlevel` DISABLE KEYS */;
INSERT INTO `salesmanlevel` VALUES (1,0,92,1,'Tcnico'),(2,0,87,2,'Gerente'),(3,0,88,3,'Supervisor'),(4,0,92,4,'Empregado');
/*!40000 ALTER TABLE `salesmanlevel` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesmanpermissions`
--

DROP TABLE IF EXISTS `salesmanpermissions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `salesmanpermissions` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `PermissionID` int(11) NOT NULL,
  `Value` tinyint(1) NOT NULL,
  `LevelUID` int(11) NOT NULL,
  `UseInService` int(11) NOT NULL DEFAULT 1,
  `UseInRetail` int(11) NOT NULL DEFAULT 1,
  PRIMARY KEY (`UID`),
  KEY `fk_salesmanpermission_has_salesmanlevel` (`LevelUID`),
  CONSTRAINT `fk_salesmanpermission_has_salesmanlevel` FOREIGN KEY (`LevelUID`) REFERENCES `salesmanlevel` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=266 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesmanpermissions`
--

LOCK TABLES `salesmanpermissions` WRITE;
/*!40000 ALTER TABLE `salesmanpermissions` DISABLE KEYS */;
INSERT INTO `salesmanpermissions` VALUES (2,0,88,0,1,1,1,1),(3,0,64,9,1,4,1,1),(4,0,57,7,1,3,0,1),(5,0,38,6,1,3,0,1),(6,0,83,5,0,3,0,1),(7,0,57,4,1,3,1,1),(8,0,57,3,1,3,1,1),(9,0,57,2,1,3,1,1),(10,0,92,8,0,4,1,1),(11,0,57,8,1,3,1,1),(12,0,57,9,1,3,1,1),(13,0,64,10,1,3,1,1),(14,0,57,11,1,3,1,1),(15,0,57,15,1,3,1,1),(16,0,57,14,1,3,0,1),(17,0,57,13,1,3,0,1),(18,0,85,12,1,3,1,1),(19,0,57,1,1,3,0,1),(20,0,88,0,1,3,1,1),(21,0,57,17,1,3,1,1),(22,0,57,16,1,3,0,1),(23,0,57,18,1,3,1,1),(24,0,57,26,1,3,1,1),(25,0,57,25,1,3,1,1),(26,0,57,24,1,3,1,1),(27,0,57,23,1,3,1,1),(28,0,57,22,1,3,0,1),(29,0,57,21,1,3,0,1),(30,0,57,20,1,3,1,1),(31,0,57,19,1,3,1,1),(32,0,57,33,1,3,0,1),(33,0,57,35,1,3,1,1),(34,0,57,34,1,3,0,1),(35,0,57,36,1,3,1,1),(36,0,57,37,1,3,1,1),(37,0,57,38,1,3,1,1),(38,0,57,32,1,3,1,1),(39,0,57,31,1,3,1,1),(40,0,57,30,1,3,1,1),(41,0,57,29,1,3,1,1),(42,0,57,28,1,3,0,1),(43,0,57,27,1,3,0,1),(44,0,57,45,1,3,1,1),(45,0,57,43,1,3,0,1),(46,0,57,42,1,3,1,1),(47,0,57,41,1,3,0,1),(48,0,57,40,1,3,1,1),(49,0,57,39,1,3,1,1),(50,0,57,44,1,3,1,1),(51,0,57,46,1,3,1,1),(52,0,28,56,1,3,1,1),(53,0,28,57,1,3,1,1),(54,0,28,55,1,3,1,1),(55,0,28,54,1,3,1,1),(56,0,28,53,1,3,1,1),(57,0,57,52,1,3,1,1),(58,0,85,51,1,3,1,1),(59,0,57,50,1,3,1,1),(60,0,57,49,1,3,1,1),(61,0,57,48,1,3,1,1),(62,0,57,47,1,3,1,1),(63,0,28,60,1,3,1,1),(64,0,28,59,1,3,1,1),(65,0,28,58,1,3,1,1),(66,0,28,61,1,3,1,1),(67,0,89,9,1,1,1,1),(68,0,92,4,1,1,1,1),(69,0,92,5,0,1,0,1),(70,0,92,6,1,1,0,1),(71,0,89,3,1,1,1,1),(72,0,89,2,1,1,1,1),(73,0,86,1,1,1,0,1),(74,0,89,7,1,1,0,1),(75,0,57,0,1,4,1,1),(76,0,90,1,1,4,0,1),(77,0,64,2,1,4,1,1),(78,0,92,3,0,4,1,1),(79,0,92,4,0,4,1,1),(80,0,83,5,0,4,0,1),(81,0,36,6,0,4,0,1),(82,0,90,7,1,4,0,1),(83,0,79,24,0,4,1,1),(84,0,57,23,1,4,1,1),(85,0,92,22,1,4,0,1),(86,0,57,21,1,4,0,1),(87,0,92,20,0,4,1,1),(88,0,92,19,0,4,1,1),(89,0,90,18,1,4,1,1),(90,0,57,17,1,4,1,1),(91,0,57,15,1,4,1,1),(92,0,57,16,1,4,0,1),(93,0,57,14,1,4,0,1),(94,0,57,13,1,4,0,1),(95,0,57,12,1,4,1,1),(96,0,92,11,0,4,1,1),(97,0,92,10,0,4,1,1),(98,0,92,30,0,4,1,1),(99,0,92,29,0,4,1,1),(100,0,92,28,0,4,0,1),(101,0,92,27,0,4,0,1),(102,0,92,26,0,4,1,1),(103,0,92,25,0,4,1,1),(104,0,92,31,0,4,1,1),(105,0,92,32,0,4,1,1),(106,0,92,33,0,4,0,1),(107,0,92,34,0,4,0,1),(108,0,92,35,0,4,1,1),(109,0,92,36,0,4,1,1),(110,0,79,37,1,4,1,1),(111,0,79,38,0,4,1,1),(112,0,57,39,1,4,1,1),(113,0,79,40,0,4,1,1),(114,0,92,41,0,4,0,1),(115,0,92,42,0,4,1,1),(116,0,92,43,0,4,0,1),(117,0,92,44,0,4,1,1),(118,0,92,45,0,4,1,1),(119,0,92,46,0,4,1,1),(120,0,92,47,0,4,1,1),(121,0,70,48,1,4,1,1),(122,0,57,49,1,4,1,1),(123,0,92,50,0,4,1,1),(124,0,90,51,1,4,1,1),(125,0,57,53,1,4,1,1),(126,0,57,54,1,4,1,1),(127,0,57,55,1,4,1,1),(128,0,57,52,1,4,1,1),(129,0,57,60,1,4,1,1),(130,0,57,59,1,4,1,1),(131,0,57,58,1,4,1,1),(132,0,57,57,1,4,1,1),(133,0,57,56,1,4,1,1),(134,0,36,61,0,4,1,1),(135,0,57,1,1,2,0,1),(136,0,57,2,1,2,1,1),(137,0,57,3,1,2,1,1),(138,0,62,4,1,2,1,1),(139,0,83,5,0,2,0,1),(140,0,48,6,1,2,0,1),(141,0,64,7,1,2,0,1),(142,0,87,8,1,2,1,1),(143,0,64,9,1,2,1,1),(144,0,64,10,1,2,1,1),(145,0,57,11,1,2,1,1),(146,0,57,12,1,2,1,1),(147,0,57,13,1,2,0,1),(148,0,57,14,1,2,0,1),(149,0,57,16,1,2,0,1),(150,0,84,17,1,2,1,1),(151,0,57,18,1,2,1,1),(152,0,57,19,1,2,1,1),(153,0,51,20,1,2,1,1),(154,0,57,15,1,2,1,1),(155,0,64,22,1,2,0,1),(156,0,57,23,1,2,1,1),(157,0,57,24,1,2,1,1),(158,0,66,25,1,2,1,1),(159,0,57,26,1,2,1,1),(160,0,57,27,1,2,0,1),(161,0,57,28,1,2,0,1),(162,0,36,29,1,2,1,1),(163,0,57,30,1,2,1,1),(164,0,84,21,1,2,0,1),(165,0,57,31,1,2,1,1),(166,0,57,32,1,2,1,1),(167,0,57,33,1,2,0,1),(168,0,57,34,1,2,0,1),(169,0,36,35,1,2,1,1),(170,0,36,36,1,2,1,1),(171,0,36,37,1,2,1,1),(172,0,36,38,1,2,1,1),(173,0,36,39,1,2,1,1),(174,0,36,40,1,2,1,1),(175,0,36,41,1,2,0,1),(176,0,36,42,1,2,1,1),(177,0,36,43,1,2,0,1),(178,0,36,44,1,2,1,1),(179,0,36,45,1,2,1,1),(180,0,36,46,1,2,1,1),(181,0,36,47,1,2,1,1),(182,0,36,48,1,2,1,1),(183,0,36,49,1,2,1,1),(184,0,36,50,1,2,1,1),(185,0,36,51,1,2,1,1),(186,0,36,52,1,2,1,1),(187,0,87,53,1,2,1,1),(188,0,36,54,1,2,1,1),(189,0,36,55,1,2,1,1),(190,0,36,56,1,2,1,1),(191,0,36,57,1,2,1,1),(192,0,36,58,1,2,1,1),(193,0,36,59,1,2,1,1),(194,0,36,60,1,2,1,1),(195,0,36,61,1,2,1,1),(196,0,89,8,1,1,1,1),(197,0,89,10,1,1,1,1),(198,0,57,14,1,1,0,1),(199,0,89,11,1,1,1,1),(200,0,89,12,1,1,1,1),(201,0,57,13,1,1,0,1),(202,0,57,15,1,1,1,1),(203,0,57,16,1,1,0,1),(204,0,78,17,1,1,1,1),(205,0,89,18,1,1,1,1),(206,0,89,19,1,1,1,1),(207,0,57,20,1,1,1,1),(208,0,89,21,1,1,0,1),(209,0,43,22,1,1,0,1),(210,0,43,24,1,1,1,1),(211,0,89,25,1,1,1,1),(212,0,43,26,1,1,1,1),(213,0,57,23,0,1,1,1),(214,0,89,27,1,1,0,1),(215,0,43,28,1,1,0,1),(216,0,89,29,1,1,1,1),(217,0,89,31,1,1,1,1),(218,0,43,30,1,1,1,1),(219,0,43,32,1,1,1,1),(220,0,66,33,1,1,0,1),(221,0,43,34,1,1,0,1),(222,0,89,35,1,1,1,1),(223,0,43,36,1,1,1,1),(224,0,57,37,0,1,1,1),(225,0,43,38,1,1,1,1),(226,0,66,39,1,1,1,1),(227,0,43,40,1,1,1,1),(228,0,57,41,1,1,0,1),(229,0,57,42,1,1,1,1),(230,0,57,43,1,1,0,1),(231,0,57,44,1,1,1,1),(232,0,70,45,1,1,1,1),(233,0,57,46,1,1,1,1),(234,0,57,47,1,1,1,1),(235,0,57,48,1,1,1,1),(236,0,57,49,1,1,1,1),(237,0,57,50,1,1,1,1),(238,0,85,51,1,1,1,1),(239,0,57,52,1,1,1,1),(240,0,87,53,1,1,1,1),(241,0,57,54,1,1,1,1),(242,0,87,55,1,1,1,1),(243,0,57,56,1,1,1,1),(244,0,57,57,1,1,1,1),(245,0,87,58,1,1,1,1),(246,0,57,59,1,1,1,1),(247,0,57,0,1,2,1,1),(248,0,92,63,0,4,1,1),(249,0,92,65,0,4,0,1),(250,0,92,64,0,4,1,1),(251,0,89,66,1,1,0,1),(252,0,87,60,1,1,1,1),(253,0,87,66,1,2,0,1),(254,0,92,67,0,4,0,0),(255,0,92,68,0,4,1,1),(256,0,92,69,0,4,1,1),(257,0,92,79,0,4,1,1),(258,0,92,83,0,4,1,1),(259,0,92,82,1,4,0,1),(260,0,92,84,0,4,1,1),(261,0,92,87,0,4,1,1),(262,0,92,88,0,4,1,1),(263,0,92,74,0,4,0,1),(264,0,92,73,0,4,0,1),(265,0,92,85,1,4,0,1);
/*!40000 ALTER TABLE `salesmanpermissions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesmans`
--

DROP TABLE IF EXISTS `salesmans`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `salesmans` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `SalesmanID` int(11) NOT NULL,
  `SalesmanName` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `SalesmanShortName` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `SalesmanLevelUID` int(11) NOT NULL,
  `SalesmanPassword` varchar(250) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `Comments` varchar(250) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `EmailAddress` varchar(300) DEFAULT NULL,
  `AddressLine1` varchar(250) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `AddressLine2` varchar(250) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `Locality` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `PostalCode` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `Country` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `Telephone` varchar(200) DEFAULT NULL,
  `MobilePhone` varchar(200) DEFAULT NULL,
  `CardID` varchar(20) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `AccessTableRange` varchar(45) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `DefaultTable` int(11) NOT NULL,
  `LanguageUID` int(11) DEFAULT NULL,
  `SelfExpenditureLimit` int(11) NOT NULL,
  `SelfExpenditureSalesPrice` int(11) NOT NULL,
  `Color` int(11) NOT NULL,
  `Photo` varchar(250) CHARACTER SET latin1 COLLATE latin1_swedish_ci NOT NULL,
  `CommissionGroupSalesmansUID` int(11) DEFAULT NULL,
  `CommissionDailyLimit` int(11) NOT NULL,
  `CommissionTransactionLimit` int(11) NOT NULL,
  `ModifyDate` datetime DEFAULT NULL,
  `DefaultScreen` int(11) NOT NULL DEFAULT 3,
  `AccountBalance` int(11) NOT NULL DEFAULT 0,
  `CommissionPercent` int(11) NOT NULL DEFAULT 0,
  `SelfExpeditureQtLimit` int(11) NOT NULL DEFAULT 0,
  `UsesPurse` int(11) NOT NULL DEFAULT 0,
  `CustomerUID` int(11) NOT NULL DEFAULT 0,
  `DefaultExitScreen` int(11) NOT NULL DEFAULT 0,
  `DefaultWorkScreen` int(11) NOT NULL DEFAULT 104,
  `Consent` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `fk_salesman_has_salesmanleve` (`SalesmanLevelUID`),
  KEY `fk_salesman_has_language` (`LanguageUID`),
  KEY `fk_salesmans_CommisionGroupSalesmans1` (`CommissionGroupSalesmansUID`),
  CONSTRAINT `fk_salesman_has_language` FOREIGN KEY (`LanguageUID`) REFERENCES `languages` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_salesman_has_salesmanleve` FOREIGN KEY (`SalesmanLevelUID`) REFERENCES `salesmanlevel` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_salesmans_CommisionGroupSalesmans1` FOREIGN KEY (`CommissionGroupSalesmansUID`) REFERENCES `commissiongroup` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesmans`
--

LOCK TABLES `salesmans` WRITE;
/*!40000 ALTER TABLE `salesmans` DISABLE KEYS */;
INSERT INTO `salesmans` VALUES (1,0,2,1,'Tcnico','Tec',1,'','','','','','','','','','','','1:9999',0,1,0,0,0,'empregada.png',NULL,0,0,'2013-04-08 10:24:06',3,0,0,0,0,2,0,104,0);
/*!40000 ALTER TABLE `salesmans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesmansessions`
--

DROP TABLE IF EXISTS `salesmansessions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `salesmansessions` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `SessionID` int(11) NOT NULL,
  `SalesmanUID` int(11) NOT NULL,
  `WorkstationID` int(11) NOT NULL,
  `RemoteSessionID` int(11) NOT NULL,
  `StartTime` datetime NOT NULL,
  `EndTime` datetime NOT NULL,
  `CashDrawerUID` int(11) NOT NULL,
  `Commission` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `fk_salesmansession_has_salesman` (`SalesmanUID`),
  KEY `fk_salesmansession_has_cashdrawer` (`CashDrawerUID`)
) ENGINE=InnoDB AUTO_INCREMENT=7 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesmansessions`
--

LOCK TABLES `salesmansessions` WRITE;
/*!40000 ALTER TABLE `salesmansessions` DISABLE KEYS */;
INSERT INTO `salesmansessions` VALUES (6,0,0,0,1,1,0,'2013-03-21 11:44:37','2013-03-21 11:44:37',0,0);
/*!40000 ALTER TABLE `salesmansessions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesterminal`
--

DROP TABLE IF EXISTS `salesterminal`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `salesterminal` (
  `UID` int(11) NOT NULL,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) DEFAULT NULL,
  `Description` varchar(45) NOT NULL,
  `DefaultSalesPrice` int(11) NOT NULL,
  `CostCenterUID` int(11) NOT NULL,
  `CashDrawerUID` int(11) NOT NULL,
  `DefaultWorkingTable` int(11) NOT NULL,
  `Timeout` int(11) NOT NULL,
  `CashDrawerDeviceID` int(11) DEFAULT NULL,
  `CDisplayDeviceID` varchar(45) DEFAULT NULL,
  `CurrentCashDrawerUID` int(11) DEFAULT NULL,
  `DocumentCounters` varchar(100) DEFAULT NULL,
  `ScreenType` int(11) NOT NULL DEFAULT 0,
  `TableEditScreen` int(11) NOT NULL DEFAULT 0,
  `TableCloseScreen` int(11) NOT NULL DEFAULT 0,
  `PlusExclusions` varchar(1500) DEFAULT NULL,
  `TableRange` varchar(100) DEFAULT NULL,
  `DefaultDocType` int(11) NOT NULL DEFAULT 1017,
  `Terminal_Seqr_Name` varchar(50) NOT NULL DEFAULT '',
  `Terminal_Seqr_Pass` varchar(50) NOT NULL DEFAULT '',
  `Terminal_Seqr_Tid` varchar(250) NOT NULL DEFAULT '',
  `Terminal_Seqr_Qr` varchar(250) NOT NULL DEFAULT '',
  `CashDroDeviceID` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `fk_salesmanterminal_has_cashdrawer` (`CashDrawerUID`),
  KEY `fk_salesmanterminal_has_costcenter` (`CostCenterUID`),
  CONSTRAINT `fk_salesmanterminal_has_costcenter` FOREIGN KEY (`CostCenterUID`) REFERENCES `costcenters` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesterminal`
--

LOCK TABLES `salesterminal` WRITE;
/*!40000 ALTER TABLE `salesterminal` DISABLE KEYS */;
INSERT INTO `salesterminal` VALUES (1,0,84,1,'Terminal 1',0,1,1,0,0,1,'0',1,'-99,-99,-99,-99,-99,-99,-99',1,0,0,NULL,NULL,1017,'','','','',0),(2,0,73,2,'Terminal 2',0,1,1,0,0,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',1,0,0,NULL,NULL,1017,'','','','',0),(3,0,72,3,'Terminal 3',1,1,1,0,0,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',1,0,0,NULL,NULL,1017,'','','','',0),(4,0,57,4,'Terminal 4',1,1,1,0,0,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',1,0,0,NULL,NULL,1017,'','','','',0),(5,0,36,5,'Terminal 5',1,1,1,0,0,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',1,0,0,NULL,NULL,1017,'','','','',0),(6,0,66,6,'Terminal 6',1,1,1,0,0,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',1,0,0,NULL,NULL,1017,'','','','',0),(7,0,78,7,'Terminal 7',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(8,0,78,8,'Terminal 8',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(9,0,78,9,'Terminal 9',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(10,0,78,10,'Terminal 10',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(11,0,78,11,'Terminal 11',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(12,0,78,12,'Terminal 12',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(13,0,78,13,'Terminal 13',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(14,0,78,14,'Terminal 14',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(15,0,78,15,'Terminal 15',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(16,0,78,16,'Terminal 16',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(17,0,78,17,'Terminal 17',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(18,0,78,18,'Terminal 18',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(19,0,78,19,'Terminal 19',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(20,0,78,20,'Terminal 20',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(21,0,78,21,'Terminal 21',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(22,0,78,22,'Terminal 22',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(23,0,78,23,'Terminal 23',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(24,0,78,24,'Terminal 24',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(25,0,78,25,'Terminal 25',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(26,0,78,26,'Terminal 26',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(27,0,78,27,'Terminal 27',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(28,0,78,28,'Terminal 28',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(29,0,78,29,'Terminal 29',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(30,0,78,30,'Terminal 30',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0),(31,0,83,31,'Terminal 31',1,1,1,0,60,0,'0',0,'-99,-99,-99,-99,-99,-99,-99',0,0,0,NULL,NULL,1017,'','','','',0);
/*!40000 ALTER TABLE `salesterminal` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesterminalexclusions`
--

DROP TABLE IF EXISTS `salesterminalexclusions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `salesterminalexclusions` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) DEFAULT NULL,
  `Description` varchar(45) DEFAULT NULL,
  `WorkingZone` varchar(450) DEFAULT NULL,
  `Salesman` varchar(150) DEFAULT NULL,
  `Family` varchar(150) DEFAULT NULL,
  `SubFamily` varchar(150) DEFAULT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesterminalexclusions`
--

LOCK TABLES `salesterminalexclusions` WRITE;
/*!40000 ALTER TABLE `salesterminalexclusions` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesterminalexclusions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesterminalproperties`
--

DROP TABLE IF EXISTS `salesterminalproperties`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `salesterminalproperties` (
  `UID` int(11) NOT NULL,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `PropertyID` int(11) DEFAULT NULL,
  `Value` varchar(45) NOT NULL,
  `SalesTerminalUID` int(11) NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_properties_has_salesterminal` (`SalesTerminalUID`),
  CONSTRAINT `fk_properties_has_salesterminal` FOREIGN KEY (`SalesTerminalUID`) REFERENCES `salesterminal` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesterminalproperties`
--

LOCK TABLES `salesterminalproperties` WRITE;
/*!40000 ALTER TABLE `salesterminalproperties` DISABLE KEYS */;
INSERT INTO `salesterminalproperties` VALUES (1,0,56,0,'1',1),(2,0,20,4,'1',1),(3,0,20,4,'0',2),(4,0,26,8,'0',1),(5,0,20,5,'1',1),(6,0,68,3,'0',1),(7,0,56,2,'1',1),(8,0,26,7,'1',1),(9,0,20,0,'1',2),(10,0,20,8,'1',2),(11,0,22,4,'1',3),(12,0,24,8,'1',4),(13,0,24,0,'1',4),(14,0,31,9,'1',1),(15,0,54,15,'1',1),(16,0,79,22,'1',1),(17,0,80,6,'0',1),(18,0,56,10,'1',1),(19,0,28,12,'1',1),(20,0,28,23,'1',1),(21,0,79,26,'1',1),(22,0,36,0,'1',5),(23,0,36,2,'1',5),(24,0,36,6,'1',5),(25,0,36,9,'1',5),(26,0,36,10,'1',5),(27,0,36,12,'1',5),(28,0,36,15,'1',5),(29,0,36,22,'1',5),(30,0,36,23,'1',5),(31,0,37,23,'1',2),(32,0,37,22,'1',2),(33,0,53,15,'1',2),(34,0,64,12,'1',2),(35,0,37,10,'1',2),(36,0,37,9,'1',2),(37,0,49,6,'0',2),(38,0,37,2,'1',2),(39,0,43,22,'1',3),(40,0,43,15,'1',3),(41,0,45,12,'1',3),(42,0,45,9,'1',3),(43,0,55,2,'0',3),(44,0,45,0,'1',3),(45,0,72,6,'1',3),(46,0,45,10,'1',3),(47,0,45,23,'1',3),(48,0,44,0,'1',6),(49,0,44,2,'1',6),(50,0,57,22,'1',4),(51,0,57,22,'1',6),(52,0,59,26,'0',2),(53,0,66,15,'1',6),(54,0,66,12,'1',6),(55,0,66,10,'1',6),(56,0,66,9,'1',6),(57,0,66,6,'0',6),(58,0,66,23,'1',6),(59,0,66,26,'0',6);
/*!40000 ALTER TABLE `salesterminalproperties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `salesterminalsalesmans`
--

DROP TABLE IF EXISTS `salesterminalsalesmans`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `salesterminalsalesmans` (
  `UID` int(11) NOT NULL,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `SalesTerminalUID` int(11) NOT NULL,
  `SalesmanUID` int(11) NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_SalesTerminal_has_salesman_salesman1` (`SalesmanUID`),
  KEY `fk_SalesTerminal_has_salesman_SalesTerminal1` (`SalesTerminalUID`),
  CONSTRAINT `fk_SalesTerminal_has_salesman_SalesTerminal1` FOREIGN KEY (`SalesTerminalUID`) REFERENCES `salesterminal` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_SalesTerminal_has_salesman_salesman1` FOREIGN KEY (`SalesmanUID`) REFERENCES `salesmans` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `salesterminalsalesmans`
--

LOCK TABLES `salesterminalsalesmans` WRITE;
/*!40000 ALTER TABLE `salesterminalsalesmans` DISABLE KEYS */;
/*!40000 ALTER TABLE `salesterminalsalesmans` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `screens`
--

DROP TABLE IF EXISTS `screens`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `screens` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  `ID` int(11) NOT NULL,
  `UserInterfaceDescription` mediumblob DEFAULT NULL,
  `SalesTerminalUID` varchar(45) NOT NULL,
  `ScreenType` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`,`ScreenType`,`SalesTerminalUID`,`ID`)
) ENGINE=InnoDB AUTO_INCREMENT=2054 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `screens`
--

LOCK TABLES `screens` WRITE;
/*!40000 ALTER TABLE `screens` DISABLE KEYS */;
INSERT INTO `screens` VALUES (1,0,1786,'SCREEN_CONFIG_PAYMENTTYPES',101,'{\"objects\":[{\"id\":\"10426\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":101},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#290#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7476\",\"windowid\":\"10426\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"3619\",\"windowid\":\"10426\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":3},{\"value\":\"#291#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1772\",\"windowid\":\"10426\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#292#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21951\",\"windowid\":\"10426\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#293#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"10736\",\"windowid\":\"10426\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":40},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#294#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"901\",\"windowid\":\"14740\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11020\",\"windowid\":\"14740\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1208\",\"windowid\":\"10426\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19657\",\"windowid\":\"10426\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23860\",\"windowid\":\"10426\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"1739\",\"windowid\":\"10426\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31599\",\"windowid\":\"10426\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#805#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"888\",\"windowid\":\"10426\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":40},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#295#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]}]}','0',0),(9,0,1634,'SCREEN_CASHES',9,'{\"objects\":[{\"id\":\"13935\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":9},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#261#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"591\",\"windowid\":\"13935\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":23},{\"value\":25},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',0),(23,0,1637,'SCREEN_MESSAGEBOX',96,'{\"objects\":[{\"id\":\"8905\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":96},{\"value\":0},{\"value\":0},{\"value\":31},{\"value\":26},{\"value\":\"#286#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7723\",\"windowid\":\"8905\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":999},{\"value\":25},{\"value\":20},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#287#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9865\",\"windowid\":\"8905\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":1},{\"value\":29},{\"value\":7},{\"value\":\"#288#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29137\",\"windowid\":\"8905\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":10},{\"value\":29},{\"value\":9},{\"value\":\"#289#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',0),(26,0,1760,'SCREEN_CONFIG_CASHDRAWERS',110,'{\"objects\":[{\"id\":\"16100\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":110},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#416#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"6080\",\"windowid\":\"16100\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"12626\",\"windowid\":\"16100\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18201\",\"windowid\":\"16100\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12675\",\"windowid\":\"16100\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13687\",\"windowid\":\"16100\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19633\",\"windowid\":\"16100\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6066\",\"windowid\":\"16100\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":3},{\"value\":\"#417#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22226\",\"windowid\":\"16100\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#418#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"631\",\"windowid\":\"16100\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":61},{\"value\":50},{\"value\":12},{\"value\":3},{\"value\":\"#419#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"10282\",\"windowid\":\"16100\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#421#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21022\",\"windowid\":\"16100\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":61},{\"value\":53},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#420#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"1094\",\"windowid\":\"16100\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',0),(29,0,1636,'SCREEN_MESSAGEBOX2BUTTONS',95,'{\"objects\":[{\"id\":\"25332\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":95},{\"value\":0},{\"value\":0},{\"value\":31},{\"value\":26},{\"value\":\"#282#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"24600\",\"windowid\":\"25332\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":19},{\"value\":20},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#283#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3129\",\"windowid\":\"25332\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":25},{\"value\":20},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#284#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9757\",\"windowid\":\"25332\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":1},{\"value\":29},{\"value\":17},{\"value\":\"#285#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',0),(30,0,1809,'SCREEN_CONFIG_CUSTOMERGROUPS',109,'{\"objects\":[{\"id\":\"13694\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":109},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#422#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"32597\",\"windowid\":\"13694\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"5617\",\"windowid\":\"13694\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20137\",\"windowid\":\"13694\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#423#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25613\",\"windowid\":\"13694\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#424#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1449\",\"windowid\":\"13694\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":3},{\"value\":\"#425#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23086\",\"windowid\":\"13694\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21637\",\"windowid\":\"13694\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20986\",\"windowid\":\"13694\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22430\",\"windowid\":\"13694\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16987\",\"windowid\":\"13694\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":40},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#427#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28179\",\"windowid\":\"13694\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":40},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#428#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19024\",\"windowid\":\"13694\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":40},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#429#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28129\",\"windowid\":\"13694\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"5895\",\"windowid\":\"13694\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":40},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#426#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"27128\",\"windowid\":\"13694\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1096#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"10283\",\"windowid\":\"13694\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":13},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"8683\",\"windowid\":\"13694\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":13},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#1095#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',0),(31,0,1648,'SCREEN_CONFIG_LANGUAGES',113,'{\"objects\":[{\"id\":\"7979\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":113},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#430#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"18218\",\"windowid\":\"7979\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"9554\",\"windowid\":\"7979\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2912\",\"windowid\":\"7979\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":3},{\"value\":\"#431#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3802\",\"windowid\":\"7979\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#432#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32240\",\"windowid\":\"7979\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#433#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13519\",\"windowid\":\"7979\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29116\",\"windowid\":\"7979\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3213\",\"windowid\":\"7979\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9406\",\"windowid\":\"7979\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18921\",\"windowid\":\"7979\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',0),(33,0,1651,'SCREEN_CONFIG_TABLE_NAMES',116,'{\"objects\":[{\"id\":\"14733\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":116},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#446#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"5034\",\"windowid\":\"14733\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"21944\",\"windowid\":\"14733\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15888\",\"windowid\":\"14733\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#663#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23149\",\"windowid\":\"14733\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#664#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"8789\",\"windowid\":\"14733\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23567\",\"windowid\":\"14733\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"316\",\"windowid\":\"14733\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18072\",\"windowid\":\"14733\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5135\",\"windowid\":\"14733\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',0),(34,0,1650,'SCREEN_CONFIG_ITEMS_GROUP_SELECTION',115,'{\"objects\":[{\"id\":\"4660\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":115},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#461#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"8000\",\"windowid\":\"4660\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"8772\",\"windowid\":\"4660\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15025\",\"windowid\":\"4660\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#448#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27949\",\"windowid\":\"4660\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#449#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"486\",\"windowid\":\"4660\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8421\",\"windowid\":\"4660\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18265\",\"windowid\":\"4660\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14550\",\"windowid\":\"4660\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10306\",\"windowid\":\"4660\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":3},{\"value\":\"#447#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30471\",\"windowid\":\"4660\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',0),(35,0,1647,'SCREEN_CONFIG_COMISSIONGROUPS',112,'{\"objects\":[{\"id\":\"27235\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":112},{\"value\":0},{\"value\":14},{\"value\":53},{\"value\":39},{\"value\":\"#452#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"27133\",\"windowid\":\"27235\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"623\",\"windowid\":\"27235\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"10823\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":3},{\"value\":\"#453#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31334\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#454#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"8576\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#455#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23171\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":40},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#456#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1658\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#457#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6083\",\"windowid\":\"27235\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5583\",\"windowid\":\"27235\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29094\",\"windowid\":\"27235\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22818\",\"windowid\":\"27235\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31452\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":40},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#458#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29075\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":40},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#459#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3183\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":40},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"#460#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18118\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',0),(38,0,1653,'SCREEN_CONFIG_SALESMANLEVELS',118,'{\"objects\":[{\"id\":\"16864\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":118},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#499#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"26458\",\"windowid\":\"16864\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"14843\",\"windowid\":\"16864\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"17241\",\"windowid\":\"16864\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#500#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1068\",\"windowid\":\"16864\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#501#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18647\",\"windowid\":\"16864\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19355\",\"windowid\":\"16864\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24177\",\"windowid\":\"16864\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":26},{\"value\":8},{\"value\":26},{\"value\":24},{\"value\":[{\"v\":26}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"27706\",\"windowid\":\"16864\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',0),(39,0,1654,'SCREEN_CONFIG_EXCLUSIONS',119,'{\"objects\":[{\"id\":\"26868\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":119},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#502#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"21947\",\"windowid\":\"26868\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"9974\",\"windowid\":\"26868\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27461\",\"windowid\":\"26868\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#503#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14920\",\"windowid\":\"26868\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#504#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28064\",\"windowid\":\"26868\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21984\",\"windowid\":\"26868\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11253\",\"windowid\":\"26868\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31788\",\"windowid\":\"26868\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22353\",\"windowid\":\"26868\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"22770\",\"windowid\":\"26868\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":13},{\"value\":14},{\"value\":13},{\"value\":24},{\"value\":[{\"v\":13}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"30609\",\"windowid\":\"26868\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":13},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#957#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23328\",\"windowid\":\"26868\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":13},{\"value\":14},{\"value\":13},{\"value\":24},{\"value\":[{\"v\":13}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":1},{\"value\":1}]},{\"id\":\"13409\",\"windowid\":\"26868\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":13},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#807#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"5696\",\"windowid\":\"26868\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":27},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#808#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"31600\",\"windowid\":\"26868\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":205},{\"value\":27},{\"value\":14},{\"value\":25},{\"value\":24},{\"value\":[{\"v\":25}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":1},{\"value\":1}]}]}','0',0),(53,0,1658,'SCREEN_CASHIER_OPEN',124,'{\"objects\":[{\"id\":\"22150\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":124},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#929#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"8023\",\"windowid\":\"22150\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"11306\",\"windowid\":\"22150\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":6},{\"value\":32},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#930#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27277\",\"windowid\":\"22150\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":1},{\"value\":8},{\"value\":17},{\"value\":20},{\"value\":[{\"v\":17}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28865\",\"windowid\":\"22150\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2617\",\"windowid\":\"22150\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":6},{\"value\":29},{\"value\":12},{\"value\":3},{\"value\":\"#931#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"10498\",\"windowid\":\"22150\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#1007#\"},{\"value\":[{\"v\":17}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]}]}','0',0),(54,0,1659,'SCREEN_CASHDRAWER_LOAN',125,'{\"objects\":[{\"id\":\"21035\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":125},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#537#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"26970\",\"windowid\":\"21035\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":1},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30440\",\"windowid\":\"21035\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28962\",\"windowid\":\"21035\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1334\",\"windowid\":\"21035\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":32},{\"value\":1},{\"value\":20},{\"value\":3},{\"value\":\"#538#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15968\",\"windowid\":\"21035\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":20},{\"value\":3},{\"value\":\"#539#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31139\",\"windowid\":\"21035\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":32},{\"value\":8},{\"value\":20},{\"value\":18},{\"value\":\"#540#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',0),(55,0,1660,'SCREEN_CASHDRAWER_BORROW',126,'{\"objects\":[{\"id\":\"32453\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":126},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#541#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"18698\",\"windowid\":\"32453\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":1},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8688\",\"windowid\":\"32453\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25106\",\"windowid\":\"32453\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11101\",\"windowid\":\"32453\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":32},{\"value\":1},{\"value\":20},{\"value\":3},{\"value\":\"#542#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13271\",\"windowid\":\"32453\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":20},{\"value\":3},{\"value\":\"#543#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10504\",\"windowid\":\"32453\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":32},{\"value\":8},{\"value\":20},{\"value\":18},{\"value\":\"#544#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',0),(56,0,1661,'SCREEN_CASHDRAWER_BALANCESETTLEMENT',127,'{\"objects\":[{\"id\":\"10889\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":127},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#545#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7161\",\"windowid\":\"10889\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":1},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23106\",\"windowid\":\"10889\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":49},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19021\",\"windowid\":\"10889\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":44},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4459\",\"windowid\":\"10889\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":32},{\"value\":1},{\"value\":20},{\"value\":3},{\"value\":\"#546#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28288\",\"windowid\":\"10889\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":20},{\"value\":3},{\"value\":\"#547#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5989\",\"windowid\":\"10889\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":32},{\"value\":8},{\"value\":20},{\"value\":18},{\"value\":\"#548#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',0),(57,0,1662,'SCREEN_CASHDRAWER_RETURN',128,'{\"objects\":[{\"id\":\"5629\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":128},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#549#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"16717\",\"windowid\":\"5629\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":1},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20804\",\"windowid\":\"5629\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":49},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5655\",\"windowid\":\"5629\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":44},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10789\",\"windowid\":\"5629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":32},{\"value\":1},{\"value\":20},{\"value\":3},{\"value\":\"#550#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17496\",\"windowid\":\"5629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":20},{\"value\":21},{\"value\":\"#551#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',0),(58,0,1663,'SCREEN_CASHDRAWER_BLEED',129,'{\"objects\":[{\"id\":\"14554\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":129},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#552#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"32622\",\"windowid\":\"14554\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":1},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14100\",\"windowid\":\"14554\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":49},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18159\",\"windowid\":\"14554\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":44},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10282\",\"windowid\":\"14554\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":32},{\"value\":1},{\"value\":20},{\"value\":3},{\"value\":\"#553#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29315\",\"windowid\":\"14554\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":20},{\"value\":21},{\"value\":\"#554#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',0),(59,0,1664,'SCREEN_CASHDRAWER_PURCHASES',130,'{\"objects\":[{\"id\":\"10255\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":130},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#555#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"28050\",\"windowid\":\"10255\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":1},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16066\",\"windowid\":\"10255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10613\",\"windowid\":\"10255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17478\",\"windowid\":\"10255\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":32},{\"value\":1},{\"value\":20},{\"value\":3},{\"value\":\"#556#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16899\",\"windowid\":\"10255\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":20},{\"value\":21},{\"value\":\"#557#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',0),(61,0,1669,'SCREEN_TABLE_RETURN',135,'{\"objects\":[{\"id\":\"20233\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":135},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#570#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"14334\",\"windowid\":\"20233\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":5},{\"value\":14},{\"value\":31},{\"value\":[{\"v\":2},{\"v\":9},{\"v\":4}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29841\",\"windowid\":\"20233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":38},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20342\",\"windowid\":\"20233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":42},{\"value\":38},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26655\",\"windowid\":\"20233\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":15},{\"value\":5},{\"value\":14},{\"value\":31},{\"value\":[{\"v\":2},{\"v\":9},{\"v\":4}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',0),(62,0,1793,'SCREEN_TABLE_DISCOUNTS',136,'{\"objects\":[{\"id\":\"23809\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":136},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#571#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"553\",\"windowid\":\"23809\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":14},{\"value\":0},{\"value\":39},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"32598\",\"windowid\":\"23809\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":14},{\"value\":28},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"8916\",\"windowid\":\"23809\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":15},{\"value\":4},{\"value\":14},{\"value\":3},{\"value\":\"#898#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1144\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25502\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16552\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":19},{\"value\":0},{\"value\":39},{\"value\":14},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#899#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26124\",\"windowid\":\"23809\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":15},{\"value\":20},{\"value\":14},{\"value\":3},{\"value\":\"#900#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31883\",\"windowid\":\"23809\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":20},{\"value\":8},{\"value\":4},{\"value\":3},{\"value\":\"#901#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12408\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":15},{\"value\":8},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#902#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19487\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":24},{\"value\":8},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#903#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14803\",\"windowid\":\"23809\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":20},{\"value\":12},{\"value\":4},{\"value\":3},{\"value\":\"#574#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14829\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":15},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#904#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31857\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":24},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#905#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20768\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":24},{\"value\":31},{\"value\":12},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#906#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4174\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":25},{\"value\":34},{\"value\":12},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#907#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9535\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":26},{\"value\":37},{\"value\":12},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#908#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4208\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":27},{\"value\":40},{\"value\":12},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#909#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11393\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":28},{\"value\":43},{\"value\":12},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#910#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27723\",\"windowid\":\"23809\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":25},{\"value\":57},{\"value\":4},{\"value\":3},{\"value\":\"#911#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"10792\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":20},{\"value\":57},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#912#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3411\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":29},{\"value\":57},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#913#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4158\",\"windowid\":\"23809\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":20},{\"value\":23},{\"value\":4},{\"value\":3},{\"value\":\"#914#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14885\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":22},{\"value\":15},{\"value\":23},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#915#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15527\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":23},{\"value\":24},{\"value\":23},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#916#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11244\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":29},{\"value\":31},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#917#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21358\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":30},{\"value\":34},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#918#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12264\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":31},{\"value\":37},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#919#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18600\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":32},{\"value\":40},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#920#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15945\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":33},{\"value\":43},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#921#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32373\",\"windowid\":\"23809\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":0},{\"value\":0},{\"value\":14},{\"value\":3},{\"value\":\"#922#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"30902\",\"windowid\":\"23809\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":0},{\"value\":33},{\"value\":14},{\"value\":3},{\"value\":\"#923#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16342\",\"windowid\":\"23809\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":0},{\"value\":36},{\"value\":14},{\"value\":3},{\"value\":\"#924#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22073\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":46},{\"value\":12},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1079#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26490\",\"windowid\":\"23809\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":46},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1080#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',0),(63,0,1671,'SCREEN_TABLE_CHECK_SPLIT',137,'{\"objects\":[{\"id\":\"15245\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":137},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#572#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"848\",\"windowid\":\"15245\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":8},{\"value\":14},{\"value\":28},{\"value\":[{\"v\":2},{\"v\":9},{\"v\":4}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3136\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":37},{\"value\":38},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5814\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":31},{\"value\":38},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30132\",\"windowid\":\"15245\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":1},{\"value\":14},{\"value\":3},{\"value\":\"#585#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21261\",\"windowid\":\"15245\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":0},{\"value\":4},{\"value\":14},{\"value\":3},{\"value\":\"#586#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11189\",\"windowid\":\"15245\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":5},{\"value\":3},{\"value\":\"#587#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28819\",\"windowid\":\"15245\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":21},{\"value\":1},{\"value\":21},{\"value\":6},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4776\",\"windowid\":\"15245\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":21},{\"value\":8},{\"value\":21},{\"value\":21},{\"value\":[{\"v\":2},{\"v\":9},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"716\",\"windowid\":\"15245\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":28},{\"value\":33},{\"value\":14},{\"value\":3},{\"value\":\"#588#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30185\",\"windowid\":\"15245\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":28},{\"value\":30},{\"value\":14},{\"value\":3},{\"value\":\"#589#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15844\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":15},{\"value\":8},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32302\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":15},{\"value\":13},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16395\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":15},{\"value\":18},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20466\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":15},{\"value\":23},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18104\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":39},{\"value\":14},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#594#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14890\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":0},{\"value\":36},{\"value\":14},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#595#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',0),(69,0,1677,'',143,'{\"objects\":[{\"id\":\"15999\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":143},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#262#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"13709\",\"windowid\":\"15999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":13},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31264\",\"windowid\":\"15999\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":18},{\"value\":39},{\"value\":35},{\"value\":4},{\"value\":8},{\"value\":-2},{\"value\":-1},{\"value\":-1}]}]}','0',0),(70,0,1678,'',144,'{\"objects\":[{\"id\":\"24034\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":144},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#843#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"21015\",\"windowid\":\"24034\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":43},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"Dados Utilizador|Escolha a licenca a activar\"}]},{\"id\":\"15159\",\"windowid\":\"24034\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#844#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"525\",\"windowid\":\"24034\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#845#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"27802\",\"windowid\":\"24034\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":27},{\"value\":9},{\"value\":25},{\"value\":20},{\"value\":[{\"v\":25}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":1}]},{\"id\":\"24247\",\"windowid\":\"24034\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":15},{\"value\":9},{\"value\":16},{\"value\":3},{\"value\":\"#846#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26182\",\"windowid\":\"24034\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":32},{\"value\":9},{\"value\":16},{\"value\":3},{\"value\":\"#849#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7252\",\"windowid\":\"24034\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":15},{\"value\":13},{\"value\":33},{\"value\":3},{\"value\":\"#850#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"8361\",\"windowid\":\"24034\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":47},{\"value\":38},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#847#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"14881\",\"windowid\":\"24034\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":42},{\"value\":38},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#848#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]}]}','0',0),(73,0,1624,'SCREEN_TABLE_DISCOUNTS',136,'{\n	\"objects\" : [\n		{\n			\"id\" : \"8428\",\n			\"type\" : \"com.sage.components.window.Window\",\n			\"arguments\" : [\n				{\n					\"value\" : 136\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 65\n				},\n				{\n					\"value\" : 45\n				},\n				{\n					\"value\" : \"#571#\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : \"[[1]]\"\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"4559\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.panels.Panel\",\n			\"arguments\" : [\n				{\n					\"value\" : 301\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 51\n				},\n				{\n					\"value\" : 39\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : \"\"\n				}\n			]\n		},\n		{\n			\"id\" : \"31452\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.list.ListBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 201\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : [\n						{\n							\"v\" : 2\n						},\n						{\n							\"v\" : 7\n						},\n						{\n							\"v\" : 3\n						}\n					]\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"15044\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 99\n				},\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#898#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"16208\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : -2\n				},\n				{\n					\"value\" : 60\n				},\n				{\n					\"value\" : 39\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#297#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"1168\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 55\n				},\n				{\n					\"value\" : 39\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#298#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"7447\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 19\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 39\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#899#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"14304\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 99\n				},\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#900#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"8919\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 2\n				},\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 8\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#901#\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"13996\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 8\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#902#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"10478\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 8\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#903#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"1300\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 6\n				},\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#574#\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"25423\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#904#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"3658\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 6\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#905#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"9025\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 31\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#906#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"11730\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 8\n				},\n				{\n					\"value\" : 34\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#907#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"20529\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 37\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#908#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"1934\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 21\n				},\n				{\n					\"value\" : 40\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#909#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"6132\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 22\n				},\n				{\n					\"value\" : 43\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#910#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"19836\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 9\n				},\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#911#\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"6695\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#912#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"18446\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 21\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#913#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"12181\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 10\n				},\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#914#\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"24186\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 22\n				},\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#915#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"13771\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 23\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#916#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"1670\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 11\n				},\n				{\n					\"value\" : 31\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#917#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"18495\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 34\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#918#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"32651\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 13\n				},\n				{\n					\"value\" : 37\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#919#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"23474\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 40\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#920#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"6860\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 43\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#921#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"5566\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 16\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#922#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 6\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"9048\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 17\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 33\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#923#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 6\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"18857\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 18\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 36\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#924#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 6\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"18950\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 56\n				},\n				{\n					\"value\" : 65\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#344#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"3315\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 65\n				},\n				{\n					\"value\" : 56\n				},\n				{\n					\"value\" : 65\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#344#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		}\n	]\n}','5',0),(81,0,1696,'SCREEN_TABLE_DISCOUNTS',136,'{\n	\"objects\" : [\n		{\n			\"id\" : \"8428\",\n			\"type\" : \"com.sage.components.window.Window\",\n			\"arguments\" : [\n				{\n					\"value\" : 136\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 65\n				},\n				{\n					\"value\" : 45\n				},\n				{\n					\"value\" : \"#571#\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : \"[[1]]\"\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"4559\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.panels.Panel\",\n			\"arguments\" : [\n				{\n					\"value\" : 301\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 51\n				},\n				{\n					\"value\" : 39\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : \"\"\n				}\n			]\n		},\n		{\n			\"id\" : \"31452\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.list.ListBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 201\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : [\n						{\n							\"v\" : 2\n						},\n						{\n							\"v\" : 7\n						},\n						{\n							\"v\" : 3\n						}\n					]\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"15044\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 99\n				},\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#898#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"16208\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : -2\n				},\n				{\n					\"value\" : 60\n				},\n				{\n					\"value\" : 39\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#297#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"1168\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 55\n				},\n				{\n					\"value\" : 39\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#298#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"7447\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 19\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 39\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#899#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"14304\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 99\n				},\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#900#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"8919\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 2\n				},\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 8\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#901#\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"13996\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 8\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#902#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"10478\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 8\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#903#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"1300\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 6\n				},\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#574#\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"25423\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#904#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"3658\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 6\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#905#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"9025\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 31\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#906#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"11730\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 8\n				},\n				{\n					\"value\" : 34\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#907#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"20529\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 37\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#908#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"1934\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 21\n				},\n				{\n					\"value\" : 40\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#909#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"6132\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 22\n				},\n				{\n					\"value\" : 43\n				},\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#910#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"19836\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 9\n				},\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#911#\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"6695\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#912#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"18446\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 21\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#913#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"12181\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 10\n				},\n				{\n					\"value\" : 20\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#914#\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"24186\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 22\n				},\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#915#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"13771\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 23\n				},\n				{\n					\"value\" : 24\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 5\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#916#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"1670\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 11\n				},\n				{\n					\"value\" : 31\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#917#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"18495\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 12\n				},\n				{\n					\"value\" : 34\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#918#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"32651\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 13\n				},\n				{\n					\"value\" : 37\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#919#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"23474\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 40\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#920#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"6860\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : 15\n				},\n				{\n					\"value\" : 43\n				},\n				{\n					\"value\" : 28\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : 4\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#921#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"5566\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 16\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#922#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 6\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"9048\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 17\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 33\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#923#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 6\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"18857\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.text.TextBox\",\n			\"arguments\" : [\n				{\n					\"value\" : 18\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 36\n				},\n				{\n					\"value\" : 14\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"#924#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 6\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"12\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				}\n			]\n		},\n		{\n			\"id\" : \"18950\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : 56\n				},\n				{\n					\"value\" : 65\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#344#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		},\n		{\n			\"id\" : \"3315\",\n			\"windowid\" : \"8428\",\n			\"type\" : \"com.sage.components.buttons.Button\",\n			\"arguments\" : [\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : 65\n				},\n				{\n					\"value\" : 56\n				},\n				{\n					\"value\" : 65\n				},\n				{\n					\"value\" : 3\n				},\n				{\n					\"value\" : \"CButton\"\n				},\n				{\n					\"value\" : \"#344#\"\n				},\n				{\n					\"value\" : 0\n				},\n				{\n					\"value\" : \"0xFFFFFF\"\n				},\n				{\n					\"value\" : \"null\"\n				},\n				{\n					\"value\" : 1\n				},\n				{\n					\"value\" : -1\n				},\n				{\n					\"value\" : -1\n				}\n			]\n		}\n	]\n}','4',0),(83,0,1720,'',149,'{\"objects\":[{\"id\":\"13124\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":149},{\"value\":4},{\"value\":5},{\"value\":34},{\"value\":20},{\"value\":\"#986#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"4270\",\"windowid\":\"13124\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":28},{\"value\":15},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11775\",\"windowid\":\"13124\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":23},{\"value\":15},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24013\",\"windowid\":\"13124\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":3},{\"value\":6},{\"value\":26},{\"value\":3},{\"value\":\"#987#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32206\",\"windowid\":\"13124\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":3},{\"value\":3},{\"value\":26},{\"value\":3},{\"value\":\"#988#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31614\",\"windowid\":\"13124\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":3},{\"value\":9},{\"value\":26},{\"value\":3},{\"value\":\"#989#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',0),(86,0,1756,'SCREEN_TABLE_NAMES',151,'{\"objects\":[{\"id\":\"29398\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":151},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#446#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"2285\",\"windowid\":\"29398\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#1004#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32117\",\"windowid\":\"29398\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28577\",\"windowid\":\"29398\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3399\",\"windowid\":\"29398\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28039\",\"windowid\":\"29398\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":1},{\"value\":12},{\"value\":3},{\"value\":\"#1005#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]}]}','0',0),(92,0,1779,'SCREEN_MOVEMENTS',154,'{\"objects\":[{\"id\":\"6447\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":154},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1046#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"31248\",\"windowid\":\"6447\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":43},{\"value\":3},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"13740\",\"windowid\":\"6447\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15247\",\"windowid\":\"6447\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17780\",\"windowid\":\"6447\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":11},{\"value\":20},{\"value\":16},{\"value\":\"#1047#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17416\",\"windowid\":\"6447\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":8},{\"value\":20},{\"value\":3},{\"value\":\"#1048#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26292\",\"windowid\":\"6447\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":5},{\"value\":20},{\"value\":3},{\"value\":\"#1049#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"2537\",\"windowid\":\"6447\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":27},{\"value\":20},{\"value\":3},{\"value\":\"#1050#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"2889\",\"windowid\":\"6447\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":27},{\"value\":20},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":2},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"24609\",\"windowid\":\"6447\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":27},{\"value\":20},{\"value\":3},{\"value\":\"#1051#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]}]}','0',0),(100,0,1823,'SCREEN_INPUTBOX_TEXT',160,'{\"objects\":[{\"id\":\"6146\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":160},{\"value\":4},{\"value\":5},{\"value\":23},{\"value\":19},{\"value\":\"#58#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"5840\",\"windowid\":\"6146\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-10},{\"value\":17},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1529\",\"windowid\":\"6146\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-9},{\"value\":12},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16502\",\"windowid\":\"6146\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":5},{\"value\":21},{\"value\":3},{\"value\":\"#58#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',0),(102,0,1825,'SCREEN_CONFIG_FAMILIES',102,'\n{\n    \"objects\": [{\n        \"id\": \"23823\",\n        \"type\": \"com.sage.components.window.Window\",\n        \"arguments\": [{\n            \"value\": 102\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 53\n        }, {\n            \"value\": 45\n        }, {\n            \"value\": \"#462#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"[[1]]\"\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"28215\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.panels.Panel\",\n        \"arguments\": [{\n            \"value\": 301\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 41\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"\"\n        }]\n    }, {\n        \"id\": \"10772\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.list.ListBox\",\n        \"arguments\": [{\n            \"value\": 201\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 35\n        }, {\n            \"value\": [{\n                \"v\": 12\n            }]\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"31535\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 3\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 7\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#463#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"16826\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 2\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#464#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"10422\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 1\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#465#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"19296\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 19\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 10\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"CCheckBox\"\n        }, {\n            \"value\": \"#468#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"1589\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": -2\n        }, {\n            \"value\": 48\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 5\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#297#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"12330\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": -1\n        }, {\n            \"value\": 43\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 5\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#298#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"6687\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 25\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#599#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 2\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"32563\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": -6\n        }, {\n            \"value\": 8\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#300#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 2\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"6090\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 8\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#471#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"9342\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 9\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 22\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#472#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"12588\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 10\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 25\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#473#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"4152\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 11\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 28\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#474#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"19329\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 12\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 31\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#475#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"6475\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 14\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 7\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#476#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"22054\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 16\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#478#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"32090\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 17\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 16\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#479#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 2\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"15652\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 18\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#480#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 2\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"12680\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 21\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 16\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#481#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"32067\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 20\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"CCheckBox\"\n        }, {\n            \"value\": \"#482#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"4814\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 26\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#600#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 2\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"19878\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 4778\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#344#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"14759\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.list.DropBox\",\n        \"arguments\": [{\n            \"value\": 15\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 10\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#477#\"\n        }, {\n            \"value\": [{\n                \"v\": 12\n            }]\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"CButton\"\n        }]\n    }, {\n        \"id\": \"13107\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.list.DropBox\",\n        \"arguments\": [{\n            \"value\": 6\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#469#\"\n        }, {\n            \"value\": [{\n                \"v\": 12\n            }]\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"CButton\"\n        }]\n    }, {\n        \"id\": \"5203\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.list.DropBox\",\n        \"arguments\": [{\n            \"value\": 7\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 16\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#470#\"\n        }, {\n            \"value\": [{\n                \"v\": 12\n            }]\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"CButton\"\n        }]\n    }, {\n        \"id\": \"13401\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.list.DropBox\",\n        \"arguments\": [{\n            \"value\": 5\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 10\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#467#\"\n        }, {\n            \"value\": [{\n                \"v\": 12\n            }]\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"CButton\"\n        }]\n    }, {\n        \"id\": \"22518\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.list.DropBox\",\n        \"arguments\": [{\n            \"value\": 29\n        }, {\n            \"value\": 27\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#949#\"\n        }, {\n            \"value\": [{\n                \"v\": 12\n            }]\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"CButton\"\n        }]\n    }, {\n        \"id\": \"23736\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 28\n        }, {\n            \"value\": 46\n        }, {\n            \"value\": 35\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#947#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 2\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }]\n    }, {\n        \"id\": \"12385\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 27\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 35\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#948#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 2\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }]\n    }, {\n        \"id\": \"25732\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.list.ListBox\",\n        \"arguments\": [{\n            \"value\": 202\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 15\n        }, {\n            \"value\": [{\n                \"v\": 13\n            }]\n        }, {\n            \"value\": \"CCheckBox\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }]\n    }, {\n        \"id\": \"31728\",\n        \"windowid\": \"23823\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 51\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 31\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1115#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }]\n}\n','0',0),(103,0,1828,'SCREEN_PROMPT_CUSTOMER',161,'{\"objects\":[{\"id\":\"26812\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":161},{\"value\":4},{\"value\":5},{\"value\":23},{\"value\":19},{\"value\":\"#1116#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"14898\",\"windowid\":\"26812\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":1},{\"value\":2},{\"value\":21},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":21}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"16990\",\"windowid\":\"26812\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":17},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25052\",\"windowid\":\"26812\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":12},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4687\",\"windowid\":\"26812\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":2},{\"value\":21},{\"value\":3},{\"value\":\"#367#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',0),(112,0,1859,'SCREEN_CONFIG_PROFILES',120,'{\"objects\":[{\"id\":\"31582\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":120},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#711#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"10940\",\"windowid\":\"31582\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"21526\",\"windowid\":\"31582\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27865\",\"windowid\":\"31582\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#712#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29325\",\"windowid\":\"31582\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#713#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1577\",\"windowid\":\"31582\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24350\",\"windowid\":\"31582\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21268\",\"windowid\":\"31582\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3105\",\"windowid\":\"31582\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11742\",\"windowid\":\"31582\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":40},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#674#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32495\",\"windowid\":\"31582\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":40},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#675#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21009\",\"windowid\":\"31582\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":40},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#677#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2585\",\"windowid\":\"31582\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#680#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"107\",\"windowid\":\"31582\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#681#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"27177\",\"windowid\":\"31582\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":10},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#682#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"3842\",\"windowid\":\"31582\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#683#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"25004\",\"windowid\":\"31582\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":13},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#684#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"12219\",\"windowid\":\"31582\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":13},{\"value\":13},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#685#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"5722\",\"windowid\":\"31582\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":14},{\"value\":13},{\"value\":25},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#686#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"18247\",\"windowid\":\"31582\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"16525\",\"windowid\":\"31582\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#676#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"16710\",\"windowid\":\"31582\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":16},{\"value\":40},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#812#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"1898\",\"windowid\":\"31582\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":40},{\"value\":23},{\"value\":12},{\"value\":15},{\"value\":[{\"v\":12}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"29248\",\"windowid\":\"31582\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":26},{\"value\":23},{\"value\":13},{\"value\":15},{\"value\":[{\"v\":13}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]}]}','0',0),(122,0,1882,'SCREEN_CONFIG_ZONES',107,'{\"objects\":[{\"id\":\"21450\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":107},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#393#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"8012\",\"windowid\":\"21450\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"25733\",\"windowid\":\"21450\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14924\",\"windowid\":\"21450\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":3},{\"value\":\"#394#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12945\",\"windowid\":\"21450\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#395#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24353\",\"windowid\":\"21450\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":40},{\"value\":11},{\"value\":12},{\"value\":3},{\"value\":\"#396#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21187\",\"windowid\":\"21450\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8091\",\"windowid\":\"21450\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18125\",\"windowid\":\"21450\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22839\",\"windowid\":\"21450\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13927\",\"windowid\":\"21450\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#400#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7228\",\"windowid\":\"21450\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":40},{\"value\":25},{\"value\":12},{\"value\":3},{\"value\":\"#405#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"641\",\"windowid\":\"21450\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"6288\",\"windowid\":\"21450\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":15},{\"value\":12},{\"value\":3},{\"value\":\"#397#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"2878\",\"windowid\":\"21450\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":40},{\"value\":18},{\"value\":12},{\"value\":3},{\"value\":\"#398#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"9817\",\"windowid\":\"21450\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":17},{\"value\":40},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"1669\",\"windowid\":\"21450\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":40},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"#404#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28855\",\"windowid\":\"21450\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":13},{\"value\":11},{\"value\":26},{\"value\":27},{\"value\":[{\"v\":26}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]}]}','0',0),(124,0,1883,'SCREEN_PLUGINS',166,'{\"objects\":[{\"id\":\"16561\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":166},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1185#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"17702\",\"windowid\":\"16561\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21246\",\"windowid\":\"16561\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":21},{\"value\":34},{\"value\":31},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1173#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7612\",\"windowid\":\"16561\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":21},{\"value\":3},{\"value\":15},{\"value\":30},{\"value\":\"#1174#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20192\",\"windowid\":\"16561\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":1},{\"value\":3},{\"value\":19},{\"value\":35},{\"value\":[{\"v\":19}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31944\",\"windowid\":\"16561\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":37},{\"value\":3},{\"value\":15},{\"value\":3},{\"value\":\"#1175#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3780\",\"windowid\":\"16561\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":37},{\"value\":6},{\"value\":15},{\"value\":3},{\"value\":\"#1176#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9895\",\"windowid\":\"16561\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":37},{\"value\":9},{\"value\":15},{\"value\":3},{\"value\":\"#1177#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21165\",\"windowid\":\"16561\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":37},{\"value\":12},{\"value\":15},{\"value\":3},{\"value\":\"#1178#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7164\",\"windowid\":\"16561\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":37},{\"value\":15},{\"value\":15},{\"value\":3},{\"value\":\"#1179#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7833\",\"windowid\":\"16561\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":37},{\"value\":18},{\"value\":15},{\"value\":3},{\"value\":\"#1180#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26389\",\"windowid\":\"16561\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":37},{\"value\":21},{\"value\":15},{\"value\":3},{\"value\":\"#1181#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6365\",\"windowid\":\"16561\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":37},{\"value\":24},{\"value\":15},{\"value\":3},{\"value\":\"#1182#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11584\",\"windowid\":\"16561\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":37},{\"value\":27},{\"value\":15},{\"value\":3},{\"value\":\"#1183#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20626\",\"windowid\":\"16561\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":37},{\"value\":30},{\"value\":15},{\"value\":3},{\"value\":\"#1184#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',0),(131,0,1890,'SCREEN_CONFIG_PRINTERS',140,'{\"objects\":[{\"id\":\"32168\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":140},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#706#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"14319\",\"windowid\":\"32168\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"6376\",\"windowid\":\"32168\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24384\",\"windowid\":\"32168\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18011\",\"windowid\":\"32168\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16597\",\"windowid\":\"32168\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26487\",\"windowid\":\"32168\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"272\",\"windowid\":\"32168\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":13},{\"value\":8},{\"value\":12},{\"value\":15},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"23734\",\"windowid\":\"32168\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":26},{\"value\":8},{\"value\":12},{\"value\":15},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"7586\",\"windowid\":\"32168\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":39},{\"value\":8},{\"value\":13},{\"value\":30},{\"value\":[{\"v\":13}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"14268\",\"windowid\":\"32168\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#709#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2435\",\"windowid\":\"32168\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#710#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20442\",\"windowid\":\"32168\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"13822\",\"windowid\":\"32168\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":24},{\"value\":12},{\"value\":3},{\"value\":\"#783#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"21385\",\"windowid\":\"32168\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":26},{\"value\":24},{\"value\":12},{\"value\":3},{\"value\":\"#784#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"22706\",\"windowid\":\"32168\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":29},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1222#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]}]}','0',0),(135,0,1902,'SCREEN_LINK_ITEM_SELECTION',170,'{\"objects\":[{\"id\":\"15099\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":170},{\"value\":2},{\"value\":5},{\"value\":50},{\"value\":42},{\"value\":\"#1228#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"3178\",\"windowid\":\"15099\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":301},{\"value\":1},{\"value\":2},{\"value\":48},{\"value\":33},{\"value\":6},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26634\",\"windowid\":\"15099\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":44},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',0),(148,0,1996,'SCREEN_PROMPT_MANUAL_DOCUMENT',171,'{\"objects\":[{\"id\":\"13957\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":171},{\"value\":4},{\"value\":5},{\"value\":23},{\"value\":19},{\"value\":\"#1264#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"16843\",\"windowid\":\"13957\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":1},{\"value\":2},{\"value\":21},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":21}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"30474\",\"windowid\":\"13957\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":17},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18055\",\"windowid\":\"13957\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":2},{\"value\":21},{\"value\":3},{\"value\":\"#1265#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27926\",\"windowid\":\"13957\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":6},{\"value\":21},{\"value\":3},{\"value\":\"#1266#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',0),(149,0,1997,'SCREEN_CONFIG_LICENCE',153,'{\"objects\":[{\"id\":\"12236\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":153},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#843#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"10689\",\"windowid\":\"12236\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17589\",\"windowid\":\"12236\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":2},{\"value\":3},{\"value\":34},{\"value\":27},{\"value\":\"#1021#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"2572\",\"windowid\":\"12236\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":2},{\"value\":30},{\"value\":34},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1020#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9568\",\"windowid\":\"12236\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":37},{\"value\":3},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1188#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18316\",\"windowid\":\"12236\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":37},{\"value\":8},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1189#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',0),(156,0,2030,'SCREEN_CONFIG_DOCUMENTPARTS',142,'{\"objects\":[{\"id\":\"228\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":142},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#749#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"25976\",\"windowid\":\"228\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"6486\",\"windowid\":\"228\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13977\",\"windowid\":\"228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#750#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23339\",\"windowid\":\"228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#751#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"17305\",\"windowid\":\"228\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26192\",\"windowid\":\"228\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3800\",\"windowid\":\"228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"13611\",\"windowid\":\"228\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11420\",\"windowid\":\"228\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26749\",\"windowid\":\"228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":31},{\"value\":\"#753#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"27120\",\"windowid\":\"228\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#752#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"13122\",\"windowid\":\"228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":28},{\"value\":\"#973#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]}]}','0',0),(161,0,2041,'SCREEN_ITEM_MENU_CONFIG',158,'{\"objects\":[{\"id\":\"23603\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":158},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1104#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"10635\",\"windowid\":\"23603\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":38},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"21231\",\"windowid\":\"23603\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":34},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"8429\",\"windowid\":\"23603\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7462\",\"windowid\":\"23603\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26575\",\"windowid\":\"23603\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":13},{\"value\":4},{\"value\":11},{\"value\":30},{\"value\":[{\"v\":11}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13318\",\"windowid\":\"23603\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":25},{\"value\":8},{\"value\":11},{\"value\":26},{\"value\":[{\"v\":11}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"19516\",\"windowid\":\"23603\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":41},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"#1105#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"18618\",\"windowid\":\"23603\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":36},{\"value\":16},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4307\",\"windowid\":\"23603\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":36},{\"value\":21},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6394\",\"windowid\":\"23603\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":25},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"#1107#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21408\",\"windowid\":\"23603\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":25},{\"value\":4},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1108#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3346\",\"windowid\":\"23603\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":41},{\"value\":4},{\"value\":11},{\"value\":30},{\"value\":[{\"v\":11}]},{\"value\":\"CButton\"},{\"value\":2},{\"value\":0},{\"value\":0}]},{\"id\":\"15483\",\"windowid\":\"23603\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"#1109#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4912\",\"windowid\":\"23603\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":205},{\"value\":41},{\"value\":4},{\"value\":11},{\"value\":33},{\"value\":[{\"v\":11}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"14261\",\"windowid\":\"23603\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',0),(163,0,2046,'SCREEN_PROFILES_SELECTION',148,'{\"objects\":[{\"id\":\"24453\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":148},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#952#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"256\",\"windowid\":\"24453\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"25962\",\"windowid\":\"24453\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26511\",\"windowid\":\"24453\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":11},{\"value\":12},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"29992\",\"windowid\":\"24453\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":26},{\"value\":12},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"27061\",\"windowid\":\"24453\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":11},{\"value\":8},{\"value\":15},{\"value\":4},{\"value\":\"#1103#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26546\",\"windowid\":\"24453\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":98},{\"value\":26},{\"value\":8},{\"value\":15},{\"value\":4},{\"value\":\"#1101#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',0),(165,0,2050,'SCREEN_TABLE_CANCEL_ITEMS',173,'{\"objects\":[{\"id\":\"24099\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":173},{\"value\":10},{\"value\":11},{\"value\":33},{\"value\":36},{\"value\":\"#1432#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"15927\",\"windowid\":\"24099\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":1},{\"value\":5},{\"value\":12},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"9053\",\"windowid\":\"24099\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":26},{\"value\":29},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10871\",\"windowid\":\"24099\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":20},{\"value\":29},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23929\",\"windowid\":\"24099\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":20},{\"value\":5},{\"value\":12},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26543\",\"windowid\":\"24099\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":14},{\"value\":6},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10953\",\"windowid\":\"24099\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":14},{\"value\":11},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6649\",\"windowid\":\"24099\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":14},{\"value\":16},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18914\",\"windowid\":\"24099\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":14},{\"value\":21},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3308\",\"windowid\":\"24099\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":20},{\"value\":2},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1433#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10734\",\"windowid\":\"24099\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":2},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1437#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',0),(167,0,2052,'SCREEN_CONFIG_RADIO_TERMINALS',152,'{\"objects\":[{\"id\":\"19764\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":152},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1009#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"5700\",\"windowid\":\"19764\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5070\",\"windowid\":\"19764\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":24},{\"value\":7},{\"value\":17},{\"value\":3},{\"value\":\"#1010#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30321\",\"windowid\":\"19764\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":24},{\"value\":11},{\"value\":17},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1013#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19574\",\"windowid\":\"19764\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":24},{\"value\":16},{\"value\":17},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1014#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24968\",\"windowid\":\"19764\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":4},{\"value\":7},{\"value\":19},{\"value\":25},{\"value\":[{\"v\":19}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]}]}','0',0),(169,0,2054,'SCREEN_CONFIG_CUSTOMERS',106,'{\"objects\":[{\"id\":\"696\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":106},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#365#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"4521\",\"windowid\":\"696\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"6222\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":10},{\"value\":26},{\"value\":3},{\"value\":\"#366#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"9574\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#367#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"10424\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":13},{\"value\":26},{\"value\":3},{\"value\":\"#368#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13797\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":26},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#369#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"17438\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":26},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#370#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18081\",\"windowid\":\"696\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3135\",\"windowid\":\"696\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5599\",\"windowid\":\"696\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25542\",\"windowid\":\"696\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2863\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#371#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11591\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":40},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#372#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23286\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":26},{\"value\":25},{\"value\":26},{\"value\":3},{\"value\":\"#373#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16177\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":40},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"#374#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3869\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":34},{\"value\":13},{\"value\":18},{\"value\":3},{\"value\":\"#375#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"7217\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":34},{\"value\":4},{\"value\":18},{\"value\":3},{\"value\":\"#376#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"26202\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":34},{\"value\":7},{\"value\":18},{\"value\":3},{\"value\":\"#377#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"15329\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":22},{\"value\":34},{\"value\":10},{\"value\":18},{\"value\":3},{\"value\":\"#379#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"18100\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":26},{\"value\":26},{\"value\":31},{\"value\":26},{\"value\":7},{\"value\":\"#381#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"19894\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":25},{\"value\":13},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"#382#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"9516\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":26},{\"value\":22},{\"value\":13},{\"value\":3},{\"value\":\"#383#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28806\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#384#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"5046\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":26},{\"value\":28},{\"value\":26},{\"value\":3},{\"value\":\"#385#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27424\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#386#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28641\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":13},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#387#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"5839\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":20},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#388#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"16356\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#389#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29370\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":34},{\"value\":16},{\"value\":18},{\"value\":3},{\"value\":\"#390#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"30952\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":27},{\"value\":20},{\"value\":20},{\"value\":32},{\"value\":10},{\"value\":\"#391#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"20352\",\"windowid\":\"696\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":16},{\"value\":20},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#392#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"195\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":28},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":3},{\"value\":\"#519#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15493\",\"windowid\":\"696\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"3724\",\"windowid\":\"696\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"27845\",\"windowid\":\"696\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":24},{\"value\":13},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#380#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"26784\",\"windowid\":\"696\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":23},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#378#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]}]}','0',0),(175,0,2064,'SCREEN_SESSION_CLOSE',133,'{\"objects\":[{\"id\":\"10900\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":133},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#565#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"22131\",\"windowid\":\"10900\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"26733\",\"windowid\":\"10900\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":14},{\"value\":4},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#566#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24238\",\"windowid\":\"10900\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28821\",\"windowid\":\"10900\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12624\",\"windowid\":\"10900\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',0),(176,0,2063,'SCREEN_SESSION_OPEN',132,'{\"objects\":[{\"id\":\"6734\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":132},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#563#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"5814\",\"windowid\":\"6734\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"27354\",\"windowid\":\"6734\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":14},{\"value\":11},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#564#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14663\",\"windowid\":\"6734\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14500\",\"windowid\":\"6734\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22799\",\"windowid\":\"6734\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"16635\",\"windowid\":\"6734\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":2},{\"value\":14},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#925#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"32675\",\"windowid\":\"6734\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":14},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#926#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',0),(177,0,2074,'SCREEN_TABLE_KEYBOARD',167,'{\"objects\":[{\"id\":\"1464\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":167},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1155#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"28440\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9949\",\"windowid\":\"1464\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13967\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":19},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27237\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":25},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20048\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":31},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27581\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":19},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8602\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":25},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22662\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":31},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24934\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":19},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22603\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":25},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12223\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":31},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25322\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":0},{\"value\":25},{\"value\":29},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4866\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":61},{\"value\":31},{\"value\":29},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"865\",\"windowid\":\"1464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":50},{\"value\":19},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#1167#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22529\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":19},{\"value\":36},{\"value\":17},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1168#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',0),(178,0,2073,'SCREEN_CARD_EXIT',165,'{\"objects\":[{\"id\":\"8252\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":165},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1143#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"20151\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22910\",\"windowid\":\"8252\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3383\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":19},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29136\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":25},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4327\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":31},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10352\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":19},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12567\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":25},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24654\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":31},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4691\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":19},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11194\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":25},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17875\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":31},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9864\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":0},{\"value\":25},{\"value\":29},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4503\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":61},{\"value\":31},{\"value\":29},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6737\",\"windowid\":\"8252\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":50},{\"value\":19},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#1167#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3614\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":19},{\"value\":36},{\"value\":17},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1168#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',0),(179,0,2072,'SCREEN_CARD_ACTIVATION',164,'{\"objects\":[{\"id\":\"29275\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":164},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1142#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"27222\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28588\",\"windowid\":\"29275\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12933\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":19},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24921\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":25},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24306\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":31},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14167\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":19},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11335\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":25},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15885\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":31},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13866\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":19},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2040\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":25},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23756\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":31},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21898\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":0},{\"value\":25},{\"value\":29},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17363\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":61},{\"value\":31},{\"value\":29},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29918\",\"windowid\":\"29275\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":50},{\"value\":19},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#1167#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7604\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":19},{\"value\":36},{\"value\":17},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1168#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',0),(522,0,1634,'SCREEN_CASHES',9,'{\"objects\":[{\"id\":\"13935\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":9},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#261#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"591\",\"windowid\":\"13935\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":23},{\"value\":25},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(524,0,1637,'SCREEN_MESSAGEBOX',96,'{\"objects\":[{\"id\":\"8905\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":96},{\"value\":0},{\"value\":0},{\"value\":31},{\"value\":26},{\"value\":\"#286#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7723\",\"windowid\":\"8905\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":999},{\"value\":25},{\"value\":20},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#287#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9865\",\"windowid\":\"8905\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":1},{\"value\":29},{\"value\":7},{\"value\":\"#288#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29137\",\"windowid\":\"8905\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":10},{\"value\":29},{\"value\":9},{\"value\":\"#289#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(525,0,2485,'SCREEN_CONFIG_CASHDRAWERS',110,'{\"objects\":[{\"id\":\"29495\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":110},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#416#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"192\",\"windowid\":\"29495\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"9512\",\"windowid\":\"29495\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7384\",\"windowid\":\"29495\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"#417#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25406\",\"windowid\":\"29495\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#418#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13086\",\"windowid\":\"29495\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":61},{\"value\":50},{\"value\":12},{\"value\":3},{\"value\":\"#419#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6131\",\"windowid\":\"29495\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#421#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29447\",\"windowid\":\"29495\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":61},{\"value\":53},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#420#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"28743\",\"windowid\":\"29495\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"2945\",\"windowid\":\"29495\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1430\",\"windowid\":\"29495\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26108\",\"windowid\":\"29495\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"779\",\"windowid\":\"29495\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(526,0,1636,'SCREEN_MESSAGEBOX2BUTTONS',95,'{\"objects\":[{\"id\":\"25332\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":95},{\"value\":0},{\"value\":0},{\"value\":31},{\"value\":26},{\"value\":\"#282#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"24600\",\"windowid\":\"25332\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":19},{\"value\":20},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#283#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3129\",\"windowid\":\"25332\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":25},{\"value\":20},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#284#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9757\",\"windowid\":\"25332\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":1},{\"value\":29},{\"value\":17},{\"value\":\"#285#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(527,0,2473,'SCREEN_CONFIG_CUSTOMERGROUPS',109,'{\"objects\":[{\"id\":\"24558\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":109},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#422#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"1529\",\"windowid\":\"24558\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"32485\",\"windowid\":\"24558\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28901\",\"windowid\":\"24558\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#423#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27338\",\"windowid\":\"24558\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#424#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6879\",\"windowid\":\"24558\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"#425#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18697\",\"windowid\":\"24558\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":40},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#427#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31807\",\"windowid\":\"24558\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":40},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#428#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32434\",\"windowid\":\"24558\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":40},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#429#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25479\",\"windowid\":\"24558\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"28456\",\"windowid\":\"24558\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":40},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#426#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"25045\",\"windowid\":\"24558\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1096#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"15695\",\"windowid\":\"24558\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":13},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"29643\",\"windowid\":\"24558\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":13},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#1095#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2891\",\"windowid\":\"24558\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4835\",\"windowid\":\"24558\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21765\",\"windowid\":\"24558\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31309\",\"windowid\":\"24558\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(528,0,1648,'SCREEN_CONFIG_LANGUAGES',113,'{\"objects\":[{\"id\":\"7979\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":113},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#430#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"18218\",\"windowid\":\"7979\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"9554\",\"windowid\":\"7979\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2912\",\"windowid\":\"7979\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":3},{\"value\":\"#431#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3802\",\"windowid\":\"7979\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#432#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32240\",\"windowid\":\"7979\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#433#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13519\",\"windowid\":\"7979\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29116\",\"windowid\":\"7979\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3213\",\"windowid\":\"7979\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9406\",\"windowid\":\"7979\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18921\",\"windowid\":\"7979\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',1),(530,0,1651,'SCREEN_CONFIG_TABLE_NAMES',116,'{\"objects\":[{\"id\":\"14733\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":116},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#446#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"5034\",\"windowid\":\"14733\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"21944\",\"windowid\":\"14733\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15888\",\"windowid\":\"14733\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#663#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23149\",\"windowid\":\"14733\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#664#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"8789\",\"windowid\":\"14733\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23567\",\"windowid\":\"14733\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"316\",\"windowid\":\"14733\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18072\",\"windowid\":\"14733\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5135\",\"windowid\":\"14733\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',1),(531,0,1650,'SCREEN_CONFIG_ITEMS_GROUP_SELECTION',115,'{\"objects\":[{\"id\":\"4660\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":115},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#461#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"8000\",\"windowid\":\"4660\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"8772\",\"windowid\":\"4660\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15025\",\"windowid\":\"4660\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#448#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27949\",\"windowid\":\"4660\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#449#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"486\",\"windowid\":\"4660\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8421\",\"windowid\":\"4660\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18265\",\"windowid\":\"4660\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14550\",\"windowid\":\"4660\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10306\",\"windowid\":\"4660\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":3},{\"value\":\"#447#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30471\",\"windowid\":\"4660\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',1),(532,0,1647,'SCREEN_CONFIG_COMISSIONGROUPS',112,'{\"objects\":[{\"id\":\"27235\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":112},{\"value\":0},{\"value\":14},{\"value\":53},{\"value\":39},{\"value\":\"#452#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"27133\",\"windowid\":\"27235\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"623\",\"windowid\":\"27235\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"10823\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":3},{\"value\":\"#453#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31334\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#454#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"8576\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#455#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23171\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":40},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#456#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1658\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#457#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6083\",\"windowid\":\"27235\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5583\",\"windowid\":\"27235\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29094\",\"windowid\":\"27235\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22818\",\"windowid\":\"27235\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31452\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":40},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#458#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29075\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":40},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#459#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3183\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":40},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"#460#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18118\",\"windowid\":\"27235\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',1),(533,0,2481,'SCREEN_CONFIG_SALESMANLEVELS',118,'{\"objects\":[{\"id\":\"27539\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":118},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#499#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"17192\",\"windowid\":\"27539\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"24010\",\"windowid\":\"27539\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11379\",\"windowid\":\"27539\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#500#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7360\",\"windowid\":\"27539\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#501#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20271\",\"windowid\":\"27539\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":26},{\"value\":8},{\"value\":27},{\"value\":24},{\"value\":[{\"v\":27}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"9548\",\"windowid\":\"27539\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"13413\",\"windowid\":\"27539\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1468\",\"windowid\":\"27539\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(535,0,2499,'SCREEN_CASHIER_OPEN',124,'\n{\"objects\":[{\"id\":\"16455\",\"type\":\"com.sage.components.window.Window\",\n\"arguments\":[{ \"value\" : 124 }, { \"value\" : 0 }, { \"value\" : 0 }, { \"value\" : 53 }, { \"value\" : 45 }, { \"value\" : \"Abertura Caixa\" }, { \"value\" : 1 }, { \"value\" : \"1\" }, { \"value\" : -1 }]},\n{\"id\":\"90\",\"windowid\":\"16455\",\"type\":\"com.sage.components.panels.Panel\",\n\"arguments\":[{ \"value\" : 301 }, { \"value\" : 0 }, { \"value\" : 0 }, { \"value\" : 53 }, { \"value\" : 39 }, { \"value\" : 1 }, { \"value\" : -1 }, { \"value\" : 1 }, { \"value\" : \"\" }]}\n,\n{\"id\":\"8649\",\"windowid\":\"16455\",\"type\":\"com.sage.components.buttons.Button\",\n\"arguments\":[{ \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 32 }, { \"value\" : 17 }, { \"value\" : 4 }, { \"value\" : \"CButton\" }, { \"value\" : \"Abrir Caixa\" }, { \"value\" : 0 }, { \"value\" : \"0xFFFFFF\" }, { \"value\" : \"null\" }, { \"value\" : 1 }, { \"value\" : -1 }, { \"value\" : -1 }, { \"bgtype\" : \"color\" }, { \"bgcolor\" : \"\" }, { \"bgimage\" : \"\" }, { \"bgimage\" : \"\" }]}\n,\n{\"id\":\"5270\",\"windowid\":\"16455\",\"type\":\"com.sage.components.list.ListBox\",\n\"arguments\":[{ \"value\" : 201 }, { \"value\" : 1 }, { \"value\" : 8 }, { \"value\" : 17 }, { \"value\" : 20 }, { \"value\" : [{\"v\":17}] }, { \"value\" : \"CButton\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : 0 }]}\n,\n{\"id\":\"4953\",\"windowid\":\"16455\",\"type\":\"com.sage.components.buttons.Button\",\n\"arguments\":[{ \"value\" : -2 }, { \"value\" : 47 }, { \"value\" : 39 }, { \"value\" : 6 }, { \"value\" : 4 }, { \"value\" : \"CButton\" }, { \"value\" : \"Voltar\" }, { \"value\" : 0 }, { \"value\" : \"0xFFFFFF\" }, { \"value\" : \"1094.png\" }, { \"value\" : 5 }, { \"value\" : -1 }, { \"value\" : -1 }, { \"bgtype\" : \"color\" }, { \"bgcolor\" : \"\" }, { \"bgimage\" : \"\" }, { \"bgimage\" : \"\" }]}\n,\n{\"id\":\"9181\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 3 }, { \"value\" : 1 }, { \"value\" : 29 }, { \"value\" : 17 }, { \"value\" : 3 }, { \"value\" : \"Fundo Maneio\" }, { \"value\" : 1 }, { \"value\" : 6 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : 0 }]}\n,\n{\"id\":\"2683\",\"windowid\":\"16455\",\"type\":\"com.sage.components.list.DropBox\",\n\"arguments\":[{ \"value\" : 4 }, { \"value\" : 1 }, { \"value\" : 4 }, { \"value\" : 17 }, { \"value\" : 3 }, { \"value\" : \"Terminal\" }, { \"value\" : [{\"v\":17}] }, { \"value\" : 6 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : 1 }, { \"value\" : \"CButton\" }]}\n,\n{\"id\":\"2008\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 9 }, { \"value\" : 26 }, { \"value\" : 4 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"1 cent\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"671\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 10 }, { \"value\" : 34 }, { \"value\" : 8 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"20 cent\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"9500\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 11 }, { \"value\" : 34 }, { \"value\" : 4 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"2 cent\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"9202\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 12 }, { \"value\" : 42 }, { \"value\" : 8 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"50 cent\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"5455\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 13 }, { \"value\" : 42 }, { \"value\" : 4 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"5 cent\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"220\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 14 }, { \"value\" : 26 }, { \"value\" : 12 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"1 Eur\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"6127\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 15 }, { \"value\" : 26 }, { \"value\" : 8 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"10 cent\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"5929\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 16 }, { \"value\" : 34 }, { \"value\" : 12 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"2 Eur\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"9109\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 18 }, { \"value\" : 26 }, { \"value\" : 17 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"5 Eur\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"5753\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 19 }, { \"value\" : 34 }, { \"value\" : 21 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"100 Eur\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"9725\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 20 }, { \"value\" : 34 }, { \"value\" : 17 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"10 Eur\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"1746\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 21 }, { \"value\" : 42 }, { \"value\" : 21 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"200 Eur\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"8474\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 22 }, { \"value\" : 26 }, { \"value\" : 21 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"20 Eur\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"2397\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 23 }, { \"value\" : 26 }, { \"value\" : 25 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"500 Eur\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,\n{\"id\":\"4374\",\"windowid\":\"16455\",\"type\":\"com.sage.components.text.TextBox\",\n\"arguments\":[{ \"value\" : 24 }, { \"value\" : 42 }, { \"value\" : 17 }, { \"value\" : 7 }, { \"value\" : 3 }, { \"value\" : \"50 Eur\" }, { \"value\" : 1 }, { \"value\" : 1 }, { \"value\" : 0 }, { \"value\" : \"12\" }, { \"value\" : 0 }, { \"value\" : -1 }, { \"value\" : -1 }]}\n,{\"id\": \"420\",\"windowid\": \"16455\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 25}, {\"value\": 47}, {\"value\": 33}, {\"value\": 6}, {\"value\": 4}, {\"value\": \"CButton\"}, {\"value\": \"Carregar CashDRO\"}, {\"value\": 0}, {\"value\": \"0xFFFFFF\"}, {\"value\": \"null\"}, {\"value\": 1}, {\"value\": -1}, {\"value\": -1}, {\"bgtype\": \"color\"}, {\"bgcolor\": \"\"}, {\"bgimage\": \"\"}, {\"bgimage\": \"\"}]}\n,\n{\"id\":\"4622\",\"windowid\":\"16455\",\"type\":\"com.sage.components.buttons.Button\",\n\"arguments\":[{ \"value\" : 8 }, { \"value\" : 39 }, { \"value\" : 25 }, { \"value\" : 11 }, { \"value\" : 4 }, { \"value\" : \"CButton\" }, { \"value\" : \"Limpar\" }, { \"value\" : 0 }, { \"value\" : \"0xFFFFFF\" }, { \"value\" : \"null\" }, { \"value\" : 1 }, { \"value\" : -1 }, { \"value\" : -1 }, { \"bgtype\" : \"color\" }, { \"bgcolor\" : \"\" }, { \"bgimage\" : \"\" }, { \"bgimage\" : \"\" }]}\n]}','0',1),(536,0,1659,'SCREEN_CASHDRAWER_LOAN',125,'{\"objects\":[{\"id\":\"21035\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":125},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#537#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"26970\",\"windowid\":\"21035\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":1},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30440\",\"windowid\":\"21035\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28962\",\"windowid\":\"21035\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1334\",\"windowid\":\"21035\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":32},{\"value\":1},{\"value\":20},{\"value\":3},{\"value\":\"#538#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15968\",\"windowid\":\"21035\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":20},{\"value\":3},{\"value\":\"#539#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31139\",\"windowid\":\"21035\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":32},{\"value\":8},{\"value\":20},{\"value\":18},{\"value\":\"#540#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(537,0,1660,'SCREEN_CASHDRAWER_BORROW',126,'{\"objects\":[{\"id\":\"32453\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":126},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#541#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"18698\",\"windowid\":\"32453\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":1},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8688\",\"windowid\":\"32453\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25106\",\"windowid\":\"32453\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11101\",\"windowid\":\"32453\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":32},{\"value\":1},{\"value\":20},{\"value\":3},{\"value\":\"#542#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13271\",\"windowid\":\"32453\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":20},{\"value\":3},{\"value\":\"#543#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10504\",\"windowid\":\"32453\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":32},{\"value\":8},{\"value\":20},{\"value\":18},{\"value\":\"#544#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(538,0,1661,'SCREEN_CASHDRAWER_BALANCESETTLEMENT',127,'{\"objects\":[{\"id\":\"10889\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":127},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#545#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7161\",\"windowid\":\"10889\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":1},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23106\",\"windowid\":\"10889\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":49},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19021\",\"windowid\":\"10889\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":44},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4459\",\"windowid\":\"10889\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":32},{\"value\":1},{\"value\":20},{\"value\":3},{\"value\":\"#546#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28288\",\"windowid\":\"10889\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":20},{\"value\":3},{\"value\":\"#547#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5989\",\"windowid\":\"10889\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":32},{\"value\":8},{\"value\":20},{\"value\":18},{\"value\":\"#548#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(539,0,1662,'SCREEN_CASHDRAWER_RETURN',128,'{\"objects\":[{\"id\":\"5629\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":128},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#549#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"16717\",\"windowid\":\"5629\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":1},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20804\",\"windowid\":\"5629\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":49},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5655\",\"windowid\":\"5629\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":44},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10789\",\"windowid\":\"5629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":32},{\"value\":1},{\"value\":20},{\"value\":3},{\"value\":\"#550#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17496\",\"windowid\":\"5629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":20},{\"value\":21},{\"value\":\"#551#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(540,0,1663,'SCREEN_CASHDRAWER_BLEED',129,'{\"objects\":[{\"id\":\"14554\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":129},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#552#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"32622\",\"windowid\":\"14554\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":1},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14100\",\"windowid\":\"14554\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":49},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18159\",\"windowid\":\"14554\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":44},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10282\",\"windowid\":\"14554\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":32},{\"value\":1},{\"value\":20},{\"value\":3},{\"value\":\"#553#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29315\",\"windowid\":\"14554\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":20},{\"value\":21},{\"value\":\"#554#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(541,0,1664,'SCREEN_CASHDRAWER_PURCHASES',130,'{\"objects\":[{\"id\":\"10255\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":130},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#555#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"28050\",\"windowid\":\"10255\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":1},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16066\",\"windowid\":\"10255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10613\",\"windowid\":\"10255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":43},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17478\",\"windowid\":\"10255\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":32},{\"value\":1},{\"value\":20},{\"value\":3},{\"value\":\"#556#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16899\",\"windowid\":\"10255\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":20},{\"value\":21},{\"value\":\"#557#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(542,0,1669,'SCREEN_TABLE_RETURN',135,'{\"objects\":[{\"id\":\"20233\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":135},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#570#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"14334\",\"windowid\":\"20233\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":5},{\"value\":14},{\"value\":31},{\"value\":[{\"v\":2},{\"v\":9},{\"v\":4}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29841\",\"windowid\":\"20233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":38},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20342\",\"windowid\":\"20233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":42},{\"value\":38},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26655\",\"windowid\":\"20233\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":15},{\"value\":5},{\"value\":14},{\"value\":31},{\"value\":[{\"v\":2},{\"v\":9},{\"v\":4}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(543,0,2539,'SCREEN_TABLE_DISCOUNTS',136,'\n{\"objects\":[{\"id\":\"29999\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":136},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#571#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"12508\",\"windowid\":\"29999\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":14},{\"value\":0},{\"value\":39},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"16075\",\"windowid\":\"29999\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":14},{\"value\":28},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28170\",\"windowid\":\"29999\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":15},{\"value\":4},{\"value\":14},{\"value\":3},{\"value\":\"#898#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16725\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":19},{\"value\":0},{\"value\":39},{\"value\":14},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#899#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8140\",\"windowid\":\"29999\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":15},{\"value\":20},{\"value\":14},{\"value\":3},{\"value\":\"#900#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18705\",\"windowid\":\"29999\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":20},{\"value\":8},{\"value\":4},{\"value\":3},{\"value\":\"#901#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22071\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":15},{\"value\":8},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#902#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20244\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":24},{\"value\":8},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#903#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4604\",\"windowid\":\"29999\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":20},{\"value\":12},{\"value\":4},{\"value\":3},{\"value\":\"#574#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21884\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":15},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#904#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26692\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":24},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#905#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21058\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":24},{\"value\":31},{\"value\":8},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#906#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16056\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":25},{\"value\":37},{\"value\":8},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#907#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1463\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":26},{\"value\":43},{\"value\":8},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#908#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10370\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":27},{\"value\":31},{\"value\":12},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#909#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16889\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":28},{\"value\":37},{\"value\":12},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#910#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29825\",\"windowid\":\"29999\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":25},{\"value\":57},{\"value\":4},{\"value\":3},{\"value\":\"#911#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4819\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":20},{\"value\":57},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#912#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15888\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":29},{\"value\":57},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#913#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29165\",\"windowid\":\"29999\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":20},{\"value\":23},{\"value\":4},{\"value\":3},{\"value\":\"#914#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7436\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":22},{\"value\":15},{\"value\":23},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#915#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20794\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":23},{\"value\":24},{\"value\":23},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#916#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14078\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":29},{\"value\":31},{\"value\":19},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#917#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22012\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":30},{\"value\":37},{\"value\":19},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#918#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17038\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":31},{\"value\":43},{\"value\":19},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#919#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12516\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":32},{\"value\":31},{\"value\":23},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#920#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22450\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":33},{\"value\":37},{\"value\":23},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#921#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9223\",\"windowid\":\"29999\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":0},{\"value\":0},{\"value\":14},{\"value\":3},{\"value\":\"#922#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"31287\",\"windowid\":\"29999\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":0},{\"value\":33},{\"value\":14},{\"value\":3},{\"value\":\"#923#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3533\",\"windowid\":\"29999\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":0},{\"value\":36},{\"value\":14},{\"value\":3},{\"value\":\"#924#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31115\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":43},{\"value\":12},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1079#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18433\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":43},{\"value\":23},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1080#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22524\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25766\",\"windowid\":\"29999\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}\n','0',1),(544,0,1671,'SCREEN_TABLE_CHECK_SPLIT',137,'{\"objects\":[{\"id\":\"15245\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":137},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#572#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"848\",\"windowid\":\"15245\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":8},{\"value\":14},{\"value\":28},{\"value\":[{\"v\":2},{\"v\":9},{\"v\":4}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3136\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":37},{\"value\":38},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5814\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":31},{\"value\":38},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30132\",\"windowid\":\"15245\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":1},{\"value\":14},{\"value\":3},{\"value\":\"#585#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21261\",\"windowid\":\"15245\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":0},{\"value\":4},{\"value\":14},{\"value\":3},{\"value\":\"#586#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11189\",\"windowid\":\"15245\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":5},{\"value\":3},{\"value\":\"#587#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28819\",\"windowid\":\"15245\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":21},{\"value\":1},{\"value\":21},{\"value\":6},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4776\",\"windowid\":\"15245\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":21},{\"value\":8},{\"value\":21},{\"value\":21},{\"value\":[{\"v\":2},{\"v\":9},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"716\",\"windowid\":\"15245\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":28},{\"value\":33},{\"value\":14},{\"value\":3},{\"value\":\"#588#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30185\",\"windowid\":\"15245\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":28},{\"value\":30},{\"value\":14},{\"value\":3},{\"value\":\"#589#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15844\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":15},{\"value\":8},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32302\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":15},{\"value\":13},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16395\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":15},{\"value\":18},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20466\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":15},{\"value\":23},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18104\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":39},{\"value\":14},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#594#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14890\",\"windowid\":\"15245\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":0},{\"value\":36},{\"value\":14},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#595#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(553,0,2528,'SCREEN_TABLE_NAMES',151,'{\"objects\":[{\"id\":\"4565\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":151},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#446#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"30303\",\"windowid\":\"4565\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"8915\",\"windowid\":\"4565\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#1004#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20335\",\"windowid\":\"4565\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":7},{\"value\":12},{\"value\":32},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13089\",\"windowid\":\"4565\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#1005#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"3372\",\"windowid\":\"4565\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"27287\",\"windowid\":\"4565\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24296\",\"windowid\":\"4565\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(555,0,2496,'SCREEN_MOVEMENTS',154,'{\"objects\":[{\"id\":\"5330\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":154},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1046#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7547\",\"windowid\":\"5330\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":43},{\"value\":3},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"31315\",\"windowid\":\"5330\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":11},{\"value\":20},{\"value\":16},{\"value\":\"#1047#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2884\",\"windowid\":\"5330\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":8},{\"value\":20},{\"value\":3},{\"value\":\"#1048#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32309\",\"windowid\":\"5330\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":5},{\"value\":20},{\"value\":3},{\"value\":\"#1049#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"8070\",\"windowid\":\"5330\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":27},{\"value\":20},{\"value\":3},{\"value\":\"#1050#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"19161\",\"windowid\":\"5330\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":27},{\"value\":20},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":2},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"25089\",\"windowid\":\"5330\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":27},{\"value\":20},{\"value\":3},{\"value\":\"#1051#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"15444\",\"windowid\":\"5330\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19555\",\"windowid\":\"5330\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(561,0,2487,'SCREEN_CONFIG_PROFILES',120,'{\"objects\":[{\"id\":\"17781\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":120},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#711#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"19147\",\"windowid\":\"17781\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"2663\",\"windowid\":\"17781\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20976\",\"windowid\":\"17781\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":27},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#712#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18603\",\"windowid\":\"17781\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#713#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6947\",\"windowid\":\"17781\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":41},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#674#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25522\",\"windowid\":\"17781\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":41},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#675#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24143\",\"windowid\":\"17781\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":41},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#677#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29961\",\"windowid\":\"17781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#680#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"21206\",\"windowid\":\"17781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":13},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#681#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"29294\",\"windowid\":\"17781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":10},{\"value\":13},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#682#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"19419\",\"windowid\":\"17781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#683#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"11628\",\"windowid\":\"17781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":13},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#684#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"15331\",\"windowid\":\"17781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":13},{\"value\":13},{\"value\":22},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#685#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"16624\",\"windowid\":\"17781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":14},{\"value\":13},{\"value\":25},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#686#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"671\",\"windowid\":\"17781\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"25725\",\"windowid\":\"17781\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":41},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#676#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"15831\",\"windowid\":\"17781\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":16},{\"value\":41},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#812#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"6617\",\"windowid\":\"17781\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":41},{\"value\":23},{\"value\":12},{\"value\":15},{\"value\":[{\"v\":12}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"24268\",\"windowid\":\"17781\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":27},{\"value\":23},{\"value\":13},{\"value\":15},{\"value\":[{\"v\":13}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"4474\",\"windowid\":\"17781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3980\",\"windowid\":\"17781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17142\",\"windowid\":\"17781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4108\",\"windowid\":\"17781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(563,0,2524,'SCREEN_PLUGINS',166,'{\"objects\":[{\"id\":\"25965\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":166},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1185#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"29895\",\"windowid\":\"25965\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":5},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"17706\",\"windowid\":\"25965\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29784\",\"windowid\":\"25965\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":37},{\"value\":34},{\"value\":16},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1173#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1099.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29370\",\"windowid\":\"25965\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":21},{\"value\":4},{\"value\":15},{\"value\":34},{\"value\":\"#1174#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19710\",\"windowid\":\"25965\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":1},{\"value\":4},{\"value\":19},{\"value\":34},{\"value\":[{\"v\":19}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4708\",\"windowid\":\"25965\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":37},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#1175#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2127\",\"windowid\":\"25965\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":37},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#1176#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19494\",\"windowid\":\"25965\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":37},{\"value\":10},{\"value\":16},{\"value\":3},{\"value\":\"#1177#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26632\",\"windowid\":\"25965\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":37},{\"value\":13},{\"value\":16},{\"value\":3},{\"value\":\"#1178#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5533\",\"windowid\":\"25965\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":37},{\"value\":16},{\"value\":16},{\"value\":3},{\"value\":\"#1179#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8926\",\"windowid\":\"25965\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":37},{\"value\":19},{\"value\":16},{\"value\":3},{\"value\":\"#1180#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11276\",\"windowid\":\"25965\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":37},{\"value\":22},{\"value\":16},{\"value\":3},{\"value\":\"#1181#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25825\",\"windowid\":\"25965\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":37},{\"value\":25},{\"value\":16},{\"value\":3},{\"value\":\"#1182#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18356\",\"windowid\":\"25965\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":37},{\"value\":28},{\"value\":16},{\"value\":3},{\"value\":\"#1183#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6137\",\"windowid\":\"25965\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":37},{\"value\":31},{\"value\":16},{\"value\":3},{\"value\":\"#1184#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(565,0,2526,'SCREEN_CONFIG_PRINTERS',140,'{\"objects\":[{\"id\":\"3000\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":140},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#706#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"20131\",\"windowid\":\"3000\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"4733\",\"windowid\":\"3000\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14412\",\"windowid\":\"3000\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":13},{\"value\":8},{\"value\":12},{\"value\":15},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"27963\",\"windowid\":\"3000\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":26},{\"value\":8},{\"value\":12},{\"value\":15},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"11273\",\"windowid\":\"3000\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":39},{\"value\":8},{\"value\":14},{\"value\":30},{\"value\":[{\"v\":14}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"9406\",\"windowid\":\"3000\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#709#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29040\",\"windowid\":\"3000\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#710#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"9304\",\"windowid\":\"3000\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"18517\",\"windowid\":\"3000\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":24},{\"value\":12},{\"value\":3},{\"value\":\"#783#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"20271\",\"windowid\":\"3000\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":26},{\"value\":24},{\"value\":12},{\"value\":3},{\"value\":\"#784#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"10082\",\"windowid\":\"3000\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":29},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1222#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"18677\",\"windowid\":\"3000\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21608\",\"windowid\":\"3000\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21884\",\"windowid\":\"3000\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19502\",\"windowid\":\"3000\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(568,0,1902,'SCREEN_LINK_ITEM_SELECTION',170,'{\"objects\":[{\"id\":\"15099\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":170},{\"value\":2},{\"value\":5},{\"value\":50},{\"value\":42},{\"value\":\"#1228#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"3178\",\"windowid\":\"15099\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":301},{\"value\":1},{\"value\":2},{\"value\":48},{\"value\":33},{\"value\":6},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26634\",\"windowid\":\"15099\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":44},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(577,0,2491,'SCREEN_CONFIG_LICENCE',153,'{\"objects\":[{\"id\":\"31190\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":153},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#843#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"8055\",\"windowid\":\"31190\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"7673\",\"windowid\":\"31190\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":2},{\"value\":5},{\"value\":34},{\"value\":27},{\"value\":\"#1021#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"11635\",\"windowid\":\"31190\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":2},{\"value\":32},{\"value\":34},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1020#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4718\",\"windowid\":\"31190\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":37},{\"value\":5},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1188#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19443\",\"windowid\":\"31190\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":37},{\"value\":10},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1189#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15861\",\"windowid\":\"31190\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(582,0,2082,'SCREEN_SALESMAN_SELECTION',2,'{\"objects\":[{\"id\":\"2853\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":2},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#245#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"20903\",\"windowid\":\"2853\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":101},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":47},{\"value\":4},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23071\",\"windowid\":\"2853\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":22},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12721\",\"windowid\":\"2853\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]}]}','4',3),(583,0,2480,'SCREEN_CONFIG_DOCUMENTPARTS',142,'{\"objects\":[{\"id\":\"26945\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":142},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#749#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"27062\",\"windowid\":\"26945\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"16762\",\"windowid\":\"26945\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22768\",\"windowid\":\"26945\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#750#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30651\",\"windowid\":\"26945\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#751#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26502\",\"windowid\":\"26945\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"138\",\"windowid\":\"26945\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":31},{\"value\":\"#753#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"21889\",\"windowid\":\"26945\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#752#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"11015\",\"windowid\":\"26945\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":28},{\"value\":\"#973#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"20458\",\"windowid\":\"26945\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18641\",\"windowid\":\"26945\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24475\",\"windowid\":\"26945\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11821\",\"windowid\":\"26945\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(585,0,2466,'SCREEN_ITEM_MENU_CONFIG',158,'{\"objects\":[{\"id\":\"21958\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":158},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1104#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"31014\",\"windowid\":\"21958\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"1149\",\"windowid\":\"21958\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11016\",\"windowid\":\"21958\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":13},{\"value\":4},{\"value\":11},{\"value\":30},{\"value\":[{\"v\":11}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"8936\",\"windowid\":\"21958\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":25},{\"value\":8},{\"value\":11},{\"value\":26},{\"value\":[{\"v\":11}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26930\",\"windowid\":\"21958\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":41},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"#1105#\"},{\"value\":[{\"v\":11}]},{\"value\":5},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"31554\",\"windowid\":\"21958\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":36},{\"value\":16},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2621\",\"windowid\":\"21958\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":36},{\"value\":21},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29176\",\"windowid\":\"21958\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":25},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"#1107#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4141\",\"windowid\":\"21958\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":25},{\"value\":4},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1108#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1093.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15117\",\"windowid\":\"21958\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":41},{\"value\":4},{\"value\":11},{\"value\":30},{\"value\":[{\"v\":11}]},{\"value\":\"CButton\"},{\"value\":2},{\"value\":0},{\"value\":0}]},{\"id\":\"22752\",\"windowid\":\"21958\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"#1109#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22334\",\"windowid\":\"21958\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":205},{\"value\":41},{\"value\":4},{\"value\":11},{\"value\":33},{\"value\":[{\"v\":11}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"31504\",\"windowid\":\"21958\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"32649\",\"windowid\":\"21958\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31811\",\"windowid\":\"21958\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(591,0,2529,'SCREEN_CONFIG_RADIO_TERMINALS',152,'{\"objects\":[{\"id\":\"11951\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":152},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1009#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"475\",\"windowid\":\"11951\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"9924\",\"windowid\":\"11951\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":24},{\"value\":7},{\"value\":17},{\"value\":3},{\"value\":\"#1010#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27376\",\"windowid\":\"11951\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":24},{\"value\":11},{\"value\":17},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1013#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6952\",\"windowid\":\"11951\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":24},{\"value\":16},{\"value\":17},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1014#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5113\",\"windowid\":\"11951\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":4},{\"value\":7},{\"value\":19},{\"value\":25},{\"value\":[{\"v\":19}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"19972\",\"windowid\":\"11951\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(598,0,2502,'SCREEN_SESSION_CLOSE',133,'{\"objects\":[{\"id\":\"13866\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":133},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#565#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"26902\",\"windowid\":\"13866\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"19656\",\"windowid\":\"13866\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":14},{\"value\":4},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#566#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26498\",\"windowid\":\"13866\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21585\",\"windowid\":\"13866\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27550\",\"windowid\":\"13866\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]}]}','0',1),(599,0,2501,'SCREEN_SESSION_OPEN',132,'{\"objects\":[{\"id\":\"10711\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":132},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#563#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"23864\",\"windowid\":\"10711\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"32359\",\"windowid\":\"10711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":14},{\"value\":11},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#564#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13844\",\"windowid\":\"10711\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"5580\",\"windowid\":\"10711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6428\",\"windowid\":\"10711\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"17336\",\"windowid\":\"10711\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":2},{\"value\":14},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#925#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"4715\",\"windowid\":\"10711\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":14},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#926#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',1),(600,0,2074,'SCREEN_TABLE_KEYBOARD',167,'{\"objects\":[{\"id\":\"1464\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":167},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1155#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"28440\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9949\",\"windowid\":\"1464\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13967\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":19},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27237\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":25},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20048\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":31},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27581\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":19},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8602\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":25},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22662\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":31},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24934\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":19},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22603\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":25},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12223\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":31},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25322\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":0},{\"value\":25},{\"value\":29},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4866\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":61},{\"value\":31},{\"value\":29},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"865\",\"windowid\":\"1464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":50},{\"value\":19},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#1167#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22529\",\"windowid\":\"1464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":19},{\"value\":36},{\"value\":17},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1168#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(601,0,2073,'SCREEN_CARD_EXIT',165,'{\"objects\":[{\"id\":\"8252\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":165},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1143#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"20151\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22910\",\"windowid\":\"8252\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3383\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":19},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29136\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":25},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4327\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":31},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10352\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":19},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12567\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":25},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24654\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":31},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4691\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":19},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11194\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":25},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17875\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":31},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9864\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":0},{\"value\":25},{\"value\":29},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4503\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":61},{\"value\":31},{\"value\":29},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6737\",\"windowid\":\"8252\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":50},{\"value\":19},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#1167#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3614\",\"windowid\":\"8252\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":19},{\"value\":36},{\"value\":17},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1168#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(602,0,2072,'SCREEN_CARD_ACTIVATION',164,'{\"objects\":[{\"id\":\"29275\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":164},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1142#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"27222\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28588\",\"windowid\":\"29275\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12933\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":19},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24921\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":25},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24306\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":31},{\"value\":8},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14167\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":19},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11335\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":25},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15885\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":31},{\"value\":15},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13866\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":19},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2040\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":25},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23756\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":31},{\"value\":22},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21898\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":0},{\"value\":25},{\"value\":29},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17363\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":61},{\"value\":31},{\"value\":29},{\"value\":5},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29918\",\"windowid\":\"29275\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":50},{\"value\":19},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#1167#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7604\",\"windowid\":\"29275\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":19},{\"value\":36},{\"value\":17},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1168#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(612,0,2104,'SCREEN_TABLE_DISCOUNTS',136,'{\"objects\":[{\"id\":\"14310\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":136},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#571#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"13671\",\"windowid\":\"14310\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":14},{\"value\":0},{\"value\":13},{\"value\":47},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"29605\",\"windowid\":\"14310\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":14},{\"value\":37},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20052\",\"windowid\":\"14310\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":14},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#898#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4353\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":22},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22530\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":17},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"88\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":19},{\"value\":0},{\"value\":47},{\"value\":14},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#899#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20476\",\"windowid\":\"14310\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":14},{\"value\":27},{\"value\":13},{\"value\":3},{\"value\":\"#900#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1291\",\"windowid\":\"14310\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":18},{\"value\":7},{\"value\":5},{\"value\":3},{\"value\":\"#901#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16411\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":14},{\"value\":7},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#902#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28069\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":23},{\"value\":7},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#903#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16521\",\"windowid\":\"14310\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":18},{\"value\":11},{\"value\":5},{\"value\":3},{\"value\":\"#574#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3655\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":14},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#904#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1788\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":23},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#905#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6021\",\"windowid\":\"14310\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":18},{\"value\":30},{\"value\":5},{\"value\":3},{\"value\":\"#914#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21665\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":22},{\"value\":14},{\"value\":30},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#915#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29973\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":23},{\"value\":23},{\"value\":30},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#916#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24723\",\"windowid\":\"14310\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":0},{\"value\":0},{\"value\":14},{\"value\":3},{\"value\":\"#922#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"31481\",\"windowid\":\"14310\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":0},{\"value\":41},{\"value\":14},{\"value\":3},{\"value\":\"#923#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2770\",\"windowid\":\"14310\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":0},{\"value\":44},{\"value\":14},{\"value\":3},{\"value\":\"#924#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7446\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":24},{\"value\":16},{\"value\":16},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#906#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17422\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":25},{\"value\":19},{\"value\":16},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#907#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3148\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":26},{\"value\":22},{\"value\":16},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#908#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14540\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":27},{\"value\":16},{\"value\":20},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#909#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11665\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":28},{\"value\":19},{\"value\":20},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#910#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"681\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":22},{\"value\":20},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1079#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17049\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":29},{\"value\":16},{\"value\":35},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#917#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30925\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":30},{\"value\":19},{\"value\":35},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#918#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6421\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":31},{\"value\":22},{\"value\":35},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#919#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16580\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":32},{\"value\":16},{\"value\":39},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#920#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31886\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":33},{\"value\":19},{\"value\":39},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#921#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2908\",\"windowid\":\"14310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":22},{\"value\":39},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1080#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','4',3),(613,0,2114,'SCREEN_TABLE_PRODUCT_TRANSF',138,'{\"objects\":[{\"id\":\"13176\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":138},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#573#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"10895\",\"windowid\":\"13176\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":47},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"Seleccione Mesa Destino|Seleccione Artigos a Transferir\"}]},{\"id\":\"19639\",\"windowid\":\"13176\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":8},{\"value\":11},{\"value\":33},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"18730\",\"windowid\":\"13176\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":3},{\"value\":\"#597#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"32640\",\"windowid\":\"13176\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7194\",\"windowid\":\"13176\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":103},{\"value\":5},{\"value\":47},{\"value\":22},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32613\",\"windowid\":\"13176\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":0},{\"value\":41},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"621\",\"windowid\":\"13176\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":21},{\"value\":41},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"10768\",\"windowid\":\"13176\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":8},{\"value\":11},{\"value\":33},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"15013\",\"windowid\":\"13176\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":11},{\"value\":14},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"25941\",\"windowid\":\"13176\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":11},{\"value\":19},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"14118\",\"windowid\":\"13176\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":11},{\"value\":24},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"22149\",\"windowid\":\"13176\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":11},{\"value\":29},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"23205\",\"windowid\":\"13176\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":16},{\"value\":5},{\"value\":11},{\"value\":3},{\"value\":\"#598#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"1402\",\"windowid\":\"13176\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":3},{\"value\":27},{\"value\":40},{\"value\":3},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":0}]},{\"id\":\"1425\",\"windowid\":\"13176\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":0},{\"value\":43},{\"value\":27},{\"value\":4},{\"value\":6},{\"value\":-1},{\"value\":102},{\"value\":0}]},{\"id\":\"20734\",\"windowid\":\"13176\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":0},{\"value\":5},{\"value\":11},{\"value\":3},{\"value\":\"#756#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"25424\",\"windowid\":\"13176\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":11},{\"value\":5},{\"value\":5},{\"value\":3},{\"value\":\"#767#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]}]}','4',3),(619,0,2525,'SCREEN_SOS_PRINTERS',176,'{\"objects\":[{\"id\":\"26265\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":176},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1579#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"2941\",\"windowid\":\"26265\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"22810\",\"windowid\":\"26265\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15385\",\"windowid\":\"26265\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"28039\",\"windowid\":\"26265\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":14},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1580#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"20521\",\"windowid\":\"26265\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":14},{\"value\":7},{\"value\":12},{\"value\":32},{\"value\":[{\"v\":12}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"28910\",\"windowid\":\"26265\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":39},{\"value\":14},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1581#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27730\",\"windowid\":\"26265\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31233\",\"windowid\":\"26265\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(624,0,2468,'SCREEN_OFFERS_CONFIG',178,'{\"objects\":[{\"id\":\"23418\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":178},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1622#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"18655\",\"windowid\":\"23418\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":302},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"23809\",\"windowid\":\"23418\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":20},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"19413\",\"windowid\":\"23418\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"32031\",\"windowid\":\"23418\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":16},{\"value\":4},{\"value\":23},{\"value\":3},{\"value\":\"#1623#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12706\",\"windowid\":\"23418\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":40},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"#1624#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13795\",\"windowid\":\"23418\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":40},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#1625#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4850\",\"windowid\":\"23418\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":40},{\"value\":25},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1626#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4289\",\"windowid\":\"23418\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":16},{\"value\":10},{\"value\":11},{\"value\":29},{\"value\":[{\"v\":11}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8467\",\"windowid\":\"23418\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":205},{\"value\":28},{\"value\":10},{\"value\":11},{\"value\":12},{\"value\":[{\"v\":11}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14539\",\"windowid\":\"23418\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":206},{\"value\":28},{\"value\":25},{\"value\":11},{\"value\":14},{\"value\":[{\"v\":11}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9673\",\"windowid\":\"23418\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":9},{\"value\":40},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#1627#\"},{\"value\":[{\"v\":12}]},{\"value\":7},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"22476\",\"windowid\":\"23418\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"22143\",\"windowid\":\"23418\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":0},{\"value\":36},{\"value\":12},{\"value\":3},{\"value\":\"#1628#\"},{\"value\":[{\"v\":12}]},{\"value\":5},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"23842\",\"windowid\":\"23418\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":32},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":2},{\"value\":0},{\"value\":0}]},{\"id\":\"15921\",\"windowid\":\"23418\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":34},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"1166\",\"windowid\":\"23418\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":40},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#1629#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23434\",\"windowid\":\"23418\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":16},{\"value\":7},{\"value\":11},{\"value\":3},{\"value\":\"#1630#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25678\",\"windowid\":\"23418\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":28},{\"value\":7},{\"value\":11},{\"value\":3},{\"value\":\"#1631#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15624\",\"windowid\":\"23418\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":28},{\"value\":22},{\"value\":11},{\"value\":3},{\"value\":\"#1632#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17725\",\"windowid\":\"23418\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":17},{\"value\":41},{\"value\":57},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1633#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29474\",\"windowid\":\"23418\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":20},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"23765\",\"windowid\":\"23418\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"12487\",\"windowid\":\"23418\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"60\",\"windowid\":\"23418\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":21},{\"value\":40},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#1647#\"},{\"value\":[{\"v\":12}]},{\"value\":5},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"29873\",\"windowid\":\"23418\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":22},{\"value\":40},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#1658#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(644,0,2467,'SCREEN_OFFERS',179,'{\"objects\":[{\"id\":\"22664\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":179},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1635#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"26142\",\"windowid\":\"22664\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"25954\",\"windowid\":\"22664\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":1},{\"value\":5},{\"value\":51},{\"value\":26},{\"value\":[{\"v\":1},{\"v\":7},{\"v\":1},{\"v\":2},{\"v\":10},{\"v\":10},{\"v\":10},{\"v\":10}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31347\",\"windowid\":\"22664\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":34},{\"value\":32},{\"value\":18},{\"value\":3},{\"value\":\"#1636#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8660\",\"windowid\":\"22664\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":32},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1637#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23135\",\"windowid\":\"22664\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":17},{\"value\":32},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1638#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15715\",\"windowid\":\"22664\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":9},{\"value\":32},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1639#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25690\",\"windowid\":\"22664\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":25},{\"value\":32},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1641#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23968\",\"windowid\":\"22664\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19647\",\"windowid\":\"22664\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(645,0,2486,'SCREEN_CONFIG_EXCLUSIONS',119,'{\"objects\":[{\"id\":\"12936\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":119},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#502#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"3008\",\"windowid\":\"12936\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"5628\",\"windowid\":\"12936\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3787\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":27},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#503#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4680\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#504#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24774\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"16987\",\"windowid\":\"12936\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":13},{\"value\":14},{\"value\":13},{\"value\":24},{\"value\":[{\"v\":13}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"28316\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":13},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#957#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3659\",\"windowid\":\"12936\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":27},{\"value\":14},{\"value\":13},{\"value\":24},{\"value\":[{\"v\":13}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"15254\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":27},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#807#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24988\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":13},{\"value\":11},{\"value\":25},{\"value\":3},{\"value\":\"#808#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"11523\",\"windowid\":\"12936\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":205},{\"value\":13},{\"value\":14},{\"value\":25},{\"value\":24},{\"value\":[{\"v\":25}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":1},{\"value\":1}]},{\"id\":\"31960\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30702\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1242\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27073\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(667,0,2304,'SCREEN_PLU_ADD_OBS',183,'{\"objects\":[{\"id\":\"16278\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":183},{\"value\":10},{\"value\":6},{\"value\":33},{\"value\":36},{\"value\":\"#1761#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"26413\",\"windowid\":\"16278\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":26},{\"value\":29},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2113\",\"windowid\":\"16278\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":20},{\"value\":29},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17771\",\"windowid\":\"16278\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":3},{\"value\":31},{\"value\":25},{\"value\":\"#58#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]}]}','0',1),(851,0,2506,'SCREEN_CONFIG_OPEN_TABLES_SERVICES',11121,'{\"objects\":[{\"id\":\"22629\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":121},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#508#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"26290\",\"windowid\":\"22629\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"Detalhe Mesa|Transferencia Mesas entre Empregados\"}]},{\"id\":\"28317\",\"windowid\":\"22629\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":31},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"#1802#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6997\",\"windowid\":\"22629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"28915\",\"windowid\":\"22629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":4},{\"value\":21},{\"value\":3},{\"value\":\"#509#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"8502\",\"windowid\":\"22629\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":32},{\"value\":13},{\"value\":21},{\"value\":22},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3},{\"v\":5},{\"v\":7}]},{\"value\":\"#1803#\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"28614\",\"windowid\":\"22629\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":32},{\"value\":35},{\"value\":21},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#870#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":5},{\"value\":-1},{\"value\":0}]},{\"id\":\"19963\",\"windowid\":\"22629\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":13},{\"value\":30},{\"value\":36},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#882#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"24031\",\"windowid\":\"22629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":32},{\"value\":7},{\"value\":21},{\"value\":3},{\"value\":\"#883#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22043\",\"windowid\":\"22629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":32},{\"value\":10},{\"value\":21},{\"value\":3},{\"value\":\"#884#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16227\",\"windowid\":\"22629\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":0},{\"value\":35},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#872#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28807\",\"windowid\":\"22629\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":21},{\"value\":9},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"11607\",\"windowid\":\"22629\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":34},{\"value\":9},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"162\",\"windowid\":\"22629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":36},{\"value\":13},{\"value\":4},{\"value\":18},{\"value\":3},{\"value\":\"#1225#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14908\",\"windowid\":\"22629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":37},{\"value\":13},{\"value\":7},{\"value\":18},{\"value\":3},{\"value\":\"#1226#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16621\",\"windowid\":\"22629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":40},{\"value\":13},{\"value\":11},{\"value\":18},{\"value\":3},{\"value\":\"#1662#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26764\",\"windowid\":\"22629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":39},{\"value\":13},{\"value\":14},{\"value\":18},{\"value\":3},{\"value\":\"#1663#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31757\",\"windowid\":\"22629\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":41},{\"value\":13},{\"value\":17},{\"value\":18},{\"value\":3},{\"value\":\"#1664#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"10782\",\"windowid\":\"22629\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1621,0,2483,'SCREEN_CONFIG_TERMINALS_RETAIL',10141,'{\"objects\":[{\"id\":\"23821\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":141},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#714#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"22969\",\"windowid\":\"23821\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"32127\",\"windowid\":\"23821\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13820\",\"windowid\":\"23821\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#715#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3461\",\"windowid\":\"23821\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#716#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32412\",\"windowid\":\"23821\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":13},{\"value\":14},{\"value\":40},{\"value\":25},{\"value\":[{\"v\":40}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"5166\",\"windowid\":\"23821\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"26917\",\"windowid\":\"23821\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#717#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30888\",\"windowid\":\"23821\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":7},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#721#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"28822\",\"windowid\":\"23821\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":26},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#720#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"24667\",\"windowid\":\"23821\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":40},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#718#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"27025\",\"windowid\":\"23821\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#862#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"26318\",\"windowid\":\"23821\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":17},{\"value\":26},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#1460#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"32044\",\"windowid\":\"23821\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":19},{\"value\":13},{\"value\":4},{\"value\":20},{\"value\":3},{\"value\":\"#1689#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"17858\",\"windowid\":\"23821\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":18},{\"value\":33},{\"value\":4},{\"value\":20},{\"value\":3},{\"value\":\"#1690#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"26396\",\"windowid\":\"23821\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":40},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30509\",\"windowid\":\"23821\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31305\",\"windowid\":\"23821\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26615\",\"windowid\":\"23821\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18201\",\"windowid\":\"23821\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1626,0,2527,'SCREEN_CONFIG_PRINTERS_RET_SERV',11140,'{\"objects\":[{\"id\":\"3517\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":140},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#706#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"24013\",\"windowid\":\"3517\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"24145\",\"windowid\":\"3517\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15835\",\"windowid\":\"3517\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":13},{\"value\":8},{\"value\":12},{\"value\":15},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"8808\",\"windowid\":\"3517\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":26},{\"value\":8},{\"value\":12},{\"value\":15},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"14319\",\"windowid\":\"3517\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":39},{\"value\":8},{\"value\":14},{\"value\":30},{\"value\":[{\"v\":14}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"1986\",\"windowid\":\"3517\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#709#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6468\",\"windowid\":\"3517\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#710#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2877\",\"windowid\":\"3517\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"1417\",\"windowid\":\"3517\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":24},{\"value\":12},{\"value\":3},{\"value\":\"#783#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"6891\",\"windowid\":\"3517\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12067\",\"windowid\":\"3517\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1627,0,2547,'SCREEN_TABLE_CANCEL_ITEMS',173,'{\"objects\":[{\"id\":\"32553\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":173},{\"value\":10},{\"value\":10},{\"value\":33},{\"value\":36},{\"value\":\"#1432#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"29154\",\"windowid\":\"32553\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":1},{\"value\":5},{\"value\":12},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26689\",\"windowid\":\"32553\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":26},{\"value\":29},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4082\",\"windowid\":\"32553\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":20},{\"value\":29},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21794\",\"windowid\":\"32553\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":20},{\"value\":5},{\"value\":12},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31419\",\"windowid\":\"32553\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":14},{\"value\":6},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27809\",\"windowid\":\"32553\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":14},{\"value\":11},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26703\",\"windowid\":\"32553\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":14},{\"value\":16},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21716\",\"windowid\":\"32553\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":14},{\"value\":21},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13711\",\"windowid\":\"32553\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":20},{\"value\":2},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1433#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4525\",\"windowid\":\"32553\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":2},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1437#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1632,0,2405,'SCREEN_MSG_BOX_TEXT',160,'\n{\"objects\":[{\"id\":\"9338\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":160},{\"value\":4},{\"value\":5},{\"value\":32},{\"value\":19},{\"value\":\"Observacao\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7324\",\"windowid\":\"9338\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-10},{\"value\":17},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31232\",\"windowid\":\"9338\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-9},{\"value\":12},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32491\",\"windowid\":\"9338\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":5},{\"value\":30},{\"value\":3},{\"value\":\"#58#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1642,0,2419,'SCREEN_CONFIG_FAMILIES_SERVICES',11102,'{\"objects\":[{\"id\":\"813\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#462#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"23252\",\"windowid\":\"813\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"6026\",\"windowid\":\"813\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"#1805#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26708\",\"windowid\":\"813\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":36},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#463#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11105\",\"windowid\":\"813\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#464#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"9070\",\"windowid\":\"813\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#465#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4956\",\"windowid\":\"813\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":25},{\"value\":0},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#599#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10304\",\"windowid\":\"813\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":12},{\"value\":13},{\"value\":3},{\"value\":\"#471#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13501\",\"windowid\":\"813\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":13},{\"value\":15},{\"value\":13},{\"value\":3},{\"value\":\"#472#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"569\",\"windowid\":\"813\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":13},{\"value\":18},{\"value\":13},{\"value\":3},{\"value\":\"#473#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"930\",\"windowid\":\"813\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":21},{\"value\":13},{\"value\":3},{\"value\":\"#474#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14782\",\"windowid\":\"813\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":13},{\"value\":24},{\"value\":13},{\"value\":3},{\"value\":\"#475#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16528\",\"windowid\":\"813\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":26},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#600#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26646\",\"windowid\":\"813\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"22340\",\"windowid\":\"813\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":27},{\"value\":12},{\"value\":13},{\"value\":3},{\"value\":\"#469#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"19307\",\"windowid\":\"813\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":40},{\"value\":4},{\"value\":12},{\"value\":31},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":-1}]},{\"id\":\"4374\",\"windowid\":\"813\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":29},{\"value\":27},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#949#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"25637\",\"windowid\":\"813\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":28},{\"value\":46},{\"value\":35},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#947#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"8054\",\"windowid\":\"813\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":27},{\"value\":40},{\"value\":35},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#948#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"11767\",\"windowid\":\"813\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26441\",\"windowid\":\"813\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23107\",\"windowid\":\"813\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31792\",\"windowid\":\"813\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":27},{\"value\":18},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1788#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"24269\",\"windowid\":\"813\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":54},{\"value\":27},{\"value\":21},{\"value\":13},{\"value\":3},{\"value\":\"#1797#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',1),(1643,0,2418,'SCREEN_CONFIG_FAMILIES_RETAIL',10102,'{\"objects\":[{\"id\":\"15177\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#462#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"27743\",\"windowid\":\"15177\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"13628\",\"windowid\":\"15177\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22649\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"#463#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32438\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#464#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32719\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#465#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30212\",\"windowid\":\"15177\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":19},{\"value\":26},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#468#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"26648\",\"windowid\":\"15177\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":25},{\"value\":0},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#599#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4144\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":40},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#471#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26528\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":40},{\"value\":22},{\"value\":13},{\"value\":3},{\"value\":\"#472#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21018\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":40},{\"value\":25},{\"value\":13},{\"value\":3},{\"value\":\"#473#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24702\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":40},{\"value\":28},{\"value\":13},{\"value\":3},{\"value\":\"#474#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11086\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":40},{\"value\":31},{\"value\":13},{\"value\":3},{\"value\":\"#475#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2711\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#476#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2174\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#478#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27315\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":26},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#481#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25286\",\"windowid\":\"15177\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":26},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#482#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"18215\",\"windowid\":\"15177\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":26},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#600#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31273\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"12002\",\"windowid\":\"15177\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":15},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#477#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"7402\",\"windowid\":\"15177\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":40},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#469#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"3557\",\"windowid\":\"15177\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":7},{\"value\":40},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#470#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"10923\",\"windowid\":\"15177\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#467#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"25192\",\"windowid\":\"15177\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":40},{\"value\":4},{\"value\":12},{\"value\":31},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":-1}]},{\"id\":\"14707\",\"windowid\":\"15177\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":29},{\"value\":27},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#949#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"60\",\"windowid\":\"15177\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":28},{\"value\":46},{\"value\":35},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#947#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"13331\",\"windowid\":\"15177\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":27},{\"value\":40},{\"value\":35},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#948#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"31787\",\"windowid\":\"15177\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":51},{\"value\":13},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#1115#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"17534\",\"windowid\":\"15177\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26466\",\"windowid\":\"15177\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27287\",\"windowid\":\"29363\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":13},{\"value\":13},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#322#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CColorBox\"}]},{\"id\":\"12815\",\"windowid\":\"15177\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1644,0,2417,'SCREEN_CONFIG_FAMILIES',102,'\n{\n    \"objects\": [{\n        \"id\": \"29363\",\n        \"type\": \"com.sage.components.window.Window\",\n        \"arguments\": [{\n            \"value\": 102\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 53\n        }, {\n            \"value\": 45\n        }, {\n            \"value\": \"#462#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"[[1]]\"\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"8559\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.panels.Panel\",\n        \"arguments\": [{\n            \"value\": 301\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 41\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"\"\n        }]\n    }, {\n        \"id\": \"23424\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.list.ListBox\",\n        \"arguments\": [{\n            \"value\": 201\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 35\n        }, {\n            \"value\": [{\n                \"v\": 12\n            }]\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"3885\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 3\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 7\n        }, {\n            \"value\": 27\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#463#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"28792\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 2\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 27\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#464#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"12755\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 1\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#465#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"28538\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 19\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 10\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"CCheckBox\"\n        }, {\n            \"value\": \"#468#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"23824\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 25\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#599#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 5\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"23966\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 8\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#471#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"2354\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 9\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 22\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#472#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"9003\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 10\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 25\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#473#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"20945\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 11\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 28\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#474#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"6172\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 12\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 31\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#475#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"14007\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 14\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 7\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#476#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"3555\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 16\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#478#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"6419\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 17\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 16\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#479#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 2\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"2137\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 18\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#480#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 2\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"32569\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 21\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 16\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#481#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"9965\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 20\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"CCheckBox\"\n        }, {\n            \"value\": \"#482#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"15237\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 26\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#600#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 5\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"2196\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 4778\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#344#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"14096\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.list.DropBox\",\n        \"arguments\": [{\n            \"value\": 15\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 10\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#477#\"\n        }, {\n            \"value\": [{\n                \"v\": 12\n            }]\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"CButton\"\n        }]\n    }, {\n        \"id\": \"2065\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.list.DropBox\",\n        \"arguments\": [{\n            \"value\": 6\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#469#\"\n        }, {\n            \"value\": [{\n                \"v\": 13\n            }]\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"CButton\"\n        }]\n    }, {\n        \"id\": \"26460\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.list.DropBox\",\n        \"arguments\": [{\n            \"value\": 7\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 16\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#470#\"\n        }, {\n            \"value\": [{\n                \"v\": 13\n            }]\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"CButton\"\n        }]\n    }, {\n        \"id\": \"23427\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.list.DropBox\",\n        \"arguments\": [{\n            \"value\": 5\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 10\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#467#\"\n        }, {\n            \"value\": [{\n                \"v\": 13\n            }]\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"CButton\"\n        }]\n    },  {\n        \"id\": \"14685\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.list.DropBox\",\n        \"arguments\": [{\n            \"value\": 29\n        }, {\n            \"value\": 27\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#949#\"\n        }, {\n            \"value\": [{\n                \"v\": 12\n            }]\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"CButton\"\n        }]\n    }, {\n        \"id\": \"7425\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 28\n        }, {\n            \"value\": 46\n        }, {\n            \"value\": 35\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#947#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 2\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }]\n    }, {\n        \"id\": \"30266\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 27\n        }, {\n            \"value\": 40\n        }, {\n            \"value\": 35\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#948#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 2\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }]\n    }, {\n        \"id\": \"8788\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.list.ListBox\",\n        \"arguments\": [{\n            \"value\": 202\n        }, {\n            \"value\": 26\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 15\n        }, {\n            \"value\": [{\n                \"v\": 13\n            }]\n        }, {\n            \"value\": \"CCheckBox\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }]\n    }, {\n        \"id\": \"27174\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 51\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 31\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1115#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"5126\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": -2\n        }, {\n            \"value\": 47\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#297#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"1041.png\"\n        }, {\n            \"value\": 5\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"8527\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": -1\n        }, {\n            \"value\": 41\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#298#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"1042.png\"\n        }, {\n            \"value\": 5\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"27287\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.list.DropBox\",\n        \"arguments\": [{\n            \"value\": 13\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 22\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#322#\"\n        }, {\n            \"value\": [{\n                \"v\": 12\n            }]\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"CColorBox\"\n        }]\n    }, {\n        \"id\": \"27620\",\n        \"windowid\": \"29363\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": -6\n        }, {\n            \"value\": 8\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#300#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 5\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }]\n}\n','0',1),(1645,0,2457,'SCREEN_CONFIG_PAYMENTTYPES_SERVICES',11101,'{\"objects\":[{\"id\":\"5680\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":101},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#290#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"9140\",\"windowid\":\"5680\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"29669\",\"windowid\":\"5680\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"#291#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14406\",\"windowid\":\"5680\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#292#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11954\",\"windowid\":\"5680\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#293#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6515\",\"windowid\":\"5680\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":40},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#294#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25874\",\"windowid\":\"5680\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"15553\",\"windowid\":\"5680\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"#1804#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11140\",\"windowid\":\"5680\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#805#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"19834\",\"windowid\":\"5680\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28106\",\"windowid\":\"5680\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18293\",\"windowid\":\"5680\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25360\",\"windowid\":\"5680\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1646,0,2456,'SCREEN_CONFIG_PAYMENTTYPES',101,'{\"objects\":[{\"id\":\"10426\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":101},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#290#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7476\",\"windowid\":\"10426\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"3619\",\"windowid\":\"10426\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":7},{\"value\":26},{\"value\":3},{\"value\":\"#291#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1772\",\"windowid\":\"10426\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":26},{\"value\":3},{\"value\":\"#292#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21951\",\"windowid\":\"10426\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#293#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"10736\",\"windowid\":\"10426\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":40},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#294#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"901\",\"windowid\":\"14740\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11020\",\"windowid\":\"14740\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1208\",\"windowid\":\"10426\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19657\",\"windowid\":\"10426\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23860\",\"windowid\":\"10426\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"1739\",\"windowid\":\"10426\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31599\",\"windowid\":\"10426\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#805#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"888\",\"windowid\":\"10426\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":40},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#295#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]}]}','0',1),(1652,0,2522,'SCREEN_PROFILES_SELECTION_RET_SERV',11148,'{\"objects\":[{\"id\":\"16310\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":148},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#952#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"4694\",\"windowid\":\"16310\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"29341\",\"windowid\":\"16310\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14213\",\"windowid\":\"16310\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":11},{\"value\":12},{\"value\":30},{\"value\":25},{\"value\":[{\"v\":30}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"11523\",\"windowid\":\"16310\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":11},{\"value\":8},{\"value\":30},{\"value\":4},{\"value\":\"#1103#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1653,0,2521,'SCREEN_PROFILES_SELECTION',148,'{\"objects\":[{\"id\":\"9534\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":148},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#952#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"13118\",\"windowid\":\"9534\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"28432\",\"windowid\":\"9534\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27031\",\"windowid\":\"9534\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":11},{\"value\":12},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"4542\",\"windowid\":\"9534\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":26},{\"value\":12},{\"value\":15},{\"value\":25},{\"value\":[{\"v\":15}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"11530\",\"windowid\":\"9534\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":11},{\"value\":8},{\"value\":15},{\"value\":4},{\"value\":\"#1103#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20238\",\"windowid\":\"9534\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":98},{\"value\":26},{\"value\":8},{\"value\":15},{\"value\":4},{\"value\":\"#1101#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1667,0,2440,'SCREEN_ITEM_SEARCH',181,'{\"objects\":[{\"id\":\"27237\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":181},{\"value\":9},{\"value\":6},{\"value\":34},{\"value\":37},{\"value\":\"#1708#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"14387\",\"windowid\":\"27237\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":14},{\"value\":6},{\"value\":19},{\"value\":22},{\"value\":[{\"v\":7},{\"v\":5}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24814\",\"windowid\":\"27237\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":27},{\"value\":29},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22520\",\"windowid\":\"27237\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":21},{\"value\":29},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26642\",\"windowid\":\"27237\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":1},{\"value\":3},{\"value\":12},{\"value\":25},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15694\",\"windowid\":\"27237\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":14},{\"value\":3},{\"value\":19},{\"value\":3},{\"value\":\"#1841#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1721,0,3023,'SCREEN_TABLE_EDIT_RETAIL_GUIAS',504,'{\"objects\":[{\"id\":\"11240\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":504},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#1830#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"32493\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":49},{\"value\":3},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1852#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12085\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":49},{\"value\":0},{\"value\":16},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"14603\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":64},{\"value\":49},{\"value\":25},{\"value\":16},{\"value\":3},{\"value\":\"#1696#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18285\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":49},{\"value\":21},{\"value\":16},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1697#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1079.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25798\",\"windowid\":\"11240\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":52},{\"value\":3},{\"value\":13},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"3756\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":52},{\"value\":3},{\"value\":13},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14554\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":49},{\"value\":6},{\"value\":16},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31132\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":81},{\"value\":49},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5280\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":82},{\"value\":53},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6698\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":83},{\"value\":57},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31357\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":84},{\"value\":49},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26789\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":85},{\"value\":53},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2810\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":86},{\"value\":57},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20226\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":87},{\"value\":49},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28035\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":88},{\"value\":53},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20257\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":57},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15381\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":53},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9277\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":72},{\"value\":49},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29030\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":90},{\"value\":49},{\"value\":28},{\"value\":16},{\"value\":3},{\"value\":\"#1702#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"248\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":61},{\"value\":37},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1084.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5454\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":92},{\"value\":61},{\"value\":43},{\"value\":4},{\"value\":8},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1085.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22171\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":91},{\"value\":57},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1713#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"377\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":93},{\"value\":61},{\"value\":31},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFF0000\"},{\"value\":\"1083.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14210\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":120},{\"value\":49},{\"value\":9},{\"value\":16},{\"value\":3},{\"value\":\"#1848#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10411\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":49},{\"value\":12},{\"value\":16},{\"value\":3},{\"value\":\"#1849#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13780\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":49},{\"value\":15},{\"value\":16},{\"value\":3},{\"value\":\"#1850#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23836\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26860\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-500},{\"value\":0},{\"value\":0},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"logo.png\"},{\"value\":50},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14004\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":40},{\"value\":46},{\"value\":9},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1831#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1150.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22307\",\"windowid\":\"11240\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":49},{\"value\":39},{\"value\":[{\"v\":4},{\"v\":25},{\"v\":4},{\"v\":5},{\"v\":4},{\"v\":5}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"50\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":7},{\"value\":43},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11998\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":2},{\"value\":43},{\"value\":5},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"2692\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":34},{\"value\":43},{\"value\":5},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20741\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":24},{\"value\":43},{\"value\":10},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32725\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":9},{\"value\":43},{\"value\":15},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"90\",\"windowid\":\"11240\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":39},{\"value\":43},{\"value\":10},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23583\",\"windowid\":\"11240\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":43},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]}]}','5',2),(1722,0,3022,'SCREEN_TABLE_EDIT_RETAIL_GUIAS',504,'{\"objects\":[{\"id\":\"15831\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":504},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"9561\",\"windowid\":\"15831\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":20},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":5}]},{\"value\":\"#1772#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23955\",\"windowid\":\"15831\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":8},{\"value\":24},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26131\",\"windowid\":\"15831\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"186\",\"windowid\":\"15831\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"32068\",\"windowid\":\"15831\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":4},{\"value\":24},{\"value\":4},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"10071\",\"windowid\":\"15831\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"31354\",\"windowid\":\"15831\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":12},{\"value\":43},{\"value\":41},{\"value\":4},{\"value\":8},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"15277\",\"windowid\":\"15831\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":43},{\"value\":7},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31792\",\"windowid\":\"15831\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":24},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21125\",\"windowid\":\"15831\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":120},{\"value\":0},{\"value\":28},{\"value\":12},{\"value\":3},{\"value\":\"#1848#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23386\",\"windowid\":\"15831\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":0},{\"value\":31},{\"value\":12},{\"value\":3},{\"value\":\"#1849#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25356\",\"windowid\":\"15831\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":0},{\"value\":34},{\"value\":12},{\"value\":3},{\"value\":\"#1850#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21593\",\"windowid\":\"15831\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":0},{\"value\":43},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1831#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1150.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23159\",\"windowid\":\"15831\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":0},{\"value\":37},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1852#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8313\",\"windowid\":\"15831\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":3},{\"value\":37},{\"value\":9},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21008\",\"windowid\":\"15831\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":0},{\"value\":40},{\"value\":12},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1750,0,3140,'SCREEN_TABLE_EDIT_GUIAS_RETAIL',10054,'\n{\"objects\":[{\"id\":\"12936\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":54},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1747#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"11186\",\"windowid\":\"12936\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":9},{\"value\":37},{\"value\":33},{\"value\":[{\"v\":3},{\"v\":19},{\"v\":3},{\"v\":4},{\"v\":3},{\"v\":4}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"32297\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":7},{\"value\":42},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4244\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26383\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":37},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"30935\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":2},{\"value\":42},{\"value\":5},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"2180\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":64},{\"value\":37},{\"value\":25},{\"value\":16},{\"value\":3},{\"value\":\"#1696#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15458\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":26},{\"value\":42},{\"value\":4},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8778\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":19},{\"value\":42},{\"value\":7},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11645\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":9},{\"value\":42},{\"value\":10},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20690\",\"windowid\":\"12936\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":37},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"25847\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":37},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1867\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":37},{\"value\":10},{\"value\":16},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14455\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":81},{\"value\":37},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32552\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":82},{\"value\":41},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29798\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":83},{\"value\":45},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28906\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":84},{\"value\":37},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32273\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":85},{\"value\":41},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18484\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":86},{\"value\":45},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26612\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":87},{\"value\":37},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21866\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":88},{\"value\":41},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4433\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":45},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20851\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":41},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29563\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":72},{\"value\":37},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27727\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":90},{\"value\":37},{\"value\":28},{\"value\":16},{\"value\":3},{\"value\":\"#1702#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4733\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":49},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1084.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9635\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":30},{\"value\":42},{\"value\":7},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29708\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":92},{\"value\":49},{\"value\":41},{\"value\":4},{\"value\":10},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1085.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26223\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":91},{\"value\":45},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1713#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22237\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":42},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19836\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":93},{\"value\":49},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1083.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30168\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":600},{\"value\":0},{\"value\":0},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"logo.png\"},{\"value\":50},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27724\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":601},{\"value\":37},{\"value\":0},{\"value\":16},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"logo_cliente.png\"},{\"value\":50},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15810\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":30},{\"value\":46},{\"value\":7},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1831#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"24731\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":126},{\"value\":37},{\"value\":14},{\"value\":16},{\"value\":6},{\"value\":\"#1880#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"24732\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":128},{\"value\":0},{\"value\":3},{\"value\":18},{\"value\":3},{\"value\":\"#1848#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"24733\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":129},{\"value\":0},{\"value\":6},{\"value\":18},{\"value\":3},{\"value\":\"#1849#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"24731\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":120},{\"value\":19},{\"value\":3},{\"value\":18},{\"value\":3},{\"value\":\"#1903#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"20817\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":19},{\"value\":6},{\"value\":18},{\"value\":3},{\"value\":\"#1904#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22177\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":37},{\"value\":20},{\"value\":16},{\"value\":3},{\"value\":\"#1850#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}\n','5',2),(1754,0,3136,'SCREEN_SALESMAN_ACCOUNT',175,'{\"objects\":[{\"id\":\"10781\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":175},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1554#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"15958\",\"windowid\":\"10781\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":43},{\"value\":3},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"24667\",\"windowid\":\"10781\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":9},{\"value\":13},{\"value\":3},{\"value\":\"#1555#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32492\",\"windowid\":\"10781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29518\",\"windowid\":\"10781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":34},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1556#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19483\",\"windowid\":\"10781\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#1557#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27973\",\"windowid\":\"10781\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":4},{\"value\":58},{\"value\":26},{\"value\":3},{\"value\":\"#770#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"24258\",\"windowid\":\"10781\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":5},{\"value\":13},{\"value\":3},{\"value\":\"#1558#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"17487\",\"windowid\":\"10781\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":5},{\"value\":13},{\"value\":3},{\"value\":\"#1558#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31436\",\"windowid\":\"10781\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":15},{\"value\":5},{\"value\":38},{\"value\":33},{\"value\":[{\"v\":38}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"8789\",\"windowid\":\"10781\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":29},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1577#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1097.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1756,0,3134,'SCREEN_PROMPT_CUSTOMER',161,'{\"objects\":[{\"id\":\"4422\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":161},{\"value\":4},{\"value\":5},{\"value\":23},{\"value\":19},{\"value\":\"#1116#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"22480\",\"windowid\":\"4422\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":1},{\"value\":2},{\"value\":21},{\"value\":3},{\"value\":\"#367#\"},{\"value\":[{\"v\":21}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"1085\",\"windowid\":\"4422\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":17},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27335\",\"windowid\":\"4422\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":12},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28647\",\"windowid\":\"4422\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":2},{\"value\":21},{\"value\":3},{\"value\":\"#367#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',1),(1762,0,3128,'SCREEN_CONFIG_ZONES_RET_SERV',11107,'{\"objects\":[{\"id\":\"8517\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":107},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#393#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"13546\",\"windowid\":\"8517\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"11586\",\"windowid\":\"8517\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14353\",\"windowid\":\"8517\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":40},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#394#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21258\",\"windowid\":\"8517\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":14},{\"value\":3},{\"value\":\"#395#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"19232\",\"windowid\":\"8517\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#400#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22093\",\"windowid\":\"8517\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":26},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#405#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12076\",\"windowid\":\"8517\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"30536\",\"windowid\":\"8517\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#397#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"8441\",\"windowid\":\"8517\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#398#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"28485\",\"windowid\":\"8517\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":13},{\"value\":13},{\"value\":26},{\"value\":25},{\"value\":[{\"v\":26}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"28148\",\"windowid\":\"8517\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":40},{\"value\":10},{\"value\":13},{\"value\":24},{\"value\":[{\"v\":13}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4640\",\"windowid\":\"8517\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":40},{\"value\":34},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1643#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1093.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28194\",\"windowid\":\"8517\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":17},{\"value\":40},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#404#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"17659\",\"windowid\":\"8517\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":40},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#404#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29321\",\"windowid\":\"8517\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":22},{\"value\":26},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#1822#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"15234\",\"windowid\":\"8517\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29660\",\"windowid\":\"8517\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14452\",\"windowid\":\"8517\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27494\",\"windowid\":\"8517\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1768,0,3122,'SCREEN_TABLE_EDIT_GUIAS_RETAIL',10054,'\n{\"objects\":[{\"id\":\"12936\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":54},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1747#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"11186\",\"windowid\":\"12936\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":9},{\"value\":37},{\"value\":33},{\"value\":[{\"v\":3},{\"v\":19},{\"v\":3},{\"v\":4},{\"v\":3},{\"v\":4}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"32297\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":7},{\"value\":42},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4244\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26383\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":37},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"30935\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":2},{\"value\":42},{\"value\":5},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"2180\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":64},{\"value\":37},{\"value\":25},{\"value\":16},{\"value\":3},{\"value\":\"#1696#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15458\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":26},{\"value\":42},{\"value\":4},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8778\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":19},{\"value\":42},{\"value\":7},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11645\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":9},{\"value\":42},{\"value\":10},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20690\",\"windowid\":\"12936\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":37},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"25847\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":37},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1867\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":37},{\"value\":10},{\"value\":16},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14455\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":81},{\"value\":37},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32552\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":82},{\"value\":41},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29798\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":83},{\"value\":45},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28906\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":84},{\"value\":37},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32273\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":85},{\"value\":41},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18484\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":86},{\"value\":45},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26612\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":87},{\"value\":37},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21866\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":88},{\"value\":41},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4433\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":45},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20851\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":41},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29563\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":72},{\"value\":37},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27727\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":90},{\"value\":37},{\"value\":28},{\"value\":16},{\"value\":3},{\"value\":\"#1702#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4733\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":49},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1084.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9635\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":30},{\"value\":42},{\"value\":7},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29708\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":92},{\"value\":49},{\"value\":41},{\"value\":4},{\"value\":10},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1085.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26223\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":91},{\"value\":45},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1713#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22237\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":42},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19836\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":93},{\"value\":49},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1083.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30168\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":600},{\"value\":0},{\"value\":0},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"logo.png\"},{\"value\":50},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27724\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":601},{\"value\":37},{\"value\":0},{\"value\":16},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"logo_cliente.png\"},{\"value\":50},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15810\",\"windowid\":\"12936\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":30},{\"value\":46},{\"value\":7},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1831#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"24731\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":126},{\"value\":37},{\"value\":14},{\"value\":16},{\"value\":6},{\"value\":\"#1880#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"24732\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":128},{\"value\":0},{\"value\":3},{\"value\":18},{\"value\":3},{\"value\":\"#1848#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"24733\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":129},{\"value\":0},{\"value\":6},{\"value\":18},{\"value\":3},{\"value\":\"#1849#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"24731\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":120},{\"value\":19},{\"value\":3},{\"value\":18},{\"value\":3},{\"value\":\"#1903#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"20817\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":19},{\"value\":6},{\"value\":18},{\"value\":3},{\"value\":\"#1904#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22177\",\"windowid\":\"12936\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":37},{\"value\":20},{\"value\":16},{\"value\":3},{\"value\":\"#1850#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}\n','0',1),(1777,0,3152,'SCREEN_PROMPT_MANUAL_DOCUMENT',171,'{\"objects\":[{\"id\":\"5303\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":171},{\"value\":4},{\"value\":5},{\"value\":23},{\"value\":19},{\"value\":\"#1264#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"9611\",\"windowid\":\"5303\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":1},{\"value\":2},{\"value\":21},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":21}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"2450\",\"windowid\":\"5303\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":12},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27429\",\"windowid\":\"5303\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":2},{\"value\":21},{\"value\":3},{\"value\":\"#1265#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27108\",\"windowid\":\"5303\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":5},{\"value\":21},{\"value\":3},{\"value\":\"#1266#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24051\",\"windowid\":\"5303\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":8},{\"value\":21},{\"value\":3},{\"value\":\"#1117#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24788\",\"windowid\":\"5303\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":17},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1785,0,3163,'SCREEN_CONFIG_ZONES',107,'{\"objects\":[{\"id\":\"17206\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":107},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#393#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"576\",\"windowid\":\"17206\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"7382\",\"windowid\":\"17206\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20328\",\"windowid\":\"17206\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":40},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#394#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21602\",\"windowid\":\"17206\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":25},{\"value\":4},{\"value\":14},{\"value\":3},{\"value\":\"#395#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"17490\",\"windowid\":\"17206\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":26},{\"value\":8},{\"value\":13},{\"value\":3},{\"value\":\"#396#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14615\",\"windowid\":\"17206\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#400#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2428\",\"windowid\":\"17206\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":26},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#405#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22242\",\"windowid\":\"17206\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"4828\",\"windowid\":\"17206\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":13},{\"value\":8},{\"value\":12},{\"value\":3},{\"value\":\"#397#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"4768\",\"windowid\":\"17206\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":11},{\"value\":12},{\"value\":3},{\"value\":\"#398#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"22448\",\"windowid\":\"17206\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":13},{\"value\":15},{\"value\":26},{\"value\":23},{\"value\":[{\"v\":26}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"23834\",\"windowid\":\"17206\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":40},{\"value\":15},{\"value\":13},{\"value\":19},{\"value\":[{\"v\":13}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"10750\",\"windowid\":\"17206\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":40},{\"value\":34},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1643#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1093.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23323\",\"windowid\":\"17206\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":17},{\"value\":40},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#404#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"13015\",\"windowid\":\"17206\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":40},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#404#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4892\",\"windowid\":\"17206\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"465\",\"windowid\":\"17206\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30033\",\"windowid\":\"17206\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20837\",\"windowid\":\"17206\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31007\",\"windowid\":\"17206\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":22},{\"value\":40},{\"value\":8},{\"value\":13},{\"value\":3},{\"value\":\"#1822#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]}]}','0',1),(1789,0,3166,'SCREEN_DESKTOP',1,'{\"objects\":[{\"id\":\"18812\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#240#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":1}]},{\"id\":\"24110\",\"windowid\":\"18812\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":0},{\"value\":47},{\"value\":27},{\"value\":4},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":-1}]}]}','4',3),(1792,0,3169,'SCREEN_TABLE_DISCOUNTS',136,'{\"objects\":[{\"id\":\"2255\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":136},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":45},{\"value\":\"#571#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"24177\",\"windowid\":\"2255\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":14},{\"value\":0},{\"value\":51},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"1583\",\"windowid\":\"2255\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":14},{\"value\":28},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2805\",\"windowid\":\"2255\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":15},{\"value\":4},{\"value\":14},{\"value\":3},{\"value\":\"#898#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26318\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":60},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14900\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":55},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23266\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":19},{\"value\":0},{\"value\":39},{\"value\":14},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#899#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31018\",\"windowid\":\"2255\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":15},{\"value\":20},{\"value\":14},{\"value\":3},{\"value\":\"#900#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27278\",\"windowid\":\"2255\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":20},{\"value\":8},{\"value\":4},{\"value\":3},{\"value\":\"#901#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2591\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":15},{\"value\":8},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#902#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1761\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":24},{\"value\":8},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#903#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6697\",\"windowid\":\"2255\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":20},{\"value\":12},{\"value\":4},{\"value\":3},{\"value\":\"#574#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12248\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":15},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#904#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31653\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":24},{\"value\":12},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#905#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16230\",\"windowid\":\"2255\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":20},{\"value\":23},{\"value\":4},{\"value\":3},{\"value\":\"#914#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21912\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":22},{\"value\":15},{\"value\":23},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#915#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10706\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":23},{\"value\":24},{\"value\":23},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#916#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30498\",\"windowid\":\"2255\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":0},{\"value\":0},{\"value\":14},{\"value\":3},{\"value\":\"#922#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"17897\",\"windowid\":\"2255\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":0},{\"value\":33},{\"value\":14},{\"value\":3},{\"value\":\"#923#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14174\",\"windowid\":\"2255\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":0},{\"value\":36},{\"value\":14},{\"value\":3},{\"value\":\"#924#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"979\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":0},{\"value\":56},{\"value\":65},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19812\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":65},{\"value\":56},{\"value\":65},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28564\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":24},{\"value\":31},{\"value\":12},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#906#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10574\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":25},{\"value\":34},{\"value\":12},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#907#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1142\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":26},{\"value\":37},{\"value\":12},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#908#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24170\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":27},{\"value\":40},{\"value\":12},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#909#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16631\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":28},{\"value\":43},{\"value\":12},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#910#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28677\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":46},{\"value\":12},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1079#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9965\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":29},{\"value\":31},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#917#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7531\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":30},{\"value\":34},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#918#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29181\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":31},{\"value\":37},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#919#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28437\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":32},{\"value\":40},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#920#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24216\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":33},{\"value\":43},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#921#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5659\",\"windowid\":\"2255\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":46},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1080#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','5',2),(1799,0,3189,'SCREEN_CONFIG_DAILY_JOURNAL_SERVICES_FULL',11323,'{\"objects\":[{\"id\":\"18228\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":123},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#520#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"1811\",\"windowid\":\"18228\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":18},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"7764\",\"windowid\":\"18228\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":18},{\"value\":38},{\"value\":[{\"v\":5},{\"v\":4},{\"v\":5},{\"v\":4}]},{\"value\":\"#1791#\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"21475\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":26},{\"value\":8},{\"value\":3},{\"value\":\"#760#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"368\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":13},{\"value\":16},{\"value\":3},{\"value\":\"#526#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"3469\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":1},{\"value\":32},{\"value\":8},{\"value\":3},{\"value\":\"#761#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"27800\",\"windowid\":\"18228\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":40},{\"value\":10},{\"value\":13},{\"value\":31},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"#1792#\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"16450\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":40},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#529#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16918\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":40},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#531#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6292\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":22},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#534#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18906\",\"windowid\":\"18228\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":48},{\"value\":42},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#535#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32183\",\"windowid\":\"18228\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":43},{\"value\":42},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6470\",\"windowid\":\"18228\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":15},{\"value\":6},{\"value\":42},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#755#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1063.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13972\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":9},{\"value\":32},{\"value\":8},{\"value\":3},{\"value\":\"#763#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"3687\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":9},{\"value\":26},{\"value\":8},{\"value\":3},{\"value\":\"#764#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"14507\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":29},{\"value\":16},{\"value\":3},{\"value\":\"#528#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"8663\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":23},{\"value\":16},{\"value\":3},{\"value\":\"#768#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"30427\",\"windowid\":\"18228\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":17},{\"value\":0},{\"value\":42},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#765#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1043.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11491\",\"windowid\":\"18228\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":22},{\"value\":24},{\"value\":17},{\"value\":17},{\"value\":[{\"v\":7},{\"v\":5}]},{\"value\":\"#1774#\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"30595\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":4},{\"value\":58},{\"value\":26},{\"value\":3},{\"value\":\"#770#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"28071\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":26},{\"value\":18},{\"value\":0},{\"value\":35},{\"value\":3},{\"value\":\"#771#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"29855\",\"windowid\":\"18228\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":10},{\"value\":16},{\"value\":3},{\"value\":\"#525#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"8508\",\"windowid\":\"18228\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":16},{\"value\":16},{\"value\":3},{\"value\":\"#527#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"7624\",\"windowid\":\"18228\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":25},{\"value\":1},{\"value\":19},{\"value\":16},{\"value\":3},{\"value\":\"#865#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"3119\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":22},{\"value\":7},{\"value\":17},{\"value\":3},{\"value\":\"#822#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4931\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":30},{\"value\":22},{\"value\":10},{\"value\":17},{\"value\":3},{\"value\":\"#1465#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19420\",\"windowid\":\"18228\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":33},{\"value\":38},{\"value\":42},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1793#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10885\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":36},{\"value\":1},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#1801#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"24411\",\"windowid\":\"18228\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":37},{\"value\":1},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#1800#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"20438\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":35},{\"value\":1},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#1800#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"3363\",\"windowid\":\"18228\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13809\",\"windowid\":\"18228\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"12952\",\"windowid\":\"18228\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":33},{\"value\":42},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1853#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19421\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":40},{\"value\":22},{\"value\":20},{\"value\":17},{\"value\":3},{\"value\":\"#1854#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13588\",\"windowid\":\"18228\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":42},{\"value\":22},{\"value\":17},{\"value\":17},{\"value\":3},{\"value\":\"#1857#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29262\",\"windowid\":\"18228\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":39},{\"value\":22},{\"value\":14},{\"value\":17},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1902#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1800,0,3188,'SCREEN_CONFIG_DAILY_JOURNAL_SERVICES',11123,'{\"objects\":[{\"id\":\"12856\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":123},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#520#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"3540\",\"windowid\":\"12856\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":18},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"22618\",\"windowid\":\"12856\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":18},{\"value\":35},{\"value\":[{\"v\":5},{\"v\":4},{\"v\":5},{\"v\":4}]},{\"value\":\"#1791#\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"2542\",\"windowid\":\"12856\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1582\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":26},{\"value\":8},{\"value\":3},{\"value\":\"#760#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"20776\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":13},{\"value\":16},{\"value\":3},{\"value\":\"#526#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"6398\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":1},{\"value\":32},{\"value\":8},{\"value\":3},{\"value\":\"#761#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"20318\",\"windowid\":\"12856\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":40},{\"value\":10},{\"value\":13},{\"value\":24},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"#1792#\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"10758\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":40},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#529#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27242\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":40},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#531#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6938\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":22},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#534#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19108\",\"windowid\":\"12856\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":48},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#535#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29091\",\"windowid\":\"12856\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":43},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11394\",\"windowid\":\"12856\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":15},{\"value\":6},{\"value\":39},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#755#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1063.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14915\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":9},{\"value\":32},{\"value\":8},{\"value\":3},{\"value\":\"#763#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"11281\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":9},{\"value\":26},{\"value\":8},{\"value\":3},{\"value\":\"#764#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"17126\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":29},{\"value\":16},{\"value\":3},{\"value\":\"#528#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"16733\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":23},{\"value\":16},{\"value\":3},{\"value\":\"#768#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"9736\",\"windowid\":\"12856\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":17},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#765#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1043.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7431\",\"windowid\":\"12856\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":22},{\"value\":24},{\"value\":17},{\"value\":10},{\"value\":[{\"v\":7},{\"v\":5}]},{\"value\":\"#1774#\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"14708\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":4},{\"value\":58},{\"value\":26},{\"value\":3},{\"value\":\"#770#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"20122\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":26},{\"value\":18},{\"value\":0},{\"value\":35},{\"value\":3},{\"value\":\"#771#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"17364\",\"windowid\":\"12856\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":10},{\"value\":16},{\"value\":3},{\"value\":\"#525#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"10836\",\"windowid\":\"12856\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":16},{\"value\":16},{\"value\":3},{\"value\":\"#527#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"14266\",\"windowid\":\"12856\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":25},{\"value\":1},{\"value\":19},{\"value\":16},{\"value\":3},{\"value\":\"#865#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"21126\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":22},{\"value\":7},{\"value\":17},{\"value\":3},{\"value\":\"#822#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26646\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":30},{\"value\":22},{\"value\":10},{\"value\":17},{\"value\":3},{\"value\":\"#1465#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10430\",\"windowid\":\"12856\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":33},{\"value\":38},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1793#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2351\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":36},{\"value\":1},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#1801#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"19787\",\"windowid\":\"12856\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":37},{\"value\":1},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#1800#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"10910\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":35},{\"value\":1},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#1800#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"18399\",\"windowid\":\"12856\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":33},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1853#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31193\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":40},{\"value\":22},{\"value\":20},{\"value\":17},{\"value\":3},{\"value\":\"#1854#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2660\",\"windowid\":\"12856\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":42},{\"value\":22},{\"value\":17},{\"value\":17},{\"value\":3},{\"value\":\"#1857#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23114\",\"windowid\":\"12856\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":39},{\"value\":22},{\"value\":14},{\"value\":17},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1902#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1821,0,3221,'SCREEN_CONFIG_CUSTOMERS',106,'  {\"objects\":[{\"id\":\"18520\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":106},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#365#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"24519\",\"windowid\":\"18520\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"15351\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":10},{\"value\":27},{\"value\":3},{\"value\":\"#366#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20319\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#367#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12014\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":13},{\"value\":27},{\"value\":3},{\"value\":\"#368#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"19933\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":26},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#369#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22375\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":26},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#370#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27191\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#371#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15405\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":40},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#372#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7436\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":26},{\"value\":25},{\"value\":27},{\"value\":3},{\"value\":\"#373#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21594\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":40},{\"value\":22},{\"value\":13},{\"value\":3},{\"value\":\"#374#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"17952\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":34},{\"value\":13},{\"value\":19},{\"value\":3},{\"value\":\"#375#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"31085\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":34},{\"value\":4},{\"value\":19},{\"value\":3},{\"value\":\"#376#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"5785\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":34},{\"value\":7},{\"value\":19},{\"value\":3},{\"value\":\"#377#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"26385\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":22},{\"value\":34},{\"value\":10},{\"value\":19},{\"value\":3},{\"value\":\"#379#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"22054\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":26},{\"value\":26},{\"value\":31},{\"value\":27},{\"value\":7},{\"value\":\"#381#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"7709\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":25},{\"value\":13},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"#382#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"8837\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":26},{\"value\":22},{\"value\":13},{\"value\":3},{\"value\":\"#383#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27798\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#384#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1018\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":26},{\"value\":28},{\"value\":27},{\"value\":3},{\"value\":\"#385#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"10935\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#386#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18100\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":13},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#387#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32080\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":20},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#388#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"18489\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#389#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12275\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":34},{\"value\":16},{\"value\":19},{\"value\":3},{\"value\":\"#390#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"8526\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":27},{\"value\":20},{\"value\":20},{\"value\":33},{\"value\":10},{\"value\":\"#391#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"3540\",\"windowid\":\"18520\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":16},{\"value\":20},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#392#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"6129\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":28},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"#519#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"5692\",\"windowid\":\"18520\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"25190\",\"windowid\":\"18520\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"4606\",\"windowid\":\"18520\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":24},{\"value\":13},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#380#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"19298\",\"windowid\":\"18520\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":23},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#378#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"31072\",\"windowid\":\"18520\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2265\",\"windowid\":\"18520\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22082\",\"windowid\":\"18520\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":14},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2081#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22081\",\"windowid\":\"18520\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25089\",\"windowid\":\"18520\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},  {\"id\":\"27787\",\"windowid\":\"18520\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":13},{\"value\":35},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#2084#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},  {\"id\":\"27788\",\"windowid\":\"18520\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":40},{\"value\":13},{\"value\":25},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#2095#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]}, {\"id\":\"27787\",\"windowid\":\"18520\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":30},{\"value\":20},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1919#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]}]}','0',1),(1829,0,3235,'SCREEN_NEW_CLIENT',150,'{\"objects\":[{\"id\":\"16093\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":150},{\"value\":4},{\"value\":8},{\"value\":23},{\"value\":38},{\"value\":\"#986#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"12867\",\"windowid\":\"16093\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":17},{\"value\":31},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32448\",\"windowid\":\"16093\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":12},{\"value\":31},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17197\",\"windowid\":\"16093\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":5},{\"value\":21},{\"value\":3},{\"value\":\"#987#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24169\",\"windowid\":\"16093\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":2},{\"value\":21},{\"value\":3},{\"value\":\"#988#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24729\",\"windowid\":\"16093\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":8},{\"value\":21},{\"value\":3},{\"value\":\"#1133#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30226\",\"windowid\":\"16093\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":11},{\"value\":21},{\"value\":3},{\"value\":\"#1134#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23162\",\"windowid\":\"16093\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":14},{\"value\":12},{\"value\":3},{\"value\":\"#989#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5111\",\"windowid\":\"16093\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":14},{\"value\":9},{\"value\":3},{\"value\":\"#1135#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29648\",\"windowid\":\"16093\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":1},{\"value\":17},{\"value\":21},{\"value\":3},{\"value\":\"#1136#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11782\",\"windowid\":\"16093\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":1},{\"value\":20},{\"value\":12},{\"value\":3},{\"value\":\"#1781#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4606\",\"windowid\":\"16093\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":23},{\"value\":1},{\"value\":23},{\"value\":12},{\"value\":3},{\"value\":\"Grupo\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"11782\",\"windowid\":\"16095\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":13},{\"value\":23},{\"value\":9},{\"value\":3},{\"value\":\"Cartao\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13842\",\"windowid\":\"16093\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":10},{\"value\":13},{\"value\":20},{\"value\":9},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1919#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13843\",\"windowid\":\"16093\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":30},{\"value\":1},{\"value\":26},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#2095#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1837,0,3242,'SCREEN_TABLE_CLOSE_RETAIL_GUIAS',10512,'{\"objects\":[{\"id\":\"19993\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":12},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#262#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"26209\",\"windowid\":\"19993\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24658\",\"windowid\":\"19993\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14994\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":125},{\"value\":10},{\"value\":22},{\"value\":18},{\"value\":3},{\"value\":\"#1903#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25158\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":10},{\"value\":25},{\"value\":18},{\"value\":3},{\"value\":\"#1904#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23486\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":10},{\"value\":28},{\"value\":27},{\"value\":3},{\"value\":\"#1878#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8651\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":123},{\"value\":10},{\"value\":32},{\"value\":35},{\"value\":3},{\"value\":\"#1879#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27571\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":124},{\"value\":10},{\"value\":35},{\"value\":35},{\"value\":3},{\"value\":\"#1880#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24449\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":126},{\"value\":28},{\"value\":22},{\"value\":17},{\"value\":3},{\"value\":\"#1876#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24179\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":127},{\"value\":28},{\"value\":25},{\"value\":17},{\"value\":3},{\"value\":\"#1877#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9661\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":10},{\"value\":40},{\"value\":13},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18929\",\"windowid\":\"19993\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":34},{\"value\":40},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#275#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}{\"objects\":[{\"id\":\"19993\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":12},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#262#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"26209\",\"windowid\":\"19993\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24658\",\"windowid\":\"19993\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14994\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":125},{\"value\":10},{\"value\":22},{\"value\":18},{\"value\":3},{\"value\":\"#1903#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25158\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":10},{\"value\":25},{\"value\":18},{\"value\":3},{\"value\":\"#1904#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23486\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":10},{\"value\":28},{\"value\":27},{\"value\":3},{\"value\":\"#1878#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8651\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":123},{\"value\":10},{\"value\":32},{\"value\":35},{\"value\":3},{\"value\":\"#1879#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27571\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":124},{\"value\":10},{\"value\":35},{\"value\":35},{\"value\":3},{\"value\":\"#1880#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24449\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":126},{\"value\":28},{\"value\":22},{\"value\":17},{\"value\":3},{\"value\":\"#1876#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24179\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":127},{\"value\":28},{\"value\":25},{\"value\":17},{\"value\":3},{\"value\":\"#1877#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9661\",\"windowid\":\"19993\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":10},{\"value\":40},{\"value\":13},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18929\",\"windowid\":\"19993\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":34},{\"value\":40},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#275#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1847,0,3259,'SCREEN_CASHIER_CLOSE',131,'{\"objects\":[{\"id\":\"5050\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":131},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#932#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"17867\",\"windowid\":\"5050\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":2},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"10189\",\"windowid\":\"5050\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":35},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#940#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20247\",\"windowid\":\"5050\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":21},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3957\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"4380\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":0},{\"value\":26},{\"value\":12},{\"value\":3},{\"value\":\"#941#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21397\",\"windowid\":\"5050\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18125\",\"windowid\":\"5050\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":31},{\"value\":[{\"v\":7},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"19054\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":13},{\"value\":35},{\"value\":12},{\"value\":3},{\"value\":\"#945#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16409\",\"windowid\":\"5050\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":0},{\"value\":30},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1073#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21535\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":83342},{\"value\":26},{\"value\":8},{\"value\":26},{\"value\":3},{\"value\":\"#1932#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5354\",\"windowid\":\"5050\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":26},{\"value\":4},{\"value\":11},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1933#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2081\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":123437},{\"value\":26},{\"value\":19},{\"value\":26},{\"value\":3},{\"value\":\"#1934#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18723\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":26},{\"value\":11},{\"value\":5},{\"value\":3},{\"value\":\"#1935#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17367\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":26},{\"value\":14},{\"value\":5},{\"value\":3},{\"value\":\"#1936#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12673\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":32},{\"value\":11},{\"value\":5},{\"value\":3},{\"value\":\"#1937#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19044\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":32},{\"value\":14},{\"value\":5},{\"value\":3},{\"value\":\"#1938#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10376\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":38},{\"value\":11},{\"value\":5},{\"value\":3},{\"value\":\"#1939#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26724\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":38},{\"value\":14},{\"value\":5},{\"value\":3},{\"value\":\"#1940#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23530\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":44},{\"value\":11},{\"value\":5},{\"value\":3},{\"value\":\"#1941#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25148\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":44},{\"value\":14},{\"value\":5},{\"value\":3},{\"value\":\"#1942#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32260\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":26},{\"value\":22},{\"value\":5},{\"value\":3},{\"value\":\"#1943#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27167\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":26},{\"value\":25},{\"value\":5},{\"value\":3},{\"value\":\"#1944#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17511\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":32},{\"value\":22},{\"value\":5},{\"value\":3},{\"value\":\"#1945#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"757\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":32},{\"value\":25},{\"value\":5},{\"value\":3},{\"value\":\"#1946#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9096\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":22},{\"value\":38},{\"value\":22},{\"value\":5},{\"value\":3},{\"value\":\"#1947#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8138\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":23},{\"value\":38},{\"value\":25},{\"value\":5},{\"value\":3},{\"value\":\"#1948#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30983\",\"windowid\":\"5050\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":44},{\"value\":22},{\"value\":5},{\"value\":3},{\"value\":\"#1949#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2930\",\"windowid\":\"5050\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":26},{\"value\":29},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1950#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2930\",\"windowid\":\"5050\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":25},{\"value\":47},{\"value\":33},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Ler CashDro\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1848,0,3267,'SCREEN_TABLE_PRODUCT_TRANSF',138,'{\"objects\":[{\"id\":\"11086\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":138},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#573#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"19996\",\"windowid\":\"11086\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":47},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"Seleccione Mesa Destino|Seleccione Artigos a Transferir\"}]},{\"id\":\"196\",\"windowid\":\"11086\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":7},{\"value\":12},{\"value\":40},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4421\",\"windowid\":\"11086\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#597#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"14664\",\"windowid\":\"11086\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31704\",\"windowid\":\"11086\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":103},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28369\",\"windowid\":\"11086\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":19},{\"value\":7},{\"value\":12},{\"value\":32},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"26269\",\"windowid\":\"11086\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":15},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"19204\",\"windowid\":\"11086\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":13},{\"value\":20},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"16538\",\"windowid\":\"11086\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":25},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"9444\",\"windowid\":\"11086\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":13},{\"value\":30},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"24728\",\"windowid\":\"11086\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":19},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#756#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"3254\",\"windowid\":\"11086\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":102},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":43},{\"value\":7},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":0}]},{\"id\":\"24538\",\"windowid\":\"11086\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":12},{\"value\":43},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":-1},{\"value\":102},{\"value\":0}]},{\"id\":\"16485\",\"windowid\":\"11086\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#756#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12173\",\"windowid\":\"11086\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":5},{\"value\":3},{\"value\":\"#767#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"5036\",\"windowid\":\"11086\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":25},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"26297\",\"windowid\":\"11086\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":19},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"29381\",\"windowid\":\"11086\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":19},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#598#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":1}]}]}','0',1),(1853,0,3285,'SCREEN_SAGE_IVA',169,'{\"objects\":[{\"id\":\"12807\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":169},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1213#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"10613\",\"windowid\":\"12807\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":6},{\"value\":12},{\"value\":32},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"29080\",\"windowid\":\"12807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Sair\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"475\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":2},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"31552\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":40},{\"value\":35},{\"value\":12},{\"value\":3},{\"value\":\"#1191#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"9207\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":40},{\"value\":23},{\"value\":12},{\"value\":3},{\"value\":\"#1192#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28880\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":40},{\"value\":26},{\"value\":12},{\"value\":3},{\"value\":\"#1193#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25656\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":40},{\"value\":29},{\"value\":12},{\"value\":3},{\"value\":\"#1194#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12118\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":40},{\"value\":32},{\"value\":12},{\"value\":3},{\"value\":\"#1195#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1128\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":40},{\"value\":20},{\"value\":12},{\"value\":3},{\"value\":\"#1196#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11937\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":13},{\"value\":23},{\"value\":12},{\"value\":3},{\"value\":\"#1197#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3485\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":13},{\"value\":26},{\"value\":12},{\"value\":3},{\"value\":\"#1198#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2531\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":29},{\"value\":12},{\"value\":3},{\"value\":\"#1199#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29390\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":13},{\"value\":32},{\"value\":12},{\"value\":3},{\"value\":\"#1200#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25222\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":35},{\"value\":12},{\"value\":3},{\"value\":\"#1201#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2277\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":20},{\"value\":12},{\"value\":3},{\"value\":\"#1202#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"5731\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":26},{\"value\":23},{\"value\":12},{\"value\":3},{\"value\":\"#1203#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2180\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":26},{\"value\":26},{\"value\":12},{\"value\":3},{\"value\":\"#1204#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"19714\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":26},{\"value\":29},{\"value\":12},{\"value\":3},{\"value\":\"#1205#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11994\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":26},{\"value\":32},{\"value\":12},{\"value\":3},{\"value\":\"#1206#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15244\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":26},{\"value\":35},{\"value\":12},{\"value\":3},{\"value\":\"#1207#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32314\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":26},{\"value\":20},{\"value\":12},{\"value\":3},{\"value\":\"#1208#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15762\",\"windowid\":\"12807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":40},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1210#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"25685\",\"windowid\":\"12807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":26},{\"value\":39},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1211#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4318\",\"windowid\":\"12807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":23},{\"value\":13},{\"value\":39},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1214#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31549\",\"windowid\":\"12807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":25},{\"value\":40},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1215#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"13536\",\"windowid\":\"12807\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":55},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"Iva Ori.1\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"934\",\"windowid\":\"12807\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":56},{\"value\":26},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"Novo Iva 1\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"12922\",\"windowid\":\"12807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":9},{\"value\":12},{\"value\":3},{\"value\":\"#1979#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27129\",\"windowid\":\"12807\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":57},{\"value\":13},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"Iva Ori.2\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"30521\",\"windowid\":\"12807\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":58},{\"value\":26},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"Novo Iva 2\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},  {\"id\":\"30006\",\"windowid\":\"12807\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":61},{\"value\":13},{\"value\":2},{\"value\":12},{\"value\":3},{\"value\":\"Familia\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},  {\"id\":\"29081\",\"windowid\":\"12807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":62},{\"value\":42},{\"value\":8},{\"value\":9},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Aplica Taxas a Familia\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},  {\"id\":\"30005\",\"windowid\":\"12807\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":59},{\"value\":26},{\"value\":5},{\"value\":12},{\"value\":3},{\"value\":\"Iva Ori.2\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"1847\",\"windowid\":\"12807\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":60},{\"value\":39},{\"value\":5},{\"value\":12},{\"value\":3},{\"value\":\"Novo Iva 2\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"30025\",\"windowid\":\"12827\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":109},{\"value\":26},{\"value\":2},{\"value\":12},{\"value\":3},{\"value\":\"Iva Ori.1\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"1847\",\"windowid\":\"12807\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":160},{\"value\":39},{\"value\":2},{\"value\":12},{\"value\":3},{\"value\":\"Novo Iva1\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]}]}','0',1),(1854,0,3288,'SCREEN_ITEM_MENU_SELECTION',159,'{\"objects\":[{\"id\":\"29443\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":159},{\"value\":0},{\"value\":0},{\"value\":50},{\"value\":42},{\"value\":\"#1110#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"22727\",\"windowid\":\"29443\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":301},{\"value\":1},{\"value\":6},{\"value\":35},{\"value\":33},{\"value\":6},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11399\",\"windowid\":\"29443\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":44},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22356\",\"windowid\":\"29443\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":41},{\"value\":2},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1111#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1332\",\"windowid\":\"29443\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":17},{\"value\":2},{\"value\":16},{\"value\":3},{\"value\":\"#1112#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20332\",\"windowid\":\"29443\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":37},{\"value\":35},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1113#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6444\",\"windowid\":\"29443\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":2},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1114#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5860\",\"windowid\":\"29443\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":37},{\"value\":6},{\"value\":12},{\"value\":29},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',1),(1861,0,3313,'SCREEN_SALESMAN_SELECTION',2,'{\"objects\":[{\"id\":\"9369\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":2},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#245#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"18674\",\"windowid\":\"9369\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":101},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":47},{\"value\":9},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32092\",\"windowid\":\"9369\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28782\",\"windowid\":\"9369\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1872,0,3344,'SCREEN_MOVEMENTS_PRINT_SERVICES',11155,'{\"objects\":[{\"id\":\"20007\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":155},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1022#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"21270\",\"windowid\":\"20007\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":16},{\"value\":4},{\"value\":22},{\"value\":29},{\"value\":[{\"v\":8},{\"v\":10},{\"v\":5}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26713\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":1},{\"value\":28},{\"value\":6},{\"value\":3},{\"value\":\"#1023#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31182\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":16},{\"value\":6},{\"value\":3},{\"value\":\"#1024#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22884\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":22},{\"value\":6},{\"value\":3},{\"value\":\"#1025#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10161\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":39},{\"value\":7},{\"value\":14},{\"value\":3},{\"value\":\"#1026#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15050\",\"windowid\":\"20007\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":15},{\"value\":6},{\"value\":34},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1027#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1063.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30700\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":8},{\"value\":28},{\"value\":6},{\"value\":3},{\"value\":\"#1028#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19444\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":8},{\"value\":22},{\"value\":6},{\"value\":3},{\"value\":\"#1029#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8581\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":8},{\"value\":16},{\"value\":6},{\"value\":3},{\"value\":\"#1030#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4098\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":25},{\"value\":13},{\"value\":3},{\"value\":\"#1031#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2672\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#1032#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20260\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#1033#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5117\",\"windowid\":\"20007\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":14},{\"value\":1},{\"value\":34},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1034#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1043.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16327\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":4},{\"value\":58},{\"value\":26},{\"value\":3},{\"value\":\"#770#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"29652\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":15},{\"value\":0},{\"value\":38},{\"value\":3},{\"value\":\"#1035#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"32283\",\"windowid\":\"20007\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":13},{\"value\":39},{\"value\":34},{\"value\":14},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1036#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1097.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17901\",\"windowid\":\"20007\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#1037#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"27827\",\"windowid\":\"20007\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#1038#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"10014\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":0},{\"value\":15},{\"value\":3},{\"value\":\"#1039#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"12120\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":39},{\"value\":10},{\"value\":14},{\"value\":3},{\"value\":\"#1040#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25904\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":39},{\"value\":16},{\"value\":14},{\"value\":3},{\"value\":\"#1041#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14659\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":39},{\"value\":13},{\"value\":14},{\"value\":3},{\"value\":\"#1042#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30886\",\"windowid\":\"20007\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":17},{\"value\":1},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#1043#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"29275\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":39},{\"value\":19},{\"value\":14},{\"value\":14},{\"value\":\"#1044#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23952\",\"windowid\":\"20007\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":39},{\"value\":4},{\"value\":14},{\"value\":3},{\"value\":\"#1045#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21290\",\"windowid\":\"20007\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":19},{\"value\":16},{\"value\":34},{\"value\":22},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1710#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19487\",\"windowid\":\"20007\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1873,0,3343,'SCREEN_MOVEMENTS_PRINT',155,'{\"objects\":[{\"id\":\"10943\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":155},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1022#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"24508\",\"windowid\":\"10943\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":15},{\"value\":4},{\"value\":23},{\"value\":29},{\"value\":[{\"v\":8},{\"v\":10},{\"v\":6}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22312\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":1},{\"value\":28},{\"value\":6},{\"value\":3},{\"value\":\"#1023#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15085\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":16},{\"value\":6},{\"value\":3},{\"value\":\"#1024#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18925\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":22},{\"value\":6},{\"value\":3},{\"value\":\"#1025#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25778\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":39},{\"value\":7},{\"value\":14},{\"value\":3},{\"value\":\"#1026#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6401\",\"windowid\":\"10943\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":15},{\"value\":6},{\"value\":34},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1027#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1063.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6766\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":8},{\"value\":28},{\"value\":6},{\"value\":3},{\"value\":\"#1028#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30349\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":8},{\"value\":22},{\"value\":6},{\"value\":3},{\"value\":\"#1029#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20138\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":8},{\"value\":16},{\"value\":6},{\"value\":3},{\"value\":\"#1030#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6102\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":25},{\"value\":13},{\"value\":3},{\"value\":\"#1031#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17139\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#1032#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31787\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#1033#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30091\",\"windowid\":\"10943\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":14},{\"value\":1},{\"value\":34},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1034#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1043.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23619\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":4},{\"value\":58},{\"value\":26},{\"value\":3},{\"value\":\"#770#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"10690\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":15},{\"value\":0},{\"value\":38},{\"value\":3},{\"value\":\"#1035#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"3524\",\"windowid\":\"10943\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":13},{\"value\":39},{\"value\":34},{\"value\":14},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1036#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1097.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18415\",\"windowid\":\"10943\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#1037#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"17351\",\"windowid\":\"10943\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#1038#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"31333\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":0},{\"value\":15},{\"value\":3},{\"value\":\"#1039#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"7305\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":39},{\"value\":10},{\"value\":14},{\"value\":3},{\"value\":\"#1040#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22230\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":39},{\"value\":16},{\"value\":14},{\"value\":3},{\"value\":\"#1041#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11699\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":39},{\"value\":13},{\"value\":14},{\"value\":3},{\"value\":\"#1042#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8192\",\"windowid\":\"10943\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":17},{\"value\":1},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#1043#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"3040\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":39},{\"value\":19},{\"value\":14},{\"value\":10},{\"value\":\"#1044#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18843\",\"windowid\":\"10943\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":39},{\"value\":4},{\"value\":14},{\"value\":3},{\"value\":\"#1045#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28486\",\"windowid\":\"10943\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":19},{\"value\":15},{\"value\":34},{\"value\":22},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1710#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30945\",\"windowid\":\"10943\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26284\",\"windowid\":\"10943\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":20},{\"value\":39},{\"value\":30},{\"value\":14},{\"value\":3},{\"value\":\"#2000#\"},{\"value\":[{\"v\":14}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]}]}','0',1),(1885,0,3350,'SCREEN_CONFIG_DEVICES',139,'{\"objects\":[{\"id\":\"18175\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":139},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#687#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"12973\",\"windowid\":\"18175\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":8},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"8708\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24328\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24661\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26386\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#689#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1095.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22493\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1096.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18342\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#690#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32321\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#691#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9020\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#692#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2522\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#693#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1412\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"13160\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":13},{\"value\":17},{\"value\":12},{\"value\":3},{\"value\":\"#694#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"30921\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":112},{\"value\":31},{\"value\":23},{\"value\":20},{\"value\":3},{\"value\":\"#701#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"26218\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":113},{\"value\":31},{\"value\":26},{\"value\":10},{\"value\":3},{\"value\":\"#702#\"},{\"value\":[{\"v\":10}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"9062\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":114},{\"value\":41},{\"value\":26},{\"value\":10},{\"value\":3},{\"value\":\"#703#\"},{\"value\":[{\"v\":10}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"23882\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":115},{\"value\":41},{\"value\":29},{\"value\":10},{\"value\":3},{\"value\":\"#704#\"},{\"value\":[{\"v\":10}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"5579\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":116},{\"value\":31},{\"value\":29},{\"value\":10},{\"value\":3},{\"value\":\"#705#\"},{\"value\":[{\"v\":10}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"20401\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":0},{\"value\":60},{\"value\":53},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#688#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30194\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":53},{\"value\":60},{\"value\":53},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#688#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19654\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":106},{\"value\":60},{\"value\":53},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#688#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23345\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":159},{\"value\":59},{\"value\":53},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#688#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26666\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":212},{\"value\":59},{\"value\":53},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#688#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1474\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":265},{\"value\":59},{\"value\":53},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#688#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22496\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":317},{\"value\":59},{\"value\":53},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#688#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14211\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":107},{\"value\":31},{\"value\":7},{\"value\":20},{\"value\":3},{\"value\":\"#696#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"21137\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":111},{\"value\":31},{\"value\":20},{\"value\":20},{\"value\":3},{\"value\":\"#698#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"24504\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":110},{\"value\":31},{\"value\":17},{\"value\":20},{\"value\":3},{\"value\":\"#699#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"14531\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":106},{\"value\":31},{\"value\":4},{\"value\":20},{\"value\":3},{\"value\":\"#695#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"6611\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":108},{\"value\":31},{\"value\":10},{\"value\":20},{\"value\":3},{\"value\":\"#697#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"10496\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":207},{\"value\":31},{\"value\":7},{\"value\":20},{\"value\":3},{\"value\":\"#696#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"16273\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":211},{\"value\":31},{\"value\":20},{\"value\":20},{\"value\":3},{\"value\":\"#698#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"24066\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":210},{\"value\":31},{\"value\":17},{\"value\":20},{\"value\":3},{\"value\":\"#699#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":2},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"4336\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":206},{\"value\":31},{\"value\":4},{\"value\":20},{\"value\":3},{\"value\":\"#695#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":2},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"28504\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":208},{\"value\":31},{\"value\":10},{\"value\":20},{\"value\":3},{\"value\":\"#697#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":2},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"18621\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":307},{\"value\":31},{\"value\":7},{\"value\":20},{\"value\":3},{\"value\":\"#696#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"4131\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":311},{\"value\":31},{\"value\":20},{\"value\":20},{\"value\":3},{\"value\":\"#697#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"27356\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":310},{\"value\":31},{\"value\":17},{\"value\":20},{\"value\":3},{\"value\":\"#699#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":3},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"1250\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":306},{\"value\":31},{\"value\":4},{\"value\":20},{\"value\":3},{\"value\":\"#695#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":3},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"16750\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":308},{\"value\":31},{\"value\":10},{\"value\":20},{\"value\":3},{\"value\":\"#697#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":3},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"4190\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":407},{\"value\":31},{\"value\":7},{\"value\":20},{\"value\":3},{\"value\":\"#696#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":4}]},{\"id\":\"26752\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":410},{\"value\":31},{\"value\":17},{\"value\":20},{\"value\":3},{\"value\":\"#699#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":4},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"22838\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":406},{\"value\":31},{\"value\":4},{\"value\":20},{\"value\":3},{\"value\":\"#695#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":4},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"1008\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":408},{\"value\":31},{\"value\":10},{\"value\":20},{\"value\":3},{\"value\":\"#697#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":4},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"5282\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":507},{\"value\":31},{\"value\":7},{\"value\":20},{\"value\":3},{\"value\":\"#696#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":5}]},{\"id\":\"22943\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":411},{\"value\":31},{\"value\":20},{\"value\":20},{\"value\":3},{\"value\":\"#1000#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":4}]},{\"id\":\"26716\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":510},{\"value\":31},{\"value\":17},{\"value\":20},{\"value\":3},{\"value\":\"#699#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":5},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"6712\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":506},{\"value\":31},{\"value\":4},{\"value\":20},{\"value\":3},{\"value\":\"#695#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":5},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"17625\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":508},{\"value\":31},{\"value\":10},{\"value\":20},{\"value\":3},{\"value\":\"#697#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":5},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"13577\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":607},{\"value\":31},{\"value\":7},{\"value\":20},{\"value\":3},{\"value\":\"#696#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"16946\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":610},{\"value\":31},{\"value\":17},{\"value\":20},{\"value\":3},{\"value\":\"#699#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":6},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"14271\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":606},{\"value\":31},{\"value\":4},{\"value\":20},{\"value\":3},{\"value\":\"#695#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":6},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"7533\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":608},{\"value\":31},{\"value\":10},{\"value\":20},{\"value\":3},{\"value\":\"#697#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":6},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"273\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":370},{\"value\":59},{\"value\":53},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#688#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8461\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":707},{\"value\":31},{\"value\":7},{\"value\":20},{\"value\":3},{\"value\":\"#696#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":7}]},{\"id\":\"1425\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":711},{\"value\":31},{\"value\":20},{\"value\":20},{\"value\":3},{\"value\":\"#1002#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":7}]},{\"id\":\"23307\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":710},{\"value\":31},{\"value\":17},{\"value\":20},{\"value\":3},{\"value\":\"#699#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":7},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"8256\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":706},{\"value\":31},{\"value\":4},{\"value\":20},{\"value\":3},{\"value\":\"#695#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":7},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"21411\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":708},{\"value\":31},{\"value\":10},{\"value\":20},{\"value\":3},{\"value\":\"#697#\"},{\"value\":[{\"v\":20}]},{\"value\":6},{\"value\":\"12\"},{\"value\":7},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"29856\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":31},{\"value\":23},{\"value\":20},{\"value\":3},{\"value\":\"#1001#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":4}]},{\"id\":\"21415\",\"windowid\":\"18175\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":511},{\"value\":31},{\"value\":20},{\"value\":20},{\"value\":3},{\"value\":\"#698#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":5}]},{\"id\":\"22091\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":127},{\"value\":31},{\"value\":35},{\"value\":20},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1411#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"32297\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":227},{\"value\":31},{\"value\":35},{\"value\":20},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1411#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"2655\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":327},{\"value\":31},{\"value\":35},{\"value\":20},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1411#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":3}]},{\"id\":\"24768\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":117},{\"value\":31},{\"value\":52},{\"value\":20},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1740#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"6467\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":217},{\"value\":28},{\"value\":52},{\"value\":20},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1740#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"30392\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":617},{\"value\":31},{\"value\":51},{\"value\":20},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1740#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":6}]},{\"id\":\"23436\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":517},{\"value\":31},{\"value\":51},{\"value\":20},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1740#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":5}]},{\"id\":\"16101\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":717},{\"value\":31},{\"value\":35},{\"value\":20},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1740#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":7}]},{\"id\":\"780\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":417},{\"value\":31},{\"value\":51},{\"value\":20},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1740#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":4}]},{\"id\":\"16629\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":317},{\"value\":31},{\"value\":51},{\"value\":20},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1740#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":3}]},{\"id\":\"10573\",\"windowid\":\"18175\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":21},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2005#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"8709\",\"windowid\":\"18175\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":13},{\"value\":27},{\"value\":12},{\"value\":15},{\"value\":[{\"v\":12}]},{\"value\":\"Interfaces Rede\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}\n]}','0',1),(1886,0,3351,'SCREEN_CONFIG_TERMINALS_SERVICES',11141,'{\"objects\":[{\"id\":\"13667\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":141},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#714#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"1330\",\"windowid\":\"13667\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"5824\",\"windowid\":\"13667\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"#1807#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27605\",\"windowid\":\"13667\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":25},{\"value\":4},{\"value\":28},{\"value\":3},{\"value\":\"#715#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26956\",\"windowid\":\"13667\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#716#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27891\",\"windowid\":\"13667\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"22348\",\"windowid\":\"13667\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15369\",\"windowid\":\"13667\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22375\",\"windowid\":\"13667\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18873\",\"windowid\":\"13667\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"494\",\"windowid\":\"13667\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":40},{\"value\":9},{\"value\":13},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',1),(1905,0,3383,'SCREEN_TABLE_EDIT_JOIN_TABLES',4004,'{\"objects\":[{\"id\":\"21956\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"14630\",\"windowid\":\"21956\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":12},{\"value\":0},{\"value\":53},{\"value\":43},{\"value\":9},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23130\",\"windowid\":\"21956\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":31},{\"value\":12},{\"value\":12},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"9830\",\"windowid\":\"21956\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":5}]},{\"value\":\"#1772#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15936\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8679\",\"windowid\":\"21956\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"22464\",\"windowid\":\"21956\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"11386\",\"windowid\":\"21956\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":60},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"16750\",\"windowid\":\"21956\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":43},{\"value\":65},{\"value\":4},{\"value\":8},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"10076\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-14},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#249#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1054.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"11425\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"18257\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"18612\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":0},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7528\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":8},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27945\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1741#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1071.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"19195\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#971#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1074.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"26163\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#966#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"25267\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#967#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"32297\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#969#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1068.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"18065\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#971#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1074.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"29679\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"4934\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]}]}{\"objects\":[{\"id\":\"21956\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"14630\",\"windowid\":\"21956\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":12},{\"value\":0},{\"value\":53},{\"value\":43},{\"value\":9},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23130\",\"windowid\":\"21956\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":31},{\"value\":12},{\"value\":12},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"9830\",\"windowid\":\"21956\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":5}]},{\"value\":\"#1772#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15936\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8679\",\"windowid\":\"21956\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"22464\",\"windowid\":\"21956\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"11386\",\"windowid\":\"21956\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":60},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"16750\",\"windowid\":\"21956\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":43},{\"value\":65},{\"value\":4},{\"value\":8},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"10076\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-14},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#249#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1054.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"11425\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"18257\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"18612\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":0},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7528\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":8},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27945\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1741#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1071.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"19195\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#971#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1074.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"26163\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#966#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"25267\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#967#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"32297\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#969#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1068.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"18065\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#971#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1074.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"29679\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"4934\",\"windowid\":\"21956\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]}]}','5',2),(1906,0,3382,'SCREEN_TABLE_EDIT_DISCO',3004,'{\"objects\":[{\"id\":\"13969\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7663\",\"windowid\":\"13969\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":12},{\"value\":0},{\"value\":53},{\"value\":43},{\"value\":9},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30103\",\"windowid\":\"13969\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":31},{\"value\":12},{\"value\":12},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"23173\",\"windowid\":\"13969\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":5}]},{\"value\":\"#1772#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26746\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18188\",\"windowid\":\"13969\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"5620\",\"windowid\":\"13969\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"7568\",\"windowid\":\"13969\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":60},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"19765\",\"windowid\":\"13969\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":43},{\"value\":65},{\"value\":4},{\"value\":8},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"16520\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"7863\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"24294\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":0},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17558\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":8},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15736\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1741#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1071.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"16109\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#966#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"30829\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#967#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"19392\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#969#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1068.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"26116\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":55},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1653#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1075.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"24432\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"19373\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10727\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#971#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1074.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"24859\",\"windowid\":\"13969\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-17},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#754#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1050.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]}]}','5',2),(1907,0,3381,'SCREEN_TABLE_EDIT_APPLY_DISCOUNT',2004,'{\"objects\":[{\"id\":\"1714\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"9772\",\"windowid\":\"1714\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":12},{\"value\":0},{\"value\":53},{\"value\":43},{\"value\":9},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12064\",\"windowid\":\"1714\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":31},{\"value\":12},{\"value\":12},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"719\",\"windowid\":\"1714\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":5}]},{\"value\":\"#1772#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3599\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9111\",\"windowid\":\"1714\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"7827\",\"windowid\":\"1714\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"5781\",\"windowid\":\"1714\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":60},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"24734\",\"windowid\":\"1714\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":43},{\"value\":65},{\"value\":4},{\"value\":8},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"25997\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-14},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#249#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1054.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"529\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"27969\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"24936\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":0},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15356\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":8},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16027\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1741#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1071.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"6492\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-17},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#754#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1050.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"21546\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#966#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"10687\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#967#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"8561\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#969#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1068.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"29113\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":42},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1652#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1075.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"14518\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"25202\",\"windowid\":\"1714\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]}]}','5',2),(1911,0,3378,'SCREEN_TABLE_EDIT_RETAIL',10004,'{\"objects\":[{\"id\":\"11778\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#1747#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"6382\",\"windowid\":\"11778\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":302},{\"value\":53},{\"value\":9},{\"value\":23},{\"value\":23},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"6403\",\"windowid\":\"11778\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":8},{\"value\":27},{\"value\":24},{\"value\":[{\"v\":2},{\"v\":12},{\"v\":2},{\"v\":3},{\"v\":2},{\"v\":3}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"2537\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":9},{\"value\":32},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1695#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":0}]},{\"id\":\"2232\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":4},{\"value\":47},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1153.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26868\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":22},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1151.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32440\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":7},{\"value\":32},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29878\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7371\",\"windowid\":\"11778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":8},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"13969\",\"windowid\":\"11778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":2},{\"value\":32},{\"value\":5},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"25248\",\"windowid\":\"11778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":64},{\"value\":0},{\"value\":35},{\"value\":15},{\"value\":3},{\"value\":\"#1696#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"9215\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":7},{\"value\":43},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1697#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1079.png\"},{\"value\":5},{\"value\":-1},{\"value\":0}]},{\"id\":\"14889\",\"windowid\":\"11778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":15},{\"value\":32},{\"value\":6},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"10250\",\"windowid\":\"11778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":9},{\"value\":32},{\"value\":6},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"20412\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":71},{\"value\":8},{\"value\":47},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1701#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1080.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15700\",\"windowid\":\"11778\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":0},{\"value\":38},{\"value\":15},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":15}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"23669\",\"windowid\":\"11778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":38},{\"value\":15},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"17798\",\"windowid\":\"11778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":0},{\"value\":41},{\"value\":15},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"31850\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":81},{\"value\":15},{\"value\":35},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"28966\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":82},{\"value\":18},{\"value\":35},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"14252\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":83},{\"value\":21},{\"value\":35},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"25374\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":84},{\"value\":15},{\"value\":38},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"23598\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":85},{\"value\":18},{\"value\":38},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"21883\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":86},{\"value\":21},{\"value\":38},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"30728\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":87},{\"value\":15},{\"value\":41},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"28979\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":88},{\"value\":18},{\"value\":41},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"32433\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":21},{\"value\":41},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"22758\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":18},{\"value\":44},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"14628\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":72},{\"value\":15},{\"value\":44},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"9988\",\"windowid\":\"11778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":90},{\"value\":10},{\"value\":44},{\"value\":5},{\"value\":3},{\"value\":\"#1702#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"24586\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":24},{\"value\":38},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1084.png\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"25015\",\"windowid\":\"11778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":21},{\"value\":32},{\"value\":6},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"30818\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":92},{\"value\":24},{\"value\":41},{\"value\":3},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1085.png\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"15231\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":91},{\"value\":21},{\"value\":44},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1713#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"3645\",\"windowid\":\"11778\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":8},{\"value\":0},{\"value\":19},{\"value\":4},{\"value\":4},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"28015\",\"windowid\":\"11778\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":3},{\"value\":4},{\"value\":24},{\"value\":4},{\"value\":4},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"1674\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":32},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8280\",\"windowid\":\"11778\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":0},{\"value\":8},{\"value\":28},{\"value\":24},{\"value\":5},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"value\":0}]},{\"id\":\"18433\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":95},{\"value\":0},{\"value\":4},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1728#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17527\",\"windowid\":\"11778\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":13},{\"value\":32},{\"value\":14},{\"value\":15},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":0},{\"v\":0},{\"v\":0},{\"v\":3}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"15539\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":93},{\"value\":24},{\"value\":35},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1083.png\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"29529\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-21},{\"value\":12},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1750#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1078.png\"},{\"value\":5},{\"value\":-1},{\"value\":0}]},{\"id\":\"30919\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-22},{\"value\":0},{\"value\":43},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1751#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1077.png\"},{\"value\":5},{\"value\":-1},{\"value\":0}]},{\"id\":\"5649\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":7},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":5},{\"value\":-1},{\"value\":0}]},{\"id\":\"30823\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":0},{\"value\":39},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1431#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1067.png\"},{\"value\":5},{\"value\":-1},{\"value\":0}]},{\"id\":\"6649\",\"windowid\":\"11778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":17},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1152.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13815\",\"windowid\":\"11778\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":124},{\"value\":0},{\"value\":36},{\"value\":13},{\"value\":3},{\"value\":\"#1875#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"4238\",\"windowid\":\"11778\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":131},{\"value\":0},{\"value\":44},{\"value\":10},{\"value\":3},{\"value\":\"#1924#\"},{\"value\":[{\"v\":10}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]}]}','4',3),(1912,0,3377,'SCREEN_TABLE_EDIT',4,'{\"objects\":[{\"id\":\"13690\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"20292\",\"windowid\":\"13690\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":43},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"20039\",\"windowid\":\"13690\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":9},{\"value\":17},{\"value\":34},{\"value\":[{\"v\":2},{\"v\":10},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"9670\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-14},{\"value\":17},{\"value\":9},{\"value\":10},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#249#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1054.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"13474\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":17},{\"value\":20},{\"value\":10},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"20277\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":43},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"21622\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":17},{\"value\":15},{\"value\":10},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"1655\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":17},{\"value\":4},{\"value\":10},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"10512\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":11},{\"value\":43},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"23970\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":17},{\"value\":31},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#255#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1056.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"22598\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5884\",\"windowid\":\"13690\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":6},{\"value\":43},{\"value\":5},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":0}]},{\"id\":\"10214\",\"windowid\":\"13690\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":155},{\"value\":5},{\"value\":47},{\"value\":22},{\"value\":4},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":0}]},{\"id\":\"17205\",\"windowid\":\"13690\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":43},{\"value\":27},{\"value\":4},{\"value\":4},{\"value\":-2},{\"value\":103},{\"value\":1}]},{\"id\":\"10128\",\"windowid\":\"13690\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":0},{\"value\":9},{\"value\":27},{\"value\":34},{\"value\":4},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":1}]},{\"id\":\"13913\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-17},{\"value\":17},{\"value\":35},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#754#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1050.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"31332\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":17},{\"value\":39},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#969#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"12605\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":17},{\"value\":43},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1431#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"18227\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":17},{\"value\":27},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"19326\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#966#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"19211\",\"windowid\":\"13690\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#967#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"19015\",\"windowid\":\"13690\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":4},{\"value\":17},{\"value\":4},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"10587\",\"windowid\":\"13690\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":22},{\"value\":4},{\"value\":3},{\"value\":-1},{\"value\":102},{\"value\":1}]},{\"id\":\"12921\",\"windowid\":\"13690\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":54},{\"value\":0},{\"value\":4},{\"value\":27},{\"value\":4},{\"value\":\"#1535#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":1}]}]}','4',3),(1914,0,3375,'SCREEN_TABLE_EDIT_JOIN_TABLES',4004,'{\"objects\":[{\"id\":\"10516\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"21344\",\"windowid\":\"10516\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":31},{\"value\":12},{\"value\":12},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"28483\",\"windowid\":\"10516\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":5}]},{\"value\":\"#1772#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7352\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-14},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#249#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1054.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"23724\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"8391\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"29118\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":0},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27510\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":8},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11046\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1741#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1071.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"19835\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19070\",\"windowid\":\"10516\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"20189\",\"windowid\":\"10516\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"6459\",\"windowid\":\"10516\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"5789\",\"windowid\":\"10516\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":43},{\"value\":53},{\"value\":4},{\"value\":8},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"8243\",\"windowid\":\"10516\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":43},{\"value\":7},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30895\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#971#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1074.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"24629\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#966#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"9378\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#967#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"15500\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#969#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1068.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"685\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#971#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1074.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"3679\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"31225\",\"windowid\":\"10516\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1915,0,3374,'SCREEN_TABLE_EDIT_DISCO',3004,'{\"objects\":[{\"id\":\"23476\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"6076\",\"windowid\":\"23476\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":31},{\"value\":12},{\"value\":12},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"12058\",\"windowid\":\"23476\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":5}]},{\"value\":\"#1772#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20879\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"4023\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"1821\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":0},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25600\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":8},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14856\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1741#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1071.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"4105\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27431\",\"windowid\":\"23476\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"21019\",\"windowid\":\"23476\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"17729\",\"windowid\":\"23476\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"252\",\"windowid\":\"23476\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":43},{\"value\":53},{\"value\":4},{\"value\":8},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"9911\",\"windowid\":\"23476\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":43},{\"value\":7},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8557\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#966#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"18826\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#967#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"13483\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#969#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1068.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"1103\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":55},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1653#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1075.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"28669\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"13334\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19851\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#971#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1074.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"7770\",\"windowid\":\"23476\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-17},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#754#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1050.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]}]}','0',1),(1916,0,3373,'SCREEN_TABLE_EDIT_APPLY_DISCOUNT',2004,'{\"objects\":[{\"id\":\"30890\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"25682\",\"windowid\":\"30890\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":31},{\"value\":12},{\"value\":12},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"16782\",\"windowid\":\"30890\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":5}]},{\"value\":\"#1772#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2474\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-14},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#249#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1054.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"4247\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"8705\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"28516\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":0},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26053\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":8},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31925\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1741#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1071.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"18589\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30192\",\"windowid\":\"30890\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"12612\",\"windowid\":\"30890\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"4618\",\"windowid\":\"30890\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"24931\",\"windowid\":\"30890\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":43},{\"value\":53},{\"value\":4},{\"value\":8},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"24712\",\"windowid\":\"30890\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":43},{\"value\":7},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5371\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-17},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#754#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1050.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"13743\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#966#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"24157\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":8},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#967#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"13604\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#969#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1068.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"10958\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":42},{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1652#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1075.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"22145\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"32063\",\"windowid\":\"30890\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1921,0,3392,'SCREEN_SALESMAN_SELECTION',2,'{\"objects\":[{\"id\":\"27901\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":2},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#245#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"30410\",\"windowid\":\"27901\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":60},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31061\",\"windowid\":\"27901\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":101},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":47},{\"value\":11},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23635\",\"windowid\":\"27901\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]}]}','5',2),(1922,0,3395,'SCREEN_CONFIG_SALESMEN_SERVICES',11105,'{\"objects\":[{\"id\":\"6557\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":105},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#338#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"8780\",\"windowid\":\"6557\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"9227\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":41},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#339#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4185\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":15},{\"value\":3},{\"value\":\"#340#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26624\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#345#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30666\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#346#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32479\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":40},{\"value\":22},{\"value\":13},{\"value\":3},{\"value\":\"#352#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"5687\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":26},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#356#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6811\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"#357#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32150\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":26},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#358#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21980\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":26},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#359#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"5207\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":22},{\"value\":40},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#360#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25133\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":40},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#362#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32585\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#363#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27851\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":25},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#364#\"},{\"value\":1},{\"value\":8},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2997\",\"windowid\":\"6557\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"#1806#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"5843\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"9050\",\"windowid\":\"6557\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":12},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#350#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"980\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":23},{\"value\":26},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#361#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24870\",\"windowid\":\"6557\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#343#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CColorBox\"}]},{\"id\":\"23069\",\"windowid\":\"6557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":33},{\"value\":40},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#1568#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21732\",\"windowid\":\"6557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10807\",\"windowid\":\"6557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13627\",\"windowid\":\"6557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8039\",\"windowid\":\"6557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1923,0,3394,'SCREEN_CONFIG_SALESMEN_RETAIL',10105,'{\"objects\":[{\"id\":\"1020\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":105},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#338#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"19652\",\"windowid\":\"1020\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"29058\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":41},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#339#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"9338\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":15},{\"value\":3},{\"value\":\"#340#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3246\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#345#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25261\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#346#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16137\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":28},{\"value\":52},{\"value\":13},{\"value\":3},{\"value\":\"#349#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"12376\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":13},{\"value\":28},{\"value\":27},{\"value\":9},{\"value\":\"#351#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"9458\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":40},{\"value\":22},{\"value\":13},{\"value\":3},{\"value\":\"#352#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6786\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":13},{\"value\":14},{\"value\":13},{\"value\":3},{\"value\":\"#354#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"30954\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":26},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#356#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13524\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"#357#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32355\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":26},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#358#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25023\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":26},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#359#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4035\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":22},{\"value\":40},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#360#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29920\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":40},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#362#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20921\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#363#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18830\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":25},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#364#\"},{\"value\":1},{\"value\":8},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24096\",\"windowid\":\"1020\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30379\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"2809\",\"windowid\":\"1020\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":12},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#350#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"21042\",\"windowid\":\"1020\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":9},{\"value\":14},{\"value\":52},{\"value\":13},{\"value\":3},{\"value\":\"#347#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"22091\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":23},{\"value\":26},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#361#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18977\",\"windowid\":\"1020\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#343#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CColorBox\"}]},{\"id\":\"1513\",\"windowid\":\"1020\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":17},{\"value\":13},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#355#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"1445\",\"windowid\":\"1020\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":26},{\"value\":13},{\"value\":28},{\"value\":26},{\"value\":3},{\"value\":\"#1139#\"},{\"value\":[{\"v\":26}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"16998\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":27},{\"value\":13},{\"value\":8},{\"value\":27},{\"value\":3},{\"value\":\"#1407#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"6325\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":28},{\"value\":27},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#1409#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"28359\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":29},{\"value\":13},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"#1412#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"9600\",\"windowid\":\"1020\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":31},{\"value\":13},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#1567#\"},{\"value\":[{\"v\":27}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"19126\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":32},{\"value\":13},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#1567#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"25182\",\"windowid\":\"1020\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":33},{\"value\":40},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#1568#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6970\",\"windowid\":\"1020\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":34},{\"value\":13},{\"value\":31},{\"value\":26},{\"value\":3},{\"value\":\"#1666#\"},{\"value\":[{\"v\":26}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"28700\",\"windowid\":\"1020\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":35},{\"value\":13},{\"value\":34},{\"value\":26},{\"value\":3},{\"value\":\"#1678#\"},{\"value\":[{\"v\":26}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"13890\",\"windowid\":\"1020\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3039\",\"windowid\":\"1020\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28553\",\"windowid\":\"1020\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16631\",\"windowid\":\"1020\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1924,0,3393,'SCREEN_CONFIG_SALESMEN',105,'\n{\"objects\":[{\"id\":\"7423\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":105},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#338#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"32232\",\"windowid\":\"7423\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"26594\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":41},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#339#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26877\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":15},{\"value\":3},{\"value\":\"#340#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14592\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#341#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23980\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":13},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#342#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"17788\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#345#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4291\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#346#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23099\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":28},{\"value\":52},{\"value\":13},{\"value\":3},{\"value\":\"#349#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"8602\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":13},{\"value\":33},{\"value\":27},{\"value\":6},{\"value\":\"#351#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"12056\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":40},{\"value\":22},{\"value\":13},{\"value\":3},{\"value\":\"#352#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12030\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":13},{\"value\":14},{\"value\":13},{\"value\":3},{\"value\":\"#354#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"31902\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":26},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#356#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6260\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"#357#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12480\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":26},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#358#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30367\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":26},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#359#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16936\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":22},{\"value\":40},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#360#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27598\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":40},{\"value\":19},{\"value\":13},{\"value\":3},{\"value\":\"#362#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24330\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#363#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13819\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":25},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#364#\"},{\"value\":1},{\"value\":8},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23467\",\"windowid\":\"7423\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30147\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"9717\",\"windowid\":\"7423\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":12},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#350#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"31263\",\"windowid\":\"7423\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":9},{\"value\":14},{\"value\":52},{\"value\":13},{\"value\":3},{\"value\":\"#347#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"28368\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":23},{\"value\":26},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#361#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7910\",\"windowid\":\"7423\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"#343#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CColorBox\"}]},{\"id\":\"32533\",\"windowid\":\"7423\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":17},{\"value\":13},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#355#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"31843\",\"windowid\":\"7423\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":26},{\"value\":13},{\"value\":28},{\"value\":26},{\"value\":3},{\"value\":\"#1139#\"},{\"value\":[{\"v\":26}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"7515\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":27},{\"value\":13},{\"value\":8},{\"value\":27},{\"value\":3},{\"value\":\"#1407#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"22651\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":28},{\"value\":27},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#1409#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"21232\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":29},{\"value\":13},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"#1412#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"3650\",\"windowid\":\"7423\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":31},{\"value\":13},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#1567#\"},{\"value\":[{\"v\":27}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"4528\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":32},{\"value\":13},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#1567#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"1768\",\"windowid\":\"7423\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":33},{\"value\":40},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#1568#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},\n{\"id\":\"2471\",\"windowid\":\"7423\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":30},{\"value\":13},{\"value\":23},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1553#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},\n{\"id\":\"2472\",\"windowid\":\"7423\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":40},{\"value\":34},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#2084#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},\n{\"id\":\"30568\",\"windowid\":\"7423\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":34},{\"value\":13},{\"value\":31},{\"value\":26},{\"value\":3},{\"value\":\"#1666#\"},{\"value\":[{\"v\":26}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"13462\",\"windowid\":\"7423\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":35},{\"value\":13},{\"value\":34},{\"value\":26},{\"value\":3},{\"value\":\"#1678#\"},{\"value\":[{\"v\":26}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"28774\",\"windowid\":\"7423\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3801\",\"windowid\":\"7423\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31246\",\"windowid\":\"7423\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":14},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2081#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31245\",\"windowid\":\"7423\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28732\",\"windowid\":\"7423\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}\n','0',1),(1929,0,3402,'SCREEN_CONFIG_DAILY_JOURNAL_FULL',323,'{\"objects\":[{\"id\":\"30224\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":123},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":49},{\"value\":\"#520#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7144\",\"windowid\":\"30224\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":18},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"18498\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":18},{\"value\":35},{\"value\":[{\"v\":5},{\"v\":4},{\"v\":5},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"30401\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":31},{\"value\":8},{\"value\":3},{\"value\":\"#759#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"26897\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":48},{\"value\":43},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3944\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":10},{\"value\":16},{\"value\":3},{\"value\":\"#523#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"128\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":25},{\"value\":8},{\"value\":3},{\"value\":\"#760#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"11535\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":22},{\"value\":16},{\"value\":3},{\"value\":\"#526#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"25419\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":1},{\"value\":28},{\"value\":8},{\"value\":3},{\"value\":\"#761#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"6800\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":36},{\"value\":10},{\"value\":17},{\"value\":20},{\"value\":[{\"v\":2},{\"v\":5},{\"v\":3},{\"v\":2},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"32197\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":36},{\"value\":7},{\"value\":17},{\"value\":3},{\"value\":\"#529#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13384\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":18},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#530#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16075\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":36},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#531#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27082\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":18},{\"value\":10},{\"value\":9},{\"value\":3},{\"value\":\"#532#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19240\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":18},{\"value\":7},{\"value\":17},{\"value\":3},{\"value\":\"#534#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31283\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#535#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17679\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":38},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10286\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":15},{\"value\":6},{\"value\":39},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#755#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1063.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4267\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":9},{\"value\":31},{\"value\":8},{\"value\":3},{\"value\":\"#762#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"19163\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":9},{\"value\":28},{\"value\":8},{\"value\":3},{\"value\":\"#763#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"1478\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":9},{\"value\":25},{\"value\":8},{\"value\":3},{\"value\":\"#764#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"2776\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":17},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#765#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1043.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18131\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":18},{\"value\":26},{\"value\":17},{\"value\":8},{\"value\":[{\"v\":9},{\"v\":7}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"2366\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":4},{\"value\":58},{\"value\":26},{\"value\":3},{\"value\":\"#770#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"30232\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":26},{\"value\":18},{\"value\":0},{\"value\":35},{\"value\":3},{\"value\":\"#771#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"3494\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":13},{\"value\":16},{\"value\":3},{\"value\":\"#525#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"32087\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":16},{\"value\":16},{\"value\":3},{\"value\":\"#527#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"22821\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":25},{\"value\":1},{\"value\":19},{\"value\":16},{\"value\":3},{\"value\":\"#865#\"},{\"value\":[{\"v\":5}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"6988\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":27},{\"value\":10},{\"value\":8},{\"value\":3},{\"value\":\"#822#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4499\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":29},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1438#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"53\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":30},{\"value\":18},{\"value\":13},{\"value\":17},{\"value\":3},{\"value\":\"#1465#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26847\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":33},{\"value\":33},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1793#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22115\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":37},{\"value\":1},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#1800#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"1987\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":35},{\"value\":1},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#1800#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"29838\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":28},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1853#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8025\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":40},{\"value\":18},{\"value\":22},{\"value\":17},{\"value\":3},{\"value\":\"#1854#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12199\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":42},{\"value\":18},{\"value\":19},{\"value\":17},{\"value\":3},{\"value\":\"#1857#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24611\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":39},{\"value\":18},{\"value\":16},{\"value\":17},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1902#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12334\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":44},{\"value\":36},{\"value\":31},{\"value\":17},{\"value\":3},{\"value\":\"#2000#\"},{\"v\":[{\"value\":17}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"19163\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":36},{\"value\":1},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#2086#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"29938\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":46},{\"value\":23},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2096#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29939\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":47},{\"value\":18},{\"value\":35},{\"value\":17},{\"value\":3},{\"value\":\"#2097#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"70001\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":50},{\"value\":36},{\"value\":35},{\"value\":12},{\"value\":3},{\"value\":\"#2128#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"70002\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":51},{\"value\":48},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1930,0,3401,'SCREEN_CONFIG_DAILY_JOURNAL',123,'{\"objects\":[{\"id\":\"30224\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":123},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":49},{\"value\":\"#520#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7144\",\"windowid\":\"30224\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":18},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"18498\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":18},{\"value\":35},{\"value\":[{\"v\":5},{\"v\":4},{\"v\":5},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"30401\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":31},{\"value\":8},{\"value\":3},{\"value\":\"#759#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"26897\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":48},{\"value\":43},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3944\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":10},{\"value\":16},{\"value\":3},{\"value\":\"#523#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"128\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":25},{\"value\":8},{\"value\":3},{\"value\":\"#760#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"11535\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":22},{\"value\":16},{\"value\":3},{\"value\":\"#526#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"25419\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":1},{\"value\":28},{\"value\":8},{\"value\":3},{\"value\":\"#761#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"6800\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":36},{\"value\":10},{\"value\":17},{\"value\":20},{\"value\":[{\"v\":2},{\"v\":5},{\"v\":3},{\"v\":2},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"32197\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":36},{\"value\":7},{\"value\":17},{\"value\":3},{\"value\":\"#529#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13384\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":18},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#530#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16075\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":36},{\"value\":4},{\"value\":17},{\"value\":3},{\"value\":\"#531#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27082\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":18},{\"value\":10},{\"value\":9},{\"value\":3},{\"value\":\"#532#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19240\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":18},{\"value\":7},{\"value\":17},{\"value\":3},{\"value\":\"#534#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31283\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#535#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17679\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":38},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10286\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":15},{\"value\":6},{\"value\":39},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#755#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1063.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4267\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":9},{\"value\":31},{\"value\":8},{\"value\":3},{\"value\":\"#762#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"19163\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":9},{\"value\":28},{\"value\":8},{\"value\":3},{\"value\":\"#763#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"1478\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":9},{\"value\":25},{\"value\":8},{\"value\":3},{\"value\":\"#764#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"2776\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":17},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#765#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1043.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18131\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":18},{\"value\":26},{\"value\":17},{\"value\":8},{\"value\":[{\"v\":9},{\"v\":7}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"2366\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":4},{\"value\":58},{\"value\":26},{\"value\":3},{\"value\":\"#770#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"30232\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":26},{\"value\":18},{\"value\":0},{\"value\":35},{\"value\":3},{\"value\":\"#771#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"3494\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":13},{\"value\":16},{\"value\":3},{\"value\":\"#525#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"32087\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":16},{\"value\":16},{\"value\":3},{\"value\":\"#527#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"22821\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":25},{\"value\":1},{\"value\":19},{\"value\":16},{\"value\":3},{\"value\":\"#865#\"},{\"value\":[{\"v\":5}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"6988\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":27},{\"value\":10},{\"value\":8},{\"value\":3},{\"value\":\"#822#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4499\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":29},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1438#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"53\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":30},{\"value\":18},{\"value\":13},{\"value\":17},{\"value\":3},{\"value\":\"#1465#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26847\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":33},{\"value\":33},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1793#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22115\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":37},{\"value\":1},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#1800#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"1987\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":35},{\"value\":1},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#1800#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"29838\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":28},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1853#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8025\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":40},{\"value\":18},{\"value\":22},{\"value\":17},{\"value\":3},{\"value\":\"#1854#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12199\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":42},{\"value\":18},{\"value\":19},{\"value\":17},{\"value\":3},{\"value\":\"#1857#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24611\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":39},{\"value\":18},{\"value\":16},{\"value\":17},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1902#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12334\",\"windowid\":\"30224\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":44},{\"value\":36},{\"value\":31},{\"value\":17},{\"value\":3},{\"value\":\"#2000#\"},{\"v\":[{\"value\":17}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"19163\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":36},{\"value\":1},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#2086#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"29938\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":46},{\"value\":23},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2096#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29939\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":47},{\"value\":18},{\"value\":35},{\"value\":17},{\"value\":3},{\"value\":\"#2097#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"70001\",\"windowid\":\"30224\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":50},{\"value\":36},{\"value\":35},{\"value\":12},{\"value\":3},{\"value\":\"#2128#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"70002\",\"windowid\":\"30224\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":51},{\"value\":48},{\"value\":35},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1931,0,3400,'SCREEN_CONFIG_OPEN_TABLES_RETAIL',10121,'{\"objects\":[{\"id\":\"31911\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":121},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#508#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"16932\",\"windowid\":\"31911\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"Detalhe Mesa|Transferencia Mesas entre Empregados\"}]},{\"id\":\"31519\",\"windowid\":\"31911\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":10},{\"value\":12},{\"value\":20},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12998\",\"windowid\":\"31911\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"10044\",\"windowid\":\"31911\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":4},{\"value\":21},{\"value\":3},{\"value\":\"#509#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28168\",\"windowid\":\"31911\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":26},{\"value\":18},{\"value\":3},{\"value\":\"#867#\"},{\"value\":[{\"v\":18}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"2503\",\"windowid\":\"31911\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":32},{\"value\":13},{\"value\":21},{\"value\":22},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3},{\"v\":5},{\"v\":7}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"4118\",\"windowid\":\"31911\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":32},{\"value\":35},{\"value\":21},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#870#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":5},{\"value\":-1},{\"value\":0}]},{\"id\":\"12983\",\"windowid\":\"31911\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":13},{\"value\":30},{\"value\":36},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#882#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"9109\",\"windowid\":\"31911\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":9},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#867#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"6759\",\"windowid\":\"31911\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":32},{\"value\":7},{\"value\":21},{\"value\":3},{\"value\":\"#883#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7835\",\"windowid\":\"31911\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":32},{\"value\":10},{\"value\":21},{\"value\":3},{\"value\":\"#884#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18736\",\"windowid\":\"31911\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":0},{\"value\":30},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#872#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4177\",\"windowid\":\"31911\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":21},{\"value\":9},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"24832\",\"windowid\":\"31911\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":34},{\"value\":9},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"19627\",\"windowid\":\"31911\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":500},{\"value\":13},{\"value\":23},{\"value\":18},{\"value\":3},{\"value\":\"#1120#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16567\",\"windowid\":\"31911\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":35},{\"value\":0},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#1224#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3802\",\"windowid\":\"31911\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":36},{\"value\":13},{\"value\":4},{\"value\":18},{\"value\":3},{\"value\":\"#1225#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30537\",\"windowid\":\"31911\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":37},{\"value\":13},{\"value\":7},{\"value\":18},{\"value\":3},{\"value\":\"#1226#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4202\",\"windowid\":\"31911\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":0},{\"value\":35},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1661#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1097.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11499\",\"windowid\":\"31911\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":40},{\"value\":13},{\"value\":11},{\"value\":18},{\"value\":3},{\"value\":\"#1662#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16935\",\"windowid\":\"31911\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":39},{\"value\":13},{\"value\":14},{\"value\":18},{\"value\":3},{\"value\":\"#1663#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6888\",\"windowid\":\"31911\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":41},{\"value\":13},{\"value\":17},{\"value\":18},{\"value\":3},{\"value\":\"#1664#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32054\",\"windowid\":\"31911\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11977\",\"windowid\":\"31911\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":42},{\"value\":13},{\"value\":35},{\"value\":18},{\"value\":3},{\"value\":\"#2000#\"},{\"value\":[{\"v\":18}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]}]}','0',1),(1932,0,3399,'SCREEN_CONFIG_OPEN_TABLES',121,'{\"objects\":[{\"id\":\"22743\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":121},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#508#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"17485\",\"windowid\":\"22743\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":7},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"Detalhe Mesa|Transferencia Mesas entre Empregados\"}]},{\"id\":\"7593\",\"windowid\":\"22743\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":10},{\"value\":12},{\"value\":20},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18573\",\"windowid\":\"22743\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"17511\",\"windowid\":\"22743\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":32},{\"value\":4},{\"value\":21},{\"value\":3},{\"value\":\"#509#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14079\",\"windowid\":\"22743\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":24},{\"value\":18},{\"value\":3},{\"value\":\"#867#\"},{\"value\":[{\"v\":18}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"22962\",\"windowid\":\"22743\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":32},{\"value\":13},{\"value\":21},{\"value\":22},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3},{\"v\":5},{\"v\":7}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"15187\",\"windowid\":\"22743\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":32},{\"value\":35},{\"value\":21},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#870#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":5},{\"value\":-1},{\"value\":0}]},{\"id\":\"19889\",\"windowid\":\"22743\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":13},{\"value\":30},{\"value\":36},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#882#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"29573\",\"windowid\":\"22743\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":9},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#867#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"9008\",\"windowid\":\"22743\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":32},{\"value\":7},{\"value\":21},{\"value\":3},{\"value\":\"#883#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18664\",\"windowid\":\"22743\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":32},{\"value\":10},{\"value\":21},{\"value\":3},{\"value\":\"#884#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12553\",\"windowid\":\"22743\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":0},{\"value\":30},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#872#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18039\",\"windowid\":\"22743\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":21},{\"value\":9},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"20398\",\"windowid\":\"22743\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":34},{\"value\":9},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"32439\",\"windowid\":\"22743\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":500},{\"value\":13},{\"value\":21},{\"value\":18},{\"value\":3},{\"value\":\"#1120#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23550\",\"windowid\":\"22743\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":31},{\"value\":13},{\"value\":30},{\"value\":18},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1145#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":5},{\"value\":-1},{\"value\":0}]},{\"id\":\"26039\",\"windowid\":\"22743\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":32},{\"value\":13},{\"value\":27},{\"value\":18},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1146#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"464\",\"windowid\":\"22743\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":35},{\"value\":0},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#1224#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26602\",\"windowid\":\"22743\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":36},{\"value\":13},{\"value\":4},{\"value\":18},{\"value\":3},{\"value\":\"#1225#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"5085\",\"windowid\":\"22743\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":37},{\"value\":13},{\"value\":7},{\"value\":18},{\"value\":3},{\"value\":\"#1226#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3310\",\"windowid\":\"22743\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":38},{\"value\":0},{\"value\":35},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1661#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1097.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9199\",\"windowid\":\"22743\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":40},{\"value\":13},{\"value\":11},{\"value\":18},{\"value\":3},{\"value\":\"#1662#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11650\",\"windowid\":\"22743\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":39},{\"value\":13},{\"value\":14},{\"value\":18},{\"value\":3},{\"value\":\"#1663#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25975\",\"windowid\":\"22743\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":41},{\"value\":13},{\"value\":17},{\"value\":18},{\"value\":3},{\"value\":\"#1664#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15929\",\"windowid\":\"22743\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30211\",\"windowid\":\"22743\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":42},{\"value\":13},{\"value\":35},{\"value\":18},{\"value\":3},{\"value\":\"#2000#\"},{\"value\":[{\"v\":18}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]}]}','0',1),(1940,0,3409,'SCREEN_CUSTOMER_ACCOUNT',156,'{\"objects\":[{\"id\":\"6543\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":156},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1055#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7504\",\"windowid\":\"6543\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":43},{\"value\":3},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"10209\",\"windowid\":\"6543\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":9},{\"value\":13},{\"value\":3},{\"value\":\"#1056#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13799\",\"windowid\":\"6543\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":21},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1057#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29974\",\"windowid\":\"6543\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#1058#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25715\",\"windowid\":\"6543\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":4},{\"value\":58},{\"value\":26},{\"value\":3},{\"value\":\"#770#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"5520\",\"windowid\":\"6543\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":5},{\"value\":13},{\"value\":3},{\"value\":\"#1059#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"13002\",\"windowid\":\"6543\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":5},{\"value\":13},{\"value\":3},{\"value\":\"#1059#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32480\",\"windowid\":\"6543\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":15},{\"value\":5},{\"value\":38},{\"value\":33},{\"value\":[{\"v\":38}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"20224\",\"windowid\":\"6543\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":29},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1574#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1097.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8805\",\"windowid\":\"6543\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31254\",\"windowid\":\"6543\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":1},{\"value\":35},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1911#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26069\",\"windowid\":\"6543\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":8},{\"value\":1},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"#1920#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"20689\",\"windowid\":\"6543\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":15},{\"value\":39},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2026#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1943,0,3417,'SCREEN_TABLE_EDIT_GUIAS_SERVICES',11054,'{\"objects\":[{\"id\":\"5294\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":54},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#1882#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"27886\",\"windowid\":\"5294\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":0},{\"value\":49},{\"value\":27},{\"value\":[{\"v\":4},{\"v\":25},{\"v\":4},{\"v\":5},{\"v\":4},{\"v\":5}]},{\"value\":\"#1771#\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"23456\",\"windowid\":\"5294\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16934\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":37},{\"value\":43},{\"value\":12},{\"value\":3},{\"value\":\"#1773#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"27634\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":27},{\"value\":9},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"14053\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":106},{\"value\":39},{\"value\":40},{\"value\":10},{\"value\":3},{\"value\":\"#1755#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7094\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":34},{\"value\":27},{\"value\":5},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"58\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":24},{\"value\":27},{\"value\":10},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11766\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":9},{\"value\":27},{\"value\":15},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5716\",\"windowid\":\"5294\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":71},{\"value\":6},{\"value\":47},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1701#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1080.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15926\",\"windowid\":\"5294\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":53},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"17039\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":53},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9399\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":50},{\"value\":3},{\"value\":15},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18199\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":105},{\"value\":39},{\"value\":31},{\"value\":10},{\"value\":3},{\"value\":\"#1756#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"543\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":39},{\"value\":27},{\"value\":10},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13435\",\"windowid\":\"5294\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":97},{\"value\":12},{\"value\":47},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1734#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1081.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21824\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":107},{\"value\":50},{\"value\":6},{\"value\":15},{\"value\":3},{\"value\":\"#1758#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25817\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":109},{\"value\":58},{\"value\":9},{\"value\":7},{\"value\":3},{\"value\":\"#1759#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21505\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":112},{\"value\":39},{\"value\":34},{\"value\":10},{\"value\":3},{\"value\":\"#1883#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4509\",\"windowid\":\"5294\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":0},{\"value\":31},{\"value\":15},{\"value\":15},{\"value\":[{\"v\":5},{\"v\":5},{\"v\":5}]},{\"value\":\"#1777#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18626\",\"windowid\":\"5294\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":50},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1695#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24536\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":108},{\"value\":50},{\"value\":9},{\"value\":8},{\"value\":3},{\"value\":\"#1760#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32690\",\"windowid\":\"5294\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":111},{\"value\":16},{\"value\":31},{\"value\":11},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1762#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"24770\",\"windowid\":\"5294\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":18},{\"value\":47},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1831#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1150.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27623\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":120},{\"value\":50},{\"value\":17},{\"value\":9},{\"value\":3},{\"value\":\"#1907#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12008\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":50},{\"value\":20},{\"value\":9},{\"value\":3},{\"value\":\"#1908#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10819\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":128},{\"value\":59},{\"value\":17},{\"value\":6},{\"value\":3},{\"value\":\"#58#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22025\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":129},{\"value\":59},{\"value\":20},{\"value\":6},{\"value\":3},{\"value\":\"#58#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30820\",\"windowid\":\"5294\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":132},{\"value\":50},{\"value\":0},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1852#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25275\",\"windowid\":\"5294\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":50},{\"value\":33},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1697#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1079.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10290\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":50},{\"value\":29},{\"value\":15},{\"value\":3},{\"value\":\"#1850#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8262\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":125},{\"value\":50},{\"value\":23},{\"value\":15},{\"value\":3},{\"value\":\"#1879#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7374\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":126},{\"value\":50},{\"value\":26},{\"value\":15},{\"value\":3},{\"value\":\"#1880#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32351\",\"windowid\":\"5294\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":145},{\"value\":16},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','5',2),(1944,0,3416,'SCREEN_TABLE_EDIT_GUIAS_SERVICES',11054,'{\"objects\":[{\"id\":\"22191\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":54},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1882#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"28955\",\"windowid\":\"22191\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":0},{\"value\":37},{\"value\":27},{\"value\":[{\"v\":3},{\"v\":19},{\"v\":3},{\"v\":4},{\"v\":3},{\"v\":4}]},{\"value\":\"#1771#\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"365\",\"windowid\":\"22191\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1828\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":25},{\"value\":43},{\"value\":12},{\"value\":3},{\"value\":\"#1773#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"4521\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":27},{\"value\":5},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"8201\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":106},{\"value\":27},{\"value\":40},{\"value\":10},{\"value\":3},{\"value\":\"#1755#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10321\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":26},{\"value\":27},{\"value\":4},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32178\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":19},{\"value\":27},{\"value\":7},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22931\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":5},{\"value\":27},{\"value\":14},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32216\",\"windowid\":\"22191\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":71},{\"value\":6},{\"value\":47},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1701#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1080.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17789\",\"windowid\":\"22191\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":41},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"31905\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":41},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27306\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":38},{\"value\":3},{\"value\":15},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27936\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":105},{\"value\":27},{\"value\":31},{\"value\":10},{\"value\":3},{\"value\":\"#1756#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11067\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":30},{\"value\":27},{\"value\":7},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24293\",\"windowid\":\"22191\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":97},{\"value\":12},{\"value\":47},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1734#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1081.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32426\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":107},{\"value\":38},{\"value\":6},{\"value\":15},{\"value\":3},{\"value\":\"#1758#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8446\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":109},{\"value\":46},{\"value\":9},{\"value\":7},{\"value\":3},{\"value\":\"#1759#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24388\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":112},{\"value\":27},{\"value\":34},{\"value\":10},{\"value\":3},{\"value\":\"#1883#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30237\",\"windowid\":\"22191\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":0},{\"value\":31},{\"value\":15},{\"value\":15},{\"value\":[{\"v\":5},{\"v\":5},{\"v\":5}]},{\"value\":\"#1777#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14402\",\"windowid\":\"22191\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":38},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1695#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10936\",\"windowid\":\"22191\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":38},{\"value\":33},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1697#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1079.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"473\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":108},{\"value\":38},{\"value\":9},{\"value\":8},{\"value\":3},{\"value\":\"#1760#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9566\",\"windowid\":\"22191\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":111},{\"value\":15},{\"value\":31},{\"value\":11},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1762#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"25285\",\"windowid\":\"22191\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":18},{\"value\":47},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1831#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1150.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2719\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":120},{\"value\":38},{\"value\":17},{\"value\":9},{\"value\":3},{\"value\":\"#1907#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11023\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":38},{\"value\":20},{\"value\":9},{\"value\":3},{\"value\":\"#1908#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6450\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":38},{\"value\":29},{\"value\":15},{\"value\":3},{\"value\":\"#1850#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23074\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":125},{\"value\":38},{\"value\":23},{\"value\":15},{\"value\":3},{\"value\":\"#1879#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18490\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":126},{\"value\":38},{\"value\":26},{\"value\":15},{\"value\":3},{\"value\":\"#1880#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12907\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":128},{\"value\":47},{\"value\":17},{\"value\":6},{\"value\":3},{\"value\":\"#58#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16608\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":129},{\"value\":47},{\"value\":20},{\"value\":6},{\"value\":3},{\"value\":\"#58#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12054\",\"windowid\":\"22191\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":132},{\"value\":38},{\"value\":0},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1852#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21920\",\"windowid\":\"22191\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":145},{\"value\":15},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1945,0,3415,'SCREEN_CANCEL_ITEMS',173,'{\"objects\":[{\"id\":\"28957\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":173},{\"value\":0},{\"value\":5},{\"value\":27},{\"value\":36},{\"value\":\"#1432#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"13224\",\"windowid\":\"28957\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":5},{\"value\":11},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24979\",\"windowid\":\"28957\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":21},{\"value\":29},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5987\",\"windowid\":\"28957\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":15},{\"value\":29},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5808\",\"windowid\":\"28957\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":5},{\"value\":11},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22594\",\"windowid\":\"28957\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":11},{\"value\":6},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12301\",\"windowid\":\"28957\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":11},{\"value\":11},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"597\",\"windowid\":\"28957\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":11},{\"value\":16},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12528\",\"windowid\":\"28957\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":11},{\"value\":21},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23929\",\"windowid\":\"28957\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":16},{\"value\":2},{\"value\":11},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1433#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29890\",\"windowid\":\"28957\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":0},{\"value\":2},{\"value\":11},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1437#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',3),(1949,0,3425,'SCREEN_SERIES_MIGRATION',185,'{\"objects\":[{\"id\":\"20800\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":185},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#2040#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"17069\",\"windowid\":\"20800\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"29466\",\"windowid\":\"20800\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":12},{\"value\":10},{\"value\":28},{\"value\":20},{\"value\":[{\"v\":10},{\"v\":6},{\"v\":6}]},{\"value\":\"#2051#\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"16489\",\"windowid\":\"20800\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":12},{\"value\":31},{\"value\":14},{\"value\":3},{\"value\":\"#2013#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13994\",\"windowid\":\"20800\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":31},{\"value\":14},{\"value\":3},{\"value\":\"#2014#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2955\",\"windowid\":\"20800\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12142\",\"windowid\":\"20800\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16357\",\"windowid\":\"20800\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":12},{\"value\":1},{\"value\":28},{\"value\":8},{\"value\":\"#2024#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1950,0,3426,'SCREEN_CONFIG_COUNTERS',168,'{\"objects\":[{\"id\":\"18034\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":168},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1216#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]}, {\"id\":\"14986\",\"windowid\":\"18034\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]}, {\"id\":\"24430\",\"windowid\":\"18034\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":35},{\"value\":19},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1217#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}, {\"id\":\"28905\",\"windowid\":\"18034\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":19},{\"value\":31},{\"value\":[{\"v\":3},{\"v\":10}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}, {\"id\":\"28912\",\"windowid\":\"18034\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":21},{\"value\":8},{\"value\":32},{\"value\":3},{\"value\":\"#1218#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29865\",\"windowid\":\"18034\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":21},{\"value\":12},{\"value\":32},{\"value\":3},{\"value\":\"#1219#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29866\",\"windowid\":\"18034\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":21},{\"value\":20},{\"value\":32},{\"value\":3},{\"value\":\"#2091#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29867\",\"windowid\":\"18034\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":70},{\"value\":21},{\"value\":24},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2092#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29868\",\"windowid\":\"18034\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":71},{\"value\":32},{\"value\":24},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2093#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}, \r\n{\"id\":\"29869\",\"windowid\":\"18034\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":72},{\"value\":42},{\"value\":24},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2094#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1056.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14984\",\"windowid\":\"18034\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":39},{\"value\":4},{\"value\":14},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1229#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]}, {\"id\":\"8312\",\"windowid\":\"18034\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":21},{\"value\":16},{\"value\":32},{\"value\":3},{\"value\":\"#1230#\"},{\"value\":[{\"v\":32}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"2027\",\"windowid\":\"18034\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":21},{\"value\":31},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1233#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]}, {\"id\":\"1533\",\"windowid\":\"18034\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}, {\"id\":\"11772\",\"windowid\":\"18034\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1952,0,3419,'SCREEN_CONFIG_TAXES',108,'\n{\"objects\":[{\"id\":\"14740\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":108},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#408#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7605\",\"windowid\":\"14740\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"15157\",\"windowid\":\"14740\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7359\",\"windowid\":\"14740\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":35},{\"value\":7},{\"value\":18},{\"value\":3},{\"value\":\"#409#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"17139\",\"windowid\":\"14740\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#410#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"17677\",\"windowid\":\"14740\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":35},{\"value\":10},{\"value\":18},{\"value\":3},{\"value\":\"#411#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"8462\",\"windowid\":\"14740\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":26},{\"value\":23},{\"value\":27},{\"value\":9},{\"value\":\"#414#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"25805\",\"windowid\":\"14740\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#415#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22077\",\"windowid\":\"14740\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"16400\",\"windowid\":\"14740\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":35},{\"value\":13},{\"value\":18},{\"value\":3},{\"value\":\"#412#\"},{\"value\":[{\"v\":18}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"11168\",\"windowid\":\"14740\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":35},{\"value\":16},{\"value\":18},{\"value\":3},{\"value\":\"#413#\"},{\"value\":[{\"v\":18}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"901\",\"windowid\":\"14740\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11020\",\"windowid\":\"14740\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27138\",\"windowid\":\"14740\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"750\",\"windowid\":\"14740\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7357\",\"windowid\":\"14740\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":35},{\"value\":19},{\"value\":18},{\"value\":3},{\"value\":\"Motivo Ise\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4972\",\"windowid\":\"14740\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":13},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1190#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}\n','0',1),(1958,0,3170,'SCREEN_TABLE_PRODUCT_TRANSF',138,'{\"objects\":[{\"id\":\"26155\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":138},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#573#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"31886\",\"windowid\":\"26155\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":53},{\"value\":47},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"Seleccione Mesa Destino|Seleccione Artigos a Transferir\"}]},{\"id\":\"24145\",\"windowid\":\"26155\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":8},{\"value\":12},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11249\",\"windowid\":\"26155\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#597#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"1348\",\"windowid\":\"26155\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8679\",\"windowid\":\"26155\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":103},{\"value\":5},{\"value\":47},{\"value\":60},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17568\",\"windowid\":\"26155\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":25},{\"value\":31},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"23357\",\"windowid\":\"26155\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":19},{\"value\":31},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"8444\",\"windowid\":\"26155\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":19},{\"value\":8},{\"value\":12},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"24878\",\"windowid\":\"26155\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":9},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"8636\",\"windowid\":\"26155\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":13},{\"value\":14},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"31827\",\"windowid\":\"26155\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":19},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"30900\",\"windowid\":\"26155\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":13},{\"value\":24},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"31824\",\"windowid\":\"26155\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":19},{\"value\":5},{\"value\":12},{\"value\":3},{\"value\":\"#598#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"28590\",\"windowid\":\"26155\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":102},{\"value\":13},{\"value\":5},{\"value\":51},{\"value\":37},{\"value\":8},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":0}]},{\"id\":\"8624\",\"windowid\":\"26155\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":13},{\"value\":42},{\"value\":51},{\"value\":4},{\"value\":9},{\"value\":-1},{\"value\":102},{\"value\":0}]},{\"id\":\"4939\",\"windowid\":\"26155\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":0},{\"value\":5},{\"value\":12},{\"value\":3},{\"value\":\"#756#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25541\",\"windowid\":\"26155\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":13},{\"value\":5},{\"value\":5},{\"value\":3},{\"value\":\"#767#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]}]}','5',2),(1963,0,3433,'SCREEN_CONFIG_DOCUMENT_TYPES',114,'{\"objects\":[{\"id\":\"26041\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":114},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#436#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"28072\",\"windowid\":\"26041\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"15382\",\"windowid\":\"26041\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32333\",\"windowid\":\"26041\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"#437#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20115\",\"windowid\":\"26041\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#438#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31404\",\"windowid\":\"26041\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#439#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14996\",\"windowid\":\"26041\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":41},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"#442#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7540\",\"windowid\":\"26041\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"32632\",\"windowid\":\"26041\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":41},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#440#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"8757\",\"windowid\":\"26041\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":41},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#441#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"26003\",\"windowid\":\"26041\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":41},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#443#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"18153\",\"windowid\":\"26041\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":9},{\"value\":41},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"#782#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"22026\",\"windowid\":\"26041\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12010\",\"windowid\":\"26041\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29297\",\"windowid\":\"26041\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23194\",\"windowid\":\"26041\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29266\",\"windowid\":\"26041\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":26},{\"value\":26},{\"value\":27},{\"value\":3},{\"value\":\"#2057#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',1),(1965,0,3454,'SCREEN_TABLE_SELECTION',3,'{\"objects\":[{\"id\":\"28142\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":3},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#246#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"11467\",\"windowid\":\"28142\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27271\",\"windowid\":\"28142\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22030\",\"windowid\":\"28142\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":17},{\"value\":4},{\"value\":3},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"10805\",\"windowid\":\"28142\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":22},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2060#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]}]}','4',3),(1967,0,3463,'SCREEN_TABLE_CLOSE_RETAIL',10011,'{\"objects\":[{\"id\":\"18986\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":11},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#262#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"5078\",\"windowid\":\"18986\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":53},{\"value\":47},{\"value\":3},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"30280\",\"windowid\":\"18986\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":54},{\"value\":16},{\"value\":11},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"21438\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":57},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"9067\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":51},{\"value\":41},{\"value\":34},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#264#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22757\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":58},{\"value\":54},{\"value\":4},{\"value\":11},{\"value\":3},{\"value\":\"#265#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29923\",\"windowid\":\"18986\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":41},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"11737\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":59},{\"value\":54},{\"value\":7},{\"value\":11},{\"value\":3},{\"value\":\"#266#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21912\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":52},{\"value\":45},{\"value\":34},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#267#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14887\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":49},{\"value\":34},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#268#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15877\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":68},{\"value\":41},{\"value\":31},{\"value\":12},{\"value\":3},{\"value\":\"#269#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3836\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":54},{\"value\":41},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#270#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29398\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":55},{\"value\":45},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#271#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15803\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":56},{\"value\":49},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#272#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8649\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":141},{\"value\":54},{\"value\":13},{\"value\":11},{\"value\":3},{\"value\":\"#1781#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18851\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":60},{\"value\":54},{\"value\":16},{\"value\":11},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12375\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":62},{\"value\":54},{\"value\":22},{\"value\":11},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11362\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31096\",\"windowid\":\"18986\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":42},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6531\",\"windowid\":\"18986\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":7},{\"value\":12},{\"value\":26},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":1}]},{\"id\":\"681\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"3541\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"28967\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"28321\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":12},{\"value\":26},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"7695\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":16},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"32166\",\"windowid\":\"18986\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":60},{\"value\":4},{\"value\":10},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9456\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":49},{\"value\":57},{\"value\":10},{\"value\":3},{\"value\":\"#773#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"28114\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":12},{\"value\":19},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"25625\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":54},{\"value\":38},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#776#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"9968\",\"windowid\":\"18986\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":16},{\"value\":42},{\"value\":33},{\"value\":4},{\"value\":5},{\"value\":-2},{\"value\":-1},{\"value\":2}]},{\"id\":\"25619\",\"windowid\":\"18986\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":10},{\"value\":12},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":2},{\"value\":1}]},{\"id\":\"30631\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"2083\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"12405\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"14297\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":12},{\"value\":26},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"14228\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":16},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"29155\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":16},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#773#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"25828\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":76},{\"value\":16},{\"value\":33},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#774#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"31433\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":12},{\"value\":19},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"11857\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":78},{\"value\":16},{\"value\":37},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#778#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"11838\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":79},{\"value\":12},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#781#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"12375\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":49},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#779#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"28702\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":82},{\"value\":54},{\"value\":19},{\"value\":11},{\"value\":3},{\"value\":\"#813#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15233\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":663},{\"value\":54},{\"value\":31},{\"value\":11},{\"value\":3},{\"value\":\"#1459#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25184\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":88},{\"value\":31},{\"value\":69},{\"value\":10},{\"value\":3},{\"value\":\"#1392#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5920\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":42},{\"value\":69},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1619#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28537\",\"windowid\":\"18986\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":54},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27282\",\"windowid\":\"18986\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":54},{\"value\":25},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#275#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29963\",\"windowid\":\"18986\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":120},{\"value\":54},{\"value\":10},{\"value\":11},{\"value\":3},{\"value\":\"#1729#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]}]}','5',2),(1968,0,3462,'SCREEN_TABLE_CLOSE_DISCO',1011,'{\"objects\":[{\"id\":\"16506\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":11},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#262#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"14378\",\"windowid\":\"16506\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":53},{\"value\":47},{\"value\":3},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"5584\",\"windowid\":\"16506\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":54},{\"value\":17},{\"value\":11},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"10412\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":57},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"16091\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22900\",\"windowid\":\"16506\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":42},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21994\",\"windowid\":\"16506\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":7},{\"value\":12},{\"value\":26},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":1}]},{\"id\":\"4278\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":16},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"20727\",\"windowid\":\"16506\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":60},{\"value\":4},{\"value\":10},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31415\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":49},{\"value\":57},{\"value\":10},{\"value\":3},{\"value\":\"#773#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"18591\",\"windowid\":\"16506\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":16},{\"value\":42},{\"value\":42},{\"value\":4},{\"value\":5},{\"value\":-2},{\"value\":-1},{\"value\":2}]},{\"id\":\"7521\",\"windowid\":\"16506\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":10},{\"value\":12},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":2},{\"value\":1}]},{\"id\":\"17371\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":16},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"412\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":16},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#773#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"5762\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":76},{\"value\":16},{\"value\":33},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#774#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"2113\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":78},{\"value\":16},{\"value\":37},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#778#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"4319\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":79},{\"value\":12},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#781#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"20455\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":58},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#779#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"28887\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":51},{\"value\":41},{\"value\":32},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#264#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31196\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":58},{\"value\":54},{\"value\":4},{\"value\":11},{\"value\":3},{\"value\":\"#265#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18814\",\"windowid\":\"16506\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":41},{\"value\":4},{\"value\":12},{\"value\":25},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"20476\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":59},{\"value\":54},{\"value\":7},{\"value\":11},{\"value\":3},{\"value\":\"#266#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31748\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":52},{\"value\":45},{\"value\":32},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#267#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6739\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":49},{\"value\":32},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#268#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30052\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":68},{\"value\":41},{\"value\":29},{\"value\":12},{\"value\":3},{\"value\":\"#269#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10914\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":54},{\"value\":41},{\"value\":36},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#270#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15938\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":55},{\"value\":45},{\"value\":36},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#271#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5445\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":56},{\"value\":49},{\"value\":36},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#272#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5833\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":60},{\"value\":54},{\"value\":17},{\"value\":11},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2568\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":62},{\"value\":57},{\"value\":23},{\"value\":8},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26264\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":63},{\"value\":54},{\"value\":30},{\"value\":11},{\"value\":3},{\"value\":\"#277#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5360\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":70},{\"value\":54},{\"value\":10},{\"value\":11},{\"value\":3},{\"value\":\"#769#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18686\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":54},{\"value\":38},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#776#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"3590\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":74},{\"value\":54},{\"value\":42},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#777#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"10\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":82},{\"value\":54},{\"value\":20},{\"value\":11},{\"value\":3},{\"value\":\"#813#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30873\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":663},{\"value\":54},{\"value\":27},{\"value\":11},{\"value\":3},{\"value\":\"#1459#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11589\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":54},{\"value\":33},{\"value\":11},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21924\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":54},{\"value\":23},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25870\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":90},{\"value\":14},{\"value\":4},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1675#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"18990\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":92},{\"value\":14},{\"value\":9},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1676#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"6630\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":14},{\"value\":20},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"16864\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":95},{\"value\":14},{\"value\":14},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1742#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"1855\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":96},{\"value\":20},{\"value\":14},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14123\",\"windowid\":\"16506\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":120},{\"value\":54},{\"value\":13},{\"value\":11},{\"value\":3},{\"value\":\"#1729#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"16255\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"21932\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"24405\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"4282\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":12},{\"value\":26},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"14492\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":12},{\"value\":19},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"22327\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"6485\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"5918\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"14215\",\"windowid\":\"16506\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":12},{\"value\":26},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"5741\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":12},{\"value\":19},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"20741\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":125},{\"value\":13},{\"value\":9},{\"value\":13},{\"value\":3},{\"value\":\"#1903#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"5201\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":3},{\"value\":18},{\"value\":13},{\"value\":3},{\"value\":\"#1904#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"18018\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":13},{\"value\":21},{\"value\":13},{\"value\":3},{\"value\":\"#1878#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"31937\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":123},{\"value\":13},{\"value\":24},{\"value\":13},{\"value\":8},{\"value\":\"#1879#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":3}]},{\"id\":\"29347\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":124},{\"value\":13},{\"value\":32},{\"value\":13},{\"value\":8},{\"value\":\"#1880#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":3}]},{\"id\":\"2540\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":126},{\"value\":13},{\"value\":12},{\"value\":13},{\"value\":3},{\"value\":\"#1876#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"19826\",\"windowid\":\"16506\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":127},{\"value\":13},{\"value\":15},{\"value\":13},{\"value\":3},{\"value\":\"#1877#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]}]}','5',2),(1970,0,3460,'SCREEN_TABLE_CLOSE',11,'{\"objects\":[{\"id\":\"645\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":11},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#262#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"17113\",\"windowid\":\"645\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":47},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"1859\",\"windowid\":\"645\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":14},{\"value\":33},{\"value\":12},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"21511\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":57},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"24871\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":58},{\"value\":14},{\"value\":27},{\"value\":12},{\"value\":3},{\"value\":\"#265#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23349\",\"windowid\":\"645\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":0},{\"value\":26},{\"value\":12},{\"value\":13},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"21935\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":59},{\"value\":14},{\"value\":30},{\"value\":12},{\"value\":3},{\"value\":\"#266#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1409\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":0},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#268#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19637\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":68},{\"value\":0},{\"value\":39},{\"value\":12},{\"value\":3},{\"value\":\"#269#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5584\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":54},{\"value\":4},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#270#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13902\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":55},{\"value\":8},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#271#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6546\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":60},{\"value\":14},{\"value\":33},{\"value\":12},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14586\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":62},{\"value\":14},{\"value\":39},{\"value\":12},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30937\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12772\",\"windowid\":\"645\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":7},{\"value\":12},{\"value\":18},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25595\",\"windowid\":\"645\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":7},{\"value\":10},{\"value\":19},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":1}]},{\"id\":\"8318\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"29518\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":7},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"8138\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":18},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"12737\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":12},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"25349\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":16},{\"value\":4},{\"value\":10},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"20844\",\"windowid\":\"645\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":22},{\"value\":4},{\"value\":10},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6291\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":49},{\"value\":57},{\"value\":10},{\"value\":3},{\"value\":\"#773#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"316\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"27993\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":14},{\"value\":42},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#776#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"21866\",\"windowid\":\"645\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":16},{\"value\":42},{\"value\":8},{\"value\":4},{\"value\":5},{\"value\":-2},{\"value\":-1},{\"value\":2}]},{\"id\":\"31726\",\"windowid\":\"645\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":7},{\"value\":12},{\"value\":19},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":2},{\"value\":1}]},{\"id\":\"106\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"3657\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":7},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"18534\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":18},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"3534\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":12},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"17801\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":22},{\"value\":4},{\"value\":6},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"7410\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":16},{\"value\":4},{\"value\":6},{\"value\":3},{\"value\":\"#773#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"6048\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":76},{\"value\":16},{\"value\":33},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#774#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"28361\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"30180\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":78},{\"value\":16},{\"value\":37},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#778#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"21565\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":79},{\"value\":12},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#781#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"20966\",\"windowid\":\"645\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":24},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#779#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"29630\",\"windowid\":\"645\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":82},{\"value\":14},{\"value\":36},{\"value\":12},{\"value\":3},{\"value\":\"#813#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','4',3),(1972,0,3458,'SCREEN_TABLE_CLOSE_DISCO',1011,'{\"objects\":[{\"id\":\"21233\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":11},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#262#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"19903\",\"windowid\":\"21233\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":47},{\"value\":3},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"3318\",\"windowid\":\"21233\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":42},{\"value\":17},{\"value\":11},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"32545\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":57},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"7454\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":51},{\"value\":29},{\"value\":34},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#264#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6618\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":58},{\"value\":42},{\"value\":4},{\"value\":11},{\"value\":3},{\"value\":\"#265#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17150\",\"windowid\":\"21233\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":29},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"16183\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":59},{\"value\":42},{\"value\":7},{\"value\":11},{\"value\":3},{\"value\":\"#266#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8850\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":52},{\"value\":33},{\"value\":34},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#267#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29596\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":37},{\"value\":34},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#268#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17821\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":68},{\"value\":29},{\"value\":31},{\"value\":12},{\"value\":3},{\"value\":\"#269#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7403\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":54},{\"value\":29},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#270#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6397\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":55},{\"value\":33},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#271#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8456\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":56},{\"value\":37},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#272#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19863\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":60},{\"value\":42},{\"value\":17},{\"value\":11},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3462\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":62},{\"value\":45},{\"value\":23},{\"value\":8},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"469\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":63},{\"value\":42},{\"value\":31},{\"value\":11},{\"value\":3},{\"value\":\"#277#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14791\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32705\",\"windowid\":\"21233\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":42},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7957\",\"windowid\":\"21233\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":7},{\"value\":12},{\"value\":26},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":1}]},{\"id\":\"32065\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":16},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"15993\",\"windowid\":\"21233\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30472\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":70},{\"value\":42},{\"value\":10},{\"value\":11},{\"value\":3},{\"value\":\"#769#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27233\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":49},{\"value\":57},{\"value\":10},{\"value\":3},{\"value\":\"#773#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"17462\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":42},{\"value\":38},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#776#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"14925\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":74},{\"value\":42},{\"value\":42},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#777#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"12213\",\"windowid\":\"21233\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":16},{\"value\":42},{\"value\":33},{\"value\":4},{\"value\":5},{\"value\":-2},{\"value\":-1},{\"value\":2}]},{\"id\":\"24865\",\"windowid\":\"21233\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":10},{\"value\":12},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":2},{\"value\":1}]},{\"id\":\"3551\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":16},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"8911\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":16},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#773#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"14320\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":76},{\"value\":16},{\"value\":33},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#774#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"19567\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":78},{\"value\":16},{\"value\":37},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#778#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"25667\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":79},{\"value\":12},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#781#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"27138\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":49},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#779#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"18818\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":82},{\"value\":42},{\"value\":20},{\"value\":11},{\"value\":3},{\"value\":\"#813#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3961\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":663},{\"value\":42},{\"value\":28},{\"value\":11},{\"value\":3},{\"value\":\"#1459#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11298\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":88},{\"value\":31},{\"value\":69},{\"value\":10},{\"value\":3},{\"value\":\"#1392#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30383\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":42},{\"value\":69},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1619#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12511\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":90},{\"value\":16},{\"value\":5},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1675#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"633\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":92},{\"value\":16},{\"value\":10},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1676#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"25631\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":16},{\"value\":21},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"30460\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":95},{\"value\":16},{\"value\":15},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1742#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"9571\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":96},{\"value\":22},{\"value\":15},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31207\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":97},{\"value\":16},{\"value\":59},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#971#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"24357\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":42},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16704\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":42},{\"value\":23},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30428\",\"windowid\":\"21233\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":120},{\"value\":42},{\"value\":13},{\"value\":11},{\"value\":3},{\"value\":\"#1729#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"19948\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"32259\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"14102\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"13385\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":12},{\"value\":26},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"30235\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":12},{\"value\":19},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"11353\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"24241\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"12257\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"3420\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":12},{\"value\":26},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"9400\",\"windowid\":\"21233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":12},{\"value\":19},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"9839\",\"windowid\":\"21233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":115},{\"value\":16},{\"value\":38},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1901#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]}]}','0',1),(1976,0,3384,'SCREEN_TABLE_EDIT_RETAIL',5004,'{\"objects\":[{\"id\":\"19807\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#1747#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"27499\",\"windowid\":\"19807\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":302},{\"value\":0},{\"value\":9},{\"value\":37},{\"value\":33},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"11824\",\"windowid\":\"19807\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":8},{\"value\":49},{\"value\":34},{\"value\":[{\"v\":4},{\"v\":25},{\"v\":4},{\"v\":5},{\"v\":4},{\"v\":5}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"18773\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":59},{\"value\":17},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1695#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"24311\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":6},{\"value\":46},{\"value\":8},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1153.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29842\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":38},{\"value\":46},{\"value\":11},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1151.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19753\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":7},{\"value\":42},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24667\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21585\",\"windowid\":\"19807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":1},{\"value\":13},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"8824\",\"windowid\":\"19807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":2},{\"value\":42},{\"value\":5},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"25048\",\"windowid\":\"19807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":64},{\"value\":49},{\"value\":25},{\"value\":16},{\"value\":3},{\"value\":\"#1696#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"28269\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":59},{\"value\":21},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1697#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1079.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"20485\",\"windowid\":\"19807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":34},{\"value\":42},{\"value\":5},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7911\",\"windowid\":\"19807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":24},{\"value\":42},{\"value\":10},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31277\",\"windowid\":\"19807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":9},{\"value\":42},{\"value\":15},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26567\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":71},{\"value\":14},{\"value\":46},{\"value\":8},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1701#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1080.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23333\",\"windowid\":\"19807\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":49},{\"value\":11},{\"value\":16},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"23864\",\"windowid\":\"19807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":49},{\"value\":8},{\"value\":16},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20590\",\"windowid\":\"19807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":49},{\"value\":11},{\"value\":16},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8364\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":81},{\"value\":49},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12226\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":82},{\"value\":53},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19141\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":83},{\"value\":57},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2522\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":84},{\"value\":49},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8557\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":85},{\"value\":53},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3249\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":86},{\"value\":57},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25505\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":87},{\"value\":49},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18573\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":88},{\"value\":53},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"199\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":57},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30350\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":53},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32646\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":72},{\"value\":49},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5283\",\"windowid\":\"19807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":90},{\"value\":49},{\"value\":28},{\"value\":16},{\"value\":3},{\"value\":\"#1702#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"14449\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":61},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1084.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2562\",\"windowid\":\"19807\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":39},{\"value\":42},{\"value\":10},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27406\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":92},{\"value\":61},{\"value\":41},{\"value\":4},{\"value\":10},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1085.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24736\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":91},{\"value\":57},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1713#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10230\",\"windowid\":\"19807\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":13},{\"value\":0},{\"value\":36},{\"value\":4},{\"value\":6},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"17218\",\"windowid\":\"19807\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":6},{\"value\":4},{\"value\":43},{\"value\":4},{\"value\":6},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"8486\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":42},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11536\",\"windowid\":\"19807\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":0},{\"value\":8},{\"value\":49},{\"value\":34},{\"value\":8},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":0}]},{\"id\":\"14785\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":95},{\"value\":0},{\"value\":4},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1728#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24280\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":97},{\"value\":22},{\"value\":46},{\"value\":8},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1734#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1081.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14528\",\"windowid\":\"19807\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":49},{\"value\":17},{\"value\":16},{\"value\":14},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":0},{\"v\":0},{\"v\":0},{\"v\":3}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"3946\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":93},{\"value\":61},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1083.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24182\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-21},{\"value\":49},{\"value\":21},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1750#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1078.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"14246\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-22},{\"value\":54},{\"value\":21},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1751#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1077.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"23241\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":54},{\"value\":17},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"8250\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":49},{\"value\":17},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1431#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1067.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"21129\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":30},{\"value\":46},{\"value\":8},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1152.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17960\",\"windowid\":\"19807\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":601},{\"value\":49},{\"value\":0},{\"value\":16},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"logo_cliente.png\"},{\"value\":50},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21595\",\"windowid\":\"19807\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":124},{\"value\":49},{\"value\":5},{\"value\":16},{\"value\":3},{\"value\":\"#1875#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"5247\",\"windowid\":\"19807\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":131},{\"value\":49},{\"value\":14},{\"value\":16},{\"value\":3},{\"value\":\"#1924#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]}]}','5',2),(1977,0,3376,'SCREEN_TABLE_EDIT_RETAIL',5004,'{\"objects\":[{\"id\":\"20557\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1747#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"29276\",\"windowid\":\"20557\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":302},{\"value\":0},{\"value\":9},{\"value\":37},{\"value\":33},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"3002\",\"windowid\":\"20557\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":8},{\"value\":37},{\"value\":34},{\"value\":[{\"v\":3},{\"v\":19},{\"v\":3},{\"v\":4},{\"v\":3},{\"v\":4}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"13549\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":47},{\"value\":17},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1695#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"15778\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":6},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1153.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10761\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":30},{\"value\":46},{\"value\":7},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1874#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1151.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22257\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":7},{\"value\":42},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10444\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23730\",\"windowid\":\"20557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":1},{\"value\":10},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"27403\",\"windowid\":\"20557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":2},{\"value\":42},{\"value\":5},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"3727\",\"windowid\":\"20557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":64},{\"value\":37},{\"value\":25},{\"value\":16},{\"value\":3},{\"value\":\"#1696#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"4681\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":47},{\"value\":21},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1697#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1079.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"28280\",\"windowid\":\"20557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":26},{\"value\":42},{\"value\":4},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19784\",\"windowid\":\"20557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":19},{\"value\":42},{\"value\":7},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6768\",\"windowid\":\"20557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":9},{\"value\":42},{\"value\":10},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27423\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":71},{\"value\":12},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1701#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1080.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12750\",\"windowid\":\"20557\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":37},{\"value\":11},{\"value\":16},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"20475\",\"windowid\":\"20557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":37},{\"value\":8},{\"value\":16},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2421\",\"windowid\":\"20557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":37},{\"value\":11},{\"value\":16},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8439\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":81},{\"value\":37},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20171\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":82},{\"value\":41},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26548\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":83},{\"value\":45},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30588\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":84},{\"value\":37},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13196\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":85},{\"value\":41},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3151\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":86},{\"value\":45},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11680\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":87},{\"value\":37},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3984\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":88},{\"value\":41},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32269\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":45},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"988\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":41},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5130\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":72},{\"value\":37},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32348\",\"windowid\":\"20557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":90},{\"value\":37},{\"value\":28},{\"value\":16},{\"value\":3},{\"value\":\"#1702#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"12227\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":49},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1084.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18344\",\"windowid\":\"20557\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":30},{\"value\":42},{\"value\":7},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17442\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":92},{\"value\":49},{\"value\":41},{\"value\":4},{\"value\":10},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1085.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26854\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":91},{\"value\":45},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1713#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14323\",\"windowid\":\"20557\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":10},{\"value\":0},{\"value\":27},{\"value\":4},{\"value\":4},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"12016\",\"windowid\":\"20557\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":6},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"2301\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":42},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15226\",\"windowid\":\"20557\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":0},{\"value\":9},{\"value\":37},{\"value\":33},{\"value\":6},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":0}]},{\"id\":\"10502\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":95},{\"value\":0},{\"value\":4},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1728#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15502\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":97},{\"value\":18},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1734#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1081.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27614\",\"windowid\":\"20557\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":37},{\"value\":17},{\"value\":16},{\"value\":14},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":0},{\"v\":0},{\"v\":0},{\"v\":3}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"25827\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":93},{\"value\":49},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1083.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22247\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-21},{\"value\":37},{\"value\":21},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1750#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1078.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"21454\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-22},{\"value\":42},{\"value\":21},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1751#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1077.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"26036\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":42},{\"value\":17},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"20962\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":37},{\"value\":17},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1431#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1067.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"13485\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":24},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1152.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12158\",\"windowid\":\"20557\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":601},{\"value\":37},{\"value\":0},{\"value\":16},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"logo_cliente.png\"},{\"value\":50},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18915\",\"windowid\":\"20557\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":124},{\"value\":37},{\"value\":5},{\"value\":16},{\"value\":3},{\"value\":\"#1875#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"15576\",\"windowid\":\"20557\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":131},{\"value\":37},{\"value\":14},{\"value\":16},{\"value\":3},{\"value\":\"#1924#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]}]}','0',1),(1981,0,3511,'SCREEN_TABLE_EDIT_DIRECT_CLOSE',1004,'{\"objects\":[{\"id\":\"23267\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"27169\",\"windowid\":\"23267\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":12},{\"value\":10},{\"value\":53},{\"value\":41},{\"value\":9},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7448\",\"windowid\":\"23267\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":31},{\"value\":12},{\"value\":12},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"22801\",\"windowid\":\"23267\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":5}]},{\"value\":\"#1772#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"446\",\"windowid\":\"23267\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"8284\",\"windowid\":\"23267\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"12098\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":8},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25664\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31332\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-14},{\"value\":0},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#249#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1054.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18961\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"20596\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"6650\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":4},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12422\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14327\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":8},{\"value\":47},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#966#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"4886\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1431#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1067.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"30038\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":8},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1152.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"23537\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1741#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1071.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"1918\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-17},{\"value\":8},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#754#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1050.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"4202\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":8},{\"value\":47},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#967#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"5595\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#969#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1068.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"7195\",\"windowid\":\"23267\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"8209\",\"windowid\":\"23267\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":12},{\"value\":0},{\"value\":53},{\"value\":5},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"193\",\"windowid\":\"23267\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":12},{\"value\":5},{\"value\":53},{\"value\":5},{\"value\":8},{\"value\":-2},{\"value\":103},{\"value\":-1}]}]}','5',2),(1983,0,3509,'SCREEN_TABLE_EDIT_DIRECT_CLOSE',1004,'{\"objects\":[{\"id\":\"30711\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"24503\",\"windowid\":\"30711\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":31},{\"value\":12},{\"value\":12},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"4976\",\"windowid\":\"30711\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":5}]},{\"value\":\"#1772#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30731\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-14},{\"value\":0},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#249#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1054.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18647\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"8399\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"10050\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":4},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24713\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":8},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10175\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1741#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1071.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"11820\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10029\",\"windowid\":\"30711\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"30208\",\"windowid\":\"30711\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"32751\",\"windowid\":\"30711\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":5},{\"value\":6},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"21278\",\"windowid\":\"30711\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":12},{\"value\":10},{\"value\":41},{\"value\":41},{\"value\":7},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18962\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-17},{\"value\":8},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#754#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1050.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"2399\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":8},{\"value\":47},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#966#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"15848\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":8},{\"value\":47},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#967#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"27697\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#969#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1068.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"21532\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1431#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1067.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"180\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"22480\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24066\",\"windowid\":\"30711\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":12},{\"value\":5},{\"value\":41},{\"value\":5},{\"value\":6},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"582\",\"windowid\":\"30711\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":8},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1152.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]}]}','0',1),(1985,0,3506,'SCREEN_TABLE_SELECTION',3,'{\"objects\":[{\"id\":\"25760\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":3},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#246#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"17092\",\"windowid\":\"25760\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":47},{\"value\":11},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12577\",\"windowid\":\"25760\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17566\",\"windowid\":\"25760\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":55},{\"value\":4},{\"value\":6},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"17306\",\"windowid\":\"25760\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":60},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2060#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]}]}','5',2),(1987,0,3504,'SCREEN_DESKTOPSESSIONS',8,'{\"objects\":[{\"id\":\"14686\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":8},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#260#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"17760\",\"windowid\":\"14686\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11066\",\"windowid\":\"14686\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"828\",\"windowid\":\"14686\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":43},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-2},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1988,0,3503,'SCREEN_CONFIG_MAIN',5,'{\"objects\":[{\"id\":\"395\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":5},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#259#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"8029\",\"windowid\":\"395\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"26992\",\"windowid\":\"395\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":43},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14543\",\"windowid\":\"395\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1989,0,3501,'SCREEN_TABLE_SELECTION_SERVICE',11003,'{\"objects\":[{\"id\":\"2185\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":3},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#246#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"28365\",\"windowid\":\"2185\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":47},{\"value\":10},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10075\",\"windowid\":\"2185\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11795\",\"windowid\":\"2185\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":7},{\"value\":-1},{\"value\":102},{\"value\":-1}]}]}','0',1),(1990,0,3500,'SCREEN_TABLE_SELECTION',3,'{\"objects\":[{\"id\":\"10062\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":3},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#246#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"18937\",\"windowid\":\"10062\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":102},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":47},{\"value\":10},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1011\",\"windowid\":\"10062\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20550\",\"windowid\":\"10062\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":43},{\"value\":4},{\"value\":6},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"7161\",\"windowid\":\"10062\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":48},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2060#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]}]}','0',1),(1992,0,3526,'SCREEN_LICENSING_WIZARD_SERVICES',11200,'{\"objects\":[{\"id\":\"26251\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":200},{\"value\":10},{\"value\":11},{\"value\":33},{\"value\":25},{\"value\":\"#1245#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"24574\",\"windowid\":\"26251\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":33},{\"value\":23},{\"value\":7},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"6627\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":26},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1246#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"19688\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":10},{\"value\":1},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"22376\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":18},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1248#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":2}]},{\"id\":\"15405\",\"windowid\":\"26251\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":1},{\"value\":7},{\"value\":31},{\"value\":10},{\"value\":[{\"v\":31}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":2},{\"value\":0}]},{\"id\":\"29764\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":23},{\"value\":18},{\"value\":9},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1246#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"32571\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":18},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1248#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"20820\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":12},{\"value\":19},{\"value\":3},{\"value\":\"#58#\"},{\"value\":1},{\"value\":50},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"7167\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":8},{\"value\":9},{\"value\":3},{\"value\":\"#1186#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"27466\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":22},{\"value\":8},{\"value\":10},{\"value\":3},{\"value\":\"#1187#\"},{\"value\":1},{\"value\":11},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"22773\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":13},{\"value\":25},{\"value\":18},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":3}]},{\"id\":\"252\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":5},{\"value\":31},{\"value\":13},{\"value\":\"#1251#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":3}]},{\"id\":\"27327\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":15},{\"value\":27},{\"value\":18},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"10531\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":1},{\"value\":4},{\"value\":31},{\"value\":13},{\"value\":\"#58#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"22370\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":16},{\"value\":22},{\"value\":18},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"15122\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":26},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1246#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":4}]},{\"id\":\"1190\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":18},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1248#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":4}]},{\"id\":\"18994\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":12},{\"value\":31},{\"value\":3},{\"value\":\"#1249#\"},{\"value\":1},{\"value\":50},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":4}]},{\"id\":\"21027\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":1},{\"value\":5},{\"value\":31},{\"value\":3},{\"value\":\"#58#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":5}]},{\"id\":\"12866\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":1},{\"value\":9},{\"value\":31},{\"value\":3},{\"value\":\"#1254#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":5}]},{\"id\":\"25855\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":1},{\"value\":13},{\"value\":31},{\"value\":3},{\"value\":\"#1255#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":5}]},{\"id\":\"25258\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":26},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1246#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":5}]},{\"id\":\"14964\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":10},{\"value\":1},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":5}]},{\"id\":\"18792\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":18},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1248#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":5}]},{\"id\":\"32649\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":22},{\"value\":1},{\"value\":4},{\"value\":31},{\"value\":3},{\"value\":\"#58#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"604\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":1},{\"value\":12},{\"value\":12},{\"value\":3},{\"value\":\"#58#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"24496\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":1},{\"value\":8},{\"value\":12},{\"value\":3},{\"value\":\"#58#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"22016\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":1},{\"value\":8},{\"value\":31},{\"value\":3},{\"value\":\"#58#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":4}]},{\"id\":\"18717\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":27},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1246#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":6}]},{\"id\":\"10957\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":14},{\"value\":18},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1248#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":6}]},{\"id\":\"23830\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":1},{\"value\":0},{\"value\":16},{\"value\":3},{\"value\":\"#1981#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"26333\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":25},{\"value\":17},{\"value\":0},{\"value\":16},{\"value\":3},{\"value\":\"#1982#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"13200\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":26},{\"value\":1},{\"value\":3},{\"value\":16},{\"value\":3},{\"value\":\"#1983#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"27532\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":31},{\"value\":17},{\"value\":6},{\"value\":16},{\"value\":3},{\"value\":\"#1984#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"5325\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":32},{\"value\":1},{\"value\":12},{\"value\":11},{\"value\":3},{\"value\":\"#1985#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"25375\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":27},{\"value\":1},{\"value\":6},{\"value\":16},{\"value\":3},{\"value\":\"#1987#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"8411\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":28},{\"value\":1},{\"value\":9},{\"value\":11},{\"value\":3},{\"value\":\"#1988#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"6338\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":29},{\"value\":12},{\"value\":9},{\"value\":10},{\"value\":3},{\"value\":\"#1989#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"23590\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":35},{\"value\":22},{\"value\":12},{\"value\":11},{\"value\":3},{\"value\":\"#1991#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"5471\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":36},{\"value\":22},{\"value\":15},{\"value\":11},{\"value\":3},{\"value\":\"#1992#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"4473\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":30},{\"value\":17},{\"value\":3},{\"value\":16},{\"value\":3},{\"value\":\"#1993#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"20491\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":37},{\"value\":22},{\"value\":9},{\"value\":11},{\"value\":3},{\"value\":\"#1994#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":6}]},{\"id\":\"15650\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":38},{\"value\":1},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#58#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"30508\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":21},{\"value\":33},{\"value\":10},{\"value\":3},{\"value\":\"#1186#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"4625\",\"windowid\":\"26251\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":39},{\"value\":13},{\"value\":4},{\"value\":19},{\"value\":3},{\"value\":\"#58#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"16260\",\"windowid\":\"26251\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":34},{\"value\":12},{\"value\":15},{\"value\":10},{\"value\":3},{\"value\":\"#1990#\"},{\"value\":[{\"v\":10}]},{\"value\":6},{\"value\":\"12\"},{\"value\":6},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"28980\",\"windowid\":\"26251\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":40},{\"value\":12},{\"value\":12},{\"value\":10},{\"value\":3},{\"value\":\"#1996#\"},{\"value\":[{\"v\":10}]},{\"value\":6},{\"value\":\"12\"},{\"value\":6},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"20667\",\"windowid\":\"26251\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":33},{\"value\":1},{\"value\":15},{\"value\":11},{\"value\":3},{\"value\":\"#1986#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":6},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"11349\",\"windowid\":\"26251\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":10},{\"value\":1},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":6}]}]}','0',1),(1994,0,3524,'SCREEN_DEVICE_DRIVERS',177,'\n{\n    \"objects\": [{\n        \"id\": \"26635\",\n        \"type\": \"com.sage.components.window.Window\",\n        \"arguments\": [{\n            \"value\": 177\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 53\n        }, {\n            \"value\": 45\n        }, {\n            \"value\": \"#1582#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": \"[[1]]\"\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"22901\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.panels.Panel\",\n        \"arguments\": [{\n            \"value\": 301\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 41\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"\"\n        }]\n    }, {\n        \"id\": \"23090\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.list.ListBox\",\n        \"arguments\": [{\n            \"value\": 201\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 35\n        }, {\n            \"value\": [{\n                \"v\": 12\n            }]\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"4607\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 2\n        }, {\n            \"value\": 21\n        }, {\n            \"value\": 5\n        }, {\n            \"value\": 11\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1583#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"20924\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 4778\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 12\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#344#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }]\n    },  {\n        \"id\": \"18685\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 90\n        }, {\n            \"value\": 370\n        }, {\n            \"value\": 59\n        }, {\n            \"value\": 53\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#688#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 2\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }]\n    }, {\n        \"id\": \"16131\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 3\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 5\n        }, {\n            \"value\": 7\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1585#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"25634\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 4\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 9\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1586#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"18720\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 5\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1587#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"8005\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 6\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 17\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1588#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"18151\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 7\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 21\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1589#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"25982\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 8\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 25\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1590#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"20020\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 9\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 29\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1591#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"30675\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 10\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 33\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1592#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"31781\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 11\n        }, {\n            \"value\": 33\n        }, {\n            \"value\": 5\n        }, {\n            \"value\": 20\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1593#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"9809\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 12\n        }, {\n            \"value\": 33\n        }, {\n            \"value\": 9\n        }, {\n            \"value\": 20\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1594#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"4693\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 13\n        }, {\n            \"value\": 33\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 20\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1595#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"7910\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 14\n        }, {\n            \"value\": 33\n        }, {\n            \"value\": 17\n        }, {\n            \"value\": 20\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1596#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"5835\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 15\n        }, {\n            \"value\": 33\n        }, {\n            \"value\": 21\n        }, {\n            \"value\": 20\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1597#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"26627\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 16\n        }, {\n            \"value\": 33\n        }, {\n            \"value\": 25\n        }, {\n            \"value\": 20\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1598#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 50\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"21657\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 17\n        }, {\n            \"value\": 33\n        }, {\n            \"value\": 29\n        }, {\n            \"value\": 20\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1599#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"3404\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 18\n        }, {\n            \"value\": 33\n        }, {\n            \"value\": 51\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"CCheckBox\"\n        }, {\n            \"value\": \"#1600#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 0\n        }]\n    }, {\n        \"id\": \"19008\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 19\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 9\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1601#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }]\n    }, {\n        \"id\": \"30443\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 20\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1602#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }]\n    }, {\n        \"id\": \"15435\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 21\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 17\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1603#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }]\n    }, {\n        \"id\": \"26675\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 22\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 21\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1604#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 1\n        }]\n    }, {\n        \"id\": \"5580\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 23\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 9\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1605#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 2\n        }]\n    }, {\n        \"id\": \"18626\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 24\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1606#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 2\n        }]\n    }, {\n        \"id\": \"19858\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": 25\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 29\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"CCheckBox\"\n        }, {\n            \"value\": \"#1607#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"null\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 2\n        }]\n    }, {\n        \"id\": \"13117\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": -2\n        }, {\n            \"value\": 47\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#297#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"1041.png\"\n        }, {\n            \"value\": 5\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"32346\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.buttons.Button\",\n        \"arguments\": [{\n            \"value\": -1\n        }, {\n            \"value\": 41\n        }, {\n            \"value\": 39\n        }, {\n            \"value\": 6\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": \"CButton\"\n        }, {\n            \"value\": \"#298#\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"0xFFFFFF\"\n        }, {\n            \"value\": \"1042.png\"\n        }, {\n            \"value\": 5\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": -1\n        }]\n    }, {\n        \"id\": \"24407\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 26\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 17\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1601#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 2\n        }]\n    }, {\n        \"id\": \"4430\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 27\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 21\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1602#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 2\n        }]\n    }, {\n        \"id\": \"26834\",\n        \"windowid\": \"26635\",\n        \"type\": \"com.sage.components.text.TextBox\",\n        \"arguments\": [{\n            \"value\": 28\n        }, {\n            \"value\": 13\n        }, {\n            \"value\": 25\n        }, {\n            \"value\": 19\n        }, {\n            \"value\": 3\n        }, {\n            \"value\": \"#1603#\"\n        }, {\n            \"value\": 1\n        }, {\n            \"value\": 4\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": \"12\"\n        }, {\n            \"value\": 0\n        }, {\n            \"value\": -1\n        }, {\n            \"value\": 2\n        }]\n    }]\n}\n','0',1),(1997,0,3521,'SCREEN_CONFIG_SYSTEM_SERVICES',11117,'{\"objects\":[{\"id\":\"7189\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":117},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#486#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"21524\",\"windowid\":\"7189\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"16341\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":0},{\"value\":13},{\"value\":16},{\"value\":3},{\"value\":\"#489#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21383\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#490#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7430\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":0},{\"value\":20},{\"value\":16},{\"value\":3},{\"value\":\"#493#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22136\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":0},{\"value\":23},{\"value\":16},{\"value\":3},{\"value\":\"#494#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15680\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":0},{\"value\":10},{\"value\":16},{\"value\":3},{\"value\":\"#495#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4285\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":0},{\"value\":26},{\"value\":16},{\"value\":3},{\"value\":\"#496#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31545\",\"windowid\":\"7189\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":17},{\"value\":1},{\"value\":36},{\"value\":24},{\"value\":[{\"v\":36}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"22428\",\"windowid\":\"7189\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":12},{\"value\":0},{\"value\":1},{\"value\":16},{\"value\":3},{\"value\":\"#498#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"20190\",\"windowid\":\"7189\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":0},{\"value\":17},{\"value\":16},{\"value\":3},{\"value\":\"#492#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"25608\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":0},{\"value\":29},{\"value\":16},{\"value\":3},{\"value\":\"#1393#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4903\",\"windowid\":\"7189\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23459\",\"windowid\":\"7189\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23441\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":17},{\"value\":26},{\"value\":16},{\"value\":3},{\"value\":\"#1862#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"32465\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":17},{\"value\":29},{\"value\":16},{\"value\":3},{\"value\":\"#1863#\"},{\"value\":1},{\"value\":11},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24165\",\"windowid\":\"7189\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":17},{\"value\":34},{\"value\":26},{\"value\":10},{\"value\":3},{\"value\":\"#2017#\"},{\"value\":[{\"v\":10}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"3170\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":34},{\"value\":29},{\"value\":18},{\"value\":3},{\"value\":\"#2018#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25137\",\"windowid\":\"7189\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":16},{\"value\":44},{\"value\":26},{\"value\":8},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#2019#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12193\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":0},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#2027#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20518\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":22},{\"value\":0},{\"value\":33},{\"value\":33},{\"value\":3},{\"value\":\"#2058#\"},{\"value\":1},{\"value\":50},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13260\",\"windowid\":\"7189\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":23},{\"value\":0},{\"value\":36},{\"value\":33},{\"value\":3},{\"value\":\"#2059#\"},{\"value\":1},{\"value\":50},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',1),(1999,0,3519,'SCREEN_CONFIG_ITEMS_SERVICES',11104,'{\"objects\":[{\"id\":\"22622\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":104},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#301#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"17331\",\"windowid\":\"22622\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"23555\",\"windowid\":\"22622\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":32},{\"value\":[{\"v\":12}]},{\"value\":\"#1769#\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"13400\",\"windowid\":\"22622\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":18},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#321#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"30457\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"32228\",\"windowid\":\"22622\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":38},{\"value\":0},{\"value\":36},{\"value\":12},{\"value\":3},{\"value\":\"#972#\"},{\"value\":[{\"v\":12}]},{\"value\":5},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"10153\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":27},{\"value\":2},{\"value\":26},{\"value\":3},{\"value\":\"#303#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11768\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":13},{\"value\":2},{\"value\":13},{\"value\":3},{\"value\":\"#305#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4771\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":40},{\"value\":18},{\"value\":13},{\"value\":3},{\"value\":\"#307#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13965\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":40},{\"value\":21},{\"value\":13},{\"value\":3},{\"value\":\"#308#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27386\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":40},{\"value\":24},{\"value\":13},{\"value\":3},{\"value\":\"#309#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"27493\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":40},{\"value\":27},{\"value\":13},{\"value\":3},{\"value\":\"#310#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22140\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":40},{\"value\":30},{\"value\":13},{\"value\":3},{\"value\":\"#311#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16350\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":27},{\"value\":5},{\"value\":26},{\"value\":3},{\"value\":\"#312#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29874\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":13},{\"value\":5},{\"value\":13},{\"value\":3},{\"value\":\"#315#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28794\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":27},{\"value\":14},{\"value\":26},{\"value\":3},{\"value\":\"#319#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"9927\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":25},{\"value\":13},{\"value\":14},{\"value\":13},{\"value\":3},{\"value\":\"#326#\"},{\"value\":1},{\"value\":50},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23968\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":33},{\"value\":27},{\"value\":8},{\"value\":26},{\"value\":3},{\"value\":\"#334#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26571\",\"windowid\":\"22622\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#314#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"18777\",\"windowid\":\"22622\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":13},{\"value\":27},{\"value\":18},{\"value\":12},{\"value\":3},{\"value\":\"#304#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"16365\",\"windowid\":\"22622\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":12},{\"value\":13},{\"value\":8},{\"value\":13},{\"value\":3},{\"value\":\"#302#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"30755\",\"windowid\":\"22622\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":7},{\"value\":27},{\"value\":11},{\"value\":26},{\"value\":3},{\"value\":\"#316#\"},{\"value\":[{\"v\":26}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"29344\",\"windowid\":\"22622\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":27},{\"value\":21},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1788#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"29952\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":54},{\"value\":27},{\"value\":24},{\"value\":12},{\"value\":3},{\"value\":\"#1797#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18117\",\"windowid\":\"22622\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31607\",\"windowid\":\"22622\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"338\",\"windowid\":\"22622\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24094\",\"windowid\":\"22622\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11794\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":47},{\"value\":27},{\"value\":27},{\"value\":12},{\"value\":3},{\"value\":\"#2007#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14046\",\"windowid\":\"22622\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":34},{\"value\":27},{\"value\":30},{\"value\":12},{\"value\":3},{\"value\":\"#335#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28523\",\"windowid\":\"22622\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":13},{\"value\":24},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#330#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}','0',1),(2002,0,3538,'SCREEN_DESKTOP',1,'{\"objects\":[{\"id\":\"12257\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#240#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":1}]},{\"id\":\"18227\",\"windowid\":\"12257\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":20},{\"value\":47},{\"value\":25},{\"value\":4},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6637\",\"windowid\":\"12257\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":60},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2065#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]}]}','5',2),(2004,0,3532,'SCREEN_PLU_EDIT_RETAIL',10182,'\n{\"objects\":[{\"id\":\"30073\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":182},{\"value\":2},{\"value\":6},{\"value\":50},{\"value\":28},{\"value\":\"#301#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},\n{\"id\":\"31436\",\"windowid\":\"30073\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":15},{\"value\":2},{\"value\":21},{\"value\":3},{\"value\":\"#303#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"11177\",\"windowid\":\"30073\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":44},{\"value\":22},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"17922\",\"windowid\":\"30073\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":39},{\"value\":22},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"25046\",\"windowid\":\"30073\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":15},{\"value\":14},{\"value\":21},{\"value\":3},{\"value\":\"#307#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"14513\",\"windowid\":\"30073\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":15},{\"value\":17},{\"value\":21},{\"value\":3},{\"value\":\"#308#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"13389\",\"windowid\":\"30073\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":15},{\"value\":20},{\"value\":21},{\"value\":3},{\"value\":\"#309#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"13507\",\"windowid\":\"30073\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":15},{\"value\":5},{\"value\":21},{\"value\":3},{\"value\":\"#312#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"31031\",\"windowid\":\"30073\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":2},{\"value\":13},{\"value\":3},{\"value\":\"#315#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"7044\",\"windowid\":\"30073\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":1},{\"value\":8},{\"value\":13},{\"value\":3},{\"value\":\"#319#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"5459\",\"windowid\":\"30073\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":25},{\"value\":1},{\"value\":14},{\"value\":13},{\"value\":3},{\"value\":\"#326#\"},{\"value\":1},{\"value\":50},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"13999\",\"windowid\":\"30073\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":33},{\"value\":15},{\"value\":8},{\"value\":21},{\"value\":3},{\"value\":\"#334#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"21359\",\"windowid\":\"30073\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#314#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},\n{\"id\":\"13095\",\"windowid\":\"30073\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":13},{\"value\":15},{\"value\":23},{\"value\":21},{\"value\":3},{\"value\":\"#304#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},\n{\"id\":\"2253\",\"windowid\":\"30073\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":12},{\"value\":1},{\"value\":5},{\"value\":13},{\"value\":3},{\"value\":\"#302#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},\n{\"id\":\"9568\",\"windowid\":\"30073\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":7},{\"value\":15},{\"value\":11},{\"value\":21},{\"value\":3},{\"value\":\"#316#\"},{\"value\":[{\"v\":21}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},\n{\"id\":\"17223\",\"windowid\":\"30073\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":1},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1788#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"862\",\"windowid\":\"30073\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":1},{\"value\":20},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#330#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"18729\",\"windowid\":\"30073\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":29},{\"value\":1},{\"value\":23},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#333#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]}]}\n','0',1),(2007,0,3529,'SCREEN_REPORTS',145,'{\"objects\":[{\"id\":\"27360\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":145},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#887#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"12793\",\"windowid\":\"27360\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"23061\",\"windowid\":\"27360\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12472\",\"windowid\":\"27360\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"10839\",\"windowid\":\"27360\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":2},{\"value\":13},{\"value\":20},{\"value\":13},{\"value\":3},{\"value\":\"#889#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"17808\",\"windowid\":\"27360\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":40},{\"value\":34},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#890#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1097.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6545\",\"windowid\":\"27360\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":27},{\"value\":4},{\"value\":26},{\"value\":30},{\"value\":\"#891#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"12987\",\"windowid\":\"27360\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":13},{\"value\":34},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#892#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1098.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21799\",\"windowid\":\"27360\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":13},{\"value\":12},{\"value\":\"#893#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"23510\",\"windowid\":\"27360\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":14},{\"value\":13},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"5860\",\"windowid\":\"27360\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":13},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"#998#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28055\",\"windowid\":\"27360\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12887\",\"windowid\":\"27360\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":16},{\"value\":27},{\"value\":34},{\"value\":13},{\"value\":3},{\"value\":\"#2000#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"10303\",\"windowid\":\"27360\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":13},{\"value\":24},{\"value\":13},{\"value\":3},{\"value\":\"#1844#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24062\",\"windowid\":\"27360\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":13},{\"value\":27},{\"value\":13},{\"value\":3},{\"value\":\"#1845#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',1),(2008,0,3528,'SCREEN_SESSION_PRINT',134,'{\"objects\":[{\"id\":\"24041\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":134},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#567#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"31332\",\"windowid\":\"24041\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"12064\",\"windowid\":\"24041\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":13},{\"value\":34},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1241#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1098.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28186\",\"windowid\":\"24041\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26256\",\"windowid\":\"24041\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":13},{\"value\":5},{\"value\":13},{\"value\":3},{\"value\":\"#1242#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13872\",\"windowid\":\"24041\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":5},{\"value\":0},{\"value\":5},{\"value\":13},{\"value\":3},{\"value\":\"#1243#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"20666\",\"windowid\":\"24041\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":8},{\"value\":26},{\"value\":26},{\"value\":[{\"v\":5},{\"v\":10},{\"v\":10}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1936\",\"windowid\":\"24041\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":2},{\"value\":40},{\"value\":34},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#568#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1097.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10141\",\"windowid\":\"24041\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":202},{\"value\":27},{\"value\":5},{\"value\":26},{\"value\":29},{\"value\":\"#1244#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"12789\",\"windowid\":\"24041\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":27},{\"value\":34},{\"value\":13},{\"value\":3},{\"value\":\"#2000#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]}]}','0',1),(2009,0,3539,'SCREEN_DESKTOP',1,'{\"objects\":[{\"id\":\"26951\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#240#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":1}]},{\"id\":\"7141\",\"windowid\":\"26951\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":15},{\"value\":47},{\"value\":22},{\"value\":4},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14541\",\"windowid\":\"26951\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":48},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2065#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]}]}','0',1),(2010,0,3546,'SCREEN_TABLE_EDIT',4,'{\"objects\":[{\"id\":\"2273\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"1501\",\"windowid\":\"2273\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":12},{\"value\":0},{\"value\":53},{\"value\":41},{\"value\":9},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26516\",\"windowid\":\"2273\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":31},{\"value\":12},{\"value\":12},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"13341\",\"windowid\":\"2273\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":5}]},{\"value\":\"#1772#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18023\",\"windowid\":\"2273\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"266\",\"windowid\":\"2273\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"12554\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":8},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9217\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6700\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-14},{\"value\":0},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#249#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1054.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"682\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"32675\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"24335\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":4},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4275\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21310\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":8},{\"value\":47},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#966#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"28582\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1431#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1067.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"28420\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":8},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1152.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"12567\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1741#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1071.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"12427\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-17},{\"value\":8},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#754#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1050.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"3737\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":8},{\"value\":47},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#967#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"5855\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#969#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1068.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"12201\",\"windowid\":\"2273\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"17832\",\"windowid\":\"2273\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":12},{\"value\":46},{\"value\":53},{\"value\":5},{\"value\":8},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"17157\",\"windowid\":\"2273\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":12},{\"value\":41},{\"value\":53},{\"value\":5},{\"value\":8},{\"value\":-2},{\"value\":103},{\"value\":-1}]}]}','5',2);
INSERT INTO `screens` VALUES (2014,0,3552,'SCREEN_LICENSING_WIZARD',200,'{\"objects\":[{\"id\":\"6465\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":200},{\"value\":10},{\"value\":11},{\"value\":33},{\"value\":25},{\"value\":\"#1245#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"6395\",\"windowid\":\"6465\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":33},{\"value\":23},{\"value\":6},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"29586\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":26},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1246#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"18921\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":10},{\"value\":1},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"31292\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":18},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1248#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":2}]},{\"id\":\"24109\",\"windowid\":\"6465\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":1},{\"value\":7},{\"value\":31},{\"value\":10},{\"value\":[{\"v\":31}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":2},{\"value\":0}]},{\"id\":\"26313\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":26},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1246#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"13850\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":18},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1248#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"14699\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":14},{\"value\":31},{\"value\":3},{\"value\":\"#1249#\"},{\"value\":1},{\"value\":50},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"5528\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":7},{\"value\":15},{\"value\":3},{\"value\":\"#1186#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"24804\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":17},{\"value\":7},{\"value\":15},{\"value\":3},{\"value\":\"#1187#\"},{\"value\":1},{\"value\":11},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"26870\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":13},{\"value\":25},{\"value\":18},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":3}]},{\"id\":\"13969\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":5},{\"value\":31},{\"value\":13},{\"value\":\"#1251#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":3}]},{\"id\":\"28991\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":15},{\"value\":27},{\"value\":18},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"6121\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":1},{\"value\":4},{\"value\":31},{\"value\":13},{\"value\":\"#58#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"7229\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":16},{\"value\":21},{\"value\":18},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"28920\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":26},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1246#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":4}]},{\"id\":\"11666\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":18},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1248#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":4}]},{\"id\":\"26517\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":1},{\"value\":12},{\"value\":31},{\"value\":3},{\"value\":\"#1249#\"},{\"value\":1},{\"value\":50},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":4}]},{\"id\":\"18825\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":1},{\"value\":5},{\"value\":31},{\"value\":3},{\"value\":\"#58#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":5}]},{\"id\":\"5477\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":1},{\"value\":9},{\"value\":31},{\"value\":3},{\"value\":\"#1254#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":5}]},{\"id\":\"14228\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":1},{\"value\":13},{\"value\":31},{\"value\":3},{\"value\":\"#1255#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":5}]},{\"id\":\"28400\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":26},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1246#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":5}]},{\"id\":\"8591\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":10},{\"value\":1},{\"value\":18},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":5}]},{\"id\":\"10315\",\"windowid\":\"6465\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":18},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1248#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":5}]},{\"id\":\"32317\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":22},{\"value\":1},{\"value\":4},{\"value\":31},{\"value\":3},{\"value\":\"#58#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"11301\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":1},{\"value\":11},{\"value\":31},{\"value\":3},{\"value\":\"#58#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"2210\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":1},{\"value\":4},{\"value\":31},{\"value\":3},{\"value\":\"#58#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"8255\",\"windowid\":\"6465\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":1},{\"value\":8},{\"value\":31},{\"value\":3},{\"value\":\"#58#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":4}]}]}','0',1),(2016,0,3551,'SCREEN_CONFIG_DAILY_JOURNAL',123,'{\"objects\":[{\"id\":\"9456\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":123},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#520#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"21535\",\"windowid\":\"9456\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":13},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"9167\",\"windowid\":\"9456\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":13},{\"value\":38},{\"value\":[{\"v\":5},{\"v\":3},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"8052\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":36},{\"value\":6},{\"value\":3},{\"value\":\"#759#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"9490\",\"windowid\":\"9456\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16514\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":0},{\"value\":5},{\"value\":13},{\"value\":3},{\"value\":\"#523#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"26502\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":0},{\"value\":24},{\"value\":6},{\"value\":3},{\"value\":\"#760#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"19443\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":0},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#526#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"500\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":0},{\"value\":30},{\"value\":6},{\"value\":3},{\"value\":\"#761#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"9994\",\"windowid\":\"9456\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":14},{\"value\":14},{\"value\":12},{\"value\":18},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"20394\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":14},{\"value\":32},{\"value\":12},{\"value\":3},{\"value\":\"#529#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1681\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":14},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#531#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9787\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":14},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#532#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13841\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":14},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#534#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17982\",\"windowid\":\"9456\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":20},{\"value\":42},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#535#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29208\",\"windowid\":\"9456\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":20},{\"value\":14},{\"value\":42},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18202\",\"windowid\":\"9456\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":15},{\"value\":7},{\"value\":42},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#755#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13651\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":7},{\"value\":36},{\"value\":6},{\"value\":3},{\"value\":\"#762#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"32288\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":7},{\"value\":30},{\"value\":6},{\"value\":3},{\"value\":\"#763#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"6079\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":7},{\"value\":24},{\"value\":6},{\"value\":3},{\"value\":\"#764#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"9088\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":33},{\"value\":13},{\"value\":3},{\"value\":\"#522#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"6223\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":27},{\"value\":13},{\"value\":3},{\"value\":\"#528#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"19422\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":21},{\"value\":13},{\"value\":3},{\"value\":\"#768#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"11434\",\"windowid\":\"9456\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":17},{\"value\":0},{\"value\":42},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#765#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17295\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":4},{\"value\":58},{\"value\":26},{\"value\":3},{\"value\":\"#770#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"4081\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":13},{\"value\":0},{\"value\":14},{\"value\":3},{\"value\":\"#771#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"203\",\"windowid\":\"9456\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":8},{\"value\":13},{\"value\":3},{\"value\":\"#525#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"20657\",\"windowid\":\"9456\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":0},{\"value\":14},{\"value\":13},{\"value\":3},{\"value\":\"#527#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"19537\",\"windowid\":\"9456\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":25},{\"value\":0},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"#865#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"24429\",\"windowid\":\"9456\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":22},{\"value\":4},{\"value\":10},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31826\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":40},{\"value\":19},{\"value\":35},{\"value\":7},{\"value\":3},{\"value\":\"#1854#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10850\",\"windowid\":\"9456\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":42},{\"value\":14},{\"value\":38},{\"value\":12},{\"value\":3},{\"value\":\"#1857#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15270\",\"windowid\":\"9456\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":39},{\"value\":14},{\"value\":35},{\"value\":5},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1902#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','4',3),(2017,0,3557,'SCREEN_DESKTOPSESSIONS',8,'{\"objects\":[{\"id\":\"19314\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":8},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#260#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"29182\",\"windowid\":\"19314\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23783\",\"windowid\":\"19314\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"26484\",\"windowid\":\"19314\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":43},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":-2},{\"value\":-1},{\"value\":-1}]}]}','4',3),(2018,0,3553,'SCREEN_CONFIG_MAIN',5,'{\"objects\":[{\"id\":\"10286\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":5},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#259#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"11573\",\"windowid\":\"10286\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":5},{\"value\":47},{\"value\":22},{\"value\":4},{\"value\":5},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"9660\",\"windowid\":\"10286\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":43},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":-2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20807\",\"windowid\":\"10286\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]}]}','4',3),(2019,0,3569,'SCREEN_TABLE_CLOSE_RETAIL_GUIAS',10512,'{\"objects\":[{\"id\":\"15295\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":12},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#262#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"24822\",\"windowid\":\"15295\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15243\",\"windowid\":\"15295\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":22},{\"value\":4},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18258\",\"windowid\":\"15295\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":125},{\"value\":1},{\"value\":11},{\"value\":12},{\"value\":3},{\"value\":\"#1903#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8922\",\"windowid\":\"15295\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":1},{\"value\":14},{\"value\":12},{\"value\":3},{\"value\":\"#1904#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24406\",\"windowid\":\"15295\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":1},{\"value\":18},{\"value\":25},{\"value\":3},{\"value\":\"#1878#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6553\",\"windowid\":\"15295\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":123},{\"value\":1},{\"value\":22},{\"value\":25},{\"value\":3},{\"value\":\"#1879#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17623\",\"windowid\":\"15295\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":124},{\"value\":1},{\"value\":25},{\"value\":25},{\"value\":3},{\"value\":\"#1880#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31098\",\"windowid\":\"15295\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":126},{\"value\":14},{\"value\":11},{\"value\":12},{\"value\":3},{\"value\":\"#1876#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11052\",\"windowid\":\"15295\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":127},{\"value\":14},{\"value\":14},{\"value\":12},{\"value\":3},{\"value\":\"#1877#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3897\",\"windowid\":\"15295\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":1},{\"value\":29},{\"value\":12},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32726\",\"windowid\":\"15295\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":14},{\"value\":29},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#275#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','4',3),(2020,0,3568,'SCREEN_TABLE_CLOSE_RETAIL',10011,'{\"objects\":[{\"id\":\"26778\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":11},{\"value\":0},{\"value\":0},{\"value\":27},{\"value\":53},{\"value\":\"#262#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"24967\",\"windowid\":\"26778\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":10},{\"value\":1},{\"value\":17},{\"value\":47},{\"value\":3},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"19407\",\"windowid\":\"26778\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":19},{\"value\":14},{\"value\":8},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":8}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"27258\",\"windowid\":\"26778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":57},{\"value\":0},{\"value\":0},{\"value\":10},{\"value\":3},{\"value\":\"#263#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"8164\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":51},{\"value\":10},{\"value\":19},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#264#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3477\",\"windowid\":\"26778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":58},{\"value\":19},{\"value\":4},{\"value\":8},{\"value\":3},{\"value\":\"#265#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5155\",\"windowid\":\"26778\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":10},{\"value\":4},{\"value\":9},{\"value\":12},{\"value\":[{\"v\":5},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"25927\",\"windowid\":\"26778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":59},{\"value\":19},{\"value\":7},{\"value\":8},{\"value\":3},{\"value\":\"#266#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2149\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":52},{\"value\":13},{\"value\":19},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#267#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19611\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":16},{\"value\":19},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#268#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25528\",\"windowid\":\"26778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":68},{\"value\":10},{\"value\":16},{\"value\":9},{\"value\":3},{\"value\":\"#269#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28118\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":54},{\"value\":10},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#270#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12562\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":55},{\"value\":13},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#271#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4810\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":56},{\"value\":16},{\"value\":23},{\"value\":3},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#272#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15051\",\"windowid\":\"26778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":60},{\"value\":19},{\"value\":14},{\"value\":8},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11518\",\"windowid\":\"26778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":62},{\"value\":19},{\"value\":20},{\"value\":8},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25265\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31711\",\"windowid\":\"26778\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":10},{\"value\":36},{\"value\":[{\"v\":2},{\"v\":5},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9204\",\"windowid\":\"26778\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":14},{\"value\":30},{\"value\":13},{\"value\":16},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":1}]},{\"id\":\"10632\",\"windowid\":\"26778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":14},{\"value\":27},{\"value\":13},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"21822\",\"windowid\":\"26778\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":22},{\"value\":4},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15095\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":19},{\"value\":42},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#776#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"13484\",\"windowid\":\"26778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":82},{\"value\":19},{\"value\":17},{\"value\":8},{\"value\":3},{\"value\":\"#813#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22172\",\"windowid\":\"26778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":663},{\"value\":0},{\"value\":40},{\"value\":10},{\"value\":3},{\"value\":\"#1459#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21646\",\"windowid\":\"26778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":88},{\"value\":31},{\"value\":69},{\"value\":10},{\"value\":3},{\"value\":\"#1392#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15525\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":42},{\"value\":69},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1619#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30478\",\"windowid\":\"26778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":43},{\"value\":10},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26234\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":19},{\"value\":23},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#275#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6194\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":10},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"12098\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":10},{\"value\":27},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"8410\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":10},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"13675\",\"windowid\":\"26778\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":10},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"21150\",\"windowid\":\"26778\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":10},{\"value\":35},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"25988\",\"windowid\":\"26778\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":120},{\"value\":19},{\"value\":10},{\"value\":8},{\"value\":3},{\"value\":\"#1729#\"},{\"value\":[{\"v\":8}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]}]}','4',3),(2021,0,3544,'SCREEN_TABLE_EDIT',4,'{\"objects\":[{\"id\":\"3862\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#248#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"23597\",\"windowid\":\"3862\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":31},{\"value\":12},{\"value\":12},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"30421\",\"windowid\":\"3862\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":5}]},{\"value\":\"#1772#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26819\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-14},{\"value\":0},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#249#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1054.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13881\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#250#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"26952\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1055.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"11831\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":4},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29639\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":8},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6641\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":8},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1741#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1071.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"26386\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5189\",\"windowid\":\"3862\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"5275\",\"windowid\":\"3862\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"27323\",\"windowid\":\"3862\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":12},{\"value\":46},{\"value\":41},{\"value\":5},{\"value\":6},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"22051\",\"windowid\":\"3862\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":41},{\"value\":7},{\"value\":4},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12551\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-17},{\"value\":8},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#754#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1050.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"21945\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":34},{\"value\":8},{\"value\":47},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#966#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"24953\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":8},{\"value\":47},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#967#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"17123\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":36},{\"value\":4},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#969#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1068.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"31251\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1431#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1067.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"17900\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":0},{\"value\":35},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":2},{\"value\":-1},{\"value\":1}]},{\"id\":\"17176\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19103\",\"windowid\":\"3862\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":12},{\"value\":41},{\"value\":41},{\"value\":5},{\"value\":6},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"4948\",\"windowid\":\"3862\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":8},{\"value\":41},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"#1536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1152.png\"},{\"value\":2},{\"value\":-1},{\"value\":0}]}]}','0',1),(2023,0,3530,'SCREEN_REPORTS_SERVICES',11145,'{\"objects\":[{\"id\":\"2698\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":145},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#887#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7928\",\"windowid\":\"2698\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"18731\",\"windowid\":\"2698\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13073\",\"windowid\":\"2698\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"7954\",\"windowid\":\"2698\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":2},{\"value\":13},{\"value\":20},{\"value\":13},{\"value\":3},{\"value\":\"#889#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"29797\",\"windowid\":\"2698\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":27},{\"value\":34},{\"value\":26},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#890#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1097.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9495\",\"windowid\":\"2698\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":27},{\"value\":4},{\"value\":26},{\"value\":29},{\"value\":\"#891#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"19186\",\"windowid\":\"2698\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":13},{\"value\":34},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#892#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1098.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5051\",\"windowid\":\"2698\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":13},{\"value\":12},{\"value\":\"#893#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"9160\",\"windowid\":\"2698\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":14},{\"value\":13},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"10261\",\"windowid\":\"2698\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":13},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"#998#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25281\",\"windowid\":\"2698\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27957\",\"windowid\":\"2698\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":13},{\"value\":24},{\"value\":13},{\"value\":3},{\"value\":\"#1844#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"10976\",\"windowid\":\"2698\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":21},{\"value\":13},{\"value\":27},{\"value\":13},{\"value\":3},{\"value\":\"#1845#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',1),(2024,0,3581,'SCREEN_TABLE_EDIT_SERVICES',11004,'{\"objects\":[{\"id\":\"13836\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#1754#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"705\",\"windowid\":\"13836\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":0},{\"value\":49},{\"value\":27},{\"value\":[{\"v\":3},{\"v\":19},{\"v\":3},{\"v\":4},{\"v\":3},{\"v\":4}]},{\"value\":\"#1771#\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"31696\",\"windowid\":\"13836\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":12},{\"value\":47},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1779#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1151.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3662\",\"windowid\":\"13836\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"19529\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":37},{\"value\":43},{\"value\":12},{\"value\":3},{\"value\":\"#1773#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"9896\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":27},{\"value\":5},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"15500\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":106},{\"value\":39},{\"value\":40},{\"value\":10},{\"value\":3},{\"value\":\"#1755#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9740\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":35},{\"value\":27},{\"value\":7},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22898\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":28},{\"value\":27},{\"value\":7},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23356\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":5},{\"value\":27},{\"value\":23},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32478\",\"windowid\":\"13836\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":71},{\"value\":6},{\"value\":47},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1701#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1080.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25127\",\"windowid\":\"13836\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":53},{\"value\":3},{\"value\":12},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"12848\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":53},{\"value\":3},{\"value\":12},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26392\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":50},{\"value\":6},{\"value\":15},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24908\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":105},{\"value\":39},{\"value\":31},{\"value\":10},{\"value\":3},{\"value\":\"#1756#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20505\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":42},{\"value\":27},{\"value\":7},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13025\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":107},{\"value\":50},{\"value\":9},{\"value\":15},{\"value\":3},{\"value\":\"#1758#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26284\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":109},{\"value\":58},{\"value\":12},{\"value\":7},{\"value\":3},{\"value\":\"#1759#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14800\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":112},{\"value\":39},{\"value\":34},{\"value\":10},{\"value\":3},{\"value\":\"#1883#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11273\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":104},{\"value\":50},{\"value\":20},{\"value\":15},{\"value\":3},{\"value\":\"#1757#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11490\",\"windowid\":\"13836\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":50},{\"value\":23},{\"value\":15},{\"value\":13},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"#1774#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"5243\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":113},{\"value\":50},{\"value\":40},{\"value\":15},{\"value\":3},{\"value\":\"#1775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3382\",\"windowid\":\"13836\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":0},{\"value\":31},{\"value\":15},{\"value\":15},{\"value\":[{\"v\":5},{\"v\":5},{\"v\":5}]},{\"value\":\"#1777#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2719\",\"windowid\":\"13836\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":50},{\"value\":15},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1695#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14601\",\"windowid\":\"13836\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":58},{\"value\":15},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1697#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1079.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24968\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":108},{\"value\":50},{\"value\":12},{\"value\":8},{\"value\":3},{\"value\":\"#1760#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5573\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":110},{\"value\":50},{\"value\":36},{\"value\":15},{\"value\":3},{\"value\":\"#1780#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21782\",\"windowid\":\"13836\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":111},{\"value\":16},{\"value\":31},{\"value\":11},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1762#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"4982\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":115},{\"value\":50},{\"value\":43},{\"value\":15},{\"value\":3},{\"value\":\"#1778#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29194\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":116},{\"value\":39},{\"value\":37},{\"value\":10},{\"value\":3},{\"value\":\"#1783#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7457\",\"windowid\":\"13836\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":119},{\"value\":16},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1799#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"19347\",\"windowid\":\"13836\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":132},{\"value\":50},{\"value\":3},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1852#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25740\",\"windowid\":\"13836\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":124},{\"value\":50},{\"value\":0},{\"value\":15},{\"value\":3},{\"value\":\"#1875#\"},{\"value\":[{\"v\":15}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"21095\",\"windowid\":\"13836\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":145},{\"value\":16},{\"value\":37},{\"value\":11},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','5',2),(2025,0,3580,'SCREEN_TABLE_EDIT_SERVICES',11004,'{\"objects\":[{\"id\":\"25464\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1754#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"7054\",\"windowid\":\"25464\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":0},{\"value\":37},{\"value\":27},{\"value\":[{\"v\":3},{\"v\":19},{\"v\":3},{\"v\":4},{\"v\":3},{\"v\":4}]},{\"value\":\"#1771#\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"18334\",\"windowid\":\"25464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":12},{\"value\":47},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1779#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1151.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31783\",\"windowid\":\"25464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21323\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":25},{\"value\":43},{\"value\":12},{\"value\":3},{\"value\":\"#1773#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"21203\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":0},{\"value\":27},{\"value\":5},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"23506\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":106},{\"value\":27},{\"value\":40},{\"value\":10},{\"value\":3},{\"value\":\"#1755#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9920\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":26},{\"value\":27},{\"value\":4},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24105\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":19},{\"value\":27},{\"value\":7},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20870\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":5},{\"value\":27},{\"value\":14},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17432\",\"windowid\":\"25464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":71},{\"value\":6},{\"value\":47},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1701#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1080.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31253\",\"windowid\":\"25464\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":41},{\"value\":3},{\"value\":12},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"5105\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":41},{\"value\":3},{\"value\":12},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9237\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":38},{\"value\":6},{\"value\":15},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26351\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":105},{\"value\":27},{\"value\":31},{\"value\":10},{\"value\":3},{\"value\":\"#1756#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24381\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":30},{\"value\":27},{\"value\":7},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9137\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":107},{\"value\":38},{\"value\":9},{\"value\":15},{\"value\":3},{\"value\":\"#1758#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15980\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":109},{\"value\":46},{\"value\":12},{\"value\":7},{\"value\":3},{\"value\":\"#1759#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9580\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":112},{\"value\":27},{\"value\":34},{\"value\":10},{\"value\":3},{\"value\":\"#1883#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15497\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":104},{\"value\":38},{\"value\":20},{\"value\":15},{\"value\":3},{\"value\":\"#1757#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32198\",\"windowid\":\"25464\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":38},{\"value\":23},{\"value\":15},{\"value\":13},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"#1774#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"9597\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":113},{\"value\":38},{\"value\":40},{\"value\":15},{\"value\":3},{\"value\":\"#1775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11902\",\"windowid\":\"25464\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":0},{\"value\":31},{\"value\":15},{\"value\":15},{\"value\":[{\"v\":5},{\"v\":5},{\"v\":5}]},{\"value\":\"#1777#\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3000\",\"windowid\":\"25464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":38},{\"value\":15},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1695#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24901\",\"windowid\":\"25464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":46},{\"value\":15},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1697#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1079.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22304\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":108},{\"value\":38},{\"value\":12},{\"value\":8},{\"value\":3},{\"value\":\"#1760#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6007\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":110},{\"value\":38},{\"value\":36},{\"value\":15},{\"value\":3},{\"value\":\"#1780#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8298\",\"windowid\":\"25464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":111},{\"value\":15},{\"value\":31},{\"value\":11},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1762#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22682\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":115},{\"value\":38},{\"value\":43},{\"value\":15},{\"value\":3},{\"value\":\"#1778#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25630\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":116},{\"value\":27},{\"value\":37},{\"value\":10},{\"value\":3},{\"value\":\"#1783#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24008\",\"windowid\":\"25464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":119},{\"value\":15},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1799#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13016\",\"windowid\":\"25464\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":132},{\"value\":38},{\"value\":3},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1852#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26991\",\"windowid\":\"25464\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":124},{\"value\":38},{\"value\":0},{\"value\":15},{\"value\":3},{\"value\":\"#1875#\"},{\"value\":[{\"v\":15}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"28808\",\"windowid\":\"25464\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":145},{\"value\":15},{\"value\":37},{\"value\":11},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}]}','0',1),(2026,0,3579,'SCREEN_TABLE_EDIT_RETAIL',10004,' {\"objects\":[{\"id\":\"12209\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":65},{\"value\":53},{\"value\":\"#1747#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"6778\",\"windowid\":\"12209\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":302},{\"value\":0},{\"value\":9},{\"value\":37},{\"value\":33},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"10733\",\"windowid\":\"12209\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":8},{\"value\":49},{\"value\":34},{\"value\":[{\"v\":4},{\"v\":25},{\"v\":4},{\"v\":5},{\"v\":4},{\"v\":5}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"6748\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":59},{\"value\":17},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1695#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"554\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":6},{\"value\":46},{\"value\":8},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1153.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7964\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":38},{\"value\":46},{\"value\":11},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#253#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1151.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3109\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":7},{\"value\":42},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30368\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27353\",\"windowid\":\"12209\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":1},{\"value\":13},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"23010\",\"windowid\":\"12209\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":2},{\"value\":42},{\"value\":5},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"13728\",\"windowid\":\"12209\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":64},{\"value\":49},{\"value\":25},{\"value\":16},{\"value\":3},{\"value\":\"#1696#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"17417\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":59},{\"value\":21},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1697#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1079.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"8019\",\"windowid\":\"12209\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":34},{\"value\":42},{\"value\":5},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30618\",\"windowid\":\"12209\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":24},{\"value\":42},{\"value\":10},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30533\",\"windowid\":\"12209\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":9},{\"value\":42},{\"value\":15},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18928\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":71},{\"value\":14},{\"value\":46},{\"value\":8},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1701#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1080.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23385\",\"windowid\":\"12209\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":49},{\"value\":11},{\"value\":16},{\"value\":3},{\"value\":\"#58#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"20368\",\"windowid\":\"12209\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":49},{\"value\":8},{\"value\":16},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27521\",\"windowid\":\"12209\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":49},{\"value\":11},{\"value\":16},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6176\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":81},{\"value\":49},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4702\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":82},{\"value\":53},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24323\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":83},{\"value\":57},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21481\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":84},{\"value\":49},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32232\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":85},{\"value\":53},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23108\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":86},{\"value\":57},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6358\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":87},{\"value\":49},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31265\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":88},{\"value\":53},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30575\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":57},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29543\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":53},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23944\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":72},{\"value\":49},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6140\",\"windowid\":\"12209\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":90},{\"value\":49},{\"value\":28},{\"value\":16},{\"value\":3},{\"value\":\"#1702#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1352\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":61},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1084.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4572\",\"windowid\":\"12209\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":39},{\"value\":42},{\"value\":10},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12134\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":92},{\"value\":61},{\"value\":41},{\"value\":4},{\"value\":10},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1085.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2788\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":91},{\"value\":57},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1713#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8774\",\"windowid\":\"12209\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":13},{\"value\":0},{\"value\":36},{\"value\":4},{\"value\":6},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"19451\",\"windowid\":\"12209\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":6},{\"value\":4},{\"value\":43},{\"value\":4},{\"value\":6},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"30463\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":42},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22141\",\"windowid\":\"12209\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":0},{\"value\":8},{\"value\":49},{\"value\":34},{\"value\":8},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":0}]},{\"id\":\"19346\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":95},{\"value\":0},{\"value\":4},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1728#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21018\",\"windowid\":\"12209\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":49},{\"value\":14},{\"value\":16},{\"value\":14},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":0},{\"v\":0},{\"v\":0},{\"v\":3}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"27609\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":93},{\"value\":61},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1083.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14981\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-21},{\"value\":49},{\"value\":21},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1750#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1078.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"20218\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-22},{\"value\":54},{\"value\":21},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1751#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1077.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"21404\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":54},{\"value\":17},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"30050\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":49},{\"value\":17},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1431#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1067.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"24575\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":30},{\"value\":46},{\"value\":8},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1152.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21388\",\"windowid\":\"12209\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":601},{\"value\":49},{\"value\":0},{\"value\":16},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"logo_cliente.png\"},{\"value\":50},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13611\",\"windowid\":\"12209\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":124},{\"value\":49},{\"value\":5},{\"value\":16},{\"value\":3},{\"value\":\"#1875#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"6185\",\"windowid\":\"12209\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":131},{\"value\":49},{\"value\":14},{\"value\":16},{\"value\":3},{\"value\":\"#1924#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]}]}\n','5',2),(2027,0,3578,'SCREEN_TABLE_EDIT_RETAIL',10004,'\n{\"objects\":[{\"id\":\"24213\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#1747#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"19182\",\"windowid\":\"24213\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":302},{\"value\":0},{\"value\":9},{\"value\":37},{\"value\":33},{\"value\":2},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"24869\",\"windowid\":\"24213\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":8},{\"value\":37},{\"value\":34},{\"value\":[{\"v\":3},{\"v\":19},{\"v\":3},{\"v\":4},{\"v\":3},{\"v\":4}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"23342\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":68},{\"value\":47},{\"value\":17},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1695#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"3001\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":6},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#252#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1153.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24594\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":30},{\"value\":46},{\"value\":7},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1874#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1151.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11085\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":7},{\"value\":42},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#254#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16954\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24390\",\"windowid\":\"24213\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":0},{\"value\":1},{\"value\":10},{\"value\":3},{\"value\":\"#257#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"16283\",\"windowid\":\"24213\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":2},{\"value\":42},{\"value\":5},{\"value\":3},{\"value\":\"#258#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"8544\",\"windowid\":\"24213\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":64},{\"value\":37},{\"value\":25},{\"value\":16},{\"value\":3},{\"value\":\"#1696#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"14383\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":63},{\"value\":47},{\"value\":21},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1697#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1079.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"12828\",\"windowid\":\"24213\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":74},{\"value\":26},{\"value\":42},{\"value\":4},{\"value\":3},{\"value\":\"#1703#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28986\",\"windowid\":\"24213\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":19},{\"value\":42},{\"value\":7},{\"value\":3},{\"value\":\"#1699#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13665\",\"windowid\":\"24213\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":9},{\"value\":42},{\"value\":10},{\"value\":3},{\"value\":\"#1700#\"},{\"value\":0},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3028\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":71},{\"value\":12},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1701#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1080.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"26997\",\"windowid\":\"24213\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":37},{\"value\":11},{\"value\":16},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"4239\",\"windowid\":\"24213\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":40},{\"value\":8},{\"value\":13},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29310\",\"windowid\":\"24213\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":37},{\"value\":11},{\"value\":16},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16749\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":81},{\"value\":37},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1156#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18204\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":82},{\"value\":41},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1157#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11406\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":83},{\"value\":45},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1158#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28392\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":84},{\"value\":37},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1159#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3385\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":85},{\"value\":41},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1160#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2522\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":86},{\"value\":45},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1161#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"13863\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":87},{\"value\":37},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1162#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"4065\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":88},{\"value\":41},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1163#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22335\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":45},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1164#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29233\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":41},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1165#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16934\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":72},{\"value\":37},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1166#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21527\",\"windowid\":\"24213\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":90},{\"value\":37},{\"value\":28},{\"value\":16},{\"value\":3},{\"value\":\"#1702#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11339\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":49},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1084.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32589\",\"windowid\":\"24213\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":76},{\"value\":30},{\"value\":42},{\"value\":7},{\"value\":3},{\"value\":\"#1704#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8792\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":92},{\"value\":49},{\"value\":41},{\"value\":4},{\"value\":10},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1085.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6192\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":91},{\"value\":45},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1713#\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"16435\",\"windowid\":\"24213\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":10},{\"value\":0},{\"value\":27},{\"value\":4},{\"value\":4},{\"value\":-1},{\"value\":102},{\"value\":-1}]},{\"id\":\"30776\",\"windowid\":\"24213\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":6},{\"value\":4},{\"value\":31},{\"value\":4},{\"value\":4},{\"value\":-2},{\"value\":103},{\"value\":-1}]},{\"id\":\"6639\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":0},{\"value\":42},{\"value\":2},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#251#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2470\",\"windowid\":\"24213\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":0},{\"value\":9},{\"value\":37},{\"value\":33},{\"value\":6},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"value\":0}]},{\"id\":\"25950\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":95},{\"value\":0},{\"value\":4},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1728#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1086.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5453\",\"windowid\":\"24213\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":37},{\"value\":14},{\"value\":16},{\"value\":14},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":0},{\"v\":0},{\"v\":0},{\"v\":3}]},{\"value\":\"#1770#\"},{\"value\":0},{\"value\":0},{\"value\":0}]},{\"id\":\"12583\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":93},{\"value\":49},{\"value\":31},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#972#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1083.png\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15317\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-21},{\"value\":37},{\"value\":21},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1750#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1078.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"7559\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-22},{\"value\":42},{\"value\":21},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1751#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1077.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"24047\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":42},{\"value\":17},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#970#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"27690\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":37},{\"value\":17},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1431#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1067.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"4946\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":24},{\"value\":46},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#1536#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1152.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"10175\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":601},{\"value\":37},{\"value\":0},{\"value\":16},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"logo_cliente.png\"},{\"value\":50},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3707\",\"windowid\":\"24213\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":124},{\"value\":37},{\"value\":5},{\"value\":16},{\"value\":3},{\"value\":\"#1875#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"26929\",\"windowid\":\"24213\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":131},{\"value\":37},{\"value\":14},{\"value\":16},{\"value\":3},{\"value\":\"#1924#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"31615\",\"windowid\":\"24213\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":132},{\"value\":37},{\"value\":8},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#1852#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]}]}\n','0',1),(2029,0,3585,'SCREEN_SAFT',146,'{\"objects\":[{\"id\":\"11496\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":146},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#944#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"24040\",\"windowid\":\"11496\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"32143\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":48},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#247#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1094.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"30116\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":10},{\"value\":1},{\"value\":11},{\"value\":17},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#960#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"7673\",\"windowid\":\"11496\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":19},{\"value\":5},{\"value\":34},{\"value\":19},{\"value\":[{\"v\":34}]},{\"value\":\"#1836#\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29233\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":12},{\"value\":19},{\"value\":25},{\"value\":17},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#638#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"20755\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":13},{\"value\":36},{\"value\":25},{\"value\":17},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#639#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"6205\",\"windowid\":\"11496\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":22},{\"value\":1},{\"value\":14},{\"value\":16},{\"value\":3},{\"value\":\"#659#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29698\",\"windowid\":\"11496\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":1},{\"value\":5},{\"value\":16},{\"value\":3},{\"value\":\"#1844#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30429\",\"windowid\":\"11496\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":1},{\"value\":8},{\"value\":16},{\"value\":3},{\"value\":\"#1845#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28154\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":18},{\"value\":26},{\"value\":31},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1871#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"772\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":19},{\"value\":26},{\"value\":35},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1872#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"20340\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":24},{\"value\":39},{\"value\":35},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1926#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"1469\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":23},{\"value\":39},{\"value\":31},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1925#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"20341\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":17},{\"value\":46},{\"value\":35},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Gerar SAFT Simplificado 1.04\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"1470\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":16},{\"value\":46},{\"value\":31},{\"value\":7},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Gerar SAFT 1.04\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"19810\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":25},{\"value\":12},{\"value\":35},{\"value\":13},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#2072#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"6205\",\"windowid\":\"11496\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":26},{\"value\":1},{\"value\":21},{\"value\":16},{\"value\":3},{\"value\":\"Sage Exchange\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29233\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":27},{\"value\":1},{\"value\":25},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Sage Exchange\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"29234\",\"windowid\":\"11496\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":28},{\"value\":12},{\"value\":25},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Enviar\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]}]}','0',1),(2030,0,3518,'SCREEN_CONFIG_ITEMS_RETAIL',10104,'{\"objects\":[{\"id\":\"27886\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":104},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#301#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"17418\",\"windowid\":\"27886\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"538\",\"windowid\":\"27886\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":32},{\"value\":[{\"v\":12}]},{\"value\":\"#1769#\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"26925\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#303#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"19930\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#305#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6422\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":40},{\"value\":23},{\"value\":13},{\"value\":3},{\"value\":\"#307#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14031\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":40},{\"value\":26},{\"value\":13},{\"value\":3},{\"value\":\"#308#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24012\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":40},{\"value\":29},{\"value\":13},{\"value\":3},{\"value\":\"#309#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11527\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":40},{\"value\":32},{\"value\":13},{\"value\":3},{\"value\":\"#310#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25772\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":40},{\"value\":35},{\"value\":13},{\"value\":3},{\"value\":\"#311#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14320\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"#312#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20733\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":10},{\"value\":27},{\"value\":3},{\"value\":\"#313#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2293\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#315#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25762\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":26},{\"value\":29},{\"value\":13},{\"value\":3},{\"value\":\"#317#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24590\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":26},{\"value\":32},{\"value\":13},{\"value\":3},{\"value\":\"#318#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14051\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":13},{\"value\":35},{\"value\":26},{\"value\":3},{\"value\":\"#319#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"14791\",\"windowid\":\"27886\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":26},{\"value\":26},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#320#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"13020\",\"windowid\":\"27886\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":32},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#321#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"14990\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":23},{\"value\":27},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#324#\"},{\"value\":1},{\"value\":7},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"8730\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":14},{\"value\":14},{\"value\":12},{\"value\":3},{\"value\":\"#325#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"10557\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":25},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#326#\"},{\"value\":1},{\"value\":50},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28013\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":26},{\"value\":27},{\"value\":18},{\"value\":26},{\"value\":3},{\"value\":\"#327#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"6980\",\"windowid\":\"27886\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":27},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#330#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"19704\",\"windowid\":\"27886\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":29},{\"value\":27},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#333#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"18146\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":33},{\"value\":27},{\"value\":22},{\"value\":26},{\"value\":3},{\"value\":\"#334#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"10752\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":34},{\"value\":40},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#335#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"21572\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":35},{\"value\":14},{\"value\":18},{\"value\":12},{\"value\":3},{\"value\":\"#336#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"18451\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"3207\",\"windowid\":\"27886\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#314#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"14455\",\"windowid\":\"27886\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":13},{\"value\":40},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#304#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"32244\",\"windowid\":\"27886\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":14},{\"value\":40},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#306#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"29187\",\"windowid\":\"27886\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":30},{\"value\":40},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#331#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"9967\",\"windowid\":\"27886\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":12},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#302#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"30929\",\"windowid\":\"27886\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":32},{\"value\":26},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#322#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CColorBox\"}]},{\"id\":\"1382\",\"windowid\":\"27886\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":38},{\"value\":0},{\"value\":36},{\"value\":12},{\"value\":3},{\"value\":\"#972#\"},{\"value\":[{\"v\":12}]},{\"value\":5},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"7273\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":51},{\"value\":14},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"#1115#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"5836\",\"windowid\":\"27886\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":46},{\"value\":26},{\"value\":23},{\"value\":13},{\"value\":3},{\"value\":\"#1227#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"18513\",\"windowid\":\"27886\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":45},{\"value\":13},{\"value\":23},{\"value\":12},{\"value\":3},{\"value\":\"#1227#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"29925\",\"windowid\":\"27886\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":7},{\"value\":26},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#316#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"560\",\"windowid\":\"27886\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":52},{\"value\":27},{\"value\":14},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1665#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"24042\",\"windowid\":\"27886\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":14},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1788#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"18908\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":54},{\"value\":14},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#1797#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"10958\",\"windowid\":\"27886\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29458\",\"windowid\":\"27886\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3243\",\"windowid\":\"27886\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"3492\",\"windowid\":\"27886\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"21946\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":56},{\"value\":33},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"FaceBook\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1155.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"21947\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":57},{\"value\":27},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Aplica Cor a todos\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"29346\",\"windowid\":\"27886\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":47},{\"value\":14},{\"value\":26},{\"value\":12},{\"value\":3},{\"value\":\"#2007#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]}]}','0',1),(2031,0,3517,'SCREEN_CONFIG_ITEMS',104,'{\"objects\":[{\"id\":\"26898\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":104},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#301#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"5163\",\"windowid\":\"26898\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":3},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"17657\",\"windowid\":\"26898\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":32},{\"value\":[{\"v\":12}]},{\"value\":\"#1769#\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"1074\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#303#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22988\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#305#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18084\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":40},{\"value\":23},{\"value\":13},{\"value\":3},{\"value\":\"#307#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"214\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":40},{\"value\":26},{\"value\":13},{\"value\":3},{\"value\":\"#308#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13052\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":40},{\"value\":29},{\"value\":13},{\"value\":3},{\"value\":\"#309#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4486\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":40},{\"value\":32},{\"value\":13},{\"value\":3},{\"value\":\"#310#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4453\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":40},{\"value\":35},{\"value\":13},{\"value\":3},{\"value\":\"#311#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4100\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"#312#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26470\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":26},{\"value\":10},{\"value\":27},{\"value\":3},{\"value\":\"#313#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15793\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"#315#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25325\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":26},{\"value\":29},{\"value\":13},{\"value\":3},{\"value\":\"#317#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"653\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":26},{\"value\":32},{\"value\":13},{\"value\":3},{\"value\":\"#318#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7837\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":13},{\"value\":35},{\"value\":26},{\"value\":3},{\"value\":\"#319#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"7888\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":26},{\"value\":26},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#320#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"4484\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":11},{\"value\":13},{\"value\":32},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#321#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"20020\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":23},{\"value\":27},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#324#\"},{\"value\":1},{\"value\":7},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"19886\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":40},{\"value\":18},{\"value\":13},{\"value\":3},{\"value\":\"#325#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"4814\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":25},{\"value\":13},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"#326#\"},{\"value\":1},{\"value\":50},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3123\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":26},{\"value\":27},{\"value\":26},{\"value\":26},{\"value\":3},{\"value\":\"#327#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"19299\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":27},{\"value\":40},{\"value\":22},{\"value\":13},{\"value\":3},{\"value\":\"#328#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"15014\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":28},{\"value\":27},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"#329#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"6549\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":27},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#330#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"7444\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":29},{\"value\":27},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#333#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"32357\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":33},{\"value\":27},{\"value\":30},{\"value\":26},{\"value\":3},{\"value\":\"#334#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"28919\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":34},{\"value\":40},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#335#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"2012\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":35},{\"value\":14},{\"value\":26},{\"value\":12},{\"value\":3},{\"value\":\"#336#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"8396\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"213\",\"windowid\":\"26898\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":14},{\"value\":4},{\"value\":12},{\"value\":22},{\"value\":[{\"v\":12}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":1},{\"value\":1}]},{\"id\":\"21790\",\"windowid\":\"26898\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"#314#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"23616\",\"windowid\":\"26898\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":13},{\"value\":40},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#304#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"22357\",\"windowid\":\"26898\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":14},{\"value\":40},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#306#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"8023\",\"windowid\":\"26898\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":30},{\"value\":40},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#331#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"7043\",\"windowid\":\"26898\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":12},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#302#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"27287\",\"windowid\":\"26898\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":32},{\"value\":26},{\"value\":13},{\"value\":13},{\"value\":3},{\"value\":\"#322#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CColorBox\"}]},{\"id\":\"12801\",\"windowid\":\"26898\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":38},{\"value\":0},{\"value\":36},{\"value\":12},{\"value\":3},{\"value\":\"#972#\"},{\"value\":[{\"v\":12}]},{\"value\":5},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"32646\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":51},{\"value\":14},{\"value\":30},{\"value\":12},{\"value\":3},{\"value\":\"#1115#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"9889\",\"windowid\":\"26898\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":46},{\"value\":26},{\"value\":23},{\"value\":13},{\"value\":3},{\"value\":\"#1227#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"20865\",\"windowid\":\"26898\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":45},{\"value\":13},{\"value\":23},{\"value\":12},{\"value\":3},{\"value\":\"#1227#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"17083\",\"windowid\":\"26898\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":7},{\"value\":26},{\"value\":16},{\"value\":13},{\"value\":3},{\"value\":\"#316#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"25133\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":52},{\"value\":27},{\"value\":14},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1665#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"4198\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":40},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1788#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"28223\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":54},{\"value\":40},{\"value\":14},{\"value\":13},{\"value\":3},{\"value\":\"#1797#\"},{\"value\":1},{\"value\":2},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"12432\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21945\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21946\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":56},{\"value\":33},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"FaceBook\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1155.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21947\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":57},{\"value\":27},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Aplica Cor a todos\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25309\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"17097\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21871\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":47},{\"value\":27},{\"value\":18},{\"value\":12},{\"value\":3},{\"value\":\"#2007#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"21894\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":204},{\"value\":14},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#2110#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"21895\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":205},{\"value\":14},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#2111#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"21896\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":206},{\"value\":14},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#2112#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"21897\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":207},{\"value\":14},{\"value\":13},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#2113#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"21898\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":208},{\"value\":14},{\"value\":16},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#2114#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"21899\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":209},{\"value\":14},{\"value\":19},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#2115#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"21900\",\"windowid\":\"26898\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":210},{\"value\":14},{\"value\":22},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#2116#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"21872\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":61},{\"value\":27},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#2101#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"21873\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":62},{\"value\":40},{\"value\":4},{\"value\":13},{\"value\":3},{\"value\":\"#2102#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"21882\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":63},{\"value\":27},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#2103#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"21883\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":64},{\"value\":40},{\"value\":7},{\"value\":13},{\"value\":3},{\"value\":\"#2104#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"21892\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":65},{\"value\":27},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#2105#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"21893\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":66},{\"value\":40},{\"value\":10},{\"value\":13},{\"value\":3},{\"value\":\"#2106#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"21901\",\"windowid\":\"26898\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":900},{\"value\":400},{\"value\":10},{\"value\":1},{\"value\":1},{\"value\":\"#2106#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]}]}','0',1),(2032,0,2461,'SCREEN_CONFIG_QUICK_PAGES',174,'{\"objects\":[{\"id\":\"20342\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":174},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#1449#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"18969\",\"windowid\":\"20342\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"5744\",\"windowid\":\"20342\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":11},{\"value\":12},{\"value\":24},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"27227\",\"windowid\":\"20342\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":19},{\"value\":3},{\"value\":\"#1450#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15030\",\"windowid\":\"20342\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"16510\",\"windowid\":\"20342\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":2},{\"value\":33},{\"value\":4},{\"value\":19},{\"value\":3},{\"value\":\"#1451#\"},{\"value\":[{\"v\":19}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"30986\",\"windowid\":\"20342\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":38},{\"value\":16},{\"value\":35},{\"value\":12},{\"value\":3},{\"value\":\"#972#\"},{\"value\":[{\"v\":12}]},{\"value\":5},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"9830\",\"windowid\":\"20342\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"15171\",\"windowid\":\"20342\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":37},{\"value\":11},{\"value\":12},{\"value\":23},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"11\",\"windowid\":\"20342\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":4},{\"value\":30},{\"value\":25},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22795\",\"windowid\":\"20342\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":3},{\"value\":30},{\"value\":17},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"949\",\"windowid\":\"20342\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":5},{\"value\":37},{\"value\":34},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1452#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1093.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8103\",\"windowid\":\"20342\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":7},{\"value\":19},{\"value\":3},{\"value\":\"#1453#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"304\",\"windowid\":\"20342\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":51},{\"value\":33},{\"value\":7},{\"value\":19},{\"value\":3},{\"value\":\"#1115#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24809\",\"windowid\":\"20342\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1904\",\"windowid\":\"20342\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}\n,{\"id\":\"2745\",\"windowid\":\"20342\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":56},{\"value\":35},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Face\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1155.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}\n,{\"id\":\"2744\",\"windowid\":\"20342\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"1146\",\"windowid\":\"20342\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}','0',1),(2033,0,1755,'SCREEN_PROMPT_DELIVERY_CUSTOMER',163,'\n{\"objects\":[{\"id\":\"451\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":163},{\"value\":2},{\"value\":5},{\"value\":50},{\"value\":46},{\"value\":\"#1130#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"17964\",\"windowid\":\"451\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":3},{\"value\":23},{\"value\":3},{\"value\":\"#1121#\"},{\"value\":[{\"v\":23}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"12778\",\"windowid\":\"451\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":1},{\"value\":3},{\"value\":23},{\"value\":3},{\"value\":\"#1121#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3828\",\"windowid\":\"451\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":7},{\"value\":21},{\"value\":3},{\"value\":\"#1122#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"30071\",\"windowid\":\"451\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":25},{\"value\":3},{\"value\":23},{\"value\":3},{\"value\":\"#1123#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28090\",\"windowid\":\"451\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":13},{\"value\":15},{\"value\":3},{\"value\":\"#1124#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"21372\",\"windowid\":\"451\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":33},{\"value\":13},{\"value\":15},{\"value\":3},{\"value\":\"#1126#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"193\",\"windowid\":\"451\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":17},{\"value\":13},{\"value\":15},{\"value\":3},{\"value\":\"#1125#\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16069\",\"windowid\":\"451\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":1},{\"value\":16},{\"value\":15},{\"value\":18},{\"value\":[{\"v\":4},{\"v\":7},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20208\",\"windowid\":\"451\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":1},{\"value\":34},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1127#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11451\",\"windowid\":\"451\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":17},{\"value\":34},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1128#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"24996\",\"windowid\":\"451\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":10},{\"value\":33},{\"value\":34},{\"value\":15},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1129#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11385\",\"windowid\":\"451\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":38},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20985\",\"windowid\":\"451\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":17},{\"value\":16},{\"value\":15},{\"value\":18},{\"value\":[{\"v\":4},{\"v\":7},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18290\",\"windowid\":\"451\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":33},{\"value\":16},{\"value\":15},{\"value\":18},{\"value\":[{\"v\":4},{\"v\":7},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3405\",\"windowid\":\"451\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":43},{\"value\":39},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"86\",\"windowid\":\"451\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":11},{\"value\":22},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#1131#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29467\",\"windowid\":\"451\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":12},{\"value\":34},{\"value\":7},{\"value\":14},{\"value\":3},{\"value\":\"#1132#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}\n','0',1),(2034,0,1755,'SCREEN_CONFIG_TERMINALS',141,'{\"objects\":[{\"id\":\"5233\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":141},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"#714#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"30900\",\"windowid\":\"5233\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":39},{\"value\":2},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"829\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26201\",\"windowid\":\"5233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":40},{\"value\":14},{\"value\":13},{\"value\":3},{\"value\":\"#715#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31434\",\"windowid\":\"5233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":13},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#716#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"29270\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":13},{\"value\":14},{\"value\":26},{\"value\":25},{\"value\":[{\"v\":26}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"25224\",\"windowid\":\"5233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#344#\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"27942\",\"windowid\":\"5233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":40},{\"value\":30},{\"value\":13},{\"value\":3},{\"value\":\"#717#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23713\",\"windowid\":\"5233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":40},{\"value\":27},{\"value\":13},{\"value\":3},{\"value\":\"#719#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15709\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":27},{\"value\":13},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"Doc\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"13836\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":4},{\"value\":40},{\"value\":20},{\"value\":13},{\"value\":3},{\"value\":\"#720#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"16905\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":40},{\"value\":33},{\"value\":13},{\"value\":3},{\"value\":\"#718#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"10212\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":8},{\"value\":13},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#862#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"21775\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":17},{\"value\":26},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#1460#\"},{\"value\":[{\"v\":27}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"31945\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":19},{\"value\":26},{\"value\":10},{\"value\":27},{\"value\":3},{\"value\":\"#1689#\"},{\"value\":[{\"v\":27}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"21913\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":18},{\"value\":26},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"#1690#\"},{\"value\":[{\"v\":27}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"545\",\"windowid\":\"5233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":40},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"8911\",\"windowid\":\"5233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11367\",\"windowid\":\"5233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"29034\",\"windowid\":\"5233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-6},{\"value\":6},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#300#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1087.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"20205\",\"windowid\":\"5233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-5},{\"value\":0},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#299#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1088.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31470\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":13},{\"value\":13},{\"value\":11},{\"value\":25},{\"value\":[{\"v\":11}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":0}]},{\"id\":\"2751\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":24},{\"value\":29},{\"value\":35},{\"value\":11},{\"value\":3},{\"value\":\"#1105#\"},{\"value\":[{\"v\":11}]},{\"value\":5},{\"value\":\"12\"},{\"value\":1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"15234\",\"windowid\":\"5233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":22},{\"value\":24},{\"value\":21},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"30086\",\"windowid\":\"5233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":23},{\"value\":24},{\"value\":26},{\"value\":5},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"23491\",\"windowid\":\"5233\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":13},{\"value\":9},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1108#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1093.png\"},{\"value\":5},{\"value\":-1},{\"value\":1}]},{\"id\":\"16541\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":29},{\"value\":9},{\"value\":11},{\"value\":26},{\"value\":[{\"v\":11}]},{\"value\":\"CButton\"},{\"value\":2},{\"value\":1},{\"value\":0}]},{\"id\":\"3596\",\"windowid\":\"5233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":25},{\"value\":13},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"#2002#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"16906\",\"windowid\":\"5233\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":28},{\"value\":40},{\"value\":23},{\"value\":13},{\"value\":3},{\"value\":\"#2080#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"10679\",\"windowid\":\"5233\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":26},{\"value\":40},{\"value\":36},{\"value\":13},{\"value\":3},{\"value\":\"#341#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',1),(2039,0,3600,'SCREEN_LOYALTY',186,'\n{\"objects\":[{\"id\":\"27237\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":186},{\"value\":9},{\"value\":6},{\"value\":34},{\"value\":37},{\"value\":\"#1708#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"14387\",\"windowid\":\"27237\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":1},{\"value\":6},{\"value\":32},{\"value\":22},{\"value\":[{\"v\":32}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24814\",\"windowid\":\"27237\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":27},{\"value\":29},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"Nao Resgatar\"},{\"value\":0},{\"value\":\"0x000000\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22520\",\"windowid\":\"27237\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":21},{\"value\":29},{\"value\":6},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"Resgatar\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15694\",\"windowid\":\"27237\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":1},{\"value\":3},{\"value\":32},{\"value\":3},{\"value\":\"Campanhas\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}\n,{\"id\":\"15695\",\"windowid\":\"27237\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":149},{\"value\":1},{\"value\":29},{\"value\":9},{\"value\":3},{\"value\":\"Pontos\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}\n,{\"id\":\"15696\",\"windowid\":\"27237\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":150},{\"value\":11},{\"value\":29},{\"value\":9},{\"value\":3},{\"value\":\"Vai Ganhar\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]}\n]}','0',1),(2040,0,3601,'SCREEN_TABLE_EDIT_BALCAO',6004,'{\"objects\":[{\"id\":\"9452\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"Venda\"},{\"value\":1},{\"value\":\"1\"},{\"value\":-1}]},{\"id\":\"6975\",\"windowid\":\"9452\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":670},{\"value\":37},{\"value\":33},{\"value\":16},{\"value\":3},{\"value\":\"Cliente\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"1220\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-13},{\"value\":0},{\"value\":30},{\"value\":4},{\"value\":21},{\"value\":\"CButton\"},{\"value\":\"#256#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5513\",\"windowid\":\"9452\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":4},{\"value\":0},{\"value\":49},{\"value\":4},{\"value\":9},{\"value\":-1},{\"value\":102},{\"value\":-1},{\"color\":\"\"},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"},{\"strechslide\":\"1\"}]},{\"id\":\"4130\",\"windowid\":\"9452\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":4},{\"value\":4},{\"value\":49},{\"value\":4},{\"value\":9},{\"value\":-2},{\"value\":103},{\"value\":-1},{\"color\":\"\"},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"},{\"strechslide\":\"1\"}]},{\"id\":\"3665\",\"windowid\":\"9452\",\"type\":\"com.sage.components.slides.SlideGrid\",\"arguments\":[{\"value\":103},{\"value\":4},{\"value\":8},{\"value\":49},{\"value\":22},{\"value\":7},{\"value\":3},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"last_grid_x\":7},{\"last_grid_y\":3},{\"default_image\":\"\"},{\"strech\":0},{\"value\":[{}]},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"2943\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-16},{\"value\":17},{\"value\":38},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"-\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1052.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"7994\",\"windowid\":\"9452\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":17},{\"value\":35},{\"value\":4},{\"value\":3},{\"value\":\"Qt\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":2},{\"value\":-1}]},{\"id\":\"7338\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-15},{\"value\":17},{\"value\":30},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"+\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1051.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"1787\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-12},{\"value\":17},{\"value\":43},{\"value\":4},{\"value\":8},{\"value\":\"CButton\"},{\"value\":\"Pedir\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1057.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"8046\",\"windowid\":\"9452\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":22},{\"value\":30},{\"value\":14},{\"value\":3},{\"value\":\"Total\"},{\"value\":0},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"2573\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":135},{\"value\":37},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"1\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"9995\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":136},{\"value\":41},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"2\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"9582\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":137},{\"value\":45},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"5\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"1464\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":138},{\"value\":37},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"10\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"3475\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":139},{\"value\":41},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"20\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"1913\",\"windowid\":\"9452\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":67},{\"value\":37},{\"value\":33},{\"value\":16},{\"value\":3},{\"value\":\"Cliente\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5750\",\"windowid\":\"9452\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":69},{\"value\":40},{\"value\":30},{\"value\":13},{\"value\":3},{\"value\":\"NIF\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9952\",\"windowid\":\"9452\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":104},{\"value\":22},{\"value\":33},{\"value\":14},{\"value\":3},{\"value\":\"Valor\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8629\",\"windowid\":\"9452\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":204},{\"value\":22},{\"value\":39},{\"value\":14},{\"value\":8},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"Metodo|Valor\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1873\",\"windowid\":\"9452\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":110},{\"value\":22},{\"value\":36},{\"value\":14},{\"value\":3},{\"value\":\"Troco\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7231\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":37},{\"value\":37},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"Hist ³rico\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1069.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"2581\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-18},{\"value\":0},{\"value\":0},{\"value\":4},{\"value\":6},{\"value\":\"CButton\"},{\"value\":\"Gaveta\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1153.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"8044\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-19},{\"value\":45},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"Descontos\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1071.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"7053\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":41},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"Cancelar artigos\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1067.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"488\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-20},{\"value\":22},{\"value\":47},{\"value\":14},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Fechar directo\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1152.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"5016\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":134},{\"value\":45},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"Limpa\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"273\",\"windowid\":\"9452\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":4},{\"value\":30},{\"value\":13},{\"value\":21},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":5}]},{\"value\":\"Qnt|Descricao|Total\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1367\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":132},{\"value\":37},{\"value\":30},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"6323\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-17},{\"value\":49},{\"value\":46},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"\"},{\"value\":0},{\"value\":\"\"},{\"value\":\"1086.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"3467\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-14},{\"value\":49},{\"value\":36},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"SubTotais\"},{\"value\":0},{\"value\":\"\"},{\"value\":\"1054.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"4170\",\"windowid\":\"9452\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-11},{\"value\":49},{\"value\":41},{\"value\":4},{\"value\":5},{\"value\":\"CButton\"},{\"value\":\"Pagar\"},{\"value\":0},{\"value\":\"\"},{\"value\":\"1053.png\"},{\"value\":2},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]}]}','0',1),(2041,0,2456,'SCREEN_CONFIG_PAYMENTTYPES',187,'{\"objects\":[{\"id\":\"17899\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":187},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"Pagamentos Auto\"},{\"value\":1},{\"value\":\"1\"},{\"value\":-1}]},{\"id\":\"3879\",\"windowid\":\"17899\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":39},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"4345\",\"windowid\":\"17899\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":41},{\"value\":10},{\"value\":12},{\"value\":3},{\"value\":\"Seqr Password\"},{\"value\":1},{\"value\":8},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"9474\",\"windowid\":\"17899\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":41},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"Seqr User id\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"2261\",\"windowid\":\"17899\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":41},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"Seqr Login\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1048\",\"windowid\":\"17899\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4778},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"Terminais\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"4206\",\"windowid\":\"17899\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":35},{\"value\":[{\"v\":12}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4428\",\"windowid\":\"29495\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Cancel\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"6721\",\"windowid\":\"29495\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"OK\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"3252\",\"windowid\":\"17899\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-3},{\"value\":28},{\"value\":17},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Registar\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]},{\"id\":\"9622\",\"windowid\":\"17899\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":13},{\"value\":4},{\"value\":27},{\"value\":3},{\"value\":\"Nome Seqr\"},{\"value\":0},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"4481\",\"windowid\":\"17899\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":6},{\"value\":13},{\"value\":7},{\"value\":27},{\"value\":3},{\"value\":\"Seqr Id\"},{\"value\":0},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"9078\",\"windowid\":\"17899\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":13},{\"value\":10},{\"value\":27},{\"value\":3},{\"value\":\"Password Seqr\"},{\"value\":0},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"6408\",\"windowid\":\"17899\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":13},{\"value\":13},{\"value\":27},{\"value\":3},{\"value\":\"Seqr QrCode\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"673\",\"windowid\":\"17899\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-4},{\"value\":34},{\"value\":17},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Cancelar\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1},{\"bgtype\":\"color\"},{\"bgcolor\":\"\"},{\"bgimage\":\"\"},{\"bgimage\":\"\"}]}]}','0',1),(2045,0,3602,'SCREEN_DAY_CLOSE',184,'\n{\n	\"objects\": [{\n		\"id\": \"6613\",\n		\"type\": \"com.sage.components.window.Window\",\n		\"arguments\": [{\n			\"value\": 184\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 53\n		}, {\n			\"value\": 53\n		}, {\n			\"value\": \"#1968#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": \"[[1]]\"\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"21026\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": -2\n		}, {\n			\"value\": 47\n		}, {\n			\"value\": 46\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#247#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"1094.png\"\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"26845\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.list.ListBox\",\n		\"arguments\": [{\n			\"value\": 201\n		}, {\n			\"value\": 24\n		}, {\n			\"value\": 32\n		}, {\n			\"value\": 18\n		}, {\n			\"value\": 14\n		}, {\n			\"value\": [{\n				\"v\": 12\n			}, {\n				\"v\": 4\n			}]\n		}, {\n			\"value\": \"#1961#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"21372\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 1\n		}, {\n			\"value\": 24\n		}, {\n			\"value\": 46\n		}, {\n			\"value\": 18\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1951#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"32283\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 3233\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 29\n		}, {\n			\"value\": 18\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1952#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"6648\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.list.ListBox\",\n		\"arguments\": [{\n			\"value\": 202\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 32\n		}, {\n			\"value\": 18\n		}, {\n			\"value\": 14\n		}, {\n			\"value\": [{\n				\"v\": 5\n			}, {\n				\"v\": 3\n			}, {\n				\"v\": 7\n			}]\n		}, {\n			\"value\": \"#1962#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"8613\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 15\n		}, {\n			\"value\": 9\n		}, {\n			\"value\": 46\n		}, {\n			\"value\": 9\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1972#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"11645\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.list.ListBox\",\n		\"arguments\": [{\n			\"value\": 203\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 20\n		}, {\n			\"value\": [{\n				\"v\": 10\n			}, {\n				\"v\": 18\n			}, {\n				\"v\": 10\n			}, {\n				\"v\": 6\n			}]\n		}, {\n			\"value\": \"#1953#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 0\n		}]\n	}, {\n		\"id\": \"17223\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 4\n		}, {\n			\"value\": 9\n		}, {\n			\"value\": 24\n		}, {\n			\"value\": 9\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1954#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"12327\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.list.DropBox\",\n		\"arguments\": [{\n			\"value\": 3\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 24\n		}, {\n			\"value\": 9\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1955#\"\n		}, {\n			\"value\": [{\n				\"v\": 9\n			}]\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": \"CButton\"\n		}]\n	}, {\n		\"id\": \"4158\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 333\n		}, {\n			\"value\": 24\n		}, {\n			\"value\": 29\n		}, {\n			\"value\": 18\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1956#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"10115\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 313\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1957#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"30724\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 5\n		}, {\n			\"value\": 18\n		}, {\n			\"value\": 24\n		}, {\n			\"value\": 9\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1958#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"19649\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.list.DropBox\",\n		\"arguments\": [{\n			\"value\": 6\n		}, {\n			\"value\": 27\n		}, {\n			\"value\": 24\n		}, {\n			\"value\": 9\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1959#\"\n		}, {\n			\"value\": [{\n				\"v\": 9\n			}]\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": \"CButton\"\n		}]\n	}, {\n		\"id\": \"8254\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 7\n		}, {\n			\"value\": 43\n		}, {\n			\"value\": 39\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#1960#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"856\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 8\n		}, {\n			\"value\": 36\n		}, {\n			\"value\": 24\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#1966#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"2376\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 9\n		}, {\n			\"value\": 39\n		}, {\n			\"value\": 24\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#254#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"20977\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 11\n		}, {\n			\"value\": 43\n		}, {\n			\"value\": 35\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"Envelope\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"28662\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 10\n		}, {\n			\"value\": 43\n		}, {\n			\"value\": 32\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1970#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"22428\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 12\n		}, {\n			\"value\": 43\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1969#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"7805\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 13\n		}, {\n			\"value\": 43\n		}, {\n			\"value\": 7\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1971#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"18318\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 14\n		}, {\n			\"value\": 19\n		}, {\n			\"value\": 34\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#1852#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"1091.png\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"11694\",\n		\"windowid\": \"6613\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 2\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 46\n		}, {\n			\"value\": 9\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1951#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}]\n}\n','0',1),(2047,0,3602,'SCREEN_TABLE_CLOSE',11,'\n{\"objects\":[{\"id\":\"4064\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":11},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":53},{\"value\":\"#262#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"20208\",\"windowid\":\"4064\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":12},{\"value\":0},{\"value\":41},{\"value\":47},{\"value\":4},{\"value\":-1},{\"value\":0},{\"value\":\"\"}]},{\"id\":\"7512\",\"windowid\":\"4064\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":10},{\"value\":42},{\"value\":16},{\"value\":11},{\"value\":3},{\"value\":\"#275#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":69},{\"value\":\"CButton\"}]},{\"id\":\"7755\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":57},{\"value\":0},{\"value\":0},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"16\"},{\"value\":0},{\"value\":0},{\"value\":-1}]},{\"id\":\"27169\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":51},{\"value\":29},{\"value\":34},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#264#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"8449\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":58},{\"value\":42},{\"value\":4},{\"value\":11},{\"value\":3},{\"value\":\"#265#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23015\",\"windowid\":\"4064\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":203},{\"value\":29},{\"value\":4},{\"value\":12},{\"value\":27},{\"value\":[{\"v\":8},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"20627\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":59},{\"value\":42},{\"value\":7},{\"value\":11},{\"value\":3},{\"value\":\"#266#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6819\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":52},{\"value\":33},{\"value\":34},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#267#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"15272\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":37},{\"value\":34},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#268#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32426\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":68},{\"value\":29},{\"value\":31},{\"value\":12},{\"value\":3},{\"value\":\"#269#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"6243\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":54},{\"value\":29},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#270#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25643\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":55},{\"value\":33},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#271#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"12903\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":56},{\"value\":37},{\"value\":38},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#272#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"32170\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":60},{\"value\":42},{\"value\":16},{\"value\":11},{\"value\":3},{\"value\":\"#275#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23020\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":62},{\"value\":45},{\"value\":22},{\"value\":8},{\"value\":3},{\"value\":\"#276#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"11061\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":63},{\"value\":42},{\"value\":31},{\"value\":11},{\"value\":3},{\"value\":\"#277#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"25751\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":67},{\"value\":0},{\"value\":47},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#280#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1020.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21100\",\"windowid\":\"4064\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":0},{\"value\":4},{\"value\":12},{\"value\":42},{\"value\":[{\"v\":2},{\"v\":6},{\"v\":4}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"5617\",\"windowid\":\"4064\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":7},{\"value\":12},{\"value\":26},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":1},{\"value\":1}]},{\"id\":\"21388\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":16},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"13485\",\"windowid\":\"4064\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":102},{\"value\":5},{\"value\":47},{\"value\":48},{\"value\":4},{\"value\":8},{\"value\":-1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27682\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":70},{\"value\":42},{\"value\":10},{\"value\":11},{\"value\":3},{\"value\":\"#769#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31527\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":49},{\"value\":57},{\"value\":10},{\"value\":3},{\"value\":\"#773#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"7191\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":73},{\"value\":42},{\"value\":38},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#776#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"17595\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":74},{\"value\":42},{\"value\":42},{\"value\":11},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#777#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":0}]},{\"id\":\"2083\",\"windowid\":\"4064\",\"type\":\"com.sage.components.slides.Slide\",\"arguments\":[{\"value\":101},{\"value\":16},{\"value\":42},{\"value\":33},{\"value\":4},{\"value\":5},{\"value\":-2},{\"value\":-1},{\"value\":2}]},{\"id\":\"9953\",\"windowid\":\"4064\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":202},{\"value\":16},{\"value\":10},{\"value\":12},{\"value\":23},{\"value\":[{\"v\":2},{\"v\":7},{\"v\":3}]},{\"value\":\"CButton\"},{\"value\":0},{\"value\":2},{\"value\":1}]},{\"id\":\"27894\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":71},{\"value\":16},{\"value\":7},{\"value\":12},{\"value\":3},{\"value\":\"#263#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"23610\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":77},{\"value\":16},{\"value\":4},{\"value\":12},{\"value\":3},{\"value\":\"#773#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"4249\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":76},{\"value\":16},{\"value\":33},{\"value\":12},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#774#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"22764\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":78},{\"value\":16},{\"value\":37},{\"value\":12},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#778#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"19406\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":79},{\"value\":12},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#781#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"23302\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":80},{\"value\":49},{\"value\":42},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#779#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":2},{\"value\":-1},{\"value\":2}]},{\"id\":\"21369\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":82},{\"value\":42},{\"value\":19},{\"value\":11},{\"value\":3},{\"value\":\"#813#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"21369\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":141},{\"value\":42},{\"value\":25},{\"value\":11},{\"value\":3},{\"value\":\"#1781#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7864\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":663},{\"value\":42},{\"value\":28},{\"value\":11},{\"value\":3},{\"value\":\"#1459#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27232\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":88},{\"value\":31},{\"value\":69},{\"value\":10},{\"value\":3},{\"value\":\"#1392#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"23978\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":42},{\"value\":69},{\"value\":10},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#1619#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"9657\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":99},{\"value\":42},{\"value\":34},{\"value\":11},{\"value\":3},{\"value\":\"#875#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"14777\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":89},{\"value\":42},{\"value\":22},{\"value\":3},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#344#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1072.png\"},{\"value\":3},{\"value\":-1},{\"value\":-1}]},{\"id\":\"865\",\"windowid\":\"4064\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":120},{\"value\":42},{\"value\":13},{\"value\":11},{\"value\":3},{\"value\":\"#1729#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"30430\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"18109\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"17677\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"31109\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":12},{\"value\":26},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":1}]},{\"id\":\"8782\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":12},{\"value\":19},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":1}]},{\"id\":\"6162\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":6},{\"value\":12},{\"value\":15},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#590#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1091.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"24159\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":7},{\"value\":12},{\"value\":11},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#591#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1092.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"27870\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":8},{\"value\":12},{\"value\":22},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#592#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1089.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"21661\",\"windowid\":\"4064\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":9},{\"value\":12},{\"value\":26},{\"value\":4},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#593#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1090.png\"},{\"value\":1},{\"value\":-1},{\"value\":2}]},{\"id\":\"32094\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":75},{\"value\":12},{\"value\":19},{\"value\":4},{\"value\":3},{\"value\":\"#775#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]},{\"id\":\"22027\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":125},{\"value\":13},{\"value\":8},{\"value\":13},{\"value\":3},{\"value\":\"#1903#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"14948\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":121},{\"value\":13},{\"value\":14},{\"value\":13},{\"value\":3},{\"value\":\"#1904#\"},{\"value\":1},{\"value\":9},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"19626\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":122},{\"value\":13},{\"value\":21},{\"value\":13},{\"value\":3},{\"value\":\"#1878#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"30871\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":123},{\"value\":13},{\"value\":24},{\"value\":13},{\"value\":8},{\"value\":\"#1879#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":3}]},{\"id\":\"10883\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":124},{\"value\":13},{\"value\":32},{\"value\":13},{\"value\":8},{\"value\":\"#1880#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":1},{\"value\":-1},{\"value\":3}]},{\"id\":\"6613\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":126},{\"value\":13},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#1876#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"2578\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":127},{\"value\":13},{\"value\":17},{\"value\":13},{\"value\":3},{\"value\":\"#1877#\"},{\"value\":1},{\"value\":10},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":3}]},{\"id\":\"22132\",\"windowid\":\"4064\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":129},{\"value\":16},{\"value\":0},{\"value\":37},{\"value\":3},{\"value\":\"#2061#\"},{\"value\":0},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":2}]}]}\n','0',1),(2048,0,3602,'SCREEN_TPA_OPTIONS',188,'\n{\"objects\":[{\"id\":\"5330\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":188},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":45},{\"value\":\"TPA\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},\n{\"id\":\"15446\",\"windowid\":\"5330\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":21},{\"value\":4},{\"value\":25},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Abrir\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"15447\",\"windowid\":\"5330\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":22},{\"value\":12},{\"value\":25},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Fechar\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"15452\",\"windowid\":\"5330\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":28},{\"value\":20},{\"value\":25},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Apuro\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"15452\",\"windowid\":\"5330\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":27},{\"value\":20},{\"value\":30},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Devolucao\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"15448\",\"windowid\":\"5330\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":23},{\"value\":4},{\"value\":30},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Manutencao\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"15449\",\"windowid\":\"5330\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":24},{\"value\":12},{\"value\":30},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Supervisor\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"15451\",\"windowid\":\"5330\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":26},{\"value\":4},{\"value\":35},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Reimprime\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"15450\",\"windowid\":\"5330\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":25},{\"value\":12},{\"value\":35},{\"value\":8},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Estado\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},\n{\"id\":\"19555\",\"windowid\":\"5330\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":46},{\"value\":39},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"Sair\"},\n{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]}]}\n','0',1),(2049,0,3545,'SCREEN_CONFIG_SYSTEM',117,'{\"objects\":[{\"id\":\"17927\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":117},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":51},{\"value\":\"#486#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"18288\",\"windowid\":\"17927\",\"type\":\"com.sage.components.panels.Panel\",\"arguments\":[{\"value\":301},{\"value\":0},{\"value\":0},{\"value\":53},{\"value\":43},{\"value\":1},{\"value\":-1},{\"value\":1},{\"value\":\"\"}]},{\"id\":\"30429\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":0},{\"value\":31},{\"value\":16},{\"value\":3},{\"value\":\"#487#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"3338\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":0},{\"value\":1},{\"value\":16},{\"value\":3},{\"value\":\"#488#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24278\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":3},{\"value\":8},{\"value\":13},{\"value\":8},{\"value\":3},{\"value\":\"#489#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"26475\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":0},{\"value\":7},{\"value\":16},{\"value\":3},{\"value\":\"#490#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"25325\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":0},{\"value\":19},{\"value\":16},{\"value\":3},{\"value\":\"#491#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"17170\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":7},{\"value\":0},{\"value\":16},{\"value\":16},{\"value\":3},{\"value\":\"#493#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13141\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":8},{\"value\":0},{\"value\":25},{\"value\":16},{\"value\":3},{\"value\":\"#494#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22122\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":9},{\"value\":0},{\"value\":13},{\"value\":8},{\"value\":3},{\"value\":\"#495#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"24513\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":10},{\"value\":0},{\"value\":28},{\"value\":16},{\"value\":3},{\"value\":\"#496#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"16744\",\"windowid\":\"17927\",\"type\":\"com.sage.components.list.ListBox\",\"arguments\":[{\"value\":201},{\"value\":17},{\"value\":1},{\"value\":36},{\"value\":24},{\"value\":[{\"v\":36}]},{\"value\":\"CCheckBox\"},{\"value\":0},{\"value\":0},{\"value\":1}]},{\"id\":\"25376\",\"windowid\":\"17927\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":12},{\"value\":0},{\"value\":4},{\"value\":16},{\"value\":3},{\"value\":\"#498#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"10980\",\"windowid\":\"17927\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":0},{\"value\":22},{\"value\":16},{\"value\":3},{\"value\":\"#492#\"},{\"value\":[{\"v\":16}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"2559\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":13},{\"value\":0},{\"value\":34},{\"value\":16},{\"value\":3},{\"value\":\"#1393#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20970\",\"windowid\":\"17927\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":47},{\"value\":44},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1041.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"28971\",\"windowid\":\"17927\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":41},{\"value\":44},{\"value\":6},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"1042.png\"},{\"value\":5},{\"value\":-1},{\"value\":-1}]},{\"id\":\"31312\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":14},{\"value\":17},{\"value\":31},{\"value\":16},{\"value\":3},{\"value\":\"#1862#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"1619\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":17},{\"value\":34},{\"value\":16},{\"value\":3},{\"value\":\"#1863#\"},{\"value\":1},{\"value\":11},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"5982\",\"windowid\":\"17927\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":17},{\"value\":34},{\"value\":30},{\"value\":11},{\"value\":3},{\"value\":\"#2017#\"},{\"value\":[{\"v\":11}]},{\"value\":6},{\"value\":\"12\"},{\"value\":-1},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"691\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":34},{\"value\":33},{\"value\":19},{\"value\":3},{\"value\":\"#2018#\"},{\"value\":0},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27718\",\"windowid\":\"17927\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":16},{\"value\":45},{\"value\":30},{\"value\":8},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#2019#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"27718\",\"windowid\":\"17927\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":27},{\"value\":45},{\"value\":40},{\"value\":8},{\"value\":3},{\"value\":\"CButton\"},{\"value\":\"#2089#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"22538\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":0},{\"value\":10},{\"value\":16},{\"value\":3},{\"value\":\"#2027#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22967\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":22},{\"value\":0},{\"value\":37},{\"value\":33},{\"value\":3},{\"value\":\"#2058#\"},{\"value\":1},{\"value\":51},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22968\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":24},{\"value\":34},{\"value\":36},{\"value\":16},{\"value\":3},{\"value\":\"#356#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"22968\",\"windowid\":\"17927\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":35},{\"value\":34},{\"value\":40},{\"value\":11},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#2090#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"2676\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":23},{\"value\":0},{\"value\":40},{\"value\":33},{\"value\":3},{\"value\":\"#2059#\"},{\"value\":1},{\"value\":51},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31312\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":36},{\"value\":17},{\"value\":25},{\"value\":16},{\"value\":3},{\"value\":\"#2099#\"},{\"value\":1},{\"value\":0},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"31313\",\"windowid\":\"17927\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":37},{\"value\":17},{\"value\":28},{\"value\":16},{\"value\":3},{\"value\":\"#2100#\"},{\"value\":1},{\"value\":11},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',1),(2050,0,3545,'SCREEN_TABLECLOSE_RETAIL',10011,'\n{\n	\"objects\": [{\n		\"id\": \"1111\",\n		\"type\": \"com.sage.components.window.Window\",\n		\"arguments\": [{\n			\"value\": 11\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 53\n		}, {\n			\"value\": 53\n		}, {\n			\"value\": \"#262#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": \"[[1]]\"\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"21032\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.panels.Panel\",\n		\"arguments\": [{\n			\"value\": 301\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 41\n		}, {\n			\"value\": 47\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"\"\n		}]\n	}, {\n		\"id\": \"16389\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.list.DropBox\",\n		\"arguments\": [{\n			\"value\": 10\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 16\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#275#\"\n		}, {\n			\"value\": [{\n				\"v\": 11\n			}]\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 69\n		}, {\n			\"value\": \"CButton\"\n		}]\n	}, {\n		\"id\": \"1712\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 57\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#263#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"16\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"32605\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 51\n		}, {\n			\"value\": 29\n		}, {\n			\"value\": 34\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#264#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"30460\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 58\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#265#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"21534\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.list.ListBox\",\n		\"arguments\": [{\n			\"value\": 203\n		}, {\n			\"value\": 29\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 27\n		}, {\n			\"value\": [{\n				\"v\": 8\n			}, {\n				\"v\": 3\n			}]\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"30184\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 59\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 7\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#266#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"5479\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 52\n		}, {\n			\"value\": 33\n		}, {\n			\"value\": 34\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#267#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"22279\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 53\n		}, {\n			\"value\": 37\n		}, {\n			\"value\": 34\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#268#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"26048\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 68\n		}, {\n			\"value\": 29\n		}, {\n			\"value\": 31\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#269#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"25331\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 54\n		}, {\n			\"value\": 29\n		}, {\n			\"value\": 38\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#270#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"17073\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 55\n		}, {\n			\"value\": 33\n		}, {\n			\"value\": 38\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#271#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"25382\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 56\n		}, {\n			\"value\": 37\n		}, {\n			\"value\": 38\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#272#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"12713\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 60\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 16\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#275#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"10665\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 62\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 22\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#276#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"32131\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 67\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 47\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#280#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"1020.png\"\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"23315\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.list.ListBox\",\n		\"arguments\": [{\n			\"value\": 201\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": [{\n				\"v\": 2\n			}, {\n				\"v\": 6\n			}, {\n				\"v\": 4\n			}]\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"20729\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.list.ListBox\",\n		\"arguments\": [{\n			\"value\": 202\n		}, {\n			\"value\": 16\n		}, {\n			\"value\": 7\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 26\n		}, {\n			\"value\": [{\n				\"v\": 2\n			}, {\n				\"v\": 7\n			}, {\n				\"v\": 3\n			}]\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"13747\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 71\n		}, {\n			\"value\": 16\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#263#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"7604\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.slides.Slide\",\n		\"arguments\": [{\n			\"value\": 102\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 47\n		}, {\n			\"value\": 48\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 8\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"9946\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 77\n		}, {\n			\"value\": 49\n		}, {\n			\"value\": 57\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#773#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"31966\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 73\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 38\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#776#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 2\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 0\n		}]\n	}, {\n		\"id\": \"18333\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.slides.Slide\",\n		\"arguments\": [{\n			\"value\": 101\n		}, {\n			\"value\": 16\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 33\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": -2\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 2\n		}]\n	}, {\n		\"id\": \"23917\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.list.ListBox\",\n		\"arguments\": [{\n			\"value\": 202\n		}, {\n			\"value\": 16\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 23\n		}, {\n			\"value\": [{\n				\"v\": 2\n			}, {\n				\"v\": 7\n			}, {\n				\"v\": 3\n			}]\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 2\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"25740\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 71\n		}, {\n			\"value\": 16\n		}, {\n			\"value\": 7\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#263#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 2\n		}]\n	}, {\n		\"id\": \"13680\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 77\n		}, {\n			\"value\": 16\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#773#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 2\n		}]\n	}, {\n		\"id\": \"4139\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 76\n		}, {\n			\"value\": 16\n		}, {\n			\"value\": 33\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"CCheckBox\"\n		}, {\n			\"value\": \"#774#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 2\n		}]\n	}, {\n		\"id\": \"22319\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 78\n		}, {\n			\"value\": 16\n		}, {\n			\"value\": 37\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#778#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 2\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 2\n		}]\n	}, {\n		\"id\": \"32310\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 79\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#781#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 2\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 2\n		}]\n	}, {\n		\"id\": \"20442\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 80\n		}, {\n			\"value\": 49\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#779#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 2\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 2\n		}]\n	}, {\n		\"id\": \"5617\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 82\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 19\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#813#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"21369\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 141\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 13\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1781#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"9495\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 663\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 31\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1459#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"23572\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 88\n		}, {\n			\"value\": 31\n		}, {\n			\"value\": 69\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1392#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"12219\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 89\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 69\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#1619#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"6430\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 99\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 34\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#875#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"1377\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 89\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 25\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#275#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"1072.png\"\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"1795\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 6\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 15\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#590#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"1091.png\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"12236\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 7\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#591#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"1092.png\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"27033\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 8\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 22\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#592#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"1089.png\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"10284\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 9\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 26\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#593#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"1090.png\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"20277\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 75\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 19\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#775#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"32194\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 6\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 15\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#590#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"1091.png\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 2\n		}]\n	}, {\n		\"id\": \"25423\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 7\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#591#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"1092.png\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 2\n		}]\n	}, {\n		\"id\": \"2684\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 8\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 22\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#592#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"1089.png\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 2\n		}]\n	}, {\n		\"id\": \"19240\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 9\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 26\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#593#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"1090.png\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 2\n		}]\n	}, {\n		\"id\": \"28022\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 75\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 19\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#775#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 2\n		}]\n	}, {\n		\"id\": \"1227\",\n		\"windowid\": \"1111\",\n		\"type\": \"com.sage.components.list.DropBox\",\n		\"arguments\": [{\n			\"value\": 120\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1729#\"\n		}, {\n			\"value\": [{\n				\"v\": 11\n			}]\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": \"CButton\"\n		}]\n	}]\n}\n','0',1),(2051,0,3602,'SCREEN_TABLE_CLOSE_SHORT',13,'\n{\n	\"objects\": [{\n		\"id\": \"20079\",\n		\"type\": \"com.sage.components.window.Window\",\n		\"arguments\": [{\n			\"value\": 13\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 32\n		}, {\n			\"value\": 35\n		}, {\n			\"value\": \"#262#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": \"[[1]]\"\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"5295\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 51\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 23\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#264#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"31994\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 58\n		}, {\n			\"value\": 14\n		}, {\n			\"value\": 2\n		}, {\n			\"value\": 17\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#265#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"19813\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.list.ListBox\",\n		\"arguments\": [{\n			\"value\": 203\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 2\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 18\n		}, {\n			\"value\": [{\n				\"v\": 8\n			}, {\n				\"v\": 3\n			}]\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"20719\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 59\n		}, {\n			\"value\": 14\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 17\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#266#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"30176\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 52\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 23\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#267#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"3725\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 53\n		}, {\n			\"value\": 9\n		}, {\n			\"value\": 23\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#268#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"11125\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 68\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 20\n		}, {\n			\"value\": 12\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#269#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"26530\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 54\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 27\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#270#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"25435\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 55\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 27\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#271#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"25763\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 56\n		}, {\n			\"value\": 9\n		}, {\n			\"value\": 27\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#272#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"13286\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 77\n		}, {\n			\"value\": 49\n		}, {\n			\"value\": 57\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#773#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 1\n		}]\n	}, {\n		\"id\": \"31610\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 88\n		}, {\n			\"value\": 31\n		}, {\n			\"value\": 69\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1392#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"14490\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 89\n		}, {\n			\"value\": 42\n		}, {\n			\"value\": 69\n		}, {\n			\"value\": 10\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#1619#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"27096\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 132\n		}, {\n			\"value\": 26\n		}, {\n			\"value\": 27\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#845#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"28595\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 131\n		}, {\n			\"value\": 14\n		}, {\n			\"value\": 27\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#278#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"22289\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.buttons.Button\",\n		\"arguments\": [{\n			\"value\": 133\n		}, {\n			\"value\": 20\n		}, {\n			\"value\": 27\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": 4\n		}, {\n			\"value\": \"CButton\"\n		}, {\n			\"value\": \"#281#\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"0xFFFFFF\"\n		}, {\n			\"value\": \"null\"\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"9498\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.list.DropBox\",\n		\"arguments\": [{\n			\"value\": 10\n		}, {\n			\"value\": 16\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 15\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#275#\"\n		}, {\n			\"value\": [{\n				\"v\": 15\n			}]\n		}, {\n			\"value\": 6\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": 69\n		}, {\n			\"value\": \"CButton\"\n		}]\n	}, {\n		\"id\": \"8649\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 141\n		}, {\n			\"value\": 14\n		}, {\n			\"value\": 20\n		}, {\n			\"value\": 17\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#1781#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"8644\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 60\n		}, {\n			\"value\": 14\n		}, {\n			\"value\": 11\n		}, {\n			\"value\": 17\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#275#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 5\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}, {\n		\"id\": \"24036\",\n		\"windowid\": \"20079\",\n		\"type\": \"com.sage.components.text.TextBox\",\n		\"arguments\": [{\n			\"value\": 62\n		}, {\n			\"value\": 14\n		}, {\n			\"value\": 17\n		}, {\n			\"value\": 17\n		}, {\n			\"value\": 3\n		}, {\n			\"value\": \"#276#\"\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 1\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": \"12\"\n		}, {\n			\"value\": 0\n		}, {\n			\"value\": -1\n		}, {\n			\"value\": -1\n		}]\n	}]\n}\n','0',1),(2052,0,3602,'SCREEN_TABLE_CLOSE',11,'\n{\"objects\": [{\"id\": \"20205\",\"type\": \"com.sage.components.window.Window\",\"arguments\": [{\"value\": 11},{\"value\": 0},{\"value\": 0},{\"value\": 65},{\"value\": 53},{\"value\": \"#262#\"},{\"value\": 1},{\"value\": \"[[1]]\"},{\"value\": -1}]},{\"id\": \"1961\",\"windowid\": \"20205\",\"type\": \"com.sage.components.panels.Panel\",\"arguments\": [{\"value\": 301},{\"value\": 12},{\"value\": 0},{\"value\": 53},{\"value\": 47},{\"value\": 4},{\"value\": -1},{\"value\": 0},{\"value\": \"\"}]},{\"id\": \"6479\",\"windowid\": \"20205\",\"type\": \"com.sage.components.list.DropBox\",\"arguments\": [{\"value\": 10},{\"value\": 54},{\"value\": 17},{\"value\": 11},{\"value\": 3},{\"value\": \"#275#\"},{\"value\": [{\"v\": 11}]},{\"value\": 6},{\"value\": \"12\"},{\"value\": -1},{\"value\": 69},{\"value\": \"CButton\"}]},{\"id\": \"8379\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 57},{\"value\": 0},{\"value\": 0},{\"value\": 12},{\"value\": 3},{\"value\": \"#263#\"},{\"value\": 1},{\"value\": 0},{\"value\": 0},{\"value\": \"16\"},{\"value\": 0},{\"value\": 0},{\"value\": -1}]},{\"id\": \"17804\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 67},{\"value\": 0},{\"value\": 46},{\"value\": 5},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#280#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"1020.png\"},{\"value\": 3},{\"value\": -1},{\"value\": -1}]},{\"id\": \"5451\",\"windowid\": \"20205\",\"type\": \"com.sage.components.list.ListBox\",\"arguments\": [{\"value\": 201},{\"value\": 0},{\"value\": 4},{\"value\": 12},{\"value\": 42},{\"value\": [{\"v\": 2},{\"v\": 7},{\"v\": 3}]},{\"value\": \"CButton\"},{\"value\": 0},{\"value\": -1},{\"value\": -1}]},{\"id\": \"23852\",\"windowid\": \"20205\",\"type\": \"com.sage.components.list.ListBox\",\"arguments\": [{\"value\": 202},{\"value\": 16},{\"value\": 7},{\"value\": 12},{\"value\": 26},{\"value\": [{\"v\": 2},{\"v\": 7},{\"v\": 3}]},{\"value\": \"CButton\"},{\"value\": 0},{\"value\": 1},{\"value\": 1}]},{\"id\": \"19230\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 71},{\"value\": 16},{\"value\": 4},{\"value\": 12},{\"value\": 3},{\"value\": \"#263#\"},{\"value\": 0},{\"value\": 6},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": 1}]},{\"id\": \"12215\",\"windowid\": \"20205\",\"type\": \"com.sage.components.slides.Slide\",\"arguments\": [{\"value\": 102},{\"value\": 5},{\"value\": 47},{\"value\": 60},{\"value\": 4},{\"value\": 10},{\"value\": -1},{\"value\": -1},{\"value\": -1}]},{\"id\": \"14611\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 77},{\"value\": 49},{\"value\": 57},{\"value\": 10},{\"value\": 3},{\"value\": \"#773#\"},{\"value\": 0},{\"value\": 6},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": 1}]},{\"id\": \"28732\",\"windowid\": \"20205\",\"type\": \"com.sage.components.slides.Slide\",\"arguments\": [{\"value\": 101},{\"value\": 16},{\"value\": 42},{\"value\": 33},{\"value\": 4},{\"value\": 5},{\"value\": -2},{\"value\": -1},{\"value\": 2}]},{\"id\": \"9978\",\"windowid\": \"20205\",\"type\": \"com.sage.components.list.ListBox\",\"arguments\": [{\"value\": 202},{\"value\": 16},{\"value\": 10},{\"value\": 12},{\"value\": 23},{\"value\": [{\"v\": 2},{\"v\": 7},{\"v\": 3}]},{\"value\": \"CButton\"},{\"value\": 0},{\"value\": 2},{\"value\": 1}]},{\"id\": \"11331\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 71},{\"value\": 16},{\"value\": 7},{\"value\": 12},{\"value\": 3},{\"value\": \"#263#\"},{\"value\": 0},{\"value\": 6},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": 2}]},{\"id\": \"9552\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 77},{\"value\": 16},{\"value\": 4},{\"value\": 12},{\"value\": 3},{\"value\": \"#773#\"},{\"value\": 1},{\"value\": 6},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": 2}]},{\"id\": \"20255\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 76},{\"value\": 16},{\"value\": 33},{\"value\": 12},{\"value\": 3},{\"value\": \"CCheckBox\"},{\"value\": \"#774#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"null\"},{\"value\": 1},{\"value\": -1},{\"value\": 2}]},{\"id\": \"17340\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 78},{\"value\": 16},{\"value\": 37},{\"value\": 12},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#778#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"null\"},{\"value\": 2},{\"value\": -1},{\"value\": 2}]},{\"id\": \"15609\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 79},{\"value\": 12},{\"value\": 42},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#781#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"null\"},{\"value\": 2},{\"value\": -1},{\"value\": 2}]},{\"id\": \"1142\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 80},{\"value\": 49},{\"value\": 42},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#779#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"null\"},{\"value\": 2},{\"value\": -1},{\"value\": 2}]},{\"id\": \"11021\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 51},{\"value\": 41},{\"value\": 32},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#264#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"null\"},{\"value\": 1},{\"value\": -1},{\"value\": -1}]},{\"id\": \"15374\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 58},{\"value\": 54},{\"value\": 4},{\"value\": 11},{\"value\": 3},{\"value\": \"#265#\"},{\"value\": 0},{\"value\": 6},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": -1}]},{\"id\": \"18157\",\"windowid\": \"20205\",\"type\": \"com.sage.components.list.ListBox\",\"arguments\": [{\"value\": 203},{\"value\": 41},{\"value\": 4},{\"value\": 12},{\"value\": 25},{\"value\": [{\"v\": 8},{\"v\": 3}]},{\"value\": \"CButton\"},{\"value\": 0},{\"value\": -1},{\"value\": 1}]},{\"id\": \"18463\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 59},{\"value\": 54},{\"value\": 7},{\"value\": 11},{\"value\": 3},{\"value\": \"#266#\"},{\"value\": 1},{\"value\": 6},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": -1}]},{\"id\": \"3272\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 52},{\"value\": 45},{\"value\": 32},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#267#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"null\"},{\"value\": 1},{\"value\": -1},{\"value\": -1}]},{\"id\": \"7419\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 53},{\"value\": 49},{\"value\": 32},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#268#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"null\"},{\"value\": 1},{\"value\": -1},{\"value\": -1}]},{\"id\": \"27915\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 68},{\"value\": 41},{\"value\": 29},{\"value\": 12},{\"value\": 3},{\"value\": \"#269#\"},{\"value\": 1},{\"value\": 6},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": -1}]},{\"id\": \"26961\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 54},{\"value\": 41},{\"value\": 36},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#270#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"null\"},{\"value\": 1},{\"value\": -1},{\"value\": -1}]},{\"id\": \"9167\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 55},{\"value\": 45},{\"value\": 36},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#271#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"null\"},{\"value\": 1},{\"value\": -1},{\"value\": -1}]},{\"id\": \"18516\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 56},{\"value\": 49},{\"value\": 36},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#272#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"null\"},{\"value\": 1},{\"value\": -1},{\"value\": -1}]},{\"id\": \"30963\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 60},{\"value\": 54},{\"value\": 17},{\"value\": 11},{\"value\": 3},{\"value\": \"#275#\"},{\"value\": 1},{\"value\": 5},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": -1}]},{\"id\": \"32255\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 62},{\"value\": 57},{\"value\": 23},{\"value\": 8},{\"value\": 3},{\"value\": \"#276#\"},{\"value\": 1},{\"value\": 1},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": -1}]},{\"id\": \"5589\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 63},{\"value\": 54},{\"value\": 32},{\"value\": 11},{\"value\": 3},{\"value\": \"#277#\"},{\"value\": 1},{\"value\": 1},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": -1}]},{\"id\": \"22099\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 70},{\"value\": 54},{\"value\": 10},{\"value\": 11},{\"value\": 3},{\"value\": \"#769#\"},{\"value\": 1},{\"value\": 6},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": -1}]},{\"id\": \"17927\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 73},{\"value\": 54},{\"value\": 39},{\"value\": 11},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#776#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"null\"},{\"value\": 2},{\"value\": -1},{\"value\": 0}]},{\"id\": \"18386\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 74},{\"value\": 54},{\"value\": 43},{\"value\": 11},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#777#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"null\"},{\"value\": 2},{\"value\": -1},{\"value\": 0}]},{\"id\": \"25201\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 82},{\"value\": 54},{\"value\": 20},{\"value\": 11},{\"value\": 3},{\"value\": \"#813#\"},{\"value\": 1},{\"value\": 5},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": -1}]},{\"id\": \"14975\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 663},{\"value\": 54},{\"value\": 29},{\"value\": 11},{\"value\": 3},{\"value\": \"#1459#\"},{\"value\": 1},{\"value\": 5},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": -1}]},{\"id\": \"25281\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 99},{\"value\": 54},{\"value\": 35},{\"value\": 11},{\"value\": 3},{\"value\": \"#875#\"},{\"value\": 1},{\"value\": 1},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": -1}]},{\"id\": \"8233\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 89},{\"value\": 54},{\"value\": 23},{\"value\": 3},{\"value\": 3},{\"value\": \"CButton\"},{\"value\": \"#344#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"1072.png\"},{\"value\": 3},{\"value\": -1},{\"value\": -1}]},{\"id\": \"12055\",\"windowid\": \"20205\",\"type\": \"com.sage.components.list.DropBox\",\"arguments\": [{\"value\": 120},{\"value\": 54},{\"value\": 13},{\"value\": 11},{\"value\": 3},{\"value\": \"#1729#\"},{\"value\": [{\"v\": 11}]},{\"value\": 6},{\"value\": \"12\"},{\"value\": -1},{\"value\": 1},{\"value\": \"CButton\"}]},{\"id\": \"12239\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 6},{\"value\": 12},{\"value\": 15},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#590#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"1091.png\"},{\"value\": 1},{\"value\": -1},{\"value\": 1}]},{\"id\": \"23627\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 7},{\"value\": 12},{\"value\": 11},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#591#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"1092.png\"},{\"value\": 1},{\"value\": -1},{\"value\": 1}]},{\"id\": \"25950\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 8},{\"value\": 12},{\"value\": 22},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#592#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"1089.png\"},{\"value\": 1},{\"value\": -1},{\"value\": 1}]},{\"id\": \"3911\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 9},{\"value\": 12},{\"value\": 26},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#593#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"1090.png\"},{\"value\": 1},{\"value\": -1},{\"value\": 1}]},{\"id\": \"12306\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 75},{\"value\": 12},{\"value\": 19},{\"value\": 4},{\"value\": 3},{\"value\": \"#775#\"},{\"value\": 1},{\"value\": 1},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": 1}]},{\"id\": \"26697\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 6},{\"value\": 12},{\"value\": 15},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#590#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"1091.png\"},{\"value\": 1},{\"value\": -1},{\"value\": 2}]},{\"id\": \"19787\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 7},{\"value\": 12},{\"value\": 11},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#591#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"1092.png\"},{\"value\": 1},{\"value\": -1},{\"value\": 2}]},{\"id\": \"7428\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 8},{\"value\": 12},{\"value\": 22},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#592#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"1089.png\"},{\"value\": 1},{\"value\": -1},{\"value\": 2}]},{\"id\": \"31374\",\"windowid\": \"20205\",\"type\": \"com.sage.components.buttons.Button\",\"arguments\": [{\"value\": 9},{\"value\": 12},{\"value\": 26},{\"value\": 4},{\"value\": 4},{\"value\": \"CButton\"},{\"value\": \"#593#\"},{\"value\": 0},{\"value\": \"0xFFFFFF\"},{\"value\": \"1090.png\"},{\"value\": 1},{\"value\": -1},{\"value\": 2}]},{\"id\": \"24825\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 75},{\"value\": 12},{\"value\": 19},{\"value\": 4},{\"value\": 3},{\"value\": \"#775#\"},{\"value\": 1},{\"value\": 1},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": 2}]},{\"id\": \"16652\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 125},{\"value\": 13},{\"value\": 8},{\"value\": 13},{\"value\": 3},{\"value\": \"#1903#\"},{\"value\": 1},{\"value\": 9},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": 3}]},{\"id\": \"30088\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 121},{\"value\": 13},{\"value\": 14},{\"value\": 13},{\"value\": 3},{\"value\": \"#1904#\"},{\"value\": 1},{\"value\": 9},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": 3}]},{\"id\": \"28136\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 122},{\"value\": 13},{\"value\": 20},{\"value\": 13},{\"value\": 3},{\"value\": \"#1878#\"},{\"value\": 1},{\"value\": 5},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": 3}]},{\"id\": \"18303\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 123},{\"value\": 13},{\"value\": 23},{\"value\": 13},{\"value\": 8},{\"value\": \"#1879#\"},{\"value\": 1},{\"value\": 5},{\"value\": 0},{\"value\": \"12\"},{\"value\": 1},{\"value\": -1},{\"value\": 3}]},{\"id\": \"9735\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 124},{\"value\": 13},{\"value\": 31},{\"value\": 13},{\"value\": 8},{\"value\": \"#1880#\"},{\"value\": 1},{\"value\": 5},{\"value\": 0},{\"value\": \"12\"},{\"value\": 1},{\"value\": -1},{\"value\": 3}]},{\"id\": \"28214\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 126},{\"value\": 13},{\"value\": 11},{\"value\": 13},{\"value\": 3},{\"value\": \"#1876#\"},{\"value\": 1},{\"value\": 10},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": 3}]},{\"id\": \"14660\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 127},{\"value\": 13},{\"value\": 17},{\"value\": 13},{\"value\": 3},{\"value\": \"#1877#\"},{\"value\": 1},{\"value\": 10},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": 3}]},{\"id\": \"21369\",\"windowid\": \"20205\",\"type\": \"com.sage.components.text.TextBox\",\"arguments\": [{\"value\": 141},{\"value\": 54},{\"value\": 26},{\"value\": 11},{\"value\": 3},{\"value\": \"#1781#\"},{\"value\": 1},{\"value\": 5},{\"value\": 0},{\"value\": \"12\"},{\"value\": 0},{\"value\": -1},{\"value\": -1}]}]}\n\n','0',2),(2053,0,2290,'SCREEN_PLU_EDIT',182,'{\"objects\":[{\"id\":\"21335\",\"type\":\"com.sage.components.window.Window\",\"arguments\":[{\"value\":182},{\"value\":2},{\"value\":6},{\"value\":50},{\"value\":28},{\"value\":\"#301#\"},{\"value\":1},{\"value\":\"[[1]]\"},{\"value\":-1}]},{\"id\":\"5545\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":1},{\"value\":15},{\"value\":2},{\"value\":21},{\"value\":3},{\"value\":\"#303#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"20243\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":4},{\"value\":1},{\"value\":2},{\"value\":13},{\"value\":3},{\"value\":\"#305#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"19362\",\"windowid\":\"21335\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-2},{\"value\":44},{\"value\":22},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#297#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"7620\",\"windowid\":\"21335\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":-1},{\"value\":39},{\"value\":22},{\"value\":5},{\"value\":4},{\"value\":\"CButton\"},{\"value\":\"#298#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":-1}]},{\"id\":\"18782\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":15},{\"value\":37},{\"value\":2},{\"value\":12},{\"value\":3},{\"value\":\"#307#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13372\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":16},{\"value\":37},{\"value\":5},{\"value\":12},{\"value\":3},{\"value\":\"#308#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28557\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":17},{\"value\":37},{\"value\":8},{\"value\":12},{\"value\":3},{\"value\":\"#309#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"15116\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":18},{\"value\":37},{\"value\":11},{\"value\":12},{\"value\":3},{\"value\":\"#310#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"19630\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":19},{\"value\":37},{\"value\":14},{\"value\":12},{\"value\":3},{\"value\":\"#311#\"},{\"value\":1},{\"value\":6},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13850\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":2},{\"value\":15},{\"value\":5},{\"value\":21},{\"value\":3},{\"value\":\"#312#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"28366\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":5},{\"value\":1},{\"value\":5},{\"value\":13},{\"value\":3},{\"value\":\"#315#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"13822\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":20},{\"value\":15},{\"value\":14},{\"value\":21},{\"value\":3},{\"value\":\"#319#\"},{\"value\":1},{\"value\":5},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"23542\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":25},{\"value\":1},{\"value\":14},{\"value\":13},{\"value\":3},{\"value\":\"#326#\"},{\"value\":1},{\"value\":4},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"18723\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":33},{\"value\":15},{\"value\":8},{\"value\":21},{\"value\":3},{\"value\":\"#334#\"},{\"value\":1},{\"value\":3},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]},{\"id\":\"12107\",\"windowid\":\"21335\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":6},{\"value\":1},{\"value\":11},{\"value\":13},{\"value\":3},{\"value\":\"#314#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"21240\",\"windowid\":\"21335\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":13},{\"value\":37},{\"value\":17},{\"value\":12},{\"value\":3},{\"value\":\"#304#\"},{\"value\":[{\"v\":12}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"2031\",\"windowid\":\"21335\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":12},{\"value\":1},{\"value\":8},{\"value\":13},{\"value\":3},{\"value\":\"#302#\"},{\"value\":[{\"v\":13}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"25024\",\"windowid\":\"21335\",\"type\":\"com.sage.components.list.DropBox\",\"arguments\":[{\"value\":7},{\"value\":15},{\"value\":11},{\"value\":21},{\"value\":3},{\"value\":\"#316#\"},{\"value\":[{\"v\":21}]},{\"value\":6},{\"value\":\"12\"},{\"value\":0},{\"value\":1},{\"value\":\"CButton\"}]},{\"id\":\"8224\",\"windowid\":\"21335\",\"type\":\"com.sage.components.buttons.Button\",\"arguments\":[{\"value\":53},{\"value\":1},{\"value\":18},{\"value\":13},{\"value\":3},{\"value\":\"CCheckBox\"},{\"value\":\"#1788#\"},{\"value\":0},{\"value\":\"0xFFFFFF\"},{\"value\":\"null\"},{\"value\":1},{\"value\":-1},{\"value\":0}]},{\"id\":\"8121\",\"windowid\":\"21335\",\"type\":\"com.sage.components.text.TextBox\",\"arguments\":[{\"value\":54},{\"value\":15},{\"value\":18},{\"value\":13},{\"value\":3},{\"value\":\"#1797#\"},{\"value\":1},{\"value\":1},{\"value\":0},{\"value\":\"12\"},{\"value\":0},{\"value\":-1},{\"value\":0}]}]}','0',1);
/*!40000 ALTER TABLE `screens` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subfamilies`
--

DROP TABLE IF EXISTS `subfamilies`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `subfamilies` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL DEFAULT 0,
  `Description` varchar(45) NOT NULL DEFAULT 'nova sub familia',
  `ShortDescription` varchar(20) DEFAULT NULL,
  `Code` int(11) NOT NULL,
  `DefaultSalesPrice` int(11) NOT NULL DEFAULT 0,
  `DefaultSalesTax` int(11) NOT NULL DEFAULT 0,
  `FamilyUID` int(11) NOT NULL,
  `PropertyUID` int(11) NOT NULL,
  `ComissionGroupUID` int(11) DEFAULT NULL,
  `PrintLocationUID` int(11) DEFAULT NULL,
  `ModifyDate` datetime DEFAULT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_subfamily_has_family` (`FamilyUID`),
  KEY `fk_subfamily_has_properties` (`PropertyUID`),
  KEY `fk_subfamily_has_tax` (`DefaultSalesTax`),
  KEY `fk_subfamilies_PrintLocations1` (`PrintLocationUID`),
  CONSTRAINT `fk_subfamilies_PrintLocations1` FOREIGN KEY (`PrintLocationUID`) REFERENCES `printlocations` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_subfamily_has_family` FOREIGN KEY (`FamilyUID`) REFERENCES `families` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_subfamily_has_properties` FOREIGN KEY (`PropertyUID`) REFERENCES `properties` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_subfamily_has_tax` FOREIGN KEY (`DefaultSalesTax`) REFERENCES `taxes` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `subfamilies`
--

LOCK TABLES `subfamilies` WRITE;
/*!40000 ALTER TABLE `subfamilies` DISABLE KEYS */;
INSERT INTO `subfamilies` VALUES (1,0,1,'SubFamilia 1','subfamilia 1',1,1,1,1,2,NULL,NULL,'2012-01-11 17:26:13');
/*!40000 ALTER TABLE `subfamilies` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subtotals`
--

DROP TABLE IF EXISTS `subtotals`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `subtotals` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `ID` varchar(45) NOT NULL,
  `CreateDate` datetime NOT NULL,
  `CreateUserUID` int(11) DEFAULT NULL,
  `Signature` blob NOT NULL,
  `ParentUID` int(11) DEFAULT NULL,
  `KeyVersion` int(11) NOT NULL,
  `DataChar` varchar(45) NOT NULL,
  `TableID` int(11) NOT NULL DEFAULT 0,
  `CustomerUID` int(11) NOT NULL DEFAULT 0,
  `NumberOfItemsInTable` int(11) NOT NULL DEFAULT 0,
  `SalesmanSessionID` int(11) NOT NULL DEFAULT 0,
  `TerminalUID` int(11) NOT NULL DEFAULT 0,
  `VatIncluded` int(11) NOT NULL DEFAULT 0,
  `DiscountPercent` float NOT NULL,
  `DiscountValue` int(11) NOT NULL DEFAULT 0,
  `TableTotal` int(11) NOT NULL DEFAULT 0,
  `CertificateNumber` int(11) NOT NULL DEFAULT 0,
  `AppVersion` int(11) NOT NULL DEFAULT 0,
  `OrderReferences` varchar(200) NOT NULL DEFAULT '',
  `atcud` varchar(100) NOT NULL DEFAULT '',
  `atqrcode` varchar(1000) NOT NULL DEFAULT '',
  PRIMARY KEY (`UID`),
  KEY `index2` (`ID`,`DataChar`)
) ENGINE=InnoDB AUTO_INCREMENT=5121 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `subtotals`
--

LOCK TABLES `subtotals` WRITE;
/*!40000 ALTER TABLE `subtotals` DISABLE KEYS */;
/*!40000 ALTER TABLE `subtotals` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `subtotalsdetails`
--

DROP TABLE IF EXISTS `subtotalsdetails`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `subtotalsdetails` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `SubTotalUID` int(11) NOT NULL,
  `CreateDate` datetime NOT NULL,
  `ParentUID` int(11) DEFAULT 0,
  `PluName` varchar(200) DEFAULT NULL,
  `PluUID` int(11) DEFAULT 0,
  `Quantity` int(11) DEFAULT 0,
  `PluUnitPrice` float NOT NULL,
  `SaleValue` int(11) DEFAULT 0,
  `SaleTaxUID` int(11) DEFAULT -1,
  `DiscountPercentage` float NOT NULL,
  `DiscountValue` int(11) DEFAULT 0,
  `SalesmanUID` int(11) DEFAULT -1,
  `SalesmanSessionID` int(11) DEFAULT 0,
  `OrderSalesTerminalUID` int(11) DEFAULT 0,
  `MenuLevel` int(11) DEFAULT 0,
  `IsOffer` int(11) DEFAULT 0,
  `NetValue` int(11) DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `IUID` (`SubTotalUID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `subtotalsdetails`
--

LOCK TABLES `subtotalsdetails` WRITE;
/*!40000 ALTER TABLE `subtotalsdetails` DISABLE KEYS */;
/*!40000 ALTER TABLE `subtotalsdetails` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `tablenames`
--

DROP TABLE IF EXISTS `tablenames`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `tablenames` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `TableID` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `tablenames`
--

LOCK TABLES `tablenames` WRITE;
/*!40000 ALTER TABLE `tablenames` DISABLE KEYS */;
/*!40000 ALTER TABLE `tablenames` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxchanges`
--

DROP TABLE IF EXISTS `taxchanges`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `taxchanges` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) DEFAULT NULL,
  `SyncCounter` int(11) DEFAULT NULL,
  `PLU` int(11) DEFAULT NULL,
  `Tax1` int(11) DEFAULT NULL,
  `Tax2` int(11) DEFAULT NULL,
  `PVP1` int(11) DEFAULT NULL,
  `PVP2` int(11) DEFAULT NULL,
  `PVP3` int(11) DEFAULT NULL,
  `PVP4` int(11) DEFAULT NULL,
  `PVP5` int(11) DEFAULT NULL,
  `ApplyOnDate` datetime DEFAULT NULL,
  `Rounded` int(11) DEFAULT NULL,
  `Edited` int(11) DEFAULT NULL,
  `DIFF1` int(11) NOT NULL DEFAULT 0,
  `DIFF2` int(11) NOT NULL DEFAULT 0,
  `DIFF3` int(11) NOT NULL DEFAULT 0,
  `DIFF4` int(11) NOT NULL DEFAULT 0,
  `DIFF5` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxchanges`
--

LOCK TABLES `taxchanges` WRITE;
/*!40000 ALTER TABLE `taxchanges` DISABLE KEYS */;
/*!40000 ALTER TABLE `taxchanges` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxes`
--

DROP TABLE IF EXISTS `taxes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `taxes` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(4) NOT NULL DEFAULT 0,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  `TaxRate` int(11) NOT NULL,
  `TaxExpirationDate` datetime NOT NULL,
  `Comment` varchar(250) DEFAULT NULL,
  `TaxTypeUID` int(11) NOT NULL,
  `TaxRegionUID` int(11) NOT NULL,
  `TaxRatePerc` int(11) NOT NULL DEFAULT 0,
  `IsentionCode` varchar(10) DEFAULT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_taxtype_uid` (`TaxTypeUID`),
  KEY `fk_taxregion_uid` (`TaxRegionUID`),
  CONSTRAINT `fk_taxregion_uid` FOREIGN KEY (`TaxRegionUID`) REFERENCES `taxregions` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_taxtype_uid` FOREIGN KEY (`TaxTypeUID`) REFERENCES `taxtypes` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=80 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxes`
--

LOCK TABLES `taxes` WRITE;
/*!40000 ALTER TABLE `taxes` DISABLE KEYS */;
INSERT INTO `taxes` VALUES (1,0,115,1,'Normal',23,'0000-00-00 00:00:00',NULL,4,1,0,NULL),(2,0,119,2,'Intermedio',13,'0000-00-00 00:00:00',NULL,3,1,0,NULL),(3,0,118,3,'Reduzido',6,'0000-00-00 00:00:00',NULL,2,1,0,NULL),(4,0,109,4,'Isento Tabaco',0,'0000-00-00 00:00:00','Regime particular do tabaco Decreto-Lei n. 346 de 85, de 23 de agosto',1,1,0,'M11'),(5,0,116,5,'No sujeito',0,'0000-00-00 00:00:00','No sujeito, no tributado ou similar; outras situaes de no liquidao do imposto',1,1,0,'M99'),(51,0,120,6,'Isento Art 16',0,'2099-01-01 00:00:00','Artigo 16. n. 6 do CIVA (ou similar) Artigo 16. n. 6 alneas a) a d) do CIVA',1,1,0,'M01'),(52,0,120,6,'Isento Art 6',0,'2099-01-01 00:00:00','Artigo 6. do Decreto-Lei n. 198 de 90, de 19 de Junho',1,1,0,'M02'),(53,0,120,6,'Isento Exi Caixa',0,'2099-01-01 00:00:00','Exigibilidade de caixa Decreto Lei n. 204 de 97, de 9 de agosto',1,1,0,'M03'),(54,0,120,6,'Isento Art 13',0,'2099-01-01 00:00:00','Isento Artigo 13. do CIVA (ou similar) Artigo 13. do CIVA',1,1,0,'M04'),(55,0,120,6,'Isento Art 14',0,'2099-01-01 00:00:00','Isento Artigo 14. do CIVA (ou similar) Artigo 14. do CIVA',1,1,0,'M05'),(56,0,120,6,'Isento Art 15',0,'2099-01-01 00:00:00','Isento Artigo 15. do CIVA (ou similar) Artigo 15. do CIVA',1,1,0,'M06'),(57,0,120,6,'Isento Art 9',0,'2099-01-01 00:00:00','Isento Artigo 9. do CIVA (ou similar) Artigo 9. do CIVA',1,1,0,'M07'),(58,0,120,6,'Isento Auto Liq',0,'2099-01-01 00:00:00','IVA  autoliquidao Artigo 2. n. 1 alnea i), j) ou l) do CIVA Artigo 6. do CIVA',1,1,0,'M08'),(59,0,120,6,'Isento ART 60',0,'2099-01-01 00:00:00','IVA - no confere direito a deduo Artigo 60. CIVA Artigo 72. n. 4 do CIVA',1,1,0,'M09'),(60,0,120,6,'Isento Art 53',0,'2099-01-01 00:00:00','IVA - Regime de iseno Artigo 53.do CIVA ',1,1,0,'M10'),(61,0,120,6,'Isento Agencias Viagens',0,'2099-01-01 00:00:00','Regime da margem de lucro  Agncias de viagens Decreto-Lei n. 221 de 85, de 3 de julho',1,1,0,'M12'),(62,0,120,6,'Isento Bens 2 Mao',0,'2099-01-01 00:00:00','Regime da margem de lucro  Bens em segunda mo Decreto-Lei n. 199 de 96, de 18 de outubro',1,1,0,'M13'),(63,0,120,6,'Isento Obj Arte',0,'2099-01-01 00:00:00','Regime da margem de lucro  Objetos de arte Decreto-Lei n. 199 de 96, de 18 de outubro',1,1,0,'M14'),(64,0,120,6,'Isento Obj colecao',0,'2099-01-01 00:00:00','Regime da margem de lucro  Objetos de coleo e antiguidades Decreto-Lei n. 199 de 96, de 18 de outubro',1,1,0,'M15'),(65,0,120,6,'Isento Art 14RITI',0,'2099-01-01 00:00:00','Isento Artigo 14. do RITI (ou similar) Artigo 14. do RITI',1,1,0,'M16'),(66,0,120,6,'Isento Regime Forf',0,'2099-01-01 00:00:00','IVA - Regime forfetrio Artigo 59.-B do CIVA',1,1,0,'M20'),(67,0,120,6,'M19',0,'2099-12-31 00:00:00','Outras isenes Isenes temporrias determinadas em diploma prprio',1,1,0,'1'),(68,0,120,6,'M21',0,'2099-12-31 00:00:00','IVA no confere direito  deduo (ou expresso similar)Artigo 72. n. 4 do CIVA',1,1,0,'1'),(69,0,120,6,'M25',0,'2099-12-31 00:00:00','Mercadorias  consignao Artigo 38. n. 1 alnea a)',1,1,0,'1'),(70,0,120,6,'M30',0,'2099-12-31 00:00:00','IVA -autoliquidao Artigo 2. n. 1 alnea i) do CIVA',1,1,0,'1'),(71,0,120,6,'M31',0,'2099-12-31 00:00:00','IVA -autoliquidao Artigo 2. n. 1 alnea j) do CIVA',1,1,0,'1'),(72,0,120,6,'M32',0,'2099-12-31 00:00:00','IVA -autoliquidao Artigo 2. n. 1 alnea l) do CIVA',1,1,0,'1'),(73,0,120,6,'M33',0,'2099-12-31 00:00:00','IVA -autoliquidao Artigo 2. n. 1 alnea m) do CIVA',1,1,0,'1'),(74,0,120,6,'M40',0,'2099-12-31 00:00:00','IVA -autoliquidao Artigo 6. n. 6 alnea a) do CIVA, a contrrio',1,1,0,'1'),(75,0,120,6,'M41',0,'2099-12-31 00:00:00','IVA -autoliquidao Artigo 8. n. 3 do RITI',1,1,0,'1'),(76,0,120,6,'M42',0,'2099-12-31 00:00:00','IVA -autoliquidao Decreto-Lei n. 21/2007, de 29 de janeiro',1,1,0,'1'),(77,0,120,6,'M43',0,'2099-12-31 00:00:00','IVA -autoliquidao Decreto-Lei n. 362/99, de 16 de setembro',1,1,0,'1'),(78,0,120,6,'M26',0,'2099-12-31 00:00:00','Iseno de IVA com direito  deduo no cabaz alimentar (Lei n. 17/2023, de 14 de abril)',1,1,0,'M26'),(79,0,120,6,'M34',0,'2099-12-31 00:00:00','IVA - autoliquidao (Artigo 2. n. 2 alnea n) do CIVA',1,1,0,'M34');
/*!40000 ALTER TABLE `taxes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxregions`
--

DROP TABLE IF EXISTS `taxregions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `taxregions` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxregions`
--

LOCK TABLES `taxregions` WRITE;
/*!40000 ALTER TABLE `taxregions` DISABLE KEYS */;
INSERT INTO `taxregions` VALUES (1,0,1,'IVACON'),(2,0,1,'IVARAA'),(3,0,1,'IVARAM');
/*!40000 ALTER TABLE `taxregions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `taxtypes`
--

DROP TABLE IF EXISTS `taxtypes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `taxtypes` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB AUTO_INCREMENT=5 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `taxtypes`
--

LOCK TABLES `taxtypes` WRITE;
/*!40000 ALTER TABLE `taxtypes` DISABLE KEYS */;
INSERT INTO `taxtypes` VALUES (1,0,1,'ISE'),(2,0,1,'RED'),(3,0,1,'INT'),(4,0,1,'NOR');
/*!40000 ALTER TABLE `taxtypes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `temp_tabletransactiondetails`
--

DROP TABLE IF EXISTS `temp_tabletransactiondetails`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `temp_tabletransactiondetails` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `SyncCounter` int(11) NOT NULL,
  `CreateDate` datetime NOT NULL,
  `ModifyDate` datetime NOT NULL,
  `TransactionUID` int(11) NOT NULL,
  `PluUID` int(11) NOT NULL,
  `Quantity` int(11) NOT NULL,
  `QuantityOrdered` int(11) NOT NULL,
  `DiscountPercent` float NOT NULL,
  `DiscountValue` int(11) NOT NULL,
  `SalesmanUID` int(11) NOT NULL,
  `TotalValue` int(11) NOT NULL,
  `ParentID` int(11) NOT NULL,
  `Waste` int(11) NOT NULL,
  `PrintingOrder` int(11) NOT NULL,
  `KDSKitchenTerminal` int(11) NOT NULL,
  `KDSPrintStatus` int(11) NOT NULL,
  `CustomerSeating` int(11) NOT NULL,
  `PluUnitPrice` float NOT NULL,
  `SalesTaxUID` int(11) NOT NULL DEFAULT 1,
  `PluName` varchar(200) DEFAULT NULL,
  `MenuLevel` int(11) NOT NULL,
  `SalesmanSessionID` int(11) NOT NULL DEFAULT 0,
  `OrderSalesTerminalUID` int(11) NOT NULL DEFAULT 0,
  `IsOffer` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `fk_tabletransaction` (`TransactionUID`),
  KEY `fk_details_has_plu` (`PluUID`),
  KEY `fk_details_has_salesman` (`SalesmanUID`),
  CONSTRAINT `fk_details_has_plu` FOREIGN KEY (`PluUID`) REFERENCES `plus` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_details_has_salesman` FOREIGN KEY (`SalesmanUID`) REFERENCES `salesmans` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_tabletransaction` FOREIGN KEY (`TransactionUID`) REFERENCES `temp_tabletransactions` (`UID`) ON DELETE CASCADE ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `temp_tabletransactiondetails`
--

LOCK TABLES `temp_tabletransactiondetails` WRITE;
/*!40000 ALTER TABLE `temp_tabletransactiondetails` DISABLE KEYS */;
/*!40000 ALTER TABLE `temp_tabletransactiondetails` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `temp_tabletransactions`
--

DROP TABLE IF EXISTS `temp_tabletransactions`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `temp_tabletransactions` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `SyncCounter` int(11) NOT NULL,
  `TableID` int(11) NOT NULL,
  `CreateDate` datetime NOT NULL,
  `ModifyDate` datetime NOT NULL,
  `CreateSalesmanUID` int(11) DEFAULT NULL,
  `ModifySalesmanUID` int(11) DEFAULT NULL,
  `CustomerUID` int(11) DEFAULT NULL,
  `CustomerCount` int(11) NOT NULL,
  `PrintedLines` int(11) NOT NULL,
  `SubTotalsPrinted` int(11) NOT NULL,
  `ConsumoMinimo` int(11) NOT NULL,
  `OrderReferences` varchar(200) NOT NULL,
  `Misc` varchar(45) NOT NULL COMMENT 'a coluna "Misc"  de uso geral, mas existe para o caso de a zona estar ocnfigurada para ser usada como carto em que precisamos de gravar qual  a mesa fsica para onde vo os pedidos.\n\nDe qualquer modo, esta coluna poder ser usada noutros cenrios.',
  `Total` int(11) NOT NULL,
  `Status` int(11) NOT NULL,
  `PrintedDocuments` int(11) NOT NULL DEFAULT 0,
  `DiscountPercent` int(11) NOT NULL,
  `DiscountValue` int(11) NOT NULL,
  `OrderDestination` int(11) NOT NULL DEFAULT 0,
  `CardStatus` int(11) NOT NULL DEFAULT -1,
  `PaymentStatus` int(11) NOT NULL DEFAULT 1,
  `Obs` varchar(40) NOT NULL DEFAULT ' ',
  `LastWorkingDocument` int(11) NOT NULL DEFAULT 0,
  `LoadCargoLocation` varchar(200) NOT NULL DEFAULT '''',
  `UnloadCargoLocation` varchar(200) NOT NULL DEFAULT '''',
  `LoadCargoDate` varchar(200) NOT NULL DEFAULT '''',
  `UnloadCargoDate` varchar(200) NOT NULL DEFAULT '''',
  `TransportMethod` varchar(200) NOT NULL DEFAULT '''',
  `DocumentType` varchar(200) NOT NULL DEFAULT '''',
  `Seqr_Invoice_Id` varchar(250) NOT NULL DEFAULT '',
  `Seqr_ersReference` varchar(500) DEFAULT NULL,
  PRIMARY KEY (`UID`),
  UNIQUE KEY `TableID_UNIQUE` (`TableID`),
  KEY `fk_temp_transaction_has_customer` (`CustomerUID`),
  KEY `fk_temp_transaction_has_salesman` (`CreateSalesmanUID`),
  KEY `fk_temp_transaction_has_modifysalesman` (`ModifySalesmanUID`),
  CONSTRAINT `fk_temp_transaction_has_customer` FOREIGN KEY (`CustomerUID`) REFERENCES `customers` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_temp_transaction_has_modifysalesman` FOREIGN KEY (`ModifySalesmanUID`) REFERENCES `salesmans` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_temp_transaction_has_salesman` FOREIGN KEY (`CreateSalesmanUID`) REFERENCES `salesmans` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=917 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `temp_tabletransactions`
--

LOCK TABLES `temp_tabletransactions` WRITE;
/*!40000 ALTER TABLE `temp_tabletransactions` DISABLE KEYS */;
/*!40000 ALTER TABLE `temp_tabletransactions` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `terminalshardware`
--

DROP TABLE IF EXISTS `terminalshardware`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `terminalshardware` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` tinyint(1) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `HwDescription` varchar(45) NOT NULL,
  `InterfaceTypeID` int(11) NOT NULL,
  `DeviceManagerUID` int(11) NOT NULL,
  `DeviceDescription` varchar(45) NOT NULL,
  `DeviceTypeID` int(11) NOT NULL,
  `DriversUID` int(11) NOT NULL,
  `SalesTerminalUID` int(11) DEFAULT NULL,
  `BackupDeviceUID` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `fk_TerminalsHardware_DeviceManager1` (`DeviceManagerUID`),
  KEY `fk_TerminalsHardware_Drivers` (`DriversUID`)
) ENGINE=InnoDB AUTO_INCREMENT=2 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `terminalshardware`
--

LOCK TABLES `terminalshardware` WRITE;
/*!40000 ALTER TABLE `terminalshardware` DISABLE KEYS */;
INSERT INTO `terminalshardware` VALUES (1,0,4,'nome do hardware',2,1,'Impressora Contas',0,1,1,0);
/*!40000 ALTER TABLE `terminalshardware` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `transactionsdetails`
--

DROP TABLE IF EXISTS `transactionsdetails`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `transactionsdetails` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `SyncCounter` int(11) NOT NULL,
  `CreateDate` datetime NOT NULL,
  `ModifyDate` datetime NOT NULL,
  `TransactionUID` int(11) NOT NULL,
  `ParentID` int(11) NOT NULL,
  `PluName` varchar(200) DEFAULT NULL,
  `PluUID` int(11) NOT NULL,
  `Quantity` int(11) NOT NULL,
  `PluUnitPrice` float NOT NULL,
  `SaleValue` int(11) NOT NULL,
  `SaleTaxUID` int(11) NOT NULL,
  `DiscountPercentage` float NOT NULL,
  `DiscountValue` int(11) NOT NULL,
  `SalesmanUID` int(11) NOT NULL,
  `Waste` int(11) NOT NULL,
  `PrintingOrder` int(11) NOT NULL,
  `CustomerSeating` int(11) NOT NULL,
  `VatIncluded` int(3) NOT NULL DEFAULT 1,
  `SalesmanSessionID` int(11) NOT NULL DEFAULT 0,
  `OrderSalesTerminalUID` int(11) NOT NULL DEFAULT 0,
  `MenuLevel` int(11) NOT NULL DEFAULT 0,
  `IsOffer` int(11) NOT NULL DEFAULT 0,
  `NetValue` int(11) NOT NULL DEFAULT 0,
  `WithholdingPercentage` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `details_transaction_uid` (`TransactionUID`)
) ENGINE=InnoDB AUTO_INCREMENT=45077 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `transactionsdetails`
--

LOCK TABLES `transactionsdetails` WRITE;
/*!40000 ALTER TABLE `transactionsdetails` DISABLE KEYS */;
/*!40000 ALTER TABLE `transactionsdetails` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `transactionsheaders`
--

DROP TABLE IF EXISTS `transactionsheaders`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `transactionsheaders` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `SyncCounter` int(11) NOT NULL,
  `CreateSalesmanUID` int(11) NOT NULL,
  `ModifySalesmanUID` int(11) NOT NULL,
  `CreateDate` datetime NOT NULL,
  `ModifyDate` datetime NOT NULL,
  `DocumentID` varchar(45) NOT NULL,
  `TableID` int(11) NOT NULL,
  `CustomerUID` int(11) NOT NULL,
  `CustomerCount` int(11) NOT NULL,
  `NumberOfPrintedSubTotals` int(11) NOT NULL,
  `NumberOfItemsInTable` int(11) NOT NULL,
  `DocumentTypeUID` int(11) NOT NULL,
  `TransactionStartTime` datetime NOT NULL,
  `TransactionEndTime` datetime NOT NULL,
  `SalesmanSessionID` int(11) NOT NULL,
  `TransactionStatus` varchar(10) NOT NULL,
  `TransactionStartTerminalUID` int(11) NOT NULL,
  `TransactionEndTerminalUID` int(11) NOT NULL,
  `CashDrawerUID` int(11) NOT NULL,
  `OrderReferences` varchar(200) NOT NULL,
  `Signature` blob NOT NULL,
  `KeyVersion` int(11) NOT NULL DEFAULT 1,
  `VatIncluded` int(11) NOT NULL DEFAULT 1,
  `Comment` varchar(400) NOT NULL,
  `PrintedDocuments` int(11) NOT NULL DEFAULT 0,
  `DiscountPercent` float NOT NULL,
  `DiscountValue` int(11) NOT NULL,
  `TableTotal` int(11) DEFAULT 0,
  `DocumentSeries` varchar(45) NOT NULL,
  `ExternalDocument` varchar(45) NOT NULL,
  `CertificateNumber` int(11) NOT NULL DEFAULT 1281,
  `PointsAccumulated` int(11) NOT NULL DEFAULT 0,
  `Zone` int(11) NOT NULL DEFAULT 0,
  `Obs` varchar(40) NOT NULL DEFAULT ' ',
  `AppVersion` int(11) NOT NULL DEFAULT 0,
  `RoundingValue` int(11) NOT NULL DEFAULT 0,
  `SourceDocument` int(11) NOT NULL DEFAULT 0,
  `LastWorkingDocument` int(11) NOT NULL DEFAULT 0,
  `rescued_campaign` int(11) DEFAULT NULL,
  `customer_nif` varchar(25) DEFAULT NULL,
  `card_id` varchar(15) DEFAULT NULL,
  `atcud` varchar(100) NOT NULL DEFAULT '',
  `atqrcode` varchar(1000) NOT NULL DEFAULT '',
  PRIMARY KEY (`UID`),
  UNIQUE KEY `DocumentID_UNIQUE` (`DocumentID`),
  KEY `fk_customer` (`CustomerUID`),
  KEY `fk_transactionheader_has_documenttype` (`DocumentTypeUID`),
  KEY `fk_transactionheader_has_cashdrawer` (`CashDrawerUID`),
  KEY `fk_theader_create_user` (`CreateSalesmanUID`),
  KEY `fk_theader_modify_user` (`ModifySalesmanUID`),
  KEY `fk_theader_statusDocSerStatus` (`TransactionStatus`,`DocumentSeries`,`CreateDate`)
) ENGINE=InnoDB AUTO_INCREMENT=19 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci COMMENT='TransactionStatus -> usa nomenclatura do SAFT : F ou A';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `transactionsheaders`
--

LOCK TABLES `transactionsheaders` WRITE;
/*!40000 ALTER TABLE `transactionsheaders` DISABLE KEYS */;
/*!40000 ALTER TABLE `transactionsheaders` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `transactionsheaders_more`
--

DROP TABLE IF EXISTS `transactionsheaders_more`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `transactionsheaders_more` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `SyncCounter` int(11) NOT NULL,
  `TransactionUID` int(11) NOT NULL,
  `LoadCargoDate` datetime DEFAULT NULL,
  `UnloadCargoDate` datetime DEFAULT NULL,
  `TransportMethod` varchar(45) NOT NULL DEFAULT '0',
  `ATDocCodeID` varchar(45) NOT NULL DEFAULT '0',
  `ATDocCodeIDStatus` int(5) NOT NULL DEFAULT 0,
  `LoadCargoLocation` varchar(200) DEFAULT NULL,
  `UnloadCargoLocation` varchar(200) DEFAULT NULL,
  `Seqr_Invoice_Id` varchar(250) NOT NULL DEFAULT '',
  `Seqr_ersReference` varchar(500) DEFAULT NULL,
  `Efat_Payload` blob DEFAULT NULL,
  `Email` varchar(100) DEFAULT NULL,
  `Efat_Status_Date` datetime DEFAULT NULL,
  `PDF_Payload` blob DEFAULT NULL,
  `Email_Read_Date` datetime DEFAULT NULL,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `transactionsheaders_more`
--

LOCK TABLES `transactionsheaders_more` WRITE;
/*!40000 ALTER TABLE `transactionsheaders_more` DISABLE KEYS */;
/*!40000 ALTER TABLE `transactionsheaders_more` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `transactionssubtotals`
--

DROP TABLE IF EXISTS `transactionssubtotals`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `transactionssubtotals` (
  `TransactionID` int(11) NOT NULL,
  `SubTotalID` int(11) NOT NULL,
  `SubTotalChar` varchar(45) NOT NULL,
  PRIMARY KEY (`TransactionID`,`SubTotalID`,`SubTotalChar`),
  KEY `index2` (`SubTotalID`),
  KEY `index3` (`SubTotalChar`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `transactionssubtotals`
--

LOCK TABLES `transactionssubtotals` WRITE;
/*!40000 ALTER TABLE `transactionssubtotals` DISABLE KEYS */;
/*!40000 ALTER TABLE `transactionssubtotals` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `transactionstenders`
--

DROP TABLE IF EXISTS `transactionstenders`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `transactionstenders` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `SyncCounter` int(11) NOT NULL,
  `TransactionUID` int(11) NOT NULL,
  `PaymentTypeUID` int(11) NOT NULL,
  `PaymentDescription` varchar(45) NOT NULL,
  `Value` int(11) NOT NULL,
  `UserNote` longtext NOT NULL,
  `CashDrawerUID` int(11) DEFAULT NULL,
  `PaymentType` int(11) NOT NULL,
  `MovementUID` int(11) DEFAULT NULL,
  `ReceiptMovementUID` int(11) DEFAULT NULL,
  PRIMARY KEY (`UID`),
  KEY `tenders_transaction_uid` (`TransactionUID`)
) ENGINE=InnoDB AUTO_INCREMENT=5635 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `transactionstenders`
--

LOCK TABLES `transactionstenders` WRITE;
/*!40000 ALTER TABLE `transactionstenders` DISABLE KEYS */;
/*!40000 ALTER TABLE `transactionstenders` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `transferrecords`
--

DROP TABLE IF EXISTS `transferrecords`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `transferrecords` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `SyncCounter` int(11) NOT NULL,
  `OperationDate` datetime NOT NULL,
  `SalesmanUID` int(11) NOT NULL,
  `SourceTable` int(11) NOT NULL,
  `DestinationTable` int(11) NOT NULL,
  `ItemUID` int(11) NOT NULL,
  `Quantity` int(11) NOT NULL,
  `SalesmanSessionID` int(11) NOT NULL,
  `ItemDescription` varchar(45) NOT NULL,
  `SalesTerminal` int(11) NOT NULL,
  `OrderDate` datetime NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_transfer_record_has_salesma` (`SalesmanUID`),
  KEY `fk_transfer_record_has_plu` (`ItemUID`),
  CONSTRAINT `fk_transfer_record_has_plu` FOREIGN KEY (`ItemUID`) REFERENCES `plus` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION,
  CONSTRAINT `fk_transfer_record_has_salesma` FOREIGN KEY (`SalesmanUID`) REFERENCES `salesmans` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `transferrecords`
--

LOCK TABLES `transferrecords` WRITE;
/*!40000 ALTER TABLE `transferrecords` DISABLE KEYS */;
/*!40000 ALTER TABLE `transferrecords` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `validationcodes`
--

DROP TABLE IF EXISTS `validationcodes`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `validationcodes` (
  `UID` int(11) NOT NULL,
  `RecordDeleted` int(11) DEFAULT NULL,
  `SyncCounter` int(11) DEFAULT NULL,
  `ValidationCode` varchar(50) DEFAULT NULL,
  `CounterId` varchar(50) DEFAULT NULL,
  `ManualCode` tinyint(1) DEFAULT 0,
  PRIMARY KEY (`UID`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `validationcodes`
--

LOCK TABLES `validationcodes` WRITE;
/*!40000 ALTER TABLE `validationcodes` DISABLE KEYS */;
/*!40000 ALTER TABLE `validationcodes` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zoneproperties`
--

DROP TABLE IF EXISTS `zoneproperties`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `zoneproperties` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  `Value` varchar(45) NOT NULL,
  `ZoneUID` int(11) NOT NULL,
  PRIMARY KEY (`UID`),
  KEY `fk_zoneproperties_zones1` (`ZoneUID`),
  CONSTRAINT `fk_zoneproperties_zones1` FOREIGN KEY (`ZoneUID`) REFERENCES `zones` (`UID`) ON DELETE NO ACTION ON UPDATE NO ACTION
) ENGINE=InnoDB AUTO_INCREMENT=48 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zoneproperties`
--

LOCK TABLES `zoneproperties` WRITE;
/*!40000 ALTER TABLE `zoneproperties` DISABLE KEYS */;
INSERT INTO `zoneproperties` VALUES (1,0,46,'tax_included','1',1),(2,0,46,'ask_customer_number','0',1),(3,0,46,'self_consumption','0',1),(4,0,46,'table_sales_limit','0',1),(5,0,46,'auto_plu','0',1),(6,0,46,'number_of_included_items','0',1),(7,0,46,'ask_customer_before_sale','0',1),(8,0,46,'table_is_card','0',1),(9,0,46,'use_map','0',1),(10,0,1,'is_delivery','0',1),(11,0,1,'card_action','0',1),(12,0,1,'is_guia','0',1),(13,0,1,'ask_table_name_on_exit','0',1),(14,0,2,'tax_included','1',2),(15,0,2,'ask_customer_number','0',2),(16,0,2,'self_consumption','0',2),(17,0,2,'table_sales_limit','0',2),(18,0,2,'auto_plu','',2),(19,0,2,'number_of_included_items0','0',2),(20,0,2,'ask_customer_before_sale','0',2),(21,0,2,'table_is_card','0',2),(22,0,2,'use_map','0',2),(23,0,2,'is_delivery','0',2),(24,0,2,'card_action','0',2),(25,0,2,'is_guia','0',2),(26,0,2,'ask_table_name_on_exit','0',2),(27,0,2,'tax_included','1',3),(28,0,2,'ask_customer_number','0',3),(29,0,2,'self_consumption','0',3),(30,0,2,'table_sales_limit','0',3),(31,0,2,'auto_plu','',3),(32,0,2,'number_of_included_items0','0',3),(33,0,2,'ask_customer_before_sale','0',3),(34,0,2,'table_is_card','0',3),(35,0,2,'use_map','0',3),(36,0,2,'is_delivery','0',3),(37,0,2,'card_action','0',3),(38,0,2,'is_guia','0',3),(39,0,2,'ask_table_name_on_exit','0',3),(40,0,2,'number_of_included_items','0',2),(41,0,2,'number_of_included_items','0',3),(42,0,1,'is_take_seguro','0',1),(43,0,1,'obriga_obs','0',1),(44,0,1,'ask_customercount','0',1),(45,0,1,'proportional_menu','1',1),(46,0,1,'transfer_uses_zoneprice','0',1),(47,0,1,'higher_menu_vat','0',1);
/*!40000 ALTER TABLE `zoneproperties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `zones`
--

DROP TABLE IF EXISTS `zones`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!40101 SET character_set_client = latin1 */;
CREATE TABLE `zones` (
  `UID` int(11) NOT NULL AUTO_INCREMENT,
  `RecordDeleted` int(11) NOT NULL,
  `SyncCounter` int(11) NOT NULL,
  `Code` int(11) NOT NULL,
  `Description` varchar(45) NOT NULL,
  `ShortDescription` varchar(20) DEFAULT NULL,
  `TableRange` varchar(250) NOT NULL,
  `DefaultSalesPriceIndex` int(11) NOT NULL,
  `DefaultTaxUID` int(11) NOT NULL,
  `DefaultTableName` varchar(20) NOT NULL,
  `Type` int(11) NOT NULL DEFAULT 0,
  PRIMARY KEY (`UID`),
  KEY `fk_zone_has_tax` (`DefaultTaxUID`)
) ENGINE=InnoDB AUTO_INCREMENT=4 DEFAULT CHARSET=latin1 COLLATE=latin1_swedish_ci;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `zones`
--

LOCK TABLES `zones` WRITE;
/*!40000 ALTER TABLE `zones` DISABLE KEYS */;
INSERT INTO `zones` VALUES (1,0,1,1,'Sala','Sala','1:99',0,0,'1',0);
/*!40000 ALTER TABLE `zones` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Dumping routines for database '#DB_NAME#'
--
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2024-06-04 11:52:27
